{ ******* AnClock ******* }
Type
	TAnClock=Record
		Hour, Min, Sec: Integer;
		ClrHour, ClrMin, ClrSec: TColor;
		Active, ShowSeconds: Boolean
	End;

Procedure AnClock_IntDraw(Me:PControl; Show,FullDraw:Boolean);
Var
	Alpha: Real;
	DX, DY, I: Integer;
	CX, CY, MaxLen, HourLen, MinLen, SecLen: Integer;
	TempColor: TColor;
	ClrCurHour, ClrCurMin, ClrCurSec: TColor;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, TAnClock(Data^), Place Do
	Begin
		CX:=(X1+X2) Div 2;
		CY:=(Y1+Y2) Div 2;
		MaxLen:=(X2-X1) Div 2;
		HourLen:=MaxLen*5 Div 9;
		MinLen:=MaxLen*7 Div 9;
		If MaxLen>30
			Then SecLen:=MaxLen-3
			Else SecLen:=MaxLen-1;

		If Show Then
		Begin
			ClrCurHour:=ClrHour;
			ClrCurMin:=ClrMin;
			ClrCurSec:=ClrSec
		End
		Else Begin
			ClrCurHour:=Kernel.ClrWinBG;
			ClrCurMin:=Kernel.ClrWinBG;
			ClrCurSec:=Kernel.ClrWinBG
		End;

		If FullDraw Then
		Begin
			Gfx.Bar(X1, Y1, X2, Y2, Kernel.ClrWinBG);
			For I:=1 To 12 Do
			Begin
				Alpha:=(3-I)*Pi/6;
				DX:=Round(Cos(Alpha)*MaxLen);
				DY:=Round(Sin(Alpha)*MaxLen);
				If (I Mod 3)=0
					Then TempColor:=ClrHour
					Else TempColor:=ClrMin;
				Gfx.PutPixel(CX+DX, CY-DY, TempColor);
				If MaxLen>30 Then
				Begin
					Gfx.PutPixel(CX+DX+1, CY-DY, TempColor);
					Gfx.PutPixel(CX+DX, CY-DY+1, TempColor);
					Gfx.PutPixel(CX+DX+1, CY-DY+1, TempColor)
				End
			End;
			If MaxLen>30 Then
				For I:=0 To 59 Do
					If (I Mod 5)<>0 Then
					Begin
						Alpha:=(15-I)*Pi/30;
						DX:=Round(Cos(Alpha)*MaxLen);
						DY:=Round(Sin(Alpha)*MaxLen);
						Gfx.PutPixel(CX+DX, CY-DY, ClrSec)
					End
		End;
			{ ᥪ㭤 }
		If ShowSeconds Then
		Begin
			Alpha:=Integer(15-Sec)*Pi/30;
			DX:=Round(Cos(Alpha)*SecLen);
			DY:=Round(Sin(Alpha)*SecLen);
			Gfx.Line(CX, CY, CX+DX, CY-DY, ClrCurSec)
		End;
			{ 墨 }
		Alpha:=Integer(15-Min)*Pi/30;
		DX:=Round(Cos(Alpha)*MinLen);
		DY:=Round(Sin(Alpha)*MinLen);
		Gfx.Line(CX, CY, CX+DX, CY-DY, ClrCurMin);
			{  }
		Alpha:=(3-(Hour+Min/60))*Pi/6;
		DX:=Round(Cos(Alpha)*HourLen);
		DY:=Round(Sin(Alpha)*HourLen);
		Gfx.Line(CX, CY, CX+DX, CY-DY, ClrCurHour);
		If MaxLen>30 Then
		Begin
			Gfx.Line(CX+1, CY, CX+DX+1, CY-DY, ClrCurHour);
			Gfx.Line(CX, CY+1, CX+DX, CY-DY+1, ClrCurHour);
			Gfx.Line(CX+1, CY+1, CX+DX+1, CY-DY+1, ClrCurHour)
		End
	End
End;

Procedure AnClock_Paint(Me:PControl; VX1,VY1,VX2:Integer);
Begin
	With Me^, TAnClock(Data^), Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY1+(VX2-VX1), Me^.Place);
	AnClock_IntDraw(Me, True, True)
End;

Procedure AnClock_SetTime(Me:PControl; VHour,VMin,VSec:Integer);
Begin
	With Me^, TAnClock(Data^) Do
	Begin
		If AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
			If (Me^.CanDraw Or Kernel.DontBother) And Visible Then
			Begin
				Kernel.BeginPaint(Place);
				AnClock_IntDraw(Me, False, False);
				Hour:=VHour;
				Min:=VMin;
				Sec:=VSec;
				AnClock_IntDraw(Me, True, False);
				Kernel.EndPaint;
				Exit
			End;
		Hour:=VHour;
		Min:=VMin;
		Sec:=VSec
	End
End;

Procedure AnClock_GetTime(Me:PControl; Var VHour,VMin,VSec:Integer);
Begin
	With Me^, TAnClock(Data^) Do
	Begin
		VHour:=Hour;
		VMin:=Min;
		VSec:=Sec
	End
End;


Procedure AnClock_StepSeconds(Me:PControl; DeltaSec:Integer);
Var
	TempHour, TempMin, TempSec: Integer;
Begin
	With Me^, TAnClock(Data^) Do
	Begin
		TempHour:=Hour;
		TempMin:=Min;
		TempSec:=Sec;

		Inc(TempSec, DeltaSec);
		While TempSec>59 Do
		Begin
			Dec(TempSec, 60);
			Inc(TempMin)
		End;
		While TempMin>59 Do
		Begin
			Dec(TempMin, 60);
			Inc(tempHour)
		End;
		While TempHour>23 Do
			Dec(TempHour, 24);
		AnClock_SetTime(Me, TempHour, TempMin, TempSec)
	End
End;



Procedure AnClock_OnDestroy(Me:PControl);
Begin
	FreeMem(Me^.Data, SizeOf(TAnClock))
End;

Function AnClock_Create(Prog:PProg; VHour,VMin,VSec:Integer;
	VShowSeconds:Boolean): PControl;
Var
	Me: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
	With Me^ Do
	Begin
		OnDestroy:=AnClock_OnDestroy;

		Enabled:=False;
		D.AssignRect(-1, -1, -1, -1, Place);

		GetMem(Data, SizeOf(TAnClock));
		With TAnClock(Data^) Do
		Begin
			Hour:=VHour;
			Min:=VMin;
			Sec:=VSec;
			ShowSeconds:=VShowSeconds;

			ClrHour:=Kernel.ClrText;
			ClrMin:=Kernel.ClrTextCom;
			ClrSec:=Kernel.ClrTextDis;

			Active:=False
		End
	End;
	AnClock_Create:=Me
End;
