{$F+}
Unit
	APMApp; { Polit Halcyon APMLib test }

Interface

Uses
	Kernel, Types, D, Ctl, APMLib;

Type
	TAPMAppData=Record
		Lab1, Lab2: PControl;
		BtnReboot, BtnShutdown, BtnCtrlAltDel, BtnSuspend: PControl;
		APMBIOS: Boolean;
		APMVer1, APMVer2: Byte;
		PicReboot, PicShutdown, PicCtrlAltDel, PicSuspend: Pointer;
	End;

Implementation

Procedure APMApp_OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TAPMAppData(Data^) Do
	Begin
		Ctl.Label_Paint(Lab1, 5, 5, 65);
		Ctl.Label_Paint(Lab2, 70, 5, X2-X1-5);
		Ctl.Button_Paint(BtnSuspend, 5, 45, X2-X1-5);
		Ctl.Button_Paint(BtnReboot, 5, 70, X2-X1-5);
		Ctl.Button_Paint(BtnCtrlAltDel, 5, 95, X2-X1-5);
		Ctl.Button_Paint(BtnShutdown, 5, 120, X2-X1-5)
	End
End;

Procedure APMApp_OnClose(Me:PProg);
Begin
	Kernel.FreeRes('b_sleep.bmp');
	Kernel.FreeRes('b_reboot.bmp');
	Kernel.FreeRes('b_ctlalt.bmp');
	Kernel.FreeRes('b_off.bmp');
	FreeMem(Me^.Data, SizeOf(TAPMAppData))
End;

Procedure APMApp_SuspendClick(Me:PProg; Control:PControl);
Var
	APMRes: Word;
Begin
	APMRes:=APMLib.FlushAllCaches;
	If APMRes>0
		Then Kernel.ShowHint(' 諮 :(')
		Else APMLib.Suspend
End;

Procedure APMApp_RebootClick(Me:PProg; Control:PControl);
Var
	APMRes: Word;
Begin
	APMRes:=APMLib.FlushAllCaches;
	If APMRes>0
		Then Kernel.ShowHint(' 諮 :(')
		Else APMLib.Reboot(False)
End;

Procedure APMApp_CtrlAltDelClick(Me:PProg; Control:PControl);
Var
	APMRes: Word;
Begin
	APMRes:=APMLib.FlushAllCaches;
	If APMRes>0
		Then Kernel.ShowHint(' 諮 :(')
		Else APMLib.CtrlAltDel
End;

Procedure APMApp_ShutdownClick(Me:PProg; Control:PControl);
Var
	APMRes: Word;
Begin
	APMRes:=APMLib.FlushAllCaches;
	If APMRes>0
		Then Kernel.ShowHint(' 諮 :(')
		Else APMLib.Shutdown
End;



Procedure APMApp_OnInit(Me:PProg);
Begin
	With Me^ Do
	Begin
		D.AssignPStr('', WinTitle);
		MinX:=150;
		MinY:=150;
		OnPaint:=APMApp_OnPaint;
		{OnIdle:=Kernel.DummyProc;}
		OnClose:=APMApp_OnClose;
		GetMem(Data, SizeOf(TAPMAppData));
		Kernel.InitWindow(Me, 'BlueDlg');
		Kernel.DrawWindow(Me);

		With TAPMAppData(Data^) Do
		Begin
			APMBIOS:=APMLib.APMIsInstalled;
			If APMBios Then
			Begin
				APMLib.APMGetVer(APMVer1,APMVer2);
				If (APMVer1<1) Or (APMVer2<1) Then
					APMBIOS:=False
			End;

			PicReboot:=Kernel.LoadBMPRes('pic\b_reboot.bmp');
			PicShutdown:=Kernel.LoadBMPRes('pic\b_off.bmp');
			PicCtrlAltDel:=Kernel.LoadBMPRes('pic\b_ctlalt.bmp');
			PicSuspend:=Kernel.LoadBMPRes('pic\b_sleep.bmp');

			Lab1:=Ctl.Label_Create(Me, 'APM BIOS:', alRight, False, '');
			If APMBIOS
				Then Lab2:=Ctl.Label_Create(Me, '', alLeft, True, '')
				Else Lab2:=Ctl.Label_Create(Me, ' ', alLeft, True, '');
			BtnSuspend:=Ctl.Button_Create(Me, ' 祪', '',
				PicSuspend, ppLeft, APMApp_SuspendClick, APMBIOS);
			BtnReboot:=Ctl.Button_Create(Me, '१⠦', '',
				PicReboot, ppLeft, APMApp_RebootClick, APMBIOS);
			BtnCtrlAltDel:=Ctl.Button_Create(Me, 'Ctrl+Alt+Del :)', '',
				PicCtrlAltDel, ppLeft, APMApp_CtrlAltDelClick, APMBIOS);
			BtnShutdown:=Ctl.Button_Create(Me, '', '',
				PicShutdown, ppLeft, APMApp_ShutdownClick, APMBIOS)
		End
	End
End;


Begin
	Kernel.RegBuiltIn('APMApp', 'pic\i_apmapp.bmp', APMApp_OnInit)
End.