{$F+}
Unit
	BarSetup; { Polit Halcyon BarSetup application }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx;

Type
	TBarSetupData=Record
		{ i i ணࠬ  ,  쮬 i }
		LabPos, RadPosTop, RadPosBottom: PControl;
		LabWidth, RadWidthFixed, SpnWidthFixed, RadWidthMax: PControl;
		LabClock, ChkDigital, ChkAnalog, ChkSeconds: PControl;
		ChkDblHeight, ChkCenter, ChkTransp: PControl;
		BtnTry, BtnClose: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TBarSetupData(Data^) Do
	Begin
		{ i   i i                         }
		{ 砩 ⮡i ॡ   i  㢠 }
		Kernel.DarkBar(X1, Y2-34, X2, Y2);
		Gfx.TranspBar(X1, Y2-35, X2, Y2-35, clBlack, 50);

		Ctl.Label_Paint(LabPos, 10, 10, 100);
		Ctl.Radio_Paint(RadPosTop, 110, 10);
		Ctl.Radio_Paint(RadPosBottom, 110, 30);

		Ctl.Label_Paint(LabWidth, 10, 65, 100);
		Ctl.Radio_Paint(RadWidthFixed, 110, 65);
		Ctl.SpinEdit_Paint(SpnWidthFixed, 202, 65, 270);
		Ctl.Radio_Paint(RadWidthMax, 110, 85);

		Ctl.Check_Paint(ChkDblHeight, 110, 110);
		Ctl.Check_Paint(ChkCenter, 110, 130);

		Ctl.Label_Paint(LabClock, 10, 165, 100);
		Ctl.Check_Paint(ChkDigital, 110, 165);
		Ctl.Check_Paint(ChkAnalog, 110, 185);
		Ctl.Check_Paint(ChkSeconds, 110, 205);

		Ctl.Check_Paint(ChkTransp, 110, 240);

		Ctl.Button_Paint(BtnTry, X2-X1-215, Y2-Y1-26, X2-X1-115);
		Ctl.Button_Paint(BtnClose, X2-X1-105, Y2-Y1-26, X2-X1-5);
	End;
End;

Procedure OnWidthChange(Me:PProg; Control:PControl);
Begin
	With Me^, TBarSetupData(Data^) Do
	Begin
		If Ctl.Radio_Selected(RadWidthFixed) Then
		Begin
			SpnWidthFixed^.Enabled:=True;
			ChkCenter^.Enabled:=True
		End
		Else Begin
			SpnWidthFixed^.Enabled:=False;
			ChkCenter^.Enabled:=False
		End;
		Ctl.SpinEdit_Draw(SpnWidthFixed);
		Ctl.Check_Draw(ChkCenter)
	End
End;

Procedure OnClockChange(Me:PProg; Control:PControl);
Begin
	With Me^, TBarSetupData(Data^) Do
	Begin
		ChkSeconds^.Enabled:=Ctl.Check_GetState(ChkDigital) Or
			Ctl.Check_GetState(ChkAnalog);
		Ctl.Check_Draw(ChkSeconds)
	End
End;



Procedure OnApplyClick(Me:PProg; Control:PControl);
Begin
	With Me^, TBarSetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Taskbar');
		If Ctl.Radio_Selected(RadPosTop)
			Then Ini.SetStr('Position', 'Top')
			Else Ini.SetStr('Position', 'Bottom');
		If Ctl.Radio_Selected(RadWidthFixed)
			Then Ini.SetStr('ButtonWidthMode', 'Fixed')
			Else Ini.SetStr('ButtonWidthMode', 'Max');
		Ini.SetInt('ButtonWidth', Ctl.SpinEdit_GetValue(SpnWidthFixed));
		Ini.SetBool('ClockDigital', Ctl.Check_GetState(ChkDigital));
		Ini.SetBool('ClockAnalog', Ctl.Check_GetState(ChkAnalog));
		Ini.SetBool('ClockShowSeconds', Ctl.Check_GetState(ChkSeconds));
		If Ctl.Check_GetState(ChkDblHeight)
			Then Ini.SetStr('Height', 'Double')
			Else Ini.SetStr('Height', 'Normal');
		Ini.SetBool('Centered', Ctl.Check_GetState(ChkCenter));
		Ini.SetBool('Transparent', Ctl.Check_GetState(ChkTransp));
	End;
	Gfx.AllowZoomRect:=False;
	Kernel.CloseProg(Kernel.FindProg('TaskBar'));
	Kernel.RunBuiltIn('TaskBar', '');
	Gfx.AllowZoomRect:=True
End;

Procedure OnCloseClick(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;

Procedure OnClose(Me:PProg);
Var
	TempPtr: Pointer;
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	With Me^, TBarSetupData(Data^) Do
		If Parent<>Nil Then
			TempPtr:=Kernel.SendMessage(Me, Parent, 'Settings:CloseSheet', Nil);
	FreeMem(Me^.Data, SizeOf(TBarSetupData))
End;

Procedure OnInit(Me:PProg);
Var
	Position, BtnWidthMode: String;
	BtnWidth: Integer;
	ClockDigital, ClockAnalog, ClockSeconds: Boolean;
	DblHeight, CenterButtons, TranspPanel: Boolean;
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr(' : ன', WinTitle);
		MinX:=280;
		MinY:=300;
		GetMem(Data, SizeOf(TBarSetupData));
		If Parent=Nil
			Then Kernel.InitWindow(Me, 'BlueDlg', [wbMin, wbClose])
			Else Kernel.InitSheetWindow(Me, 'BlueDlg', [wbSlide], brLeft);
		Kernel.DrawWindowAni(Me);

		With TBarSetupData(Data^) Do
		Begin
			Ini.Select('polit.ini', 'Taskbar');
			Position:=Ini.GetStr('Position', 'TOP');
			BtnWidthMode:=Ini.GetStr('ButtonWidthMode', 'FIXED');
			BtnWidth:=Ini.GetInt('ButtonWidth', 90);
			ClockDigital:=Ini.GetBool('ClockDigital', True);
			ClockAnalog:=Ini.GetBool('ClockAnalog', True);
			ClockSeconds:=Ini.GetBool('ClockShowSeconds', True);
			DblHeight:=(Ini.GetStr('Height', 'NORMAL')='DOUBLE');
			TranspPanel:=Ini.GetBool('Transparent', False);
			CenterButtons:=Ini.GetBool('Centered', False);

			{  -  i  ⢮७ i i 㢠 }

			LabPos:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
			RadPosTop:=Ctl.Radio_Create(Me, '', (Position='TOP'), 1);
			RadPosBottom:=Ctl.Radio_Create(Me, '', (Position='BOTTOM'), 1);

			LabWidth:=Ctl.Label_Create(Me, 'ਭ :', Nil, lsNormal, alRight);
			RadWidthFixed:=Ctl.Radio_Create(Me, 'iᮢ', (BtnWidthMode='FIXED'), 2);
			Ctl.Radio_SetOnChange(RadWidthFixed, OnWidthChange);
			SpnWidthFixed:=Ctl.SpinEdit_Create(Me, 20, 200, 10, BtnWidth);
			SpnWidthFixed^.Enabled:=(BtnWidthMode='FIXED');
			RadWidthMax:=Ctl.Radio_Create(Me, 'ᨬ쭠', (BtnWidthMode='MAX'), 2);
			Ctl.Radio_SetOnChange(RadWidthMax, OnWidthChange);

			ChkDblHeight:=Ctl.Check_Create(Me, 'i ', DblHeight);
			ChkCenter:=Ctl.Check_Create(Me, '㢠 ', CenterButtons);

			LabClock:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
			ChkDigital:=Ctl.Check_Create(Me, '஢', ClockDigital);
			Ctl.Check_SetOnChange(ChkDigital, OnClockChange);
			ChkAnalog:=Ctl.Check_Create(Me, 'i筨', ClockAnalog);
			Ctl.Check_SetOnChange(ChkAnalog, OnClockChange);
			ChkSeconds:=Ctl.Check_Create(Me, 'I ᥪ㭤', ClockSeconds);
			ChkSeconds^.Enabled:=ClockDigital Or ClockAnalog;

			ChkTransp:=Ctl.Check_Create(Me, '஧਩  i', TranspPanel);

			BtnTry:=Ctl.Button_Create(Me, '஡㢠', Kernel.PicApply,
				ppLeft, OnApplyClick);
			D.ReassignPStr('ॣ ன i'+#13+
				'१  ', BtnTry^.Hint);
			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseClick);

			ActiveCtl:=RadPosTop;
			ButtonEnter:=BtnTry;
			ButtonEsc:=BtnClose
		End
	End
End;



Begin
	Kernel.RegBuiltIn('BarSetup', '', 'pic\i_barset.bmp', OnInit)
End.
