{ ************ Button ************ }
Type
	TButton=Record
		Caption: PStr;
		OnPress: TCtlHandler;
		Down, DownNow: Boolean;
		Picture: Pointer;
		PicturePos: TPicturePos;
		MarkStyle: TButtonMarkStyle;
	End;

Var
	ButtonInside: Boolean;
	PicBtn: Array[TButtonMarkStyle] Of TSkinPic;
	PicBtnL, PicBtnC, PicBtnR: Array[TPicturePos] Of TSkinPic;
	ButtonSkinned, ButtonTiledSkin: Boolean;

Procedure Button_IntDraw(Me:PControl);
Var
	ClrLU, ClrRD, ClrFill, ClrFont: TColor;
	Indent, PicWidth, MarkWidth: Integer;
	TempStr: String;
	TempEnabled, TempPressed: Boolean;

	Procedure SetVals(A,B,C,D:TColor);
	Begin
		ClrLU:=A;
		ClrRD:=B;
		ClrFill:=C;
		ClrFont:=D
	End;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, TButton(Data^), Place Do
	Begin
		If Me=Owner^.ButtonEnter
			Then SetVals(Kernel.Clr3DActLight, Kernel.Clr3DActDark,
				Kernel.Clr3DAct, Kernel.ClrTextAct)
			Else SetVals(Kernel.Clr3DLight, Kernel.Clr3DDark,
				Kernel.Clr3DFace, Kernel.ClrText);
		If Down Or DownNow Then
		Begin
			Indent:=1;
			SetVals(Kernel.Clr3DActDark, Kernel.Clr3DActLight,
				Kernel.Clr3DAct, Kernel.ClrTextAct)
		End
		Else
			Indent:=0;
		If Not Enabled Then
			SetVals(Kernel.ClrDisabled, Kernel.ClrDisabled,
				Kernel.ClrWinBG, Kernel.ClrTextDis);
		If ButtonSkinned Then
		Begin
			TempEnabled:=Enabled;
			TempPressed:=Down Or DownNow;
			If Enabled Then
			Begin
				If (Not TempPressed) And (Me=Owner^.ButtonEnter) Then
				Begin
					TempEnabled:=False;
					TempPressed:=True
				End
			End
			Else TempPressed:=False;
			If ButtonTiledSkin
				Then Gfx.SkinBarTiled(X1, Y1, X2, PicBtnL[PicturePos, TempEnabled, TempPressed],
					PicBtnC[PicturePos, TempEnabled, TempPressed],
					PicBtnR[PicturePos, TempEnabled, TempPressed])
				Else Gfx.SkinBar(X1, Y1, X2, PicBtnL[PicturePos, TempEnabled, TempPressed],
					PicBtnR[PicturePos, TempEnabled, TempPressed])
		End
		Else Begin
			If Enabled
				Then Gfx.FillButtonRect(X1, Y1, X2, Y2, ClrLU, ClrRD, ClrFill)
				Else Begin
					Gfx.ButtonRect(X1, Y1, X2, Y2, ClrLU, ClrRD);
					Kernel.WindowBar(X1+1, Y1+1, X2-1, Y2-1, False, False)
				End
		End;

		If Enabled And (Me=Owner^.ButtonEsc) Then
		Begin
			PutPixel(X1+1, Y1+1, clRed);
			PutPixel(X2-1, Y1+1, clRed);
			PutPixel(X1+1, Y2-1, clRed);
			PutPixel(X2-1, Y2-1, clRed)
		End;

		If (Picture<>Nil) And (PicturePos=ppLeft)
			Then PicWidth:=Gfx.ImageX(Picture)+4
			Else PicWidth:=0;
		If MarkStyle<>bmNone Then
		Begin
			MarkWidth:=Gfx.ImageX(PicBtn[MarkStyle, True, False])+1;
			Gfx.PutSprite(X2-MarkWidth+Indent,
				(Y1+Y2-Gfx.ImageY(PicBtn[MarkStyle, True, False])) Div 2+Indent,
				PicBtn[MarkStyle, Enabled, DownNow])
		End
		Else
			MarkWidth:=0;

		Font.SetFont(Kernel.CurFont);
		TempStr:=Kernel.ShortenStr(String(Caption^), X2-X1-2-PicWidth-MarkWidth);

		If PicturePos=ppLeft Then
		Begin
			If Picture<>Nil Then
				If Enabled
					Then Gfx.PutSprite(X1+3+Indent, Y1+2+Indent, Picture)
					Else Gfx.PutSpriteGrayed16(X1+3+Indent, Y1+2+Indent, Picture);
			Font.Print(X1+3+PicWidth+Indent, Y1+4+Indent, ClrFont, TempStr)
		End
		Else Begin
			If Picture<>Nil Then
			Begin
				PicWidth:=Gfx.ImageX(Picture);
				If Enabled
					Then Gfx.PutSprite((X1+X2-MarkWidth-PicWidth) Div 2+Indent,
						Y1+2+Indent, Picture)
					Else Gfx.PutSpriteGrayed16((X1+X2-MarkWidth-PicWidth) Div 2+Indent,
						Y1+2+Indent, Picture)
			End;
			Font.Print((X1+X2-MarkWidth-Font.Width(TempStr)) Div 2+1+Indent,
				Y2-16+Indent, ClrFont, TempStr)
		End
	End
End;

Function Button_PrefWidth(Me:PControl): Integer;
Var
	TempWidth: Integer;
Begin
	With Me^, TButton(Data^) Do
	Begin
		If (Picture<>Nil) And (PicturePos=ppLeft)
			Then TempWidth:=Gfx.ImageX(Picture)+4
			Else TempWidth:=0;
		If MarkStyle<>bmNone Then
			Inc(TempWidth, Gfx.ImageX(PicBtn[MarkStyle, True, False])+1);
		Font.SetFont(Kernel.CurFont);
		Inc(TempWidth, Font.Width(String(Caption^))+5)
	End;
	Button_PrefWidth:=TempWidth
End;


Function Button_OnKey(Me:PControl; Key,ExtKey:Char): Boolean;
Begin
	With Me^, TButton(Data^) Do
		If Key=' ' Then
		Begin
			DownNow:=True;
			Button_IntDraw(Me);
				{ 2fix: delay }
			Kernel.WaitTicks(2);
			DownNow:=False;
			Button_IntDraw(Me);
			CurCtl:=Me;
			With TButton(Me^.Data^) Do
				If OwnerCtl=Nil
					Then OnPress(Me^.Owner, Me)
					Else OnPress(Me^.Owner, OwnerCtl);
			Button_OnKey:=True
		End
		Else
			Button_OnKey:=False
End;


Procedure Button_Paint(Me:PControl; VX1,VY1,VX2:Integer);
Begin
	With Me^, TButton(Data^), Owner^.ClientRect Do
		If (PicturePos=ppTop) And (Picture<>Nil)
			Then D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY1+35, Me^.Place)
			Else D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY1+20, Me^.Place);
	Button_IntDraw(Me)
End;

Procedure Button_HideMouse(Var X,Y:Integer);
Begin
	ButtonInside:=D.InRect(X, Y, CurCtl^.Place);
	Kernel.HideMouse(X, Y)
End;

Procedure Button_ShowMouse(Var X,Y:Integer);
Var
	InsideNow:Boolean;
Begin
	InsideNow:=D.InRect(X, Y, CurCtl^.Place);
	If ButtonInside Xor InsideNow Then
	Begin
		TButton(CurCtl^.Data^).DownNow:=InsideNow;
		Button_IntDraw(CurCtl)
	End;
	Kernel.ShowMouse(X, Y)
End;

Procedure Button_OnClick(Me:PControl; X, Y:Integer);
Begin
	With TButton(Me^.Data^) Do
	Begin
		ButtonInside:=True;
		CurCtl:=Me;
		If Not Down Then
			DownNow:=True;
		Button_IntDraw(Me);
		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(Button_HideMouse, Button_ShowMouse,
			Kernel.RefreshNeeded)=0;
		If Not Down Then
			DownNow:=False;
		Button_IntDraw(Me);
		If D.InRect(Kernel.MsX, Kernel.MsY, Me^.Place) Then
			With Me^, TButton(Data^) Do
				If OwnerCtl=Nil
					Then OnPress(Me^.Owner, Me)
					Else OnPress(Me^.Owner, OwnerCtl)
	End
End;

Procedure Button_TryAutoRedraw(Me:PControl);
Begin
	If Me^.AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
		If (Me^.CanDraw Or Kernel.DontBother) And Me^.Visible Then
		Begin
			Kernel.BeginPaint(Me^.Place);
			Button_IntDraw(Me);
			Kernel.EndPaint
		End
End;

Procedure Button_Draw(Me:PControl);
Begin
	If (Me^.CanDraw Or Kernel.DontBother) Then
	Begin
		Kernel.BeginPaint(Me^.Place);
		If Me^.Visible
			Then Button_IntDraw(Me)
			Else Kernel.HideCtl(Me);
		Kernel.EndPaint
	End
End;

Procedure Button_SetCaption(Me:PControl; VCaption:String);
Begin
	With Me^,TButton(Data^) Do
		D.ReAssignPStr(VCaption, Caption);
	Button_TryAutoRedraw(Me)
End;

Function Button_GetCaption(Me:PControl): String;
Begin
	With Me^,TButton(Data^) Do
		Button_GetCaption:=String(Caption^)
End;

Function Button_GetPicture(Me:PControl): Pointer;
Begin
	With Me^, TButton(Data^) Do
		Button_GetPicture:=Picture
End;


Procedure Button_SetPicture(Me:PControl; VPicture:Pointer);
Begin
	With Me^,TButton(Data^) Do
		Picture:=VPicture;
	Button_TryAutoRedraw(Me)
End;

Procedure Button_SetCapAndPic(Me:PControl; VCaption:String;
	VPicture:Pointer);
Begin
	With Me^,TButton(Data^) Do
	Begin
		D.ReAssignPStr(VCaption, Caption);
		Picture:=VPicture
	End;
	Button_TryAutoRedraw(Me)
End;

Procedure Button_SetDown(Me:PControl; VDown:Boolean);
Begin
	With Me^, TButton(Data^) Do
		Down:=VDown;
	Button_TryAutoRedraw(Me)
End;

Function Button_GetDown(Me:PControl): Boolean;
Begin
	With Me^, TButton(Data^) Do
		Button_GetDown:=Down
End;


Procedure Button_SetMarkStyle(Me:PControl; VMarkStyle:TButtonMarkStyle);
Begin
	With Me^, TButton(Data^) Do
		MarkStyle:=VMarkStyle;
	Button_TryAutoRedraw(Me)
End;


Procedure Button_OnDestroy(Me:PControl);
Begin
	With Me^, TButton(Data^) Do
	Begin
		D.FreePStr(Caption, 'Ctl - Button_OnDestroy');
		FreeMem(Data, SizeOf(TButton))
	End
End;


Function Button_Create(Prog:PProg; VCaption:String; VPicture:Pointer;
	VPicturePos:TPicturePos; VOnPress:TCtlHandler): PControl;
Var
	Me:PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
	With Me^ Do
	Begin
		OnClick:=Button_OnClick;
		OnKey:=Button_OnKey;
		OnDestroy:=Button_OnDestroy;

		GetMem(Data, SizeOf(TButton));
		With TButton(Data^) Do
		Begin
			D.AssignPStr(VCaption, Caption);
			OnPress:=VOnPress;
			Picture:=VPicture;
			PicturePos:=VPicturePos;
			Down:=False;
			DownNow:=False;
			MarkStyle:=bmNone
		End
	End;
	Button_Create:=Me
End;
