{ ************ Canvas ************ }
Type
	TCanvas=Record
		Beveled: Boolean;
		OnMouseDown, OnMouseUp: TCanvasClickProc;
	End;

Procedure Canvas_Paint(Me:PControl; VX1, VY1, VX2, VY2:Integer);
Begin
	With Me^, TCanvas(Data^), Owner^.ClientRect Do
	Begin
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY2, Me^.Place);
		If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
			Exit;
		If Beveled Then
			With Me^.Place Do
			Begin
				Gfx.Rectangle(X1, Y1, X2, Y2, Kernel.ClrStatic);
				Gfx.Rectangle(X1+1, Y1+1, X2-1, Y2-1, Kernel.ClrWinBG);
				Gfx.Bar(X1+2, Y1+2, X2-2, Y2-2, kernel.ClrDisabled)
			End
	End
End;


Procedure Canvas_BeginPaint(Me:PControl);
Begin
	Kernel.BeginPaint(Me^.Place)
End;

Procedure CanvasClickDummy(Me:PProg; Control:PControl; X,Y:Integer);
Begin
End;

Procedure Canvas_OnClick(Me:PControl; X, Y:Integer);
Begin
	With Me^, TCanvas(Data^) Do
	Begin
		CurCtl:=Me;
		OnMouseDown(Owner, Me, Kernel.MsX-Place.X1, Kernel.MsY-Place.Y1);
		If Mouse.GetMask=0 Then Exit;

		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(Kernel.HideMouse, Kernel.ShowMouse,
			Kernel.RefreshNeeded)=0;
		If D.InRect(Kernel.MsX, Kernel.MsY, Me^.Place) Then
			OnMouseUp(Owner, Me, Kernel.MsX-Place.X1, Kernel.MsY-Place.Y1)
	End
End;


Procedure Canvas_SetOnMouseDown(Me:PControl; VOnMouseDown:TCanvasClickProc);
Begin
	With TCanvas(Me^.Data^) Do
	Begin
		OnMouseDown:=VOnMouseDown;
		Me^.Enabled:=True
	End
End;

Procedure Canvas_SetOnMouseUp(Me:PControl; VOnMouseUp:TCanvasClickProc);
Begin
	With TCanvas(Me^.Data^) Do
	Begin
		OnMouseUp:=VOnMouseUp;
		Me^.Enabled:=True
	End
End;


Procedure Canvas_OnDestroy(Me:PControl);
Begin
	FreeMem(Me^.Data, SizeOf(TCanvas))
End;

Function Canvas_Create(Prog:PProg; VBeveled:Boolean):PControl;
Var
	Me:PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Kernel.CtlClickDummy,
		Kernel.CtlKeyDummy, Kernel.CtlRefocusDummy, Kernel.CtlDummy,
		Kernel.CtlDummy, False, True, Hint);}
	With Me^ Do
	Begin
		OnClick:=Canvas_OnClick;
		OnDestroy:=Canvas_OnDestroy;

		Enabled:=False;
		FocusCtl:=Nil;
		D.AssignRect(-1, -1, -1, -1, Place);

		GetMem(Data, SizeOf(TCanvas));
		With TCanvas(Data^) Do
		Begin
			Beveled:=VBeveled;
			OnMouseDown:=CanvasClickDummy;
			OnMouseUp:=CanvasClickDummy
		End
	End;
	Canvas_Create:=Me
End;
