{$F+}
Unit
	CDPlayer; { Polit Halcyon CDPlayer application }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx, Popup, AudioCD;

Const
	TrackLen=200;

Type
	TCDPlayerData=Record
		BtnTrack, BtnPrev, BtnNext: PControl;
		TrkPos, LabPos: PControl;
		BtnPlay, BtnStop, BtnEject: PControl;
		PctVolume, TrkVolume: PControl;
		PicPlay, PicPause, PicStop, PicEject1, PicEject2, PicSpeaker,
		PicPrev, PicNext: {PControl}Pointer;

		CDStatus: (cdNormal, cdEjected, cdPlaying, cdPause);
		FirstTrack, LastTrack, CurTrack: Byte;
		MnuTracks: PMenuItem;

		TimSpin, TimTrack: PControl;
		PicSpin: Array[1..8] Of Pointer;
		SpinFrame: Integer;
		CurTrackLen, CurTrackPlayed: LongInt;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TCDPlayerData(Data^) Do
	Begin
			{BtnSong, BtnPrev, BtnNext: PControl;
			TrkPos, LabPos: PControl;
			BtnPlay, BtnStop, BtnEject: PControl;
			PctVolume, TrkVolume: PControl;}
		Ctl.Button_Paint(BtnTrack, 10, 10, 150);
		Ctl.Button_Paint(BtnPrev, 155, 10, 178);
		Ctl.Button_Paint(BtnNext, 183, 10, 206);

		Ctl.Track_Paint(TrkPos, 10, 50, 150);
		Ctl.Label_Paint(LabPos, 155, 50, 206);

		Ctl.Button_Paint(BtnPlay, 10, 80, 54);
		Ctl.Button_Paint(BtnStop, 59, 80, 82);
		Ctl.Button_Paint(BtnEject, 87, 80, 110);

		Ctl.PicCtl_Paint(PctVolume, 135, 83);
		Ctl.Track_Paint(TrkVolume, 155, 80, 206)
	End;
End;

Function OnKey(Me:PProg; Key,ExtKey:Char): Boolean;
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin


	End;
	OnKey:=False
End;



Procedure PlayNewCurTrack(Me:PProg);
Var
	StartSec, TrackLen, DiskEnd: LongInt;
	Min, Sec, Frame: LongInt;
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		Ctl.Button_SetCaption(BtnTrack, 'i '+D.St(CurTrack));
			{ check length }
		AudioCD.Calculate_Track(CurTrack, StartSec, TrackLen, DiskEnd);
		AudioCD.HSG2RED(TrackLen, Min, Sec, Frame);
		Ctl.Label_SetCaption(LabPos, D.St2(Min)+':'+D.St2(Sec));
		CurTrackLen:=Min*60+Sec;
		CurTrackPlayed:=1;
		Ctl.Track_SetPos(TrkPos, 1);
		If CDStatus In [cdPlaying, cdPause] Then
		Begin
			AudioCD.Stop_Audio;
			AudioCD.Play_Track(CurTrack);
			If CDStatus=cdPause Then
			Begin
				Ctl.Button_SetCapAndPic(BtnPlay, '', PicPause);
				CDStatus:=cdPlaying
			End
		End
	End
End;

Procedure OnTrackClick(Me:PProg; Item:PMenuItem);
Var
	TempStr: String;
	Res: Word;
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		TempStr:=String(Item^.Name^);
		Delete(TempStr, 1, 8);
		Val(TempStr, CurTrack, Res);
		PlayNewCurTrack(Me)
	End
End;

Procedure CountTracks(Me:PProg);
Var
	TempLeadOut: LongInt;
	V: Byte;
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		FirstTrack:=0;
		LastTrack:=0;
		AudioCD.Audio_Disk_Info(FirstTrack, LastTrack, TempLeadOut);
		If Not D.InRange(CurTrack, FirstTrack, LastTrack) Then
			CurTrack:=FirstTrack;

		If MnuTracks<>Nil Then
		Begin
			Popup.FreeMenu(MnuTracks);
			MnuTracks:=Popup.CreateMenu
		End;
		For V:=FirstTrack To LastTrack Do
			Popup.AddCommand(MnuTracks, 'i '+D.St(V), '', '', Nil,
				True, OnTrackClick);
		Ctl.Button_SetCaption(BtnTrack, 'i '+D.St(CurTrack));

		PlayNewCurTrack(Me)
	End
End;




Procedure OnTrackBtnClick(Me:PProg; Control:PControl);
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		With Control^.Place Do
			Popup.OpenMenu(Me, MnuTracks, X1, Y2+1)
	End
End;


Procedure OnPlayClick(Me:PProg; Control:PControl);
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		Case CDStatus Of
			cdNormal: Begin
				AudioCD.Play_Track(CurTrack);
				Ctl.Button_SetCapAndPic(BtnPlay, '', PicPause);
				CDStatus:=cdPlaying
			End;
			cdPlaying: Begin
				AudioCD.Pause_Audio;
				Ctl.Button_SetCapAndPic(BtnPlay, '', PicPlay);
				CDStatus:=cdPause
			End;
			cdPause: Begin
				AudioCD.Resume_Audio;
				Ctl.Button_SetCapAndPic(BtnPlay, '', PicPause);
				CDStatus:=cdPlaying
			End;
		End
	End
End;

Procedure OnStopClick(Me:PProg; Control:PControl);
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		If CDStatus=cdPause Then
		Begin
			AudioCD.Resume_Audio;
			CDStatus:=cdPlaying
		End;
		If CDStatus=cdPlaying Then
		Begin
			AudioCD.Stop_Audio;
			CDStatus:=cdNormal;
			Ctl.Button_SetCapAndPic(BtnPlay, '', PicPlay);
		End
	End
End;


Procedure OnEjectClick(Me:PProg; Control:PControl);
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		If CDStatus=cdNormal Then
		Begin
			AudioCD.Eject_Disk;
			Ctl.Button_SetCapAndPic(BtnEject, '', PicEject2);
			CDStatus:=cdEjected
		End
		Else Begin
			AudioCD.Close_Tray;
			Ctl.Button_SetCapAndPic(BtnEject, '', PicEject1);
			CDStatus:=cdNormal;
			AudioCD.ReadTOC;
			BCRT.Delay(1400);
			CountTracks(Me)
		End

	End
End;


Procedure OnPrevClick(Me:PProg; Control:PControl);
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		If CurTrack=FirstTrack
			Then CurTrack:=LastTrack
			Else Dec(CurTrack);
		PlayNewCurTrack(Me)
	End
End;


Procedure OnNextClick(Me:PProg; Control:PControl);
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		If CurTrack=LastTrack
			Then CurTrack:=FirstTrack
			Else Inc(CurTrack);
		PlayNewCurTrack(Me)
	End
End;

Procedure OnVolumeTrack(Me:PProg; Control:PControl);
Var
	Volume: Byte;
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		Volume:=Ctl.Track_GetPos(TrkVolume)*10;
		AudioCD.Audio_Channel_Control(0, Volume, 1, Volume, 2, Volume, 3, Volume)
	End
End;






Procedure OnSpinTimer(Me:PProg; Control:PControl; Times:Integer);
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		If Not (CDStatus=cdPlaying) Then Exit;
		If Not BtnTrack^.CanDraw Then Exit;
		D.Cycle(SpinFrame, 1, 8);
		Kernel.SetWindowCapAndIcon(Me, ' CD', PicSpin[SpinFrame])
	End
End;

Procedure OnTrackTimer(Me:PProg; Control:PControl; Times:Integer);
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		If CDStatus=cdPlaying Then
		Begin
			Inc(CurTrackPlayed, Times);
			Ctl.Track_SetPos(TrkPos, CurTrackPlayed*TrackLen Div CurTrackLen)
		End
	End
End;

{Procedure DebugOnIdle(Me:PProg);
Var
	DevStatus:Word;
	Temp1, Temp2: LongInt;
	TempStr: String;
Begin
	With Me^, TCDPlayerData(Data^) Do
	Begin
		AudioCD.Audio_Status(DevStatus, Temp1, Temp2);
		If (DevStatus And csPlaying)<>0
			Then TempStr:='Playing'+#13
			Else TempStr:=#13;
		If (DevStatus And csDoorOpen)<>0
			Then TempStr:=TempStr+'DoorOpen';
		Ctl.Label_SetCaption(LabStatus, TempStr)
	End
End;}


Procedure OnClose(Me:PProg);
Begin
	Kernel.FreeRes('b_play.bmp');
	Kernel.FreeRes('b_pause.bmp');
	Kernel.FreeRes('b_stop.bmp');
	Kernel.FreeRes('b_eject1.bmp');
	Kernel.FreeRes('b_eject2.bmp');
	Kernel.FreeRes('speaker.bmp');
	Kernel.FreeRes('b_prev.bmp');
	Kernel.FreeRes('b_next.bmp');
	Kernel.FreeRes('spin1.bmp');
	Kernel.FreeRes('spin2.bmp');
	Kernel.FreeRes('spin3.bmp');
	Kernel.FreeRes('spin4.bmp');
	Kernel.FreeRes('spin5.bmp');
	Kernel.FreeRes('spin6.bmp');
	Kernel.FreeRes('spin7.bmp');
	Kernel.FreeRes('spin8.bmp');
	FreeMem(Me^.Data, SizeOf(TCDPlayerData))
End;

Procedure OnInit(Me:PProg);
Var
	DevStatus:Word;
	Temp1, Temp2: LongInt;
	TempIcon: Pointer;
	Ch0, Vol0, Ch1, Vol1, Ch2, Vol2, Ch3, Vol3: Byte;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnKey:=OnKey;
	{Me^.OnIdle:=DebugOnIdle;}
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr(' CD', WinTitle);
		MinX:=216{300};
		MinY:=110;
		GetMem(Data, SizeOf(TCDPlayerData));
		Kernel.InitWindow(Me, 'BlueDlg', [wbClose]);
		Kernel.DrawWindowAni(Me);

		With TCDPlayerData(Data^) Do
		Begin
			PicPlay:=Kernel.LoadBMPRes('pic\b_play.bmp');
			PicPause:=Kernel.LoadBMPRes('pic\b_pause.bmp');
			PicStop:=Kernel.LoadBMPRes('pic\b_stop.bmp');
			PicEject1:=Kernel.LoadBMPRes('pic\b_eject1.bmp');
			PicEject2:=Kernel.LoadBMPRes('pic\b_eject2.bmp');
			PicSpeaker:=Kernel.LoadBMPRes('pic\speaker.bmp');
			PicPrev:=Kernel.LoadBMPRes('pic\b_prev.bmp');
			PicNext:=Kernel.LoadBMPRes('pic\b_next.bmp');

			PicSpin[1]:=Kernel.LoadBMPRes('prog\cdplay\spin1.bmp');
			PicSpin[2]:=Kernel.LoadBMPRes('prog\cdplay\spin2.bmp');
			PicSpin[3]:=Kernel.LoadBMPRes('prog\cdplay\spin3.bmp');
			PicSpin[4]:=Kernel.LoadBMPRes('prog\cdplay\spin4.bmp');
			PicSpin[5]:=Kernel.LoadBMPRes('prog\cdplay\spin5.bmp');
			PicSpin[6]:=Kernel.LoadBMPRes('prog\cdplay\spin6.bmp');
			PicSpin[7]:=Kernel.LoadBMPRes('prog\cdplay\spin7.bmp');
			PicSpin[8]:=Kernel.LoadBMPRes('prog\cdplay\spin8.bmp');

			{BtnSong, BtnPrev, BtnNext: PControl;
			TrkPos, LabPos: PControl;
			BtnPlay, BtnStop, BtnEject: PControl;
			PctVolume, TrkVolume: PControl;}

			AudioCD.ReadTOC;
			AudioCD.Audio_Status(DevStatus, Temp1, Temp2);
			CDStatus:=cdNormal;
			If (DevStatus And csPlaying)=0 Then CDStatus:=cdPlaying;
			If (DevStatus And csDoorOpen)=0 Then CDStatus:=cdEjected;

			BtnTrack:=Ctl.Button_Create(Me, 'i 1', Nil, ppLeft,
				OnTrackBtnClick);
			Ctl.Button_SetMarkStyle(BtnTrack, bmMenuDown);
			BtnPrev:=Ctl.Button_Create(Me, '', PicPrev, ppLeft, OnPrevClick);
			BtnNext:=Ctl.Button_Create(Me, '', PicNext, ppLeft, OnNextClick);

			TrkPos:=Ctl.Track_Create(Me, 1, TrackLen, 1, tkMonoWidth, False,
				Kernel.CtlDummyProc);
			LabPos:=Ctl.Label_Create(Me, '00:00', Nil, lsBeveled, alCenter);

			If CDStatus=cdPlaying
				Then TempIcon:=PicPause
				Else TempIcon:=PicPlay;
			BtnPlay:=Ctl.Button_Create(Me, '', TempIcon, ppLeft, OnPlayClick);
			BtnStop:=Ctl.Button_Create(Me, '', PicStop, ppLeft, OnStopClick);
			If CDStatus=cdEjected
				Then TempIcon:=PicEject2
				Else TempIcon:=PicEject1;
			BtnEject:=Ctl.Button_Create(Me, '', TempIcon, ppLeft, OnEjectClick);

			PctVolume:=Ctl.PicCtl_Create(Me, PicSpeaker, False, False, True);
			AudioCD.Audio_Channel_Info(Ch0, Vol0, Ch1, Vol1, Ch2, Vol2, Ch3, Vol3);
			Vol0:=180;
			TrkVolume:=Ctl.Track_Create(Me, 0, 25,	Vol0 Div 10,
				tkGrowRight, False, OnVolumeTrack);

			{LabStatus:=Ctl.Label_Create(Me, '', Nil, lsNormal, alLeft);}
			TimSpin:=Ctl.TimerCtl_Create(Me, 1, True, OnSpinTimer);
			SpinFrame:=1;
			TimTrack:=Ctl.TimerCtl_Create(Me, 18, True, OnTrackTimer);

			ActiveCtl:=BtnPlay;

			MnuTracks:=Popup.CreateMenu;
			CurTrack:=1;
			CountTracks(Me);
		End
	End
End;



Begin
	Kernel.RegBuiltIn('CDPlayer', 'CD- ', 'pic\i_cdplay.bmp', OnInit)
End.
