{ ************ Check box ************ }
Type
	TCheck=Record
		Caption: PStr;
		OnChange: TCtlHandler;
		Checked, CheckedNow: Boolean
	End;

Var
	CheckInside: Boolean;
	{PicCheck: TSkinPic;}



Procedure Check_IntDraw(Me:PControl);
Var
	TempStr: String;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, Place, TCheck(Data^) Do
	Begin
		Gfx.PutSprite(X1, Y1, PicCheck[Enabled, CheckedNow]);
		Font.SetFont(Kernel.CurFont);
		TempStr:=Kernel.ShortenStr(String(Caption^), X2-X1-21);
		If Enabled
			Then Font.Print(X1+21, Y1+2, Kernel.ClrText, TempStr)
			Else Font.Print(X1+21, Y1+2, Kernel.ClrTextDis, TempStr)
	End;
End;

Procedure Check_Paint(Me:PControl; VX1, VY1:Integer);
Begin
	Font.SetFont(Kernel.CurFont);
	With Me^, TCheck(Data^), Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1+2, X1+VX1+Font.Width(String(Caption^))+21,
			Y1+VY1+14+2, Me^.Place);
	Check_IntDraw(Me)
End;

Function Check_OnKey(Me:PControl; Key,ExtKey:Char): Boolean;
Begin
	With Me^, TCheck(Data^) Do
		If Key=' ' Then
		Begin
			Checked:=Not Checked;
			CheckedNow:=Checked;
			Check_IntDraw(Me);
			TCheck(Me^.Data^).OnChange(Me^.Owner, Me);
			Check_OnKey:=True
		End
		Else
			Check_OnKey:=False
End;


Procedure Check_HideMouse(Var X,Y:Integer);
Begin
	CheckInside:=D.InRect(X, Y, CurCtl^.Place);
	Kernel.HideMouse(X, Y)
End;

Procedure Check_ShowMouse(Var X,Y:Integer);
Var
	InsideNow: Boolean;
Begin
	InsideNow:=D.InRect(X, Y, CurCtl^.Place);
	With TCheck(CurCtl^.Data^) Do
		If CheckInside Xor InsideNow Then
		Begin
			If InsideNow
				Then CheckedNow:=Not Checked
				Else CheckedNow:=Checked;
			Check_IntDraw(CurCtl)
		End;
	Kernel.ShowMouse(X, Y)
End;

Procedure Check_OnClick(Me:PControl; X, Y:Integer);
Begin
	With TCheck(Me^.Data^) Do
	Begin
		CheckInside:=True;
		CurCtl:=Me;
		CheckedNow:=Not Checked;
		Check_IntDraw(Me);
		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(Check_HideMouse, Check_ShowMouse,
			Kernel.RefreshNeeded)=0;
		Checked:=CheckedNow;
		Check_IntDraw(Me);
		If D.InRect(Kernel.MsX, Kernel.MsY, Me^.Place) Then
			With Me^ Do
				TCheck(Data^).OnChange(Owner, Me)
	End
End;

Procedure Check_TryAutoRedraw(Me:PControl);
Begin
	If Me^.AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
		If (Me^.CanDraw Or Kernel.DontBother) And Me^.Visible Then
		Begin
			Kernel.BeginPaint(Me^.Place);
			Check_IntDraw(Me);
			Kernel.EndPaint
		End
End;

Procedure Check_Draw(Me:PControl);
Begin
	If (Me^.CanDraw Or Kernel.DontBother) Then
	Begin
		Kernel.BeginPaint(Me^.Place);
		If Me^.Visible
			Then Check_IntDraw(Me)
			Else Kernel.HideCtl(Me);
		Kernel.EndPaint
	End
End;


Procedure Check_SetCaption(Me:PControl; VCaption:String);
Begin
	With Me^, TCheck(Data^) Do
		D.ReAssignPStr(VCaption, Caption);
	Kernel.BeginPaint(Me^.Place);
	Kernel.HideCtl(Me);
	Kernel.EndPaint;
	Check_TryAutoRedraw(Me)
End;

Procedure Check_SetState(Me:PControl; VChecked:Boolean);
Begin
	With Me^, TCheck(Data^) Do
		Checked:=VChecked;
	Check_TryAutoRedraw(Me)
End;

Function Check_GetState(Me:PControl):Boolean;
Begin
	Check_GetState:=TCheck(Me^.Data^).Checked
End;

Procedure Check_SetOnChange(Me:PControl; VOnChange:TCtlHandler);
Begin
	With Me^, TCheck(Data^) Do
		OnChange:=VOnChange
End;


Procedure Check_OnDestroy(Me:PControl);
Begin
	With Me^, TCheck(Data^) Do
		D.FreePStr(Caption, 'Ctl - Check_OnDestroy');
	FreeMem(Me^.Data, SizeOf(TCheck))
End;

Function Check_Create(Prog:PProg; VCaption:String; VChecked:Boolean): PControl;
Var
	Me:PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
	With Me^ Do
	Begin
		OnClick:=Check_OnClick;
		OnKey:=Check_OnKey;
		OnDestroy:=Check_OnDestroy;

		GetMem(Data, SizeOf(TCheck));
		With TCheck(Data^) Do
		Begin
			D.AssignPStr(VCaption, Caption);
			OnChange:=Kernel.CtlDummyProc;
			Checked:=VChecked;
			CheckedNow:=VChecked;
		End
	End;
	Check_Create:=Me
End;
