{$F+}
Unit
	ColorDlg; { Polit Halcyon ColorDlg application }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx;

Type
	TColorDlgData=Record
		NbkPages, CslTest: PControl;
		PicSpectre, PicTracks: Pointer;
		LabHue, TrkHue, LabLum, TrkLum, LabSat, TrkSat: PControl;
		CanSample: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TColorDlgData(Data^) Do
	Begin
		Ctl.Notebook_Paint(NbkPages, 5, 5, X2-X1-5, Y2-Y1-35);

		Ctl2.ColorSel_Paint(CslTest, 10, 35, X2-X1-10, Y2-Y1-40);

		Ctl.Label_Paint(LabHue, 10, 35, 80);
		Ctl.Track_Paint(TrkHue, 90, 35, X2-X1-15);
		Ctl.Label_Paint(LabLum, 10, 65, 80);
		Ctl.Track_Paint(TrkLum, 90, 65, 160);
		Ctl.Label_Paint(LabSat, 10, 95, 80);
		Ctl.Track_Paint(TrkSat, 90, 95, 130);
		Ctl.Canvas_Paint(CanSample, 5, Y2-Y1-26, 70, Y2-Y1-5);
	End;
End;

Procedure OnColorTrack(Me:PProg; Control:PControl);
Var
	Hue, Sat, Lum: Integer;
	CurColor: TColor;
Begin
	With Me^, TColorDlgData(Data^) Do
	Begin
		Hue:=Ctl.Track_GetPos(TrkHue);
		Lum:=Ctl.Track_GetPos(TrkLum);
		Sat:=Ctl.Track_GetPos(TrkSat);
		CurColor:=32+Sat*96+Lum*24+Hue;
		Ctl.Canvas_BeginPaint(CanSample);
		With CanSample^.Place Do
			Gfx.Bar(X1+3, Y1+3, X2-3, Y2-3, CurColor);
		Kernel.EndPaint
	End
End;

Procedure OnClose(Me:PProg);
Begin
	Kernel.FreeRes('b_spectr.bmp');
	Kernel.FreeRes('b_trackb.bmp');
	FreeMem(Me^.Data, SizeOf(TColorDlgData))
End;

Procedure OnInit(Me:PProg);
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('i ', WinTitle);
		MinX:=210;
		MinY:=158;
		GetMem(Data, SizeOf(TColorDlgData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TColorDlgData(Data^) Do
		Begin
			PicSpectre:=Kernel.LoadBMPRes('pic\b_spectr.bmp');
			PicTracks:=Kernel.LoadBMPRes('pic\b_trackb.bmp');

			NbkPages:=Ctl.Notebook_Create(Me, False);
			CslTest:=Ctl2.ColorSel_Create(Me, clBlack);
			Ctl.Notebook_AddPage(NbkPages, 'i', '', PicSpectre);
			LabHue:=Ctl.Label_Create(Me, 'ii:', Nil, lsNormal, alRight);
			TrkHue:=Ctl.Track_Create(Me, 0, 23, 0, tkMonowidth, False, OnColorTrack);
			LabLum:=Ctl.Label_Create(Me, 'ࠢi:', Nil, lsNormal, alRight);
			TrkLum:=Ctl.Track_Create(Me, 0, 3, 0, tkGrowRight, True, OnColorTrack);
			LabSat:=Ctl.Label_Create(Me, '祭i:', Nil, lsNormal, alRight);
			TrkSat:=Ctl.Track_Create(Me, 0, 1, 0, tkGrowRight, True, OnColorTrack);
			Ctl.Notebook_AddPage(NbkPages, '᫮i 祭', '', PicTracks);
			CanSample:=Ctl.Canvas_Create(Me, True);
			ActiveCtl:=CslTest;
		End
	End
End;



Begin
	Kernel.RegBuiltIn('ColorDlg', 'ColorDlg', 'pic\i_clrsel.bmp', OnInit)
End.
