{$F+}
Unit
	Ctl; { Polit Halcyon controls (interface) unit }

Interface

Uses
	D, Log, Ini, Kernel, Types, Gfx, Font, Popup, Ctl2;

Type
	TTimerCtlProc=Procedure(Me:PProg; Control:PControl; Times:Integer);
	TProgressKind=(pkDeterm, pkIndeterm);
	TTrackKind=(tkMonowidth, tkGrowRight, tkGrowLeft);
	TPicturePos=(ppTop, ppLeft);
	TLabelStyle=(lsNormal, lsDisabled, lsComment, lsBeveled);
	TSplitterArrows=(saNone, saLeftUp, saRightDown);
	TButtonMarkStyle=(bmNone, bmMenuDown, bmMenuUp, bmSwitch, bmDialog);
	TCanvasClickProc=Procedure(Me:PProg; Control:PControl; X,Y:Integer);
	TInpLineChangeFunc=Function(Me:PProg; Control:PControl; Ch:String): String;


	Procedure Init;
	Procedure Done;


	Procedure Canvas_Paint(Me:PControl; VX1, VY1, VX2, VY2:Integer);
	Procedure Canvas_BeginPaint(Me:PControl);
	Procedure Canvas_SetOnMouseDown(Me:PControl; VOnMouseDown:TCanvasClickProc);
	Procedure Canvas_SetOnMouseUp(Me:PControl; VOnMouseUp:TCanvasClickProc);
	Function Canvas_Create(Prog:PProg; VBeveled:Boolean): PControl;

	Procedure Button_Draw(Me:PControl);
	Procedure Button_Paint(Me:PControl; VX1, VY1, VX2:Integer);
	Function Button_PrefWidth(Me:PControl): Integer;
	Procedure Button_SetDown(Me:PControl; VDown:Boolean);
	Function Button_GetDown(Me:PControl): Boolean;
	Procedure Button_SetCaption(Me:PControl; VCaption:String);
	Function Button_GetCaption(Me:PControl): String;
	Function Button_GetPicture(Me:PControl): Pointer;
	Procedure Button_SetPicture(Me:PControl; VPicture:Pointer);
	Procedure Button_SetCapAndPic(Me:PControl; VCaption:String;
		VPicture:Pointer);
	Procedure Button_SetMarkStyle(Me:PControl; VMarkStyle:TButtonMarkStyle);
	Function Button_Create(Prog:PProg; VCaption:String; VPicture:Pointer;
		VPicturePos:TPicturePos; VOnPress:TCtlHandler): PControl;

	Procedure Label_Paint(Me:PControl; VX1, VY1, VX2:Integer);
	Procedure Label_Draw(Me:PControl);
	Procedure Label_SetCaption(Me:PControl; VCaption:String);
	Procedure Label_SetStyle(Me:PControl; VStyle:TLabelStyle);
	Function Label_GetCaption(Me:PControl): String;
	Function Label_GetPicture(Me:PControl): Pointer;
	Procedure Label_CopyToClipboard(Me:PControl);
	Function Label_Create(Prog:PProg; VCaption:String; VPicture:Pointer;
		VStyle:TLabelStyle; VAlign:TAlign): PControl;

	Procedure InpLine_Paint(Me:PControl; VX1, VY1, VX2:Integer);
	Procedure InpLine_PaintDirect(Me:PControl;VX1,VY1,VX2:Integer);
	Procedure InpLine_Draw(Me:PControl);
	Function InpLine_GetText(Me:PControl): String;
	Procedure InpLine_SetText(Me:PControl; VText:String);
	Procedure InpLine_SetOnChangeFunc(Me:PControl; VOnChange:TInpLineChangeFunc);
	Function InpLine_Create(Prog:PProg; VText:String; VIcon:Pointer): PControl;

	Procedure Scroll_Paint(Me:PControl; VX1, VY1, VX2, VY2:Integer);
	Procedure Scroll_PaintDirect(Me:PControl; VX1, VY1, VX2, VY2:Integer);
	Procedure Scroll_Draw(Me:PControl);
	Procedure Scroll_SetParams(Me:PControl; VTotalLen, VVisLen, VFirstItem:Integer);
	Function Scroll_GetPos(Me:PControl): Integer;
	Function Scroll_Create(Prog:PProg; VTotalLen,VVisLen,VFirstItem:Integer;
		VOrient:TOrientation; VOnUpdate:TCtlHandler):PControl;
		{OK}
	Procedure Check_Paint(Me:PControl; VX1, VY1:Integer);
	Procedure Check_Draw(Me:PControl);
	Procedure Check_SetCaption(Me:PControl; VCaption:String);
	Procedure Check_SetState(Me:PControl; VChecked:Boolean);
	Function Check_GetState(Me:PControl): Boolean;
	Procedure Check_SetOnChange(Me:PControl; VOnChange:TCtlHandler);
	Function Check_Create(Prog:PProg; VCaption:String; VChecked:Boolean): PControl;
		{OK}
	Procedure Radio_Paint(Me:PControl; VX1, VY1:Integer);
	Procedure Radio_Draw(Me:PControl);
	Procedure Radio_Select(Me:PControl);
	Function Radio_Selected(Me:PControl): Boolean;
	Procedure Radio_SetOnChange(Me:PControl; VOnChange:TCtlHandler);
	Function Radio_Create(Prog:PProg; VCaption:String; VSelected:Boolean;
		VGroup:Integer): PControl;

	Procedure Header_Paint(Me:PControl; VX1, VY1, VX2:Integer);
	Procedure Header_SetCaption(Me:PControl; VCaption:String);
	Function Header_Create(Prog:PProg; VCaption:String): PControl;

	Procedure Progress_Paint(Me:PControl; VX1, VY1, VX2:Integer);
	Procedure Progress_Draw(Me:PControl);
	Procedure Progress_SetValue(Me:PControl; VValue:Integer);
	Procedure Progress_SetParams(Me:PControl; VMin,VMax,VValue:Integer);
	Procedure Progress_SetKind(Me:PControl; VKind:TProgressKind);
	Procedure Progress_Step(Me:PControl);
	Function Progress_Create(Prog:PProg; VMin,VMax,VValue:Integer;
		VKind:TProgressKind): PControl;

	Procedure TimerCtl_SetActive(Me:PControl; VActive:Boolean);
	Function TimerCtl_Create(Prog:PProg; Freq:Integer; VActive:Boolean;
		VOnTimer:TTimerCtlProc): PControl;

	Procedure TabSet_Paint(Me:PControl; VX1, VY1, VX2, VY2:Integer);
	Procedure TabSet_PaintDirect(Me:PControl; VX1, VY1, VX2, VY2:Integer);
	Procedure TabSet_SetActiveTab(Me:PControl; VActiveTab:Integer);
	Function TabSet_GetActiveTab(Me:PControl): Integer;
	Procedure TabSet_AddTab(Me:PControl; VName, VHint:String; VIcon:Pointer);
	Function TabSet_Create(Prog:PProg; VDarkBack:Boolean;
		VOnChange:TCtlHandler):PControl;

	Procedure Notebook_Paint(Me:PControl; VX1, VY1, VX2, VY2:Integer);
	Procedure Notebook_AddPage(Me:PControl; VName, VHint:String; VIcon:Pointer);
	Procedure Notebook_SetActivePage(Me:PControl; VActivePage:Integer);
	Function Notebook_GetActivePage(Me:PControl): Integer;
	Procedure Notebook_SetOnChange(Me:PControl; VOnChange:TCtlHandler);
	Function Notebook_Create(Prog:PProg;VGrayBack:Boolean): PControl;
		{OK}
	Procedure Track_Paint(Me:PControl; VX1, VY1, VX2:Integer);
	Procedure Track_Draw(Me:PControl);
	Function Track_GetPos(Me:PControl): Integer;
	Procedure Track_SetPos(Me:PControl; VPos:Integer);
	Function Track_Create(Prog:PProg; VMin, VMax, VValue:Integer;
		VKind:TTrackKind; VTicks:Boolean; VOnUpdate:TCtlHandler): PControl;

	Procedure PicCtl_Paint(Me:PControl; VX,VY:Integer);
	Procedure PicCtl_Draw(Me:PControl);
	Procedure PicCtl_SetPicture(Me:PControl; VPicture:Pointer);
	Function PicCtl_Create(Prog:PProg; VPicture:Pointer;
		VBeveled,VBig,VTransp:Boolean):PControl;

	Procedure PopupBtn_Paint(Me:PControl; VX1, VY1, VX2:Integer);
	Function PopupBtn_AsButton(Me:PControl): PControl;
	Function PopupBtn_Create(Prog:PProg; VCaption:String; VMenu:PMenuItem;
		VPicture:Pointer; VPicturePos:TPicturePos): PControl;

	Procedure Splitter_Paint(Me:PControl; VX1,VY1,VX2,VY2:Integer);
	Function Splitter_GetCoord(Me:PControl): Integer;
	Procedure Splitter_SetCoord(Me:PControl; VCoord:Integer);
	Function Splitter_Create(Prog:PProg; VPos:Integer;
		VOrient:TOrientation; VArrows:TSplitterArrows): PControl;

	Procedure Switcher_Paint(Me:PControl; VX1, VY1, VX2:Integer);
	Function Switcher_AsButton(Me:PControl): PControl;
	Function Switcher_Create(Prog:PProg; VMenu:PMenuItem;
		VPicturePos:TPicturePos): PControl;

	Procedure MainMenu_Paint(Me:PControl; VX1, VY1, VX2:Integer);
	Function MainMenu_Create(Prog:PProg; VMenu:PMenuItem;
		VPicturePos:TPicturePos): PControl;

	Procedure SpinEdit_Paint(Me:PControl; VX1,VY1,VX2:Integer);
	Procedure SpinEdit_Draw(Me:PControl);
	Function SpinEdit_GetValue(Me:PControl): Integer;
	Procedure SpinEdit_SetOnChange(Me:PControl; VOnChange:TCtlHandler);
	Function SpinEdit_Create(Prog:PProg; VMin,VMax,VStep,VValue:Integer): PControl;

Var
	PicCheck: TSkinPic; { used by Check & ListBox }


Implementation

Var
	CurCtl:PControl;

	LastMsX, LastMsY: Integer;
	Delta: Integer;
	MouseScrUp, MouseScrDown, MouseScrLeft, MouseScrRight: Pointer;
	MouseScrVer, MouseScrHor: Pointer;

	

	

{$I Canvas.Inc}

{$I Button.Inc}

{$I Label.Inc}

{$I InpLine.Inc}

{$I Scroll.Inc}

{$I Check.Inc}

{$I Radio.Inc}

{$I Header.Inc}

{$I Progress.Inc}

{$I TimerCtl.Inc}

{$I TabSet.Inc}

{$I Notebook.Inc}

{$I Track.Inc}

{$I PicCtl.Inc}

{$I PopupBtn.Inc}

{$I Splitter.Inc}

{$I Switcher.Inc}

{$I MainMenu.Inc}

{$I SpinEdit.Inc}














Procedure Init;
Var
	P: Pointer;
Begin
		{    InpLine }
	Pic.LoadBMP(Kernel.SkinDir+'inp_left.bmp', P);
	Gfx.SplitSkin3(P, PicInpL);
	InpArrowsWidth:=Gfx.ImageX(PicInpL[True, False]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'inp_rght.bmp', P);
	Gfx.SplitSkin3(P, PicInpR);
	Kernel.LoadingStep;

		{  ii ப⪨ Scroll }
	Pic.LoadBMP(Kernel.SkinDir+'scr_ver.bmp', P);
	Gfx.SplitSkin4(P, PicLine[orVertical]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_hor.bmp', P);
	Gfx.SplitSkin4(P, PicLine[orHorizontal]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_up.bmp', P);
	Gfx.SplitSkin3(P, PicArDec[orVertical]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_down.bmp', P);
	Gfx.SplitSkin3(P, PicArInc[orVertical]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_left.bmp', P);
	Gfx.SplitSkin3(P, PicArDec[orHorizontal]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_rght.bmp', P);
	Gfx.SplitSkin3(P, PicArInc[orHorizontal]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_hdrg.bmp', P);
	Gfx.SplitSkin3(P, PicDrag[orHorizontal]);
	ScrollDragSkinned:=(Gfx.ImageY(PicDrag[orHorizontal, True, False])>1);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_vdrg.bmp', P);
	Gfx.SplitSkin3(P, PicDrag[orVertical]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_sldu.bmp', P);
	Gfx.SplitSkin3(P, PicSlider1[orVertical]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_sldd.bmp', P);
	Gfx.SplitSkin3(P, PicSlider2[orVertical]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_sldl.bmp', P);
	Gfx.SplitSkin3(P, PicSlider1[orHorizontal]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'scr_sldr.bmp', P);
	Gfx.SplitSkin3(P, PicSlider2[orHorizontal]);
	ScrollSliderSkinned:=(Gfx.ImageY(PicSlider1[orHorizontal, True, False])>1);
	MinSliderSize:=Gfx.ImageX(PicDrag[orHorizontal, True, False])+
		Gfx.ImageX(PicSlider1[orHorizontal, True, False])+
		Gfx.ImageX(PicSlider2[orHorizontal, True, False])+1;
	Kernel.LoadingStep;

		{  䫠 Check }
	Pic.LoadBMP(Kernel.SkinDir+'check.bmp', P);
	Gfx.SplitSkin4(P, PicCheck);
	Kernel.LoadingStep;
		{  ࠤi Radio }
	Pic.LoadBMP(Kernel.SkinDir+'radio.bmp', P);
	Gfx.SplitSkin4(P, PicRadio);
	Kernel.LoadingStep;
		{   Button }
	Pic.LoadBMP(Kernel.SkinDir+'btn_up.bmp', P);
	Gfx.SplitSkin3(P, PicBtn[bmMenuUp]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'btn_down.bmp', P);
	Gfx.SplitSkin3(P, PicBtn[bmMenuDown]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'btn_rght.bmp', P);
	Gfx.SplitSkin3(P, PicBtn[bmSwitch]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'btn_dlg.bmp', P);
	Gfx.SplitSkin3(P, PicBtn[bmDialog]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'buttonl.bmp', P);
	Gfx.SplitSkin4(P, PicBtnL[ppLeft]);
	Kernel.LoadingStep;
	ButtonSkinned:=(Gfx.ImageY(PicBtnL[ppLeft, True, False])>1);
	Pic.LoadBMP(Kernel.SkinDir+'buttonr.bmp', P);
	Gfx.SplitSkin4(P, PicBtnR[ppLeft]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'buttonc.bmp', P);
	Gfx.SplitSkin4(P, PicBtnC[ppLeft]);
	ButtonTiledSkin:=(Gfx.ImageY(PicBtnC[ppLeft, True, False])>1);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'button2l.bmp', P);
	Gfx.SplitSkin4(P, PicBtnL[ppTop]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'button2r.bmp', P);
	Gfx.SplitSkin4(P, PicBtnR[ppTop]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'button2c.bmp', P);
	Gfx.SplitSkin4(P, PicBtnC[ppTop]);
	Kernel.LoadingStep;

		{  ii Track }
	Pic.LoadBMP(Kernel.SkinDir+'track.bmp', P);
	Gfx.SplitSkin3(P, PicTrack);
	TrackHalfWidth:=Gfx.ImageX(PicTrack[True, False]) Div 2;
	Kernel.LoadingStep;
		{  SpinEdit }
	Pic.LoadBMP(Kernel.SkinDir+'spn_up.bmp', P);
	Gfx.SplitSkin3(P, PicSpinUp);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'spn_down.bmp', P);
	Gfx.SplitSkin3(P, PicSpinDown);
	SpinArrowWidth:=Gfx.ImageX(PicSpinUp[True, False]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'spn_drag.bmp', P);
	Gfx.SplitSkin3(P, PicSpinDrag);
	SpinDragWidth:=Gfx.ImageX(PicSpinUp[True, False]);
	Kernel.LoadingStep;
		{  Splitter }
	Pic.LoadBMP(Kernel.SkinDir+'spl_up.bmp', P);
	Gfx.SplitSkin3(P, PicSplit[drUp]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'spl_down.bmp', P);
	Gfx.SplitSkin3(P, PicSplit[drDown]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'spl_left.bmp', P);
	Gfx.SplitSkin3(P, PicSplit[drLeft]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'spl_rght.bmp', P);
	Gfx.SplitSkin3(P, PicSplit[drRight]);
	Kernel.LoadingStep;
		{   TabSet }
	Pic.LoadBMP(Kernel.SkinDir+'tab_linl.bmp', P);
	Gfx.SplitSkin3(P, PicTabLineL);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'tab_linr.bmp', P);
	Gfx.SplitSkin3(P, PicTabLineR);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'tab_tabl.bmp', P);
	Gfx.SplitSkin4(P, PicTabL);
	TabSetSkinned:=(Gfx.ImageY(PicTabL[True, False])>1);
	If TabSetSkinned
		Then TabLineHeight:=Gfx.ImageY(PicTabLineL[True, False])
		Else TabLineHeight:=4;
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'tab_tabr.bmp', P);
	Gfx.SplitSkin4(P, PicTabR);
	Kernel.LoadingStep;

		{  - i ( Scroll  InpLine) }
	MouseScrUp:=Kernel.LoadCursor(Kernel.MouseDir+'scr_up.cur');
	Kernel.LoadingStep;
	MouseScrDown:=Kernel.LoadCursor(Kernel.MouseDir+'scr_down.cur');
	Kernel.LoadingStep;
	MouseScrLeft:=Kernel.LoadCursor(Kernel.MouseDir+'scr_left.cur');
	Kernel.LoadingStep;
	MouseScrRight:=Kernel.LoadCursor(Kernel.MouseDir+'scr_rght.cur');
	Kernel.LoadingStep;
	MouseScrVer:=Kernel.LoadCursor(Kernel.MouseDir+'scr_ver.cur');
	Kernel.LoadingStep;
	MouseScrHor:=Kernel.LoadCursor(Kernel.MouseDir+'scr_hor.cur');
	Kernel.LoadingStep;
		{  -  Splitter }
	{SplitterMouseLR:=Kernel.LoadCursor(Kernel.MouseDir+'size_hor.cur');
	Kernel.LoadingStep;
	SplitterMouseUD:=Kernel.LoadCursor(Kernel.MouseDir+'size_ver.cur');
	Kernel.LoadingStep;}

	Ini.Select('polit.ini', 'Controls');
	InpLineSelectAllOnFocus:=Ini.GetBool('InpLineSelectAllOnFocus', False);
	InpLineArrowsRemoveSel:=Ini.GetBool('InpLineArrowsRemoveSel', True);
	Kernel.LoadingStep;

End;

Procedure Done;
Begin
		{    InpLine }
	Gfx.FreeSkin3(PicInpL);
	Gfx.FreeSkin3(PicInpR);
		{  ii ப⪨ Scroll }
	Gfx.FreeSkin4(PicLine[orHorizontal]);
	Gfx.FreeSkin4(PicLine[orVertical]);
	Gfx.FreeSkin3(PicArDec[orVertical]);
	Gfx.FreeSkin3(PicArInc[orVertical]);
	Gfx.FreeSkin3(PicArDec[orHorizontal]);
	Gfx.FreeSkin3(PicArInc[orHorizontal]);
	Gfx.FreeSkin3(PicDrag[orHorizontal]);
	Gfx.FreeSkin3(PicDrag[orVertical]);
	Gfx.FreeSkin3(PicSlider1[orVertical]);
	Gfx.FreeSkin3(PicSlider2[orVertical]);
	Gfx.FreeSkin3(PicSlider1[orHorizontal]);
	Gfx.FreeSkin3(PicSlider2[orHorizontal]);
		{  䫠 Check }
	Gfx.FreeSkin4(PicCheck);
		{  ࠤi Radio }
	Gfx.FreeSkin4(PicRadio);
		{   Button }
	Gfx.FreeSkin3(PicBtn[bmMenuUp]);
	Gfx.FreeSkin3(PicBtn[bmMenuDown]);
	Gfx.FreeSkin3(PicBtn[bmSwitch]);
	Gfx.FreeSkin3(PicBtn[bmDialog]);
	Gfx.FreeSkin4(PicBtnL[ppLeft]);
	Gfx.FreeSkin4(PicBtnR[ppLeft]);
	Gfx.FreeSkin4(PicBtnC[ppLeft]);
	Gfx.FreeSkin4(PicBtnL[ppTop]);
	Gfx.FreeSkin4(PicBtnR[ppTop]);
	Gfx.FreeSkin4(PicBtnC[ppTop]);
		{  ii Track }
	Gfx.FreeSkin3(PicTrack);
		{  SpinEdit }
	Gfx.FreeSkin3(PicSpinUp);
	Gfx.FreeSkin3(PicSpinDown);
	Gfx.FreeSkin3(PicSpinDrag);
		{  Splitter }
	Gfx.FreeSkin3(PicSplit[drUp]);
	Gfx.FreeSkin3(PicSplit[drDown]);
	Gfx.FreeSkin3(PicSplit[drLeft]);
	Gfx.FreeSkin3(PicSplit[drRight]);
		{   TabSet }
	Gfx.FreeSkin3(PicTabLineL);
	Gfx.FreeSkin3(PicTabLineR);
	Gfx.FreeSkin4(PicTabL);
	Gfx.FreeSkin4(PicTabR);


		{  -  ii ப⪨ Scroll i   InpLine }
	Kernel.FreeCursor(MouseScrVer);
	Kernel.FreeCursor(MouseScrUp);
	Kernel.FreeCursor(MouseScrDown);
	Kernel.FreeCursor(MouseScrHor);
	Kernel.FreeCursor(MouseScrLeft);
	Kernel.FreeCursor(MouseScrRight);

	{Kernel.FreeCursor(SplitterMouseUD);
	Kernel.FreeCursor(SplitterMouseLR);}
	
End;



Begin
End.