{$F+}
Unit
	Ctl2; { Polit Halcyon controls (interface) second unit }

Interface

Uses
	D, Log, Ini, Kernel, Types, Gfx, Font, Popup, Printer, LptGfx;

Type
	TMemoKind=(mkEditable, mkReadOnly);
	PListItem=^TListItem;
	TListItem=Record
		Name: PStr;
		Selected: Boolean;
		Indent: Byte;
		Icon: Pointer;
		SubItem, Next: PListItem
	End;
	TListBoxHintHandler=Procedure(Me:PProg; Control:PControl; Item:PListItem);
	TListBoxSortFunc=Function(Me:PProg; Item1,Item2:PListItem): Boolean;
	TListColumnAlign=(lcLeft, lcRight, lcRightMono);

	Procedure Init;
	Procedure Done;


	Procedure Memo_Paint(Me:PControl; VX1, VY1, VX2, VY2:Integer);
	Procedure Memo_Draw(Me:PControl);
	Procedure Memo_Clear(Me:PControl);
	Procedure Memo_LoadFile(Me:PControl; FName:String; ToClear:Boolean);
	Procedure Memo_SaveToFile(Me:PControl; FName:String;
		KeepWordWrap,SaveBAK,DoRecodeBack:Boolean);
	Procedure Memo_Print(Me:PControl);
	Procedure Memo_SetKind(Me:PControl; VKind:TMemoKind);
	Procedure Memo_SetFont(Me:PControl; VFont:Pointer);
	Function Memo_Create(Prog:PProg; VKind:TMemoKind; Enabled:Boolean;
		Hint:String):PControl;

	Procedure AnClock_Paint(Me:PControl; VX1,VY1,VX2:Integer);
	Procedure AnClock_SetTime(Me:PControl; VHour,VMin,VSec:Integer);
	Procedure AnClock_GetTime(Me:PControl; Var VHour,VMin,VSec:Integer);
	Procedure AnClock_StepSeconds(Me:PControl; DeltaSec:Integer);
	Function AnClock_Create(Prog:PProg; VHour,VMin,VSec:Integer;
		VShowSeconds:Boolean): PControl;

	Procedure MonthCal_Paint(Me:PControl; VX1,VY1:Integer);
	Procedure MonthCal_SetDate(Me:PControl; VYear,VMonth,VDay:Word);
	Procedure MonthCal_GetDate(Me:PControl; Var VYear,VMonth,VDay:Word);
	Function MonthCal_Create(Prog:PProg; VYear,VMonth,VDay:Word): PControl;

	Procedure ListBox_Paint(Me:PControl; VX1, VY1, VX2, VY2:Integer);
	Procedure ListBox_Draw(Me:PControl);
	Procedure ListBox_AddItemFirst(Me:PControl; VName:String; VIcon:Pointer;
		VIndent:Byte);
	Procedure ListBox_AddItemLast(Me:PControl; VName:String; VIcon:Pointer;
		VIndent:Byte);
	Procedure ListBox_AddItemSorted(Me:PControl; VName:String; VIcon:Pointer;
		VIndent:Byte);
   Procedure ListBox_AddItemSecond(Me:PControl; VName:String; VIcon:Pointer;
		VIndent:Byte);
	Procedure ListBox_AddSubItem(Me:PControl; VName:String; VIcon:Pointer);
	Procedure ListBox_Sort(Me:PControl);
	Function ListBox_GetItemByIndex(Me:PControl; Index:Integer): PListItem;
	Function ListBox_FindItem(Me:PControl; VName: String): Integer;
	Function ListBox_GetItemsNum(Me:PControl): Integer;
	Function ListBox_GetSelItemIndex(Me:PControl): Integer;
	Procedure ListBox_SelectItem(Me:PControl; VSelItemNum:Integer);
	Function ListBox_GetSelItem(Me:PControl): PListItem;
	Procedure ListBox_GetSelItemRect(Me:PControl; Var R:TRect);
	Procedure ListBox_Clear(Me:PControl);
	{Procedure ListBoxHintDummy(Me:PProg; Control:PControl; Item:PListItem);}
	Function ListBox_DefaultSortFunc(Me:PProg; Item1,Item2:PListItem): Boolean;
	Procedure ListBox_SetSortFunc(Me:PControl; VSortFunc:TListBoxSortFunc);
	Procedure ListBox_SetOnBeforeSelect(Me:PControl; VOnBeforeSelect:TCtlHandler);
	Procedure ListBox_SetOnSelect(Me:PControl; VOnSelect:TCtlHandler);
	Procedure ListBox_SetOnStrongSelect(Me:PControl; VOnStrongSelect:TCtlHandler);
	Procedure ListBox_SetOnContextMenu(Me:PControl; VOnContextMenu:TCtlHandler);
	Procedure ListBox_SetOnHint(Me:PControl; VOnHint:TListBoxHintHandler);
	Procedure ListBox_SetColumnProps(Me:PControl; VColumnNum:Integer;
		VAlign:TListColumnAlign; VVisible:Boolean);
	Procedure ListBox_ScrollToViewSelItem(Me:PControl);
	Function ListBox_GetSelItemsTotal(Me:PControl): Integer;
	Procedure ListBox_DebugListItems(Me:PControl);
	Procedure ListBox_DeleteItem(Me:PControl; N:Integer);
	Function ListBox_Create(Prog:PProg; VMultiSelect:Boolean): PControl;

	Procedure ColorSel_Paint(Me:PControl; VX1,VY1,VX2,VY2:Integer);
	Function ColorSel_Create(Prog:PProg; VColor:TColor): PControl;


Implementation

Uses
	Ctl;

Var
	CurCtl:PControl;
	LastX, LastY: Integer;


{$I Memo.Inc}

{$I AnClock.Inc}

{$I MonthCal.Inc}

{$I ListBox.Inc}

{******* ColorSel *******}

Type
	TColorSel=Record
		Color: TColor;
		CellX, CellY: Integer;
	End;

Procedure ColorSel_IntDraw(Me:PControl);
Var
	X, Y, Z: Integer;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, TColorSel(Data^), Place Do
	Begin
			{ grid lines }
		For Y:=0 To 8 Do
			Gfx.Line(X1, Y1+Y*CellY, X2, Y1+Y*CellY, clBlack);
		For X:=0 To 30 Do
			Gfx.Line(X1+X*CellX, Y1, X1+X*CellX, Y2, clBlack);

			{ standard 16-color set }
		For X:=0 To 1 Do
			For Y:=0 To 7 Do
				Gfx.Bar(X1+X*CellX+1, Y1+Y*CellY+1, X1+(X+1)*CellX-1,
					Y1+(Y+1)*CellY-1, X*8+Y);

			{ gray shades }
		For X:=0 To 3 Do
			For Y:=0 To 7 Do
				Gfx.Bar(X1+(X+2)*CellX+1, Y1+Y*CellY+1, X1+(X+3)*CellX-1,
					Y1+(Y+1)*CellY-1, 224+X*8+Y);

			{ remaining full color set }
		For Z:=0 To 1 Do
			For X:=0 To 23 Do
				For Y:=0 To 3 Do
					Gfx.Bar(X1+(X+6)*CellX+1, Y1+(Y+Z*4)*CellY+1,
						X1+(X+7)*CellX-1, Y1+(Y+Z*4+1)*CellY-1,
						32+Z*96+Y*24+X);
	End
End;

Procedure ColorSel_Paint(Me:PControl; VX1,VY1,VX2,VY2:Integer);
Begin
	With Me^, TColorSel(Data^), Owner^.ClientRect Do
	Begin
		CellX:=(VX2-VX1) Div 30;
		CellY:=(VY2-VY1) Div 8;
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX1+CellX*30, Y1+VY1+CellY*8,
			Me^.Place)
	End;
	ColorSel_IntDraw(Me)
End;


Procedure ColorSel_OnDestroy(Me:PControl);
Begin
	FreeMem(Me^.Data, SizeOf(TColorSel))
End;

Function ColorSel_Create(Prog:PProg; VColor:TColor): PControl;
Var
	Me: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
	With Me^ Do
	Begin
		{OnClick:=ColorSel_OnClick;
		OnKey:=ColorSel_OnKey;}
		OnDestroy:=ColorSel_OnDestroy;

		GetMem(Data, SizeOf(TMonthCal));
		With TColorSel(Data^) Do
		Begin
			Color:=VColor;
				{ for debug }
			CellX:=10;
			CellY:=10
		End;
	End;
	ColorSel_Create:=Me
End;



Procedure Init;
Var
	F: File;
	V: Byte;
Begin
		{  । Memo (⥪⭥ ) }
	Ini.Select('polit.ini', 'Controls');
	MemoFastScroll:=Ini.GetBool('MemoFastScroll', True);

	Assign(F, 'win1251.kod');
	Reset(F, 1);
	BlockRead(F, Recode[1, 0], 256);
	Close(F);
	For V:=0 To 255 Do
		RecodeBack[1, Byte(Recode[1, V])]:=Char(V);
	Assign(F, 'koi8.kod');
	Reset(F, 1);
	BlockRead(F, Recode[2, 0], 256);
	Close(F);
	For V:=0 To 255 Do
		RecodeBack[2, Byte(Recode[2, V])]:=Char(V)
End;

Procedure Done;
Begin

End;

Begin
End.