{$F+}
Unit
	D; { Polit Halcyon Eva different useful stuff like min(), st() unit }

Interface

Uses
	DOS, Types, Log, Clipbrd, LFN;


	Function FileExist(Name:String): Boolean;
	Function PathExist(Path:String): Boolean;

	Function InRect(X,Y:Integer; R:TRect): Boolean;
	Function RectInRect(R1,R2:TRect): Boolean;
	Function RectInRectCoord(R:TRect; X1,Y1,X2,Y2:Integer): Boolean;
	Function InRectCoord(X,Y,X1,Y1,X2,Y2:Integer): Boolean;
	Function RectsEqual(R1,R2:TRect): Boolean;
	Function Intersect(R1,R2:TRect): Boolean;
	Function IntersectCoord(R1:TRect; X1,Y1,X2,Y2:Integer): Boolean;
	Function IntersectCoord2(AX1,AY1,AX2,AY2,BX1,BY1,BX2,BY2:Integer): Boolean;

	Function Min(A,B:Integer): Integer;
	Function Min3(A,B,C:Integer): Integer;
	Function Max(A,B:Integer): Integer;

	Function St(N:Integer): String;
	Function StL(L:LongInt): String;
	Function StReal(R:Real): String;
	Function St2(N:Integer): String;
	Function Str2Int(S:String): Integer;

	Function UpCaseLine(S:String): String;

	Procedure AssignPStr(S:String; Var P:Pointer);
	Procedure FreePStr(Var P:Pointer; Module:String);
	Procedure ReassignPStr(S:String; Var P:Pointer);

	Procedure AssignRect(X1,Y1,X2,Y2:Integer; Var Rect:TRect);
	Procedure AddRects(R1,R2:TRect; Var R:TRect);
	Procedure AddRectsPlus(R1,R2:TRect; Var R:TRect);
	Procedure SubRects(R1,R2:TRect; Var R:TRect);

	Procedure TrimSpaces(Var S:String);

	Function ClipFPath(FullName:String): String;
	Function ClipFName(FullName:String): String;
	Function ClipFExt(FullName:String): String;
	Function ClipFNameExt(FullName:String): String;

	Procedure Dummy;

	Procedure SwapInt(Var A,B:Integer);
	Procedure SwapReal(Var A,B:Real);
	Procedure NotMore(Var N:Integer; Margin:Integer);
	Procedure NotLess(Var N:Integer; Margin:Integer);
	Function InRange(N,A,B:Integer): Boolean;
	Procedure ToRange(Var N:Integer; A,B:Integer);
	Procedure ToRangeL(Var N:LongInt; A,B:LongInt);
	Procedure NotMorePair(Var N1,N2:Integer; Margin:Integer);
	Procedure NotLessPair(Var N1,N2:Integer; Margin:Integer);
	Procedure ToRangePair(Var N1,N2:Integer; A,B:Integer);
	Procedure Cycle(Var N:Integer; Min,Max:Integer);

	Function DirectionTo(X0,Y0,X1,Y1:Integer): Real;
	Function Sgn(N:Integer): Integer;

	Procedure IncNoMore(Var N:Integer; Max:Integer);
	Procedure DecNoLess(Var N:Integer; Min:Integer);
	Procedure SwitchValue(Var N:Integer; Val1,Val2:Integer);

	Procedure CheckMachineSpeed;
	Procedure Delay(Period:Integer);
	Procedure DetectHostOS;

	Function NormLine(S:String): String;
	Function NormNum(S:String): String;
	Function GetWeekDay(Year,Month,Day:Word): Word;
	{Function RandomByXY(X,Y,Range:LongInt): Integer;}

	Function GetDriveType(Letter:Char): TDriveType;
	Function GetCurDriveType: TDriveType;
	Function GetFirstCDDrive: Char;
	Function GetCDDrivesNum: Byte;

	Function DropLastPathItem(S:String): String;

	Procedure WinCopy;
	Procedure WinPaste;

	Procedure SetupKeyboard(RepeatDelay,RepeatRate:Byte);

	Function ArcSin(X:Real): Real;
	Function LastPathItem(S:String): String;
	Function UniqueFName(Path:String): String;
	Function GetVolumeLabel(Drive:Char): String;
	Function FileOrFolder(Name:String): TFileOrFolder;

	Function CountChars(C:Char; S:String): Integer;
	Procedure JustifyLine(Var S:String; NewWidth:Integer);

	Procedure DetectLFNSupport;
	Function TranslitLine(S:String): String;
	Function IntToHex(N:LongInt; Digits:Integer): String;
	Function CloneChar(C:Char; N:Integer): String;

Const
	ksRightShift=$01;
	ksLeftShift=$02;
	ksCtrl=$04;
	ksAlt=$08;
	ksScrollLockOn=$10;
	ksNumLockOn=$20;
	ksCapsLockOn=$40;
	ksInsertOn=$80;

	ksLeftCtrl=$0100;
	ksLeftAlt=$0200;
	ksRightCtrl=$0400;
	ksRightAlt=$0800;
	ksScrollLock=$1000;
	ksNumLock=$2000;
	ksCapsLock=$4000;
	ksSysReq=$8000;



Var
	MachineSpeed: LongInt;
	SysTimer: LongInt Absolute $0040:$006c;
	KeyStatus: Word Absolute $0040:$0017;
	{ExtKeyStatus: Byte Absolute $0040:$0018;}
	HostOS: TOperatingSystem;
	LFNSupport: Boolean;

Implementation

Var
	Regs: Registers;

Function FileExist(Name:String): Boolean;
Var
	SR: SearchRec;
Begin
	FindFirst(Name, AnyFile, SR);
	FileExist:=(DOSError=0)
End;

Function PathExist(Path:String): Boolean;
Var
	LastPath: String;
Begin
	GetDir(0, LastPath);
	{$IFOPT I+}
		{$I-}
		ChDir(Path);
		{$I+}
	{$ELSE}
		ChDir(Path);
	{$ENDIF}
	PathExist:=(IOResult=0);
	ChDir(LastPath)
End;

Function InRect(X,Y:Integer; R:TRect): Boolean;
Begin
	If (X>=R.X1) And (X<=R.X2) And (Y>=R.Y1) And (Y<=R.Y2)
		Then InRect:=True
		Else InRect:=False
End;

Function RectInRect(R1,R2:TRect): Boolean;
Begin
	RectInRect:=InRect(R1.X1, R1.Y1, R2) And InRect(R1.X2, R1.Y2, R2)
End;

Function RectInRectCoord(R:TRect; X1,Y1,X2,Y2:Integer): Boolean;
Begin
	RectInRectCoord:=InRectCoord(R.X1, R.Y1, X1, Y1, X2, Y2) And
		InRectCoord(R.X2, R.Y2, X1, Y1, X2, Y2)
End;

Function InRectCoord(X,Y,X1,Y1,X2,Y2:Integer): Boolean;
Begin
	If (X>=X1) And (X<=X2) And (Y>=Y1) And (Y<=Y2)
		Then InRectCoord:=True
		Else InRectCoord:=False
End;

Function RectsEqual(R1,R2:TRect): Boolean;
Begin
	If (R1.X1=R2.X1) And (R1.X2=R2.X2) And (R1.Y1=R2.Y1) And (R1.Y2=R2.Y2)
		Then RectsEqual:=True
		Else RectsEqual:=False
End;

Function Intersect(R1,R2:TRect): Boolean;
Begin
	If (R1.X2<R2.X1) Or (R1.X1>R2.X2) Or
		(R1.Y2<R2.Y1) Or (R1.Y1>R2.Y2)
		Then Intersect:=False
		Else Intersect:=True
End;

Function IntersectCoord(R1:TRect; X1,Y1,X2,Y2:Integer): Boolean;
Begin
	If (R1.X2<X1) Or (R1.X1>X2) Or
		(R1.Y2<Y1) Or (R1.Y1>Y2)
		Then IntersectCoord:=False
		Else IntersectCoord:=True
End;

Function IntersectCoord2(AX1,AY1,AX2,AY2,BX1,BY1,BX2,BY2:Integer): Boolean;
Begin
	If (AX2<BX1) Or (AX1>BX2) Or
		(AY2<BY1) Or (AY1>BY2)
		Then IntersectCoord2:=False
		Else IntersectCoord2:=True
End;

Function Min(A,B:Integer): Integer;
Begin
	If A<B
		Then Min:=A
		Else Min:=B
End;

Function Min3(A,B,C:Integer): Integer;
Begin
	Min3:=Min(A, Min(B, C))
End;


Function Max(A,B:Integer): Integer;
Begin
	If A>B
		Then Max:=A
		Else Max:=B
End;

Function St(N:Integer): String;
Var
	T: String;
Begin
	Str(N, T);
	St:=T
End;

Function StL(L:LongInt): String;
Var
	T: String;
Begin
	Str(L, T);
	StL:=T
End;

Function StReal(R:Real): String;
Var
	T: String;
Begin
	Str(R, T);
	StReal:=T
End;


Function St2(N:Integer): String;
Var
	T: String;
Begin
	Str(N, T);
	If N<=9
		Then St2:='0'+T
		Else St2:=T
End;

Function Str2Int(S:String): Integer;
Var
	TempInt: Integer;
	Res: Word;
Begin
	Val(S, TempInt, Res);
	If Res=0
		Then Str2Int:=TempInt
		Else Str2Int:=0
End;

Function UpCaseLine(S:String): String;
Var
	V: Byte;
Begin
	For V:=1 To Length(S) Do
		S[V]:=UpCase(S[V]);
	UpCaseLine:=S
End;

Procedure AssignPStr(S:String; Var P:Pointer);
Begin
	If MaxAvail<Length(S)+1 Then
	Begin
		Log.ErrMsg('D', 'AssignPStr', 'Not enough memory to assign "'+S+'"');
		Log.ActMsg('Ignoring assign request');
		Exit
	End;
	GetMem(P, Length(S)+1);
	Move(S[0], P^, Length(S)+1)
End;

Procedure FreePStr(Var P:Pointer; Module:String);
Begin
	{Log.BugMsg('D', 'FreePStr', 'Freeing pstring '+D.St(Byte(P^))+' '+String(P^));
	Log.ActMsg('from module '+Module);}
	If P=Nil Then
		Log.ErrMsg('D', 'FreePStr', 'Trying to free pointer which = Nil');
	FreeMem(P, Length(String(P^))+1)
End;

Procedure ReassignPStr(S:String; Var P:Pointer);
Begin
	FreePStr(P, 'D - ReassignPStr');
	AssignPStr(S, P)
End;

Procedure AssignRect(X1,Y1,X2,Y2:Integer; Var Rect:TRect);
Begin
	Rect.X1:=X1;
	Rect.Y1:=Y1;
	Rect.X2:=X2;
	Rect.Y2:=Y2
End;

Procedure AddRects(R1,R2:TRect; Var R:TRect);
Begin
	R.X1:=R1.X1+R2.X1;
	R.Y1:=R1.Y1+R2.Y1;
	R.X2:=R1.X2+R2.X2;
	R.Y2:=R1.Y2+R2.Y2
End;

Procedure AddRectsPlus(R1,R2:TRect; Var R:TRect);
Begin
	If R2.X1>0
		Then R.X1:=R1.X1+R2.X1
		Else R.X1:=R1.X2+R2.X1;
	If R2.Y1>0
		Then R.Y1:=R1.Y1+R2.Y1
		Else R.Y1:=R1.Y2+R2.Y1;
	If R2.X2>0
		Then R.X2:=R1.X1+R2.X2
		Else R.X2:=R1.X2+R2.X2;
	If R2.Y2>0
		Then R.Y2:=R1.Y1+R2.Y2
		Else R.Y2:=R1.Y2+R2.Y2
End;

Procedure SubRects(R1,R2:TRect; Var R:TRect);
Begin
	R.X1:=R1.X1-R2.X1;
	R.Y1:=R1.Y1-R2.Y1;
	R.X2:=R1.X2-R2.X2;
	R.Y2:=R1.Y2-R2.Y2
End;



Procedure TrimSpaces(Var S:String);
Begin
	If S='' Then Exit;
	While S[Length(S)] In [' ', #9, #255] Do
		S:=Copy(S, 1, Length(S)-1);
	If S='' Then Exit;
	While S[1] In [' ', #9, #255] Do
		S:=Copy(S, 2, Length(S)-1)
End;

Function ClipFPath(FullName:String): String;
Var
	Path: DirStr;
	Name: NameStr;
	Ext: ExtStr;
Begin
	FSplit(FullName, Path, Name, Ext);
	ClipFPath:=Path
End;

Function ClipFName(FullName:String): String;
Var
	Path: DirStr;
	Name: NameStr;
	Ext: ExtStr;
Begin
	FSplit(FullName, Path, Name, Ext);
	ClipFName:=Name
End;

Function ClipFExt(FullName:String): String;
Var
	Path: DirStr;
	Name: NameStr;
	Ext: ExtStr;
Begin
	FSplit(FullName, Path, Name, Ext);
	ClipFExt:=Ext
End;

Function ClipFNameExt(FullName:String): String;
Var
	Path: DirStr;
	Name: NameStr;
	Ext: ExtStr;
Begin
	FSplit(FullName, Path, Name, Ext);
	ClipFNameExt:=Name+Ext
End;


Procedure Dummy;
Begin End;

Procedure SwapInt(Var A,B:Integer);
Var
	Temp: Integer;
Begin
	Temp:=A;
	A:=B;
	B:=Temp
End;

Procedure SwapReal(Var A,B:Real);
Var
	Temp: Real;
Begin
	Temp:=A;
	A:=B;
	B:=Temp
End;


Procedure NotMore(Var N:Integer; Margin:Integer);
Begin
	If N>Margin Then
		N:=Margin
End;

Procedure NotLess(Var N:Integer; Margin:Integer);
Begin
	If N<Margin Then
		N:=Margin
End;

Function InRange(N,A,B:Integer): Boolean;
Begin
	If (N>=A) And (N<=B)
		Then InRange:=True
		Else InRange:=False
End;

Procedure ToRange(Var N:Integer; A,B:Integer);
Begin
	{If N<A
		Then N:=A
		Else If N>B
			Then N:=B}
	If N>B Then N:=B;
	If N<A Then N:=A
	{NotMore(N, B);
	NotLess(N, A)}
End;

Procedure ToRangeL(Var N:LongInt; A,B:LongInt);
Begin
	If N<A
		Then N:=A
		Else If N>B
			Then N:=B
	{NotMore(N, B);
	NotLess(N, A)}
End;


Procedure NotMorePair(Var N1,N2:Integer; Margin:Integer);
Var
	Delta: Integer;
Begin
	If N2>Margin Then
	Begin
		Delta:=N2-Margin;
		Dec(N1, Delta);
		Dec(N2, Delta)
	End
End;

Procedure NotLessPair(Var N1,N2:Integer; Margin:Integer);
Var
	Delta: Integer;
Begin
	If N1<Margin Then
	Begin
		Delta:=Margin-N1;
		Inc(N1, Delta);
		Inc(N2, Delta)
	End
End;

Procedure ToRangePair(Var N1,N2:Integer; A,B:Integer);
Begin
	NotLessPair(N1, N2, A);
	NotMorePair(N1, N2, B)
End;

Procedure Cycle(Var N:Integer; Min,Max:Integer);
Begin
	Inc(N);
	If N>=Max Then
		N:=Min
End;

Function DirectionTo(X0,Y0,X1,Y1:Integer): Real;
Var
	Temp: Real;
Begin
	If X1=X0
		Then
			If Y1<Y0
				Then Temp:=-Pi/2
				Else Temp:=Pi/2
		Else
			If X1>X0
				Then Temp:=ArcTan((Y1-Y0)/(X1-X0))
				Else Temp:=ArcTan((Y1-Y0)/(X1-X0))-Pi;
	If Temp<0
		Then DirectionTo:=Temp+Pi*2
		Else If Temp>Pi*2
			Then DirectionTo:=Temp-Pi*2
			Else DirectionTo:=Temp
End;

Function Sgn(N:Integer): Integer;
Begin
	If N>0
		Then Sgn:=1
		Else If N<0
			Then Sgn:=-1
			Else Sgn:=0
End;

	{ 21.10.2002 }
Procedure IncNoMore(Var N:Integer; Max:Integer);
Begin
	If N<Max Then
		Inc(N)
End;

Procedure DecNoLess(Var N:Integer; Min:Integer);
Begin
	If N>Min Then
		Dec(N)
End;

Procedure SwitchValue(Var N:Integer; Val1,Val2:Integer);
Begin
	If N=Val1
		Then N:=Val2
		Else N:=Val1
End;

Procedure CheckMachineSpeed;
Var
	R: Real;
	TempTimer: LongInt;
Begin
	TempTimer:=SysTimer;
	Repeat
	Until SysTimer>TempTimer;

	TempTimer:=SysTimer;
	MachineSpeed:=0;
	Repeat
		R:=Sin(0.123);
		Inc(MachineSpeed)
	Until SysTimer>TempTimer;
	MachineSpeed:=MachineSpeed Div 40;
	Log.SysMsg('D', 'CheckMachineSpeed', 'Speed = '+D.St(MachineSpeed));
	Log.ActMsg('(approx. '+D.StL(MachineSpeed*4*182)+' sinuses per second)')
End;

Procedure Delay(Period:Integer);
Var
	I: Integer;
	Times: LongInt;
	R: Real;
Begin
	Times:=Period*MachineSpeed*4*182 Div 1000;
	For I:=1 To Times Do
		R:=Sin(0.123)
End;



Procedure DetectHostOS;
Begin
	Regs.AX := $1600;
	Intr($2F, Regs);
	If Boolean(Regs.AL)
		Then HostOS:=osWindows
		Else HostOS:=osDOS
End;



Function LoCase(C:Char): Char;
Begin
	If C In ['A'..'Z']
		Then LoCase:=Char(Byte(C)+32)
		Else LoCase:=C
End;

Function NormLine(S:String): String;
Var
	V: Byte;
Begin
	If Length(S)=0 Then Exit;
	S[1]:=UpCase(S[1]);
	For V:=2 To Length(S) Do
		S[V]:=LoCase(S[V]);
	NormLine:=S
End;

Function NormNum(S:String): String;
Var
	TempStr: String;
	V, L: Byte;
Begin
	TempStr:='';
	L:=Length(S);
	For V:=1 To L Do
	Begin
		TempStr:=S[L-V+1]+TempStr;
		If (V Mod 3)=0 Then
			If V<>L Then
				TempStr:=' '+TempStr
	End;
	NormNum:=TempStr
End;

Function GetWeekDay(Year,Month,Day:Word): Word;
Var
	RealYear, RealMonth, RealDay, RealWDay, TempWDay: Word;
Begin
	DOS.GetDate(RealYear, RealMonth, RealDay, RealWDay);
	DOS.SetDate(Year, Month, Day);
	DOS.GetDate(Year, Month, Day, TempWDay);
	DOS.SetDate(RealYear, RealMonth, RealDay);
	GetWeekDay:=TempWDay
End;

{Function RandomByXY(X,Y,Range:LongInt): Integer;
Var
	T: Real;
Begin
	Inc(X, 345);
	Inc(Y, 456);
	If X<>Y
		Then T:=(X*Y)/Abs(X-Y)*Pi
		Else T:=X*Pi;
	RandomByXY:=Trunc(Frac(T)*Range);
End;}




Function GetDriveType(Letter:Char): TDriveType;
Begin
	Regs.BX := Ord(UpCase(Letter))+1-Ord('A');
	Regs.AX := $4408; { DOS 3.0+ IOCTL (44h), func 08 - get drive type }
	MsDos(Regs);
	If (Regs.Flags And $01)=0
		Then If Regs.AL=0
			Then GetDriveType := dtFloppy
			Else GetDriveType := dtFixed
		Else GetDriveType := dtNone
End;

Function GetCurDriveType: TDriveType;
Begin
	GetCurDriveType:=GetDriveType('@')
End;

Function GetFirstCDDrive: Char;
Begin
  Regs.AX:=$1500;
  Regs.BX:=$0000;
  Intr($2F, Regs);
  GetFirstCDDrive:=Char(Regs.CL+Byte('A'))
End;

Function GetCDDrivesNum: Byte;
Begin
  Regs.AX:= $1500;
  Regs.BX:= $0000;
  Intr($2F, Regs);
  GetCDDrivesNum:= Regs.BL;
End;

Function DropLastPathItem(S:String): String;
Var
	V: Byte;
	Finished: Boolean;
Begin
	V:=Length(S);
	Finished:=False;
	While (V>0) And Not Finished Do
	Begin
		If S[V]='\' Then Finished:=True;
		Dec(V)
	End;
	DropLastPathItem:=Copy(S, 1, V)
End;




Procedure WinCopy;
Var
	F: File;
	P: Pointer;
	Size: Word;
	Res: Boolean;
Begin
	If HostOS<>osWindows Then Exit;
	If Not FileExist('clipbrd.txt') Then Exit;
	{$IFDEF DPMI}Exit;{$ENDIF}

	Log.BugMsg('D', 'WinCopy', 'All OK, copying to Windows clipboard');
	Assign(F, 'clipbrd.txt');
	Reset(F, 1);
	Size:=FileSize(F);
	If (Size>65000) Or (Size>MaxAvail) Then
	Begin
		Close(F);
		Exit
	End;
	GetMem(P, Size+1);
	Reset(F, 1);
	BlockRead(F, P^, Size);
	TMatrix(P^)[Size]:=0;
	Close(F);

	Res:=Clipbrd.OpenClipboard;
	Res:=Clipbrd.EmptyClipboard;
	Res:=Clipbrd.SetClipboardData(cf_OEMText, P^, Size+1);
	Res:=Clipbrd.CloseClipboard;
End;

Procedure WinPaste;
Var
	F: File;
	P: Pointer;
	Size, Minus: LongInt;
	Res: Boolean;
Begin
	If HostOS<>osWindows Then Exit;
	{$IFDEF DPMI}Exit;{$ENDIF}

	Log.BugMsg('D', 'WinPaste', 'All OK, pasting from Windows clipboard');
	Res:=Clipbrd.OpenClipboard;
	Size:=Clipbrd.GetClipboardDataSize(cf_OEMText);
	If Size>65000 Then Exit;
	if Size>MaxAvail Then Exit;
	GetMem(P, Size);
	Res:=Clipbrd.GetClipboardData(cf_OEMText, P^);
	Res:=Clipbrd.CloseClipboard;

		{ ਡ 墮 i i, Memo ⠪   }
	Minus:=0;
	While TMatrix(P^)[Size-Minus-1]=0 Do
		Inc(Minus);

	Assign(F, 'clipbrd.txt');
	Rewrite(F, 1);
	BlockWrite(F, P^, Size-Minus);
	Close(F);
	FreeMem(P, Size)
End;

Procedure SetupKeyboard(RepeatDelay,RepeatRate:Byte);
Begin
	Regs.AH:=$03;
	Regs.AL:=$05;
	Regs.BH:=RepeatDelay;
	Regs.BL:=RepeatRate;
	Intr($16, Regs)
End;

Function ArcSin(X:Real): Real;
Begin
	If X>0.99
		Then ArcSin:=Pi/2
		Else If X<-0.99
			Then ArcSin:=-Pi/2
			Else ArcSin:=ArcTan(X/Sqrt(1-X*X));
End;

Function LastPathItem(S:String): String;
Var
	V: Byte;
Begin
	V:=Length(S);
	Repeat
		Dec(V)
	Until (S[V]='\') Or (V=1);
	If V=1
		Then LastPathItem:=S
		Else LastPathItem:=Copy(S, V+1, Length(S)-V)
End;

Function UniqueFName(Path:String): String;
Var
	V: Byte;
	TempFName: String;
Begin
	If Path<>'' Then Path:=Path+'\';
	TempFName:='        .tmp';
	Repeat
		For V:=1 To 8 Do
			TempFName[V]:=Char(Byte('A')+Random(26));
	Until Not FileExist(Path+TempFName);
	UniqueFName:=TempFName
End;

Function GetVolumeLabel(Drive:Char): String;
Var
	SR: SearchRec;
	TempLabel: String;
	B: Byte;
Begin
	FindFirst(Drive+':\*.*', VolumeID, SR);
	If DOSError=0 Then
	Begin
		TempLabel:=SR.Name;
		B:=Pos('.', TempLabel);
		If B<>0 Then
			Delete(TempLabel, B, 1);
		GetVolumeLabel:=D.NormLine(TempLabel)
	End
	Else GetVolumeLabel:=''
End;

Function FileOrFolder(Name:String): TFileOrFolder;
Var
	SR: SearchRec;
Begin
	FindFirst(Name, AnyFile, SR);
	FileOrFolder:=ffFile;
	If (SR.Attr And Directory)<>0 Then
		FileOrFolder:=ffFolder
End;

Function CountChars(C:Char; S:String): Integer;
Var
	N, I: Integer;
Begin
	N:=0;
	For I:=1 To Length(S) Do
		If S[I]=C Then Inc(N);
	CountChars:=N
End;

Procedure JustifyLine(Var S:String; NewWidth:Integer);
Var
	SpacesNum, CurPos: Integer;
	C, LastC: Char;
Begin
	While S[Length(S)]=' ' Do
		Dec(Byte(S[0]));
	SpacesNum:=NewWidth-Length(S);
	CurPos:=1;
	C:='a';
	LastC:='a';
	While SpacesNum>0 Do
	Begin
		If (LastC=' ') And (C<>' ') Then
		Begin
			Insert(' ', S, CurPos);
			Dec(SpacesNum)
		End;
		Inc(CurPos);
		If CurPos>Length(S) Then
		Begin
			CurPos:=1;
			C:='a'
		End;
		LastC:=C;
		C:=S[CurPos]
	End
End;

Procedure DetectLFNSupport;
Const
	DirName='TestLongName';
Var
	Res: Integer;
Begin
	Res:=LFN.LFNMkDir(DirName);
	LFNSupport:=(Res=0);
	If LFNSupport Then
		LFN.LFNRmDir(DirName)
End;

Function TranslitLine(S:String): String;
Const
	Tr1: Array[''..''] Of String[3]=
		('A', 'B', 'V', 'G', 'D', 'E', 'ZH', 'Z',
		 'I', 'Y', 'K', 'L', 'M', 'N', 'O', 'P',
		 'R', 'S', 'T', 'U', 'F', 'H', 'C', 'CH',
		 'SH', 'SCH', '', 'Y', '', 'E', 'YU', 'YA');
	Tr21: Array[''..''] Of String[3]=
		('a', 'b', 'v', 'g', 'd', 'e', 'zh', 'z',
		 'i', 'y', 'k', 'l', 'm', 'n', 'o', 'p');
	Tr22: Array[''..''] Of String[3]=
		('r', 's', 't', 'u', 'f', 'h', 'c', 'ch',
		 'sh', 'sch', '', 'y', '', 'e', 'yu', 'ya');
Var
	TempStr: String;
	V: Byte;
Begin
	S:=UpCaseLine(S);
	TempStr:='';
	For V:=1 To Length(S) Do
		Case S[V] Of
			''..'': TempStr:=TempStr+Tr1[S[V]];
			''..'': TempStr:=TempStr+Tr21[S[V]];
			''..'': TempStr:=TempStr+Tr22[S[V]];
			Else TempStr:=TempStr+S[V]
		End;
	TranslitLine:=TempStr
End;

Function IntToHex(N:LongInt; Digits:Integer): String;
Const
	HexDigit: String='0123456789ABCDEF';
Var
	TempStr: String;
	I: Integer;
Begin
	TempStr:='';
	Repeat
		TempStr:=HexDigit[(N Mod 16)+1]+TempStr;
		N:=N Div 16
	Until N=0;
	For I:=Length(TempStr)+1 To Digits Do
		TempStr:='0'+TempStr;
	IntToHex:=TempStr
End;

Function CloneChar(C:Char; N:Integer): String;
Var
	V: Byte;
	S: String;
Begin
	S:='';
	For V:=1 To Min(255, N) Do
		S:=S+'|';
	CloneChar:=S
End;










Begin
	LFNSupport:=False
End.