{****************************************************************************
 * SoundLib 2 DMA driver - (c) 2001 by Stefan Goehler                       *
 * Copyright agreement in soundlib.txt - illegal copy without this file!    *
 ****************************************************************************}
{$IFDEF FPC}
{$A+,B-,F+,G+,N-,E-,P+,Q-,R-,T-,V+,X+}
{$ASMMODE INTEL}
{$ELSE}
{$A+,B-,F+,G+,N-,E-,P+,Q-,R-,T-,V+,X+}
{$ENDIF}

unit drv_dma;

interface

procedure initdma(dma : byte;p : longint;size,flags : word);

const
  dma_8bit     = $0001;
  dma_16bit    = $0002;
  dma_send     = $0010;
  dma_get      = $0020;
  dma_autoinit = $0040;

implementation
uses ports;

const
  { Constants for the dma-port-adresses }
  dma_lpage          : array[0..7] of byte = ($87,$83,$81,$82,$88,$8B,$89,$8A);
  dma_hpage          : array[0..7] of word = ($487,$483,$481,$482,$00,$48B,$489,$48A);
  dma_adr            : array[0..7] of byte = ($00,$02,$04,$06,$C0,$C4,$C8,$CC);
  dma_wc             : array[0..7] of byte = ($01,$03,$05,$07,$C2,$C6,$CA,$CE);


function checkbit(source,bit : longint) : boolean;
begin
  checkbit := (source and bit <> 0);
end;

procedure initdma(dma : byte;p : longint;size,flags : word);
var
  b         : byte;
  l         : longint;
  segm,offs : word;

begin
  p := p and $FFFF0000;
  l := p shr 12;
  segm := l shr 16;
  if (dma > 3) then
  offs := word(p shr 13)
  else
  offs := l and $FFFF;

  if (checkbit(flags,dma_get)) then b := $44 else b := $48;
  if (checkbit(flags,dma_autoinit)) then inc(b,$10);
  if (checkbit(flags,dma_16bit))and(dma <= 3) then size := size*2;

  if (dma > 3) then
  begin
    outp($D4,dma);
    outp($D6,b+dma-4);
    outp($D8,0);
  end else
  begin
    outp($0A,dma+4);
    outp($0B,b+dma);
    outp($0C,0);
  end;
  outp(dma_adr[dma],(offs));
  outp(dma_adr[dma],(offs) shr 8);
  outp(dma_lpage[dma],segm);
  outp(dma_wc[dma],(size-1));
  outp(dma_wc[dma],(size-1) shr 8);
  if (dma > 3) then outp($D4,dma-4) else outp($0A,dma);
end;

begin
end.