{$F+}
Unit
	FileDlg; { Polit Halcyon FileDlg application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, DOS, Popup;

Type
	TFileDlgData=Record
		Lab1, LabPath, LstDirs, PbtDrives, LstFiles, BtnOpen, BtnCancel: PControl;
		SplTest: PControl;
		Lab2, InpName: PControl;
		MnuDrives: PMenuItem;
		CurDir: String;
		PicUp, PicFolder, PicFile: Pointer;
		PicFloppy, PicFixed, PicCD: Pointer;
		Mask: String;
		Mode: Char;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Var
	TempX: Integer;
Begin
	With Me^, ClientRect, TFileDlgData(Data^) Do
	Begin
		Ctl.Label_Paint(Lab1, 5, 5, 45);
		Ctl.Label_Paint(LabPath, 50, 5, X2-X1-60);
		Ctl.PopupBtn_Paint(PbtDrives, X2-X1-55, 5, X2-X1-5);
		TempX:=Ctl.Splitter_GetCoord(SplTest);

		If Mode='o' Then
		Begin
			Ctl.Splitter_Paint(SplTest, 120, 35, X2-X1-150, Y2-Y1-40);
			Ctl2.ListBox_Paint(LstDirs, 5, 35, TempX-7, Y2-Y1-40);
			Ctl2.ListBox_Paint(LstFiles, TempX+7, 35, X2-X1-5, Y2-Y1-40)
		End
		Else Begin
			Ctl.Splitter_Paint(SplTest, 120, 35, X2-X1-150, Y2-Y1-65);
			Ctl2.ListBox_Paint(LstDirs, 5, 35, TempX-7, Y2-Y1-65);
			Ctl2.ListBox_Paint(LstFiles, TempX+7, 35, X2-X1-5, Y2-Y1-65);
			Ctl.Label_Paint(Lab2, 5, Y2-Y1-55, 45);
			Ctl.InpLine_Paint(InpName, 50, Y2-Y1-55, X2-X1-5)
		End;

		Ctl.Button_Paint(BtnOpen, X2-X1-160, Y2-Y1-25, X2-X1-85);
		Ctl.Button_Paint(BtnCancel, X2-X1-75, Y2-Y1-25, X2-X1-5);
	End;
End;

Procedure ChangeDir(Me:PProg);
Var
	SR: SearchRec;
	TempStr: String;
	DT: DateTime;
	FilesPresent: Boolean;
Begin
	With Me^, TFileDlgData(Data^) Do
	Begin
		Ctl2.ListBox_Clear(LstDirs);

		If Length(CurDir)>2 Then
			Ctl2.ListBox_AddItemFirst(LstDirs, '..', PicUp, 0);
		DOS.FindFirst(CurDir+'\*.*', Directory, SR);
		While DOSError=0 Do
		Begin
			If (SR.Attr And Directory<>0) And (SR.Name[1]<>'.') Then
				Ctl2.ListBox_AddItemSorted(LstDirs,
					D.NormLine(SR.Name), PicFolder, 0);
			DOS.FindNext(SR)
		End;
		Ctl2.ListBox_SelectItem(LstDirs, 1);
		If Not Kernel.IgnoreAutoRedraw Then
			Ctl2.ListBox_Draw(LstDirs);

		Ctl2.ListBox_Clear(LstFiles);
		FilesPresent:=False;
		DOS.FindFirst(CurDir+'\'+Mask, AnyFile, SR);
		While DOSError=0 Do
		Begin
			If (SR.Attr And Directory)=0 Then
			Begin
				TempStr:=D.NormLine(D.ClipFName(SR.Name));
				Ctl2.ListBox_AddItemSorted(LstFiles, TempStr, PicFile, 0);
				TempStr:=D.ClipFExt(SR.Name);
				TempStr:=Copy(TempStr, 2, Length(TempStr)-1);
				TempStr:=D.NormLine(TempStr);
				Ctl2.ListBox_AddSubItem(LstFiles, TempStr, Nil);
				Ctl2.ListBox_AddSubItem(LstFiles, D.StL(SR.Size), Nil);
				DOS.UnpackTime(SR.Time, DT);
				TempStr:=D.St(DT.Day)+'/'+D.St(DT.Month)+'/'+D.St(DT.Year);
				Ctl2.ListBox_AddSubItem(LstFiles, TempStr, Nil);
				FilesPresent:=True
			End;
			DOS.FindNext(SR)
		End;
		If FilesPresent Then
			Ctl2.ListBox_SelectItem(LstFiles, 1);
		If Not Kernel.IgnoreAutoRedraw Then
			Ctl2.ListBox_Draw(LstFiles);

		Ctl.Label_SetCaption(LabPath, CurDir)
	End
End;

Procedure OnDirSelect(Me:PProg; Control:PControl);
Var
	SelItem: PListItem;
Begin
	With Me^, TFileDlgData(Data^) Do
	Begin
		SelItem:=Ctl2.ListBox_GetSelItem(LstDirs);
		If String(SelItem^.Name^)='..' Then
		Begin
			If Pos('\', CurDir)>0 Then
			Begin
				Repeat
					CurDir:=Copy(CurDir, 1, Length(CurDir)-1)
				Until CurDir[Length(CurDir)]='\';
				CurDir:=Copy(CurDir, 1, Length(CurDir)-1)
			End
		End
		Else
			CurDir:=CurDir+'\'+String(SelItem^.Name^)
	End;
	ChangeDir(Me);
	{Kernel.PaintWindow(Me)}
End;

Procedure OnDriveSelect(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TFileDlgData(Data^) Do
		CurDir:=String(Item^.Name^)[1]+':';
	ChangeDir(Me)
End;


Procedure OnFileListHint(Me:PProg; Control:PControl; Item:PListItem);
Var
	TempStr: String;
Begin
	If Item<>Nil Then
	Begin
		TempStr:=' : '+String(Item^.Name^)+'.'+
			String(Item^.SubItem^.Name^)+#13;
		TempStr:=TempStr+'i: '+String(Item^.SubItem^.SubItem^.Name^)+
			' '+#13;
		TempStr:=TempStr+' : '+
			String(Item^.SubItem^.SubItem^.SubItem^.Name^)
	End
	Else
		TempStr:='';
	D.ReassignPStr(TempStr, Control^.Hint)
End;

Procedure OnFileStrongSelect(Me:PProg; Control:PControl);
Var
	TempItem: PListItem;
	TempPStr: PStr;
	TempFile, TempExt: String;
	TempPtr: Pointer;
Begin
	With Me^, TFileDlgData(Data^) Do
		Case Mode Of
			'o': Begin
				TempItem:=Ctl2.ListBox_GetSelItem(LstFiles);
				If TempItem<>Nil Then
				Begin
					TempFile:=Ctl.Label_GetCaption(LabPath)+'\'+
						String(TempItem^.Name^)+'.'+
						String(TempItem^.SubItem^.Name^);
					Log.BugMsg('FileDlg', 'OnFileStrongSelect', 'File = '+TempFile);
					If Parent<>Nil Then
					Begin
						TempPtr:=Kernel.SendMessage(Me, Parent, 'OpenFile', @TempFile);
					End
					Else Begin
						{ execute file };
						TempExt:=D.UpCaseLine(String(TempItem^.SubItem^.Name^));
						If TempExt='TXT' Then
							Kernel.RunBuiltIn('Notepad', TempFile);
					End;
					Kernel.CloseProg(Me)
				End
				Else
					Kernel.ShowHint('  䠩')
			End;
			's': Begin
				If Ctl.InpLine_GetText(InpName)<>'' Then
				Begin
					TempFile:=Ctl.Label_GetCaption(LabPath)+'\'+
						Ctl.InpLine_GetText(InpName);
					If Parent<>Nil Then
						TempPtr:=Kernel.SendMessage(Me, Parent, 'SaveFile', @TempFile);
					Kernel.CloseProg(Me)
				End
				Else
					Kernel.ShowHint('  i'' 䠩')
			End;
		End
End;

Procedure OnFileSelect(Me:PProg; Control:PControl);
Var
	TempItem: PListItem;
	TempPStr: PStr;
	TempFile, TempExt: String;
Begin
	With Me^, TFileDlgData(Data^) Do
	Begin
		If Mode='o' Then Exit;

		TempItem:=Ctl2.ListBox_GetSelItem(LstFiles);
		If TempItem<>Nil Then
			Ctl.InpLine_SetText(InpName, String(TempItem^.Name^)+'.'+
				String(TempItem^.SubItem^.Name^))
	End
End;


Procedure OnCancelClick(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;


Procedure OnClose(Me:PProg);
Begin
	Kernel.FreeRes('up.bmp');
	Kernel.FreeRes('folder.bmp');
	Kernel.FreeRes('file.bmp');
	Kernel.FreeRes('d_floppy.bmp');
	Kernel.FreeRes('d_fixed.bmp');
	Kernel.FreeRes('d_cdrom.bmp');
	FreeMem(Me^.Data, SizeOf(TFileDlgData))
End;



Procedure MakeDrivesMenu(Me:PProg);
Var
	Letter: Char;
	FirstCD: Char;
	CurCD: Byte;
Begin
	With Me^, TFileDlgData(Data^) Do
	Begin
		MnuDrives:=Popup.CreateMenu;

		For Letter:='A' To 'Z' Do
			Case D.GetDriveType(Letter) Of
				dtFloppy: Popup.AddCommand(MnuDrives, Letter+':', '', '',
					PicFloppy, True, OnDriveSelect);
				dtFixed: Popup.AddCommand(MnuDrives, Letter+': '+
					D.GetVolumeLabel(Letter), '', '',
					PicFixed, True, OnDriveSelect);
			End;

			{ ६  ᪮ CD-ROM }
		FirstCD:=D.GetFirstCDDrive;
		For CurCD:=1 To D.GetCDDrivesNum Do
			Popup.AddCommand(MnuDrives, Char(Byte(FirstCD)+CurCD-1)+':',
				'', '', PicCD, True, OnDriveSelect)
	End
End;


Procedure OnInit(Me:PProg);
Var
	TempInt: Integer;
	TempStr: String;
	TempMode: Char;
	TempPtr: Pointer;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		If Length(String(Param^))>0
			Then TempMode:=String(Param^)[1]
			Else TempMode:='s';

		If TempMode='s'
			Then D.AssignPStr('ॣ 䠩', WinTitle)
			Else D.AssignPStr('i 䠩', WinTitle);
		MinX:=390;
		MinY:=210;
		GetMem(Data, SizeOf(TFileDlgData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TFileDlgData(Data^) Do
		Begin
			Mode:=TempMode;
			If Length(String(Param^))>2
				Then Mask:=Copy(String(Param^), 3, Length(String(Param^))-2)
				Else Mask:='*.*';
			PicUp:=Kernel.LoadBMPRes('pic\up.bmp');
			PicFolder:=Kernel.LoadBMPRes('pic\folder.bmp');
			PicFile:=Kernel.LoadBMPRes('pic\file.bmp');
			PicFloppy:=Kernel.LoadBMPRes('pic\d_floppy.bmp');
			PicFixed:=Kernel.LoadBMPRes('pic\d_fixed.bmp');
			PicCD:=Kernel.LoadBMPRes('pic\d_cdrom.bmp');

			GetDir(0, CurDir);
			TempPtr:=Kernel.FindProg('Navi');
			If TempPtr<>Nil Then
			Begin { .  i }
				TempPtr:=Kernel.SendMessage(Me, TempPtr, 'GetDir', Nil);
				If TempPtr<>Nil Then
					CurDir:=String(TempPtr^)
			End;

			MakeDrivesMenu(Me);
			Lab1:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
			LabPath:=Ctl.Label_Create(Me, CurDir, PicFolder, lsBeveled, alLeft);
			GetDir(0, TempStr);
			PbtDrives:=Ctl.PopupBtn_Create(Me, TempStr[1]+':', MnuDrives,
				PicFixed, ppLeft);
			LstDirs:=Ctl2.ListBox_Create(Me, False);
			Ctl2.ListBox_SetOnStrongSelect(LstDirs, OnDirSelect);
			LstDirs^.AutoRedraw:=False;
			Ctl2.ListBox_SelectItem(LstDirs, 1);
			SplTest:=Ctl.Splitter_Create(Me, 130, orVertical, saLeftUp);
			SplTest^.FocusCtl:=Nil;
			LstFiles:=Ctl2.ListBox_Create(Me, False);
			Ctl2.ListBox_SetOnSelect(LstFiles, OnFileSelect);
			Ctl2.ListBox_SetOnStrongSelect(LstFiles, OnFileStrongSelect);
			Ctl2.ListBox_SetOnHint(LstFiles, OnFileListHint);
			LstFiles^.AutoRedraw:=False;
			Ctl2.ListBox_SelectItem(LstFiles, 1);
			Ctl2.ListBox_SetColumnProps(LstFiles, 3, lcRightMono, True);
			Ctl2.ListBox_SetColumnProps(LstFiles, 4, lcRightMono, True);

			If Mode='s' Then
			Begin
				Lab2:=Ctl.Label_Create(Me, 'I'':', Nil, lsNormal, alRight);
				TempInt:=Pos('.', Mask);
				If TempInt>0 Then
				Begin
					TempStr:=Copy(Mask, TempInt, Length(Mask)-TempInt+1);
					If TempStr='.*' Then
						TempStr:=''
				End
				Else
					TempStr:='';
				InpName:=Ctl.InpLine_Create(Me, TempStr, PicFile);
				BtnOpen:=Ctl.Button_Create(Me, 'ॣ', Kernel.PicOK,
					ppLeft, OnFileStrongSelect);
			End
			Else Begin
				BtnOpen:=Ctl.Button_Create(Me, 'i', Kernel.PicOK,
					ppLeft, OnFileStrongSelect);
				D.ReassignPStr('i ࠭ 䠩', BtnOpen^.Hint);
			End;
			BtnCancel:=Ctl.Button_Create(Me, 'i', Kernel.PicClose,
				ppLeft, OnCancelClick);
			D.ReassignPStr('  i', BtnCancel^.Hint);

			ButtonEnter:=BtnOpen;
			ButtonEsc:=BtnCancel;
			If Mode='s'
				Then ActiveCtl:=InpName
				Else ActiveCtl:=LstFiles;

			ChangeDir(Me)
		End
	End
End;



Begin
	Kernel.RegBuiltIn('FileDlg', '', '', OnInit)
End.
