Program
	FileOps6; { almost ready }

Uses
	DOS;

Const
	ChunkSize: LongInt=8192;

Type
	TObjectKind=(okFile, okFolder);

Var
	Steps, CurSteps: LongInt;

		{ for NextStep }
	Objects: Array[1..70] Of Record
		Name: String[12];
		Kind: TObjectKind
	End;
	ObjectsNum, CurObject: Integer;

		{ for OnIdle }
	Par: Array[1..70] Of Record
		Path: String;
		SR: SearchRec;
		Res: Integer;
		State: (stPrepare, stStartSearch, stContSearch, stCopyFile);
	End;
	LastPar: Integer;
	OrigSourcePath, SourcePath, TargetPath: String;
	PBuf: Pointer;
	RealSize: Integer;
	F1, F2: File;
	FileOp: Array[1..2] Of (foDelete, foRename, foCopy, foMove, foStatQuick, foStatFull);
	OpObject: TObjectKind;
	Pass: 1..2;


Function ClipFName(FullName:String): String;
Var
	Path, Name, Ext: String;
Begin
	FSplit(FullName, Path, Name, Ext);
	ClipFName:=Name
End;

Function ClipFNameExt(FullName:String): String;
Var
	Path, Name, Ext: String;
Begin
	FSplit(FullName, Path, Name, Ext);
	ClipFNameExt:=Name+Ext
End;



	{ to enter supply:
	  Objects array, ObjectsNum, CurObject
	  OrigSourcePath
	  }

Procedure NextStep;
Begin
	If CurObject=ObjectsNum Then
	Begin { Pass complete }
		If Pass=1 Then
		Begin { second pass }
			WriteLn('Pass 1 complete, steps = ', Steps);
			Write('Cur steps: 0000000');
			CurSteps:=0;
			Pass:=2;
			CurObject:=0
		End
		Else Begin { all done! }
			LastPar:=-1;
			Exit
		End
	End;

	Inc(CurObject);
	LastPar:=1;
	Par[1].State:=stPrepare;
	opObject:=Objects[CurObject].Kind;
	SourcePath:=OrigSourcePath+'\'+Objects[CurObject].Name
End;


	{ to enter supply:
	  LastPar=1;
	  Par[1].State=stPrepare;
	  opObject, FileOp[1, 2], Pass;
	  SourcePath, TargetPath; }
Procedure OnIdle;
Begin
	If LastPar=0 Then
	Begin { Current step complete }
		NextStep;
		Exit
	End;

	With Par[LastPar] Do
		Case State Of
			stPrepare: Begin
				Case OpObject Of
					okFolder: Begin
						If FileOp[Pass] In [foRename, foCopy, foMove] Then
						Begin
							TargetPath:=TargetPath+'\'+ClipFName(SourcePath+'.tmp');
							MkDir(TargetPath)
						End;
						Path:='';
						State:=stStartSearch
					End;
					okFile: Begin
						Case FileOp[Pass] Of
							foDelete: Begin
								Assign(F1, SourcePath);
								SetFAttr(F1, 0);
								Erase(F1);
								Inc(CurSteps);
								LastPar:=0
							End;
							foRename: Begin
								Assign(F1, SourcePath);
								Rename(F1, TargetPath+'\'+ClipFNameExt(SourcePath));
								Inc(CurSteps);
								LastPar:=0
							End;
							foCopy, foMove: Begin
								FileMode:=0;
								Assign(F1, SourcePath);
								Reset(F1, 1);
								Assign(F2, TargetPath+'\'+ClipFNameExt(SourcePath));
								Rewrite(F2, 1);
								State:=stCopyFile
							End;
							foStatQuick: Begin
								Inc(Steps);
								LastPar:=0
							End;
							foStatFull: Begin
								Assign(F1, SourcePath);
								Reset(F1, 1);
								Inc(Steps, (FileSize(F1)+ChunkSize-1) Div ChunkSize);
								Close(F1);
								LastPar:=0
							End
						End
					End
				End;
			End;
			stStartSearch: Begin { start search }
				FindFirst(SourcePath+Path+'\*.*', AnyFile, SR);
				Res:=DOSError;
				State:=stContSearch
			End;
			stContSearch: Begin { next file/folder found }
				If Res=0 Then { something found }
				Begin
					If (SR.Attr and Directory)=0 Then
					Begin { it's a file }
						Case FileOp[Pass] Of
							foDelete: Begin
								Assign(F1, SourcePath+Path+'\'+SR.Name);
								SetFAttr(F1, 0);
								Erase(F1);
								Inc(CurSteps)
							End;
							foRename: Begin
								Assign(F1, SourcePath+Path+'\'+SR.Name);
								Rename(F1, TargetPath+Path+'\'+SR.Name);
								Inc(CurSteps)
							End;
							foCopy, foMove: Begin
								FileMode:=0;
								Assign(F1, SourcePath+Path+'\'+SR.Name);
								Reset(F1, 1);
								Assign(F2, TargetPath+Path+'\'+SR.Name);
								Rewrite(F2, 1);
								State:=stCopyFile
							End;
							foStatQuick: Inc(Steps);
							foStatFull: Begin
								Assign(F1, SourcePath+Path+'\'+SR.Name);
								Reset(F1, 1);
								Inc(Steps, (FileSize(F1)+ChunkSize-1) Div ChunkSize);
								Close(F1)
							End
						End
					End
					Else If SR.Name[1]<>'.' Then
						Begin { it's a folder }
							Case FileOp[Pass] Of
								foRename, foCopy, foMove: Begin
									MkDir(TargetPath+Path+'\'+SR.Name);
									Inc(CurSteps)
								End;
								foStatQuick, foStatFull: Inc(Steps)
							End;
							Par[LastPar+1].Path:=Path+'\'+SR.Name;
							Par[LastPar+1].State:=stStartSearch;
							Inc(LastPar)
						End;
					FindNext(SR);
					Res:=DOSError
				End
				Else Begin { current search complete }
					Case FileOp[Pass] Of
						foRename, foMove: RmDir(SourcePath+Path);
						foDelete: Begin
							RmDir(SourcePath+Path);
							Inc(CurSteps)
						End
					End;
					Dec(LastPar)
				End
			End;
			stCopyFile: Begin
				BlockRead(F1, PBuf^, ChunkSize, RealSize);
				If RealSize>0 Then
				Begin
					BlockWrite(F2, PBuf^, RealSize);
					Inc(CurSteps)
				End;
				If RealSize<ChunkSize Then
				Begin
					Close(F1);
					Close(F2);
					If FileOp[Pass]=foMove Then
					Begin
						SetFAttr(F1, 0);
						Erase(F1)
					End;
					Case OpObject Of
						okFolder: State:=stContSearch;
						okFile: Dec(LastPar)
					End
				End
			End
		End;
	If Pass=2 Then
		Write(#8#8#8#8#8#8#8, CurSteps:7)
End;



Begin
	WriteLn;
	WriteLn;
	GetMem(PBuf, ChunkSize);
	LastPar:=1;
	OrigSourcePath:='D:\Temp\Qfolders';
	TargetPath:='D:\Temp\0';
	Objects[1].Name:='nhp';
	Objects[1].Kind:=okFolder;
	ObjectsNum:=1;
	CurObject:=0;
	FileOp[1]:=foStatFull;
	FileOp[2]:=foCopy;

	If FileOp[2]=foDelete
		Then Steps:=1
		Else Steps:=0;
	Pass:=1;
	NextStep;

	Repeat
		OnIdle
	Until LastPar=-1;
	FreeMem(PBuf, ChunkSize)
End.
