Program
	FindRAMD; { Searches for RAM Disk (TDSK.EXE) }

Uses
	DOS;

Type
	TDriveType=(dtFixed, dtFloppy, dtCDROM, dtNone);

Var
	Letter, Cur: Char;
	TempStr: String;

Function GetDriveType(Letter:Char): TDriveType;
Var
	Regs: Registers;
Begin
	Regs.BX := Ord(UpCase(Letter))+1-Ord('A');
	Regs.AX := $4408; { DOS 3.0+ IOCTL (44h), func 08 - get drive type }
	MsDos(Regs);
	If (Regs.Flags And $01)=0
		Then If Regs.AL=0
			Then GetDriveType := dtFloppy
			Else GetDriveType := dtFixed
		Else GetDriveType := dtNone
End;

Function GetVolumeLabel(Drive:Char): String;
Var
	SR: SearchRec;
	TempLabel: String;
Begin
	FindFirst(Drive+':\*.*', VolumeID, SR);
	If DOSError=0 Then
	Begin
		TempLabel:=SR.Name;
		Delete(TempLabel, Pos('.', TempLabel), 1);
		GetVolumeLabel:=TempLabel
	End
	Else GetVolumeLabel:=''
End;


Begin
		{ Search TurboDsk by kind and volume label }
	Letter:=' ';
	Cur:='A';
	Repeat
		If GetDriveType(Cur)=dtFixed Then
			If GetVolumeLabel(Cur)='TURBODSK' Then
				Letter:=Cur;
		Cur:=Succ(Cur)
	Until (Letter<>' ') Or (Cur>'Z');

		{ Is TurboDsk found? }
	If Letter=' ' Then
	Begin
		WriteLn('Cannot find RAM disk (TDSK.EXE).');
		Write('Enter drive letter to unpack Polit to: ');
		ReadLn(Letter);
		While GetDriveType(Letter)<>dtFixed Do
		Begin
			WriteLn;
			WriteLn('Drive ', Letter, ': is not valid hard drive.');
			Write('Enter another drive letter to unpack Polit to: ');
			ReadLn(TempStr);
			Letter:=TempStr[1]
		End
	End
	Else WriteLn('RAM disk found: ', Letter, ': [TURBODSK]');

	ChDir(Letter+':\')
End.