{$F+}
Unit
	FirstApp; { Polit Halcyon first application (for test purposes only) }

Interface

Uses
	Kernel, Types, D, Gfx, Ctl, Popup;

Type
	TFirstAppData=Record
		BtnTest, BtnDis, BtnExit, CanPic, LblTest, InpTest, ScrTest: PControl;
		SwtTest: PControl;
		BX, BY, BSX, BSY, Count: Integer;
		PicShot, PicPopup: Pointer;
		MyMenu: PMenuItem;
	End;

Implementation

Procedure FirstApp_OnPaint(Me:PProg);
Var
	I, Temp: Integer;
Begin
	With Me^, ClientRect, TFirstAppData(Data^) Do
	Begin
		Ctl.Canvas_Paint(CanPic, 0, 0, X2-X1-25, Y2-Y1-70);
		{Ctl.Button_Paint(BtnTest, 5, Y2-Y1-24, 65);}
		Ctl.Switcher_Paint(SwtTest, 5, Y2-Y1-24, 65);
		Ctl.Button_Paint(BtnDis, 70, Y2-Y1-24, 145);
		Ctl.Button_Paint(BtnExit, 150, Y2-Y1-24, 205);
		Ctl.Label_Paint(LblTest, 5, Y2-Y1-41, X2-X1-25);
		Ctl.Label_SetCaption(LblTest, 'Window Size: '+
			D.St(X2-X1+1)+' x '+D.St(Y2-Y1+1));
		Ctl.InpLine_Paint(InpTest, 5, Y2-Y1-65, X2-X1-25);
		Ctl.Scroll_Paint(ScrTest, X2-X1-17, 2, X2-X1-3, Y2-Y1-33);

		With CanPic^.Place Do
			For I:=0 To Y2-Y1-70 Do
				Gfx.Line(X1, Y1+I, X2, Y1+I, Random(7));

		If BX>X2-X1-10 Then
		Begin
			BX:=0;
			BSX:=1
		End;
		If BY>Y2-Y1-10 Then
		Begin
			BY:=0;
			BSY:=1;
		End;
		Gfx.Bar(X1+BX+2, Y1+BY+2, X1+BX+8, Y1+BY+8, clWhite)
	End
End;

Procedure FirstApp_OnClose(Me:PProg);
Begin
	Kernel.FreeRes('b_shot.bmp');
	Kernel.FreeRes('b_popup.bmp');
	{With Me^, TFirstAppData(Data^) Do
		Popup.FreeMenu(MyMenu); freed by Switcher }
	FreeMem(Me^.Data, SizeOf(TFirstAppData))
End;

Procedure FirstApp_OnIdle(Me:PProg);
Var
	Temp: Integer;
Begin
	With Me^, TFirstAppData(Data^), CanPic^.Place Do
	Begin
		If Not CanPic^.CanDraw Then Exit;

		With ClientRect Do
			Temp:=Random(Y2-Y1-70);
		Kernel.BeginPaintCoord(X1, Y1+Temp, X2, Y1+Temp);
		Gfx.Line(X1, Y1+Temp, X2, Y1+Temp, Random(7));
		Kernel.EndPaint;

		Inc(Count);
		If Count>7 Then
		Begin
			Count:=1;
			Inc(BX, BSX);
			If BX=0 Then BSX:=1;
			IF BX>=X2-X1-10 Then BSX:=-1;
			Inc(BY, BSY);
			If BY=0 Then BSY:=1;
			IF BY>=Y2-Y1-10 Then BSY:=-1;
			Kernel.BeginPaintCoord(X1+BX+2, Y1+BY+2, X1+BX+8, Y1+BY+8);
			Gfx.Bar(X1+BX+2, Y1+BY+2, X1+BX+8, Y1+BY+8, clWhite);
			Kernel.EndPaint
		End
	End
End;

Procedure FirstApp_OnShotClick(Me:PProg; Control:PControl);
Begin
	Kernel.TakeScreenshot
End;

Procedure FirstApp_OnPopupClick(Me:PProg;Control:PControl);
Begin
	With Me^, TFirstAppData(Data^), Control^.Place Do
		Popup.OpenMenu(Me, MyMenu, X1, Y2+1);
End;


Procedure FirstApp_OnExitClick(Me:PProg; Control:PControl);
Begin
	Kernel.GoodbyePolit
End;

Procedure FirstApp_OnScrollUpdate(Me:PProg; Control:PControl);
Begin
End;

Procedure FirstApp_OnInit(Me:PProg);
Var
	TempMenu: PMenuItem;
Begin
	With Me^ Do
	Begin
		D.AssignPStr('First App '+String(Param^), WinTitle);
		{D.AssignRect(20,100,220,240,WinRect);}
		MinX:=210;
		MinY:=120;
		OnPaint:=FirstApp_OnPaint;
		OnIdle:=FirstApp_OnIdle;
		OnClose:=FirstApp_OnClose;
		GetMem(Data,SizeOf(TFirstAppData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TFirstAppData(Data^) Do
		Begin
			PicShot:=Kernel.LoadBMPRes('pic\b_shot.bmp');
			PicPopup:=Kernel.LoadBMPRes('pic\b_popup.bmp');
			Log.BugMsg('FirstApp', 'OnInit', 'Pictures loaded');

			CanPic:=Ctl.Canvas_Create(Me, False);
			{BtnTest:=Ctl.Button_Create(Me, 'i',
				'஡ i'#13'筮 ii쪮 ࠭'#13#13'(. 䠩 SHOTnnnn.PCX)',
				PicShot, ppLeft, FirstApp_OnShotClick, True);}

			BtnDis:=Ctl.Button_Create(Me, '',
				PicPopup, ppLeft, FirstApp_OnPopupClick);
			Ctl.Button_SetMarkStyle(BtnDis, bmMenuDown);
			Log.BugMsg('FirstApp', 'OnInit', 'Button Menu ok');
			BtnExit:=Ctl.Button_Create(Me, 'i',
				Kernel.PicClose, ppLeft, FirstApp_OnExitClick);
			Log.BugMsg('FirstApp', 'OnInit', 'Button Exit ok');
			LblTest:=Ctl.Label_Create(Me, '', Nil, lsComment, alCenter);
			Log.BugMsg('FirstApp', 'OnInit', 'Label ok');
			InpTest:=Ctl.InpLine_Create(Me,
				'The road is never easy. It was never meant to be easy...', PicShot);
			Log.BugMsg('FirstApp', 'OnInit', 'Inpline ok');
			ScrTest:=Ctl.Scroll_Create(Me, 10, 3, 1, orVertical,
				FirstApp_OnScrollUpdate);
			ScrTest^.Enabled:=False;
			Log.BugMsg('FirstApp', 'OnInit', 'Scroll ok');
			{ActiveCtl:=InpTest;}
			Log.BugMsg('FirstApp', 'OnInit', 'Controls created');

			MyMenu:=Popup.CreateMenu;

			Popup.AddCommand(MyMenu, ' ', '', 'Sample hint 1',
				Nil, True, Popup.DummyProc);
			Popup.AddLegend(MyMenu, '( - ᭥)', 'Sample hint 1', Nil);
			Popup.AddCommand(MyMenu, 'First Item', 'F1', 'Sample hint 1', PicShot,
				True, Popup.DummyProc);
			Popup.AddCommand(MyMenu, 'Disabled Item', 'F2', 'Sample hint 2',
				PicPopup, False, Popup.DummyProc);
			TempMenu:=Popup.AddSubmenu(MyMenu, 'Submenu', 'Sample hint 3', PicClose, True);

				Popup.AddLegend(TempMenu, '( - ᭥)',
					'Sample hint 1', Nil);
				Popup.AddCommand(TempMenu, 'First Item', 'F1', 'hint 1', PicShot,
					True, Popup.DummyProc);
				Popup.AddCommand(TempMenu, 'Disabled Item', 'F2', 'hint 2', PicPopup,
					False, Popup.DummyProc);
				Popup.AddCheck(TempMenu, '-䫠', '', 'hint 2', Nil, True,
					True, Popup.DummyProc);
				TempMenu:=Popup.AddSubmenu(TempMenu, 'Submenu', 'hint 3', PicClose, True);

					Popup.AddRadio(TempMenu, '㯭i 窨', '', 'hint 4',
						Nil, True, 1, True, Popup.DummyProc);
					Popup.AddRadio(TempMenu, ' 窨', '', 'hint 4',
						Nil, False, 1, True, Popup.DummyProc);

			TempMenu:=Popup.AddSubmenu(MyMenu, '㢠 ',
				'Sample hint 3', PicShot, True);

				Popup.AddRadio(TempMenu, '㯭i 窨', '', 'hint 4',
					Nil, True, 1, True, Popup.DummyProc);
				Popup.AddRadio(TempMenu, ' 窨', '', 'hint 4',
					Nil, False, 1, True, Popup.DummyProc);
				Popup.AddRadio(TempMenu, '᮪', '', 'hint 4',
					Nil, False, 1, True, Popup.DummyProc);
				Popup.AddRadio(TempMenu, ' ()', '', 'hint 4',
					Nil, False, 1, True, Popup.DummyProc);

			Popup.AddSpace(MyMenu);
			Popup.AddCheck(MyMenu, 'i', 'Alt+X', 'Sample hint 4',
				Nil, True, True, Popup.DummyProc);
			Popup.AddSpace(MyMenu);
			Popup.AddRadio(MyMenu, 'Radiobutton 1', '', 'Sample hint 4',
				Nil, False, 1, True, Popup.DummyProc);
			Popup.AddRadio(MyMenu, 'i 2', '', 'Sample hint 4',
				Nil, True, 1, True, Popup.DummyProc);

			Log.BugMsg('FirstApp', 'OnInit', 'Menus created');

			SwtTest:=Ctl.Switcher_Create(Me, MyMenu, ppLeft);

			BX:=21;
			BY:=21;
			BSX:=1;
			BSY:=1;
			Count:=1;
		End
	End;
End;


Begin
	Kernel.RegBuiltIn('FirstApp', '⮢ ணࠬ', 'pic\i_app.bmp',FirstApp_OnInit)
End.