{$F+}
Unit
	FPropDlg; { Polit Halcyon FPropDlg application }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx, DOS, LFN;

Type
	TFPropDlgData=Record
		Lab1, InpName,
		Lab2, LabKind,
		Lab3, LabLocation, BtnCopy,
		Lab4, LabDate,
		Lab5, LabSize,
		Lab6, ChkReadOnly, ChkHidden, ChkArchive, ChkSystem,
		BtnAccept, BtnClose: PControl;
		PicFolder, PicCopy: Pointer;

	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TFPropDlgData(Data^) Do
	Begin
		Kernel.DarkBar(X1, Y2-34, X2, Y2);
		Gfx.TranspBar(X1, Y2-35, X2, Y2-35, clBlack, 50);

		Ctl.Label_Paint(Lab1, 10, 10, 80);
		Ctl.InpLine_Paint(InpName, 90, 10, X2-X1-10);

		Ctl.Label_Paint(Lab2, 10, 40, 80);
		Ctl.Label_Paint(LabKind, 90, 40, X2-X1-10);

		Ctl.Label_Paint(Lab3, 10, 70, 80);
		Ctl.Label_Paint(LabLocation, 90, 70, X2-X1-40);
		Ctl.Button_Paint(BtnCopy, X2-X1-35, 70, X2-X1-10);

		Ctl.Label_Paint(Lab4, 10, 110, 80);
		Ctl.Label_Paint(LabDate, 90, 110, X2-X1-10);

		Ctl.Label_Paint(Lab5, 10, 140, 80);
		Ctl.Label_Paint(LabSize, 90, 140, X2-X1-10);

		Ctl.Label_Paint(Lab6, 10, 180, 80);
		Ctl.Check_Paint(ChkReadOnly, 90, 180);
		Ctl.Check_Paint(ChkHidden, 90, 200);
		Ctl.Check_Paint(ChkArchive, 90, 220);
		Ctl.Check_Paint(ChkSystem, 90, 240);

		Ctl.Button_Paint(BtnAccept, X2-X1-215, Y2-Y1-26, X2-X1-115);
		Ctl.Button_Paint(BtnClose, X2-X1-105, Y2-Y1-26, X2-X1-5);
	End;
End;

Procedure OnCopyClick(Me:PProg; Ctl:PControl);
Begin
	With TFPropDlgData(Me^.Data^) Do
		Label_CopyToClipboard(LabLocation)
End;

Procedure OnAcceptClick(Me:PProg; Ctl:PControl);
Var
	NewName, ShortNewName: String;
	F: File;
	TempAttr: Word;
	TempPtr: Pointer;
	TempParent: PProg;
Begin
	With Me^, TFPropDlgData(Data^) Do
	Begin
		NewName:=D.ClipFPath(String(Param^));
		NewName:=NewName+InpLine_GetText(InpName);
		{NewName:=NewName+D.ClipFExt(String(Param^));}
		If String(Param^)<>NewName Then { i' i? }
			{LFN.LFNRename(String(Param^), NewName);}
		Begin
			Assign(F, String(Param^));
			Rename(F, NewName)
		End;
		{LFN.LFNGetShortPath(False, NewName, ShortNewName);}
		ShortNewName:=NewName;
			{ ⠢ ਡ }
		TempAttr:=0;
		If Check_GetState(ChkReadOnly) Then Inc(TempAttr, ReadOnly);
		If Check_GetState(ChkHidden) Then Inc(TempAttr, Hidden);
		If Check_GetState(ChkArchive) Then Inc(TempAttr, Archive);
		If Check_GetState(ChkSystem) Then Inc(TempAttr, SysFile);
		Assign(F, ShortNewName);
		SetFAttr(F, TempAttr);

		If Parent<>Nil Then
		Begin
			TempParent:=Parent;
			Kernel.CloseProg(Me);
			TempPtr:=Kernel.SendMessage(Nil, TempParent, 'FilePropsChanged', @NewName)
		End
		Else Kernel.CloseProg(Me)
	End
End;

Procedure OnCloseClick(Me:PProg; Ctl:PControl);
Begin
	Kernel.CloseProg(Me)
End;

Procedure OnClose(Me:PProg);
Begin
	Kernel.FreeRes('folder.bmp');
	Kernel.FreeRes('b_copy.bmp');
	FreeMem(Me^.Data, SizeOf(TFPropDlgData))
End;

Procedure OnInit(Me:PProg);
Var
	F: File;
	TempName, TempExt: String;
	TempLong: LongInt;
	TempAttr: Word;
	DT: DateTime;
	Subject: TFileOrFolder;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		MinX:=305;
		MinY:=310;
		GetMem(Data, SizeOf(TFPropDlgData));

		With TFPropDlgData(Data^) Do
		Begin
			PicFolder:=Kernel.LoadBMPRes('pic\folder.bmp');
			PicCopy:=Kernel.LoadBMPRes('pic\b_copy.bmp');

			{LFN.LFNGetShortPath(False, String(Param^), TempName);}
			TempName:=String(Param^);
			Subject:=D.FileOrFolder(TempName);
			If Subject=ffFile Then
			Begin
				Assign(F, TempName);
				Reset(F, 1);

				TempName:=D.LastPathItem(String(Param^));
				D.AssignPStr(TempName+' - ⨢i', WinTitle);
				Icon:=Kernel.GetFileIcon(TempName)
			End
			Else Begin { Subject=ffFolder }
				TempName:=D.LastPathItem(String(Param^));
				D.AssignPStr(TempName+' - ⨢i', WinTitle);
				Icon:=PicFolder
			End;
			Kernel.InitWindow(Me, 'BlueDlg', [wbClose]);
			Kernel.DrawWindowAni(Me);

			Lab1:=Ctl.Label_Create(Me, 'I'':', Nil, lsNormal, alRight);
			InpName:=Ctl.InpLine_Create(Me, TempName, Icon);
			Lab1^.FocusCtl:=InpName;

			If Subject=ffFile Then
			Begin
				TempExt:=D.ClipFExt(String(Param^));
				Delete(TempExt, 1, 1);
				Lab2:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
				LabKind:=Ctl.Label_Create(Me, Kernel.GetFileDescr(String(Param^)),
					Icon, lsBeveled, alLeft)
			End
			Else Begin
				Lab2:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
				LabKind:=Ctl.Label_Create(Me, '', PicFolder, lsBeveled, alLeft)
			End;

			Lab3:=Ctl.Label_Create(Me, 'i饭:', Nil, lsNormal, alRight);
			TempName:=D.ClipFPath(String(Param^));
			If Length(TempName)>3 Then
				Delete(TempName, Length(TempName), 1);
			LabLocation:=Ctl.Label_Create(Me, TempName, PicFolder,
				lsBeveled, alLeft);
			D.ReassignPStr(TempName, LabLocation^.Hint);
			BtnCopy:=Ctl.Button_Create(Me, '', PicCopy, ppLeft, OnCopyClick);
			D.ReassignPStr('i ஧i饭  ', BtnCopy^.Hint);


			If Subject=ffFile Then
			Begin
				GetFTime(F, TempLong);
				UnpackTime(TempLong, DT);
				Lab4:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
				LabDate:=Ctl.Label_Create(Me, D.St2(DT.Day)+'.'+D.St2(DT.Month)+
					'.'+D.St(DT.Year)+', '+D.St2(DT.Hour)+':'+D.St2(DT.Min)+':'+
					D.St2(DT.Sec), Nil, lsBeveled, alLeft);

				TempLong:=FileSize(F);
				Lab5:=Ctl.Label_Create(Me, 'i:', Nil, lsNormal, alRight);
				LabSize:=Ctl.Label_Create(Me, D.NormNum(D.StL(TempLong))+' ',
					Nil, lsBeveled, alLeft);

				GetFAttr(F, TempAttr);
				Close(F);
				Lab6:=Ctl.Label_Create(Me, 'ਡ:', Nil, lsNormal, alRight);
				ChkReadOnly:=Ctl.Check_Create(Me, 'i쪨  ⠭', (TempAttr And ReadOnly)<>0);
				ChkHidden:=Ctl.Check_Create(Me, '客', (TempAttr And Hidden)<>0);
				ChkArchive:=Ctl.Check_Create(Me, 'i', (TempAttr And Archive)<>0);
				ChkSystem:=Ctl.Check_Create(Me, '⥬', (TempAttr And SysFile)<>0)
			End
			Else Begin
				Lab4:=Ctl.Label_Create(Me, ':', Nil, lsDisabled, alRight);
				LabDate:=Ctl.Label_Create(Me, '-', Nil, lsBeveled, alLeft);
				Lab5:=Ctl.Label_Create(Me, 'i:', Nil, lsDisabled, alRight);
				LabSize:=Ctl.Label_Create(Me, '-', Nil, lsBeveled, alLeft);
				Lab6:=Ctl.Label_Create(Me, 'ਡ:', Nil, lsDisabled, alRight);
				ChkReadOnly:=Ctl.Check_Create(Me, 'i쪨  ⠭', False);
				ChkReadOnly^.Enabled:=False;
				ChkHidden:=Ctl.Check_Create(Me, '客', False);
				ChkHidden^.Enabled:=False;
				ChkArchive:=Ctl.Check_Create(Me, 'i', False);
				ChkArchive^.Enabled:=False;
				ChkSystem:=Ctl.Check_Create(Me, '⥬', False);
				ChkSystem^.Enabled:=False;
			End;

			BtnAccept:=Ctl.Button_Create(Me, '਩', Kernel.PicOK,
				ppLeft, OnAcceptClick);
			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseClick);

			ActiveCtl:=InpName;
			ButtonEnter:=BtnAccept;
			ButtonEsc:=BtnClose
		End
	End
End;



Begin
	Kernel.RegBuiltIn('FPropDlg', '', 'pic\i_app.bmp', OnInit)
End.
