{$F+}
Unit
	Friends; { Polit Halcyon Friends application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Popup, DOS;

Const
	FriendsPath='Prog\Friends\';

Type
	TFriendsData=Record
		PbtNew, PbtDelete, SwtOrient: PControl; { 㫡 }
		MnuNew, MnuDelete, MnuOrient: PMenuItem;
		LstFriends: PControl;                   { ᯨ᮪ }
		LabName, InpName: PControl;             {    iᠬ }
		LabNick, InpNick: PControl;
		LabPhone, InpPhone: PControl;
		LabBirthday, InpBirthday: PControl;
		LabCountry, InpCountry: PControl;
		LabAddress, InpAddress: PControl;
		LabEMail, InpEMail: PControl;
		LabSite, InpSite: PControl;
		{ ... }
		PicGuy, PicGal, PicVer, PicHor: Pointer; { ⨭ }
		PicNew, PicDelete: Pointer;
		Orient: TOrientation;

	End;

Implementation

Procedure OnPaint(Me:PProg);
Var
	ListBottom, Fields1Top, Fields2Top, ListRight, TempCenter: Integer;
	Labels1Left, Labels2Left, Fields1Right, Fields1Left, Fields2Left: Integer;
Begin
	With Me^, ClientRect, TFriendsData(Data^) Do
	Begin
		Ctl.PopupBtn_Paint(PbtNew, 5, 5, 75);
		Ctl.PopupBtn_Paint(PbtDelete, 80, 5, 150);
		Ctl.Switcher_Paint(SwtOrient, 165, 5, 235);

		Case Orient Of
			orHorizontal: Begin
				ListBottom:=Y2-Y1-5;
				Fields1Top:=50;
				Fields2Top:=Fields1Top+120;
				ListRight:=X2-X1-240;
				Labels1Left:=ListRight+10;
				Fields1Left:=Labels1Left+90;
				Fields1Right:=X2-X1-5;
				Labels2Left:=Labels1Left;
				Fields2Left:=Fields1Left
			End;
			orVertical: Begin
				ListBottom:=Y2-Y1-125;
				Fields1Top:=ListBottom+15;
				Fields2Top:=Fields1Top;
				ListRight:=X2-X1-5;
				TempCenter:=(X2-X1) Div 2;
				Labels1Left:=5;
				Fields1Left:=Labels1Left+90;
				Fields1Right:=TempCenter-5;
				Labels2Left:=TempCenter+5;
				Fields2Left:=Labels2Left+90
			End
		End;

		Ctl2.ListBox_Paint(LstFriends, 5, 50, ListRight, ListBottom);

			{ i }
		Ctl.Label_Paint(LabName, Labels1Left, Fields1Top, Fields1Left-5);
		Ctl.Label_Paint(LabNick, Labels1Left, Fields1Top+25, Fields1Left-5);
		Ctl.Label_Paint(LabPhone, Labels1Left, Fields1Top+50, Fields1Left-5);
		Ctl.Label_Paint(LabBirthday, Labels1Left, Fields1Top+85, Fields1Left-5);

		Ctl.Label_Paint(LabCountry, Labels2Left, Fields2Top, Fields2Left-5);
		Ctl.Label_Paint(LabAddress, Labels2Left, Fields2Top+25, Fields2Left-5);
		Ctl.Label_Paint(LabEmail, Labels2Left, Fields2Top+60, Fields2Left-5);
		Ctl.Label_Paint(LabSite, Labels2Left, Fields2Top+85, Fields2Left-5);

			{   }
		Ctl.InpLine_Paint(InpName, Fields1Left, Fields1Top, Fields1Right);
		Ctl.InpLine_Paint(InpNick, Fields1Left, Fields1Top+25, Fields1Right);
		Ctl.InpLine_Paint(InpPhone, Fields1Left, Fields1Top+50, Fields1Right);
		Ctl.InpLine_Paint(InpBirthday, Fields1Left, Fields1Top+85, Fields1Right);

		Ctl.InpLine_Paint(InpCountry, Fields2Left, Fields2Top, X2-X1-5);
		Ctl.InpLine_Paint(InpAddress, Fields2Left, Fields2Top+25, X2-X1-5);
		Ctl.InpLine_Paint(InpEmail, Fields2Left, Fields2Top+60, X2-X1-5);
		Ctl.InpLine_Paint(InpSite, Fields2Left, Fields2Top+85, X2-X1-5);
	End;
End;

{  II   }

Function GetFriendFName(Item: PListItem): String;
Begin
	GetFriendFName:=FriendsPath+String(Item^.SubItem^.Name^)
End;

Function GetCurFriendFName(Me:PProg): String;
Begin
	With Me^, TFriendsData(Data^) Do
		GetCurFriendFName:=GetFriendFName(Ctl2.ListBox_GetSelItem(LstFriends))
End;

Function GetCurFriendNick(Me:PProg): String;
Begin
	With Me^, TFriendsData(Data^) Do
		GetCurFriendNick:=String(Ctl2.ListBox_GetSelItem(LstFriends)^.Name^)
End;

Procedure ShowFriendInfo(Me:PProg);
Begin { ⠦   i ࠭ 㣠 }
	With Me^, TFriendsData(Data^) Do
	Begin
		If Ctl2.ListBox_GetItemsNum(LstFriends)=0 Then Exit;

		Ini.Select(GetCurFriendFName(Me), 'Friend');
		Ini.UpCaseNeeded:=False;
		Ctl.InpLine_SetText(InpName, Ini.GetStr('Name', ''));
		Ctl.InpLine_SetText(InpNick, Ini.GetStr('Nick', ''));
		Ctl.InpLine_SetText(InpPhone, Ini.GetStr('Phone', ''));
		Ctl.InpLine_SetText(InpBirthday, Ini.GetStr('Birthday', ''));
		Ctl.InpLine_SetText(InpCountry, Ini.GetStr('Country', ''));
		Ctl.InpLine_SetText(InpAddress, Ini.GetStr('Address', ''));
		Ctl.InpLine_SetText(InpEmail, Ini.GetStr('Email', ''));
		Ctl.InpLine_SetText(InpSite, Ini.GetStr('WWW', ''));
		Ini.UpCaseNeeded:=True
	End
End;



Procedure LoadFriend(Me:PProg; FName:String);
Var
	TempIcon: Pointer;
Begin
	With Me^, TFriendsData(Data^) Do
	Begin
		Ini.Load(FName);
		Ini.Select(FName, 'Friend');
		Ini.UpCaseNeeded:=False;
		If D.UpCaseLine(D.ClipFExt(FName))='.GAL'
			Then TempIcon:=PicGal
			Else TempIcon:=PicGuy;
		Ctl2.ListBox_AddItemLast(LstFriends,
			Ini.GetStr('Nick', ''), TempIcon, 0);
		Ctl2.ListBox_AddSubItem(LstFriends, D.ClipFNameExt(FName), Nil);
		Ctl2.ListBox_AddSubItem(LstFriends, Ini.GetStr('Phone', ''), Nil);
		Ctl2.ListBox_AddSubItem(LstFriends, Ini.GetStr('Name', ''), Nil);
		{...}
		Ini.UpCaseNeeded:=True;
	End
End;

Procedure LoadAllFriends(Me:PProg);
	Procedure LoadFriendsByMask(Mask:String);
	Var
		SR: SearchRec;
	Begin
		DOS.FindFirst(Mask, AnyFile, SR);
		While DOSError=0 Do
		Begin
			LoadFriend(Me, D.ClipFPath(Mask)+SR.Name);
			DOS.FindNext(SR)
		End
	End;

Begin {  i 䠩 prog\friends\(*.gal|*.guy),  ᯨ᮪ }
	With Me^, TFriendsData(Data^) Do
	Begin
		LoadFriendsByMask(FriendsPath+'*.gal');
		LoadFriendsByMask(FriendsPath+'*.guy');
		Ctl2.ListBox_Sort(LstFriends);
		If Ctl2.ListBox_GetItemsNum(LstFriends)>0 Then
			Ctl2.ListBox_SelectItem(LstFriends, 1);
		ShowFriendInfo(Me)
	End
End;



Procedure RenameCurFriend(Me:PProg; NewNick:String);
Var
	TempName, TempExt, NewFName: String;
	TempF: File;
	TempIndex: Integer;
	CurItem: PListItem;

	Function NickToFName(Nick:String): String;
	Const
		AllowedChars='ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_';
	Var
		V: Byte;
	Begin
		Nick:=D.UpCaseLine(D.TranslitLine(Nick));
			{  i ᨬ }
		V:=1;
		While V<=Length(Nick) Do
			If Pos(Nick[V], AllowedChars)>0
				Then Inc(V)
				Else Delete(Nick, V, 1);

		If Length(Nick)>8 Then
			Nick:=Copy(Nick, 1, 8);

		NickToFName:=Nick
	End;

Begin { i㢠 ७ ( ᯨ  䠩) }
	With Me^, TFriendsData(Data^) Do
	Begin
		TempName:=String(Ctl2.ListBox_GetSelItem(LstFriends)^.Name^);
		TempExt:=D.ClipFExt(GetCurFriendFName(Me));
		NewFName:=NickToFName(NewNick)+TempExt;
		If GetCurFriendFName(Me)<>FriendsPath+NewFName Then
		Begin {  i i i. i` 䠩 }
			Ini.FreeFile(GetCurFriendFName(Me));
			Assign(TempF, GetCurFriendFName(Me));
			Rename(TempF, FriendsPath+NewFName);
			Ini.Load(FriendsPath+NewFName);
			CurItem:=Ctl2.ListBox_GetSelItem(LstFriends);
			D.ReassignPStr(NewFName, CurItem^.SubItem^.Name)
		End
	End
End;


Procedure SaveFriendInfo(Me:PProg);
Var
	OldNick, NewNick: String;
Begin { ॣ  䠩i i i;  ॡ, i㢠 䠩 㣠 }
	With Me^, TFriendsData(Data^) Do
	Begin
		OldNick:=String(Ctl2.ListBox_GetSelItem(LstFriends)^.Name^);
		NewNick:=Ctl.InpLine_GetText(InpNick);
		Ini.Select(GetCurFriendFName(Me), 'Friend');
		Ini.SetStr('Name', Ctl.InpLine_GetText(InpName));
		Ini.SetStr('Nick', Ctl.InpLine_GetText(InpNick));
		Ini.SetStr('Phone', Ctl.InpLine_GetText(InpPhone));
		Ini.SetStr('Birthday', Ctl.InpLine_GetText(InpBirthday));
		Ini.SetStr('Country', Ctl.InpLine_GetText(InpCountry));
		Ini.SetStr('Address', Ctl.InpLine_GetText(InpAddress));
		Ini.SetStr('Email', Ctl.InpLine_GetText(InpEmail));
		Ini.SetStr('WWW', Ctl.InpLine_GetText(InpSite));
		If NewNick<>OldNick Then RenameCurFriend(Me, NewNick)
	End
End;

Procedure UpdateListRecord(Me:PProg);
Var
	TempStr: String;
	CurItem: PListItem;
Begin { ॣ  䠩i i i;  ॡ, i㢠 䠩 㣠 }
	With Me^, TFriendsData(Data^) Do
	Begin
		CurItem:=Ctl2.ListBox_GetSelItem(LstFriends);

		TempStr:=Ctl.InpLine_GetText(InpNick);
		D.ReassignPStr(TempStr, CurItem^.Name);
		TempStr:=Ctl.InpLine_GetText(InpPhone);
		D.ReassignPStr(TempStr, CurItem^.SubItem^.SubItem^.Name);
		TempStr:=Ctl.InpLine_GetText(InpName);
		D.ReassignPStr(TempStr, CurItem^.SubItem^.SubItem^.SubItem^.Name);
		{...}
	End
End;



Procedure OnBeforeFriendSelect(Me:PProg; Control:PControl);
Begin
	SaveFriendInfo(Me);
	UpdateListRecord(Me)
End;

Procedure OnFriendSelect(Me:PProg; Control:PControl);
Begin
	ShowFriendInfo(Me);
End;

Function FriendsListEmpty(Me:PProg): Boolean;
Begin
	With Me^, TFriendsData(Data^) Do
		FriendsListEmpty:=(Ctl2.ListBox_GetItemsNum(LstFriends)=0)
End;

Procedure CheckEnabled(Me:PProg);
Var
	NowEnabled, MustBeEnabled: Boolean;
Begin { ॢi,   i 㯭i i  . "" }
	With Me^, TFriendsData(Data^) Do
	Begin
		NowEnabled:=InpName^.Enabled;
		MustBeEnabled:=Not FriendsListEmpty(Me);

		If NowEnabled<>MustBeEnabled Then
		Begin
			Ctl.PopupBtn_AsButton(PbtDelete)^.Enabled:=MustBeEnabled;
			InpName^.Enabled:=MustBeEnabled;
			InpNick^.Enabled:=MustBeEnabled;
			InpPhone^.Enabled:=MustBeEnabled;
			InpBirthday^.Enabled:=MustBeEnabled;
			InpCountry^.Enabled:=MustBeEnabled;
			InpAddress^.Enabled:=MustBeEnabled;
			InpEmail^.Enabled:=MustBeEnabled;
			InpSite^.Enabled:=MustBeEnabled;

			Kernel.PaintWindow(Me)
		End
	End
End;


Procedure OnNewClick(Me:PProg; Item:PMenuItem);
Var
	TempName: String;
	TempIndex: Integer;

	Function GenUniqueName: String;
	Var
		TempExt: String;
		N: Integer;
	Begin
		With Me^, TFriendsData(Data^) Do
		Begin
			If Item^.Icon=PicGal
				Then TempExt:='.GAL'
				Else TempExt:='.GUY';

			If Not D.FileExist(FriendsPath+'Friend'+TempExt)
				Then GenUniqueName:='Friend'+TempExt
				Else Begin
					N:=1;
					While D.FileExist(FriendsPath+'Friend'+D.St(N)+TempExt) Do
						Inc(N);
					GenUniqueName:='Friend'+D.St(N)+TempExt
				End
		End
	End;

Begin
	With Me^, TFriendsData(Data^) Do
	Begin
		If Not FriendsListEmpty(Me) Then
		Begin
			SaveFriendInfo(Me);
			UpdateListRecord(Me)
		End;

		TempName:=GenUniqueName;
		Ini.CreateFile(FriendsPath+TempName);
		Ini.Select(FriendsPath+TempName, 'Friend');
		Ini.SetStr('Name', '');
		Ini.SetStr('Nick', ClipFName(TempName));
		Ini.SetStr('Phone', '');
		Ini.SetStr('Birthday', '');
		Ini.SetStr('Country', '');
		Ini.SetStr('Address', '');
		Ini.SetStr('Email', '');
		Ini.SetStr('WWW', '');
		Ini.SaveCurFile;
		LoadFriend(Me, FriendsPath+TempName);
		TempIndex:=Ctl2.ListBox_FindItem(LstFriends, ClipFName(TempName));
		Ctl2.ListBox_Draw(LstFriends);
		Ctl2.ListBox_SelectItem(LstFriends, TempIndex);
		ShowFriendInfo(Me);
		CheckEnabled(Me);
		Kernel.SelectFocusCtl(Me, InpName)
	End
End;

Procedure ClearFields(Me:PProg);
Var
	NowEnabled, MustBeEnabled: Boolean;
Begin { ॢi,   i 㯭i i  . "" }
	With Me^, TFriendsData(Data^) Do
	Begin
		Ctl.InpLine_SetText(InpName, '');
		Ctl.InpLine_SetText(InpNick, '');
		Ctl.InpLine_SetText(InpPhone, '');
		Ctl.InpLine_SetText(InpBirthday, '');
		Ctl.InpLine_SetText(InpCountry, '');
		Ctl.InpLine_SetText(InpAddress, '');
		Ctl.InpLine_SetText(InpEmail, '');
		Ctl.InpLine_SetText(InpSite, '');
	End
End;


Procedure OnDeleteClick(Me:PProg; Item:PMenuItem);
Var
	FName: String;
	TempF: File;
Begin
	With Me^, TFriendsData(Data^) Do
	Begin
		FName:=GetCurFriendFName(Me);
		Ini.FreeFile(FName);
		Assign(TempF, FName);
		Erase(TempF);
		Ctl2.ListBox_DeleteItem(LstFriends,
			Ctl2.ListBox_GetSelItemIndex(LstFriends));
		CheckEnabled(Me);
		If FriendsListEmpty(Me)
			Then ClearFields(Me)
			Else ShowFriendInfo(Me)
	End
End;


Procedure OnOrientClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TFriendsData(Data^) Do
	Begin
		If Orient=orVertical
			Then Orient:=orHorizontal
			Else Orient:=orVertical;
		Kernel.PaintWindow(Me)
	End
End;


Procedure MakeMenus(Me:PProg);
Begin
	With Me^, TFriendsData(Data^) Do
	Begin
		MnuNew:=Popup.CreateMenu;
		Popup.AddCommand(MnuNew, 'i稭', '', '', PicGal, True,
			OnNewClick);
		Popup.AddCommand(MnuNew, '', '', '', PicGuy, True,
			OnNewClick);

		MnuDelete:=Popup.CreateMenu;
		Popup.AddCommand(MnuDelete, ',  , ', '', '',
			PicDelete, True, OnDeleteClick);

		MnuOrient:=Popup.CreateMenu;
		Popup.AddCommand(MnuOrient, 'ਧ.', '', '', PicHor, True,
			OnOrientClick);
		Popup.AddCommand(MnuOrient, '⨪.', '', '', PicVer, True,
			OnOrientClick);
	End
End;




Procedure OnClose(Me:PProg);
Begin
	With Me^, TFriendsData(Data^) Do
	Begin
		If Not FriendsListEmpty(Me) Then
			SaveFriendInfo(Me);

		Kernel.FreeRes('pic\girl-r.bmp');
		Kernel.FreeRes('pic\boy.bmp');
		Kernel.FreeRes('prog\friends\lay-ver.bmp');
		Kernel.FreeRes('prog\friends\lay-hor.bmp');
		Kernel.FreeRes('pic\b_new.bmp');
		Kernel.FreeRes('pic\b_erase.bmp');

	End;
	FreeMem(Me^.Data, SizeOf(TFriendsData))
End;


Procedure OnInit(Me:PProg);
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('i', WinTitle);
		MinX:=420;
		MinY:=280;
		GetMem(Data, SizeOf(TFriendsData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TFriendsData(Data^) Do
		Begin
			PicGal:=Kernel.LoadBMPRes('pic\girl-r.bmp');
			PicGuy:=Kernel.LoadBMPRes('pic\boy.bmp');
			PicVer:=Kernel.LoadBMPRes('prog\friends\lay-ver.bmp');
			PicHor:=Kernel.LoadBMPRes('prog\friends\lay-hor.bmp');
			PicNew:=Kernel.LoadBMPRes('pic\b_new.bmp');
			PicDelete:=Kernel.LoadBMPRes('pic\b_erase.bmp');

			MakeMenus(Me);

			PbtNew:=Ctl.PopupBtn_Create(Me, '', MnuNew, PicNew, ppTop);
			PbtDelete:=Ctl.PopupBtn_Create(Me, '', MnuDelete,
				PicDelete, ppTop);
			SwtOrient:=Ctl.Switcher_Create(Me, MnuOrient, ppTop);

			LstFriends:=Ctl2.ListBox_Create(Me, False);
			Ctl2.ListBox_SetColumnProps(LstFriends, 2, lcLeft, False);
			Ctl2.ListBox_SetOnBeforeSelect(LstFriends, OnBeforeFriendSelect);
			Ctl2.ListBox_SetOnSelect(LstFriends, OnFriendSelect);

			LabName:=Ctl.Label_Create(Me, 'I'':', Nil, lsNormal, alRight);
			InpName:=Ctl.InpLine_Create(Me, '', Nil);
			LabNick:=Ctl.Label_Create(Me, 'i:', Nil, lsNormal, alRight);
			InpNick:=Ctl.InpLine_Create(Me, '', Nil);
			LabPhone:=Ctl.Label_Create(Me, '䮭:', Nil, lsNormal, alRight);
			InpPhone:=Ctl.InpLine_Create(Me, '', Nil);
			LabBirthday:=Ctl.Label_Create(Me, ' த.:', Nil, lsNormal, alRight);
			InpBirthday:=Ctl.InpLine_Create(Me, '', Nil);

			LabCountry:=Ctl.Label_Create(Me, ', i:', Nil, lsNormal, alRight);
			InpCountry:=Ctl.InpLine_Create(Me, '', Nil);
			LabAddress:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
			InpAddress:=Ctl.InpLine_Create(Me, '', Nil);
			LabEmail:=Ctl.Label_Create(Me, 'E-mail:', Nil, lsNormal, alRight);
			InpEmail:=Ctl.InpLine_Create(Me, '', Nil);
			LabSite:=Ctl.Label_Create(Me, 'Web-ᠩ:', Nil, lsNormal, alRight);
			InpSite:=Ctl.InpLine_Create(Me, '', Nil);

			Orient:=orHorizontal{orVertical};

			LoadAllFriends(Me);
			CheckEnabled(Me);

			ActiveCtl:=LstFriends
		End
	End
End;



Begin
	Kernel.RegBuiltIn('Friends', 'i', 'pic\girl-r.bmp', OnInit)
End.
