Unit
	Gfx; { Polit Halcyon Eva graphics unit (interface to SGraph) }

Interface

Uses
	SGraph, D, Log, Ini, Types, Mouse, BCRT;

Type
	TButtonRectStyle=(brSharp, brRounded);
	TMimicDir=(mdLeft, mdRight, mdRandom);

Const
	clBlack=224;
	clNavy=1;
	clOlive=2;
	clTeal=3;

	clMaroon=4;
	clPurple=5;
	clBrown=6;
	clSilver=7;

	clGray=8;
	clBlue=9;
	clGreen=10;
	clCyan=11;

	clRed=12;
	clMagenta=13;
	clYellow=14;
	clWhite=15;
		{ additional colors, experimental }
	clOpaqueBlack=224;
	clMidGray=17;
	clBlueGray=18;
	clNightGray={19}230;
	clDarkTeal={20}150;

	RGBCacheMaxSize=64;

		{ Basic graphics stuff }
	Procedure Init;
	Procedure SetMode(X,Y,BPP:Integer);

	Procedure ClearDesk;
	Procedure PutPixel(X,Y:Word; Color:LongInt);
	Function GetPixel(X,Y:Integer): LongInt;
	Procedure Line(X1,Y1,X2,Y2:Integer; Color:LongInt);
	Procedure QualityLine(X1,Y1,X2,Y2:Integer; Color:TColor);
	Procedure HighQualityLine(X1,Y1,X2,Y2:Real; Color:TColor);
	Procedure Rectangle(X1,Y1,X2,Y2:Integer; Color:LongInt);
	Procedure Ellipse(CX,CY,RX,RY:Integer; Color:LongInt);
	Procedure FillCircle(CX,CY,R:Integer; Color:LongInt);
	Procedure ButtonRect(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD:LongInt);
	Procedure FillButtonRect(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD,ColorFill:LongInt);
	Procedure TranspButtonRect(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD:LongInt;
		Percent:Byte);
	Procedure AngleRect(X1,Y1,X2,Y2:Integer; Color:LongInt);
	Procedure TabRect(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD:LongInt);
	Procedure TabBar(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD,ColorFill:LongInt);
	Procedure Bar(X1,Y1,X2,Y2:Integer; Color:LongInt);

	Procedure InvertBar(X1,Y1,X2,Y2:Integer);
	Procedure InvertFrame(FX1,FY1,FX2,FY2:Integer);
	Procedure InvertBarPlus(X1,Y1,X2,Y2,Color1,Color2:Integer);
	Procedure InvertBarPlusPlus(X1,Y1,X2,Y2,Color1,Color2:Integer);

	Function RGB(VR,VG,VB:Byte): TColor;
	Function Blend(C1,C2:TColor; Percent:Byte): TColor;

	Procedure TranspPixel(X,Y:Integer; Color: TColor; Percent:Byte);
	Procedure TranspBar(X1,Y1,X2,Y2:Integer; Color:TColor; Percent:Byte);
	Procedure PutTranspSprite(X1,Y1,Percent:Integer; P:Pointer);
	Procedure StripBar(X1,Y1,X2,Y2:Integer);
	Procedure BlurBar(X1,Y1,X2,Y2:Integer; FadeBy:Integer);
	Procedure SteelBar(X1,Y1,X2,Y2,Darkness:Integer);
	Procedure SteelBarMimic(X1,Y1,X2,Y2:Integer; MimicDir:TMimicDir);
	Procedure AgedBar(X1,Y1,X2,Y2: Integer; ClrEdge,ClrFill:TColor);
	Procedure StripedBar(X1,Y1,X2,Y2,Darkness:Integer);
	Procedure StripedBarMimic(X1,Y1,X2,Y2:Integer; MimicDir:TMimicDir);
	Procedure StoneBar(X1,Y1,X2,Y2,Darkness:Integer);

	Procedure SkinBar(X1,Y1,X2:Integer; PicL,PicR:Pointer);
	Procedure SkinBarVer(X1,Y1,Y2:Integer; PicU,PicD:Pointer);
	Procedure SkinBarTiled(X1,Y1,X2:Integer; PicL,PicM,PicR:Pointer);

	Procedure HorGradBar(X1,Y1,X2,Y2:Integer; C1,C2:TColor);
	Procedure VerGradBar(X1,Y1,X2,Y2:Integer; C1,C2:TColor);

		{ Image blocks (small, <64K) }
	Function ImageSize(X,Y:Integer): Word;
	Function ImageSize2(P:Pointer): Word;
	Function ImageSize4(X1,Y1,X2,Y2:Integer): Word;
	Procedure GetImage(X1,Y1,X2,Y2:Integer; Var P:Pointer);
	Procedure PutImage(X,Y:Integer; P:Pointer);
	Procedure PutSprite(X,Y:Integer; P:Pointer);
	Function ImageX(P:Pointer): Integer;
	Function ImageX2(P:Pointer): Integer;
	Function ImageY(P:Pointer): Integer;
	Function ImageY2(P:Pointer): Integer;
	Procedure GetImagePlus(X1,Y1,X2,Y2:Integer; Var P:Pointer);
	Procedure FreeImage(P:Pointer);

	Procedure GetBigImagePlus(X1,Y1,X2,Y2:Integer; Var P:Pointer);
	Procedure PutBigImage(X,Y:Integer; P:Pointer);
	Procedure PutBigSprite(X,Y:Integer; P:Pointer);
	Function BigImageSize(X1,Y1,X2,Y2:Integer): LongInt;
	Procedure FreeBigImage(Var P:Pointer);

	Procedure MakeEmptyImage(Var P:Pointer);
	Procedure SplitSkin3(Var OrigP:Pointer; Var Target: TSkinPic);
	Procedure SplitSkin4(Var OrigP:Pointer; Var Target: TSkinPic);
	Procedure FreeSkin3(Var Skin:TSkinPic);
	Procedure FreeSkin4(Var Skin:TSkinPic);

	Procedure PrepareRectImage(Var PU,PD,PL,PR:Pointer);
	Procedure GetRectImage(X1,Y1,X2,Y2:Integer; Var PU,PD,PL,PR:Pointer);
	Procedure PutRectImage(X1,Y1,X2,Y2:Integer; Var PU,PD,PL,PR:Pointer);
	Procedure FreeRectImage(Var PU,PD,PL,PR:Pointer);

	Procedure SavePCX(X1,Y1,X2,Y2:Integer; FName:String);
	Procedure ShowPCX(X,Y:Integer; FName:String);

	Procedure ZoomRect(R1,R2:TRect);

	Procedure PutSpriteGrayed16(X,Y:Integer; P:Pointer);
	Procedure PutImageX8(X,Y:Integer; P:Pointer);
	Procedure PutSpriteX8(X,Y:Integer; P:Pointer);

	Procedure ShadowPixel(X,Y:Integer);
	Procedure ShadowBar(X1,Y1,X2,Y2:Integer);
	Procedure PutSpriteShadow(X1,Y1,Depth:Integer; P:Pointer);

	Procedure CheckerBar(X1,Y1,X2,Y2:Integer; Color:TColor);
	Procedure BoxShadow(X1,Y1,X2,Y2,Depth:Integer);
	Procedure BoxShadowSoft(X1,Y1,X2,Y2,Depth:Integer);
	Procedure DitherBar(X1,Y1,X2,Y2:Integer; R,G,B:Byte);

	Procedure FadeDownPal;
	Procedure FadeUpPal;
	Procedure ApplyBrightCont(Brightness, Contrast: Integer);
	Procedure BlackPal;
	Procedure ReloadPal;
	Procedure SetPalColor(Color,R,G,B:Integer);
	Procedure LoadPal(FName:String; Var Palette:TPalette);
	Procedure ChangePal(FName:String);
	Procedure MakeRGB2Pal;

	Procedure Done;

(*Type
	TBigImage=Record
		Sig: LongInt; { must be 0 }
		Width, CurHeight: Integer;
		Next: Pointer;
		P: Byte;
	End;*)

Var
	ScrX, ScrY, ScrBPP: Integer;
	DesktopColor: Word;
	AniDelay, FadeDelay: Integer;
	Palette: TPalette;
	AllowZoomRect: Boolean;
	ButtonRectStyle: TButtonRectStyle;
	RGB2Pal: Array[0..15, 0..15, 0..15] Of TColor;


Implementation

Var
	ShadowTable: Array[0..255] Of Byte;
	RGBCache: Array[1..RGBCacheMaxSize] Of Record
		R, G, B: Byte;
		Color: TColor
	End;
	CacheSize, CacheCur: Integer;


Procedure SetScrParams(SX,SY,SBPP:Integer);
Begin
	ScrX:=SX-1;
	ScrY:=SY-1;
	ScrBPP:=SBPP
End;

Procedure ClearDesk;
Begin
	Bar(0, 0, ScrX, ScrY, DesktopColor)
End;

{Procedure MakeShadowTable;
Var
	I, J, Nearest: Byte;
	NearestDist: Integer;

	Function ShadowDist(C1, C2:Byte): Integer;
	Const
		Shift=14;
	Var
		Temp, IR, IG, IB:Integer;
	Begin
		IR:=Palette[C1].R-Shift;
		D.ToRange(IR, 0, 255);
		IR:=Abs(Palette[C2].R-IR);
		IG:=Palette[C1].G-Shift;
		D.ToRange(IG, 0, 255);
		IG:=Abs(Palette[C2].G-IG);
		IB:=Palette[C1].B-Shift;
		D.ToRange(IB, 0, 255);
		IB:=Abs(Palette[C2].B-IB);
		ShadowDist:=IR+IG+IB
	End;
Begin
	For I:=0 To 255 Do
	Begin
		Nearest:=0;
		NearestDist:=ShadowDist(I, Nearest);
		For J:=1 To 255 Do
			If (J<>I) And (ShadowDist(I, J)<NearestDist) Then
			Begin
				Nearest:=J;
				NearestDist:=ShadowDist(I, Nearest)
			End;
		ShadowTable[I]:=Nearest
	End
End;}

procedure MakeShadowTable;
var
  I, J: Byte;
  Nearest: Word;
  TempDist, NearestDist: Word;
  {Start, Finish: LongInt;
  StartS, FinishS: string;}

  function ShadowDist(C1, C2: Byte): Word;
  const
    Shift = 14;
  var
    IR, IG, IB: Integer;
  begin
    IR := Palette[C1].R - Shift;
    if IR < 0 then
      IR := 0;
    {D.NotLess(IR, 0);}
    IR := Abs(Palette[C2].R - IR);
    IG := Palette[C1].G - Shift;
    if IG < 0 then
      IG := 0;
    {D.NotLess(IG, 0);}
    IG := Abs(Palette[C2].G - IG);
    IB := Palette[C1].B - Shift;
	 if IB < 0 then
      IB := 0;
    {D.NotLess(IB, 0);}
    IB := Abs(Palette[C2].B - IB);
    ShadowDist := IR + IG + IB;
  end;

begin
  {Log.SysMsg('Gfx', 'MakeShadowTableCyber', 'Start.');
  Start := SysTimer;}
  for I := 0 to 255 do
  begin
    Nearest := 0;
    NearestDist := ShadowDist(I, Nearest);
    for J := 1 to 255 do
    begin
      TempDist := ShadowDist(I, J);
      if TempDist < NearestDist then
      begin
		  Nearest := J;
        NearestDist := TempDist;
      end;
    end;
    ShadowTable[I] := Nearest;
  end;
  {FinishS := D.StL(SysTimer - Start);
  Log.SysMsg('Gfx', 'MakeShadowTableCyber', 'Finish. Work time: ' + FinishS);}
end;

Procedure MakeRGB2Pal;
Var
	R, G, B: Byte;
Begin
	For R:=0 To 15 Do
		For G:=0 To 15 Do
			For B:=0 To 15 Do
				RGB2Pal[R, G, B]:=RGB(R Shl 2, G Shl 2, B Shl 2)
End;




Procedure SetMode(X,Y,BPP:Integer);
Begin
	Log.SysMsg('Gfx', 'OpenGraphics', 'X='+D.St(X)+' Y='+D.St(Y)+', BPP='+D.St(BPP));
	SetScrParams(X, Y, BPP);
	If BPP=8 Then
	Begin
		If (X=320) And (Y=200)
			Then SGraph.InitGraph(V320X200X256)
			Else If (X=640) And (Y=400)
				Then SGraph.InitGraph(V640X400X256)
				Else If (X=640) And (Y=480)
					Then SGraph.InitGraph(V640X480X256)
					Else If (X=800) And (Y=600)
						Then SGraph.InitGraph(V800X600X256)
						Else If (X=1024) And (Y=768)
							Then SGraph.InitGraph(V1024X768X256)
							Else If (X=1280) And (Y=1024)
								Then SGraph.InitGraph(V1280X1024X256)
								Else Begin
									Log.ErrMsg('Gfx', 'OpenGraphics',
										'unknown 8 BPP video mode');
									Log.ActMsg('Setting 800x600x256');
									SGraph.InitGraph(V800X600X256);
									SetScrParams(800, 600, 8)
								End
	End
	Else Begin
		Log.ErrMsg('Gfx', 'OpenGraphics', 'only 8 BPP modes supported');
		Log.ActMsg('Setting 800x600x256');
		SGraph.InitGraph(V800X600X256);
		SetScrParams(800, 600, 8)
	End;
	If SGraph.GraphResult=grOK
		Then Log.SysMsg('Gfx', 'OpenGraphics',
			'Graphics mode opened (VESA supported)')
		Else Begin
			Log.FatMsg('Gfx', 'OpenGraphics', 'Cannot open graphics mode :(');
			Log.ActMsg('VESA or this video mode is not supported by your video card');
			Log.Done;
			WriteLn('UKR:   ⠭ i筨 ०.');
			WriteLn('      i ᪠ -i Windows 200  XP, ஡  ');
			WriteLn('     -i ஧⮣   ࠭ (Alt+Enter) FAR''  Command Prompt''.');
			WriteLn('        , ஡ i Windows 98  i DOS.');
			WriteLn('ENG: Cannot open graphics mode.');
			WriteLn('     If Polit is runned under Windows 2000 or XP, try to run it from');
			WriteLn('     FAR or Command Prompt in full-screen mode (Alt+Enter).');
			WriteLn('     If this doesn''t help, try to run it under Windows 98 or DOS.');
			Halt(13)
		End;
	SGraph.GetAllPalette(@Palette);
End;

Procedure PutPixel(X,Y:Word; Color:LongInt);
Begin
	SGraph.PutPixel(X, Y, Color)
End;

Function GetPixel(X,Y:Integer): LongInt;
Begin
	GetPixel:=SGraph.GetPixel(X, Y)
End;

Procedure Line(X1,Y1,X2,Y2:Integer; Color:LongInt);
Begin
	SGraph.SetColor(Color);
	SGraph.Line(X1, Y1, X2, Y2)
End;

Procedure Rectangle(X1,Y1,X2,Y2:Integer; Color:LongInt);
Begin
	SGraph.SetColor(Color);
	SGraph.Rectangle(X1, Y1, X2, Y2)
End;

Procedure Ellipse(CX,CY,RX,RY:Integer; Color:LongInt);
Begin
	SGraph.SetColor(Color);
	SGraph.Ellipse(CX, CY, RX, RY)
End;

Procedure FillCircle(CX,CY,R:Integer; Color:LongInt);
Var
	X, Y, RSqr: LongInt;
Begin
	SGraph.SetColor(Color);
	RSqr:=Sqr(R);
	For Y:=0 To R Do
	Begin
		X:=Round(Sqrt(RSqr-Sqr(Y)));
		SGraph.Line(CX-X, CY-Y, CX+X, CY-Y);
		SGraph.Line(CX-X, CY+Y, CX+X, CY+Y);

	End
	{SGraph.FillEllipse(X, Y, RX, RY, Color)}
	{SGraph.Ellipse(X, Y, RX, RY)}
End;


Procedure ButtonRect(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD:LongInt);
Begin
	Case ButtonRectStyle Of
		brSharp: Begin
			SGraph.SetColor(ColorLU);
			SGraph.Line(X1, Y1, X2, Y1);
			SGraph.Line(X1, Y1+1, X1, Y2-1);
			SGraph.SetColor(ColorRD);
			SGraph.Line(X1, Y2, X2, Y2);
			SGraph.Line(X2, Y1+1, X2, Y2-1)
		End;
		brRounded: Begin
			SGraph.SetColor(ColorLU);
			SGraph.Line(X1+1, Y1, X2-1, Y1);
			SGraph.Line(X1, Y1+1, X1, Y2-1);
			SGraph.SetColor(ColorRD);
			SGraph.Line(X1+1, Y2, X2-1, Y2);
			SGraph.Line(X2, Y1+1, X2, Y2-1);
			SGraph.PutPixel(X1+1, Y1+1, ColorLU);
			SGraph.PutPixel(X2-1, Y2-1, ColorRD)
		End;
	End
End;

Procedure TranspButtonRect(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD:LongInt;
	Percent:Byte);
Begin
	TranspBar(X1, Y1, X2, Y1, ColorLU, Percent);
	TranspBar(X1, Y1+1, X1, Y2-1, ColorLU, Percent);
	TranspBar(X1, Y2, X2, Y2, ColorRD, Percent);
	TranspBar(X2, Y1+1, X2, Y2-1, ColorRD, Percent)
End;


Procedure FillButtonRect(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD,ColorFill:LongInt);
Begin
	Sgraph.SetColor(ColorFill);
	SGraph.Bar(X1+1, Y1+1, X2-1, Y2-1);
	{VerGradBar(X1+1, Y1+1, X2-1, Y2-1, ColorLU, ColorRD);}
	ButtonRect(X1, Y1, X2, Y2, ColorLU, ColorRD);
	
	{SGraph.PutPixel(X1+1,Y1+1,ColorLU);
	SGraph.PutPixel(X2-1,Y2-1,ColorRD)}
End;

{Procedure FillButtonRect(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD,ColorFill:LongInt);
Var
	Y: Integer;
   TempClr, ClrStep: Integer;
Begin
	If ColorFill=clSilver Then
   Begin
   	ButtonRect(X1, Y1, X2, Y2, ColorLU, ColorRD);
   	TempClr:=254;
      SGraph.SetColor(TempClr);
      ClrStep:=(Y2-Y1-1) Div 12;
      D.NotLess(ClrStep, 1);
      For Y:=Y1+1 To Y2-1 Do
      Begin
      	SGraph.Line(X1+1, Y, X2-1, Y);
         If (Y-Y1) Mod ClrStep=0 Then
         Begin
         	Dec(TempClr);
            SGraph.SetColor(TempClr)
         End
      End
   End
   Else
   	IntFillButtonRect(X1, Y1, X2, Y2, ColorLU, ColorRD, ColorFill)
End;}

Procedure AngleRect(X1,Y1,X2,Y2:Integer; Color:LongInt);
Begin
	SGraph.SetColor(Color);
	SGraph.Line(X1, Y1, X2, Y1);
	SGraph.Line(X1, Y1+1, X1, Y2)
End;

Procedure TabRect(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD:LongInt);
Begin
	SGraph.SetColor(ColorLU);
	SGraph.Line(X1, Y1, X2, Y1);
	SGraph.Line(X1, Y1+1, X1, Y2);
	SGraph.SetColor(ColorRD);
	SGraph.Line(X2, Y1+1, X2, Y2)
End;

Procedure TabBar(X1,Y1,X2,Y2:Integer; ColorLU,ColorRD,ColorFill:LongInt);
Begin
	TabRect(X1, Y1, X2, Y2, ColorLU, ColorRD);
	SGraph.SetColor(ColorFill);
	SGraph.Bar(X1+1, Y1+1, X2-1, Y2)
End;


Procedure Bar(X1,Y1,X2,Y2:Integer; Color:LongInt);
Begin
	SGraph.SetColor(Color);
	SGraph.Bar(X1, Y1, X2, Y2)
End;



Function ImageSize(X,Y:Integer): Word;
Begin
	ImageSize:=SGraph.ImageSize(1, 1, X, Y)
End;

Function ImageSize2(P:Pointer): Word;
Begin
	ImageSize2:=ImageSize(ImageX(P), ImageY(P))
End;

Function ImageSize4(X1,Y1,X2,Y2:Integer): Word;
Begin
	ImageSize4:=SGraph.ImageSize(X1, Y1, X2, Y2)
End;

Procedure InvertBar(X1,Y1,X2,Y2:Integer);
Var
	P: Pointer;
	Size: Word;
	I: Word;
Begin
	Size:=SGraph.ImageSize(X1, Y1, X2, Y2);
	GetMem(P, Size);
	SGraph.GetImage(X1, Y1, X2, Y2, P);
	For I:=4 To Size-1 Do
		{TMatrix(P^)[I]:=Not TMatrix(P^)[I];}
		If TMatrix(P^)[I]>=128
			Then Dec(TMatrix(P^)[I], 128)
			Else Inc(TMatrix(P^)[I], 128);
	SGraph.PutImage(X1, Y1, P);
	FreeMem(P, Size)
End;

Procedure InvertBarPlus(X1,Y1,X2,Y2,Color1,Color2:Integer);
Var
	P: Pointer;
	Size: Word;
	I: Word;
Begin
	Size:=SGraph.ImageSize(X1, Y1, X2, Y2);
	GetMem(P, Size);
	SGraph.GetImage(X1, Y1, X2, Y2, P);
	For I:=4 To Size Do
		If TMatrix(P^)[I]=Color1
			Then TMatrix(P^)[I]:=Color2
			Else TMatrix(P^)[I]:=Color1;
	SGraph.PutImage(X1, Y1, P);
	FreeMem(P, Size)
End;

Procedure InvertBarPlusPlus(X1,Y1,X2,Y2,Color1,Color2:Integer);
Var
	P: Pointer;
	Size: Word;
	I: Word;
Begin
	Size:=SGraph.ImageSize(X1, Y1, X2, Y2);
	GetMem(P, Size);
	SGraph.GetImage(X1, Y1, X2, Y2, P);
	For I:=4 To Size Do
		If TMatrix(P^)[I]=Color1
			Then TMatrix(P^)[I]:=Color2;
	SGraph.PutImage(X1, Y1, P);
	FreeMem(P, Size)
End;

Procedure QualityLine(X1,Y1,X2,Y2:Integer; Color:TColor);
Const
	Threshold=12;
Var
	X, Y: Integer;
	UpperY, LowerY: Integer;
	LeftX, RightX: Integer;
	ExactX, ExactY, Fraction, Delta: Real;
	LeftPerc, UpperPerc: Integer;
Begin
	If (X1=X2) Or (Y1=Y2) Then
	Begin
		Line(X1, Y1, X2, Y2, Color);
		Exit
	End;

	SGraph.PutPixel(X1, Y1, Color);
	SGraph.PutPixel(X2, Y2, Color);
	If Abs(Y1-Y2)<Abs(X1-X2) Then
	Begin { line is closer to horizontal }
		If X1>X2 Then
		Begin
			D.SwapInt(X1, X2);
			D.SwapInt(Y1, Y2)
		End;

		ExactY:=Y1;
		Delta:=(Y2-Y1)/(X2-X1);
		For X:=X1+1 To X2-1 Do
		Begin
			ExactY:=ExactY+Delta;
			UpperY:=Trunc(ExactY);
			UpperPerc:=Round((1-Frac(ExactY))*100);

			If UpperPerc>=Threshold Then
				TranspPixel(X, UpperY, Color, UpperPerc);
			If (100-UpperPerc)>=Threshold Then
				TranspPixel(X, UpperY+1, Color, 100-UpperPerc)
		End
	End
	Else Begin { line is closer to vertical }
		If Y1>Y2 Then
		Begin
			D.SwapInt(X1, X2);
			D.SwapInt(Y1, Y2)
		End;

		ExactX:=X1;
		Delta:=(X2-X1)/(Y2-Y1);
		For Y:=Y1+1 To Y2-1 Do
		Begin
			ExactX:=ExactX+Delta;
			LeftX:=Trunc(ExactX);
			LeftPerc:=Round((1-Frac(ExactX))*100);

			If LeftPerc>=Threshold Then
				TranspPixel(LeftX, Y, Color, LeftPerc);
			If (100-LeftPerc)>=Threshold Then
				TranspPixel(LeftX+1, Y, Color, 100-LeftPerc)
		End
	End

End;

Procedure HighQualityLine(X1,Y1,X2,Y2:Real; Color:TColor);
Const
	Threshold=12;
Var
	X, Y: Integer;
	UpperY, LowerY: Integer;
	LeftX, RightX: Integer;
	ExactX, ExactY, Fraction, Delta: Real;
	LeftPerc, UpperPerc: Integer;
Begin
	If (Round(X1)=Round(X2)) Or (Round(Y1)=Round(Y2)) Then
	Begin
		Line(Round(X1), Round(Y1), Round(X2), Round(Y2), Color);
		Exit
	End;

	If Abs(Y1-Y2)<Abs(X1-X2) Then
	Begin { line is closer to horizontal }
		If X1>X2 Then
		Begin
			D.SwapReal(X1, X2);
			D.SwapReal(Y1, Y2)
		End;

		Delta:=(Y2-Y1)/(X2-X1);
		TranspPixel(Trunc(X1), Round(Y1), Color, Round((1-Frac(X1)*100)));
		ExactY:=Y1+(1-Frac(X1))*Delta;
		For X:=Trunc(X1)+1 To Round(X2) Do
		Begin
			UpperY:=Trunc(ExactY);
			UpperPerc:=Round((1-Frac(ExactY))*100);

			If UpperPerc>=Threshold Then
				TranspPixel(X, UpperY, Color, UpperPerc);
			If (100-UpperPerc)>=Threshold Then
				TranspPixel(X, UpperY+1, Color, 100-UpperPerc);
			ExactY:=ExactY+Delta;
		End
	End
	Else Begin { line is closer to vertical }
		If Y1>Y2 Then
		Begin
			D.SwapReal(X1, X2);
			D.SwapReal(Y1, Y2)
		End;

		ExactX:=X1;
		TranspPixel(Round(X1), Trunc(Y1), Color, Round((1-Frac(Y1)*100)));
		Delta:=(X2-X1)/(Y2-Y1);
		For Y:=Trunc(Y1)+1 To Round(Y2) Do
		Begin
			LeftX:=Trunc(ExactX);
			LeftPerc:=Round((1-Frac(ExactX))*100);

			If LeftPerc>=Threshold Then
				TranspPixel(LeftX, Y, Color, LeftPerc);
			If (100-LeftPerc)>=Threshold Then
				TranspPixel(LeftX+1, Y, Color, 100-LeftPerc);
			ExactX:=ExactX+Delta;
		End
	End

End;



Procedure InvertFrame(FX1,FY1,FX2,FY2:Integer);
Begin
	InvertBar(FX1, FY1, FX2, FY1);
	InvertBar(FX1, FY2, FX2, FY2);
	InvertBar(FX1, FY1+1, FX1, FY2-1);
	InvertBar(FX2, FY1+1, FX2, FY2-1)
End;




Function RGB(VR,VG,VB:Byte): TColor;
Var
	CurColor, BestColor: TColor;
	I, CurDist, BestDist: Integer;
	Found: Boolean;

	Function Dist:Integer;
	Begin
		With Palette[CurColor] Do
			Dist:=Abs(VR-R)+Abs(VG-G)+Abs(VB-B)
	End;
Begin
		{ ᯮ ﭥ   }
	I:=1;
	Found:=False;
	While (I<=CacheSize) And Not Found Do
		With RGBCache[I] Do
			If (VR=R) And (VG=G) And (VB=B)
				Then Found:=True
				Else Inc(I);
	If Found Then { ! }
	Begin
		RGB:=RGBCache[I].Color;
		Exit
	End;

		{   ᭮ :( }
	BestColor:=1;
	CurColor:=1; { fix:    #0 -    ஧਩ }
	BestDist:=Dist;
	For CurColor:=2 To 255 Do
	Begin
		CurDist:=Dist;
		If CurDist<BestDist Then
		Begin
			BestColor:=CurColor;
			BestDist:=CurDist
		End
	End;
	RGB:=BestColor;

		{    }
	If CacheSize<RGBCacheMaxSize Then
	Begin
		Inc(CacheSize);
		CacheCur:=CacheSize
	End
	Else Begin
		Inc(CacheCur);
		If CacheCur>RGBCacheMaxSize Then
			CacheCur:=1
	End;
	With RGBCache[CacheCur] Do
	Begin
		R:=VR;
		G:=VG;
		B:=VB;
		Color:=BestColor
	End;
End;




Procedure BlendRGB(R1,G1,B1,R2,G2,B2,Percent:Byte; Var RR,RG,RB:Byte);
Begin
	RR:=(Integer(R1)*Percent+Integer(R2)*(100-Percent)) Div 100;
	RG:=(Integer(G1)*Percent+Integer(G2)*(100-Percent)) Div 100;
	RB:=(Integer(B1)*Percent+Integer(B2)*(100-Percent)) Div 100
End;

Function Blend(C1,C2:TColor; Percent:Byte): TColor;
Var
	TempR, TempG, TempB: Byte;
Begin
	BlendRGB(Palette[C1].R, Palette[C1].G, Palette[C1].B,
		Palette[C2].R, Palette[C2].G, Palette[C2].B, Percent,
		TempR, TempG, TempB);
	{Blend:=RGB(TempR, TempG, TempB)}
	Blend:=RGB2Pal[TempR Shr 2, TempG Shr 2, TempB Shr 2]
End;








Procedure TranspPixel(X,Y:Integer; Color: TColor; Percent:Byte);
Begin
	SGraph.PutPixel(X, Y, Blend(Color, SGraph.GetPixel(X,Y), Percent))
End;

Procedure TranspBar(X1,Y1,X2,Y2:Integer; Color:TColor; Percent:Byte);
Var
	X, Y, StartX: Integer;
	LastColor, NextColor, LastBlended: TColor;
	Finished: Boolean;
	DrawLastPixel: Boolean;
Begin
	{For Y:=Y1 To Y2 Do
		For X:=X1 To X2 Do
			TranspPixel(X, Y, Color, Percent)}
	If X2>X1 Then
		For Y:=Y1 To Y2 Do
		Begin
			DrawLastPixel:=True;
			X:=X1;
			Repeat
					{ iᥫi  ७ }
				NextColor:=SGraph.GetPixel(X, Y);
				Repeat
					LastColor:=NextColor;
					LastBlended:=Blend(Color, LastColor, Percent);
					Sgraph.PutPixel(X, Y, LastBlended);
					Inc(X);
					NextColor:=SGraph.GetPixel(X, Y);
				Until (NextColor=LastColor) Or (X=X2);

				If X<X2 Then
				Begin {   iᥫi }
					StartX:=X;
					Finished:=False;
					While (Not Finished) And (X<X2) Do
						If SGraph.GetPixel(X+1, Y)=LastColor
							Then Inc(X)
							Else Finished:=True;
					SGraph.SetColor(LastBlended);
					SGraph.Bar(StartX, Y, X, Y);
					If X=X2 Then DrawLastPixel:=False;
					If X<X2 Then Inc(X);
					If X=X2 Then
						NextColor:=SGraph.GetPixel(X, Y)
				End;
				If (X=X2) And DrawLastPixel Then
				Begin { ⠭i iᥫ  浪 }
					LastBlended:=Blend(Color, NextColor, Percent);
					Sgraph.PutPixel(X, Y, LastBlended);
				End
			Until X>=X2
		End
	Else { ⮢稪 ਭ  1 iᥫ;  i   ன }
		For Y:=Y1 To Y2 Do
			TranspPixel(X1, Y, Color, Percent)
End;

Procedure StripBar(X1,Y1,X2,Y2:Integer);
Var
	Y: Integer;
Begin
	For Y:=Y1 To Y2 Do
		{Case Y Mod 6 Of
			0: TranspBar(X1, Y, X2, Y, 255, 80);
			1, 5: TranspBar(X1, Y, X2, Y, 253, 80);
			2, 4: TranspBar(X1, Y, X2, Y, 251, 80);
			3: TranspBar(X1, Y, X2, Y, 249, 80)
		End}
		Case Y Mod 8 Of
			0: TranspBar(X1, Y, X2, Y, 255, 80);
			1, 7: TranspBar(X1, Y, X2, Y, 254, 80);
			2, 6: TranspBar(X1, Y, X2, Y, 253, 80);
			3, 5: TranspBar(X1, Y, X2, Y, 252, 80);
			4: TranspBar(X1, Y, X2, Y, 251, 80)
		End
End;

(* Procedure BlurBar(X1,Y1,X2,Y2:Integer; FadeBy:Integer);
Var
	X, Y: Integer;
	TempR, TempG, TempB: Integer;
	Clr, ClrU, ClrD, ClrL, ClrR: Byte;
	StartTime: LongInt;
Begin
	StartTime:=D.SysTimer;
	For Y:=Y1 To Y2 Do
		For X:=X1 To X2 Do
		Begin
			Clr:=SGraph.GetPixel(X, Y);
			ClrR:=SGraph.GetPixel(X+1, Y);
			ClrD:=SGraph.GetPixel(X, Y+1);

			If (Clr<>ClrR) Or (Clr<>ClrD) Then
			Begin
				TempR:=(Palette[Clr].R+Palette[ClrR].R+Palette[ClrD].R) Div 3+FadeBy;
				TempG:=(Palette[Clr].G+Palette[ClrR].G+Palette[ClrD].G) Div 3+FadeBy;
				TempB:=(Palette[Clr].B+Palette[ClrR].B+Palette[ClrD].B) Div 3+FadeBy
			End
			Else Begin
				TempR:=Palette[Clr].R+FadeBy;
				TempG:=Palette[Clr].G+FadeBy;
				TempB:=Palette[Clr].B+FadeBy
			End;
			D.ToRange(TempR, 0, 63);
			D.ToRange(TempG, 0, 63);
			D.ToRange(TempB, 0, 63);
			Gfx.PutPixel(X, Y, RGB(TempR, TempG, TempB))
		End;
	Log.BugMsg('Gfx', 'BlurBar', 'Working time: '+D.StL(SysTimer-StartTime))
End; *)

	{ CyberHead's }
procedure BlurBar(X1, Y1, X2, Y2: Integer; FadeBy: Integer);
var
  X, Y: Integer;
  TempR, TempG, TempB: Integer;

  StartTime: LongInt;
  StartS, FinishS: string;
  Clr, ClrR, ClrD: Word;
  StartClr, StartClrR, StartClrD: Word;
  StartX: Word;
  {StartRGB: Word;}

  function GetRGB(Clr, ClrR, ClrD: Word): Integer;
  begin
	 if (Clr <> ClrR) or (Clr <> ClrD) then
	 begin
		TempR := (Palette[Clr].R + Palette[ClrR].R + Palette[ClrD].R) div 3 + FadeBy;
		TempG := (Palette[Clr].G + Palette[ClrR].G + Palette[ClrD].G) div 3 + FadeBy;
		TempB := (Palette[Clr].B + Palette[ClrR].B + Palette[ClrD].B) div 3 + FadeBy;
	 end
	 else
	 begin
		TempR := Palette[Clr].R + FadeBy;
		TempG := Palette[Clr].G + FadeBy;
		TempB := Palette[Clr].B + FadeBy;
	 end;
	 D.ToRange(TempR, 0, 63);
	 D.ToRange(TempG, 0, 63);
	 D.ToRange(TempB, 0, 63);
	 {GetRGB := RGB(TempR, TempG, TempB);}
	 GetRGB:=RGB2Pal[TempR Shr 2, TempG Shr 2, TempB Shr 2]
  end;

begin
  {Log.SysMsg('Gfx', 'BlurBarCyber', 'Start.');}
  StartTime := D.SysTimer;
  for Y := Y1 to Y2 do
  begin
	 Clr := SGraph.GetPixel(X1, Y);
	 ClrR := SGraph.GetPixel(X1 + 1, Y);
	 ClrD := SGraph.GetPixel(X1, Y + 1);
	 StartX := X1;
	 StartClr := Clr;
	 StartClrR := ClrR;
	 StartClrD := ClrD;
	 {StartRGB := GetRGB(StartColor, ClrR, ClrD);}
	 for X := X1 + 1 to X2+1 do
	 begin
		ClrR := SGraph.GetPixel(X + 1, Y);
		ClrD := SGraph.GetPixel(X, Y + 1);

		if (StartClr <> Clr) or (StartClrR <> ClrR) or (StartClrD <> ClrD) Or
			(X=X2+1) then
		begin
        Gfx.Line(StartX, Y, X - 1, Y, GetRGB(StartClr, StartClrR, StartClrD));
        StartClr := Clr;
        StartClrR := ClrR;
        StartClrD := ClrD;
		  StartX := X;
		end;
		Clr := ClrR;
	 end;
  end;
  Log.SysMsg('Gfx', 'BlurBarCyber', 'Work time: ' + D.StL(D.SysTimer-StartTime))
end;


Procedure PutTranspSprite(X1,Y1,Percent:Integer; P:Pointer);
Const
	TranspColor=0;
Var
	X, Y, Width: Integer;
	C: Byte;
Begin
	Width:=TMatrix2(P^)[0];
	For Y:=0 To TMatrix2(P^)[1]-1 Do
		For X:=0 To Width-1 Do
		Begin
			C:=TMatrix(P^)[4+Y*Width+X];
			If C<>TranspColor Then
				TranspPixel(X1+X, Y1+Y, C, Percent)
		End
End;






Procedure GetImage(X1,Y1,X2,Y2:Integer; Var P:Pointer);
Begin
	SGraph.GetImage(X1, Y1, X2, Y2, P)
End;

Procedure PutImage(X,Y:Integer; P:Pointer);
Begin
	SGraph.PutImage(X, Y, P)
End;

Procedure PutSprite(X,Y:Integer; P:Pointer);
Begin
	SGraph.PutSprite(X, Y, P)
End;

Function ImageX(P:Pointer): Integer;
Begin
	ImageX:=TMatrix2(P^)[0]
End;

Function ImageX2(P:Pointer): Integer;
Begin
	If TBigImage(P^).SmallWidth=0
		Then ImageX2:=TBigImage(P^).BigWidth
		Else ImageX2:=TBigImage(P^).SmallWidth
End;

Function ImageY(P:Pointer): Integer;
Begin
	ImageY:=TMatrix2(P^)[1]
End;

Function ImageY2(P:Pointer): Integer;
Var
	TempHeight: Integer;
	Finished: Boolean;
	CurP: Pointer;
Begin
	If TMatrix2(P^)[1]=0 Then
	Begin { big image }
		TempHeight:=TBigImage(P^).BigHeight;
		CurP:=TBigImage(P^).Next;
		Finished:=False;
		Repeat
			If TBigImage(CurP^).SmallHeight=0 Then
			Begin { stripe }
				Inc(TempHeight, TBigImage(CurP^).BigHeight);
				CurP:=TBigImage(CurP^).Next
			End
			Else Begin { last }
				Inc(TempHeight, TBigImage(CurP^).SmallHeight);
				Finished:=True
			End
		Until Finished;
		ImageY2:=TempHeight
	End
	Else ImageY2:=TMatrix2(P^)[1]
End;

Procedure SavePCX(X1,Y1,X2,Y2:Integer; FName:String);
Begin
	SGraph.SavePCX(X1, Y1, X2, Y2, FName)
End;

Procedure ShowPCX(X,Y:Integer; FName:String);
Begin
	SGraph.LoadPCX(X, Y, FName)
End;

Procedure GetImagePlus(X1,Y1,X2,Y2:Integer; Var P:Pointer);
Begin
	GetMem(P, ImageSize4(X1, Y1, X2, Y2));
	SGraph.GetImage(X1, Y1, X2, Y2, P)
End;

Procedure FreeImage(P:Pointer);
Begin
	FreeMem(P, ImageSize2(P))
End;




Procedure GetBigImagePlus(X1,Y1,X2,Y2:Integer; Var P:Pointer);
Var
	CurY, Width, MaxHeight: Integer;
	CurP, LastP, TempP: Pointer;
Begin
	CurY:=Y1;
	Width:=X2-X1+1;
	MaxHeight:=64000 Div Width;
	P:=Nil;
	LastP:=Nil;
	Repeat
		If Y2-CurY+1>MaxHeight Then
		Begin
			GetMem(CurP, ImageSize4(X1, CurY, X2, CurY+MaxHeight-1)+8);
			TempP:=@(TBigImage(CurP^).BigWidth);
			GetImage(X1, CurY, X2, CurY+MaxHeight-1, TempP);
			TBigImage(CurP^).SmallWidth:=0;
			TBigImage(CurP^).SmallHeight:=0;
			If P=Nil Then P:=CurP;
			If LastP<>Nil Then TBigImage(LastP^).Next:=CurP;
			LastP:=CurP;
			Inc(CurY, MaxHeight)
		End
		Else Begin
			GetImagePlus(X1, CurY, X2, Y2, CurP);
			If P=Nil Then P:=CurP;
			If LastP<>Nil Then TBigImage(LastP^).Next:=CurP;
			Inc(CurY, MaxHeight)
		End
	Until CurY>Y2
End;

Procedure PutBigImage(X,Y:Integer; P:Pointer);
Var
	CurY: Integer;
	CurP, TempP: Pointer;
	Finished: Boolean;
Begin
	CurY:=Y;
	CurP:=P;
	Finished:=False;
	Repeat
		If TBigImage(CurP^).SmallWidth=0 Then
		Begin
			TempP:=@(TBigImage(CurP^).BigWidth);
			PutImage(X, CurY, TempP);
			Inc(CurY, ImageY(TempP));
			CurP:=TBigImage(CurP^).Next
		End
		Else Begin
			PutImage(X, CurY, CurP);
			Finished:=True
		End
	Until Finished
End;

Procedure PutBigSprite(X,Y:Integer; P:Pointer);
Var
	CurY: Integer;
	CurP, TempP: Pointer;
	Finished: Boolean;
Begin
	CurY:=Y;
	CurP:=P;
	Finished:=False;
	Repeat
		If TBigImage(CurP^).SmallWidth=0 Then
		Begin
			TempP:=@(TBigImage(CurP^).BigWidth);
			PutSprite(X, CurY, TempP);
			Inc(CurY, ImageY(TempP));
			CurP:=TBigImage(CurP^).Next
		End
		Else Begin
			PutSprite(X, CurY, CurP);
			Finished:=True
		End
	Until Finished
End;

Function BigImageSize(X1,Y1,X2,Y2:Integer): LongInt;
Var
	TempSize: LongInt;
Begin
	TempSize:=LongInt(X2-X1)*LongInt(Y2-Y1);
	BigImageSize:=TempSize+((TempSize Div 64000)+1)*12
End;

Procedure FreeBigImage(Var P:Pointer);
Var
	NextP: Pointer;
	Size: Word;
Begin
	While P<>Nil Do
	Begin
		If TBigImage(P^).SmallWidth=0 Then
		Begin
			Size:=ImageSize(TBigImage(P^).BigWidth, TBigImage(P^).BigHeight)+8;
			NextP:=TBigImage(P^).Next
		End
		Else Begin
			Size:=ImageSize(TBigImage(P^).SmallWidth, TBigImage(P^).SmallHeight);
			NextP:=Nil
		End;
		FreeMem(P, Size);
		P:=NextP
	End
End;




Procedure PrepareRectImage(Var PU,PD,PL,PR:Pointer);
Var
	SizeHor, SizeVer: Word;
Begin
	SizeHor:=SGraph.ImageSize(0, 0, ScrX, 0);
	GetMem(PU, SizeHor);
	GetMem(PD, SizeHor);
	SizeVer:=SGraph.ImageSize(0, 0, 0, ScrY);
	GetMem(PL, SizeVer);
	GetMem(PR, SizeVer)
End;

Procedure GetRectImage(X1,Y1,X2,Y2:Integer; Var PU,PD,PL,PR:Pointer);
Begin
	SGraph.GetImage(X1, Y1, X2, Y1, PU);
	SGraph.GetImage(X1, Y2, X2, Y2, PD);
	SGraph.GetImage(X1, Y1+1, X1, Y2-1, PL);
	SGraph.GetImage(X2, Y1+1, X2, Y2-1, PR)
End;

Procedure PutRectImage(X1,Y1,X2,Y2:Integer; Var PU,PD,PL,PR:Pointer);
Begin
	SGraph.PutImage(X1, Y1, PU);
	SGraph.PutImage(X1, Y2, PD);
	SGraph.PutImage(X1, Y1+1, PL);
	SGraph.PutImage(X2, Y1+1, PR)
End;

Procedure FreeRectImage(Var PU,PD,PL,PR:Pointer);
Var
	SizeHor, SizeVer: Word;
Begin
	SizeHor:=SGraph.ImageSize(0, 0, ScrX, 0);
	FreeMem(PU, SizeHor);
	FreeMem(PD, SizeHor);
	SizeVer:=SGraph.ImageSize(0, 0, 0, ScrY);
	FreeMem(PL, SizeVer);
	FreeMem(PR, SizeVer)
End;








Procedure ZoomRect(R1,R2:TRect);
Var
	Last: TRect;
	DX1, DX2, DY1, DY2: Real;
	X1, Y1, X2, Y2, Temp: Real;
	Steps, I: Integer;
	Dl: Integer;
	ZoomSpeed, ZoomDelay: Integer;
	MouseDX, MouseDY: Integer;
	StopAnimsOnMouse: Boolean;
Begin
	If Not AllowZoomRect Then Exit;
	Steps:=Abs(R1.X1-R2.X1)+Abs(R1.X2-R2.X2)+
		Abs(R1.Y1-R2.Y1)+Abs(R1.Y2-R2.Y2);
	Steps:=Steps Div (ScrY Div 3)+18;
	Ini.Select('polit.ini', 'Graphics');
	ZoomSpeed:=Ini.GetInt('ZoomSpeed', 50);
	If ZoomSpeed=-1 Then Exit;
	D.ToRange(ZoomSpeed, 0, 10);
	ZoomDelay:=(10-ZoomSpeed)*D.MachineSpeed Div 2;
	StopAnimsOnMouse:=Ini.GetBool('StopAnimsOnMouse', True);

	DX1:=(R2.X1-R1.X1)/Steps;
	DX2:=(R2.X2-R1.X2)/Steps;
	DY1:=(R2.Y1-R1.Y1)/Steps;
	DY2:=(R2.Y2-R1.Y2)/Steps;

	Last:=R1;
	X1:=R1.X1+DX1;
	X2:=R1.X2+DX2;
	Y1:=R1.Y1+DY1;
	Y2:=R1.Y2+DY2;

	InvertFrame(R1.X1, R1.Y1, R1.X2, R1.Y2);
	InvertFrame(Round(X1), Round(Y1), Round(X2), Round(Y2));

	For I:=2 To Steps Do
	Begin
		InvertFrame(Last.X1, Last.Y1, Last.X2, Last.Y2);

		Last.X1:=Round(X1);
		Last.X2:=Round(X2);
		Last.Y1:=Round(Y1);
		Last.Y2:=Round(Y2);

		X1:=X1+DX1;
		X2:=X2+DX2;
		Y1:=Y1+DY1;
		Y2:=Y2+DY2;

		InvertFrame(Round(X1), Round(Y1), Round(X2), Round(Y2));
		For Dl:=0 To ZoomDelay Do
			Temp:=Sin(Dl);

		If StopAnimsOnMouse Then
		Begin
			Mouse.GetDXDY(MouseDX, MouseDY);
			If (MouseDX<>0) Or (MouseDY<>0) {Or (Mouse.GetMask<>Mouse.mbNone)} Or
				BCRT.KeyPressed Then
				Break
		End
	End;
	InvertFrame(Last.X1, Last.Y1, Last.X2, Last.Y2);
	InvertFrame(Round(X1), Round(Y1), Round(X2), Round(Y2))
End;


Procedure PutSpriteGrayed256(X,Y:Integer; P:Pointer);
Var
	AX, AY, Width, Lightness: Integer;
	Color: Byte;
Begin
	Width:=ImageX(P);
	For AY:=0 To ImageY(P)-1 Do
		For AX:=0 To Width-1 Do
		Begin
			Color:=TMatrix(P^)[4+AY*Width+AX];
			If Color<>0 Then
			Begin
				Lightness:=Palette[Color].R+Palette[Color].G+Palette[Color].B;
				SGraph.PutPixel(X+AX, Y+AY, 240+(Lightness Div 48))
			End
		End
End;

Procedure PutSpriteGrayed16(X,Y:Integer; P:Pointer);
Var
	AX, AY, Width: Integer;
Begin
	PutTranspSprite(X, Y, 50, P);
	{PutSpriteGrayed256(X, Y, P);}
	{Width:=ImageX(P);
	For AY:=0 To ImageY(P)-1 Do
		For AX:=0 To Width-1 Do
			If TMatrix(P^)[4+AY*Width+AX] In [1, 2, 3, 4, 5, 6, 8, 16]
				Then SGraph.PutPixel(X+AX, Y+AY, clGray)}
End;

Procedure PutImageX8(X,Y:Integer; P:Pointer);
Var
	AX, AY, Width: Integer;
Begin
	Width:=ImageX(P);
	For AY:=0 To ImageY(P)-1 Do
		For AX:=0 To Width-1 Do
		Begin
			SGraph.SetColor(TMatrix(P^)[4+AY*Width+AX]);
			SGraph.Bar(X+AX Shl 3, Y+AY Shl 3, X+AX Shl 3+7, Y+AY Shl 3+7)
		End
End;

Procedure PutSpriteX8(X,Y:Integer; P:Pointer);
Var
	AX, AY, Width: Integer;
Begin
	Width:=ImageX(P);
	For AY:=0 To ImageY(P)-1 Do
		For AX:=0 To Width-1 Do
			If TMatrix(P^)[4+AY*Width+AX]<>0 Then
			Begin
				SGraph.SetColor(TMatrix(P^)[4+AY*Width+AX]);
				SGraph.Bar(X+AX Shl 3, Y+AY Shl 3, X+AX Shl 3+7, Y+AY Shl 3+7)
			End
End;


Procedure ShadowPixel(X,Y:Integer);
Begin
	SGraph.PutPixel(X, Y, ShadowTable[SGraph.GetPixel(X,Y)])
End;

Procedure ShadowBar(X1,Y1,X2,Y2:Integer);
Var
	X, Y: Integer;
Begin
	For Y:=Y1 To Y2 Do
		For X:=X1 To X2 Do
			ShadowPixel(X, Y)
End;

Procedure PutSpriteShadow(X1,Y1,Depth:Integer; P:Pointer);
Const
	TranspColor=0;
Var
	X, Y: Integer;
	Width: Integer;
Begin
	SGraph.PutSprite(X1, Y1, P);
	Width:=TMatrix2(P^)[0];
	For Y:=Depth To TMatrix2(P^)[1]-1 Do
		For X:=Depth To Width-1 Do
			If (TMatrix(P^)[4+Y*Width+X]=TranspColor) And
				(TMatrix(P^)[4+(Y-Depth)*Width+(X-Depth)]<>TranspColor) Then
				ShadowPixel(X1+X, Y1+Y);
	For X:=Width To Width+Depth-1 Do
		For Y:=Depth To TMatrix2(P^)[1]-1 Do
			If TMatrix(P^)[4+(Y-Depth)*Width+(X-Depth)]<>TranspColor Then
				ShadowPixel(X1+X, Y1+Y);
	For Y:=TMatrix2(P^)[1] To TMatrix2(P^)[1]+Depth-1 Do
		For X:=Depth To Width+Depth-1 Do
			If TMatrix(P^)[4+(Y-Depth)*Width+(X-Depth)]<>TranspColor Then
				ShadowPixel(X1+X, Y1+Y);
End;

Procedure BoxShadow(X1,Y1,X2,Y2,Depth:Integer);
Begin
	ShadowBar(X1+Depth, Y2+1, X2+Depth, Y2+Depth);
	ShadowBar(X2+1, Y1+Depth, X2+Depth, Y2)
End;

Procedure BoxShadowSoft(X1,Y1,X2,Y2,Depth:Integer);
Var
	N: Integer;
	Transp, TranspStep: Integer;
Begin
	TranspStep:=60 Div Depth;
	Transp:=60;
	For N:=1 To Depth Do
	Begin
		TranspBar(X1+Depth*2-N, Y2+N, X2+N, Y2+N, clBlack, Transp);
		TranspBar(X2+N, Y1+Depth*2-N, X2+N, Y2+N-1, clBlack, Transp);
		If N>1 Then
		Begin
			TranspBar(X1+Depth*2-N, Y2+1, X1+Depth*2-N, Y2+N-1, clBlack, Transp);
			TranspBar(X2+1, Y1+Depth*2-N, X2+N-1, Y1+Depth*2-N, clBlack, Transp)
		End;
		Dec(Transp, TranspStep)
	End
End;

Procedure CheckerBar(X1,Y1,X2,Y2:Integer; Color:TColor);
Var
	X, Y: Integer;
	Flag:Boolean;
Begin
	For Y:=Y1 To Y2 Do
	Begin
		Flag:=Odd(Y);
		For X:=X1 To X2 Do
		Begin
			If Flag Then
				PutPixel(X, Y, Color);
			Flag:=Not Flag
		End
	End
End;



Procedure MakeEmptyImage(Var P:Pointer);
Begin
	GetMem(P, 5);
	TMatrix(P^)[0]:=1;
	TMatrix(P^)[1]:=0;
	TMatrix(P^)[2]:=1;
	TMatrix(P^)[3]:=0;
	TMatrix(P^)[4]:=0
End;

Procedure SplitSkin3(Var OrigP:Pointer; Var Target:TSkinPic);
Var
	Width, Height: Integer;
Begin
	Width:=ImageX(OrigP) Div 3;
	Height:=ImageY(OrigP);
	If (Width=0) And (Height=1) Then
	Begin { looks like MakeEmptyImage result :) }
		MakeEmptyImage(Target[True, False]);
		MakeEmptyImage(Target[False, False]);
		MakeEmptyImage(Target[True, True])
	End
	Else Begin
		GetMem(Target[True, False], ImageSize(Width, Height));
		SGraph.VirtGetImage(0, 0, Width-1, Height-1, Target[True, False], OrigP);
		GetMem(Target[False, False], ImageSize(Width, Height));
		SGraph.VirtGetImage(Width, 0, Width*2-1, Height-1, Target[False, False], OrigP);
		GetMem(Target[True, True], ImageSize(Width, Height));
		SGraph.VirtGetImage(Width*2, 0, Width*3-1, Height-1, Target[True, True], OrigP)
	End;
	Target[False, True]:=Target[False, False];
	FreeImage(OrigP)
End;

Procedure SplitSkin4(Var OrigP:Pointer; Var Target:TSkinPic);
Var
	Width, Height: Integer;
Begin
	Width:=ImageX(OrigP) Div 4;
	Height:=ImageY(OrigP);
	If (Width=0) And (Height=1) Then
	Begin { looks like MakeEmptyImage result :) }
		MakeEmptyImage(Target[True, False]);
		MakeEmptyImage(Target[False, False]);
		MakeEmptyImage(Target[True, True]);
		MakeEmptyImage(Target[False, True])
	End
	Else Begin
		GetMem(Target[True, False], ImageSize(Width, Height));
		SGraph.VirtGetImage(0, 0, Width-1, Height-1, Target[True, False], OrigP);
		GetMem(Target[False, False], ImageSize(Width, Height));
		SGraph.VirtGetImage(Width, 0, Width*2-1, Height-1, Target[False, False], OrigP);
		GetMem(Target[True, True], ImageSize(Width, Height));
		SGraph.VirtGetImage(Width*2, 0, Width*3-1, Height-1, Target[True, True], OrigP);
		GetMem(Target[False, True], ImageSize(Width, Height));
		SGraph.VirtGetImage(Width*3, 0, Width*4-1, Height-1, Target[False, True], OrigP)
	End;
	FreeImage(OrigP)
End;


Procedure FreeSkin3(Var Skin:TSkinPic);
Begin
	FreeImage(Skin[True, False]);
	FreeImage(Skin[False, False]);
	FreeImage(Skin[True, True])
End;

Procedure FreeSkin4(Var Skin:TSkinPic);
Begin
	FreeImage(Skin[True, False]);
	FreeImage(Skin[False, False]);
	FreeImage(Skin[True, True]);
	FreeImage(Skin[False, True])
End;




Procedure SteelBar(X1,Y1,X2,Y2,Darkness:Integer); { darkness=56/70 }
Const
	MaxStep=21;
	UniRandomBool: Array[0..23] Of Boolean=
		(True, True, True, False, True, False, False, True,
		True, False, True, False, True, True, False, False,
		False, True, False, False, True, False, True, False);
	UniRandomLen: Array[0..20] Of Integer=
		(14, 23, 17, 12, 25, 9, 20, 15, 11, 24, 8, 21, 22, 13, 16, 19,
		 10, 7, 27, 18, 26);
	UniRandomColor: Array[0..19] Of Integer=
		(1, -2, 1, 2, 0, 0, -1, 2, -2, 0, 1, 0, -1, 2, 1, -2, 2, -1, -2, -1);
Var
	Color1, Color2, Color0, Y, X, NextX, DX, CurColor, J: Integer;
Begin
	If X2<X1 Then Exit; { slided panel }
	Color0:=(Darkness*32 Div 100)+224;
	Color1:=D.Max(Color0-2, 224);
	Color2:=D.Min(Color0+2, 255);
	J:=0;
	For Y:=Y1 To Y2 Do
	Begin
		X:=X1;
		{CurColor:=Color1+Random(Color2-Color1+1);}
		{CurColor:=Color1+((X+Y) Mod (Color2-Color1+1));}
		CurColor:=Color0+UniRandomColor[(X+Y) Mod 20];
		Repeat
			{NextX:=D.Min(X+Random(MaxStep), X2);}
			{NextX:=D.Min(X+((X+Y) Mod MaxStep), X2);}
			NextX:=D.Min(X+UniRandomLen[J], X2);
			D.Cycle(J, 0, 20);
			If CurColor=Color1
				Then Inc(CurColor)
				Else If CurColor=Color2
					Then Dec(CurColor)
					Else If {Random(2)=0} {Odd(X+Y)} UniRandomBool[(X+Y) Mod 24]
						Then Dec(CurColor)
						Else Inc(CurColor);
			Line(X, Y, NextX, Y, CurColor);
			{TranspBar(X, Y, NextX, Y, CurColor, 80);}
			X:=NextX+1
		Until X>X2;
		{BCRT.Delay(7);} { to optimize for speed }
	End
End;

Procedure SteelBarMimic(X1,Y1,X2,Y2:Integer; MimicDir:TMimicDir);
Const
	MaxStep=21;
Var
	Color2, Y, X, NextX, DX, CurColor: Integer;
Begin
	If X2<X1 Then Exit; { slided panel }
	If MimicDir=mdRandom Then
		If Random(2)=0
			Then MimicDir:=mdLeft
			Else MimicDir:=mdRight;
	For Y:=Y1 To Y2 Do
	Begin
		CurColor:=GetPixel(X1-1, Y);
		Color2:=GetPixel(X2+1, Y);
		If Not D.InRange(Color2, 232, 255) Then
			Color2:=CurColor;
		If Not D.InRange(CurColor, 232, 255) Then
			CurColor:=Color2;
		X:=X1;
		If X2-X1>=MaxStep
			Then Repeat
				NextX:=D.Min(X+Random(MaxStep), X2);
				If Abs(CurColor-Color2)>1
					Then Inc(CurColor, D.Sgn(Color2-CurColor))
					Else If Random(2)=0
						Then Dec(CurColor)
						Else Inc(CurColor);
				Line(X, Y, NextX, Y, CurColor);
				{TranspBar(X, Y, NextX, Y, CurColor, 80);}
				X:=NextX+1
			Until X>X2
			Else Case MimicDir Of
				mdLeft: Line(X1, Y, X2, Y, CurColor);
				mdRight: Line(X1, Y, X2, Y, Color2)
			End
	End
End;

Procedure StoneBar(X1,Y1,X2,Y2,Darkness:Integer);
Var
	Color1, Color2, CurColor, I: Integer;
	Procedure AlterColor;
	Begin
		If CurColor=Color1
			Then Inc(CurColor)
			Else If CurColor=Color2
				Then Dec(CurColor)
				Else Case Random(21) Of
					1: Dec(CurColor);
					2: Inc(CurColor)
				End
	End;
Begin
	Color1:=D.Max((Darkness*32 Div 100)+224-2, 224);
	Color2:=D.Min((Darkness*32 Div 100)+224+2, 255);
	If (X2-X1)>(Y2-Y1) Then
	Begin { Horizontal }
		CurColor:=Color1+Random(Color2-Color1+1);
		For I:=0 To Y2-Y1 Do
		Begin
			Line(X1, Y1+I, X1+I, Y1, CurColor);
			AlterColor
		End;
		For I:=X1+(Y2-Y1) To X2 Do
		Begin
			Line(I, Y1, I-(Y2-Y1), Y2, CurColor);
			AlterColor
		End;
		For I:=1 To Y2-Y1 Do
		Begin
			Line(X2-(Y2-Y1)+I, Y2, X2, Y1+I, CurColor);
			AlterColor
		End
	End

End;



Procedure AgedBar(X1,Y1,X2,Y2: Integer; ClrEdge,ClrFill:TColor);
Const
	ColorTab: Array[0..6] Of TColor=(106, 107, 84, 203, 204, 179, 180);
Var
	X, Y: Integer;
	I: Integer;
Begin
	If X2<X1 Then Exit; { slided panel }
	Bar(X1+2, Y1+2, X2-2, Y2-2, ClrFill);
	For X:=X1+2 To X2-2 Do
		If Random(2)=0 Then
		Begin
			PutPixel(X, Y1, ClrEdge);
			PutPixel(X, Y1+1, ClrFill);
			PutPixel(X, Y2-1, ClrEdge)
		End
		Else Begin
			PutPixel(X, Y1+1, ClrEdge);
			PutPixel(X, Y2-1, ClrFill);
			PutPixel(X, Y2, ClrEdge)
		End;
	For Y:=Y1+2 To Y2-2 Do
		If Random(2)=0 Then
		Begin
			PutPixel(X1, Y, ClrEdge);
			PutPixel(X1+1, Y, ClrFill);
			PutPixel(X2-1, Y, ClrEdge)
		End
		Else Begin
			PutPixel(X1+1, Y, ClrEdge);
			PutPixel(X2-1, Y, ClrFill);
			PutPixel(X2, Y, ClrEdge)
		End;
	PutPixel(X1+1, Y1+1, ClrEdge);
	PutPixel(X1+1, Y2-1, ClrEdge);
	PutPixel(X2-1, Y1+1, ClrEdge);
	PutPixel(X2-1, Y2-1, ClrEdge);

	For I:=1 To LongInt(X2-X1)*LongInt(Y2-Y1) Div 7 Do
		PutPixel(X1+2+Random(X2-X1-3), Y1+2+Random(Y2-Y1-3),
			ColorTab[Random(7)])
End;

Procedure StripedBar(X1,Y1,X2,Y2,Darkness:Integer);
Const
	MaxStep=21;
Var
	Y, MidColor: Integer;
Begin
	If X2<X1 Then Exit; { slided panel }
	MidColor:=(Darkness*32 Div 100)+224;
	D.ToRange(MidColor, 225, 254);
	For Y:=Y1 To Y2 Do
		Case Y Mod 4 Of
			0: Line(X1, Y, X2, Y, MidColor+1);
			1, 3: Line(X1, Y, X2, Y, MidColor);
			2: Line(X1, Y, X2, Y, MidColor-1)
		End
End;

Procedure StripedBarMimic(X1,Y1,X2,Y2:Integer; MimicDir:TMimicDir);
Const
	MaxStep=21;
Var
	Y, MidColor: Integer;
Begin
	If MimicDir=mdLeft
		Then MidColor:=GetPixel(X1-1, (Y1 Div 4)*4+1)
		Else MidColor:=GetPixel(X2+1, (Y1 Div 4)*4+1);
	D.ToRange(MidColor, 225, 254);
	For Y:=Y1 To Y2 Do
		Case Y Mod 4 Of
			0: Line(X1, Y, X2, Y, MidColor+1);
			1, 3: Line(X1, Y, X2, Y, MidColor);
			2: Line(X1, Y, X2, Y, MidColor-1)
		End
End;





Procedure SkinBar(X1,Y1,X2:Integer; PicL,PicR:Pointer);
Var
	TX1, TX2, Y: Integer;
Begin
	TX1:=X1+ImageX(PicL);
	TX2:=X2-ImageX(PicR);
	PutSprite(X1, Y1, PicL);
	PutSprite(TX2+1, Y1, PicR);
	For Y:=Y1 To Y1+ImageY(PicL)-1 Do
		Line(TX1, Y, TX2, Y, GetPixel(TX1-1, Y))
End;

Procedure SkinBarVer(X1,Y1,Y2:Integer; PicU,PicD:Pointer);
Var
	TY1, TY2, X: Integer;
Begin
	TY1:=Y1+ImageY(PicU);
	TY2:=Y2-ImageY(PicD);
	PutSprite(X1, Y1, PicU);
	PutSprite(X1, TY2+1, PicD);
	For X:=X1 To X1+ImageX(PicU)-1 Do
		Line(X, TY1, X, TY2, GetPixel(X, TY1-1))
End;

Procedure SkinBarTiled(X1,Y1,X2:Integer; PicL,PicM,PicR:Pointer);
Var
	WL, WM, WR, X, N: Integer;
	TempP: Pointer;
Begin
	WL:=ImageX(PicL);
	WM:=ImageX(PicM);
	WR:=ImageX(PicR);
	PutSprite(X1, Y1, PicL);
	X:=X1+WL;
	For N:=1 To (X2-X1+1-WL-WR) Div WM Do
	Begin
		PutImage(X, Y1, PicM);
		Inc(X, WM)
	End;
	If X<(X2-WR+1) Then
	Begin
		GetImagePlus(X-WM, Y1, X2-WR-WM, Y1+ImageY(PicM)-1, TempP);
		PutImage(X, Y1, TempP);
		FreeImage(TempP)
	End;
	PutSprite(X2-WR+1, Y1, PicR)
End;



Procedure HorGradBar(X1,Y1,X2,Y2:Integer; C1,C2:TColor);
Var
	X, Y: Integer;
	R, G, B, C, DR, DG, DB: Integer;
	ConstR1, ConstG1, ConstB1: Integer;
	ConstR2, ConstG2, ConstB2: Real;
Begin
	DR:=0;
	DG:=0;
	DB:=0;
	ConstR1:=Palette[C1].R*4;
	ConstG1:=Palette[C1].G*4;
	ConstB1:=Palette[C1].B*4;
	ConstR2:=(Palette[C2].R*4-Palette[C1].R*4+1)/(X2-X1+1);
	ConstG2:=(Palette[C2].G*4-Palette[C1].G*4+1)/(X2-X1+1);
	ConstB2:=(Palette[C2].B*4-Palette[C1].B*4+1)/(X2-X1+1);
	For Y:=Y1 To Y2 Do
	Begin
		R:=Palette[C1].R*4;
		G:=Palette[C1].G*4;
		B:=Palette[C1].B*4;
		C:=C1;
		For X:=X1 To X2-1 Do
		Begin
			PutPixel(X, Y, C);
			{R:=Palette[C1].R+Round((Palette[C2].R-Palette[C1].R+1)/(Y2-Y1+1)*(Y-Y1))+DR;
			G:=Palette[C1].G+Round((Palette[C2].G-Palette[C1].G+1)/(Y2-Y1+1)*(Y-Y1))+DG;
			B:=Palette[C1].B+Round((Palette[C2].B-Palette[C1].B+1)/(Y2-Y1+1)*(Y-Y1))+DB;}
			R:=ConstR1+Round(ConstR2*(X-X1))+DR;
			G:=ConstG1+Round(ConstG2*(X-X1))+DG;
			B:=ConstB1+Round(ConstB2*(X-X1))+DB;
			D.ToRange(R, 0, 255);
			D.ToRange(G, 0, 255);
			D.ToRange(B, 0, 255);
			C:=RGB2Pal[R Div 16, G Div 16, B Div 16];
			DR:=R-Palette[C].R*4;
			DG:=G-Palette[C].G*4;
			DB:=B-Palette[C].B*4
		End;
		PutPixel(X2, Y, C)
	End;
End;

Procedure VerGradBar(X1,Y1,X2,Y2:Integer; C1,C2:TColor);
Var
	X, Y: Integer;
	R, G, B, C, DR, DG, DB: Integer;
Begin
	DR:=0;
	DG:=0;
	DB:=0;
	For X:=X1 To X2 Do
	Begin
		R:=Palette[C1].R*4;
		G:=Palette[C1].G*4;
		B:=Palette[C1].B*4;
		C:=C1;
		For Y:=Y1 To Y2-1 Do
		Begin
			PutPixel(X, Y, C);
			R:=Palette[C1].R*4+Round((Palette[C2].R*4-Palette[C1].R*4+1)/(Y2-Y1+1)*(Y-Y1))+DR;
			G:=Palette[C1].G*4+Round((Palette[C2].G*4-Palette[C1].G*4+1)/(Y2-Y1+1)*(Y-Y1))+DG;
			B:=Palette[C1].B*4+Round((Palette[C2].B*4-Palette[C1].B*4+1)/(Y2-Y1+1)*(Y-Y1))+DB;
			D.ToRange(R, 0, 255);
			D.ToRange(G, 0, 255);
			D.ToRange(B, 0, 255);
			C:=RGB2Pal[R Div 16, G Div 16, B Div 16];
			DR:=R-Palette[C].R*4;
			DG:=G-Palette[C].G*4;
			DB:=B-Palette[C].B*4
		End;
		PutPixel(X, Y2, C)
	End;
End;

Procedure DitherBar(X1,Y1,X2,Y2:Integer; R,G,B:Byte);
Const
	LinesInBlock=7;
Var
	X, Y, N: Integer;
	TR, TG, TB, C: Integer;
	ErrR, ErrG, ErrB: Integer;
	P: Pointer;

	Procedure DitherLine(LY:Integer);
	Var
		X: Integer;
	Begin
		For X:=X1 To X2 Do
		Begin
			TR:=R+ErrR;
			TG:=G+ErrG;
			TB:=B+ErrB;
			D.ToRange(TR, 0, 255);
			D.ToRange(TG, 0, 255);
			D.ToRange(TB, 0, 255);
			C:=RGB2Pal[TR Shr 4, TG Shr 4, TB Shr 4];
			ErrR:=TR-Gfx.Palette[C].R Shl 2;
			ErrG:=TG-Gfx.Palette[C].G Shl 2;
			ErrB:=TB-Gfx.Palette[C].B Shl 2;
			SGraph.PutPixel(X, LY, C)
		End
	End;

Begin
	ErrR:=0;
	ErrG:=0;
	ErrB:=0;
	If (Y2-Y1+1)>LinesInBlock Then
	Begin { 鮡 袨 , 㤥    }
			{ 1.  i LinesInBlock 浪i }
		For Y:=Y1 To Y1+LinesInBlock-1 Do
			DitherLine(Y);
		Y:=Y1+LinesInBlock;
			{ 2.  ॡ, ஧  PutImage' }
		If (Y2-Y1+1-LinesInBlock)>=1 Then
		Begin
			GetMem(P, ImageSize(X2-X1+1, LinesInBlock));
			GetImage(X1, Y1, X2, Y1+LinesInBlock-1, P);
			For N:=1 To (Y2-Y1+1-LinesInBlock) Div LinesInBlock Do
			Begin
				PutImage(X1, Y, P);
				Inc(Y, LinesInBlock)
			End;
			FreeImage(P)
		End;
			{ 3.  讪 ii }
		For N:=Y To Y2 Do
			DitherLine(N)
	End
	Else For Y:=Y1 To Y2 Do
		DitherLine(Y)
End;





Procedure FadeDownPal;
Var
	TempPal: TPalette;
	I, Dl: Integer;
	Temp: Real;
	FadeSpeed, FadeDelay: Integer;
	MouseDX, MouseDY: Integer;
	StopAnimsOnMouse: Boolean;
Begin
	Ini.Select('polit.ini', 'Graphics');
	FadeSpeed:=Ini.GetInt('FadeSpeed', 5);
	If FadeSpeed=-1 Then
	Begin
		BlackPal;
		Exit
	End;
	D.ToRange(FadeSpeed, 0, 10);
	FadeDelay:=(10-FadeSpeed)*D.MachineSpeed;
	StopAnimsOnMouse:=Ini.GetBool('StopAnimsOnMouse', True);

	TempPal:=Palette;
	For I:=0 To 31 Do
	Begin
		SGraph.FadeDown(@TempPal, 2);
		SGraph.SetAllPalette(@TempPal);
		For Dl:=1 To FadeDelay Do
			Temp:=Sin(Dl);
		If StopAnimsOnMouse Then
		Begin
			Mouse.GetDXDY(MouseDX, MouseDY);
			If (MouseDX<>0) Or (MouseDY<>0) Or (Mouse.GetMask<>Mouse.mbNone) Or
				BCRT.KeyPressed Then
				Break
		End
	End;
	BlackPal
End;

Procedure FadeUpPal;
Var
	TempPal: TPalette;
	I, I1, J, Dl: Integer;
	Temp: Real;
	FadeSpeed, FadeDelay: Integer;
	MouseDX, MouseDY: Integer;
	StopAnimsOnMouse: Boolean;
Begin
	Ini.Select('polit.ini', 'Graphics');
	FadeSpeed:=Ini.GetInt('FadeSpeed', 5);
	If FadeSpeed=-1 Then
	Begin
		ReloadPal;
		Exit
	End;
	D.ToRange(FadeSpeed, 0, 10);
	FadeDelay:=(10-FadeSpeed)*D.MachineSpeed;
	StopAnimsOnMouse:=Ini.GetBool('StopAnimsOnMouse', True);

	For I:=31 DownTo 0 Do
	Begin
		I1:=I+I;
		TempPal:=Palette;
		For J:=0 To 255 Do
		Begin
			If TempPal[J].R>I1
				Then Dec(TempPal[J].R, I1)
				Else TempPal[J].R:=0;
			If TempPal[J].G>I1
				Then Dec(TempPal[J].G, I1)
				Else TempPal[J].G:=0;
			If TempPal[J].B>I1
				Then Dec(TempPal[J].B, I1)
				Else TempPal[J].B:=0
		End;
		SGraph.SetAllPalette(@TempPal);
		For Dl:=1 To FadeDelay Do
			Temp:=Sin(Dl);

		If StopAnimsOnMouse Then
		Begin
			Mouse.GetDXDY(MouseDX, MouseDY);
			If (MouseDX<>0) Or (MouseDY<>0) Or (Mouse.GetMask<>Mouse.mbNone) Or
				BCRT.KeyPressed Then
				Break
		End
	End;
	ReloadPal
End;

Procedure ApplyBrightCont(Brightness, Contrast: Integer);
Var
	V: Byte;
	Temp:Integer;

	Procedure ApplyContrast(Var C:Byte);
	Begin
		Temp:=C;
		Temp:=Round((Temp-32)*Contrast/5)+32;
		D.ToRange(Temp, 0, 63);
		C:=Temp
	End;
	Procedure ApplyBrightness(Var C:Byte);
	Begin
		Temp:=C+Brightness*5;
		D.ToRange(Temp, 0, 63);
		C:=Temp
	End;
	Procedure ProcessOneByte(Var C:Byte);
	Begin
		{ApplyContrast(C);
		ApplyBrightness(C)}
		Temp:=C;
		Temp:=Round((Temp-32)*Contrast/5)+32;
		Inc(Temp, Brightness*5);
		D.ToRange(Temp, 0, 63);
		C:=Temp
	End;
Begin
	For V:=0 To 255 Do
	Begin
		ProcessOneByte(Palette[V].R);
		ProcessOneByte(Palette[V].G);
		ProcessOneByte(Palette[V].B);
	End;
	ReloadPal
End;

Procedure BlackPal;
Var
	TempPal:TPalette;
	I:Integer;
Begin
	For I:=0 To 255 Do
	Begin
		TempPal[I].R:=0;
		TempPal[I].G:=0;
		TempPal[I].B:=0
	End;
	SGraph.SetAllPalette(@TempPal)
End;

Procedure ReloadPal;
Begin
	SGraph.SetAllPalette(@Palette);
	{MakeShadowTable}
End;

Procedure SetPalColor(Color,R,G,B:Integer);
Begin
	Sgraph.SetRGBPalette(Color, (R+1) Div 4, (G+1) Div 4, (B+1) Div 4)
End;

Procedure LoadPal(FName:String; Var Palette:TPalette);
Var
	F: Text;
	I: Integer;
Begin
	If Not D.FileExist(FName) Then
	Begin
		Log.ErrMsg('Gfx','Load','Palette file not found: '+FName);
		Log.ActMsg('Ignoring palette load request');
		Exit
	End;
	SGraph.GetAllPalette(@Palette);
	Assign(F,FName);
	Reset(F);
	I:=0;
	Repeat
		With Palette[I] Do
		Begin
			ReadLn(F, R, G, B);
			R:=R Div 4;
			G:=G Div 4;
			B:=B Div 4;
			If I<128 Then
			Begin {    㣠  i - ii  }
				Palette[255-I].R:=63-R;
				Palette[255-I].G:=63-G;
				Palette[255-I].B:=63-B
			End
		End;
		Inc(I)
	Until EOF(F) Or (I>255);
	Close(F);
	If I>256 Then
	Begin
		Log.ErrMsg('Gfx', 'Init', 'Palette file '+FName+' contains more than 256 colors.');
		Log.ActMsg('Ignoring other colors.')
	End;
	{MakeShadowTable}
End;

Procedure ChangePal(FName:String);
Var
	NewPal, TempPal: TPalette;
	I, K, Dl: Integer;
	Temp: Real;
	FadeSpeed, FadeDelay: Integer;
Begin
	Ini.Select('polit.ini', 'Graphics');
	FadeSpeed:=Ini.GetInt('FadeSpeed', 50);
	If FadeSpeed=-1 Then
	Begin
		LoadPal(FName, Palette);
		ReloadPal;
		Exit
	End;
	D.ToRange(FadeDelay, 0, 10);
	FadeDelay:=(10-FadeSpeed)*D.MachineSpeed;

	LoadPal(FName, NewPal);
	For I:=1 To 16 Do
	Begin
		For K:=0 To 255 Do
		Begin
			TempPal[K].R:=Palette[K].R+(NewPal[K].R-Palette[K].R)*I Div 16;
			TempPal[K].G:=Palette[K].G+(NewPal[K].G-Palette[K].G)*I Div 16;
			TempPal[K].B:=Palette[K].B+(NewPal[K].B-Palette[K].B)*I Div 16
		End;
		SGraph.SetAllPalette(@TempPal);
		For Dl:=1 To FadeDelay*2 Do
			Temp:=Sin(Dl)
	End;
	Palette:=NewPal;
	ReloadPal;
	MakeShadowTable;
	MakeRGB2Pal;
	CacheSize:=0;
	CacheCur:=0
End;








Procedure Init;
Var
	Temp:String;
	X,Y,BPP:Integer;
	Res:Word;
	F:Text;
	I:Integer;
Begin
	Log.SysMsg('Gfx','Init','Graphics init sequence started');
	Ini.Select('polit.ini', 'Graphics');

	X:=Ini.GetInt('X', 640);
	Y:=Ini.GetInt('Y', 480);
	BPP:=Ini.GetInt('BPP', 8);
	SetMode(X,Y,BPP);
	{AniDelay:=Ini.GetInt('AniDelay',900);
	FadeDelay:=Ini.GetInt('FadeDelay',1200);}
	If Ini.GetStr('ButtonCorners', 'Sharp')='ROUNDED'
		Then ButtonRectStyle:=brRounded
		Else ButtonRectStyle:=brSharp;

		{ Load & set palette }
	Temp:=Ini.GetStr('Palette', 'colors\polit.pal');
	If D.FileExist(Temp) Then
	Begin
		LoadPal(Temp, Palette);
		SGraph.SetAllPalette(@Palette);
		MakeShadowTable;
		MakeRGB2Pal
	End
	Else Begin
		Log.ErrMsg('Gfx','Init','Palette file not found: '+Temp);
		Log.ActMsg('Ignoring palette set request');
	End;

	Temp:=Ini.GetStr('ColorScheme', 'colors\default.ini');
	Ini.Load(Temp);
	Ini.SelectSec('Colors');
	DesktopColor:=Ini.GetInt('Desktop', clNavy);
	Ini.SelectFile('polit.ini');
	{ClearDesk}
	CacheSize:=0;
	CacheCur:=0;
	AllowZoomRect:=True
End;


Procedure Done;
Begin
	Log.SysMsg('Gfx','Init','Graphics shutdown sequence started');
	CloseGraph
End;

Begin
End.