{ ************ Header ************ }
Type
	THeader=Record
		Caption: PStr;
	End;

Procedure Header_Draw(Me:PControl);
Var
	TempStr: String;
	TempX: Integer;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;
	With Me^, Place, THeader(Data^) Do
	Begin
		Font.SetFont(Kernel.CurFont);
		TempStr:=Kernel.ShortenStr(String(Caption^), X2-X1+1);
		TempX:=X1+Font.Width(TempStr);
		Kernel.WindowBar(X1, Y1, X2, Y2, False, True);
		Gfx.Line(X1, Y1+10, X2, Y1+10, Kernel.ClrWinDarkBG);
		If TempX<X2 Then
			Gfx.Line(TempX, Y1+9, X2, Y1+9, Kernel.ClrTextCom);
		Font.Print(X1, Y1, Kernel.ClrTextCom, TempStr)
	End
End;

Procedure Header_Paint(Me:PControl; VX1, VY1, VX2:Integer);
Begin
	With Me^.Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY1+15, Me^.Place);
	Header_Draw(Me)
End;


Procedure Header_SetCaption(Me:PControl; VCaption:String);
Begin
	With Me^, THeader(Data^) Do
	Begin
		D.ReassignPStr(VCaption, Caption);
		If AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
			If (Me^.CanDraw Or Kernel.DontBother) And Visible Then
			Begin
				Kernel.BeginPaint(Place);
				Header_Draw(Me);
				Kernel.EndPaint
			End
	End
End;

Procedure Header_OnDestroy(Me:PControl);
Begin
	With Me^ Do
		D.FreePStr(THeader(Data^).Caption, 'Ctl - Header_Destroy');
	FreeMem(Me^.Data, SizeOf(THeader))
End;

Function Header_Create(Prog:PProg; VCaption:String): PControl;
Var
	Me:PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
	GetMem(Me^.Data, SizeOf(THeader));
	With Me^ Do
	Begin
		OnDestroy:=Header_OnDestroy;
		Enabled:=False;

		With THeader(Data^) Do
			D.AssignPStr(VCaption, Caption)
	End;
	Header_Create:=Me
End;
