{$F+}
Unit
	Help; { Polit Halcyon Help application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Ctl3, Popup, DOS;

Type
	THelpData=Record
		MnuTopic: PMenuItem;
		PbtTopic, HtmContent: PControl;
		ProgName: Array[1..50] Of Record
			Name, FriendlyName: PStr
		End;
		ProgNameNum: Integer;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, THelpData(Data^) Do
	Begin
		Ctl.PopupBtn_Paint(PbtTopic, 5, 5, X2-X1-5);
		Ctl3.HTML_Paint(HtmContent, 5, 32, X2-X1-5, Y2-Y1-5);
	End;
End;

Procedure OnClose(Me:PProg);
Begin
	FreeMem(Me^.Data, SizeOf(THelpData))
End;

Function FindProgByFriendlyName(Me:PProg; VFName:String): Integer;
Var
	I: Integer;
Begin
	With Me^, THelpData(Data^) Do
	Begin
		FindProgByFriendlyName:=0;
		For I:=1 To ProgNameNum Do
			If String(ProgName[I].FriendlyName^)=VFName Then
				FindProgByFriendlyName:=I
	End
End;

Function FindProgByName(Me:PProg; VName:String): Integer;
Var
	I: Integer;
Begin
	With Me^, THelpData(Data^) Do
	Begin
		VName:=D.UpCaseLine(VName);
		FindProgByName:=0;
		For I:=1 To ProgNameNum Do
			If String(ProgName[I].Name^)=VName Then
				FindProgByName:=I
	End
End;

Function OnMessage(Me, Sender:PProg; VMsg:String; VData:Pointer): Pointer;
Var
	TempName, ButtonName: String;
	N: Integer;
Begin
	With Me^, THelpData(Data^) Do
	Begin
		If VMsg='OpenHelp' Then
		Begin
			{LFN.LFNGetShortPath(False, String(VData^), TempName);}
			TempName:=String(VData^);
			If Not D.FileExist('help\'+TempName+'.htm') Then TempName:='Polit';
			N:=FindProgByName(Me, TempName);
			If N=0
				Then ButtonName:=''
				Else ButtonName:=String(ProgName[N].FriendlyName^);
			Ctl.Button_SetCaption(Ctl.PopupBtn_AsButton(PbtTopic), ButtonName);
			Ctl3.HTML_LoadFile(HtmContent, 'help\'+String(TempName)+'.htm');
			D.ReassignPStr(TempName, Param)
		End;
	End
End;


Procedure OnTopicClick(Me:PProg; Item:PMenuItem);
Var
	N: Integer;
Begin
	With Me^, THelpData(Data^) Do
	Begin
		Ctl.Button_SetCaption(Ctl.PopupBtn_AsButton(PbtTopic),
			String(Item^.Name^));
		N:=FindProgByFriendlyName(Me, String(Item^.Name^));
		Ctl3.HTML_LoadFile(HtmContent, 'help\'+String(ProgName[N].Name^)+'.htm');
		D.ReassignPStr(String(ProgName[N].Name^), Param)
	End
End;



Procedure CreateTopicMenu(Me:PProg);
Var
	SR: SearchRec;
	TempBuiltIn: PBuiltIn;
	TempF: Text;
	TempS: String;
Begin
	With Me^, THelpData(Data^) Do
	Begin
		MnuTopic:=Popup.CreateMenu;
		ProgNameNum:=0;
		DOS.FindFirst('help\*.htm', AnyFile-Directory, SR);
		While DOS.DOSError=0 Do
		Begin
			Inc(ProgNameNum);
			D.AssignPStr(D.UpCaseLine(D.ClipFName(SR.Name)),
				ProgName[ProgNameNum].Name);
				{  யᠭ   ⥬  䠩i? }
			Assign(TempF, 'help\'+SR.Name);
			Reset(TempF);
			ReadLn(TempF, TempS);
			Close(TempF);
			If Copy(TempS, 1, 5)='<!-- '
				Then D.AssignPStr(Copy(TempS, 6, Length(TempS)-9),
					ProgName[ProgNameNum].FriendlyName)
				Else Begin { 㪠 । ⠭ ணࠬ }
					TempBuiltIn:=Kernel.FindBuiltIn(String(ProgName[ProgNameNum].Name^));
					If TempBuiltIn=Nil
						Then D.AssignPStr(String(ProgName[ProgNameNum].Name^),
							ProgName[ProgNameNum].FriendlyName)
						Else D.AssignPStr(String(TempBuiltIn^.FriendlyName^),
							ProgName[ProgNameNum].FriendlyName)
				End;

			Popup.AddCommand(MnuTopic, String(ProgName[ProgNameNum].FriendlyName^),
				'', '', Icon, True, OnTopicClick);
			DOS.FindNext(SR)
		End
	End
End;

Procedure OnInit(Me:PProg);
Var
	FName: String;
	ButtonName: String;
	N: Integer;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	Me^.OnMessage:=OnMessage;
	With Me^ Do
	Begin
		FName:=String(Param^);
		If Not D.FileExist('help\'+FName+'.htm') Then FName:='Polit';
		D.AssignPStr(D.LastPathItem(FName), WinTitle);

		D.AssignPStr('i筨', WinTitle);
		MinX:=270;
		MinY:=240;
		GetMem(Data, SizeOf(THelpData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With THelpData(Data^) Do
		Begin
				{ create menu }
			CreateTopicMenu(Me);
				{ create controls }
			N:=FindProgByName(Me, FName);
			If N=0
				Then ButtonName:=''
				Else ButtonName:=String(ProgName[N].FriendlyName^);
			PbtTopic:=Ctl.PopupBtn_Create(Me, ButtonName, MnuTopic, Icon, ppLeft);
			HtmContent:=Ctl3.HTML_Create(Me);
			Ctl3.HTML_LoadFile(HtmContent, 'help\'+FName+'.htm');
		End
	End
End;



Begin
	Kernel.RegBuiltIn('Help', 'i筨', 'pic\i_help.bmp', OnInit)
End.
