{ ******* PHASE 1 - LOAD FILE TO MEMORY | LL OK ******* }

Procedure OldLoadHTML(FName:String);
Var
	F: Text;
	TempStr: String;
	TempLine: PPtrList;
	N: Integer;
Begin
	Assign(F, FName);
	Reset(F);
	New(FirstSrcLine);
	D.AssignPStr('', FirstSrcLine^.Data);
	LastSrcLine:=FirstSrcLine;
	While Not EOF(F) Do
	Begin
		ReadLn(F, TempStr);
		N:=IOResult;
		If N<>0 Then
		Begin
			Log.BugMsg('HTML', 'LoadHTML', 'Error loading source lines: '+
				D.St(N)+'. Last source line:');
			Log.ActMsg(TempStr)
		End;
		D.TrimSpaces(TempStr);
		New(LastSrcLine^.Next);
		LastSrcLine:=LastSrcLine^.Next;
		D.AssignPStr(TempStr, LastSrcLine^.Data)
	End;
	LastSrcLine^.Next:=Nil;
	Close(F)
End;

Procedure LoadHTML(FName:String);
Const
	BufMaxSize=8192;
Var
	Buf: Pointer;
	BufPos, BufSize: Integer;
	F: File;
	C, LastC: Char;
	EndOfFile: Boolean;
	TempStr: String;

	Procedure LoadBuffer;
	Var
		TempSize: Integer;
	Begin
		Move(TMatrix(Buf^)[BufPos], Buf^, BufSize-BufPos);
		BlockRead(F, TMatrix(Buf^)[BufSize-BufPos], BufPos, TempSize);
		BufSize:=(BufSize-BufPos)+TempSize;
		BufPos:=0;
		If TempSize=0 Then EndOfFile:=True
	End;

	Function GetNextChar: Char;
	Begin
		GetNextChar:=Char(TMatrix(Buf^)[BufPos]);
		Inc(BufPos);
		If BufPos>=BufSize Then LoadBuffer
	End;

	Procedure StoreLine;
	Begin
		D.TrimSpaces(TempStr);
		New(LastSrcLine^.Next);
		LastSrcLine:=LastSrcLine^.Next;
		D.AssignPStr(TempStr, LastSrcLine^.Data)
	End;

Begin
	If MaxAvail<BufMaxSize Then
	Begin
		Log.ErrMsg('HTML', 'LoadHTML', 'Not enough memory to allocate buffer');
		Log.ActMsg('Ignoring load request :(');
		Exit
	End;

		{ 1. Allocate buffer }
	GetMem(Buf, BufMaxSize);
	Assign(F, FName);
	Reset(F, 1);
	BlockRead(F, Buf^, BufMaxSize, BufSize);
	BufPos:=0;
	LastC:=#0;
	EndOfFile:=False;
	TempStr:='';

	New(FirstSrcLine);
	D.AssignPStr('', FirstSrcLine^.Data);
	LastSrcLine:=FirstSrcLine;

		{ 2. Let's enter a main loop }
	Repeat
		C:=GetNextChar;
		If Not EndOfFile Then
			Case C Of
				#$0d, #$0a: Begin
					If (LastC In [#$0d, #$0a]) And (C<>LastC)
						Then C:=#0
						Else Begin
							StoreLine;
							TempStr:='';
						End
					End;
				' ': Begin
					If Length(TempStr)>200 Then
					Begin
						StoreLine;
						TempStr:=''
					End
					Else TempStr:=TempStr+C
				End;
				Else TempStr:=TempStr+C; { Ordinary character }
			End;
		LastC:=C
	Until EndOfFile;

	StoreLine;
	LastSrcLine^.Next:=Nil;
	Close(F);

		{ Free buffer }
	FreeMem(Buf, BufMaxSize);
End;


Procedure FreeSrcLines;
Var
	CurLine, NextLine: PPtrList;
Begin
	CurLine:=FirstSrcLine;
	While CurLine<>Nil Do
	Begin
		D.FreePStr(CurLine^.Data, 'HTML - FreeSrcLines');
		NextLine:=CurLine^.Next;
		Dispose(CurLine);
		CurLine:=NextLine
	End;
	FirstSrcLine:=Nil;
	LastSrcLine:=Nil
End;