{ ******* PHASE 2 - BREAK FILE TO CHUNKS ******* }

Var
	AddLeadingSpaceFlag: Boolean;

Procedure BreakToChunks;
Var
	CurChar: Integer;
	TempOut, TempS1, TempS2: String;
	V: Byte;
	InsideBrackets: Boolean;

	CurSrcLine: PPtrList;

	Function TrimLeadingSpaces(Var S:String): Boolean;
	Begin
		TrimLeadingSpaces:=False;
		While (Length(S)>=1) And (S[1] In [' ', #9, #255]) Do
		Begin
			Delete(S, 1, 1);
			TrimLeadingSpaces:=True
		End
	End;

	Function TrimTailingSpaces(Var S:String): Boolean;
	Begin
		TrimTailingSpaces:=False;
		While (Length(S)>=1) And (S[Length(S)] In [' ', #9, #255]) Do
		Begin
			Delete(S, Length(S), 1);
			TrimTailingSpaces:=True
		End
	End;



	Function GetTagOrText: String;
	Var
		TempStr, PreTempStr, ResStr: String;
		EndOfFile, LineTooLong: Boolean;
	Begin
		{Log.BugMsg('HTML', 'GetTagOrText', 'Entering...');}
		PreTempStr:=String(CurSrcLine^.Data^);
		{Log.BugMsg('HTML', 'GetTagOrText', 'Get PreTempStr: '+PretempStr);}
		D.TrimSpaces(PreTempStr);
		{Log.BugMsg('HTML', 'GetTagOrText', 'Trimmed spaces');}
		While (PreTempStr='') And (CurSrcLine<>Nil) Do
		Begin
			CurSrcLine:=CurSrcLine^.Next;
			If CurSrcLine<>Nil Then
			Begin { end of file }
				PreTempStr:=String(CurSrcLine^.Data^);
				D.TrimSpaces(PreTempStr)
			End
		End;
		{Log.BugMsg('HTML', 'GetTagOrText', 'Skipped possible empty lines');}
		If CurSrcLine=Nil Then
		Begin
			GetTagOrtext:='';
			Exit
		End;

		TempStr:=String(CurSrcLine^.Data^);
		TempStr:=Copy(TempStr, CurChar, Length(TempStr)-CurChar+1);
		ResStr:='';
		EndOfFile:=False;
		{Log.BugMsg('HTML', 'GetTagOrText', 'Re-got string, analysing');}
		If TempStr[1]='<' Then
		Begin { it's a tag }
			While (Pos('>', TempStr)=0) And Not EndOfFile Do
			Begin { tag have no end on this line }
				ResStr:=ResStr+TempStr+' ';
				CurSrcLine:=CurSrcLine^.Next;
				CurChar:=1;
				If CurSrcLine<>Nil
					Then TempStr:=String(CurSrcLine^.Data^)
					Else EndOfFile:=True
			End;
			If Not EndOfFile Then
			Begin
				ResStr:=ResStr+Copy(TempStr, 1, Pos('>', TempStr));
				CurChar:=CurChar+Pos('>', TempStr);
				If CurChar=Length(String(CurSrcLine^.Data^))+1 Then
				Begin
					CurSrcLine:=CurSrcLine^.Next;
					AddLeadingSpaceFlag:=True;
					CurChar:=1
				End
			End
		End
		Else Begin { it's a text }
			LineTooLong:=False;
			While (Pos('<', TempStr)=0) And (Not EndOfFile) And
				(Not LineTooLong) Do
			Begin { no tag starts on this line }
				ResStr:=ResStr+TempStr+' ';
				CurSrcLine:=CurSrcLine^.Next;
				CurChar:=1;
				If CurSrcLine<>Nil
					Then TempStr:=String(CurSrcLine^.Data^)
					Else EndOfFile:=True;
				If Length(ResStr)+Length(TempStr)+1>255 Then
					LineTooLong:=True
			End;
			If (Not EndOfFile) And (Not LineTooLong) Then
			Begin
				ResStr:=ResStr+Copy(TempStr, 1, Pos('<', TempStr)-1);
				CurChar:=CurChar+Pos('<', TempStr)-1
			End;
			{CustomTrimSpaces(ResStr);} { maybe bugs with spaces }
		End;
		GetTagOrText:=ResStr
	End;

	Procedure AddTagChunk(S:String);
	Begin
		Log.BugMsg('HTML', 'AddTagChunk', '"'+S+'"');
		If LastChunk=Nil Then
		Begin
			New(LastChunk);
			FirstChunk:=LastChunk
		End
		Else Begin
			New(LastChunk^.Next);
			LastChunk:=LastChunk^.Next
		End;
		LastChunk^.Next:=Nil;
		LastChunk^.Kind:=chTag;
		If S[1]='/' Then
		Begin { closing tag }
			LastChunk^.Tag:=D.UpCaseLine(Copy(S, 2, Length(S)-1));
			LastChunk^.Opening:=False
		End
		Else Begin { opening/default tag }
			LastChunk^.Tag:=D.UpCaseLine(S);
			LastChunk^.Opening:=True
		End;
		LastChunk^.FirstParam:=Nil
	End;

	Procedure AddTagChunkParam(S1,S2:String);
	Var
		TempParam: PParam;
	Begin
		With LastChunk^ Do
		Begin
			New(TempParam);
			TempParam^.Name:=D.UpCaseLine(S1);
			If S2[1]='"' Then Delete(S2, 1, 1);
			If S2[Length(S2)]='"' Then Delete(S2, Length(S2), 1);
			D.AssignPStr(D.UpCaseLine(S2), TempParam^.Value);
			If FirstParam<>Nil Then
			Begin
				TempParam^.Next:=FirstParam;
				FirstParam:=TempParam
			End
			Else Begin
				FirstParam:=TempParam;
				FirstParam^.Next:=Nil
			End
		End
	End;

	Procedure TranslateSpecChars(Var S:String);
	Var
		V: Byte;
		OnceAgain: Boolean;
	Begin
		Repeat
			OnceAgain:=False;

			V:=Pos('&nbsp;', S);
			If V>0 Then
			Begin
				Delete(S, V, 5);
				S[V]:=' ';
				OnceAgain:=True
			End;

			V:=Pos('&lt;', S);
			If V>0 Then
			Begin
				Delete(S, V, 3);
				S[V]:='<';
				OnceAgain:=True
			End;

			V:=Pos('&gt;', S);
			If V>0 Then
			Begin
				Delete(S, V, 3);
				S[V]:='>';
				OnceAgain:=True
			End;

			V:=Pos('&amp;', S);
			If V>0 Then
			Begin
				Delete(S, V, 4);
				S[V]:='&';
				OnceAgain:=True
			End;
			
		Until Not OnceAgain
		{ !!! repeat this loop for chars without ";" }
	End;

	Function EmptyString(S:String): Boolean;
	Var
		V: Byte;
	Begin
		EmptyString:=True;
		V:=1;
		While V<=Length(S) Do
			If Not (S[V] In [' ', #9, #255]) Then
			Begin
				EmptyString:=False;
				Exit
			End
			Else Inc(V)
	End;

	Procedure AddTextChunk(S:String);
	Begin
		Log.BugMsg('HTML', 'AddTextChunk', '"'+S+'"');
		If EmptyString(S) Then
		Begin
			Log.ActMsg('Empty string, ignoring');
			AddLeadingSpaceFlag:=True;
			Exit
		End;

		If LastChunk=Nil Then
		Begin
			New(LastChunk);
			FirstChunk:=LastChunk
		End
		Else Begin
			New(LastChunk^.Next);
			LastChunk:=LastChunk^.Next
		End;
		LastChunk^.Next:=Nil;
		LastChunk^.Kind:=chText;
		LastChunk^.SoftSpaces:=[];
		If TrimLeadingSpaces(S) Then
			LastChunk^.SoftSpaces:=LastChunk^.SoftSpaces+[ssLeading];
		If AddLeadingSpaceFlag Then
		Begin
			LastChunk^.SoftSpaces:=LastChunk^.SoftSpaces+[ssLeading];
			AddLeadingSpaceFlag:=False
		End;
		If TrimTailingSpaces(S) Then
			LastChunk^.SoftSpaces:=LastChunk^.SoftSpaces+[ssTailing];
		TranslateSpecChars(S);
		D.AssignPStr(S, LastChunk^.Text)
	End;

Begin
	Log.BugMsg('HTML', 'HTML_BreakToChunks', 'Entering...');
	CurSrcLine:=FirstSrcLine;
	CurChar:=1;
	AddLeadingSpaceFlag:=False;
	FirstChunk:=Nil;
	LastChunk:=Nil;
	Repeat
		{Log.BugMsg('HTML', 'BreakToChunks', 'Loop start...');}
		TempOut:=GetTagOrText;
		{Log.BugMsg('HTML', 'BreakToChunks', 'Got piece of text: '+TempOut);}
		If TempOut<>'' Then
			If TempOut[1]='<' Then
			Begin { Tag chunk }
				Log.BugMsg('HTML', 'BreakToChunks', 'Tag found: '+TempOut);
				TempOut:=Copy(TempOut, 2, Length(TempOut)-2); { remove < > }
				V:=Pos(' ', TempOut);
				If V>0 Then
				Begin { tag with parameters }
					{Log.BugMsg('HTML', 'BreakToChunks', 'Tag with parameters');}
					AddTagChunk(Copy(TempOut, 1, V-1));
					Delete(TempOut, 1, V);
						{ parse parameters }
					Repeat
						V:=1;
						TempS1:='';
						TempS2:='';
						InsideBrackets:=False;
						Repeat
							If (Not InsideBrackets) And (TempOut[V]='=') Then
							Begin
								TempS1:=Copy(TempOut, 1, V-1);
								Delete(TempOut, 1, V);
								V:=1
							End
							Else Begin
								If TempOut[V]='"' Then
									InsideBrackets:=Not InsideBrackets;
								Inc(V)
							End
						Until (V>Length(TempOut)) Or ((Not InsideBrackets) And (TempOut[V]=' '));
						TempS2:=Copy(TempOut, 1, V-1);
						Delete(TempOut, 1, V);
						If TempS1=''
							Then AddTagChunkParam(TempS2, '')
							Else AddTagChunkParam(TempS1, TempS2)
					Until TempOut=''
				End
				Else Begin { tag without parameters }
					{Log.BugMsg('HTML', 'BreakToChunks', 'Tag without parameters');}
					AddTagChunk(TempOut);
					{Log.BugMsg('HTML', 'BreakToChunks', 'Tag added');}
				End
			End
			Else Begin { Text chunk }
				AddTextChunk(TempOut)
			End;
		{Log.BugMsg('HTML', 'BreakToChunks', 'Before loop end...');}
	Until CurSrcLine=Nil;
	{Log.BugMsg('HTML', 'BreakToChunks', 'Main loop finished!');}
	LastChunk^.Next:=Nil;
	Log.BugMsg('HTML', 'HTML_BreakToChunks', 'Done!');
End;

Procedure FreeChunks;
Var
	CurChunk, NextChunk: PChunk;
	CurParam, NextParam: PParam;
Begin
	CurChunk:=FirstChunk;
	While CurChunk<>Nil Do
	Begin
		Case CurChunk^.Kind Of
			chTag: Begin
				CurParam:=CurChunk^.FirstParam;
				While CurParam<>Nil Do
				Begin
					D.FreePStr(CurParam^.Value, 'HTML - FreeChunks');
					NextParam:=CurParam^.Next;
					Dispose(CurParam);
					CurParam:=NextParam
				End
			End;
			chText: D.FreePStr(CurChunk^.Text, 'HTML - FreeChunks')
		End;
		NextChunk:=CurChunk^.Next;
		Dispose(CurChunk);
		CurChunk:=NextChunk
	End;
	FirstChunk:=Nil;
	LastChunk:=Nil
End;