{ ******* Character Formatting ******* }

{     ਭ樯 ⠪.

	楤 TagCharacterFormatting  i, i  쮣 ⨯
	⥣i.  ᠬ:
		 ⥣ iਢ
			i
				   ⥪
				"㢠" 
			I
				 i ⥪ i  i  
				"㢠" i ⥣ i 㯨 i  ⥪  設

	楤 ApplyTagCharacterFormatting  i ⥣   
	楤 TagXXX (  ⥣i 㯨 ଠ㢠 ᨬi)

	楤 TagXXX ᭥  ஡ ⥣i (i 筨
	ਡi ⥪ TextState

		  ⥣ (ଠ㢠 ⥪)
	1.  楤 TagXXX
	2.   ⥣  横 Parse.Inc
	3.   ⥣  ApplyTagCharacterFormatting
	4.  ॡ,  iਬ  ࠬi  DrawPage.Inc
}


Procedure TagBIG;
Begin
	Inc(TextState.Size)
End;

Procedure TagB;
Begin
	TextState.Attr:=TextState.Attr+[faBold]
End;

Procedure TagI;
Begin
	TextState.Attr:=TextState.Attr+[faItalic]
End;

Procedure TagU;
Begin
	TextState.Attr:=TextState.Attr+[faUnderline]
End;


Procedure TagFont(VTag:TChunk);
Var
	TempStr: String;
Begin
	TempStr:=FindParam(VTag, 'FACE');
	If TempStr<>'' Then
	Begin
		TextState.Face:=0;
		If TempStr='TRIPLEX' Then TextState.Face:=1;
		If TempStr='SMALL' Then TextState.Face:=2;
		If TempStr='SANSSERIF' Then TextState.Face:=3;
		If TempStr='GOTHIC' Then TextState.Face:=4
	End;

	TempStr:=FindParam(VTag, 'SIZE');
	If TempStr<>'' Then
	Begin
		If TempStr[1] In ['+', '-']
			Then Inc(TextState.Size, D.Str2Int(TempStr))
			Else TextState.Size:=D.Str2Int(TempStr);
		D.ToRange(TextState.Size, 1, 10)
	End;

	TempStr:=FindParam(VTag, 'COLOR');
	If TempStr<>'' Then
		TextState.Color:=Color2Int(TempStr);
End;

Procedure TagCENTER2;
Begin
	TextState.Align:=alCenter
End;

Procedure TagP2(VTag:TChunk);
Var
	TempStr: String;
Begin
	TempStr:=D.UpCaseLine(FindParam(VTag, 'ALIGN'));
	TextState.Align:=alLeft;
	If TempStr='CENTER' Then TextState.Align:=alCenter;
	If TempStr='RIGHT' Then TextState.Align:=alRight
End;

Procedure ApplyTagCharacterFormatting(VTag:TChunk);
Begin
	With VTag Do
	Begin
		If (Tag='B') Or (Tag='STRONG') Then TagB;
		If Tag='I' Then TagI;
		If Tag='U' Then TagU;
		If Tag='BIG' Then TagBIG;
		If Tag='FONT' Then TagFont(VTag);

		If Tag='CENTER' Then TagCENTER2;
		If Tag='P' Then TagP2(VTag);

		{...}
	End;
End;

Procedure TagCharacterFormatting(VTag:TChunk);
Var
	I: Integer;
Begin
	With VTag Do
		If Opening Then
		Begin
			AddTagToStack(VTag);
			ApplyTagCharacterFormatting(VTag)
		End
		Else Begin
			RemoveTopmostFromStackByName(Tag);
			TextState:=OrigTextState;
			For I:=1 To StackTop Do
				ApplyTagCharacterFormatting(TagStack[I])
		End
End;

{ ******* Paragraph Formatting ******* }



Procedure IntTagBR(FirstRealignItem:PPageItem);
Var
	TempXShift, ItemBaselineHeight, TempYShift: Integer;
	CurItem: PPageItem;
Begin
	Log.BugMsg('HTML', 'TagBR', 'Aligning...');

	If CurLineHeight=0 Then
	Begin
		{Graph.SetTextStyle(TextState.Face, HorizDir, TextState.Size);}
		Inc(CurY, Font.HeightVector(MyFont, FSize[TextState.Size]) Div 2+2)
	End
	Else Inc(CurY, CurLineHeight+2);
	CurX:=Area[AreaNum].X1;
	
		{ check last line alignment, shift page items if needed }
	Case TextState.Align Of
		alLeft: TempXShift:=0;
		alCenter: TempXShift:=(Area[AreaNum].X2-LastPageItem^.Place.X2) Div 2;
		alRight: TempXShift:=Area[AreaNum].X2-LastPageItem^.Place.X2;
	End;

	If FirstRealignItem<>Nil Then
	Begin
		CurItem:=FirstRealignItem^.Next;
		While CurItem<>Nil Do
		Begin
			If Not (CurItem^.Kind In [piText, piLink, piImage, piRect, piBar,
				piPlaceholder]) Then
			Begin
				Log.BugMsg('HTML', 'IntTagBR', 'Error during realign - invalid tag');
				Exit
			End;
			With CurItem^.Place Do
			Begin
				Inc(X1, TempXShift);
				Inc(X2, TempXShift);

				If CurBaselineHeight<>0 Then
				Begin
					If CurItem^.Kind=piText Then
					Begin
						ItemBaselineHeight:=Font.BaselineHeightVector(MyFont,
							FSize[CurItem^.Attr.Size]);
						If ItemBaselineHeight<>CurBaselineHeight Then
						Begin
							
							TempYShift:=CurBaselineHeight-ItemBaselineHeight;
							Inc(Y1, TempYShift);
							Inc(Y2, TempYShift);
							Log.BugMsg('HTML', 'IntTagBR', 'Item "'+
								String(CurItem^.Text^)+'", YShift = '+
								D.St(TempYShift));
						End
					End
				End
			End;
			CurItem:=CurItem^.Next
		End
	End;

	CurLineHeight:=0;
	CurBaselineHeight:=0;
	LastLineStartItem:=LastPageItem
End;

Procedure TagBR;
Begin
	IntTagBR(LastLineStartItem)
End;

Procedure TagCENTER(VTag: TChunk);
Begin
	If CurX<>Area[AreaNum].X1 Then TagBR;
	TagCharacterFormatting(VTag)
End;

Procedure TagP(VTag: TChunk);
Begin
	If CurX<>Area[AreaNum].X1 Then TagBR;
	TagCharacterFormatting(VTag)
End;

{ ******* Different ******* }

Procedure TagHR(VTag:TChunk);
Var
	TempStr: String;
	TempPageWidth, TempWidth, TempLeftOffset, TempHeight: Integer;
	TempColor: Byte;
Begin
	TempPageWidth:=Area[AreaNum].X2-Area[AreaNum].X1+1;
	TempStr:=FindParam(VTag, 'WIDTH');
	If TempStr<>'' Then
	Begin
		If TempStr[Length(TempStr)]='%' Then
		Begin
			TempWidth:=D.Str2Int(Copy(TempStr, 1, Length(TempStr)-1));
			TempWidth:=Round(TempWidth/100*TempPageWidth)
		End
		Else TempWidth:=Str2Int(TempStr)
	End
	Else TempWidth:=Round(TempPageWidth*0.8);
	TempLeftOffset:=(TempPageWidth-TempWidth) Div 2;

	TempStr:=FindParam(VTag, 'HEIGHT');
	If TempStr<>''
		Then TempHeight:=D.Str2Int(TempStr)
		Else TempHeight:=2;

	TempStr:=FindParam(VTag, 'COLOR');
	If TempStr<>''
		Then TempColor:=Color2Int(TempStr)
		Else TempColor:=TextState.Color;

	TagBR;
	TagBR;
	With Area[AreaNum] Do
		AddBarItem(X1+TempLeftOffset, CurY, X2-TempLeftOffset,
			CurY+TempHeight-1, TempColor);
	Inc(CurY, TempHeight);
	TagBR;
	TagBR
End;

Procedure TagIMG(VTag:TChunk);
Var
	TempStr: String;
	TempWidth, TempHeight: Integer;
	TempPtr: Pointer;
Begin
	TempStr:=FindParam(VTag, 'WIDTH');
	If TempStr<>''
		Then TempWidth:=D.Str2Int(TempStr)
		Else TempWidth:=16;
	TempStr:=FindParam(VTag, 'HEIGHT');
	If TempStr<>''
		Then TempHeight:=D.Str2Int(TempStr)
		Else TempHeight:=16;
	TempStr:=FindParam(VTag, 'SRC');
	If D.FileExist(TempStr) Then
	Begin
		Pic.LoadGIF(TempStr, TempPtr);
		TempWidth:=Gfx.ImageX(TempPtr);
		TempHeight:=Gfx.ImageY(TempPtr)
	End
	Else Gfx.MakeEmptyImage(TempPtr);

	If CurX+TempWidth-1>Area[AreaNum].X2 Then TagBR;
	AddImageItem(CurX, CurY, CurX+TempWidth-1, CurY+TempHeight-1, TempPtr);
	Inc(CurX, TempWidth+2);
	If CurLineHeight<TempHeight Then
		CurLineHeight:=TempHeight

End;


{ ******* Lists ******* }

Procedure TagUL(VTag:TChunk);
Var
	TempStr: String18;
Begin
	If VTag.Opening Then
	Begin
		Inc(AreaNum);
		Area[AreaNum]:=Area[AreaNum-1];
		Inc(Area[AreaNum].X1,30)
	End
	Else Dec(AreaNum);
	TagBR;
	TagBR
End;

Procedure TagLI(VTag:TChunk);
Var
	TempY: Integer;
Begin
	If VTag.Opening Then
	Begin
		If CurX<>Area[AreaNum].X1 Then TagBR;
		{Graph.SetTextStyle(TextState.Face, HorizDir, TextState.Size);}
		TempY:=CurY+Font.HeightVector(MyFont, FSize[TextState.Size]) Div 2;
		AddBarItem(CurX-15-2, TempY-1, CurX-15+2, TempY+1, TextState.Color);
		AddBarItem(CurX-15-1, TempY-2, CurX-15+1, TempY+2, TextState.Color)
	End
End;

{ ******* Tables ******* }

Procedure TagTABLE(VTag:TChunk);
Var
	TempStr: String;
	TempPageWidth, TempWidth: Integer;
	I, J, K: Integer;
	TempX, TempY, TempDelta: Integer;
Begin
	If VTag.Opening Then
	Begin
		TempStr:=FindParam(VTag, 'WIDTH');
		TempPageWidth:=Area[AreaNum].X2-Area[AreaNum].X1-6;
		If TempStr<>'' Then
		Begin
			If TempStr[Length(TempStr)]='%' Then
			Begin
				TempWidth:=D.Str2Int(Copy(TempStr, 1, Length(TempStr)-1));
				TempWidth:=Round(TempWidth/100*TempPageWidth)
			End
			Else TempWidth:=D.Str2Int(TempStr)
		End
		Else TempWidth:=TempPageWidth;
			{ add new record to table stack }
		Inc(TableStackTop);
		New(TableStack[TableStackTop]);
		TableStack[TableStackTop]^.Rows:=0;
		TableStack[TableStackTop]^.Cols:=0;
		TableStack[TableStackTop]^.CurRow:=0;
		TableStack[TableStackTop]^.CurCol:=0;
		TableStack[TableStackTop]^.Width:=TempWidth;
		{TableStack[TableStackTop]^.CurCellBG:=bgNone;}
		TempStr:=FindParam(VTag, 'CELLSPACING');
		If TempStr<>''
			Then TableStack[TableStackTop]^.CellSpacing:=D.Str2Int(TempStr)
			Else TableStack[TableStackTop]^.CellSpacing:=2;
		TempStr:=FindParam(VTag, 'CELLPADDING');
		If TempStr<>''
			Then TableStack[TableStackTop]^.CellPadding:=D.Str2Int(TempStr)
			Else TableStack[TableStackTop]^.CellPadding:=2;
		TempStr:=FindParam(VTag, 'BORDER');
		If TempStr<>''
			Then TableStack[TableStackTop]^.Border:=D.Str2Int(TempStr)
			Else TableStack[TableStackTop]^.Border:=1;

		For I:=1 To MaxTableCols Do
			TableStack[TableStackTop]^.Col[I].Width:=0;
		For I:=1 To MaxTableRows Do
			TableStack[TableStackTop]^.RowHeight[I]:=0;

		With TableStack[TableStackTop]^ Do
			Log.BugMsg('HTML', 'TagTABLE', 'Width = '+D.St(Width)+
				', Border = '+D.St(Border)+', CellPadding = '+D.St(CellPadding)+
				', CellSpacing = '+D.St(CellSpacing));

		{For I:=1 To 7 Do
			For J:=1 To 7 Do
				TableStack[TableStackTop].Span[I, J]:=0;
		TableStack[TableStackTop].LastSpanByte:=0;}
			{ add new area }
		If CurX<>Area[AreaNum].X1 Then TagBR;
		Inc(AreaNum);
		Area[AreaNum]:=Area[AreaNum-1];
		TableStack[TableStackTop]^.OrigX1:=CurX;
		TableStack[TableStackTop]^.OrigY1:=CurY;
		Log.ActMsg('OrigX1 = '+D.St(CurX)+', OrigY1 = '+D.St(CurY));
		With Area[AreaNum], TableStack[TableStackTop]^ Do
		Begin
			TempDelta:=CellSpacing+Border*2;
			Y1:=CurY+TempDelta;
			Inc(X1, TempDelta);
			Dec(X2, TempDelta);

			Inc(CurX, TempDelta+CellPadding);
			Inc(CurY, TempDelta+CellPadding);

			CurX1:=CurX;
			CurY1:=CurY
		End;
		(*AddTableStartItem; { to align all table later }
		TableStack[TableStackTop]^.TableStart:=LastPageItem;*)

	End
	Else Begin
		With TableStack[TableStackTop]^ Do
		Begin
			TempY:=OrigY1+CellSpacing+Border*2;
			For I:=1 To Rows Do
			Begin
				TempX:=OrigX1+CellSpacing+Border*2;
				For J:=1 To Cols Do
				Begin
					For K:=1 To Border Do
						AddRectItem(TempX-K, TempY-K, TempX+Col[J].Width+K-1,
							TempY+RowHeight[I]+K-1, 0, 0);
					Inc(TempX, Col[J].Width+CellSpacing+Border*2)
				End;
				Inc(TempY, RowHeight[I]+CellSpacing+Border*2)
			End;
				{ outer frame }
			For K:=1 To Border Do
				AddRectItem(OrigX1+K-1, OrigY1+K-1, TempX-K, TempY-K, 0, 0)
		End;

		Dec(AreaNum);
		(*IntTagBR(TableStack[TableStackTop]^.TableStart); { to align all table }*)
		{TagBR;}
		Dispose(TableStack[TableStackTop]);
		Dec(TableStackTop);
	End;
	Log.BugMsg('HTML', 'TagTable', 'Exiting')
End;

Procedure TagTR(VTag:TChunk);
Var
	TempStr: String;
	TempHeight: Integer;
	I, J: Integer;
	TempX: Integer;
Begin
	If VTag.Opening Then
	Begin
		TempStr:=FindParam(VTag, 'HEIGHT');
		If TempStr=''
			Then TempHeight:=0
			Else TempHeight:=D.Str2Int(TempStr);
		With TableStack[TableStackTop]^ Do
		Begin
			Inc(Rows);
			Inc(CurRow);
			RowHeight[CurRow]:=TempHeight;
			CurX1:=Area[AreaNum].X1+CellPadding;
			CurX:=CurX1;
		End
	End
	Else Begin
		With TableStack[TableStackTop]^ Do
		Begin
				{ add background if needed }
			TempX:=OrigX1;
			For I:=1 To CurCol Do
				Inc(TempX, Col[I].Width+Border*2+CellSpacing);

			With Area[AreaNum] Do
				For I:=CurCol Downto 1 Do
				Begin
					If Col[I].BGKind=bgColor Then
						PlaceholderToBarItem(TempX-Col[I].Width, CurY1-CellPadding,
							TempX-1, CurY1+RowHeight[CurRow]-CellPadding-1,
							Col[I].BGColor);
					Dec(TempX, Col[I].Width+Border*2+CellSpacing)
				End;

				{ alter CurY1 }
			Inc(CurY1, RowHeight[CurRow]+CellSpacing+Border*2);
			CurCol:=0;
			CurY:=CurY1
		End
	End
End;

Procedure TagTD(VTag:TChunk);
Var
	TempStr: String;
	TempTableWidth, TempWidth, TempHeight: Integer;
	I: Integer;
	TempRect: TRect;
Begin
	With TableStack[TableStackTop]^ Do
		If VTag.Opening Then
		Begin
			TempTableWidth:=Width;

			If CurRow=1 Then
			Begin
				TempStr:=FindParam(VTag, 'WIDTH');
				If TempStr<>'' Then
				Begin
					If TempStr[Length(TempStr)]='%' Then
					Begin
						TempWidth:=D.Str2Int(Copy(TempStr, 1, Length(TempStr)-1));
						TempWidth:=Round(TempWidth/100*TempTableWidth)
					End
					Else TempWidth:=D.Str2Int(TempStr)
				End
				Else Begin
						{ width is unspecified; take half available width }
					TempWidth:=TempTableWidth;
					For I:=1 To Cols Do
						Dec(TempWidth, Col[I].Width+CellSpacing+Border*2);
					TempWidth:=(TempWidth Div 2)-CellSpacing-Border*2;
				End
			End
			Else TempWidth:=Col[CurCol].Width;

			TempStr:=FindParam(VTag, 'HEIGHT');
			If TempStr=''
				Then TempHeight:=0
				Else TempHeight:=D.Str2Int(TempStr);

			Inc(CurCol);
			If CurCol>Cols Then Cols:=CurCol;
			If Col[CurCol].Width=0 Then
				Col[CurCol].Width:=TempWidth;
			If RowHeight[CurRow]<TempHeight Then
				RowHeight[CurRow]:=TempHeight;
			{Inc(LastSpanByte);
			Span[CurRow, CurCol]:=LastSpanByte;}

			TempStr:=FindParam(VTag, 'BGCOLOR');
			If TempStr<>'' Then
			Begin
				Col[CurCol].BGKind:=bgColor;
				Col[CurCol].BGColor:=Color2Int(TempStr);
				AddPlaceholderItem
			End
			Else Col[CurCol].BGKind:=bgNone;

				{ add cell area }
			Inc(AreaNum);
			Area[AreaNum].X1:=CurX1;
			Area[AreaNum].Y1:=CurY1;
			Area[AreaNum].X2:=CurX1+Col[CurCol].Width-CellPadding*2-1;
			Area[AreaNum].Y2:=Area[AreaNum-1].Y2-CellPadding*2-1
		End
		Else Begin { tag is closing }

				{ check cell height }
			If CurX<>Area[AreaNum].X1 Then TagBR;
			TempHeight:=CurY-CurY1+1+CellPadding*2;
			If TempHeight>RowHeight[CurRow] Then
				RowHeight[CurRow]:=TempHeight;

				{ Alter CurX1 }
			Inc(CurX1, Col[CurCol].Width+CellSpacing+Border*2);

			CurX:=CurX1;
			CurY:=CurY1;

			Dec(AreaNum)
		End
End;

{ ******* Structural ******* }

Procedure TagTITLE(VTag:TChunk);
Var
	TempY: Integer;
Begin
	If VTag.Opening
		Then CurDocSection:=dsTitle
		Else CurDocSection:=dsNone
End;

Procedure TagBODY(VTag:TChunk);
Var
	TempStr: String;
Begin
	If VTag.Opening Then
	Begin
		CurDocSection:=dsBody;

		TempStr:=FindParam(VTag, 'BGCOLOR');
		If TempStr[1]='#' Then Delete(TempStr, 1, 1);
		If TempStr=''
			Then DocProps.BGColor:=15
			Else DocProps.BGColor:=Color2Int(TempStr);

		TempStr:=FindParam(VTag, 'TEXT');
		If TempStr[1]='#' Then Delete(TempStr, 1, 1);
		If TempStr=''
			Then DocProps.TextColor:=0
			Else DocProps.TextColor:=Color2Int(TempStr);

		TempStr:=FindParam(VTag, 'LINK');
		If TempStr[1]='#' Then Delete(TempStr, 1, 1);
		If TempStr=''
			Then DocProps.LinkColor:=9
			Else DocProps.LinkColor:=Color2Int(TempStr);

		OrigTextState.Color:=DocProps.TextColor;
	End
	Else CurDocSection:=dsNone
End;
