Unit
	Ini; { Polit Halcyon Eva ini files support unit, ver 2 }

Interface

Uses
	Types, D, Log;

Const
	DefaultIniPath='';

Type
	PIniRec=^TIniRec;
	TIniRec=Record
		Name, Value: PStr;
		Next: PIniRec
	End;

	PIniSection=^TIniSection;
	TIniSection=Record
		Name: PStr;
		FirstRec: PIniRec;
		Next: PIniSection
	End;

	PIniFile=^TIniFile;
	TIniFile=Record
		Name: PStr;
		FirstSection, CurSection: PIniSection;
		Next: PIniFile
	End;


	Procedure Load(FName:String);
	Procedure CreateFile(FName:String);
	Procedure CreateSection(VName:String);
	Procedure SelectFile(FName:String);
	Procedure FreeFile(FName:String);
	Procedure SelectSec(VName:String);
	Procedure Select(FName,SecName:String);
	Function GetStr(VKey,Default:String):String;
	Function GetInt(VKey:String;Default:Integer):Integer;
	Function GetBool(VKey:String;Default:Boolean):Boolean;
	Procedure SetStr(VName, VValue:String);
	Procedure SetInt(VName:String; VValue:Integer);
	Procedure SetBool(VName:String; VValue:Boolean);
	Procedure SaveCurFile;
	Procedure Done;

Var
	UpCaseNeeded, FlushNeeded: Boolean;

Implementation

Var
	FirstIniFile, CurIniFile: PIniFile;
	SectionCreated: Boolean;


Function FindIniFile(FName:String): PIniFile;
Var
	TempFile: PIniFile;
	Found: Boolean;
Begin
	If Pos('\', FName)=0 Then
		FName:=DefaultIniPath+FName;

	TempFile:=FirstIniFile;
	Found:=False;
	FName:=D.UpCaseLine(FName);
	While (TempFile<>Nil) And Not Found Do
		If String(TempFile^.Name^)=FName
			Then Found:=True
			Else TempFile:=TempFile^.Next;

	If Found
		Then FindIniFile:=TempFile
		Else FindIniFile:=Nil
End;


Procedure Load(FName:String);
Var
	F: Text;
	TempStr: String;
	V: Byte;
	TempRec: PIniRec;
Begin
	If Pos('\', FName)=0 Then
		FName:=DefaultIniPath+FName;
	Log.SysMsg('Ini', 'Load', 'Loading INI file: '+FName);
	If Not D.FileExist(FName) Then
	Begin
		Log.ErrMsg('Ini', 'Load', 'File not found, ignoring');
		Log.ActMsg('Ignoring load request');
		Exit
	End;
	If FindIniFile(FName)<>Nil Then
	Begin
		Log.ErrMsg('Ini', 'Load', 'File already loaded');
		Log.ActMsg('Selecting this file indtead');
		SelectFile(FName);
		Exit
	End;


		{ ⢮  TIniFile }
	New(CurIniFile);
	CurIniFile^.Next:=FirstIniFile;
	FirstIniFile:=CurIniFile;

	With CurIniFile^ Do
	Begin
		D.AssignPStr(D.UpCaseLine(FName), Name);
		New(FirstSection);
		FirstSection^.Next:=Nil;
		D.AssignPStr('', FirstSection^.Name);
		FirstSection^.FirstRec:=Nil;

		Assign(F, FName);
		Reset(F);

		While Not EOF(F) Do
		Begin
				{  i i㢠 冷 }
			ReadLn(F, TempStr);
			V:=Pos(';', TempStr); {  ? }
			If V<>0 Then
				TempStr:=Copy(TempStr, 1, V-1);
			D.TrimSpaces(TempStr);

			If TempStr<>'' Then
			Begin
				If TempStr[1]='[' Then
				Begin { TempStr -   ᥪi }
					If TempStr[Length(TempStr)]<>']' Then
					Begin
						TempStr:=TempStr+']';
						Log.ErrMsg('Ini', 'Load', 'Ini file section header has no closing "]"');
						Log.ActMsg('Treating it as '+TempStr)
					End;
					{New(CurSection);
					CurSection^.Next:=FirstSection;
					FirstSection:=CurSection;}
						{ ॡ   i ᯨ᪠ :( }
					CurSection:=FirstSection;
					While CurSection^.Next<>Nil Do
						CurSection:=CurSection^.Next;
					New(CurSection^.Next);
					CurSection:=CurSection^.Next;
					CurSection^.Next:=Nil;
					D.AssignPStr(Copy(TempStr, 2, Length(TempStr)-2),
						CurSection^.Name);
					CurSection^.FirstRec:=Nil;
					{Log.BugMsg('Ini', 'Load', 'Section header added: '+TempStr)}
				End

				Else Begin {  ⨯ name=value,   CurSection }
					V:=Pos('=', TempStr);
					If V>0 Then
					Begin
						{New(TempRec);
						TempRec^.Next:=CurSection^.FirstRec;
						CurSection^.FirstRec:=TempRec;}
							{ ॡ   i ᯨ᪠ :( }
						If CurSection^.FirstRec=Nil Then
						Begin
							New(CurSection^.FirstRec);
							TempRec:=CurSection^.FirstRec
						End
						Else Begin
							TempRec:=CurSection^.FirstRec;
							While TempRec^.Next<>Nil Do
								TempRec:=TempRec^.Next;
							New(TempRec^.Next);
							TempRec:=TempRec^.Next
						End;
						TempRec^.Next:=Nil;

						D.AssignPStr(Copy(TempStr, 1, V-1), TempRec^.Name);
						D.AssignPStr(Copy(TempStr, V+1, Length(TempStr)-V),
							TempRec^.Value);
						{Log.BugMsg('Ini', 'Load', 'Line added: '+TempStr)}
					End
					Else Begin
						Log.ErrMsg('Ini', 'Load',
							'Ini line have no "[" nor "=": "'+TempStr+'"');
						Log.ActMsg('Ignoring this line')
					End
				End
			End
		End;
		Close(F);
		CurSection:=FirstSection;
		SectionCreated:=False
	End
End;

Procedure CreateFile(FName:String);
Begin
	New(CurIniFile);
	CurIniFile^.Next:=FirstIniFile;
	FirstIniFile:=CurIniFile;

	With CurIniFile^ Do
	Begin
		D.AssignPStr(FName, Name);
		New(FirstSection);
		FirstSection^.Next:=Nil;
		D.AssignPStr('', FirstSection^.Name);
		FirstSection^.FirstRec:=Nil
	End
End;

Procedure CreateSection(VName:String);
Begin
	With CurIniFile^ Do
	Begin
		CurSection:=FirstSection;
		While CurSection^.Next<>Nil Do
			CurSection:=CurSection^.Next;
		New(CurSection^.Next);
		CurSection:=CurSection^.Next;
		CurSection^.Next:=Nil;
		D.AssignPStr(VName, CurSection^.Name);
		CurSection^.FirstRec:=Nil
	End;

	If FlushNeeded Then
		SaveCurFile
End;




Procedure SelectFile(FName:String);
Var
	TempFile: PIniFile;
Begin
	Log.SysMsg('Ini', 'Select', 'Selecting INI file: '+FName);
	TempFile:=FindIniFile(FName);
	If TempFile=Nil Then
	Begin
		Log.ErrMsg('Log', 'SetFile', 'Requested file not found among loaded files');
		Log.ActMsg('Creating empty file');
		CreateFile(FName)
		{If CurIniFile=Nil
			Then Log.ActMsg('Ignoring select request (no files selected)')
			Else Log.ActMsg('File '+String(CurIniFile^.Name^)+' remains current')}
	End
	Else Begin
		CurIniFile:=TempFile;
		CurIniFile^.CurSection:=CurIniFile^.FirstSection;
		SectionCreated:=False
	End;
End;

Procedure IntFreeFile(VFile:PIniFile);
Var
	PrevFile: PIniFile;
	TempSection, NextSection: PIniSection;
	TempRec, NextRec: PIniRec;
Begin
	TempSection:=VFile^.FirstSection;
	While TempSection<>Nil Do
	Begin
		TempRec:=TempSection^.FirstRec;
		While TempRec<>Nil Do
		Begin
			D.FreePStr(TempRec^.Name, 'Ini - IntFreeFile');
			D.FreePStr(TempRec^.Value, 'Ini - IntFreeFile');
			NextRec:=TempRec^.Next;
			Dispose(TempRec);
			TempRec:=NextRec
		End;
		D.FreePStr(TempSection^.Name, 'Ini - IntFreeFile');
		NextSection:=TempSection^.Next;
		Dispose(TempSection);
		TempSection:=NextSection
	End;

	If CurIniFile=VFile Then
		CurIniFile:=Nil;
	If VFile<>FirstIniFile Then
	Begin
		PrevFile:=FirstIniFile;
		While (PrevFile^.Next<>VFile) And (PrevFile^.Next<>Nil) Do
			PrevFile:=PrevFile^.Next;
		If PrevFile^.Next=VFile Then
			PrevFile^.Next:=VFile^.Next;
		D.FreePStr(VFile^.Name, 'Ini - IntFreeFile');
		Dispose(VFile)
	End
	Else Begin
		VFile:=FirstIniFile^.Next;
		D.FreePStr(FirstIniFile^.Name, 'Ini - IntFreeFile');
		Dispose(FirstIniFile);
		FirstIniFile:=VFile
	End
End;

Procedure FreeFile(FName:String);
Var
	TempFile: PIniFile;
Begin
	Log.SysMsg('Ini', 'FreeFile', 'Freeing file: '+FName);
	TempFile:=FindIniFile(FName);
	If TempFile=Nil
		Then Log.ErrMsg('Ini', 'FreeFile', 'File not found among loaded')
		Else IntFreeFile(TempFile)
End;

Function FindSection(VName:String): PIniSection;
Var
	TempSection: PIniSection;
	Found: Boolean;
Begin
	TempSection:=CurIniFile^.FirstSection;
	Found:=False;
	While (TempSection<>Nil) And Not Found Do
		If String(TempSection^.Name^)=VName
			Then Found:=True
			Else TempSection:=TempSection^.Next;

	If Found
		Then FindSection:=TempSection
		Else FindSection:=Nil
End;

Procedure SelectSec(VName:String);
Var
	TempSection: PIniSection;
Begin
	If CurIniFile=Nil Then
	Begin
		Log.ErrMsg('Ini', 'SetSection', 'No Ini file loaded, ignoring');
		Exit
	End;

	TempSection:=FindSection(VName);
	If TempSection<>Nil Then
	Begin
		{Log.BugMsg('Ini', 'SetSection', 'Current section set: '+VName);}
		CurIniFile^.CurSection:=TempSection;
		SectionCreated:=False
	End
	Else Begin
		Log.ErrMsg('Ini', 'SetSection', 'Section not found: '+VName);
		Log.ActMsg('Creating empty section');
		CreateSection(VName);
		SectionCreated:=True
	End
End;

Procedure Select(FName,SecName:String);
Begin
	SelectFile(FName);
	SelectSec(SecName)
End;


Function FindRec(VName:String): PIniRec;
Var
	TempRec: PIniRec;
	Found: Boolean;
Begin
	If CurIniFile=Nil Then
	Begin
		Log.ErrMsg('Ini', 'FindRec', 'No Ini file loaded, ignoring');
		FindRec:=Nil;
		Exit
	End;

	VName:=D.UpCaseLine(VName);
	TempRec:=CurIniFile^.CurSection^.FirstRec;
	Found:=False;
	While (TempRec<>Nil) And Not Found Do
		If D.UpCaseLine(String(TempRec^.Name^))=VName
			Then Found:=True
			Else TempRec:=TempRec^.Next;

	If Found
		Then FindRec:=TempRec
		Else FindRec:=Nil
End;

Function GetStr(VKey,Default:String): String;
Var
	TempRec: PIniRec;
Begin
	TempRec:=FindRec(VKey);
	If TempRec=Nil Then
	Begin
		Log.ErrMsg('Ini', 'GetStr', 'Key not found: '+VKey);
		Log.ActMsg('Cur file = '+String(CurIniFile^.Name^)+
			', cur section = '+String(CurIniFile^.CurSection^.Name^));
		Log.ActMsg('Returning default string: '+Default);
		{If SectionCreated Then}
			SetStr(VKey, Default);
		GetStr:=Default
	End
	Else Begin
		If UpCaseNeeded
			Then GetStr:=D.UpCaseLine(String(TempRec^.Value^))
			Else GetStr:=String(TempRec^.Value^)
	End
End;

Function GetInt(VKey:String; Default:Integer): Integer;
Var
	TempRec: PIniRec;
	TempInt: Integer;
	Res:Word;
Begin
	TempRec:=FindRec(VKey);
	If TempRec=Nil Then
	Begin
		Log.ErrMsg('Ini', 'GetInt', 'Key not found: '+VKey);
		Log.ActMsg('Cur file = '+String(CurIniFile^.Name^)+
			', cur section = '+String(CurIniFile^.CurSection^.Name^));
		Log.ActMsg('Returning default value: '+D.St(Default));
		{If SectionCreated Then}
			SetInt(VKey, Default);
		GetInt:=Default
	End
	Else Begin
		Val(String(TempRec^.Value^), TempInt, Res);
		If Res<>0 Then
		Begin
			Log.ErrMsg('Ini','GetInt','Key value is not valid integer: '+
				VKey+'='+String(TempRec^.Value^));
			Log.ActMsg('Returning default value: '+D.St(Default));
			GetInt:=Default
		End
		Else
			GetInt:=TempInt
	End
End;

Function GetBool(VKey:String; Default:Boolean): Boolean;
Var
	TempRec: PIniRec;
	TempStr: String;
Begin
	TempRec:=FindRec(VKey);
	If TempRec=Nil Then
	Begin
		Log.ErrMsg('Ini', 'GetBool', 'Key not found: '+VKey);
		Log.ActMsg('Cur file = '+String(CurIniFile^.Name^)+
			', cur section = '+String(CurIniFile^.CurSection^.Name^));
		If Default
			Then Log.ActMsg('Returning default value: True')
			Else Log.ActMsg('Returning default value: False');
		{If SectionCreated Then}
			SetBool(VKey, Default);
		GetBool:=Default
	End
	Else Begin
		TempStr:=D.UpCaseLine(String(TempRec^.Value^));
		If (TempStr='YES') Or (TempStr='TRUE') Or (TempStr='1')
			Then GetBool:=True
			Else GetBool:=False
	End
End;



Procedure SetStr(VName, VValue:String);
Var
	TempRec, PrevRec: PIniRec;
Begin
	If CurIniFile=Nil Then Exit;
	TempRec:=FindRec(VName);
	If TempRec=Nil Then
	Begin
		If CurIniFile^.CurSection^.FirstRec<>Nil Then
		Begin
			PrevRec:=CurIniFile^.CurSection^.FirstRec;
			While PrevRec^.Next<>Nil Do
				PrevRec:=PrevRec^.Next;
			New(TempRec);
			PrevRec^.Next:=TempRec
		End
		Else Begin
			New(TempRec);
			CurIniFile^.CurSection^.FirstRec:=TempRec
		End;
		TempRec^.Next:=Nil;
		D.AssignPStr(VName, TempRec^.Name);
		D.AssignPStr(VValue, TempRec^.Value)
	End
	Else
		D.ReassignPStr(VValue, TempRec^.Value);

	If FlushNeeded Then
		SaveCurFile
End;

Procedure SetInt(VName:String; VValue:Integer);
Begin
	SetStr(VName, D.St(VValue))
End;

Procedure SetBool(VName:String; VValue:Boolean);
Begin
	If VValue
		Then SetStr(VName, 'True')
		Else SetStr(VName, 'False')
End;



Procedure SaveCurFile;
Var
	TempSection: PIniSection;
	TempRec: PIniRec;
	F:Text;
Begin
	If CurIniFile=Nil Then Exit;

	Assign(F, String(CurIniFile^.Name^));
	Rewrite(F);
	TempSection:=CurIniFile^.FirstSection;
	While TempSection<>Nil Do
	Begin
		If String(TempSection^.Name^)<>'' Then
		Begin
			WriteLn(F, '['+String(TempSection^.Name^)+']');
			TempRec:=TempSection^.FirstRec;
			While TempRec<>Nil Do
			Begin
				Write(F, String(TempRec^.Name^)+'=');
				WriteLn(F, String(TempRec^.Value^));
				TempRec:=TempRec^.Next
			End;
			WriteLn(F)
		End;
		TempSection:=tempSection^.Next
	End;
	Close(F)
End;







Procedure Done;
Begin
	While FirstIniFile<>Nil Do
		IntFreeFile(FirstIniFile)
End;


Begin
	FirstIniFile:=Nil;
	CurIniFile:=Nil;
	UpCaseNeeded:=True;
	FlushNeeded:=True;
	SectionCreated:=False
End.