{ ************ InpLine ************ }
Type
	TScrollZone=(szLeft, szRight, szText, szNone);
	TInpLine=Record
		S: String;
		CursorPos: Integer;
		Color: TColor;
		Icon: Pointer;
		IconWidth: Integer;

		Scroll: Boolean;
		FirstChar, LastChar: Integer;
		LastWidth: Integer;

		Selection: Boolean;
		SelStart, SelEnd: Integer;
		ContextMenu: PMenuItem;
		OnChange: TInpLineChangeFunc;

		LeftDown, RightDown: Boolean;
	End;

Var
	InpZone: TScrollZone;
	Pos1, Pos2: Integer;
	PicInpL, PicInpR: TSkinPic;
	InpArrowsWidth: Integer;

	InpLineSelectAllOnFocus: Boolean;
	InpLineArrowsRemoveSel: Boolean;

Function InpLineChangeDummy(Me:PProg; Control:PControl; Ch:String): String;
Begin
	InpLineChangeDummy:=Ch
End;

Procedure InpLine_CheckScroll(Me:PControl);
Var
	TempWidth: Integer;
Begin
	With Me^, TInpLine(Data^) Do
	Begin
		Font.SetFont(Kernel.CurFont);
		LastChar:=Length(S);
		If (Font.Width(S)>=Place.X2-Place.X1-InpArrowsWidth*2-IconWidth-3) Or
			(FirstChar>1) Then
		Begin
			Scroll:=True;
			TempWidth:=Font.Width(Copy(S, FirstChar, LastChar-FirstChar+1));
			While TempWidth>=Place.X2-Place.X1-InpArrowsWidth*2-IconWidth-3 Do
			Begin
				Dec(TempWidth, Font.Width(S[LastChar]));
				Dec(LastChar)
			End
		End
		Else
			Scroll:=False
	End
End;

Procedure InpLine_CheckScrollFromLast(Me:PControl);
Var
	TempWidth: Integer;
Begin
	With Me^,TInpLine(Data^) Do
	Begin
		Font.SetFont(Kernel.CurFont);
		FirstChar:=1;
		If (Font.Width(S)>=Place.X2-Place.X1-InpArrowsWidth*2-IconWidth-3) Or
			(LastChar<Length(S)) Then
		Begin
			Scroll:=True;
			TempWidth:=Font.Width(Copy(S, FirstChar, LastChar-FirstChar+1));
			While TempWidth>=Place.X2-Place.X1-InpArrowsWidth*2-IconWidth-3 Do
			Begin
				Dec(TempWidth, Font.Width(S[FirstChar]));
				Inc(FirstChar)
			End
		End
		Else
			Scroll:=False
	End
End;

Function InpLine_CursorX(Me:PControl):Integer;
Begin
	Font.SetFont(Kernel.CurFont);
	With Me^, TInpLine(Data^), Place Do
		InpLine_CursorX:=Font.Width(Copy(S, FirstChar, CursorPos-FirstChar+1))+
			X1+2+IconWidth+InpArrowsWidth
End;

Procedure InpLine_DrawCursor(Me:PControl; Focused:Boolean);
Var
	CursorX, Color: Integer;
Begin
	With Me^, TInpLine(Data^), Place Do
	Begin
		CursorX:=InpLine_CursorX(Me);
		If Focused
			Then Color:=Kernel.ClrEditFont
			Else If Selection And ((CursorPos=SelStart) Or (CursorPos=SelEnd))
				Then Color:=Kernel.ClrEditSel
				Else Color:=Kernel.ClrEdit;
		Gfx.Line(CursorX, Y1+4, CursorX, Y2-2, Color)
	End
End;

Procedure InpLine_DrawText(Me:PControl; Focused:Boolean);
Var
	Sel1, Sel2, Sel1X, Sel2X: Integer;
Begin
	With Me^, TInpLine(Data^), Place Do
	Begin
		Font.SetFont(Kernel.CurFont);
		If Enabled Then
		Begin { enabled }
			If (Not Selection) Or (SelEnd<FirstChar) Or (SelStart>LastChar) Then
			Begin { selection is invisible now }
				Gfx.Bar(X1+IconWidth+InpArrowsWidth+2,
					Y1+3, X2-InpArrowsWidth-1, Y2-1, Kernel.ClrEdit);
				Font.Print(X1+IconWidth+InpArrowsWidth+3, Y1+4,
					Kernel.ClrEditFont, Copy(S,FirstChar,LastChar-FirstChar+1))
			End { selection is invisible now end }
			Else Begin { selection is visible now }
				Sel1:=D.Max(SelStart, FirstChar-1);
				Sel2:=D.Min(SelEnd, LastChar);
				Sel1X:=Font.Width(Copy(S, FirstChar, Sel1-FirstChar+1))+
					X1+IconWidth+InpArrowsWidth+2;
				Sel2X:=Font.Width(Copy(S, FirstChar, Sel2-FirstChar+1))+
					X1+IconWidth+InpArrowsWidth+2;
				If Not Focused Then
				Begin { not focused }
					Gfx.Bar(X1+IconWidth+InpArrowsWidth+2, Y1+3,
						X2-InpArrowsWidth-1, Y2-1, Kernel.ClrEdit);
					Font.Print(X1+IconWidth+InpArrowsWidth+3, Y1+4,
						Kernel.ClrEditFont, Copy(S, FirstChar, LastChar-FirstChar+1));
					If D.InRange(SelStart, FirstChar-1, LastChar-1) Then
						Gfx.Line(Sel1X, Y1+3, Sel1X, Y2-1, Kernel.ClrEditSel);
					Gfx.Line(Sel1X, Y1+3, Sel2X, Y1+3, Kernel.ClrEditSel);
					Gfx.Line(Sel1X, Y2-1, Sel2X, Y2-1, Kernel.ClrEditSel);
					If D.InRange(SelEnd, FirstChar, LastChar) Then
						Gfx.Line(Sel2X, Y1+3, Sel2X, Y2-1, Kernel.ClrEditSel)
				End { not focused end }
				Else Begin { focused }
					If Sel1<>FirstChar-1 Then
					Begin
						Gfx.Bar(X1+IconWidth+InpArrowsWidth+2, Y1+3,
							Sel1X-1, Y2-1, Kernel.ClrEdit);
						Font.Print(X1+IconWidth+InpArrowsWidth+3, Y1+4,
							Kernel.ClrEditFont, Copy(S, FirstChar, Sel1-FirstChar+1))
					End;
					Gfx.Bar(Sel1X, Y1+3, Sel2X, Y2-1, Kernel.ClrEditSel);
					Font.Print(Sel1X+1, Y1+4, Kernel.ClrEditFont,
						Copy(S, Sel1+1, Sel2-Sel1));
					If Sel2X<=X2-InpArrowsWidth-1 Then
					Begin
						Gfx.Bar(Sel2X+1, Y1+3, X2-InpArrowsWidth-1,
							Y2-1, Kernel.ClrEdit);
						Font.Print(Sel2X+1, Y1+4, Kernel.ClrEditFont,
							Copy(S,Sel2+1,LastChar-Sel2))
					End
				End { focused end }
			End { selection is visible now end }
		End { enabled end }
		Else Begin { disabled }
			Gfx.Bar(X1+IconWidth+InpArrowsWidth+2, Y1+3, X2-InpArrowsWidth,
				Y2-1, Kernel.ClrWinBG);
			Font.Print(X1+IconWidth+InpArrowsWidth+3, Y1+4,
				Kernel.ClrTextDis, Copy(S, FirstChar, LastChar-FirstChar+1))
		End
	End
End;


Procedure InpLine_IntDraw(Me:PControl); Forward;
Procedure InpLine_SelectAll(Me:PControl); Forward;

Procedure InpLine_OnRefocus(Me:PControl; Focused:Boolean);
Var
	CurColor: TColor;
	CurX: Integer;
Begin
	Kernel.CtlRefocusDummy(Me, Focused);
	With Me^, TInpLine(Data^), Place Do
	Begin
		If Focused And InpLineSelectAllOnFocus Then
			InpLine_SelectAll(Me);
		If Selection Then
			InpLine_DrawText(Me,Focused);
		InpLine_DrawCursor(Me,Focused)
	End
End;


Procedure InpLine_IntDraw(Me:PControl);
Var
	ClrFill: TColor;
	Temp:String;
	SystemActiveCtl: PControl;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, TInpLine(Data^), Place Do
	Begin
		If Enabled
			Then ClrFill:=Kernel.ClrEdit
			Else ClrFill:=Kernel.ClrWinBG;

		Font.SetFont(Kernel.CurFont);
		If X2-X1>LastWidth Then
		Begin
			If Font.Width(S)<=X2-X1-IconWidth-InpArrowsWidth*2-3
				Then Begin
					FirstChar:=1;
					InpLine_CheckScroll(Me)
				End
				Else Begin
					InpLine_CheckScrollFromLast(Me);
					InpLine_CheckScroll(Me)
				End
		End
		Else Begin
			InpLine_CheckScroll(Me);
			If CursorPos+1<FirstChar Then
			Begin
				FirstChar:=CursorPos-5;
				D.NotLess(FirstChar, 1);
				InpLine_CheckScroll(Me)
			End;
			If CursorPos>LastChar Then
			Begin
				LastChar:=CursorPos+5;
				D.NotMore(LastChar, Length(S));
				InpLine_CheckScrollFromLast(Me)
			End;
			If Font.Width(Copy(S, FirstChar, Length(S)-FirstChar+1))<
				X2-X1-IconWidth-InpArrowsWidth*2-3 Then
			Begin
				LastChar:=Length(S);
				InpLine_CheckScrollFromLast(Me)
			End
		End;
		LastWidth:=X2-X1;

		If Enabled Then
		Begin
			Gfx.AngleRect(X1, Y1, X2, Y2, Kernel.ClrEditDarker);
			Gfx.AngleRect(X1+1, Y1+1, X2, Y2, Kernel.ClrEditDark)
		End
		Else Begin
			Gfx.AngleRect(X1, Y1, X2, Y2, Kernel.ClrDisabled);
			Gfx.AngleRect(X1+1, Y1+1, X2, Y2, Kernel.ClrDisabled2)
		End;
		Gfx.Rectangle(X1+2, Y1+2, X2, Y2, ClrFill);

		Gfx.Bar(X1+2, Y1+2, X1+IconWidth+InpArrowsWidth+1, Y2, ClrFill);
		If Icon<>Nil Then
			If Enabled
				Then Gfx.PutSprite(X1+3, Y1+3, Icon)
				Else Gfx.PutSpriteGrayed16(X1+3, Y1+3, Icon);

		Gfx.Bar(X1+IconWidth+2, Y1+2, X1+IconWidth+InpArrowsWidth+1,
			Y2-1, ClrFill);
		If Scroll And (FirstChar>1) Then
			Gfx.PutSprite(X1+2+IconWidth, Y1+2, PicInpL[Enabled, LeftDown]);

		Gfx.Bar(X2-InpArrowsWidth, Y1+2, X2-1, Y2-1, ClrFill);
		If Scroll And (LastChar<Length(S)) Then
			Gfx.PutSprite(X2-InpArrowsWidth, Y1+2, PicInpR[Enabled, RightDown]);

		If Kernel.ActiveWin<>Nil
			Then SystemActiveCtl:=Kernel.ActiveWin^.ActiveCtl
			Else SystemActiveCtl:=Nil;
		InpLine_DrawText(Me, SystemActiveCtl=Me^.FocusCtl);
		If Enabled Then
			InpLine_DrawCursor(Me, SystemActiveCtl=Me)
	End
End;

Procedure InpLine_Paint(Me:PControl; VX1,VY1,VX2:Integer);
Begin
	With Me^.Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY1+20, Me^.Place);
	InpLine_IntDraw(Me)
End;

Procedure InpLine_PaintDirect(Me:PControl; VX1,VY1,VX2:Integer);
Begin
	D.AssignRect(VX1, VY1, VX2, VY1+20, Me^.Place);
	InpLine_IntDraw(Me)
End;



Procedure InpLine_CursorTimer(Me:PControl; Times:Integer);
Var
	CurX: Integer;
Begin
	With Me^, Place, TInpLine(Data^) Do
	Begin
		If (Not CanDraw) Or (Me^.Owner<>Kernel.ActiveWin) Or
			(Not Visible) Or (Me^.FocusCtl<>Me^.Owner^.ActiveCtl) Then Exit;

		CurX:=InpLine_CursorX(Me);
		If Color=Kernel.ClrEditFont
			Then If Selection And D.InRange(CursorPos, SelStart-1, SelEnd)
				Then Color:=Kernel.ClrEditSel
				Else Color:=Kernel.ClrEdit
			Else Color:=Kernel.ClrEditFont;
		Kernel.BeginPaintCoord(CurX, Y1+3, CurX, Y2-1);
		Gfx.Line(CurX, Y1+4, CurX, Y2-2, Color);
		Kernel.EndPaint
	End
End;

Procedure InpLine_Select(Me:PControl; LastPos:Integer);
Begin
	With Me^, TInpLine(Data^) Do
	Begin
		If (Not Selection) Or
			((LastPos<>SelStart) And (LastPos<>SelEnd)) Then
		Begin
			SelStart:=CursorPos;
			SelEnd:=LastPos;
			Selection:=True
		End
		Else Begin
			If LastPos=SelStart
				Then SelStart:=CursorPos
				Else SelEnd:=CursorPos;
			If SelStart=SelEnd Then
				Selection:=False;
		End;
		If SelStart>SelEnd Then
			D.SwapInt(SelStart, SelEnd);
	End
End;

Procedure InpLine_DelSel(Me:PControl);
Begin
	With Me^, TInpLine(Data^) Do
		If Selection Then
		Begin
			S:=Copy(S, 1, SelStart)+Copy(S, SelEnd+1, Length(S)-SelEnd);
			CursorPos:=SelStart;
			D.NotMore(FirstChar, CursorPos);
			Selection:=False
		End
End;

Procedure InpLine_Copy(Me:PControl);
Var
	F: Text;
Begin
	With Me^, TInpLine(Data^) Do
		If Selection Then
		Begin
			Assign(F, 'clipbrd.txt');
			Rewrite(F);
			Write(F, Copy(S, SelStart, SelEnd-SelStart));
			Close(F);
			If D.HostOS=osWindows Then
				D.WinCopy
		End
End;

Procedure InpLine_Cut(Me:PControl);
Begin
	InpLine_Copy(Me);
	InpLine_DelSel(Me)
End;

Procedure InpLine_Paste(Me:PControl);
Var
	F: Text;
	TempStr: String;
Begin
	If D.HostOS=osWindows Then
		D.WinPaste;
	With Me^, TInpLine(Data^) Do
	Begin
		If Selection Then
			InpLine_DelSel(Me);
		Assign(F, 'clipbrd.txt');
		Reset(F);
		Readln(F, TempStr);
		S:=Copy(S, 1, CursorPos)+TempStr+Copy(S, CursorPos+1, Length(S)-CursorPos);
		Inc(CursorPos, Length(TempStr))
	End
End;

Procedure InpLine_SelectAll(Me:PControl);
Begin
	With Me^, TInpLine(Data^) Do
		If Length(S)>0 Then
		Begin
			Selection:=True;
			SelStart:=0;
			SelEnd:=Length(S)
		End
End;



Function InpLine_OnKey(Me:PControl; Key,ExtKey:Char): Boolean;
Var
	T: LongInt;
	Recognized, Flag: Boolean;
	LastPos: Integer;
	TempStr: String;
Begin
	Recognized:=False;
	With Me^, TInpLine(Data^) Do
	Begin
		LastPos:=CursorPos;
		If (Key=#0) And (ExtKey In [#75, #77, #83, #71, #79, #115, #116]) Then
		Begin
			Case ExtKey Of
					{ Left arrow }
				#75: If CursorPos>0 Then
				Begin 
					Dec(CursorPos);
					If (D.KeyStatus And (ksLeftShift+ksRightShift))<>0
						Then InpLine_Select(Me,LastPos)
						Else If InpLineArrowsRemoveSel Then
							Selection:=False
				End;
					{ Right arrow }
				#77: If CursorPos<Length(S) Then
				Begin
					Inc(CursorPos);
					If (D.KeyStatus And (ksLeftShift+ksRightShift))<>0
						Then InpLine_Select(Me,LastPos)
						Else If InpLineArrowsRemoveSel Then
							Selection:=False
				End;
					{ Del }
				#83: If Not Selection Then
				Begin
					If Scroll And (CursorPos=LastChar) Then
					Begin
						Inc(LastChar, 5);
						NotMore(LastChar, Length(S));
						InpLine_CheckScrollFromLast(Me)
					End
					Else
						If CursorPos<Length(S) Then
							S:=Copy(S, 1, CursorPos)+
								Copy(S, CursorPos+2, Length(S)-CursorPos-1)
				End
				Else
					InpLine_DelSel(Me);

					{ Home }
				#71: If CursorPos<>0 Then
				Begin
					CursorPos:=0;
					If (D.KeyStatus And (ksLeftShift+ksRightShift))<>0
						Then InpLine_Select(Me, LastPos)
						Else If InpLineArrowsRemoveSel Then
							Selection:=False
				End;
					{ End }
				#79: If CursorPos<>Length(S) Then
				Begin
					CursorPos:=Length(S);
					InpLine_CheckScrollFromLast(Me);
					If (D.KeyStatus And (ksLeftShift+ksRightShift))<>0
						Then InpLine_Select(Me, LastPos)
						Else If InpLineArrowsRemoveSel Then
							Selection:=False
				End;
					{ Ctrl+Left }
				#115: If CursorPos>0 Then
				Begin
					Repeat
						Dec(CursorPos)
					Until (S[CursorPos+1]=' ') Or (CursorPos=0);
					If (D.KeyStatus And (ksLeftShift+ksRightShift))<>0
						Then InpLine_Select(Me, LastPos)
						Else If InpLineArrowsRemoveSel Then
							Selection:=False
				End;
					{ Ctrl+Right }
				#116: If CursorPos<Length(S) Then
				Begin
					Flag:=False;
					Repeat
						Inc(CursorPos);
						If CursorPos=Length(S)
							Then Flag:=True
					Until (S[CursorPos+1]=' ') Or Flag;
					InpLine_CheckScrollFromLast(Me);
					If (D.KeyStatus And (ksLeftShift+ksRightShift))<>0
						Then InpLine_Select(Me, LastPos)
						Else If InpLineArrowsRemoveSel Then
							Selection:=False
				End
			End;
			Recognized:=True
		End;

		If Key In [' '..#255, #8, ^X, ^C, ^V, ^A] Then
		Begin
			Case Key Of
					{ Character key }
				' '..#255: Begin
					If Selection Then InpLine_DelSel(Me);
					If OwnerCtl=Nil
						Then TempStr:=OnChange(Owner, Me, Key)
						Else TempStr:=OnChange(Owner, OwnerCtl, Key);
					S:=Copy(S, 1, CursorPos)+TempStr+
						Copy(S, CursorPos+1, Length(S)-CursorPos);
					Inc(CursorPos, Length(TempStr));
					InpLine_CheckScroll(Me)
				End;
					{ Backspace }
				#8: If CursorPos>0 Then
					If Not Selection Then
						If CursorPos+1=FirstChar Then
						Begin
							Dec(FirstChar, 5);
							NotLess(FirstChar, 1)
						End
						Else Begin
							S:=Copy(S, 1, CursorPos-1)+
								Copy(S, CursorPos+1, Length(S)-CursorPos);
							Dec(CursorPos)
						End
					Else
						InpLine_DelSel(Me);
					{ Ctrl+X }
				^X: InpLine_Cut(Me);
					{ Ctrl+C }
				^C: InpLine_Copy(Me);
					{ Ctrl+V }
				^V: InpLine_Paste(Me);
					{ Ctrl+A }
				^A: InpLine_SelectAll(Me)
			End;
			Recognized:=True
		End;

		If (Key In [#13, #27]) And (@OnChange<>@InpLineChangeDummy) Then
		Begin
			If OwnerCtl=Nil
				Then TempStr:=OnChange(Owner, Me, Key)
				Else TempStr:=OnChange(Owner, OwnerCtl, Key);
			Recognized:=True
		End;

		If Recognized Then
		Begin
			Color:=Kernel.ClrEdit;
			InpLine_IntDraw(Me)
		End
	End;
	InpLine_OnKey:=Recognized
End;

Procedure InpLine_ScrollTimer(Me:PControl; Times:Integer);
Var
	PaintNeeded: Boolean;
Begin
	With Me^, Place, TInpLine(Data^) Do
	Begin
		PaintNeeded:=False;

		If (InpZone=szLeft) And (FirstChar>1) Then
		Begin
			Dec(FirstChar);
			CursorPos:=FirstChar-1;
			InpLine_CheckScroll(Me);
			PaintNeeded:=True
		End;

		If (InpZone=szRight) And (LastChar<Length(S)) Then
		Begin
			Inc(LastChar);
			CursorPos:=LastChar;
			InpLine_CheckScrollFromLast(Me);
			PaintNeeded:=True
		End;

		If InpZone=szText Then
		Begin
			If D.InRange(Kernel.MsX, X1, X1+IconWidth+InpArrowsWidth+1) Then
				If FirstChar>1 Then
				Begin
					LeftDown:=True;
					Dec(FirstChar);
					CursorPos:=FirstChar-1;
					SelStart:=Pos1;
					SelEnd:=CursorPos;
					If SelStart>SelEnd Then
						D.SwapInt(SelStart, SelEnd);
					If SelStart<>SelEnd
						Then Selection:=True
						Else Selection:=False;
					InpLine_CheckScroll(Me);
					PaintNeeded:=True
				End
				Else
					If SelStart<>0 Then
					Begin
						SelStart:=0;
						CursorPos:=0;
						PaintNeeded:=True
					End;

			If D.InRange(Kernel.MsX,X2-InpArrowsWidth,X2) Then
				If LastChar<Length(S) Then
				Begin
					RightDown:=True;
					Inc(LastChar);
					CursorPos:=LastChar;
					SelStart:=Pos1;
					SelEnd:=CursorPos;
					If SelStart>SelEnd Then
						D.SwapInt(SelStart,SelEnd);
					If SelStart<>SelEnd
						Then Selection:=True
						Else Selection:=False;
					InpLine_CheckScrollFromLast(Me);
					PaintNeeded:=True
				End
				Else
					If SelEnd<>Length(S) Then
					Begin
						SelEnd:=Length(S);
						CursorPos:=SelEnd;
						PaintNeeded:=True
					End;

			If D.InRange(Kernel.MsX, X1+IconWidth+InpArrowsWidth+2,
				X2-InpArrowsWidth-1) Then
			Begin
				If LeftDown Or RightDown Then
					PaintNeeded:=True;
				LeftDown:=False;
				RightDown:=False
			End
		End;

		If PaintNeeded Then
		Begin
			Kernel.BeginPaint(Place);
			InpLine_IntDraw(Me);
			Kernel.EndPaint
		End
	End
End;

Procedure InpLine_OnWheel(Me:PControl; Delta:Integer);
Begin
	With Me^, TInpLine(Data^) Do
	Begin
		If (Delta>0) And (LastChar<Length(S)) Then
		Begin
			Inc(LastChar, Delta{*3});
			D.NotMore(LastChar, Length(S));
			CursorPos:=LastChar;
			InpLine_CheckScrollFromLast(Me)
		End;
		If (Delta<0) And (FirstChar>1) Then
		Begin
			Inc(FirstChar, Delta{*3});
			D.NotLess(FirstChar, 1);
			CursorPos:=FirstChar-1;
			InpLine_CheckScroll(Me)
		End;
		Kernel.BeginPaint(Place);
		InpLine_IntDraw(Me);
		Kernel.EndPaint
	End
End;

Procedure InpLine_HideMouse(Var X,Y:Integer);
Begin
	LastMsX:=X;
	LastMsY:=Y;
	Kernel.HideMouse(X, Y)
End;

Function InpLine_TextPos(Me:PControl; X:Integer): Integer;
Var
	Temp: String;
	CurPos, BestPos, BestDist: Integer;
	I, NewI, Step, Dist, LastDist: Integer;
Begin
	With Me^, Place, TInpLine(Data^) Do
	Begin
		Font.SetFont(Kernel.CurFont);
		CurPos:=X1+IconWidth+InpArrowsWidth+2;
		BestPos:=FirstChar-1;
		BestDist:=Abs(CurPos-X);
		For I:=FirstChar To LastChar Do
		Begin
			Inc(CurPos, Font.ChWidth(S[I]));
			If Abs(CurPos-X)<BestDist Then
			Begin
				BestPos:=I;
				BestDist:=Abs(CurPos-X)
			End
		End;
		InpLine_TextPos:=BestPos
	End
End;


Procedure InpLine_ShowMouse(Var X,Y:Integer);
Var
	Temp: Integer;
Begin
	If InpZone In [szLeft, szRight] Then
	Begin
		X:=LastMsX;
		Y:=LastMsY
	End
	Else
		With CurCtl^, Place, TInpLine(Data^) Do
		Begin
			Y:=LastMsY;
			If D.InRange(X, X1+IconWidth+InpArrowsWidth+2, X2-InpArrowsWidth-2) Then
			Begin
				Temp:=InpLine_TextPos(CurCtl, X);
				If Temp=CursorPos Then
				Begin
					Kernel.ShowMouse(X, Y);
					Exit
				End;
				CursorPos:=Temp;
				SelStart:=Pos1;
				SelEnd:=CursorPos;
				If SelStart>SelEnd Then
					D.SwapInt(SelStart, SelEnd);
				If SelStart<>SelEnd
					Then Selection:=True
					Else Selection:=False
			End;
			D.ToRange(X, X1+IconWidth+InpArrowsWidth-1, X2-InpArrowsWidth+2);
			InpLine_IntDraw(CurCtl)
		End;
	Kernel.ShowMouse(X, Y)
End;

Procedure InpLine_OnContextMenuClick(Me:PProg; Item:PMenuItem);
Begin
	If String(Item^.Name^)='i' Then
		InpLine_Cut(CurCtl);
	If String(Item^.Name^)='i' Then
		InpLine_Copy(CurCtl);
	If String(Item^.Name^)='⠢' Then
		InpLine_Paste(CurCtl);
	If String(Item^.Name^)='i ' Then
		InpLine_SelectAll(CurCtl);
	InpLine_IntDraw(CurCtl)
End;

Procedure InpLine_OnClick(Me:PControl; X,Y:Integer);
Begin
	If Mouse.GetMask=Mouse.mbRight Then
	Begin { i ࠢ  誨,  ⥪⭥  }
		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(Kernel.HideMouse,
			Kernel.ShowMouse, Kernel.RefreshNeeded)=Mouse.mbNone;

		CurCtl:=Me;
		With Me^, TInpLine(Data^) Do
			Popup.OpenMenu(Me^.Owner, ContextMenu, Kernel.MsX, Kernel.MsY);
		Exit
	End;

	CurCtl:=Me;
	LastMsX:=X;
	LastMsY:=Y;
	With Me^,Place,TInpLine(Data^) Do
	Begin
		If D.InRange(X, X1, X1+IconWidth+InpArrowsWidth+2) Then
		Begin
			InpZone:=szLeft;
			Kernel.SelectCursor(MouseScrLeft);
			LeftDown:=True
		End;
		If D.InRange(X, X1+IconWidth+InpArrowsWidth+2, X2-InpArrowsWidth-2) Then
			InpZone:=szText;
		If D.InRange(X, X2-InpArrowsWidth-1, X2) Then
		Begin
			InpZone:=szRight;
			Kernel.SelectCursor(MouseScrRight);
			RightDown:=True
		End
	End;

	If InpZone=szText Then
	Begin
		Pos1:=InpLine_TextPos(Me,X);
		TInpLine(Me^.Data^).CursorPos:=Pos1;
		TInpLine(Me^.Data^).Color:=Kernel.ClrEdit;
		TInpLine(Me^.Data^).Selection:=False;
		InpLine_IntDraw(Me);
		Kernel.SelectCursor(Kernel.MouseText)
	End;
	Kernel.AddTimer(Me, InpLine_ScrollTimer, 1);

	Repeat
		Kernel.CheckSysKeys
	Until Kernel.HeartOfPolit(InpLine_HideMouse, InpLine_ShowMouse,
		Kernel.RefreshNeeded)=0;

	Kernel.SelectCursor(Kernel.MouseDefault);
	Kernel.RemoveTimer(Me, InpLine_ScrollTimer);
	TInpLine(Me^.Data^).LeftDown:=False;
	TInpLine(Me^.Data^).RightDown:=False;
	InpLine_IntDraw(Me)
End;


Procedure InpLine_SetText(Me:PControl; VText:String);
Begin
	With Me^, TInpLine(Data^) Do
	Begin
		S:=VText;
		FirstChar:=1;
		CursorPos:=Length(S);
		Selection:=False;
		If AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
			If (Me^.CanDraw Or Kernel.DontBother) And Visible Then
			Begin
				Kernel.BeginPaint(Place);
				InpLine_IntDraw(Me);
				Kernel.EndPaint
			End
	End
End;

Procedure InpLine_Draw(Me:PControl);
Begin
	With Me^ Do
		If CanDraw Or Kernel.DontBother Then
		Begin
			Kernel.BeginPaint(Place);
			If Visible
				Then InpLine_IntDraw(Me)
				Else Kernel.HideCtl(Me);
			Kernel.EndPaint
		End
End;

Function InpLine_GetText(Me:PControl):String;
Begin
	With TInpLine(Me^.Data^) Do
		InpLine_GetText:=S
End;

Procedure InpLine_SetOnChangeFunc(Me:PControl; VOnChange:TInpLineChangeFunc);
Begin
	With Me^,TInpLine(Data^) Do
		OnChange:=VOnChange
End;

Procedure InpLine_OnDestroy(Me:PControl);
Begin
	With Me^ Do
		FreeMem(Data, SizeOf(TInpLine));
	Kernel.RemoveTimer(Me, InpLine_CursorTimer)
End;


Function InpLine_Create(Prog:PProg; VText:String; VIcon:Pointer): PControl;
Var
	Me:PControl;
	TempPeriod:Integer;
Begin
	{Log.BugMsg('Ctl', 'InpLine_Create', 'Starting...');}
	Me:=Kernel.AddCtl(Prog);
	{Log.BugMsg('Ctl', 'InpLine_Create', 'Kernel.AddCtl ok');}
	With Me^ Do
	Begin
		OnClick:=InpLine_OnClick;
		OnKey:=InpLine_OnKey;
		OnRefocus:=InpLine_OnRefocus;
		OnWheel:=InpLine_OnWheel;
		OnDestroy:=InpLine_OnDestroy;
		{Log.BugMsg('Ctl', 'InpLine_Create', 'Handlers ok');}
		GetMem(Data, SizeOf(TInpLine));
		{Log.BugMsg('Ctl', 'InpLine_Create', 'GetMem(Data) ok');}
		With TInpLine(Data^) Do
		Begin
			S:=VText;
			FirstChar:=1;
			CursorPos:=Length(S);
			Color:=Kernel.ClrEdit;
			LastWidth:=30000;
			Selection:=False;
			LeftDown:=False;
			RightDown:=False;
			Icon:=VIcon;
			If Icon=Nil
				Then IconWidth:=0
				Else IconWidth:=Gfx.ImageX(Icon)+4;
			OnChange:=InpLineChangeDummy;
			{Log.BugMsg('Ctl', 'InpLine_Create', 'Data init ok');}

			ContextMenu:=Popup.CreateMenu;
			Popup.AddCommand(ContextMenu, 'i', 'Ctrl+X',
				'७ i ⥪  ',
				Kernel.PicCut, True, InpLine_OnContextMenuClick);
			Popup.AddCommand(ContextMenu, 'i', 'Ctrl+C',
				'i i ⥪  ',
				Kernel.PicCopy, True, InpLine_OnContextMenuClick);
			Popup.AddCommand(ContextMenu, '⠢', 'Ctrl+V',
				'⠢ ⥪ i ',
				Kernel.PicPaste, D.FileExist('clipbrd.txt'),
				InpLine_OnContextMenuClick);
			Popup.AddSpace(ContextMenu);
			Popup.AddCommand(ContextMenu, 'i ', 'Ctrl+A',
				'i  ⥪  i ',
				Nil, True, InpLine_OnContextMenuClick);
			{Log.BugMsg('Ctl', 'InpLine_Create', 'Context popup ok');}
		End
	End;
	Ini.Select('polit.ini', 'Controls');
	TempPeriod:=Ini.GetInt('CursorBlinkPeriod', 5);
	If TempPeriod>0 Then
		Kernel.AddTimer(Me, InpLine_CursorTimer, TempPeriod);
	{Log.BugMsg('Ctl', 'InpLine_Create', 'Finishing');}
	InpLine_Create:=Me
End;
