{$F+}
Unit
	Kernel; { Polit Halcyon kernel }

Interface

Uses
	Types, Log, Ini, D, Gfx, Pic, Font, Mouse, BCRT, DOS{, LFN} {,WinAPI};

Const
	FirstWinLook: PWinLook=Nil;
	FirstProg: PProg=Nil;
	FirstEvent: PEvent=Nil;
	FirstRes: PResource=Nil;
	FirstBuiltIn: PBuiltIn=Nil;
	FirstTimer: PTimer=Nil;
	FirstScrSaver: PScreenSaver=Nil;
	FirstCursor: PCursor=Nil;
	FirstWinPos: PWinPos=Nil;

	LoadingStepsTotal=96;
	MouseWorkingDelay=45;

Var
	CurFont: Pointer;
	MsX, MsY: Integer;
	MsX8, MsY8: Integer;
	MsSizeX, MsSizeY: Integer;
	MsRect: TRect;
	MouseVis: Boolean;
	MouseShadow: Integer;
	MouseDefault, MouseMove, MouseResizeHor, MouseResizeVer,
	MouseResizeDiag1, MouseResizeDiag2, MouseText, MouseNo,
	MouseWait: Pointer;
	MouseWorking: Array[1..4] Of Pointer;
	MouseWorkingFrame, MouseWorkingSubframe: Integer;

	ActiveWin: PProg;
	Screen: TRect;
	{ProcsTable: TProcsTable;}

	ClrWinBG, ClrWinDarkBG,
	ClrWinLight, ClrWinDark,
	Clr3DFace, Clr3DLight, Clr3DDark,
	Clr3DAct, Clr3DActLight, Clr3DActDark,
	ClrText, ClrTextDis, ClrTextCom, ClrTextAct,
	ClrAccent, ClrAccent2,
	ClrDisabled, ClrDisabled2, ClrStatic,
	ClrLines, ClrLines2: TColor;
	ClrEdit, ClrEditDark, ClrEditDarker,
	ClrEditFont, ClrEditSel, ClrEditSelFont: TColor;
	ClrList, ClrListDark, ClrListDarker,
	ClrListFont, ClrListSel, ClrListSelFont: TColor;

	HintHideTime, HintShowTime, HintShadowDepth: Integer;
	HintAnimate: Boolean;

	DontBother: Boolean; { for covered controls paint (ToFrontWindow) }
	IgnoreAutoRedraw: Boolean; { ignore control AutoRedraw during prog OnInit }

	MouseDir, SkinDir, TempDir: String;

		{   Popup  i 祩 }
	HideMouseProc, ShowMouseProc: TMouseProc2;
	RefreshNeededFunc: TRefreshNeededFunc;
	HideMouseSave, ShowMouseSave: TMouseProc2;
	RefreshNeededSave: TRefreshNeededFunc;
	InsideHeart: Boolean;
	HintPresent: Boolean;
	LastMouseMove: LongInt;
	MsSpeed: Integer;

	PicOK, PicApply, PicClose: Pointer;
	PicCut, PicCopy, PicPaste{, PicErase}: Pointer;

	KeybLayout: Array[1..4, #0..#255] Of Char;
	KeybLayoutName: Array[0..4] Of String[2];
	CurLayout, LayoutNum: Integer;


	Procedure CtlClickDummy(Me:PControl; X, Y:Integer);
	Procedure CtlDummy(Me:PControl);
	Procedure CtlDummyProc(Me:PProg; Control:PControl);
	Procedure CtlRefocusDummy(Me:PControl; Focused:Boolean);
	Function CtlKeyDummy(Me:PControl; Key,ExtKey:Char): Boolean;
	Procedure CtlWheelDummy(Me:PControl; Delta:Integer);
	Procedure WinLookDummy(Prog:PProg);
	Procedure WinLookClickDummy(Prog:PProg; X,Y:Integer);
	Procedure DummyProc(Me:PProg);
	Function DummyMessageFunc(Me, Sender:PProg; Msg:String; Data:Pointer): Pointer;
	Function DummyKeyFunc(Me:PProg; Key,ExtKey:Char): Boolean;

	Function LoadRes(FName:String): Pointer;
	Function LoadBMPRes(FName:String): Pointer;
	Function LoadSkinBMPRes(FName:String): Pointer;
	Procedure FreeRes(Name:String);

	Procedure RefreshAllCanDrawFlags;

	Procedure RegBuiltIn(Name,FriendlyName,IconFName:String; OnInit:TProc);
	Function FindBuiltIn(Name:String): PBuiltIn;
	Procedure RunBuiltIn(Name,Params:String);
	Procedure RunChild(Me:PProg; VOnInit:TProc; Params:String);
	Procedure RunChild2(Me:PProg; Name,Params:String);
	{Procedure RunDLL(Name,Params:String);}
	Procedure CloseProg(Prog:PProg);
	Function FindProg(VName:String): PProg;
	Function FindProgPlus(VName, VParam:String): PProg;

	Procedure RunDOSApp(FName,Params:String);
	Procedure RunFile(FName:String);
	Function GetFileIcon(FName:String): Pointer;
	Function GetFileDescr(FName:String): String;

	Function FindWinPos(VName:String): PWinPos;

	Procedure HideWindow(Prog:PProg);
	Procedure MinimizeWindow(Prog:PProg);
	Procedure ToFrontWindow(Prog:PProg; ForceDraw:Boolean);
	Procedure ToFrontWindowChilds(Prog:PProg);
	Procedure DeactivateWindow(Prog:PProg);
	Procedure ResizeOrMoveWindow(Prog:PProg; NewX1,NewY1,NewX2,NewY2:Integer);
	Procedure MaximizeWindow(Prog:PProg);
	Procedure SlidePanel(Prog:PProg);

	Procedure SetWindowCaption(Prog:PProg; VCaption:String);
	Procedure SetWindowCapAndIcon(Prog:PProg; VCaption:String; VIcon:Pointer);
	Procedure FitAllWindowsToScreen(ToDraw: Boolean);
	Procedure AssignWinSize(Prog:PProg; NewX,NewY:Integer);

	Procedure ShowHint(HintText:String);

	Procedure DesktopPopupPlus(VX1,VY1:Integer);
	Procedure DesktopPopup;

	Function AddCtl(VProg:PProg): PControl;
	Procedure DestroyCtl(Me:PProg; Control:PControl);
	Procedure HideCtl(Ctl:PControl);

	Procedure RegWinLook(Struc:TWinLook);
	Function FindWinLook(Name:String): PWinLook;

	Procedure AddEventFunc(Name:String; Func:TEventFunc; Owner:PProg);
	Procedure RemoveEventFunc(Func:TEventFunc; Owner:PProg);
	Procedure RaiseEvent(Name:String; Params:Pointer);

	Procedure InitWindow(Prog:PProg; WinLookName:String;
		VWinButtons:TWinButtonSet);
	Procedure InitPanelWindow(Prog:PProg; WinLookName:String;
		Border:TBorder; VWinButtons:TWinButtonSet; Width:Integer);
	Procedure InitSheetWindow(Prog:PProg; WinLookName:String;
		VWinButtons:TWinButtonSet; VWinBorder:TBorder);
	Procedure EmptyWindow(Prog:PProg);
	Procedure DrawWindow(Prog:PProg);
	Procedure DrawWindowAni(Prog:PProg);
	Procedure DrawWindowFrame(Prog:PProg);
	Procedure PaintWindow(Prog:PProg);
	Procedure RefreshCanDrawFlags(Prog:PProg);
	Procedure ResetTimers;

	Procedure WindowBar(X1,Y1,X2,Y2:Integer; Dark,Mimic:Boolean);
	Procedure DarkBar(X1,Y1,X2,Y2:Integer);
	Procedure WinBGBar(Prog:PProg; X1,Y1,X2,Y2:Integer);

	Procedure HideMouse(Var X,Y:Integer);
	Procedure ShowMouse(Var X,Y:Integer);
	Function RefreshNeeded(Rect:TRect): Boolean;
	Procedure PlaceMouse(NewX,NewY: Integer);

	Procedure BeginPaint(Rect:TRect);
	Procedure BeginPaintCoord(X1,Y1,X2,Y2:Integer);
	Procedure EndPaint;

	Procedure SelectFocusCtl(Prog:PProg; VCtl:PControl);
	Procedure ClickCtl(Prog:PProg; VCtl:PControl);

	Procedure AddTimer(VCtl:PControl; VProc:TTimerProc; VFreq:Integer);
	Procedure RemoveTimer(VCtl:PControl; VProc:TTimerProc);

	Procedure CheckSysKeys;
	Procedure TakeScreenShot;
	Procedure Key(C1,C2:Char; KStatus:Word);
	Function HeartOfPolit(VHideMouse,VShowMouse:TMouseProc2;
		VRefreshNeeded:TRefreshNeededFunc): Word;
	Procedure HeartShell;
	Function WhichWin(X,Y:Integer): PProg;
	Function WhichControl(Prog:PProg; X,Y:Integer; CanBeDisabled:Boolean): PControl;
	Procedure GoodbyePolit;
	Procedure LoadingStep;
	Procedure StartUp;
	Procedure RestartPolit;

	Function ShortenStr(S:String; Width:Integer): String;
	Function ShortenStrFW(S:String; Width:Integer): String;
	Procedure WaitTicks(N:Integer);

	Procedure RegScrSaver(VName:String; VOnInit,VOnIdle:TScreenSaverProc);

	Function LoadCursor(Name:String): Pointer;
	Procedure FreeCursor(VImage:Pointer);
	Procedure SelectCursor(VImage:Pointer);
	Procedure MouseWorkingNextFrame;

	Function SendMessage(Sender,Receiver:PProg; Msg:String; Data:Pointer): Pointer;

		{  i Popup  i 祩 }
	Procedure ExecTimers;
	Procedure Click;
	Procedure ShowHintPlus;


Implementation

Uses { god bless BP7 developers for unit cross-references ! }
	Ctl, Ctl2, Ctl3, WinLook, Popup;

Var
	MsImage, MsSave: Pointer;
	MsHotX, MsHotY: Word;

	ZList: Array[1..128] Of PProg; { For Z-Index supporting stuff }
	ZListNum: Integer;

	HintX1, HintY1, HintX2, HintY2: Integer;
	HintImage, HintUnderImage: Pointer;
	
	ScrSaveTime: LongInt;
	ScrSaver: PScreenSaver;

	{PopupItemsNum: Integer;
	PopupItem: Array[1..30] Of Record
		Name, HotKey, Hint: PStr;
		Icon: Pointer;
		Y: Integer
	End;
	PopupX1, PopupY1, PopupX2, PopupY2: Integer;
	PopupMsItem: Integer;}
	PolitLogoPic: Pointer;
	LoadingSteps: Integer;
	LoadingNow: Boolean;

	PicShot, PicReboot, PicQuit, PicSaver: Pointer; { for DesktopPopup }

	MachineSpeed: LongInt;
	MnuDesktop: PMenuItem;
	WinBGMode: (bgSolidColor, bgMetal, bgStriped);

	PicFileUnknown, PicFileText, PicFilePicture, PicFileProgram,
	PicFileVideo, PicFileMusic, PicFileHTML,
	PicFileRFont, PicFileVFont: Pointer;

	LastKeyStatus: Word;
	






Procedure CtlClickDummy(Me:PControl; X,Y:Integer);
Begin End;

Procedure CtlDummy(Me:PControl);
Begin End;

Procedure CtlDummyProc(Me:PProg; Control:PControl);
Begin End;

Procedure CtlRefocusDummy(Me:PControl; Focused:Boolean);
Var
	BGColor: Word;
Begin
	With Me^.Place Do
		If Focused Then
		Begin
			Case WinBGMode Of
				bgSolidColor, bgStriped: Gfx.Rectangle(X1-2, Y1-2, X2+2, Y2+2,
					ClrAccent2);
				bgMetal: Gfx.TranspButtonRect(X1-2, Y1-2, X2+2, Y2+2,
					ClrAccent, ClrAccent, 40);
			End;
			Gfx.Rectangle(X1-1, Y1-1, X2+1, Y2+1, ClrAccent)
		End
		Else Case WinBGMode Of
			bgSolidColor: Begin
				BGColor:=Gfx.GetPixel(X1-3, Y1);
				Gfx.Rectangle(X1-1, Y1-1, X2+1, Y2+1, BGColor);
				Gfx.Rectangle(X1-2, Y1-2, X2+2, Y2+2, BGColor)
			End;
			bgMetal: Begin
				Gfx.SteelBarMimic(X1-2, Y1-2, X2+2, Y1-1, mdRandom);
				Gfx.SteelBarMimic(X1-2, Y2+1, X2+2, Y2+2, mdRandom);
				Gfx.SteelBarMimic(X1-2, Y1, X1-1, Y2, mdLeft);
				Gfx.SteelBarMimic(X2+1, Y1, X2+2, Y2, mdRight);
			End;
			bgStriped: Begin
				Gfx.StripedBarMimic(X1-2, Y1-2, X2+2, Y1-1, mdRandom);
				Gfx.StripedBarMimic(X1-2, Y2+1, X2+2, Y2+2, mdRandom);
				Gfx.StripedBarMimic(X1-2, Y1, X1-1, Y2, mdLeft);
				Gfx.StripedBarMimic(X2+1, Y1, X2+2, Y2, mdRight);
			End;
		End
End;

Function CtlKeyDummy(Me:PControl; Key,ExtKey:Char): Boolean;
Begin
	CtlKeyDummy:=False
End;

Procedure CtlWheelDummy(Me:PControl; Delta:Integer);
Begin
End;

Procedure WinLookDummy(Prog:PProg);
Begin End;

Procedure WinLookClickDummy(Prog:PProg; X,Y:Integer);
Begin End;

Procedure DummyProc(Me:PProg);
Begin End;

Function DummyMessageFunc(Me, Sender:PProg; Msg:String; Data:Pointer): Pointer;
Begin
	DummyMessageFunc:=Nil
End;

Function DummyKeyFunc(Me:PProg; Key,ExtKey:Char): Boolean;
Begin
	DummyKeyFunc:=False
End;




Function FindRes(Name:String): PResource;
Var
	Cur: PResource;
	Found: Boolean;
Begin
	Cur:=FirstRes;
	Found:=False;
	FindRes:=Nil;
	While (Cur<>Nil) And (Not Found) Do
	Begin
		If Cur^.Name=Name Then
		Begin
			Found:=True;
			FindRes:=Cur
		End
		Else
			Cur:=Cur^.Next
	End
End;

Function LoadRes(FName:String): PResData;
Var
	F: File;
	L: LongInt;
	Res, Cur: PResource;
Begin
	Res:=FindRes(D.ClipFNameExt(FName));
	If Res<>Nil Then
	Begin
		{Log.BugMsg('Kernel', 'LoadRes', 'Resource found & reused: '+FName);}
		LoadRes:=Res^.Data;
		Inc(Res^.UseCount);
		Exit
	End;

	If Not FileExist(FName) Then
	Begin
		Log.ErrMsg('Kernel', 'LoadRes', 'File not found: '+FName);
		Log.ActMsg('Ignoring load request');
		LoadRes:=Nil;
		Exit
	End;
	Assign(F, FName);
	Reset(F, 1);
	L:=FileSize(F);
	If L>65535 Then
	Begin
		Log.ErrMsg('Kernel', 'LoadRes', 'File size is >64K, cannot load');
		Log.ActMsg('Ignoring load request');
		Close(F);
		LoadRes:=Nil;
		Exit
	End;

	New(Cur);
	Cur^.Next:=FirstRes;
	FirstRes:=Cur;

	Cur^.Name:=D.ClipFNameExt(FName);
	Cur^.Size:=L;
	Cur^.UseCount:=1;
	GetMem(Cur^.Data, L);
	BlockRead(F, Cur^.Data^, L);
	Close(F);
	LoadRes:=Cur^.Data;
	{Log.SysMsg('Kernel', 'LoadRes', 'Resource loaded: '+FName)}
End;

Procedure AssignRes(FName:String; Res:Pointer; Size:Word);
Var
	F: File;
	L: LongInt;
	Cur: PResource;
Begin
	New(Cur);
	Cur^.Next:=FirstRes;
	FirstRes:=Cur;

	Cur^.Name:=D.ClipFNameExt(FName);
	Cur^.Size:=Size;
	Cur^.Data:=Res;
	Cur^.UseCount:=1;
	{Log.SysMsg('Kernel', 'AssignRes', 'Resource assigned: '+FName)}
End;

Function LoadBMPRes(FName:String): Pointer;
Var
	P: Pointer;
	Size: Word;
	Res: PResource;
Begin
	Res:=FindRes(D.ClipFNameExt(FName));
	If Res<>Nil Then
	Begin
		{Log.BugMsg('Kernel', 'LoadBMPRes', 'Resource found & reused: '+FName);}
		LoadBMPRes:=Res^.Data;
		Inc(Res^.UseCount);
		Exit
	End
	Else Begin
		Pic.LoadBMP(FName, P);
		Size:=Gfx.ImageSize2(P);
		AssignRes(FName, P, Size);
		LoadBMPRes:=P
	End
End;

Function LoadSkinBMPRes(FName:String): Pointer;
Begin
	LoadSkinBMPRes:=LoadBMPRes(SkinDir+FName);
	LoadingStep
End;

Procedure DestroyRes(FName:String);
Var
	Cur, Temp: PResource;
	Found: Boolean;
	ResName: String;
Begin
	ResName:=D.ClipFNameExt(FName);
	If FirstRes^.Name=ResName Then
	Begin
		FreeMem(FirstRes^.Data, FirstRes^.Size);
		Temp:=FirstRes^.Next;
		Dispose(FirstRes);
		FirstRes:=Temp
	End
	Else Begin
		Cur:=FirstRes;
		Found:=False;
		While (Cur^.Next<>Nil) And (Not Found) Do
			If Cur^.Next^.Name=ResName
				Then Found:=True
				Else Cur:=Cur^.Next;

		If Found Then
		Begin
			Temp:=Cur^.Next^.Next;
			FreeMem(Cur^.Next^.Data, Cur^.Next^.Size);
			Cur^.Next:=Temp
		End
		Else Begin
			Log.ErrMsg('Kernel', 'DestroyRes', 'Resource not found:'+FName);
			Log.ActMsg('Ignoring destroy request')
		End
	End
End;

Procedure FreeRes(Name:String);
Var
	TempRes: PResource;
Begin
	TempRes:=FindRes(D.ClipFNameExt(Name));
	If TempRes=Nil Then
	Begin
		Log.ErrMsg('Kernel', 'FreeRes', 'Resource not found: '+Name);
		Log.ActMsg('Ignoring destroy request');
		Exit
	End;
	If TempRes^.UseCount<=1
		Then DestroyRes(Name)
		Else Dec(TempRes^.UseCount)
End;

Procedure FreeAllRes;
Var
	Cur, Temp: PResource;
Begin
	While FirstRes<>Nil Do
	Begin
		Log.ErrMsg('Kernel', 'FreeAllRes', 'Lost resource, size = '+
			D.St(FirstRes^.Size));
		Temp:=FirstRes^.Next;
		FreeMem(FirstRes^.Data, FirstRes^.Size);
		Dispose(FirstRes);
		FirstRes:=Temp
	End
End;

Procedure RemoveAllTimers;
Begin
	While FirstTimer<>Nil Do
		RemoveTimer(FirstTimer^.Control, FirstTimer^.Proc)
End;











Procedure RegWinLook(Struc:TWinLook);
Var
	CurLook, NextLook: PWinLook;
Begin
	NextLook:=FirstWinLook;
	New(FirstWinLook);
	FirstWinLook^:=Struc;
	FirstWinLook^.Next:=NextLook;
	Log.SysMsg('Kernel', 'RegWinLook', 'New WinLook registered: '+String(FirstWinLook^.Name^))
End;

Procedure FreeAllWinLooks;
Var
	NextLook: PWinLook;
Begin
	While FirstWinLook<>Nil Do
	Begin
		NextLook:=FirstWinLook^.Next;
		D.FreePStr(FirstWinLook^.Name, 'Kernel - FreeAllWinLooks');
		Dispose(FirstWinLook);
		FirstWinLook:=NextLook
	End;
	FirstWinLook:=Nil {    }
End;



Procedure RegBuiltIn(Name,FriendlyName,IconFName:String; OnInit:TProc);
Var
	Cur: PBuiltIn;
Begin
	New(Cur);
	Cur^.Next:=FirstBuiltIn;
	FirstBuiltIn:=Cur;

	D.AssignPStr(Name, Cur^.Name);
	D.AssignPStr(FriendlyName, Cur^.FriendlyName);
	If IconFName=''
		Then Cur^.Icon:=Nil
		Else Pic.LoadBMP(IconFName, Cur^.Icon);
	Cur^.OnInit:=OnInit;
	Log.SysMsg('Kernel', 'RegBuiltIn', 'Built-in app registered: '+Name)
End;

Procedure FreeAllBuiltIns;
Var
	Temp: PBuiltIn;
Begin
	While FirstBuiltIn<>Nil Do
	Begin
		Temp:=FirstBuiltIn^.Next;
		D.FreePStr(FirstBuiltIn^.Name, 'Kernel - FreeAllBuiltIns');
		If FirstBuiltIn^.Icon<>Nil Then
			Gfx.FreeImage(FirstBuiltIn^.Icon);
			{FreeMem(FirstBuiltIn^.Icon, Gfx.ImageSize2(FirstBuiltIn^.Icon));}
		Dispose(FirstBuiltIn);
		FirstBuiltIn:=Temp
	End
End;

Function FindBuiltIn(Name:String): PBuiltIn;
Var
	Cur: PBuiltIn;
	Found: Boolean;
Begin
	Cur:=FirstBuiltIn;
	Found:=False;
	FindBuiltIn:=Nil;
	Name:=D.UpCaseLine(Name);
	While (Cur<>Nil) And (Not Found) Do
	Begin
		If D.UpCaseLine(String(Cur^.Name^))=Name Then
		Begin
			Found:=True;
			FindBuiltIn:=Cur
		End
		Else
			Cur:=Cur^.Next
	End
End;

Procedure RemoveFirstBuiltIn;
Var
	Temp: PBuiltIn;
Begin
	Temp:=FirstBuiltIn^.Next;
	Dispose(FirstBuiltIn);
	FirstBuiltIn:=Temp
End;





Procedure AddWinPos(WinPos:TWinPos);
Var
	Cur: PWinPos;
Begin
	New(Cur);
	Cur^:=WinPos;
	Cur^.Next:=FirstWinPos;
	FirstWinPos:=Cur
End;

Function FindWinPos(VName:String): PWinPos;
Var
	Cur: PWinPos;
	Found: Boolean;
Begin
	Cur:=FirstWinPos;
	Found:=False;
	While (Cur<>Nil) And (Not Found) Do
		If String(Cur^.Name^)=VName
			Then Found:=True
			Else Cur:=Cur^.Next;
	If Found
		Then FindWinPos:=Cur
		Else FindWinPos:=Nil
End;

Procedure LoadWinPosList;
Var
	F: Text;
	TempStr: String;
	Temp: TWinPos;
Begin
	If Not D.FileExist('winpos.dat') Then Exit;
	Assign(F, 'winpos.dat');
	Reset(F);
	While Not EOF(F) Do
	Begin
		ReadLn(F, TempStr);
		D.AssignPStr(TempStr, Temp.Name);
		ReadLn(F, Temp.X1, Temp.Y1);
		ReadLn(F, Temp.SizeX, Temp.SizeY);
		ReadLn(F);
		AddWinPos(Temp)
	End;
	Close(F)
End;

Procedure SaveAndFreeWinPosList;
Var
	F: Text;
	Cur, Temp: PWinPos;
Begin
	Assign(F, 'winpos.dat');
	Rewrite(F);
	Cur:=FirstWinPos;
	While Cur<>Nil Do
	Begin
		WriteLn(F, String(Cur^.Name^));
		WriteLn(F, Cur^.X1, ' ', Cur^.Y1);
		WriteLn(F, Cur^.SizeX, ' ', Cur^.SizeY);
		WriteLn(F);

		Temp:=Cur^.Next;
		Dispose(Cur);
		Cur:=Temp
	End;
	Close(F);
	FirstWinPos:=Nil
End;

Procedure GetProgWinPos(Prog:PProg; Var WinPos:TWinPos);
Begin
	With Prog^, WinLook^.ClientDeltaRect Do
	Begin
		D.AssignPStr(String(Name^{WinTitle^}), WinPos.Name);
		WinPos.X1:=WinRect.X1;
		WinPos.Y1:=WinRect.Y1;
		WinPos.SizeX:=WinRect.X2-WinRect.X1-X1+X2;
		WinPos.SizeY:=WinRect.Y2-WinRect.Y1-Y1+Y2
	End
End;

Procedure SetProgWinPos(Prog:PProg; WinPos:TWinPos);
Begin
	With Prog^, WinLook^.ClientDeltaRect Do
	Begin
		WinRect.X1:=WinPos.X1;
		WinRect.Y1:=WinPos.Y1;
		WinRect.X2:=WinRect.X1+WinPos.SizeX+X1-X2;
		WinRect.Y2:=WinRect.Y1+WinPos.SizeY+Y1-Y2
	End
End;

Procedure FitWindowToScreen(Prog:PProg; ToDraw:Boolean); Forward;

Procedure AssignWinSize(Prog:PProg; NewX,NewY:Integer);
Var
	DX, DY: Integer;
Begin
	If Prog^.Visible Then Exit;

	With Prog^ Do
	Begin
		DX:=NewX-(ClientRect.X2-ClientRect.X1+1);
		DY:=NewY-(ClientRect.Y2-ClientRect.Y1+1);
		Inc(WinRect.X2, DX);
		Inc(WinRect.Y2, DY);
		Inc(ClientRect.X2, DX);
		Inc(ClientRect.Y2, DY)
	End;
	FitWindowToScreen(Prog, False)
End;











Procedure ZListFree;
Begin
	ZListNum:=0
End;

Procedure ZListAdd(Prog:PProg);
Begin
	Inc(ZListNum);
	ZList[ZListNum]:=Prog
End;

Function ZListMaxZ:Integer;
Var
	I, Mx: Integer;
Begin
	If ZListNum>0 Then
	Begin
		Mx:=1;
		For I:=1 To ZListNum Do
			If ZList[I]^.ZIndex>ZList[Mx]^.ZIndex Then
				Mx:=I;
		ZListMaxZ:=Mx
	End
	Else
		ZListMaxZ:=0
End;

Function ZListPresent(Prog:PProg): Boolean;
Var
	I: Integer;
Begin
	ZListPresent:=False;
	For I:=1 To ZListNum Do
		If ZList[I]=Prog Then
			ZListPresent:=True
End;

Procedure ZListSortByZ;
Var
	I, J: Integer;
	Temp: PProg;
Begin
	For I:=1 To ZListNum-1 Do
		For J:=I+1 To ZListNum Do
			If (ZList[J]^.WinKind=wkPanel) Or
				(ZList[I]^.ZIndex>ZList[J]^.ZIndex) Then
			Begin
				Temp:=ZList[I];
				ZList[I]:=ZList[J];
				ZList[J]:=Temp
			End
End;

Function MaxZIndex(ExceptProg:PProg): Integer;
Var
	I, Mx: Integer;
	CurProg: PProg;
Begin
	Mx:=0;
	CurProg:=FirstProg;
	While CurProg<>Nil Do
	Begin
		If (CurProg^.Visible) And (CurProg^.WinKind In [wkNormal, wkSheet]) And
			(CurProg^.ZIndex>Mx) And (CurProg<>ExceptProg) Then
			Mx:=CurProg^.ZIndex;
		CurProg:=CurProg^.Next
	End;
	MaxZIndex:=Mx
End;

Function WhichWinOnTop(X,Y:Integer): PProg;
Var
	I: Integer;
	Cur: PProg;
Begin
	ZListFree;
	Cur:=FirstProg;
	While Cur<>Nil Do
	Begin
		If Cur^.Visible And D.InRect(MsX,MsY,Cur^.WinRect) Then
			ZListAdd(Cur);
		Cur:=Cur^.Next
	End;
	I:=ZListMaxZ;
	If I=0
		Then WhichWinOnTop:=Nil
		Else WhichWinOnTop:=ZList[I]
End;

Function TopIntersectWindow(Rect:TRect): PProg;
Var
	Cur, Top: PProg;
	TopZ: Integer;
Begin
	Cur:=FirstProg;
	TopZ:=0;
	Top:=Nil;
	While Cur<>Nil Do
	Begin
		If Cur^.Visible And D.Intersect(Rect, Cur^.WinRect) And
			(Cur^.ZIndex>TopZ) Then
		Begin
			Top:=Cur;
			TopZ:=Cur^.ZIndex
		End;
		Cur:=Cur^.Next
	End;
	If TopZ=0
		Then TopIntersectWindow:=Nil
		Else TopIntersectWindow:=Top
End;

Function TopIntersectFocusableWindow(Rect:TRect): PProg;
Var
	Cur, Top: PProg;
	TopZ: Integer;
Begin
	Cur:=FirstProg;
	TopZ:=0;
	Top:=Nil;
	While Cur<>Nil Do
	Begin
		If Cur^.Visible And D.Intersect(Rect, Cur^.WinRect) And
			(Cur^.ZIndex>TopZ) And Cur^.CanBeActive Then
		Begin
			Top:=Cur;
			TopZ:=Cur^.ZIndex
		End;
		Cur:=Cur^.Next
	End;
	If TopZ=0
		Then TopIntersectFocusableWindow:=Nil
		Else TopIntersectFocusableWindow:=Top
End;


Function WindowFullyCoveredFromTop(Prog, ExceptProg:PProg): Boolean;
Var
	CurProg: PProg;
Begin
	WindowFullyCoveredFromTop:=False;
	CurProg:=FirstProg;
	While CurProg<>Nil Do
	Begin
		If (CurProg<>Prog) And (CurProg<>ExceptProg) Then
			If (CurProg^.ZIndex>Prog^.ZIndex) And CurProg^.Visible And
				D.RectInRect(Prog^.WinRect, CurProg^.WinRect) Then
				WindowFullyCoveredFromTop:=True;
		CurProg:=CurProg^.Next
	End
End;

Function WindowFullyCoveredFromBottom(Prog:PProg):Boolean;
Var
	Cur: PProg;
Begin
	WindowFullyCoveredFromBottom:=False;
	Cur:=FirstProg;
	While Cur<>Nil Do
	Begin
		If Cur<>Prog Then
			If (Cur^.ZIndex<Prog^.ZIndex) And Cur^.Visible And
				D.RectInRect(Prog^.WinRect, Cur^.WinRect) Then
				WindowFullyCoveredFromBottom:=True;
		Cur:=Cur^.Next
	End
End;

Function WindowCoveredFromTop(Prog, ExceptProg:PProg): Boolean;
Var
	CurProg: PProg;
Begin
	WindowCoveredFromTop:=False;
	CurProg:=FirstProg;
	While CurProg<>Nil Do
	Begin
		If (CurProg<>Prog) And (CurProg<>ExceptProg) Then
			If (CurProg^.ZIndex>Prog^.ZIndex) And CurProg^.Visible And
				D.Intersect(Prog^.WinRect, CurProg^.WinRect) Then
				WindowCoveredFromTop:=True;
		CurProg:=CurProg^.Next
	End
End;



Function ControlCovered(VCtl:PControl): Boolean;
Var
	Temp: PProg;
Begin
	Temp:=TopIntersectWindow(VCtl^.Place);
	If Temp=Nil
		Then ControlCovered:=False
		Else If VCtl^.Owner=Temp { maybe dangerous, ZIndex's must be compared }
		{Else If Ctl^.Owner^.ZIndex>Temp^.ZIndex}
			Then ControlCovered:=False
			Else ControlCovered:=True
End;

Procedure FitWindowToScreen(Prog:PProg; ToDraw:Boolean);
Var
	NewRect: TRect;
Begin
	If Not (Prog^.WinKind In [wkNormal, wkSheet]) Then Exit;
	NewRect:=Prog^.WinRect;
	With NewRect Do
	Begin
		D.NotMorePair(X1, X2, Screen.X2);
		D.NotLessPair(X1, X2, Screen.X1);
		D.NotMore(X2, Screen.X2);
		D.NotMorePair(Y1, Y2, Screen.Y2);
		D.NotLessPair(Y1, Y2, Screen.Y1);
		D.NotMore(Y2, Screen.Y2);
		If Not D.RectsEqual(NewRect, Prog^.WinRect) Then
			If ToDraw And (Prog^.Visible)
				Then ResizeOrMoveWindow(Prog, X1, Y1, X2, Y2)
				Else Begin
					Prog^.WinRect:=NewRect;
					With Prog^ Do
						D.AddRects(WinRect, WinLook^.ClientDeltaRect, ClientRect);
					{If Not Prog^.Visible Then
					Begin
						Prog^.Visible:=True;
						RefreshCanDrawFlags(Prog);
						Prog^.Visible:=False
					End}
				End
	End
End;

Procedure FitAllWindowsToScreen(ToDraw: Boolean);
Var
	CurProg: PProg;
Begin
	CurProg:=FirstProg;
	While CurProg<>Nil Do
	Begin
		If CurProg^.WinKind In [wkNormal, wkSheet] Then
			FitWindowToScreen(CurProg, ToDraw);
		CurProg:=CurProg^.Next
	End
End;

Procedure RefreshCanDrawFlags(Prog:PProg);
Var
	CurCtl: PControl;
Begin
	CurCtl:=Prog^.FirstCtl;
	While CurCtl<>Nil Do
	Begin
		CurCtl^.CanDraw:=Prog^.Visible And (Not ControlCovered(CurCtl));
		CurCtl:=CurCtl^.Next
	End;
End;

Procedure RefreshAllCanDrawFlags;
Var
	Cur: PProg;
Begin
	Cur:=FirstProg;
	While Cur<>Nil Do
	Begin
		RefreshCanDrawFlags(Cur);
		Cur:=Cur^.Next
	End;
End;



Function RunBuiltInInt(Name, Params:String; VParent:PProg): PProg;
Var
	Prog: PBuiltIn;
	Cur: PProg;
	Temp: PProg;
	CurCtl: PControl;
	MemBefore: LongInt;
Begin
	Log.SysMsg('Kernel', 'RunBuiltIn', 'Starting built-in program: '+Name);
	Log.ActMsg('Params = '+Params);
	Prog:=FindBuiltIn(Name);
	If Prog=Nil Then
	Begin
		Log.ErrMsg('Kernel', 'RunBuiltInInt', 'Built-in program not found: '+Name);
		Log.ActMsg('Ignoring start request');
		RunBuiltInInt:=Nil;
		Exit
	End;

	MemBefore:=MemAvail;
	New(Cur);
	Cur^.Next:=FirstProg;
	FirstProg:=Cur;
	RunBuiltInInt:=Cur;
	
	{Temp:=ActiveWin;
	ActiveWin:=Cur;
	If Temp<>Nil Then
	Begin
		If Temp^.ActiveCtl<>Nil Then
			Temp^.ActiveCtl^.OnRefocus(Temp^.ActiveCtl, False);
		DrawWindowFrame(Temp)
	End;}
	
	{Log.ActMsg('Prog structure created, windows swithed');}
	With Cur^ Do
	Begin
		Visible:=False; { for debug }

		D.AssignPStr(String(Prog^.Name^), Name);
		D.AssignPStr(Params, Param);
		Icon:=Prog^.Icon;
		WinTitle:=Nil;
		WinKind:=wkNone;

		{ZIndex:=MaxZIndex+1;}
		FirstCtl:=Nil;
		ActiveCtl:=Nil;
		ButtonEnter:=Nil;
		ButtonEsc:=Nil;
		ButtonF1:=Nil;
		WinLookData:=Nil;
		Parent:=VParent;
		If VParent<>Nil Then
			VParent^.Child:=Cur;
		Child:=Nil;

			{ for safety reset handlers }
		OnPaint:=DummyProc;
		OnIdle:=DummyProc;
		OnMessage:=DummyMessageFunc;
		OnKey:=DummyKeyFunc;
		OnClose:=DummyProc;

		IgnoreAutoRedraw:=True;
		Prog^.OnInit(Cur);
		IgnoreAutoRedraw:=False;

			{ check ActiveCtl }
		If ActiveCtl<>Nil Then
			If Not ActiveCtl^.Enabled Or (ActiveCtl^.FocusCtl<>ActiveCtl) Then
			Begin
				CurCtl:=FirstCtl;
				While ((Not CurCtl^.Enabled) Or (CurCtl^.FocusCtl<>CurCtl)) And
					(CurCtl^.Next<>Nil) Do
					CurCtl:=CurCtl^.Next;
				If CurCtl^.Enabled And (CurCtl^.FocusCtl=CurCtl)
					Then ActiveCtl:=CurCtl
					Else ActiveCtl:=Nil
			End;

		{If Cur^.WinKind=wkNormal
			Then ZIndex:=ZInd+1
			Else ZIndex:=1;}
		{Log.ActMsg('OnInit called');}
		DontBother:=True;
		{Log.BugMsg('Kernel', 'RunBuiltInInt', 'Going to call OnPaint...');}
		BeginPaint(Screen);
		OnPaint(Cur);
		{Log.ActMsg('OnPaint called');}
		If Cur=ActiveWin Then {   Init/Paint  ⨫   }
			If ActiveCtl<>Nil Then
				ActiveCtl^.OnRefocus(ActiveCtl, True);
		EndPaint;
		DontBother:=False;
		Memory:=MemBefore-MemAvail
	End;
	RefreshAllCanDrawFlags;
	{Log.SysMsg('Kernel','RunBuiltIn','Built-in program started: '+Name)}
End;

Procedure RunBuiltIn(Name,Params:String);
Var
	JustRunned: PProg;
Begin
	JustRunned:=RunBuiltInInt(Name, Params, Nil);
	If JustRunned=Nil Then Exit;
	RaiseEvent('OpenWin', JustRunned);
	If JustRunned^.ButtonEnter<>Nil Then
		With JustRunned^.ButtonEnter^.Place Do
			PlaceMouse((X1+X2) Div 2, (Y1+Y2) Div 2)
End;

Procedure RunChild(Me:PProg; VOnInit:TProc; Params:String);
Var
	JustRunned: PProg;
Begin
	If Me^.Child<>Nil Then
	Begin
		Log.ErrMsg('Kernel', 'RunChild', String(Me^.Name^)+
			' attemps to run a second child');
		Log.ActMsg('Refusing to do it.');
		Exit
	End;
	RegBuiltIn(String(Me^.Name^)+' dialog','', '', VOnInit);
	JustRunned:=RunBuiltInInt(String(Me^.Name^)+' dialog', Params, Me);
	{Me^.Child:=FirstProg;
	FirstProg^.Parent:=Me;}
	RemoveFirstBuiltIn;
	If JustRunned=Nil Then Exit;
	RaiseEvent('OpenChildWin', JustRunned);
	If JustRunned^.ButtonEnter<>Nil Then
		With JustRunned^.ButtonEnter^.Place Do
			PlaceMouse((X1+X2) Div 2, (Y1+Y2) Div 2)
End;

Procedure RunChild2(Me:PProg; Name,Params:String);
Var
	JustRunned: PProg;
Begin
	If Me^.Child<>Nil Then
	Begin
		Log.ErrMsg('Kernel', 'RunChild', String(Me^.Name^)+
			' attemps to run a second child, "'+Name+'".');
		Log.ActMsg('Refusing to do it.');
		Exit
	End;
	JustRunned:=RunBuiltInInt(Name, Params, Me);
	If JustRunned=Nil Then Exit;
	RaiseEvent('OpenChildWin', JustRunned);
	If JustRunned^.ButtonEnter<>Nil Then
		With JustRunned^.ButtonEnter^.Place Do
			PlaceMouse((X1+X2) Div 2, (Y1+Y2) Div 2)
End;

(* Procedure RunDLL(Name,Params:String);
Var
	ProgHandle: THandle;
	Cur: PProg;
	Temp: PProg;
	ZInd: Integer;
	Name1: String;
	PName: PChar;

	OnGetProcs: TFarProc;
	OnInit: TFarProc;
Type
	TOnGetProcs=Procedure(Table:TProcsTable);
	TOnInit=Procedure(Me:PProg; Params:String);
Begin
	Log.SysMsg('Kernel', 'RunDLL', 'Starting DLL program: '+Name);
	If Not FileExist(Name+'.dll') Then
	Begin
		Log.ErrMsg('Kernel', 'RunDLL', 'Program not found');
		Log.ActMsg('Ignoring start request');
		Exit
	End;
	ZInd:=MaxZIndex;

	New(Cur);
	Cur^.Next:=FirstProg;
	FirstProg:=Cur;

	Temp:=ActiveWin;
	ActiveWin:=Cur;
	If Temp<>Nil Then
	Begin
		If Temp^.ActiveCtl<>Nil Then
			Temp^.ActiveCtl^.OnRefocus(Temp^.ActiveCtl, False);
		DrawWindowFrame(Temp)
	End;
	Name1:=Name+'.dll'+#0;
	D.AssignPStr(Name, Cur^.Name);
	With Cur^ Do
	Begin
		WinTitle:=Nil;
		ZIndex:=ZInd+1;
		{ZIndex:=MaxZIndex+1;}
		FirstCtl:=Nil;
		ActiveCtl:=Nil;

		ProgHandle:=LoadLibrary(@Name1[1]);
		Log.SysMsg('Kernel', 'RunDLL', 'LoadLibrary result = '+D.St(ProgHandle));

		Name1:='OnGetProcs'+#0;
		PName:=@Name1[1];
		OnGetProcs:=GetProcAddress(ProgHandle, @Name1[1]);
		TOnGetProcs(OnGetProcs)(ProcsTable);

		Name1:='OnInit'+#0;
		PName:=@Name1[1];
		OnInit:=GetProcAddress(ProgHandle, PName);
		TOnInit(OnInit)(Cur, Params);
		
		DontBother:=True;
		OnPaint(Cur);
		If ActiveCtl<>Nil Then
			ActiveCtl^.OnRefocus(ActiveCtl, True);
		DontBother:=False
	End;
	RefreshAllCanDrawFlags;
	RaiseEvent('OpenWin', Cur)
End; *)

Procedure RemoveAllProgEvents(Prog:PProg); Forward;

Procedure CloseProg(Prog:PProg);
Var
	Cur, Temp: PProg;
	Found: Boolean;
	CurCtl, TempCtl: PControl;
	CurWinPosPtr, NextWinPosPtr: PWinPos;
	TempWinPos: TWinPos;
	TempX1, TempY1, TempSizeX, TempSizeY: Integer;
	TempRect: TRect;
	NewActiveWin: PProg;
	MemBefore, ProgMem: LongInt;
	AllScreen: TRect;
Begin
	Log.SysMsg('Kernel', 'CloseProg', 'Terminating program: '+String(Prog^.Name^));
	MemBefore:=MemAvail;
	ProgMem:=Prog^.Memory;
	If Prog<>FirstProg Then
	Begin
		Cur:=FirstProg;
		Found:=False;
		While (Cur<>Nil) And Not Found Do
			If Cur^.Next=Prog
				Then Found:=True
				Else Cur:=Cur^.Next;
		If Not Found Then
		Begin
			Log.ErrMsg('Kernel', 'CloseProg', 'Program not found');
			Log.ActMsg('Ignoring close request');
			Exit
		End;
		Cur^.Next:=Cur^.Next^.Next
	End
	Else
		FirstProg:=Prog^.Next;

	RaiseEvent('CloseWin', Prog);
	{
		ॢi,    ᯨ WinPos'i i, 瘟 ਢ
		 ⠪ - ࠢ    ᯨ
		 i -   
	}
	CurWinPosPtr:=FindWinPos(String(Prog^.Name^{WinTitle^}));
	If CurWinPosPtr=Nil Then
	Begin
		GetProgWinPos(Prog, TempWinPos);
		AddWinPos(TempWinPos)
	End
	Else Begin
		NextWinPosPtr:=CurWinPosPtr^.Next;
		GetProgWinPos(Prog, CurWinPosPtr^);
		CurWinPosPtr^.Next:=NextWinPosPtr
	End;

	Prog^.OnClose(Prog); { If OnClose(Prog)=False Then Exit   can be here }
		{   ணࠬ  i, ਡ i  }
	If Prog^.Child<>Nil Then
	Begin
		Prog^.Child^.Parent:=Nil;
		CloseProg(Prog^.Child)
	End;
	RemoveAllProgEvents(Prog); {    }
	If Prog^.WinKind<>wkNone Then
	Begin
		HideWindow(Prog);
			{ animate it }
		With Prog^.WinRect Do
		Begin
			Case Prog^.WinKind Of
				wkNormal: D.AssignRect((X1+X2) Div 2-2, (Y1+Y2) Div 2-2,
					(X1+X2) Div 2+2, (Y1+Y2) Div 2+2, TempRect);
				wkSheet, wkPanel: Case Prog^.WinBorder Of
					brLeft: D.AssignRect(X1, Y1, X1+4, Y2, TempRect);
					brRight: D.AssignRect(X1, Y1, X1+4, Y2, TempRect);
					brTop: D.AssignRect(X1, Y1, X2, Y1+4, TempRect);
					brBottom: D.AssignRect(X1, Y2-4, X2, Y2, TempRect)
				End
			End;
			Gfx.ZoomRect(Prog^.WinRect, TempRect)
		End
	End;

	If Prog^.WinKind=wkPanel Then
		With Prog^, WinRect Do
			Case WinBorder Of
				brLeft: Dec(Screen.X1, X2-X1+1);
				brRight: Inc(Screen.X2, X2-X1+1);
				brTop: Dec(Screen.Y1, Y2-Y1+1);
				brBottom: Inc(Screen.Y2, Y2-Y1+1)
			End;

	D.FreePStr(Prog^.Name, 'Kernel - CloseProg (name)');
	D.FreePStr(Prog^.WinTitle, 'Kernel - CloseProg (wintitle)');
	D.FreePStr(Prog^.Param, 'Kernel - CloseProg (param)');
	IgnoreAutoRedraw:=True;

	CurCtl:=Prog^.FirstCtl;
	While CurCtl<>Nil Do
	Begin
		CurCtl^.OnDestroy(CurCtl);
		If CurCtl^.Hint<>Nil Then
			D.FreePStr(CurCtl^.Hint, 'Kernel - CloseProg (control hint)');
		TempCtl:=CurCtl^.Next;
		Dispose(CurCtl);
		CurCtl:=TempCtl
	End;
	IgnoreAutoRedraw:=False;
	If Prog^.WinKind<>wkNone Then
		Prog^.WinLook^.OnDestroy(Prog);

	If Prog^.Parent=Nil Then
	Begin
		Dispose(Prog);
		{NewActiveWin:=TopIntersectWindow(Screen)}
		D.AssignRect(0, 0, ScrX, ScrY, AllScreen);
		NewActiveWin:=TopIntersectFocusableWindow(AllScreen)
	End
	Else Begin
		Prog^.Parent^.Child:=Nil; { 㡨  :(... }
		NewActiveWin:=Prog^.Parent;
		Dispose(Prog)
	End;
	ActiveWin:=Nil;
	If NewActiveWin<>Nil Then
		ToFrontWindow(NewActiveWin, False);
	{Begin
		DrawWindowFrame(ActiveWin);
		If ActiveWin^.ActiveCtl<>Nil Then
			ActiveWin^.ActiveCtl^.OnRefocus(ActiveWin^.ActiveCtl, True)
	End;}
	RaiseEvent('ActivateWin', ActiveWin);
	If MemAvail-MemBefore<>0
		Then Log.ErrMsg('Kernel', 'CloseProg', 'Used memory = '+D.StL(ProgMem)+
			', freed memory = '+D.StL(MemAvail-MemBefore))
		Else Log.BugMsg('Kernel', 'CloseProg', 'Memory freed correctly');

End;

Function FindProg(VName:String): PProg;
Var
	Cur: PProg;
	Found: Boolean;
Begin
	Cur:=FirstProg;
	Found:=False;
	While (Cur<>Nil) And Not Found Do
		If String(Cur^.Name^)=VName
			Then Found:=True
			Else Cur:=Cur^.Next;
	If Found
		Then FindProg:=Cur
		Else FindProg:=Nil
End;

Function FindProgPlus(VName, VParam:String): PProg;
Var
	Cur: PProg;
	Found: Boolean;
Begin
	Cur:=FirstProg;
	Found:=False;
	While (Cur<>Nil) And Not Found Do
		If (String(Cur^.Name^)=VName) And (String(Cur^.Param^)=VParam)
			Then Found:=True
			Else Cur:=Cur^.Next;
	If Found
		Then FindProgPlus:=Cur
		Else FindProgPlus:=Nil
End;





Procedure DrawBG(Rect:TRect);
Const
	Sequence: Array[0..5] Of TColor=(213, 214, 215, 216, 215, 214);
Var
	Y, C: Integer;
Begin
	With Rect Do
		Gfx.Bar(X1, Y1, X2, Y2, Gfx.DesktopColor)
		{Gfx.DitherBar(X1, Y1, X2, Y2, 56, 96, 168)}
	{With Rect Do
		For Y:=Y1 To Y2 Do
			Gfx.Line(X1, Y, X2, Y, Sequence[Y Mod 6])}
End;

Procedure PaintWindowDirect(Prog:PProg); Forward;

Procedure HideWindow(Prog:PProg);
Var
	I: Integer;
	Cur: PProg;
Begin
	ZListFree;
	ZListAdd(Prog);
	I:=1;
	Repeat
		Cur:=FirstProg;
		While Cur<>Nil Do
		Begin
			If Cur^.Visible And D.Intersect(ZList[I]^.WinRect, Cur^.WinRect) And
				Not ZListPresent(Cur) Then
				ZListAdd(Cur);
			Cur:=Cur^.Next
		End;
		Inc(I)
	Until I>ZListNum;

	If Not WindowFullyCoveredFromBottom(Prog) Then
	Begin
		BeginPaint(Prog^.WinRect);
		DrawBG(Prog^.WinRect);
		EndPaint
	End;
	ZList[1]:=ZList[ZListNum];
	Dec(ZListNum);
	ZListSortByZ;
	DontBother:=True;
	For I:=1 To ZListNum Do
		If Not WindowFullyCoveredFromTop(ZList[I], Prog) Then
			PaintWindowDirect(ZList[I]);
	DontBother:=False;
	RefreshAllCanDrawFlags
End;

Procedure MinimizeWindow(Prog:PProg);
Var
	AllScreen: TRect;
Begin
	Prog^.Visible:=False; { ! swapped lines }
	{Prog^.ZIndex:=1;}
	HideWindow(Prog);
	D.AssignRect(0, 0, ScrX, ScrY, AllScreen);
	ActiveWin:=TopIntersectFocusableWindow(AllScreen);
	If ActiveWin<>Nil Then
	Begin
		DrawWindowFrame(ActiveWin);
		If ActiveWin^.ActiveCtl<>Nil Then
			If ActiveWin^.WinRect.X1<>ActiveWin^.WinRect.X2 Then
				ActiveWin^.ActiveCtl^.OnRefocus(ActiveWin^.ActiveCtl, True)
	End;
	RaiseEvent('MinimizeWin', Prog);
	RaiseEvent('ActivateWin', ActiveWin); { ActiveWin can be Nil! }
	{RefreshCanDrawFlags(Prog)}
End;

Procedure ToFrontWindow(Prog:PProg; ForceDraw:Boolean);
Var
	LastActiveWin: PProg;
	FullRedrawNeeded: Boolean;

	Procedure Popusk(N:Integer);
	Var
		CurProg:PProg;
	Begin
		CurProg:=FirstProg;
		While CurProg<>Nil Do
		Begin
			If CurProg^.ZIndex>N Then
				Dec(CurProg^.ZIndex);
			CurProg:=CurProg^.Next
		End
	End;
Begin
	If Prog=Nil Then Exit;
	{If Not (Prog^.WinKind In [wkNormal, wkSheet]) Then Exit;}
	If Not Prog^.CanBeActive Then Exit;
	If Prog=ActiveWin Then Exit;

	FullRedrawNeeded:=WindowCoveredFromTop(Prog, Nil);
	LastActiveWin:=ActiveWin;
	ActiveWin:=Prog;
	If Prog^.Visible Then
		Popusk(ActiveWin^.ZIndex);
	Prog^.ZIndex:=MaxZIndex(Prog)+1;
	Prog^.Visible:=True;
	RefreshAllCanDrawFlags;
	If LastActiveWin<>Nil Then
	Begin
		DrawWindowFrame(LastActiveWin);
		With LastActiveWin^ Do
			If ActiveCtl<>Nil Then
				ActiveCtl^.OnRefocus(ActiveCtl, False)
	End;
	If LastActiveWin<>Prog Then
		If FullRedrawNeeded Or ForceDraw
			Then PaintWindowDirect(Prog)
			Else DrawWindowFrame(Prog);
	With ActiveWin^ Do
		If ActiveCtl<>Nil Then
			If WinRect.X1<>WinRect.X2 Then
				ActiveCtl^.OnRefocus(ActiveCtl, True);

	RaiseEvent('ActivateWin', Prog)
End;

Procedure DeactivateWindow(Prog:PProg);
Begin
	DrawWindowFrame(Prog);
	If Prog^.ActiveCtl<>Nil Then
		Prog^.ActiveCtl^.OnRefocus(Prog^.ActiveCtl, False)
End;




Procedure ResizeOrMoveWindow(Prog:PProg; NewX1,NewY1,NewX2,NewY2:Integer);
Var
	R: TRect;
	TopWin: PProg;
Begin
	With Prog^.WinRect Do
	Begin
			{   ४ i ? }
		TopWin:=TopIntersectWindow(Prog^.WinRect);
		If (TopWin<>Nil) And (TopWin<>Prog) Then
			ToFrontWindow(Prog, False);

		If (X1=NewX1) And (Y1=NewY1) And (X2=NewX2) And (Y2=NewY2) Then
		Begin
			Prog^.WinLook^.OnDrawFrame(Prog);
			Exit
		End;

		If Prog^.Child<>Nil Then
			If Prog^.Child^.WinKind=wkSheet Then
				With Prog^ Do
					Case Child^.WinBorder Of
						brLeft: ResizeOrMoveWindow(Child, NewX2+1,
							NewY1+WinLook^.ClientDeltaRect.Y1, NewX2+1+Child^.MinX,
							NewY1+WinLook^.ClientDeltaRect.Y1+Child^.MinY);
					End;	

		D.AssignRect(NewX1, NewY1, NewX2, NewY2, R);
		Gfx.ZoomRect(Prog^.WinRect, R);

		HideWindow(Prog);
		Prog^.WinRect:=R;
		With Prog^ Do
			D.AddRects(WinRect, WinLook^.ClientDeltaRect, ClientRect)
	End;
	PaintWindowDirect(Prog);

	RefreshAllCanDrawFlags;
End;

Procedure MaximizeWindow(Prog:PProg);
Begin
	If D.RectsEqual(Prog^.WinRect, Screen) Then
	Begin
		With Prog^.LastWinRect Do
			ResizeOrMoveWindow(Prog, X1, Y1, X2, Y2);
		Prog^.WinRect:=Prog^.LastWinRect
	End
	Else Begin
		Prog^.LastWinRect:=Prog^.WinRect;
		With Screen Do
			ResizeOrMoveWindow(Prog, X1, Y1, X2, Y2)
	End
End;

Procedure SlidePanel(Prog:PProg);
Var
	TempRect: TRect;
Begin
	If Not (Prog^.WinKind=wkPanel) Then Exit;

	With Prog^ Do
	Begin
		LastWinRect:=WinRect;
		TempRect:=WinRect;
		Case WinBorder Of
			brLeft: Begin
				Dec(Screen.X1, WinRect.X2-WinRect.X1);
				TempRect.X2:=WinRect.X1
			End;
			brRight: Begin
				Inc(Screen.X2, WinRect.X2-WinRect.X1);
				TempRect.X1:=WinRect.X2
			End;
		End
	End;
	With TempRect Do
		ResizeOrMoveWindow(Prog, X1, Y1, X2, Y2);

	ActiveWin:=TopIntersectWindow(Screen);
	If ActiveWin<>Nil Then
	Begin
		DrawWindowFrame(ActiveWin);
		If ActiveWin^.ActiveCtl<>Nil Then
			ActiveWin^.ActiveCtl^.OnRefocus(ActiveWin^.ActiveCtl, True)
	End;
	{RaiseEvent('SlidePanel', Prog);}
	RaiseEvent('ActivateWin', ActiveWin);
End;



Procedure SetWindowCaption(Prog:PProg; VCaption:String);
Begin
	{Log.BugMsg('Kernel', 'SetWindowCaption', 'Starting...');}
	D.ReassignPStr(VCaption, Prog^.WinTitle);
	If Prog^.Visible Then
	Begin
		BeginPaint(Prog^.WinRect);
		Prog^.WinLook^.OnDrawFrame(Prog);
		EndPaint
	End;
	RaiseEvent('RenameWin', Prog)
End;

Procedure SetWindowCapAndIcon(Prog:PProg; VCaption:String; VIcon:Pointer);
Begin
	{Log.BugMsg('Kernel', 'SetWindowCapAndIcon', 'Starting...');}
	D.ReassignPStr(VCaption, Prog^.WinTitle);
	Prog^.Icon:=VIcon;
	If Prog^.Visible Then
	Begin
		BeginPaint(Prog^.WinRect);
		Prog^.WinLook^.OnDrawFrame(Prog);
		EndPaint
	End;
	RaiseEvent('RenameWin', Prog)
End;






Function AddCtl(VProg:PProg): PControl;
Var
	Cur: PControl;
Begin
	With VProg^ Do
	Begin
		New(Cur);
		Cur^.Next:=FirstCtl;
		FirstCtl:=Cur;

		With Cur^ Do
		Begin
			Enabled:=True;
			Visible:=True;
			AutoRedraw:=True;
			D.AssignPStr('', Hint);
			Owner:=VProg;
			OwnerCtl:=Nil;
			OnClick:=CtlClickDummy;
			OnKey:=CtlKeyDummy;
			OnRefocus:=CtlRefocusDummy;
			OnHint:=CtlDummy;
			OnWheel:=CtlWheelDummy;
			OnDestroy:=CtlDummy;
			FocusCtl:=Cur;
			D.AssignRect(1, 1, 2, 2, Place); { for debug }
				{ for debug }
			CanDraw:=(VProg=ActiveWin) Or (VProg^.WinKind=wkPanel)
		End;
		ActiveCtl:=Cur
	End;
	AddCtl:=Cur
End;

Procedure DestroyCtl(Me:PProg; Control:PControl);
Var
	Cur: PControl;
	Found: Boolean;
Begin
	If Control<>Me^.FirstCtl Then
	Begin
		Cur:=Me^.FirstCtl;
		Found:=False;
		While (Cur^.Next<>Nil) And (Not Found) Do
			If Cur^.Next=Control
				Then Found:=True
				Else Cur:=Cur^.Next;
		If Found Then
			Cur^.Next:=Cur^.Next^.Next
	End
	Else
		Me^.FirstCtl:=Control^.Next;

	Control^.OnDestroy(Control);
	D.FreePStr(Control^.Hint, 'Kernel - DestroyCtl');
	Dispose(Control)
End;

Procedure HideCtl(Ctl:PControl);
Begin
	With Ctl^.Place Do
		Case WinBGMode Of
			bgSolidColor: Gfx.Bar(X1, Y1, X2, Y2, Gfx.GetPixel(X1-3, Y1));
			bgMetal: Gfx.SteelBarMimic(X1, Y1, X2, Y2, mdRandom);
			bgStriped: Gfx.StripedBarMimic(X1, Y1, X2, Y2, mdRandom);
		End
End;


Procedure SetCtlRedrawFlag(Ctl:PControl; Flag:Boolean);
Begin
	Ctl^.AutoRedraw:=Flag
End;

Procedure SetFocusCtl(Ctl,VFocusCtl:PControl);
Begin
	Ctl^.Enabled:=True;
	Ctl^.FocusCtl:=VFocusCtl
End;







Function FindWinLook(Name:String): PWinLook;
Var
	CurWinLookForFind: PWinLook;
	Found: Boolean;
	CurName: String;
Begin
	CurWinLookForFind:=FirstWinLook;
	Found:=False;
	FindWinLook:=Nil;
	While (CurWinLookForFind<>Nil) And (Not Found) Do
	Begin
		If CurWinLookForFind^.Name<>Nil
			Then CurName:=String(CurWinLookForFind^.Name^)
			Else CurName:='';
		If CurName=Name Then
		Begin
			Found:=True;
			FindWinLook:=CurWinLookForFind
		End
		Else
			CurWinLookForFind:=CurWinLookForFind^.Next
	End
End;






Procedure AddEventFunc(Name:String; Func:TEventFunc; Owner:PProg);
Var
	Cur: PEvent;
Begin
	New(Cur);
	Cur^.Next:=FirstEvent;
	FirstEvent:=Cur;

	D.AssignPStr(Name, Cur^.Name);
	Cur^.Func:=Func;
	Cur^.Owner:=Owner;
	Log.SysMsg('Kernel', 'AddEventFunc', 'Event func added for "'+Name+'",');
	Log.ActMsg('Owner is '+String(Owner^.Name^))
End;

Procedure RemoveEventFunc(Func:TEventFunc; Owner:PProg);
Var
	Cur, Temp: PEvent;
	Found: Boolean;
Begin
	If FirstEvent=Nil Then Exit; {    :) }
	If (@FirstEvent^.Func=@Func) And (FirstEvent^.Owner=Owner) Then
	Begin
		Temp:=FirstEvent^.Next;
		Dispose(FirstEvent);
		FirstEvent:=Temp
	End
	Else Begin
		Cur:=FirstEvent;
		Found:=False;
		While (Cur^.Next<>Nil) And (Not Found) Do
			If (@Cur^.Next^.Func=@Func) And (Cur^.Next^.Owner=Owner)
				Then Found:=True
				Else Cur:=Cur^.Next;
		If Found Then
		Begin
			Temp:=Cur^.Next^.Next;
			Dispose(Cur^.Next);
			Cur^.Next:=Temp
		End
		Else Begin
			Log.ErrMsg('Kernel', 'RemoveEventFunc', 'Func to remove not found');
			Log.ActMsg('Ignoring remove request')
		End
	End
End;

Procedure RemoveAllEvents;
Begin
	While FirstEvent<>Nil Do
		RemoveEventFunc(FirstEvent^.Func, FirstEvent^.Owner)
End;

Procedure RemoveAllProgEvents(Prog:PProg);
Var
	Cur: PEvent;
Begin
	Cur:=FirstEvent;
	While Cur<>Nil Do
		If Cur^.Owner=Prog
			Then Begin
				Log.ErrMsg('Kernel', 'RemoveAllProgEvents', 'Event lost, removing it');
				Log.ActMsg('Prog = '+String(Prog^.Name^)+', event = '+
					String(Cur^.Name^));
				RemoveEventFunc(Cur^.Func, Prog)
			End
			Else Cur:=Cur^.Next
End;


Procedure RaiseEvent(Name:String; Params:Pointer);
Var
	Cur: PEvent;
	Finish: Boolean;
Begin
	{Log.SysMsg('Kernel', 'RaiseEvent', 'Event raised: '+Name);}
	Cur:=FirstEvent;
	Finish:=False;
	While (Cur<>Nil) And (Not Finish) Do
	Begin
		If Name=String(Cur^.Name^) Then
		Begin
			{Log.ActMsg('Calling handler, owner is '+String(Cur^.Owner^.Name^));}
			Finish:=Cur^.Func(Cur^.Owner, Params)
		End;
		Cur:=Cur^.Next
	End
End;





Procedure GetWinCoords(Prog:PProg);
Const
	WinShiftX=21;
	WinShiftY=21;
Var
	CurWinPosPtr: PWinPos;
	TempWinPos: TWinPos;
	RX, RY: Integer;
	Cur: PProg;
	Found: Boolean;
Begin
		{ ToDo: get coords from file polit.win | 05.10.02 working on it }
	CurWinPosPtr:=FindWinPos(String(Prog^.Name^{WinTitle^}));
	If CurWinPosPtr=Nil Then
	Begin
		D.AssignPStr(String(Prog^.Name^{WinTitle^}), TempWinPos.Name);
		TempWinPos.X1:=Random(Screen.X2-Screen.X1-Prog^.MinX-20)+Screen.X1;
		TempWinPos.Y1:=Random(Screen.Y2-Screen.Y1-Prog^.MinY-30)+Screen.Y1;
		TempWinPos.SizeX:=Prog^.MinX;
		TempWinPos.SizeY:=Prog^.MinY;
		AddWinPos(TempWinPos);
		SetProgWinPos(Prog, TempWinPos);
	End
	Else Begin
			{ ॢi,   㦥 ⠪ i  ࠭i }
		Found:=False;
		Cur:=FirstProg^.Next;
		While (Cur<>Nil) And (Not Found) Do
			If String(Cur^.Name^{WinTitle^})=String(Prog^.Name^{WinTitle^})
				Then Found:=True
				Else Cur:=Cur^.Next;
		If Found Then
		Begin
			Prog^.WinRect:=Cur^.WinRect;
			With Prog^.WinRect Do
			Begin
				Inc(X1, WinShiftX);
				Inc(X2, WinShiftX);
				Inc(Y1, WinShiftY);
				Inc(Y2, WinShiftY)
			End
		End
		Else
			SetProgWinPos(Prog, CurWinPosPtr^)
	End;
	Prog^.LastWinRect:=Prog^.WinRect
End;

Procedure GetChildWinCoords(Prog:PProg);
Var
	TempPWinPos: PWinPos;
	TempWinPos: TWinPos;
	NewX1, NewY1, DX, DY: Integer;
Begin
	TempPWinPos:=FindWinPos(String(Prog^.Name^));
	If TempPWinPos=Nil Then
	Begin {   ஧i i   }
		TempWinPos.SizeX:=Prog^.MinX;
		TempWinPos.SizeY:=Prog^.MinY
	End
	Else TempWinPos:=TempPWinPos^;
	With Prog^.Parent^, WinRect Do
	Begin
		TempWinPos.X1:=((X1+X2) Div 2)-(TempWinPos.SizeX Div 2)-1;
		TempWinPos.Y1:=Y1+WinLook^.ClientDeltaRect.Y1
	End;
	SetProgWinPos(Prog, TempWinPos)
End;

{Procedure GetChildWinCoords0(Prog:PProg);
Var
	TempWinPos: TWinPos;
Begin
	With Prog^.Parent^, WinRect Do
	Begin
		TempWinPos.X1:=((X1+X2) Div 2)-(Prog^.MinX Div 2)-1;
		TempWinPos.Y1:=Y1+WinLook^.ClientDeltaRect.Y1;
		TempWinPos.SizeX:=Prog^.MinX;
		TempWinPos.SizeY:=Prog^.MinY
	End;
	SetProgWinPos(Prog, TempWinPos)
End;}

Procedure GetSheetWinCoords(Prog:PProg);
Var
	TempWinPos: TWinPos;
Begin
	Case Prog^.WinBorder Of
		brLeft: With Prog^.Parent^, WinRect Do
		Begin
			TempWinPos.X1:=X2+1;
			TempWinPos.Y1:=Y1+WinLook^.ClientDeltaRect.Y1;
			TempWinPos.SizeX:=Prog^.MinX;
			TempWinPos.SizeY:=Prog^.MinY
		End;
		brRight: With Prog^.Parent^, WinRect Do
		Begin
			TempWinPos.X1:=X1-1-Prog^.MinX;
			TempWinPos.Y1:=Y1+WinLook^.ClientDeltaRect.Y1;
			TempWinPos.SizeX:=Prog^.MinX;
			TempWinPos.SizeY:=Prog^.MinY
		End;
	End;
	SetProgWinPos(Prog, TempWinPos)
End;



Procedure AnimateWindowOpen(Prog:PProg);
Var
	TempRect:TRect;
Begin
	With Prog^, WinRect Do
	Begin
		Case WinKind Of
			wkNormal: D.AssignRect(MsX+MsHotX-2, MsY+MsHotY-2,
				MsX+MsHotX+2, MsY+MsHotY+2, TempRect);
			wkSheet, wkPanel: Case WinBorder Of
				brLeft: D.AssignRect(X1, Y1, X1+2, Y2, TempRect);
				brRight: D.AssignRect(X2-2, Y1, X2, Y2, TempRect);
				brTop: D.AssignRect(X1, Y1, X2, Y1+2, TempRect);
				brBottom: D.AssignRect(X1, Y2-2, X2, Y2, TempRect)
			End
		End;
		Gfx.ZoomRect(TempRect, WinRect)
	End
End;

Procedure InitWindow(Prog:PProg; WinLookName:String;
	VWinButtons:TWinButtonSet);
Var
	WinLook: PWinLook;
	LastActWin: PProg;
Begin
	WinLook:=FindWinLook(WinLookName);
	If WinLook=Nil Then
	Begin
		Log.ErrMsg('Kernel', 'InitWindow', 'Requested WinLook not found: '+WinLookName);
		Log.ActMsg('Using first installed WinLook: '+String(FirstWinLook^.Name^));
		Prog^.WinLook:=FirstWinLook
	End
	Else
		Prog^.WinLook:=WinLook;

	If Prog^.Parent=Nil
		Then GetWinCoords(Prog)
		Else GetChildWinCoords(Prog);

	LastActWin:=ActiveWin;
	ActiveWin:=Prog;
	If LastActWin<>Nil Then
	Begin
		If LastActWin^.ActiveCtl<>Nil Then
			LastActWin^.ActiveCtl^.OnRefocus(LastActWin^.ActiveCtl, False);
		DrawWindowFrame(LastActWin)
	End;
	With Prog^, WinLook^.ClientDeltaRect Do
	Begin
		Inc(MinX, X1);
		Dec(MinX, X2);
		Inc(MinY, Y1);
		Dec(MinY, Y2)
	End;
	With Prog^, WinRect Do
	Begin
		WinKind:=wkNormal;
		WinButtons:=VWinButtons;
		WinBG:=bgDefault;
		CanBeActive:=True;
		ZIndex:=MaxZIndex(Nil)+1;
		{Log.BugMsg('Kernel', 'InitWindow', 'ZIndex = '+D.St(ZIndex));}
		FitWindowToScreen(Prog, False);
		D.AddRects(WinRect, WinLook^.ClientDeltaRect, ClientRect);
		WinLook^.OnPrepare(Prog);
		WinLook^.OnRefreshButtons(Prog);
	End;
	{AnimateWindowOpen(Prog);}
End;

Procedure InitPanelWindow(Prog:PProg; WinLookName:String; Border:TBorder;
	VWinButtons:TWinButtonSet; Width:Integer);
Var
	WinLook: PWinLook;
	LastActWin: PProg;
Begin
	WinLook:=FindWinLook(WinLookName);
	If WinLook=Nil Then
	Begin
		Log.ErrMsg('Kernel', 'InitPanelWindow', 'Requested WinLook not found: '+WinLookName);
		Log.ActMsg('Using first installed WinLook');
		Prog^.WinLook:=FirstWinLook
	End
	Else
		Prog^.WinLook:=WinLook;

	Prog^.WinBorder:=Border;
	Prog^.WinRect:=Screen;
	With Prog^.WinRect Do
		Case Border Of
			brLeft: X2:=X1+Width;
			brRight: X1:=X2-Width;
			brTop: Y2:=Y1+Width;
			brBottom: Y1:=Y2-Width
		End;

	If Prog^.CanBeActive Then
	Begin
		LastActWin:=ActiveWin;
		ActiveWin:=Prog;
		If LastActWin<>Nil Then
		Begin
			If LastActWin^.ActiveCtl<>Nil Then
				LastActWin^.ActiveCtl^.OnRefocus(LastActWin^.ActiveCtl, False);
			DrawWindowFrame(LastActWin)
		End
	End;
	
	Inc(Width);
	With Screen Do
		Case Border Of
			brLeft: Inc(X1, Width);
			brRight: Dec(X2, Width);
			brTop: Inc(Y1, Width);
			brBottom: Dec(Y2, Width)
		End;

	With Prog^ Do
	Begin
		D.AddRects(WinRect, WinLook^.ClientDeltaRect, ClientRect);
		WinKind:=wkPanel;
		WinButtons:=VWinButtons;
		WinBG:=bgDefault;
		CanBeActive:=False;
		ZIndex:=1;
		WinLook^.OnPrepare(Prog);
		WinLook^.OnRefreshButtons(Prog)
	End;
	{AnimateWindowOpen(Prog);}
	FitAllWindowsToScreen(True)
End;

Procedure InitSheetWindow(Prog:PProg; WinLookName:String;
	VWinButtons:TWinButtonSet; VWinBorder:TBorder);
Var
	WinLook: PWinLook;
	LastActWin: PProg;
	LastScreen: TRect;
Begin
	WinLook:=FindWinLook(WinLookName);
	If WinLook=Nil Then
	Begin
		Log.ErrMsg('Kernel', 'InitWindow', 'Requested WinLook not found: '+WinLookName);
		Log.ActMsg('Using first installed WinLook: '+String(FirstWinLook^.Name^));
		Prog^.WinLook:=FirstWinLook
	End
	Else
		Prog^.WinLook:=WinLook;

	Prog^.WinBorder:=VWinBorder;
	GetSheetWinCoords(Prog);
	LastScreen:=Screen;
	With Prog^ Do
	Begin
		Case WinBorder Of
			brLeft: Dec(Screen.X2, WinRect.X2-WinRect.X1+1);
			brRight: Inc(Screen.X1, WinRect.X2-WinRect.X1+1);
		End;
		If WinRect.Y2>Parent^.WinRect.Y2 Then
			Dec(Screen.Y2, Parent^.WinRect.Y2-WinRect.Y2)
	End;
	FitWindowToScreen(Prog^.Parent, True);
	Screen:=LastScreen;

	LastActWin:=ActiveWin;
	ActiveWin:=Prog;
	If LastActWin<>Nil Then
	Begin
		If LastActWin^.ActiveCtl<>Nil Then
			LastActWin^.ActiveCtl^.OnRefocus(LastActWin^.ActiveCtl, False);
		DrawWindowFrame(LastActWin)
	End;
	With Prog^, WinLook^.ClientDeltaRect Do
	Begin
		Inc(MinX, X1);
		Dec(MinX, X2);
		Inc(MinY, Y1);
		Dec(MinY, Y2)
	End;
	With Prog^, WinRect Do
	Begin
		WinKind:=wkSheet;
		WinButtons:=VWinButtons;
		WinBG:=bgDefault;
		CanBeActive:=True;
		ZIndex:=MaxZIndex(Nil)+1;
		FitWindowToScreen(Prog, False);
		D.AddRects(WinRect, WinLook^.ClientDeltaRect, ClientRect);
		WinLook^.OnPrepare(Prog);
		WinLook^.OnRefreshButtons(Prog);
	End;
	{AnimateWindowOpen(Prog)}
End;




Procedure WindowBar(X1,Y1,X2,Y2:Integer; Dark,Mimic:Boolean);
Var
	Color: TColor;
Begin
	Case WinBGMode Of
		bgSolidColor: Begin
			If Mimic
				Then Begin
					Color:=Gfx.GetPixel(X1-1, Y1);
					If Color=ClrAccent Then
						Color:=Gfx.GetPixel(X1-3, Y1);
					{Color:=Gfx.GetPixel(X1-3, Y1);
					If (Color=ClrAccent) Or (Color=ClrAccent2) Or
						(Color=ClrList) Or (Color=ClrListSel) Or
						(Color=ClrThen
						Color:=Gfx.GetPixel(X1-1, Y1)}
				End
				Else If Dark
					Then Color:=ClrWinDarkBG
					Else Color:=ClrWinBG;
			Gfx.Bar(X1, Y1, X2, Y2, Color)
		End;
		bgMetal: If Mimic
			Then Gfx.SteelBarMimic(X1, Y1, X2, Y2, mdRandom)
			Else If Dark
				Then Gfx.SteelBar(X1, Y1, X2, Y2, 56)
				Else Gfx.SteelBar(X1, Y1, X2, Y2, 70);
		{bgMetal: Gfx.StoneBar(X1, Y1, X2, Y2, 70);}
		bgStriped: If Dark
			Then Gfx.StripedBar(X1, Y1, X2, Y2, 80)
			Else Gfx.StripedBar(X1, Y1, X2, Y2, 90);
	End
End;

Procedure DarkBar(X1,Y1,X2,Y2:Integer);
Begin
	Case WinBGMode Of
		bgSolidColor: Gfx.Bar(X1, Y1, X2, Y2, ClrWinDarkBG);
		bgMetal: Gfx.SteelBar(X1, Y1, X2, Y2, 56);
		bgStriped: Gfx.StripedBar(X1, Y1, X2, Y2, 80);
	End
End;

Procedure WinBGBar(Prog:PProg; X1,Y1,X2,Y2:Integer);
Begin
	Case Prog^.WinBG Of
		bgDefault, bgManual: WindowBar(X1, Y1, X2, Y2, False, False);
		bgDark, bgManualDark: DarkBar(X1, Y1, X2, Y2);
	End
End;


Procedure EmptyWindow(Prog:PProg);
Begin
	With Prog^.WinRect Do
		If X1=X2 Then Exit;
	With Prog^, ClientRect Do
		If WinBG In [bgDefault, bgDark] Then
			WinBGBar(Prog, X1, Y1, X2, Y2)
End;


Procedure DrawWindow(Prog:PProg);
Begin
	Prog^.Visible:=True;
	BeginPaint(Prog^.WinRect);
	Prog^.WinLook^.OnDrawFrame(Prog);
	EmptyWindow(Prog);
	EndPaint
End;

Procedure DrawWindowAni(Prog:PProg);
Begin
	AnimateWindowOpen(Prog);
	DrawWindow(Prog)
End;

Procedure DrawWindowFrame(Prog:PProg);
Begin
	BeginPaint(Prog^.WinRect);
	Prog^.WinLook^.OnDrawFrame(Prog);
	EndPaint
End;

Procedure PaintWindowDirect(Prog:PProg);
Begin
	DrawWindow(Prog);
	BeginPaint(Prog^.WinRect);
	Prog^.OnPaint(Prog);
	If (Prog=ActiveWin) And (Prog^.ActiveCtl<>Nil) And
		(Prog^.WinRect.X1<>Prog^.WinRect.X2) Then
		Prog^.ActiveCtl^.OnRefocus(Prog^.ActiveCtl, True);
	EndPaint
End;

Procedure PaintWindow(Prog:PProg);
Begin
	If TopIntersectWindow(Prog^.WinRect)=Prog Then
		PaintWindowDirect(Prog);
	{Begin
		DrawWindow(Prog);
		Prog^.OnPaint(Prog);
		If (Prog=ActiveWin) And (Prog^.ActiveCtl<>Nil) Then
			Prog^.ActiveCtl^.OnRefocus(Prog^.ActiveCtl, True)
	End}
End;

Procedure ResetTimers;
Var
	Cur: PTimer;
Begin
	Log.BugMsg('Kernel', 'ResetTimers', 'SysTimer = '+D.StL(D.SysTimer));
	Cur:=FirstTimer;
	While Cur<>Nil Do
	Begin
		Cur^.NextTime:=D.SysTimer;
		Cur^.Times:=1;

		Cur:=Cur^.Next
	End
End;


Procedure ExecTimers;
Var
	Cur: PTimer;
Begin
	Cur:=FirstTimer;
	{Log.BugMsg('Kernel', 'ExecTimers', 'Starting');}
	While Cur<>Nil Do
	Begin
		If Cur^.NextTime<D.SysTimer Then
		Begin
			{Log.BugMsg('Kernel', 'ExecTimers', 'Timer skipped');}
			Inc(Cur^.NextTime, Cur^.Freq);
			Inc(Cur^.Times)
		End;
		If Cur^.NextTime=D.SysTimer Then
		Begin
			{Log.SysMsg('Kernel','ExecTimers','Timer executed, freq='+D.St(Cur^.Freq));}
			{Log.BugMsg('Kernel', 'ExecTimers', 'Executing timer');}
			Cur^.Proc(Cur^.Control, Cur^.Times);
			Cur^.NextTime:=D.SysTimer+Cur^.Freq;
			Cur^.Times:=1
		End;
		Cur:=Cur^.Next
	End
End;



Procedure Hint_HideMouse(Var X,Y:Integer);
Begin
	{HideMouseSave(X,Y);}
	HideMouse(X, Y);
	Gfx.PutImage(HintX1, HintY1, HintUnderImage)
End;

Procedure Hint_ShowMouse(Var X,Y:Integer);
Begin
	Gfx.GetImage(HintX1, HintY1, HintX2, HintY2, HintUnderImage);
	Gfx.PutImage(HintX1, HintY1, HintImage);
	{ShowMouseSave(X,Y)}
	ShowMouse(X,Y)
End;

Function Hint_RefreshNeeded(Rect:TRect): Boolean;
Begin
	Hint_RefreshNeeded:=
		D.IntersectCoord(Rect, HintX1, HintY1, HintX2, HintY2) Or
		RefreshNeededSave(Rect)
End;

Procedure ShowHint(HintText:String);
Const
	HintShift=2;
Var
	HintWidth, HintHeight: Integer;
	HintSize: Word;
	DX, DY: Integer;
	CurIdle, NextIdle: PProg;
	LastMsMask, MsMask: Word;
	HintLines: Array[1..21] Of PStr;
	HintLinesNum: Integer;
	V, CurY: Integer;
	LastMouseVis: Boolean;
	R1, R2: TRect;
Begin
	If HintText='' Then Exit;
	{Log.SysMsg('Kernel', 'ShowHint', 'Showing hint: '+HintText);}
	HintLinesNum:=0;
	HintWidth:=0;
	HintHeight:=18+HintShadowDepth;
	Font.SetFont(CurFont);
	While Pos(#13, HintText)>0 Do
	Begin
		V:=Pos(#13, HintText);
		Inc(HintLinesNum);
		D.AssignPStr(Copy(HintText, 1, V-1), HintLines[HintLinesNum]);
		If String(HintLines[HintLinesNum]^)=''
			Then Inc(HintHeight, 6)
			Else Inc(HintHeight, 12);
		If Font.Width(String(HintLines[HintLinesNum]^))>HintWidth Then
			HintWidth:=Font.Width(String(HintLines[HintLinesNum]^));
		HintText:=Copy(HintText, V+1, Length(HintText)-V)
	End;
	Inc(HintLinesNum);
	D.AssignPStr(HintText, HintLines[HintLinesNum]);
	If Font.Width(String(HintLines[HintLinesNum]^))>HintWidth Then
		HintWidth:=Font.Width(String(HintLines[HintLinesNum]^));
	Inc(HintWidth, 6+HintShadowDepth);

	HintSize:=Gfx.ImageSize(HintWidth, HintHeight);
	GetMem(HintImage, HintSize);
	GetMem(HintUnderImage, HintSize);
	{HintX1:=MsX+12;}
	HintX1:=MsX+MsSizeX-1-MsHotX+HintShift;
	HintY1:=MsY;
	HintX2:=HintX1+HintWidth-1;
	HintY2:=HintY1+HintHeight-1;
	HintPresent:=True;
	D.ToRangePair(HintX1, HintX2, 0, Gfx.ScrX);
	D.ToRangePair(HintY1, HintY2, 0, Gfx.ScrY);
	If MsX+MsSizeX-1-MsHotX >= HintX1 Then
	Begin { i    誨? }
		HintX1:=MsX-MsHotX;
		HintX2:=HintX1+HintWidth-1;
		D.ToRangePair(HintX1, HintX2, 0, Gfx.ScrX);
		If MsY+MsSizeY-1-MsHotY+(HintY2-HintY1+1)+HintShift <= ScrY
			Then HintY1:=MsY+MsSizeY-1-MsHotY+HintShift
			Else HintY1:=MsY-MsHotY-HintHeight-HintShift;
		HintY2:=HintY1+HintHeight-1
	End;
	LastMouseVis:=MouseVis;
	If LastMouseVis Then
		HideMouse(MsX, MsY);

	If HintAnimate Then
	Begin
		D.AssignRect(MsX, MsY, MsX+2, MsY+2, R1);
		D.AssignRect(HintX1, HintY1, HintX2, HintY2, R2);
		Gfx.ZoomRect(R1, R2)
	End;

	Gfx.GetImage(HintX1, HintY1, HintX2, HintY2, HintUnderImage);

	Gfx.Rectangle(HintX1, HintY1, HintX2-HintShadowDepth,
		HintY2-HintShadowDepth, ClrStatic);
	{Gfx.Bar(HintX1+1, HintY1+1, HintX2-1-HintShadowDepth,
		HintY2-1-HintShadowDepth, clGray);}
	Gfx.TranspBar(HintX1+1, HintY1+1, HintX2-1-HintShadowDepth,
		HintY2-1-HintShadowDepth, ClrDisabled, 80);
	CurY:=HintY1+2;
	For V:=1 To HintLinesNum Do
	Begin
		Font.Print(HintX1+3, CurY, ClrStatic, String(HintLines[V]^));
		If String(HintLines[V]^)=''
			Then Inc(CurY, 6)
			Else Inc(CurY, 12)
	End;
	If HintShadowDepth>0 Then
	Begin
		Ini.Select('polit.ini', 'Graphics');
		If Ini.GetStr('Shadows', 'SMOOTH')='FAST'
			Then Gfx.BoxShadow(HintX1, HintY1, HintX2-HintShadowDepth,
				HintY2-HintShadowDepth, HintShadowDepth)
			Else Gfx.BoxShadowSoft(HintX1, HintY1, HintX2-HintShadowDepth,
				HintY2-HintShadowDepth, HintShadowDepth)
	End;
	{Gfx.ShadowBar(HintX1+HintShadowDepth, HintY2-HintShadowDepth+1,
		HintX2, HintY2);
	Gfx.ShadowBar(HintX2-HintShadowDepth+1, HintY1+HintShadowDepth,
		HintX2, HintY2-HintShadowDepth);}

	Gfx.GetImage(HintX1, HintY1, HintX2, HintY2, HintImage);
	Gfx.PutImage(HintX1, HintY1, HintUnderImage);

	LastMouseMove:=D.SysTimer;
	CurIdle:=FirstProg;
	LastMsMask:=Mouse.GetMask;

	HideMouseSave:=HideMouseProc;
	HideMouseProc:=Hint_HideMouse;
	ShowMouseSave:=ShowMouseProc;
	ShowMouseProc:=Hint_ShowMouse;
	RefreshNeededSave:=RefreshNeededFunc;
	RefreshNeededFunc:=Hint_RefreshNeeded;
	Hint_ShowMouse(MsX, MsY);

	(* C:=ReadKey; { some more code will be here soon } *)

	Repeat
		ExecTimers;
		If CurIdle<>Nil Then
		Begin
			NextIdle:=CurIdle^.Next;
			CurIdle^.OnIdle(CurIdle);
			CurIdle:=NextIdle;
			If CurIdle=Nil Then
				CurIdle:=FirstProg
		End;
		Mouse.GetDXDY(DX, DY);
		MsMask:=Mouse.GetMask
	Until (MsMask<>LastMsMask) Or (DX<>0) Or (DY<>0) Or
		(D.SysTimer-LastMouseMove>HintHideTime) Or KeyPressed Or
		(D.KeyStatus<>LastKeyStatus);

	Hint_HideMouse(MsX, MsY);
	ShowMouseProc:=ShowMouseSave;
	HideMouseProc:=HideMouseSave;
	RefreshNeededFunc:=RefreshNeededSave;
	If LastMouseVis Then
		ShowMouse(MsX, MsY);
	LastMouseMove:=D.SysTimer;
	FreeMem(HintImage, HintSize);
	FreeMem(HintUnderImage, HintSize);
	For V:=1 To HintLinesNum Do
		D.FreePStr(HintLines[V], 'Kernel - ShowHint')
End;

Procedure ShowHintPlus;
Var
	CurProg: PProg;
	CurCtl: PControl;
	TempHint: String;
Begin
	CurProg:=WhichWinOnTop(MsX, MsY);
	If CurProg=Nil Then Exit;
	CurCtl:=WhichControl(CurProg, MsX, MsY, True);
	If CurCtl=Nil Then Exit;
	CurCtl^.OnHint(CurCtl);
	If CurCtl^.Hint<>Nil Then
		SHowHint(String(CurCtl^.Hint^));
	{TempHint:=String(CurCtl^.Hint^);
	ShowHint(TempHint)}
End;



Procedure ExecScrSaver;
Var
	CurProg: PProg;
	CurCtl: PControl;
	I: Integer;
	Temp: Real;
	DX, DY: Integer;
	LastMsMask, MsMask: Word;
	CurIdle: PProg;
	LastMouseVis: Boolean;
	C: Char;
Begin
	Log.SysMsg('Kernel', 'ExecScrSaver', 'Starting screen saver: '+String(ScrSaver^.Name^));
	{LastMouseVis:=MouseVis;
	If Not MouseVis Then
		ShowMouseProc(MsX,MsY);}
		{ ஭  i i稬 ஫ }
	CurProg:=FirstProg;
	While CurProg<>Nil Do
	Begin
		CurCtl:=CurProg^.FirstCtl;
		While CurCtl<>Nil Do
		Begin
			CurCtl^.CanDraw:=False;
			CurCtl:=CurCtl^.Next
		End;
		CurProg:=CurProg^.Next
	End;

		{ ᭥  iᥩ }
	Gfx.FadeDownPal;
	CurIdle:=FirstProg;
	LastMsMask:=Mouse.GetMask;
	ScrSaver^.OnInit;
	Gfx.ReloadPal;
	Mouse.GetDXDY(DX, DY); {  ।஦ :) }
	Repeat
		ScrSaver^.OnIdle;
		ExecTimers;
		If CurIdle<>Nil Then
		Begin
			CurIdle^.OnIdle(CurIdle);
			CurIdle:=CurIdle^.Next;
			If CurIdle=Nil Then
				CurIdle:=FirstProg
		End;
		Mouse.GetDXDY(DX, DY);
		MsMask:=Mouse.GetMask
	Until (MsMask<>LastMsMask) Or (DX<>0) Or (DY<>0) Or Keypressed Or
		(D.KeyStatus<>LastKeyStatus);

	Log.SysMsg('Kernel', 'ExecScrSaver', 'Terminating screen saver');
	If MsMask<>LastMsMask Then
		Log.ActMsg('Reason: mouse buttons state change '+D.St(MsMask));
	If (DX<>0) Or (DY<>0) Then
		Log.ActMsg('Reason: mouse move '+D.St(DX)+' '+D.St(DY));
	If KeyPressed Then
		Log.ActMsg('Reason: key press');

	Gfx.BlackPal;
	Gfx.ClearDesk;
		{  i i  Z-iᮬ }
	RefreshAllCanDrawFlags;
	DontBother:=True;
	ZListFree;
	CurProg:=FirstProg;
	While CurProg<>Nil Do
	Begin
		If CurProg^.Visible Then
			ZListAdd(CurProg);
		CurProg:=CurProg^.Next
	End;
	ZListSortByZ;
	InsideHeart:=False;
	For I:=1 To ZListNum Do
		PaintWindowDirect(ZList[I]);
	InsideHeart:=True;
	If MouseVis Then
		ShowMouseProc(MsX, MsY);
	DontBother:=False;
	LastMouseMove:=D.SysTimer;
	Gfx.FadeUpPal;
	If KeyPressed Then
		While KeyPressed Do
			C:=ReadKey
End;






Procedure OnDesktopMenuCmdClick(Me:PProg; Item:PMenuItem);
Begin
	If String(Item^.Name^)='i ࠭'
		Then TakeScreenShot
		Else If String(Item^.Name^)='⠢'
			Then ExecScrSaver
			Else If String(Item^.Name^)='१⠦'
				Then RestartPolit
				Else If String(Item^.Name^)=''
					Then GoodbyePolit
End;

Procedure OnDesktopMenuProgClick(Me:PProg; Item:PMenuItem);
Var
	CurBuiltIn, Found: PBuiltIn;
	TempStr: String;
Begin
	CurBuiltIn:=FirstBuiltIn;
	Found:=Nil;
	TempStr:=String(Item^.Name^);
	While CurBuiltIn<>Nil Do
	Begin
		If String(CurBuiltIn^.FriendlyName^)=TempStr Then
			Found:=CurBuiltIn;
		CurBuiltIn:=CurBuiltIn^.Next
	End;
	If Found<>Nil Then
		RunBuiltIn(String(Found^.Name^), '')
End;

Procedure DesktopPopupPlus(VX1,VY1:Integer);
Begin
		{ 祪 i᪠i  誨 }
	If Mouse.GetMask<>Mouse.mbNone Then
		Repeat
			CheckSysKeys
		Until Kernel.HeartOfPolit(HideMouse, ShowMouse, RefreshNeeded)=0;

	Popup.OpenMenu(Nil, MnuDesktop, VX1, VY1)
End;

Procedure DesktopPopup;
Begin
	DesktopPopupPlus(MsX, MsY)
End;






Procedure ShowMouse(Var X,Y:Integer);
Begin
	{BCRT.Delay(150);}
	If MouseVis Then Exit;
	Gfx.GetImage(X-MsHotX, Y-MsHotY, X+MsSizeX-1-MsHotX, Y+MsSizeY-1-MsHotY,
		MsSave);
	If MouseShadow=0
		Then Gfx.PutTranspSprite(X-MsHotX, Y-MsHotY, 80, MsImage)
		Else Gfx.PutSpriteShadow(X-MsHotX, Y-MsHotY, MouseShadow, MsImage);
	MouseVis:=True
End;

Procedure HideMouse(Var X,Y:Integer);
Begin
	{BCRT.Delay(150);}
	If Not MouseVis Then Exit;
	Gfx.PutImage(X-MsHotX, Y-MsHotY, MsSave);
	MouseVis:=False
End;

Function RefreshNeeded(Rect:TRect): Boolean;
Begin
	RefreshNeeded:=D.IntersectCoord(Rect,
		MsX-MsHotX, MsY-MsHotY, MsX-MsHotX+MsSizeY, MsY-MsHotY+MsSizeY)
End;

Procedure PlaceMouse(NewX,NewY: Integer);
Const
	Steps=49;
Var
	I, RealDX, RealDY: Integer;
	MouseX, MouseY, DX, DY: Real;
	LastMouseVis: Boolean;
	TempStr: String;
Begin
	Ini.Select('polit.ini', 'Mouse');
	TempStr:=Ini.GetStr('PlaceMouse', 'ANIMATE');
	If TempStr='NO' Then Exit;
	If TempStr='ANIMATE' Then
	Begin
		LastMouseVis:=MouseVis;
		MouseX:=MsX;
		MouseY:=MsY;
		DX:=(NewX-MsX)/Steps;
		DY:=(NewY-MsY)/Steps;
		For I:=1 To Steps Do
		Begin
			HideMouse(MsX, MsY);
			MouseX:=MouseX+DX;
			MouseY:=MouseY+DY;
			MsX:=Round(MouseX);
			MsY:=Round(MouseY);
			ShowMouse(MsX, MsY);
			D.Delay(7);
			Mouse.GetDXDY(RealDX, RealDY);
			If (RealDX<>0) Or (RealDY<>0) Then
				Break
		End;
		If Not LastMouseVis Then
			HideMouse(MsX, MsY);
		MouseVis:=LastMouseVis;
		MsX8:=MsX*8;
		MsY8:=MsY*8
	End;
	If TempStr='WARP' Then
	Begin
		If MouseVis Then
		Begin
			HideMouse(MsX, MsY);
			MsX:=NewX;
			MsY:=NewY;
			MsX8:=MsX*8;
			MsY8:=MsY*8;
			ShowMouse(MsX, MsY)
		End
		Else Begin
			MsX:=NewX;
			MsY:=NewY;
		End
	End;
	LastMouseMove:=D.SysTimer
End;




Procedure BeginPaint(Rect:TRect);
Begin
	If InsideHeart Then
	Begin
		With Rect Do
		Begin
			If X1>X2 Then D.SwapInt(X1, X2);
			If Y1>Y2 Then D.SwapInt(Y1, Y2)
		End;
		If RefreshNeededFunc(Rect) Then
		Begin
			HideMouseProc(MsX, MsY);
			MouseVis:=False
		End
	End
End;

Procedure BeginPaintCoord(X1,Y1,X2,Y2:Integer);
Var
	Temp:TRect;
Begin
	D.AssignRect(X1, Y1, X2, Y2, Temp);
	BeginPaint(Temp)
End;

Procedure EndPaint;
Begin
	If InsideHeart And Not MouseVis Then
		ShowMouseProc(MsX, MsY)
End;


Function HeartOfPolit(VHideMouse,VShowMouse:TMouseProc2;
	VRefreshNeeded:TRefreshNeededFunc): Word;
Var
	DX, DY, Wheel: Integer;
	CurIdle, NextIdle: PProg;
	LastMsMask, MsMask: Word;
	MsRect8: TRect;
Begin
	{LastMouseMove:=SysTimer;}
	InsideHeart:=True;
	HideMouseProc:=VHideMouse;
	ShowMouseProc:=VShowMouse;
	RefreshNeededFunc:=VRefreshNeeded;

	LastMsMask:=Mouse.GetMask;
	LastKeyStatus:=D.KeyStatus;
	CurIdle:=FirstProg;
	ShowMouseProc(MsX, MsY);
	MsX8:=MsX*8;
	MsY8:=MsY*8;
	MsRect8.X1:=MsRect.X1*8;
	MsRect8.Y1:=MsRect.Y1*8;
	MsRect8.X2:=MsRect.X2*8;
	MsRect8.Y2:=MsRect.Y2*8;
	{Log.SysMsg('Kernel','HeartOfPolit','Entered main loop (MaxAvail='+D.StL(MaxAvail)+')');}
	MsMask:=Mouse.GetMask;
	Repeat
		Mouse.GetDXDY(DX, DY);
		If (DX<>0) Or (DY<>0) Then
		Begin {  訢  }
			LastMouseMove:=D.SysTimer;
			HintPresent:=False;
			HideMouseProc(MsX, MsY);
			Inc(MsX8, DX*MsSpeed);
			D.ToRange(MsX8, MsRect8.X1, MsRect8.X2);
			MsX:=MsX8 Div 8;
			Inc(MsY8, DY*MsSpeed);
			D.ToRange(MsY8, MsRect8.Y1, MsRect8.Y2);
			MsY:=MsY8 Div 8;
			ShowMouseProc(MsX, MsY);
			MsX8:=MsX*8;
			MsY8:=MsY*8;
		End
		Else Begin {   -  . 䮭i  }
			If (D.SysTimer-LastMouseMove>HintShowTime) And
				(MsMask=Mouse.mbNone) Then
			Begin
				If Not HintPresent Then
					ShowHintPlus;
				If (ScrSaver<>Nil) And (D.SysTimer-LastMouseMove>ScrSaveTime) Then
					ExecScrSaver
			End;
			ExecTimers;
			If CurIdle<>Nil Then
			Begin
				NextIdle:=CurIdle^.Next;
				CurIdle^.OnIdle(CurIdle);
				CurIdle:=NextIdle;
				If CurIdle=Nil Then
					CurIdle:=FirstProg
			End
		End;
		Mouse.GetMaskAndWheel(MsMask, Wheel);
		If Wheel<>0 Then
		Begin {    誨 }
			If ActiveWin<>Nil Then
				If ActiveWin^.ActiveCtl<>Nil Then
					ActiveWin^.ActiveCtl^.OnWheel(ActiveWin^.ActiveCtl, Wheel);
		End
	Until (MsMask<>LastMsMask) Or KeyPressed Or (D.KeyStatus<>LastKeyStatus);
	HideMouseProc(MsX, MsY);
	HeartOfPolit:=MsMask;

	{ShowMouseProc:=Kernel_ShowMouse;} { ToDo: save old procs instead }
	{HideMouseProc:=Kernel_HideMouse;}         { will it work ? }
	{RefreshNeededFunc:=Kernel_RefreshNeeded;}
	InsideHeart:=False;
	LastMouseMove:=D.SysTimer
End;

Function WhichWin(X,Y:Integer): PProg;
Var
	Cur: PProg;
	Found: Boolean;
Begin
	Cur:=FirstProg;
	Found:=False;
	While (Cur<>Nil) And (Not Found) Do
		If D.InRect(X, Y, Cur^.WinRect)
			Then Found:=True
			Else Cur:=Cur^.Next;
	If Found
		Then WhichWin:=Cur
		Else WhichWin:=Nil
End;

Function WhichControl(Prog:PProg; X,Y:Integer; CanBeDisabled:Boolean): PControl;
Var
	Cur: PControl;
	Found: Boolean;
Begin
	Cur:=Prog^.FirstCtl;
	Found:=False;
	While (Cur<>Nil) And (Not Found) Do
		If D.InRect(X, Y, Cur^.Place) And Cur^.Visible And
			(Cur^.Enabled Or CanBeDisabled)
			Then Found:=True
			Else Cur:=Cur^.Next;
	If Found
		Then WhichControl:=Cur
		Else WhichControl:=Nil
End;

Procedure ToFrontWindowChilds(Prog:PProg);
Var
	CurProg: PProg;
Begin
	CurProg:=Prog;
	Repeat
		If CurProg^.Child<>ActiveWin Then
		Begin
			ToFrontWindow(CurProg, False);
			ToFrontWindow(CurProg^.Child, False)
		End;
		If CurProg^.Child^.WinKind=wkNormal Then
			Gfx.ZoomRect(CurProg^.WinRect, CurProg^.Child^.WinRect);
		CurProg:=CurProg^.Child
	Until CurProg^.Child=Nil
End;

Procedure Click;
Var
	ClickedProg: PProg;
	ClickedCtl, TempCtl: PControl;
	CurProg: PProg;
Begin
	ClickedProg:=WhichWinOnTop(MsX, MsY);
	If ClickedProg<>Nil Then
	Begin
		If ClickedProg^.Child<>Nil Then
		Begin
			ToFrontWindowChilds(ClickedProg);
			If ActiveWin^.WinKind=wkNormal Then
				Exit
		End;

		If (ClickedProg^.Parent<>Nil) And (ClickedProg<>ActiveWin) Then
			ToFrontWindow(ClickedProg^.Parent, False);

		If (D.KeyStatus And ksAlt)<>0 Then
		Begin
			ClickedProg^.WinLook^.OnClick(ClickedProg, MsX, MsY);
			Exit
		End;

		ClickedCtl:=WhichControl(ClickedProg, MsX, MsY, True);
		{If ClickedCtl<>Nil Then
			If ClickedCtl^.FocusCtl<>Nil Then
				If ClickedCtl^.FocusCtl^.Enabled
					Then ClickedCtl:=ClickedCtl^.FocusCtl
					Else ClickedCtl:=Nil;}
		If ClickedCtl<>Nil Then
			If ClickedProg=ActiveWin Then
			Begin { click in same window }
				If (ClickedProg^.ActiveCtl<>Nil) And
					(ClickedProg^.ActiveCtl<>ClickedCtl) And
					(ClickedCtl^.FocusCtl<>Nil) Then
					If ClickedCtl^.FocusCtl^.Enabled Then
					Begin
						TempCtl:=ClickedProg^.ActiveCtl; { 23.03.2003 edited }
						ClickedProg^.ActiveCtl:=ClickedCtl^.FocusCtl; { fix 05.08.02 }
						TempCtl^.OnRefocus(TempCtl, False);
						ClickedProg^.ActiveCtl^.OnRefocus(ClickedProg^.ActiveCtl,
							True)
					End;
				If ClickedCtl^.Enabled Then
					ClickedCtl^.OnClick(ClickedCtl, MsX, MsY)
			End
			Else Begin { click in another window }
				{If ActiveWin<>Nil Then
					DeactivateWindow(ActiveWin);}
				If (ClickedProg^.ActiveCtl<>Nil) And (ClickedCtl^.FocusCtl<>Nil) Then
					If ClickedCtl^.FocusCtl^.Enabled Then
						ClickedProg^.ActiveCtl:=ClickedCtl^.FocusCtl;
				(*If ClickedProg^.WinKind In [wkNormal, wkSheet] Then { don't activate panels }
					ToFrontWindow(ClickedProg, False);*)
				If ClickedProg^.CanBeActive Then
					ToFrontWindow(ClickedProg, False);
				If ClickedCtl^.Enabled Then
					ClickedCtl^.OnClick(ClickedCtl, MsX, MsY)
			End
		Else Begin { ClickedCtl=Nil }
			If (ClickedProg<>ActiveWin) And
				{(ClickedProg^.WinKind In [wkNormal, wkSheet]) Then}
				ClickedProg^.CanBeActive Then
			Begin
				{If ActiveWin<>Nil Then
					DeactivateWindow(ActiveWin);}
				ToFrontWindow(ClickedProg, False)
			End;
			ClickedProg^.WinLook^.OnClick(ClickedProg, MsX, MsY)
		End
	End
	Else Begin { click on desktop }
		If Mouse.GetMask=Mouse.mbRight Then
			DesktopPopup
	End
End;

Procedure TakeScreenShot;
Var
	SR: SearchRec;
	N: Integer;
	Res: Word;
	CurName: String[12];
Begin
	FindFirst('shot????.pcx', AnyFile, SR);
	CurName:='SHOT0000.PCX';
	While DOSError=0 Do
	Begin
		If (SR.Attr And Directory)=0 Then
			If SR.Name>CurName Then
				CurName:=SR.Name;
		FindNext(SR)
	End;
	Val(Copy(CurName,5,4), N, Res);
	If Res=0 Then
	Begin
		Inc(N);
		CurName:=D.St(N);
		While Length(CurName)<4 Do
			CurName:='0'+CurName;
		CurName:='shot'+CurName+'.pcx'
	End
	Else
		CurName:='shot0001.pcx';

	Ini.Select('polit.ini', 'Mouse');
	If Ini.GetBool('OnScreenshots', True) Xor MouseVis Then
	Begin
		If MouseVis Then
		Begin
			HideMouseProc(MsX, MsY);
			Gfx.SavePCX(0, 0, Gfx.ScrX, Gfx.ScrY, CurName);
			ShowMouseProc(MsX, MsY)
		End
		Else Begin
			ShowMouseProc(MsX, MsY);
			Gfx.SavePCX(0, 0, Gfx.ScrX, Gfx.ScrY, CurName);
			HideMouseProc(MsX, MsY)
		End
	End
	Else
		Gfx.SavePCX(0, 0, Gfx.ScrX, Gfx.ScrY, CurName)
End;

Procedure CheckSysKeys; { specially for drag&drop operations }
Var
	C1, C2: Char;
Begin
	If KeyPressed Then
	Begin
		C1:=ReadKey;
		If KeyPressed
			Then C2:=ReadKey
			Else C2:=#0;

		If (C1=#0) And (C2=#67) Then
			TakeScreenShot;
	End;
End;

Procedure SelectFocusCtl(Prog:PProg; VCtl:PControl);
Begin
	With Prog^ Do
	Begin
		If TopIntersectWindow(Prog^.WinRect)=Prog Then
		Begin
			If ActiveCtl<>Nil Then
				ActiveCtl^.OnRefocus(ActiveCtl, False);
			ActiveCtl:=VCtl;
			If ActiveCtl<>Nil Then
				ActiveCtl^.OnRefocus(ActiveCtl, True)
		End
		Else
			ActiveCtl:=VCtl
	End
End;

Procedure RaiseKeyPressEvent(C1,C2:Char; KStatus:Word);
Var
	PressedKey: TKey;
Begin
	PressedKey.C1:=C1;
	PressedKey.C2:=C2;
	PressedKey.KStatus:=KStatus;
	RaiseEvent('KeyPress', @PressedKey)
End;

Procedure ClickCtl(Prog:PProg; VCtl:PControl);
Var
	TempBool: Boolean;
Begin
	If VCtl=Nil Then Exit;
	If (Prog^.ActiveCtl<>Nil) And (VCtl^.FocusCtl=VCtl) Then
		SelectFocusCtl(Prog, VCtl);
	TempBool:=VCtl^.OnKey(VCtl, ' ', #0)
End;

Procedure CallHelp;
Var
	ProHelp: PProg;
Begin
	With ActiveWin^ Do
		If ButtonF1<>Nil Then
		Begin
			If ButtonF1^.Enabled Then
				ClickCtl(ActiveWin, ButtonF1)
		End
		Else Begin
			ProHelp:=FindProg('Help');
			If ProHelp<>Nil Then
			Begin
				SendMessage(Nil, ProHelp, 'OpenHelp', ActiveWin^.Name);
				ToFrontWindow(ProHelp, True)
			End
			Else RunBuiltIn('Help', String(ActiveWin^.Name^))
		End
End;

Procedure Key(C1,C2:Char; KStatus:Word);
Var
	Temp, Searching: PControl;
	TempBool: Boolean;

	Procedure EnterEscF1;
	Begin
		With ActiveWin^ Do
		Begin
			If (C1=#13) Then { Enter }
				If ButtonEnter<>Nil Then
					If ButtonEnter^.Enabled Then
						ClickCtl(ActiveWin, ButtonEnter);

			If (C1=#27) Then { Esc }
				If ButtonEsc<>Nil Then
					If ButtonEsc^.Enabled Then
						ClickCtl(ActiveWin, ButtonEsc);

			If (C1=#0) And (C2=#59) Then { F1 }
				CallHelp
		End
	End;

Begin
	If (C1=#0) And (C2=#67) Then
	Begin { F9 }
		TakeScreenShot;
		Exit
	End;

		{  ᠬ i ( i ⨯ Alt)? }
	If (C1<>#0) Or (C2<>#0) Then
	Begin
			{ 07.07.2004 Apply keyboard layout }
		If (C1<>#0) And (CurLayout>0) Then
			C1:=KeybLayout[CurLayout, C1];

		If ActiveWin<>Nil Then
		Begin
			If ActiveWin^.OnKey(ActiveWin, C1, C2) Then Exit;

			If ActiveWin^.ActiveCtl<>Nil Then
			Begin
				If Not ActiveWin^.ActiveCtl^.OnKey(ActiveWin^.ActiveCtl, C1, C2) Then
					With ActiveWin^ Do
					Begin
							{ see if key is special like tab, enter etc }
						If (C1=#9) Then
						Begin { Tab }
							ActiveCtl^.OnRefocus(ActiveCtl, False);
							Repeat
								If ActiveCtl=FirstCtl
									Then Searching:=Nil
									Else Searching:=ActiveCtl;
								Temp:=FirstCtl;
								While Temp^.Next<>Searching Do
									Temp:=Temp^.Next;
								ActiveCtl:=Temp
							Until (ActiveCtl^.Enabled) And (ActiveCtl^.Visible) And
								(ActiveCtl^.FocusCtl=ActiveCtl); { fix 05.08.02 }
							ActiveCtl^.OnRefocus(ActiveCtl, True)
						End;

						If (C1=#0) And (C2=#15) Then
						Begin { Shift+Tab }
							ActiveCtl^.OnRefocus(ActiveCtl, False);
							Repeat
								ActiveCtl:=ActiveCtl^.Next;
								If ActiveCtl=Nil Then
									ActiveCtl:=FirstCtl
							Until (ActiveCtl^.Enabled) And (ActiveCtl^.Visible) And
								(ActiveCtl^.FocusCtl=ActiveCtl);
							ActiveCtl^.OnRefocus(ActiveCtl, True)
						End;

						EnterEscF1
					End
			End
			Else { ActiveWin^.ActiveCtl<>Nil }
				EnterEscF1

		End
	End;

		{ raise sys key press event }
	If C1=#0 Then
		RaiseKeyPressEvent(C1, C2, KStatus)
End;

Procedure HeartShell;
Var
	CurProg: PProg;
	CurCtl: PControl;
	C, ExtC: Char;
Begin
	{Log.BugMsg('Kernel', 'HeartShell', 'Entering');}
	Repeat
		If HeartOfPolit(HideMouse, ShowMouse, RefreshNeeded)<>0 Then
			Click;
		If KeyPressed Or (LastKeyStatus<>D.KeyStatus) Then
		Begin
			If KeyPressed Then
			Begin
				C:=ReadKey;
				If KeyPressed And (C=#0)
					Then ExtC:=ReadKey
					Else ExtC:=#0
			End
			Else Begin
				C:=#0;
				ExtC:=#0
			End;
			LastKeyStatus:=D.KeyStatus;
			Key(C, ExtC, LastKeyStatus)
		End
	Until 2+2=5
End;





Procedure AddTimer(VCtl:PControl; VProc:TTimerProc; VFreq:Integer);
Var
	Temp: PTimer;
Begin
	New(Temp);
	Temp^.Control:=VCtl;
	Temp^.Proc:=VProc;
	Temp^.Freq:=VFreq;
	Temp^.Times:=1;
	Temp^.NextTime:=D.SysTimer+VFreq;
	Temp^.Next:=FirstTimer;
	FirstTimer:=Temp
End;

Procedure RemoveTimer(VCtl:PControl; VProc:TTimerProc);
Var
	Temp, Cur: PTimer;
	Found: Boolean;
Begin
	If (FirstTimer^.Control=VCtl) And (@FirstTimer^.Proc=@VProc) Then
	Begin
		Temp:=FirstTimer^.Next;
		Dispose(FirstTimer);
		FirstTimer:=Temp
	End
	Else Begin
		Cur:=FirstTimer;
		Found:=False;
		While (Cur^.Next<>Nil) And Not Found Do
			If (Cur^.Next^.Control=VCtl) And (@Cur^.Next^.Proc=@VProc)
				Then Found:=True
				Else Cur:=Cur^.Next;
		If Found Then
		Begin
			Temp:=Cur^.Next;
			If Cur^.Next<>Nil Then
				Cur^.Next:=Cur^.Next^.Next;
			Dispose(Temp)
		End
	End
End;

Function ShortenStr(S:String; Width:Integer):String;
Begin
	If Width<Font.Width('...') Then
	Begin
		ShortenStr:='';
		Exit
	End;
	If Font.Width(S)>Width Then
	Begin
		Repeat
			Dec(Byte(S[0]))
		Until Font.Width(S+'...')<=Width;
		ShortenStr:=S+'...'
	End
	Else
		ShortenStr:=S
End;

Function ShortenStrFW(S:String; Width:Integer):String;
Begin
	If Width<Font.WidthFW('...') Then
	Begin
		ShortenStrFW:='';
		Exit
	End;
	If Font.WidthFW(S)>Width Then
	Begin
		Repeat
			Dec(Byte(S[0]))
		Until Font.WidthFW(S+'...')<=Width;
		ShortenStrFW:=S+'...'
	End
	Else
		ShortenStrFW:=S
End;


Procedure WaitTicks(N:Integer);
Var
	L: LongInt;
Begin
	L:=D.SysTimer;
	Repeat
	Until D.SysTimer>=L+N
End;



Procedure RegScrSaver(VName:String; VOnInit,VOnIdle:TScreenSaverProc);
Var
	Cur: PScreenSaver;
Begin
	Log.SysMsg('Kernel', 'RegScrSaver', 'Registering screensaver: '+VName);
	New(Cur);
	Cur^.Next:=FirstScrSaver;
	FirstScrSaver:=Cur;

	D.AssignPStr(VName, Cur^.Name);
	Cur^.OnInit:=VOnInit;
	Cur^.OnIdle:=VOnIdle
End;

Function FindScrSaver(VName:String): PScreenSaver;
Var
	Cur: PScreenSaver;
	Found: Boolean;
Begin
	VName:=D.UpCaseLine(VName);
	Cur:=FirstScrSaver;
	Found:=False;
	While (Cur<>Nil) And (Not Found) Do
		If D.UpCaseLine(String(Cur^.Name^))=VName
			Then Found:=True
			Else Cur:=Cur^.Next;
	If Found
		Then FindScrSaver:=Cur
		Else FindScrSaver:=Nil
End;




Function LoadCursor(Name:String): Pointer;
Var
	Cur: PCursor;
Begin
	New(Cur);
	Cur^.Next:=FirstCursor;
	FirstCursor:=Cur;

	With Cur^ Do
	Begin
		Pic.LoadCUR(Name, Image, HotX, HotY);
		SizeX:=Gfx.ImageX(Image);
		SizeY:=Gfx.ImageY(Image);
		LoadCursor:=Image
	End
End;

Procedure FreeCursor(VImage:Pointer);
Var
	Cur, Temp: PCursor;
	Found: Boolean;
Begin
	If FirstCursor=Nil Then Exit;
	If FirstCursor^.Image=VImage Then
	Begin
		Temp:=FirstCursor^.Next;
		FreeMem(FirstCursor^.Image, Gfx.ImageSize2(FirstCursor^.Image));
		Dispose(FirstCursor);
		FirstCursor:=Temp
	End
	Else Begin
		Cur:=FirstCursor;
		Found:=False;
		While (Cur^.Next<>Nil) And (Not Found) Do
			If Cur^.Next^.Image=VImage
				Then Found:=True
				Else Cur:=Cur^.Next;
		If Found Then
		Begin
			Temp:=Cur^.Next^.Next;
			FreeMem(Cur^.Next^.Image, Gfx.ImageSize2(Cur^.Next^.Image));
			Dispose(Cur^.Next);
			Cur^.Next:=Temp
		End
	End
End;

Function FindCursor(VImage:Pointer): PCursor;
Var
	Cur: PCursor;
	Found: Boolean;
Begin
	Cur:=FirstCursor;
	Found:=False;
	While (Cur<>Nil) And (Not Found) Do
		If Cur^.Image=VImage
			Then Found:=True
			Else Cur:=Cur^.Next;
	If Found
		Then FindCursor:=Cur
		Else FindCursor:=Nil
End;


Procedure IntSelectCursor(VImage:Pointer; ToHideMouse:Boolean);
Var
	NewCursor: PCursor;
Begin
	NewCursor:=FindCursor(VImage);
	If NewCursor=Nil Then
	Begin
		Log.ErrMsg('Kernel','IntSelectCursor','Cursor not found');
		Exit
	End;

	If ToHideMouse Then
		HideMouseProc(MsX, MsY);
	If MsSave<>Nil Then
	Begin
		FreeMem(MsSave, Gfx.ImageSize2(MsSave));
		Dec(MsRect.X1, MsHotX);
		Dec(MsRect.Y1, MsHotY);
		Inc(MsRect.X2, MsSizeX-MsHotX-1);
		Inc(MsRect.Y2, MsSizeY-MsHotY-1)
	End;

	MsImage:=NewCursor^.Image;
	MsSizeX:=Gfx.ImageX(MsImage)+MouseShadow;
	MsSizeY:=Gfx.ImageY(MsImage)+MouseShadow;
	GetMem(MsSave, Gfx.ImageSize(MsSizeX, MsSizeY));

	MsHotX:=NewCursor^.HotX;
	MsHotY:=NewCursor^.HotY;

	Inc(MsRect.X1, MsHotX);
	Inc(MsRect.Y1, MsHotY);
	Dec(MsRect.X2, MsSizeX-MsHotX-1);
	Dec(MsRect.Y2, MsSizeY-MsHotY-1);
	D.ToRange(MsX, MsRect.X1, MsRect.X2);
	D.ToRange(MsY, MsRect.Y1, MsRect.Y2);
	{With MsRect Do
		Log.BugMsg('Kernel','SelectCursor','New mouse rect: '+D.St(X1)+
			' '+D.St(Y1)+' '+D.St(X2)+' '+D.St(Y2));}

	If ToHideMouse Then
		ShowMouseProc(MsX, MsY)
End;


Procedure SelectCursor(VImage:Pointer);
Begin
	IntSelectCursor(VImage, InsideHeart And MouseVis)
End;

Procedure MouseWorkingNextFrame;
Begin
	Inc(MouseWorkingSubframe);
	If MouseWorkingSubframe>=MouseWorkingDelay Then
	Begin
		MouseWorkingSubframe:=1;
		D.Cycle(MouseWorkingFrame, 1, 5);
		IntSelectCursor(MouseWorking[MouseWorkingFrame], MouseVis)
	End
End;



Function SendMessage(Sender,Receiver:PProg; Msg:String; Data:Pointer): Pointer;
Begin
	If Receiver<>Nil
		Then SendMessage:=Receiver^.OnMessage(Receiver, Sender, Msg, Data)
		Else SendMessage:=Nil
End;


Procedure RunFile(FName:String);
Var
	TempExt: String;
	ShortFName, ShortFName2: String;
	F: File;
Begin
		{ fixme :) - there some external association list must be used }
	{LFN.LFNGetShortPath(False, FName, ShortFName);}
	ShortFName:=FName;
	TempExt:=D.UpCaseLine(D.ClipFExt(FName));
	Delete(TempExt, 1, 1);
	If (TempExt='BMP') Or (TempExt='GIF') Or (TempExt='JPG')
		Or (TempExt='JPE') {Or (TempExt='PCX')} Then
		RunBuiltIn('ViewPic', FName)
	Else If (TempExt='EXE') Or (TempExt='COM') Or (TempExt='BAT') Then
		RunDOSApp(ShortFName, '')
	Else If (TempExt='MPG') Or (TempExt='MPE') Then
		RunDOSApp('addon\dmpeg.exe -p0 -b', ShortFName)
	Else If (TempExt='AVI') Or (TempExt='FLI') Or (TempExt='FLC') Then
		RunDOSApp('addon\qv.exe', ShortFName)
	Else If (TempExt='WAV') Then
		RunBuiltIn('WavePlay', ShortFName)
	{Else If (TempExt='HTM') Then
		RunBuiltIn('TestHTM1', ShortFName)}
	{Else If (TempExt='JPG') or (TempExt='JPE') Then
	Begin
		Log.BugMsg('Kernel', 'RunFile', 'Opening JPEG');
		ShortFName2:=D.ClipFName(ShortFName)+'.gif';
		Log.ActMsg('ShortFName2: '+ShortFName2);
		If D.FileExist(ShortFName2) Then
		Begin
			Log.ActMsg('File exist, erasing');
			Assign(F, ShortFName2);
			Erase(F)
		End;
		Log.ActMsg('Executing addon\jpg2gif.exe');
		DOS.Exec('addon\jpg2gif.exe', ShortFName);
		If D.FileExist(ShortFName2) Then
		Begin
			Log.ActMsg('File created, starting ViewPic');
			RunBuiltIn('ViewPic', ShortFName2);
			Assign(F, ShortFName2);
			Erase(F)
		End
		Else Log.ActMsg('File not found :(');
	End}
	Else RunBuiltIn('Notepad', FName);

End;

Function GetFileIcon(FName:String): Pointer;
Var
	TempExt: String;
Begin
	TempExt:=D.UpCaseLine(D.ClipFExt(FName));
	Delete(TempExt, 1, 1);
	GetFileIcon:=PicFileUnknown;
	If TempExt='TXT' Then GetFileIcon:=PicFileText;
	If (TempExt='BMP') Or (TempExt='GIF') Or (TempExt='JPG')
		Or (TempExt='JPE') {Or (TempExt='PCX')} Then GetFileIcon:=PicFilePicture;
	If (TempExt='EXE') Or (TempExt='COM') Or (TempExt='BAT') Then GetFileIcon:=PicFileProgram;
	If (TempExt='MPG') Or (TempExt='MPE') Or (TempExt='AVI') Or
		(TempExt='FLI') Or (TempExt='FLC') Then GetFileIcon:=PicFileVideo;
	If TempExt='WAV' Then GetFileIcon:=PicFileMusic;
	If TempExt='RAF' Then GetFileIcon:=PicFileRFont;
	If TempExt='CHR' Then GetFileIcon:=PicFileVFont;
	{If TempExt='HTM' Then GetFileIcon:=PicFileHTML;}
End;

Function GetFileDescr(FName:String): String;
Var
	TempExt, TempDescr: String;
Begin
	TempExt:=D.UpCaseLine(D.ClipFExt(FName));
	Delete(TempExt, 1, 1);
	TempDescr:='i ⨯';
	If TempExt='TXT' Then TempDescr:='';
	If (TempExt='BMP') Or (TempExt='GIF') Or (TempExt='JPG') Or
		(TempExt='JPE') {Or (TempExt='PCX')} Then TempDescr:='⨭';
	If (TempExt='EXE') Or (TempExt='COM') Or (TempExt='BAT') Then TempDescr:='ணࠬ';
	If (TempExt='MPG') Or (TempExt='AVI') Or (TempExt='FLI') Or
		(TempExt='FLC') Then TempDescr:='i';
	If TempExt='WAV' Then TempDescr:='㧨';
	{If TempExt='HTM' Then TempDescr:='Web-i';}
	If TempExt='RAF' Then TempDescr:='஢ ';
	If TempExt='CHR' Then TempDescr:='୨ ';

	GetFileDescr:=TempDescr+' ('+D.UpCaseLine(TempExt)+')'
End;









Procedure LoadingScreen;
Var
	TempX, TempY: Integer;
Begin
	Gfx.Bar(0, 0, Gfx.ScrX, Gfx.ScrY, clGray);
	Gfx.PutSprite((Gfx.ScrX-Gfx.ImageX(PolitLogoPic)) Div 2,
		(Gfx.ScrY-Gfx.ImageY(PolitLogoPic)) Div 2, PolitLogoPic);
	TempX:=(Gfx.ScrX Div 2)-LoadingStepsTotal-2;
	TempY:=(Gfx.ScrY+Gfx.ImageY(PolitLogoPic)) Div 2+30;
	Gfx.Rectangle(TempX, TempY-2, TempX+LoadingStepsTotal*2+2,
		TempY+19, clWhite);
	LoadingSteps:=0
End;

Procedure LoadingStep;
Var
	TempX,TempY:Integer;
Begin
	If Not LoadingNow Then Exit;
	Inc(LoadingSteps);
	TempX:=(Gfx.ScrX Div 2)-LoadingStepsTotal-2+LoadingSteps*2;
	TempY:=(Gfx.ScrY+Gfx.ImageY(PolitLogoPic)) Div 2+30;
	Gfx.Line(TempX, TempY, TempX, TempY+17, clWhite);
	{BCRT.Delay(21)}
End;

Procedure MakeDesktopMenu;
Var
	CurBuiltIn: PBuiltIn;
Begin
	MnuDesktop:=Popup.CreateMenu;
	Popup.AddCommand(MnuDesktop, 'i ࠭', 'F9', '஡ i'+#13+
		'筮 ii쪮 ࠭'+#13+'(. 䠩 SHOTnnnn.PCX)',
		PicShot, True, OnDesktopMenuCmdClick);
	Popup.AddSpace(MnuDesktop);

	CurBuiltIn:=FirstBuiltIn;
	While CurBuiltIn<>Nil Do
	Begin
		If String(CurBuiltIn^.FriendlyName^)<>'' Then
			Popup.AddCommand(MnuDesktop, String(CurBuiltIn^.FriendlyName^), '', '',
				CurBuiltIn^.Icon, True, OnDesktopMenuProgClick);
		CurBuiltIn:=CurBuiltIn^.Next
	End;

	Popup.AddSpace(MnuDesktop);
	Popup.AddCommand(MnuDesktop, '⠢', '',
		' ࠭ ⠢ (screensaver)',
		PicSaver, True, OnDesktopMenuCmdClick);
	Popup.AddCommand(MnuDesktop, '१⠦', '', '',
		PicReboot, True, OnDesktopMenuCmdClick);
	Popup.AddCommand(MnuDesktop, '', '', '',
		PicQuit, True, OnDesktopMenuCmdClick)
End;

Procedure LoadKeybLayouts;
Var
	SR: SearchRec;
	C: Char;
	F: File;
Begin
	LayoutNum:=0;
	KeybLayoutName[0]:='EN';
	FindFirst('??.kbd', AnyFile, SR);
	While DOSerror=0 Do
	Begin
		Inc(LayoutNum);
		For C:=#0 To #255 Do
			KeybLayout[LayoutNum, C]:=C;
		Assign(F, SR.Name);
		Reset(F, 1);
		BlockRead(F, KeybLayout[LayoutNum, #32], 96);
		Close(F);
		KeybLayoutName[LayoutNum]:=Copy(SR.Name, 1, 2);
		Log.SysMsg('Kernel', 'LoadKeybLayouts', 'Layout N '+D.St(LayoutNum)+
			' loaded: '+SR.Name);

		FindNext(SR)
	End;
	CurLayout:=0{LayoutNum}
End;

Procedure Init;
Var
	Temp: String;
	I: Integer;
Begin
	TempDir:='Temp\';
	If GetCurDriveType=dtFloppy Then
	Begin { i 饭  ᪥ }
		Log.Enabled:=False;
		Ini.FlushNeeded:=False;

		If D.PathExist('C:\') Then TempDir:='C:\'
	End;
	If D.PathExist('C:\WINDOWS\TEMP') Then
		TempDir:='C:\WINDOWS\TEMP\';

	Log.SysMsg('Kernel', 'Init', 'Kernel init sequence started');
	Log.BugMsg('Kernel', 'Init', 'TempDir = '+TempDir);
	{Ini.Init;}
	Ini.Load('polit.ini');
	Gfx.Init;
	PolitLogoPic:=LoadBMPRes('pic\biglogo.bmp');
	LoadingNow:=True;
	LoadingSteps:=0;
	LoadingScreen;

	Screen.X1:=0;
	Screen.Y1:=0;
	Screen.X2:=Gfx.ScrX;
	Screen.Y2:=Gfx.ScrY;
	Mouse.Init;

	Ini.Select('polit.ini', 'Boot');
	CurFont:=LoadRes(Ini.GetStr('Font', 'fonts\default.raf')); LoadingStep;
	Temp:=Ini.GetStr('WinBGMode', 'SolidColor');
	WinBGMode:=bgSolidColor;
	If Temp='METAL' Then WinBGMode:=bgMetal;
	If Temp='STRIPED' Then WinBGMode:=bgStriped;

	SkinDir:=Ini.GetStr('SkinDir', 'skin\default\');
	If Length(SkinDir)>0 Then
		If SkinDir[Length(SkinDir)]<>'\' Then
			SkinDir:=SkinDir+'\';
	Ini.SelectSec('Mouse');
	MouseShadow:=Ini.GetInt('ShadowDepth', 0);
	MouseDir:=Ini.GetStr('CursorsDir', 'mouse\neutral\');
	If Length(MouseDir)>0 Then
		If MouseDir[Length(MouseDir)]<>'\' Then
			MouseDir:=MouseDir+'\';

	InsideHeart:=False;
	MsSave:=Nil;
	MouseDefault:=LoadCursor(MouseDir+'default.cur'); LoadingStep;
	MouseMove:=LoadCursor(MouseDir+'move.cur'); LoadingStep;
	MouseResizeHor:=LoadCursor(MouseDir+'size_hor.cur'); LoadingStep;
	MouseResizeVer:=LoadCursor(MouseDir+'size_ver.cur'); LoadingStep;
	MouseResizeDiag1:=LoadCursor(MouseDir+'size_d1.cur'); LoadingStep;
	MouseResizeDiag2:=LoadCursor(MouseDir+'size_d2.cur'); LoadingStep;
	MouseText:=LoadCursor(MouseDir+'textsel.cur'); LoadingStep;
	MouseNo:=LoadCursor(MouseDir+'no.cur'); LoadingStep;
	MouseWait:=LoadCursor(MouseDir+'wait.cur'); LoadingStep;
	MouseWorking[1]:=LoadCursor(MouseDir+'working1.cur'); LoadingStep;
	MouseWorking[2]:=LoadCursor(MouseDir+'working2.cur'); LoadingStep;
	MouseWorking[3]:=LoadCursor(MouseDir+'working3.cur'); LoadingStep;
	MouseWorking[4]:=LoadCursor(MouseDir+'working4.cur'); LoadingStep;
	MouseWorkingFrame:=1;
	MouseWorkingSubframe:=1;
	D.AssignRect(0, 0, Gfx.ScrX, Gfx.ScrY, MsRect);
	SelectCursor(MouseDefault);
	MsX:=ScrX Div 2;
	MsY:=ScrY Div 2;

	PicShot:=Kernel.LoadBMPRes('pic\b_sshot.bmp'); LoadingStep;
	PicReboot:=Kernel.LoadBMPRes('pic\b_restar.bmp'); LoadingStep;
	PicQuit:=Kernel.LoadBMPRes('pic\b_exit.bmp'); LoadingStep;
	PicSaver:=Kernel.LoadBMPRes('pic\b_ssaver.bmp'); LoadingStep;
	PicFileUnknown:=Kernel.LoadBMPRes('pic\file.bmp'); LoadingStep;
	PicFileText:=Kernel.LoadBMPRes('pic\f_txt.bmp'); LoadingStep;
	PicFilePicture:=Kernel.LoadBMPRes('pic\f_pic.bmp'); LoadingStep;
	PicFileProgram:=Kernel.LoadBMPRes('pic\f_prog.bmp'); LoadingStep;
	PicFileVideo:=Kernel.LoadBMPRes('pic\f_video.bmp'); LoadingStep;
	PicFileMusic:=Kernel.LoadBMPRes('pic\f_wav.bmp'); LoadingStep;
	PicFileHTML:=Kernel.LoadBMPRes('pic\f_htm.bmp'); LoadingStep;
	PicFileRFont:=Kernel.LoadBMPRes('pic\f_rfont.bmp'); LoadingStep;
	PicFileVFont:=Kernel.LoadBMPRes('pic\f_vfont.bmp'); LoadingStep;
	PicOK:=Kernel.LoadBMPRes('pic\b_ok.bmp'); LoadingStep;
	PicApply:=Kernel.LoadBMPRes('pic\b_apply.bmp'); LoadingStep;
	PicClose:=Kernel.LoadBMPRes('pic\b_cancel.bmp'); LoadingStep;
	PicCut:=Kernel.LoadBMPRes('pic\b_cut.bmp'); LoadingStep;
	PicCopy:=Kernel.LoadBMPRes('pic\b_copy.bmp'); LoadingStep;
	PicPaste:=Kernel.LoadBMPRes('pic\b_paste.bmp'); LoadingStep;

	Ctl.Init;
	Ctl2.Init;
	Ctl3.Init;
	WinLook.Init;
	Popup.Init;

	ShowMouseProc:=ShowMouse;
	HideMouseProc:=HideMouse;
	RefreshNeededFunc:=RefreshNeeded;
	Ini.Select('polit.ini', 'Graphics');
	Temp:=Ini.GetStr('ColorScheme', 'colors\default.ini');
	Ini.Load(Temp); LoadingStep;

	Ini.SelectSec('Colors');
	ClrWinBG:=Ini.GetInt('WindowBG', clSilver);
	ClrWinDarkBG:=Ini.GetInt('WindowDarkBG', clMidGray);
	ClrWinLight:=Ini.GetInt('ActWinLightPlus', clWhite);
	ClrWinDark:=Ini.GetInt('ActWinDarkPlus', clGray);
	Clr3DFace:=Ini.GetInt('3DFace', clSilver);
	Clr3DLight:=Ini.GetInt('3DLight', clWhite);
	Clr3DDark:=Ini.GetInt('3DDark', clGray);
	Clr3DAct:=Ini.GetInt('3DAct', clBlueGray);
	Clr3DActLight:=Ini.GetInt('3DActLight', clWhite);
	Clr3DActDark:=Ini.GetInt('3DActDark', clNavy);
	ClrText:=Ini.GetInt('Text', clBlack);
	ClrTextDis:=Ini.GetInt('TextDisabled', clGray);
	ClrTextCom:=Ini.GetInt('TextComment', clWhite);
	ClrTextAct:=Ini.GetInt('TextActive', clBlack);
	ClrAccent:=Ini.GetInt('Accent', clBlue);
	ClrAccent2:=Ini.GetInt('Accent2', clBlueGray);
	ClrLines:=Ini.GetInt('Lines', clBlue);
	ClrLines2:=Ini.GetInt('Lines2', clBlueGray);
	ClrDisabled:=Ini.GetInt('Disabled', clGray);
	ClrDisabled2:=Ini.GetInt('Disabled2', clMidGray);
	ClrEdit:=Ini.GetInt('EditBG', clWhite);
	ClrEditDark:=Ini.GetInt('EditDark', clMidGray);
	ClrEditDarker:=Ini.GetInt('EditDarker', clBlack);
	ClrEditFont:=Ini.GetInt('EditFont', clBlack);
	ClrEditSel:=Ini.GetInt('EditSel', clBlueGray);
	ClrEditSelFont:=Ini.GetInt('EditSelFont', clBlack);
	ClrList:=Ini.GetInt('ListBG', clTeal);
	ClrListDark:=Ini.GetInt('ListDark', clDarkTeal);
	ClrListDarker:=Ini.GetInt('ListDarker', clBlack);
	ClrListFont:=Ini.GetInt('ListFont', clWhite);
	ClrListSel:=Ini.GetInt('ListSel', clBlueGray);
	ClrListSelFont:=Ini.GetInt('ListSelFont', clWhite);
	ClrStatic:=Ini.GetInt('Static', clWhite);


	Ini.Select('polit.ini', 'Hint');
	HintShowTime:=Ini.GetInt('ShowTime', 18);
	HintHideTime:=Ini.GetInt('HideTime', 72);
	HintShadowDepth:=Ini.GetInt('ShadowDepth', 3);
	HintAnimate:=Ini.GetBool('AnimateShow', True);
	Ini.Select('polit.ini', 'Mouse');
	MsSpeed:=Ini.GetInt('Speed', 8);

	LoadWinPosList; LoadingStep;

	Ini.Select('polit.ini', 'Keyboard');
	D.SetupKeyboard(Ini.GetInt('RepeatDelay', 1),
		Ini.GetInt('RepeatSpeed', 12));

	LoadKeybLayouts; LoadingStep;

	DontBother:=False;
	HintPresent:=False;
	LastMouseMove:=D.SysTimer;
	{PopupItemsNum:=0;
	PopupItem[1].Y:=0;}
	IgnoreAutoRedraw:=False;
	LoadingNow:=False;
	LastKeyStatus:=0;
End;

Procedure StartUp;
Var
	F: Text;
	TempName, TempParam, TempState: String;
	TempProg: PProg;
	FileEmpty: Boolean;
Begin
	Gfx.ClearDesk;
	MakeDesktopMenu;
	FileEmpty:=True;
	If D.FileExist('autoexec.dat') Then
	Begin
		Assign(F, 'autoexec.dat');
		Reset(F);
		Gfx.AllowZoomRect:=False;
		While Not EOF(F) Do
		Begin
			ReadLn(F, TempName);
			ReadLn(F, TempParam);
			ReadLn(F, TempState);
			ReadLn(F);
			TempProg:=RunBuiltInInt(TempName, TempParam, Nil);
			If TempProg<>Nil Then
			Begin
				RaiseEvent('OpenWin', TempProg);
				If TempState='Min' Then MinimizeWindow(TempProg)
			End;
			FileEmpty:=False
		End;
		Gfx.AllowZoomRect:=True;
		Close(F)
	End;
	If FileEmpty Then
	Begin
		RunBuiltIn('TaskBar', '');
	End;

	Ini.Select('polit.ini', 'ScreenSaver');
	ScrSaver:=FindScrSaver(Ini.GetStr('Name', 'Black'));
	If ScrSaver<>Nil Then
		ScrSaveTime:=Round(Ini.GetInt('Time', 60)*18.2);
End;

Procedure CloseAllProgs;
Var
	Cur, LastProg: PProg;
	F: Text;
	I: Integer;
Begin
	Cur:=FirstProg;
	ZListFree;
	While Cur<>Nil Do
	Begin
		ZListAdd(Cur);
		Cur:=Cur^.Next
	End;
	ZListSortByZ;

	Assign(F, 'autoexec.dat');
	Rewrite(F);
	For I:=1 To ZListNum Do
		If ZList[I]^.Parent=Nil Then
		Begin
			WriteLn(F, String(ZList[I]^.Name^));
			WriteLn(F, String(ZList[I]^.Param^));
			If ZList[I]^.Visible
				Then WriteLn(F, 'Normal')
				Else WriteLn(F, 'Min');
			WriteLn(F)
		End;
	Close(F);

	While FirstProg<>Nil Do
		CloseProg(FirstProg)
End;

Procedure Done;
Begin
	Log.SysMsg('Kernel', 'Done', 'Kernel shutdown sequence started');
	Log.BugMsg('Kernel', 'Done', 'Loading Steps = '+D.St(LoadingSteps));

	Gfx.AllowZoomRect:=False;
	CloseAllProgs;
	Gfx.AllowZoomRect:=True;
	SaveAndFreeWinPosList;

	FreeRes('biglogo.bmp');
	Ini.Select('polit.ini', 'Boot');
	FreeRes(Ini.GetStr('Font', 'fonts\default.raf'));

	FreeCursor(MouseDefault);
	FreeCursor(MouseMove);
	FreeCursor(MouseResizeHor);
	FreeCursor(MouseResizeVer);
	FreeCursor(MouseResizeDiag1);
	FreeCursor(MouseResizeDiag2);
	FreeCursor(MouseText);
	FreeCursor(MouseNo);
	FreeCursor(MouseWait);
	FreeCursor(MouseWorking[1]);
	FreeCursor(MouseWorking[2]);
	FreeCursor(MouseWorking[3]);
	FreeCursor(MouseWorking[4]);

	Kernel.FreeRes('b_sshot.bmp');
	Kernel.FreeRes('b_restar.bmp');
	Kernel.FreeRes('b_exit.bmp');
	Kernel.FreeRes('b_ssaver.bmp');

	Kernel.FreeRes('file.bmp');
	Kernel.FreeRes('f_txt.bmp');
	Kernel.FreeRes('f_pic.bmp');
	Kernel.FreeRes('f_prog.bmp');
	Kernel.FreeRes('f_video.bmp');
	Kernel.FreeRes('f_wav.bmp');
	Kernel.FreeRes('f_htm.bmp');

	Kernel.FreeRes('b_ok.bmp');
	Kernel.FreeRes('b_apply.bmp');
	Kernel.FreeRes('b_close.bmp');
	Kernel.FreeRes('b_cut.bmp');
	Kernel.FreeRes('b_copy.bmp');
	Kernel.FreeRes('b_paste.bmp');

	Ctl.Done;
	Ctl2.Done;
	Ctl3.Done;
	WinLook.Done;
	Popup.FreeMenu(MnuDesktop);
	Popup.Done;

	FreeAllWinLooks;
	Ini.Done;
	RemoveAllTimers;
	RemoveAllEvents;
	Gfx.Done;
	FreeAllRes;
	Log.Done
End;


Procedure RestartPolit;
Begin
	Log.BugMsg('Kernel', 'RestartPolit', 'Starting...');
	Done;

	Log.Init('polit.log', True);
	Init;
	StartUp;
	Log.BugMsg('Kernel', 'RestartPolit', 'Finished successfully');
End;

Procedure RunDOSApp(FName,Params:String);
Var
	LastDir, TempCmd: String;
Begin
	Done;

	GetDir(0, LastDir);
	ChDir(D.DropLastPathItem(FName));
	TempCmd:='/C '+D.ClipFNameExt(FName)+' '+Params;
	DOS.Exec(GetEnv('COMSPEC'), TempCmd);

	WriteLn;
	WriteLn(FName+' executed.');
	Write('Press Enter to return to Polit...');
	ReadLn;
	ChDir(LastDir);

	Log.Init('polit.log', True);
	Init;
	StartUp
End;


Procedure GoodbyePolit;
Begin
	Gfx.FadeDownPal;

		{ FreeAllBuiltIns was after Done; this may cause problems when }
		{  progs will run built-ins when system is going to shut down  }

	Done;
	FreeAllBuiltIns;


	Halt(1)
End;

Begin
	Log.Init('polit.log', True);
	Init;
	{ProcsTable.RunBuiltIn:=RunBuiltIn;
	ProcsTable.InitWindow:=InitWindow;
	ProcsTable.DrawWindow:=DrawWindow;
	ProcsTable.AssignPStr:=D.AssignPStr;}
	D.CheckMachineSpeed;
	D.DetectHostOS;
	{D.DetectLFNSupport;}

	FirstBuiltIn:=Nil;
	{FirstWinLook:=Nil;}
End.