{$F+}
Unit
	KeySetup; { Polit Halcyon KeySetup application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Gfx, DOS;

Const
	DelayTab: Array[0..3] Of String[4]=('0.25', '0.5', '0.75', '1.0');
	RateTab: Array[0..31] Of String[4]=
		('30.0', '26.7', '24.0', '21.8', '20.0', '18.5', '17.1', '16.0',
		 '15.0', '13.3', '12.0', '10.9', '10.0',  '9.2',  '8.6',  '8.0',
		  '7.5',  '6.7',  '6.0',  '5.5',  '5.0',  '4.6',  '4.3',  '4.0',
		  '3.7',  '3.3',  '3.0',  '2.7',  '2.5',  '2.3',  '2.1',  '2.0');

Type
	TKeySetupData=Record
		HdrRepeat: PControl;
		LabRep1, TrkRepDelay, LabRepDelay: PControl;
		LabRep2, TrkRepSpeed, LabRepSpeed: PControl;
		HdrCursor: PControl;
		LabCur1, TrkCurRate, CanCurRate: PControl;
		BtnTry, BtnClose: PControl;
		PicBarCtls: Pointer;
		TimCursor: PControl;
		NbkPages, HdrKeys,
		LabKeyPrev, InpKeyPrev,
		LabKeyNext, InpKeyNext,
		LabKeyMax, InpKeyMax,
		LabKeyMin, InpKeyMin,
		LabKeyClose, InpKeyClose,
		LabKeyMenu, InpKeyMenu, PctBarCtls: PControl;

		Hdr0, LstLanguages: PControl;
		Hdr1, RadNone, RadName, RadFlag, PctSample: PControl;
		Hdr2, ChkLShift, ChkLCtrl, ChkLAlt,
		ChkRShift, ChkRCtrl, ChkRAlt: PControl;

		BlinkRate, CurTick: Integer;
		CurColor: TColor;
		PicLangNone, PicLangName, PicLangFlag: Pointer;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TKeySetupData(Data^) Do
	Begin
		Kernel.WinBGBar(Me, X1, Y1, X2, Y1+4);
		Kernel.WinBGBar(Me, X1, Y1+5, X1+4, Y2-35);
		Kernel.WinBGBar(Me, X2-4, Y1+5, X2, Y2-35);
		Kernel.WinBGBar(Me, X1, Y2-34, X2, Y2);
		Kernel.WindowBar(X1+5, Y1+5+22, X2-5, Y2-35, False, False);

		Ctl.Notebook_Paint(NbkPages, 5, 5, X2-X1-5, Y2-Y1-35);
			{ page 1 }
		Ctl.Header_Paint(HdrRepeat, 15, 40, X2-X1-15);
		Ctl.Label_Paint(LabRep1, 25, 55, X2-X1-12);
		Ctl.Track_Paint(TrkRepDelay, 95, 75, 175);
		Ctl.Label_Paint(LabRepDelay, 185, 75, 255);
		Ctl.Label_Paint(LabRep2, 25, 115, X2-X1-25);
		Ctl.Track_Paint(TrkRepSpeed, 25, 135, 175);
		Ctl.Label_Paint(LabRepSpeed, 185, 135, 255);

		Ctl.Header_Paint(HdrCursor, 15, 180, X2-X1-15);
		Ctl.Label_Paint(LabCur1, 25, 195, X2-X1-25);
		Ctl.Track_Paint(TrkCurRate, 25, 215, 175);
		Ctl.Canvas_Paint(CanCurRate, 185, 215, 255, 235);
			{ page 2 }
		Ctl.Label_Paint(LabKeyPrev, 15, 40, 130);
		Ctl.InpLine_Paint(InpKeyPrev, 140, 40, 230);
		Ctl.Label_Paint(LabKeyNext, 15, 65, 130);
		Ctl.InpLine_Paint(InpKeyNext, 140, 65, 230);
		Ctl.Label_Paint(LabKeyMax, 15, 90, 130);
		Ctl.InpLine_Paint(InpKeyMax, 140, 90, 230);
		Ctl.Label_Paint(LabKeyMin, 15, 115, 130);
		Ctl.InpLine_Paint(InpKeyMin, 140, 115, 230);
		Ctl.Label_Paint(LabKeyClose, 15, 140, 130);
		Ctl.InpLine_Paint(InpKeyClose, 140, 140, 230);
		Ctl.Label_Paint(LabKeyMenu, 15, 165, 130);
		Ctl.InpLine_Paint(InpKeyMenu, 140, 165, 230);
		Ctl.PicCtl_Paint(PctBarCtls, 240, 40);
			{ page 3 }
		Ctl.Header_Paint(Hdr0, 15, 40, 115);
		Ctl2.ListBox_Paint(LstLanguages, 15, 57, 115, 140);

		Ctl.Header_Paint(Hdr1, 140, 40, X2-X1-15);
		Ctl.PicCtl_Paint(PctSample, 140, 57);
		Ctl.Radio_Paint(RadNone, 140, 85);
		Ctl.Radio_Paint(RadName, 140, 105);
		Ctl.Radio_Paint(RadFlag, 140, 125);
		

		Ctl.Header_Paint(Hdr2, 15, 165, X2-X1-15);
		Ctl.Check_Paint(ChkLShift, 15, 180);
		Ctl.Check_Paint(ChkLCtrl, 15, 200);
		Ctl.Check_Paint(ChkLAlt, 15, 220);
		Ctl.Check_Paint(ChkRShift, 140, 180);
		Ctl.Check_Paint(ChkRCtrl, 140, 200);
		Ctl.Check_Paint(ChkRAlt, 140, 220);

		Ctl.Button_Paint(BtnTry, X2-X1-215, Y2-Y1-26, X2-X1-115);
		Ctl.Button_Paint(BtnClose, X2-X1-105, Y2-Y1-26, X2-X1-5);
	End;
End;

Procedure OnDelayChange(Me:PProg; Control:PControl);
Begin
	With Me^, TKeySetupData(Data^) Do
		Ctl.Label_SetCaption(LabRepDelay,
			DelayTab[Ctl.Track_GetPos(TrkRepDelay)]+' ᥪ')
End;

Procedure OnSpeedChange(Me:PProg; Control:PControl);
Begin
	With Me^, TKeySetupData(Data^) Do
		Ctl.Label_SetCaption(LabRepSpeed,
			RateTab[31-Ctl.Track_GetPos(TrkRepSpeed)]+' / ᥪ')
End;

Procedure OnCurRateChange(Me:PProg; Control:PControl);
Begin
	With Me^, TKeySetupData(Data^) Do
		BlinkRate:=19-Ctl.Track_GetPos(TrkCurRate)
End;

Procedure OnCursorTimer(Me:PProg; Control:PControl; Times:Integer);
Begin
	With Me^, TKeySetupData(Data^) Do
	Begin
		Inc(CurTick, Times);
		If CurTick>=BlinkRate Then
		Begin
			CurTick:=0;
			If CurColor=Kernel.ClrDisabled
				Then CurColor:=Kernel.ClrStatic
				Else CurColor:=Kernel.ClrDisabled;
			If Ctl.Notebook_GetActivePage(NbkPages)=1 Then
				With CanCurRate^.Place Do
				Begin
					Kernel.BeginPaintCoord(X1+34, Y1+3, X1+35, Y1+17);
					Gfx.Bar(X1+34, Y1+3, X1+35, Y1+17, CurColor);
					Kernel.EndPaint
				End
		End
	End
End;

Procedure OnLangSignModeChange(Me:PProg; Control:PControl);
Begin
	With TKeySetupData(Me^.Data^) Do
	Begin
		If Ctl.Radio_Selected(RadNone) Then
			Ctl.PicCtl_SetPicture(PctSample, PicLangNone);
		If Ctl.Radio_Selected(RadName) Then
			Ctl.PicCtl_SetPicture(PctSample, PicLangName);
		If Ctl.Radio_Selected(RadFlag) Then
			Ctl.PicCtl_SetPicture(PctSample, PicLangFlag);
	End;
End;

Procedure OnApplyClick(Me:PProg; Control:PControl);
Var
	TempPtr: Pointer;
	TempStr: String;
	CurItem: PListItem;
	SR: SearchRec;
	WasEnabled, NowEnabled: Boolean;
	F: File;
Begin
	With Me^, TKeySetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Keyboard');
		Ini.SetInt('RepeatDelay', Ctl.Track_GetPos(TrkRepDelay));
		Ini.SetInt('RepeatSpeed', 31-Ctl.Track_GetPos(TrkRepSpeed));
		Ini.Select('polit.ini', 'Controls');
		Ini.SetInt('CursorBlinkPeriod', 19-Ctl.Track_GetPos(TrkCurRate));

		Ini.Select('polit.ini', 'Taskbar');
			{ i ᯮi    ᪡i }
		TempStr:='Name';
		If Ctl.Radio_Selected(RadNone) Then TempStr:='No';
		If Ctl.Radio_Selected(RadName) Then TempStr:='Name';
		If Ctl.Radio_Selected(RadFlag) Then TempStr:='Flag';
		Ini.SetStr('ShowLanguage', TempStr);
			{ i i ii  ४祭  }
		TempStr:='';
		If Ctl.Check_GetState(ChkLShift) Then TempStr:=TempStr+'LeftShift';
		If Ctl.Check_GetState(ChkLCtrl) Then TempStr:=TempStr+'LeftCtrl';
		If Ctl.Check_GetState(ChkLAlt) Then TempStr:=TempStr+'LeftAlt';
		If Ctl.Check_GetState(ChkRSHift) Then TempStr:=TempStr+'RightShift';
		If Ctl.Check_GetState(ChkRCtrl) Then TempStr:=TempStr+'RightCtrl';
		If Ctl.Check_GetState(ChkRAlt) Then TempStr:=TempStr+'RightAlt';
		Ini.SetStr('SwitchLanguage', TempStr);
		Ini.SaveCurFile;
			{ i ன ⨢/⨢ ஧ }
		CurItem:=Ctl2.ListBox_GetItemByIndex(LstLanguages, 1);
		While CurItem<>Nil Do
		Begin
			TempStr:=String(CurItem^.SubItem^.Name^);
			WasEnabled:=(Pos('-OFF', TempStr)=0);
			NowEnabled:=CurItem^.Selected;
			If WasEnabled<>NowEnabled Then
			Begin
				Assign(F, TempStr);
				If NowEnabled
					Then Rename(F, Copy(TempStr, 1, 2)+'.kbd')
					Else Rename(F, Copy(TempStr, 1, 2)+'-off.kbd')
			End;
			CurItem:=CurItem^.Next
		End
	End;
	If Me^.Parent<>Nil Then
		TempPtr:=Kernel.SendMessage(Me, Me^.Parent, 'Settings:OpenSheet', Nil);
	Kernel.RestartPolit
End;

Procedure OnCloseClick(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;

Procedure OnClose(Me:PProg);
Var
	TempPtr: Pointer;
	TempItem: PListItem;
	TempStr: String;
Begin
	With Me^, TKeySetupData(Data^) Do
	Begin
		If Parent<>Nil Then
			TempPtr:=Kernel.SendMessage(Me, Parent, 'Settings:CloseSheet', Nil);

			{ free language flags }
		TempItem:=Ctl2.ListBox_GetItemByIndex(LstLanguages, 1);
		While TempItem<>Nil Do
		Begin
			TempStr:=String(TempItem^.Name^)+'.bmp';
			If D.FileExist('prog\taskbar\'+TempStr) Then
				Kernel.FreeRes(TempStr);
			TempItem:=TempItem^.Next
		End
	End;
	Kernel.FreeRes('bar_ctls.bmp');
	Kernel.FreeRes('lng-none.bmp');
	Kernel.FreeRes('lng-name.bmp');
	Kernel.FreeRes('lng-flag.bmp');
	FreeMem(Me^.Data, SizeOf(TKeySetupData))
End;

Procedure ListAllLanguages(Me:PProg);
Var
	SR: SearchRec;
	TempStr: String;
	TempPtr: Pointer;
	TempItem: PListItem;
	N: Integer;
Begin
	With Me^, TKeySetupData(Data^) Do
	Begin
		N:=0;
		DOS.FindFirst('*.kbd', AnyFile Xor Directory, SR);
		While DOSError=0 Do
		Begin
			TempStr:='prog\taskbar\'+D.ClipFName(SR.Name)+'.bmp';
			If Pos('-OFF', TempStr)<>0 Then
				Delete(TempStr, Pos('-OFF', TempStr), 4);
			If D.FileExist(TempStr)
				Then TempPtr:=Kernel.LoadBMPRes(TempStr)
				Else TempPtr:=Nil;
			Ctl2.ListBox_AddItemLast(LstLanguages, Copy(SR.Name, 1, 2),
				TempPtr, 0);
			Ctl2.ListBox_AddSubItem(LstLanguages, SR.Name, Nil);
			Inc(N);
			TempItem:=Ctl2.ListBox_GetItemByIndex(LstLanguages, N);
				{   i祭 ஧? }
			TempItem^.Selected:=(Pos('-OFF', SR.Name)=0);
			DOS.FindNext(SR)
		End
	End
End;


Procedure OnInit(Me:PProg);
Var
	V, DelayVal, RateVal, CursorRateVal: Integer;
	TempStr: String;
	TempPtr: Pointer;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('i: ன', WinTitle);
		MinX:=280;
		MinY:=285;
		GetMem(Data, SizeOf(TKeySetupData));
		If Parent=Nil
			Then Kernel.InitWindow(Me, 'BlueDlg', [wbMin, wbClose])
			Else Kernel.InitSheetWindow(Me, 'BlueDlg', [wbSlide], brLeft);
		WinBG:=bgManualDark;
		Kernel.DrawWindowAni(Me);

		With TKeySetupData(Data^) Do
		Begin
			PicBarCtls:=Kernel.LoadBMPRes('pic\bar_ctls.bmp');
			PicLangNone:=Kernel.LoadBMPRes('prog\taskbar\lng-none.bmp');
			PicLangName:=Kernel.LoadBMPRes('prog\taskbar\lng-name.bmp');
			PicLangFlag:=Kernel.LoadBMPRes('prog\taskbar\lng-flag.bmp');

			Ini.Select('polit.ini', 'Keyboard');
			DelayVal:=Ini.GetInt('RepeatDelay', 1);
			D.ToRange(DelayVal, 0, 3);
			RateVal:=Ini.GetInt('RepeatSpeed', 12);
			D.ToRange(RateVal, 0, 31);
			Ini.Select('polit.ini', 'Controls');
			CursorRateVal:=Ini.GetInt('CursorBlinkPeriod', 5);
			D.ToRange(CursorRateVal, 1, 18);

			NbkPages:=Ctl.Notebook_Create(Me, True);

				{ ******* i 1 - i ******* }
			HdrRepeat:=Ctl.Header_Create(Me,
				'  i ਬ i...');
			LabRep1:=Ctl.Label_Create(Me, 'ਬ । 訬 ७:',
				Nil, lsNormal, alLeft);
			TrkRepDelay:=Ctl.Track_Create(Me, 0, 3, DelayVal, tkGrowRight, True,
				OnDelayChange);
			LabRep1^.FocusCtl:=TrkRepDelay;
			LabRepDelay:=Ctl.Label_Create(Me, DelayTab[DelayVal]+' ᥪ',
				Nil, lsBeveled, alCenter);
			LabRep2:=Ctl.Label_Create(Me, 'i ७:',
				Nil, lsNormal, alLeft);
			TrkRepSpeed:=Ctl.Track_Create(Me, 0, 31, 31-RateVal, tkGrowRight, False,
				OnSpeedChange);
			LabRep2^.FocusCtl:=TrkRepSpeed;
			LabRepSpeed:=Ctl.Label_Create(Me, RateTab[RateVal]+' / ᥪ',
				Nil, lsBeveled, alCenter);

			HdrCursor:=Ctl.Header_Create(Me, '');
			LabCur1:=Ctl.Label_Create(Me, 'i :',
				Nil, lsNormal, alLeft);
			TrkCurRate:=Ctl.Track_Create(Me, 1, 18, 19-CursorRateVal, tkGrowRight, False,
				OnCurRateChange);
			LabCur1^.FocusCtl:=TrkCurRate;
			CanCurRate:=Ctl.Canvas_Create(Me, True);

			Ctl.Notebook_AddPage(NbkPages, 'i', '', Nil);

				{ ******* i 2 - i ii ******* }
			LabKeyPrev:=Ctl.Label_Create(Me, '। i:', Nil, lsDisabled, alRight);
			InpKeyPrev:=Ctl.InpLine_Create(Me, 'Alt+F7', Nil);
			InpKeyPrev^.Enabled:=False;
			LabKeyNext:=Ctl.Label_Create(Me, '㯭 i:', Nil, lsDisabled, alRight);
			InpKeyNext:=Ctl.InpLine_Create(Me, 'Alt+F8', Nil);
			InpKeyNext^.Enabled:=False;
			LabKeyMax:=Ctl.Label_Create(Me, ':', Nil, lsDisabled, alRight);
			InpKeyMax:=Ctl.InpLine_Create(Me, 'Alt+plus', Nil);
			InpKeyMax^.Enabled:=False;
			LabKeyMin:=Ctl.Label_Create(Me, ':', Nil, lsDisabled, alRight);
			InpKeyMin:=Ctl.InpLine_Create(Me, 'Alt+minus', Nil);
			InpKeyMin^.Enabled:=False;
			LabKeyClose:=Ctl.Label_Create(Me, ':', Nil, lsDisabled, alRight);
			InpKeyClose:=Ctl.InpLine_Create(Me, 'Alt+F5', Nil);
			InpKeyClose^.Enabled:=False;
			LabKeyMenu:=Ctl.Label_Create(Me, ' :', Nil, lsDisabled, alRight);
			InpKeyMenu:=Ctl.InpLine_Create(Me, 'Alt+F9', Nil);
			InpKeyMenu^.Enabled:=False;
			PctBarCtls:=Ctl.PicCtl_Create(Me, PicBarCtls, False, False, True);

			Ctl.Notebook_AddPage(NbkPages, 'i ii', '', Nil);

				{ ******* i 3 -  ******* }
			Hdr0:=Ctl.Header_Create(Me, '㯭i ');
			LstLanguages:=Ctl2.ListBox_Create(Me, True);
			Ctl2.ListBox_SetColumnProps(LstLanguages, 2, lcLeft, False);
			ListAllLanguages(Me);

			Hdr1:=Ctl.Header_Create(Me, '  i ');

			Ini.Select('polit.ini', 'Taskbar');
			TempStr:=Ini.GetStr('ShowLanguage', 'NAME');
			TempPtr:=Nil;
			If TempStr='NO' Then TempPtr:=PicLangNone;
			If TempStr='NAME' Then TempPtr:=PicLangName;
			If TempStr='FLAG' Then TempPtr:=PicLangFlag;
			PctSample:=Ctl.PicCtl_Create(Me, TempPtr, False, False, True);
			RadNone:=Ctl.Radio_Create(Me, ' 㢠', (TempStr='NO'), 1);
			Ctl.Radio_SetOnChange(RadNone, OnLangSignModeChange);
			RadName:=Ctl.Radio_Create(Me, '㢠 ', (TempStr='NAME'), 1);
			Ctl.Radio_SetOnChange(RadName, OnLangSignModeChange);
			RadFlag:=Ctl.Radio_Create(Me, '㢠 ࠯', (TempStr='FLAG'), 1);
			Ctl.Radio_SetOnChange(RadFlag, OnLangSignModeChange);

			Ini.Select('polit.ini', 'Taskbar');
			TempStr:=Ini.GetStr('SwitchLanguage', '');
			Hdr2:=Ctl.Header_Create(Me, 'ii i  ४祭 ');
			ChkLShift:=Ctl.Check_Create(Me, 'i Shift',
				(Pos('LEFTSHIFT', TempStr)>0));
			ChkLCtrl:=Ctl.Check_Create(Me, 'i Ctrl',
				(Pos('LEFTCTRL', TempStr)>0));
			ChkLAlt:=Ctl.Check_Create(Me, 'i Alt',
				(Pos('LEFTALT', TempStr)>0));
			ChkRShift:=Ctl.Check_Create(Me, 'ࠢ Shift',
				(Pos('RIGHTSHIFT', TempStr)>0));
			ChkRCtrl:=Ctl.Check_Create(Me, 'ࠢ Ctrl',
				(Pos('RIGHTCTRL', TempStr)>0));
			ChkRAlt:=Ctl.Check_Create(Me, 'ࠢ Alt',
				(Pos('RIGHTALT', TempStr)>0));

			Ctl.Notebook_AddPage(NbkPages, '', '', Nil);

				{ ******* ६ ******* }
			BtnTry:=Ctl.Button_Create(Me, '஡㢠', Kernel.PicApply,
				ppLeft, OnApplyClick);
			D.ReassignPStr('ॣ ன '+#13+
				'१ i', BtnTry^.Hint);
			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseClick);
			TimCursor:=Ctl.TimerCtl_Create(Me, 1, True, OnCursorTimer);

			ActiveCtl:=TrkCurRate;
			ButtonEnter:=BtnTry;
			ButtonEsc:=BtnClose;

			CurTick:=0;
			BlinkRate:=19-Ctl.Track_GetPos(TrkCurRate);
			CurColor:=clWhite
		End
	End
End;



Begin
	Kernel.RegBuiltIn('KeySetup', '', 'pic\i_keyset.bmp', OnInit)
End.
