Const
	ListItemHeight=18;

Type
	TColumn=Record
		RealWidth: Integer;
		Align: TListColumnAlign;
		Visible: Boolean;
	End;
	TListBox=Record
		FirstItem, LastItem, RecentItem: PListItem;
		ItemsNum, FirstLine, SelItemNum, ClickedItemNum: Integer;
		RecentItemLevel: Integer;
		SelItem: PListItem;
		ShowIcons: Boolean;
		OnBeforeSelect, OnSelect, OnStrongSelect, OnContextMenu: TCtlHandler;
		OnHint: TListBoxHintHandler;
		Column: Array[1..12] Of TColumn;
		ColumnNum:Integer;
		SortFunc: TListBoxSortFunc;
		ListScroll: PControl;
		TempVisLen: Integer;
		MultiSelect: Boolean;
		SelItemsTotal: Integer;
	End;

Var
	ListPixelColor: Byte;
	ListVisLen, ListMouseItem: Integer;


Procedure ListBoxHintDummy(Me:PProg; Control:PControl; Item:PListItem);
Begin End;

Procedure ListBox_DrawItem(Me:PControl; Item:PListItem; ItemY:Integer;
	Selected: Boolean);
Const
	ColumnDist=18;
Var
	CurSubItem: PListItem;
	DebugCurX, NextDebugCurX, CurLevel: Integer;
	I, Color: Integer;

	Procedure DrawSubItem(Item:PListItem; X1,Y,X2:Integer;
		IsSubItem:Boolean; Align:TListColumnAlign);
	Var
		Shift: Integer;
		TempStr: String;
		TempAlign: TListColumnAlign;
		TempWidth: Integer;
	Begin
		With Me^, TListBox(Data^) Do
		Begin
			Inc(X1, Item^.Indent);
			If X1>=Place.X2-2 Then Exit;
			TempAlign:=Align;
			If X2>Place.X2-2 Then
			Begin
				TempWidth:=Place.X2-X1;
				If X2-ColumnDist>Place.X2 Then
					TempAlign:=lcLeft
			End
			Else
				TempWidth:=X2-X1;

			If MultiSelect And (Not IsSubItem) Then
			Begin
				Shift:=20;
				Gfx.PutSprite(X1-Item^.Indent, Y,
					Ctl.PicCheck[Enabled, Item^.Selected])
			End
			Else
				Shift:=0;
			If ShowIcons Then
			Begin
				If Item^.Icon<>Nil Then
				Begin
					If Enabled
						Then Gfx.PutSprite(X1+Shift, Y, Item^.Icon)
						Else Gfx.PutSpriteGrayed16(X1+Shift, Y, Item^.Icon);
					Inc(Shift, 20)
				End
				Else If Not IsSubItem Then
					Inc(Shift, 20)
			End;

			Font.SetFont(Kernel.CurFont);
			If TempAlign=lcRightMono
				Then TempStr:=Kernel.ShortenStrFW(String(Item^.Name^), TempWidth-Shift+1)
				Else TempStr:=Kernel.ShortenStr(String(Item^.Name^), TempWidth-Shift+1);
			Case TempAlign Of
				lcLeft: Font.Print(X1+Shift, Y+1, Color, TempStr);
				lcRight: Font.Print(X2-ColumnDist-Font.Width(TempStr),
					Y+1, Color, TempStr);
				lcRightMono: Font.PrintFW(X2-ColumnDist-Font.WidthFW(TempStr),
					Y+1, Color, TempStr)
			End;
		End
	End;

Begin
	With Me^, Place, TListBox(Data^) Do
	Begin
		If Enabled
			Then If Selected
				Then Color:=Kernel.ClrListSelFont
				Else Color:=Kernel.ClrListFont
			Else Color:=Kernel.ClrTextDis;
		DebugCurX:=X1+3+ColumnDist+Column[1].RealWidth;

		DrawSubItem(Item, X1+4, ItemY, DebugCurX, False, lcLeft);

		If Item^.SubItem<>Nil Then
		Begin
			CurSubItem:=Item^.SubItem;
			CurLevel:=2;
			Repeat
				If Column[CurLevel].Visible Then
				Begin
					NextDebugCurX:=DebugCurX-1+ColumnDist+Column[CurLevel].RealWidth;
					DrawSubItem(CurSubItem, DebugCurX, ItemY, NextDebugCurX, True,
						Column[CurLevel].Align);
					DebugCurX:=NextDebugCurX
				End;
				Inc(CurLevel);
				CurSubItem:=CurSubItem^.SubItem
			Until CurSubItem=Nil
		End
	End
End;

Procedure ListBox_OnRefocus(Me:PControl; Focused:Boolean);
Var
	I, CurColor, CurX, TempY: Integer;
Begin
	Inc(Me^.Place.X2, 16);
	Kernel.CtlRefocusDummy(Me, Focused);
	Dec(Me^.Place.X2, 16);

	With Me^, Place, TListBox(Data^) Do
	Begin
		TempVisLen:=(Y2-Y1-4) Div ListItemHeight;
		If D.InRange(SelItemNum, FirstLine, FirstLine+TempVisLen-1) Then
		Begin
			SelItem:=FirstItem;
			For I:=1 To SelItemNum-1 Do
				SelItem:=SelItem^.Next;
			TempY:=Y1+5+(SelItemNum-FirstLine)*18;
			If Focused
				Then CurColor:=Kernel.ClrListSel
				Else CurColor:=Kernel.ClrList;
			Gfx.Bar(X1+4, TempY, X2-2, TempY+15, CurColor);
			If ItemsNum>0 Then
				ListBox_DrawItem(Me, SelItem, TempY, Focused)
		End
	End
End;



Procedure ListBox_IntDraw(Me:PControl; DrawScroll:Boolean);
Const
	ColumnDist=9;
Var
	Cur: PListItem;
	CurY, TempY: Integer;
	I{, Color}: Integer;
	SystemActiveCtl: PControl;
Begin
	With Me^, TListBox(Data^), Place Do
	Begin
		ListScroll^.Enabled:=Enabled;
		ListScroll^.Visible:=Visible;
		ListScroll^.CanDraw:=True;
		If ((Not CanDraw) And (Not Kernel.DontBother)) Or Not Visible Then
			Exit;

		If Enabled Then
		Begin
			Gfx.AngleRect(X1, Y1, X2, Y2, Kernel.ClrListDarker);
			Gfx.AngleRect(X1+1, Y1+1, X2, Y2, Kernel.ClrListDark);
			Gfx.Bar(X1+2, Y1+2, X2, Y2, Kernel.ClrList)
		End
		Else Begin
			Gfx.AngleRect(X1, Y1, X2, Y2, Kernel.ClrDisabled);
			Gfx.AngleRect(X1+1, Y1+1, X2, Y2, Kernel.ClrDisabled2);
			Gfx.Bar(X1+2, Y1+2, X2, Y2, Kernel.ClrWinBG)
		End;

		If ItemsNum>0 Then
		Begin
			TempVisLen:=(Y2-Y1-4) Div ListItemHeight;
			If (ItemsNum>TempVisLen) And (FirstLine>ItemsNum-TempVisLen+1) Then
				FirstLine:=ItemsNum-TempVisLen+1;

			Cur:=FirstItem;
			I:=1;
			While I<FirstLine Do
			Begin
				Inc(I);
				If Cur<>Nil Then
					Cur:=Cur^.Next
			End;

			If Kernel.ActiveWin<>Nil
				Then SystemActiveCtl:=Kernel.ActiveWin^.ActiveCtl
				Else SystemActiveCtl:=Nil;
			If D.InRange(SelItemNum, FirstLine, FirstLine+TempVisLen-1) Then
			Begin
				TempY:=Y1+4+(SelItemNum-FirstLine)*18;
				If Enabled Then
				Begin
					If SystemActiveCtl=Me
						Then Gfx.Bar(X1+3, TempY, X2-1, TempY+17,
							Kernel.ClrListSel)
						Else Gfx.Rectangle(X1+3, TempY, X2-1, TempY+17,
							Kernel.ClrListSel)
				End
				Else Gfx.Rectangle(X1+3, TempY, X2-1, TempY+17,
					Kernel.ClrDisabled)
			End;

			CurY:=Y1+5; { was +4 }
			Font.SetFont(Kernel.CurFont);
			I:=1;
			{If Enabled
				Then Color:=Kernel.ClrListFont
				Else Color:=Kernel.ClrTextDis;}
			While (Cur<>Nil) And (I<=TempVisLen) Do
			Begin
				If FirstLine+I-1=SelItemNum Then
				Begin
					SelItem:=Cur;
					ListBox_DrawItem(Me, Cur, CurY,
						(Me=SystemActiveCtl))
				End
				Else
					ListBox_DrawItem(Me, Cur, CurY, False);
				Inc(CurY, ListItemHeight);
				Cur:=Cur^.Next;
				Inc(I)
			End;
			SelItem:=ListBox_GetSelItem(Me)
		End
		Else
			TempVisLen:=0;

		If DrawScroll Then
		Begin
			Scroll_SetParams(ListScroll, ItemsNum, TempVisLen, FirstLine);
			If (ListScroll^.CanDraw Or Kernel.DontBother) Then
				Scroll_PaintDirect(ListScroll, X2+2, Y1, X2+16, Y2)
		End
	End
End;

Procedure ListBox_Paint(Me:PControl; VX1,VY1,VX2,VY2:Integer);
Begin
	With Me^.Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX2-16, Y1+VY2, Me^.Place);
	ListBox_IntDraw(Me, True)
End;

Procedure ListBox_TryAutoRedraw(Me:PControl);
Begin
	If Me^.AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
		If (Me^.CanDraw Or Kernel.DontBother) And Me^.Visible Then
		Begin
			With Me^.Place Do
				Kernel.BeginPaintCoord(X1, Y1, X2+14, Y2);
			ListBox_IntDraw(Me, True);
			Kernel.EndPaint
		End
End;

Procedure ListBox_Draw(Me:PControl);
Begin
	If Me^.CanDraw Or Kernel.DontBother Then
	Begin
		With Me^.Place Do
			Kernel.BeginPaintCoord(X1, Y1, X2+14, Y2);
		If Me^.Visible
			Then ListBox_IntDraw(Me, True)
			Else Kernel.HideCtl(Me);
		Kernel.EndPaint
	End
End;


Procedure ListBox_SelectItem(Me:PControl; VSelItemNum:Integer);
Var
	I, CurColor, CurX, TempY: Integer;
Begin
	With Me^, Place, TListBox(Data^) Do
	Begin
		If ItemsNum=0 Then Exit;
		D.ToRange(VSelItemNum, 0, ItemsNum);

		If Kernel.IgnoreAutoRedraw Or (Not Me^.CanDraw) Or (Not Me^.Visible) Then
		Begin
			SelItemNum:=VSelItemNum;
			SelItem:=ListBox_GetSelItem(Me);
			Exit
		End;
		If D.InRange(VSelItemNum, FirstLine, FirstLine+TempVisLen-1) And
			CanDraw Then
		Begin
			Kernel.BeginPaint(Place);
			If SelItemNum<>0 Then
				If D.InRange(SelItemNum, FirstLine, FirstLine+TempVisLen-1) Then
				Begin
					SelItem:=FirstItem;
					For I:=1 To SelItemNum-1 Do
						SelItem:=SelItem^.Next;
					TempY:=Y1+5+(SelItemNum-FirstLine)*18;
					Gfx.Bar(X1+3, TempY-1, X2-1, TempY+ListItemHeight-2,
						Kernel.ClrList);
					ListBox_DrawItem(Me, SelItem, TempY, False)
				End;
			SelItemNum:=VSelItemNum;

			If SelItemNum<>0 Then
			Begin
				SelItem:=FirstItem;
				For I:=1 To SelItemNum-1 Do
					SelItem:=SelItem^.Next;
				TempY:=Y1+5+(SelItemNum-FirstLine)*18;
				Gfx.Bar(X1+3, TempY-1, X2-1, TempY+ListItemHeight-2,
					Kernel.ClrListSel);
				ListBox_DrawItem(Me, SelItem, TempY, True)
			End;
			Kernel.EndPaint
		End
		Else Begin { ॡ ப㢠 -  i }
			SelItemNum:=VSelItemNum;
			{SelItem:=Nil;}
			SelItem:=ListBox_GetSelItem(Me);
			If (SelItemNum<>0) And (ItemsNum>TempVisLen) Then
			Begin
				If SelItemNum<FirstLine Then
					FirstLine:=SelItemNum;
				If SelItemNum>FirstLine+TempVisLen-1 Then
					FirstLine:=SelItemNum-TempVisLen+1
			End;
			If Not IgnoreAutoRedraw Then
			Begin {  i 㦥 Place ? }
				TempVisLen:=(Place.Y2-Place.Y1-4) Div ListItemHeight;
				If SelItemNum>FirstLine+TempVisLen-1 Then
					FirstLine:=SelItemNum-TempVisLen+1
			End;
			ListBox_TryAutoRedraw(Me)
		End
	End
End;

Procedure ListBox_IntSelectItem(Me:PControl; VSelItemNum:Integer);
Var
	AutoRedrawSave: Boolean;
Begin
	AutoRedrawSave:=Me^.AutoRedraw;
	Me^.AutoRedraw:=True;
	ListBox_SelectItem(Me, VSelItemNum);
	Me^.AutoRedraw:=AutoRedrawSave
End;








Procedure ListBox_HideMouse(Var X,Y:Integer);
Var
	TempY: Integer;
Begin
	Kernel.HideMouse(X, Y);
	With CurCtl^, Place, TListBox(Data^) Do
	Begin
		If ListMouseItem=-1 Then Exit;
		TempY:=Y1+4+ListMouseItem*18;
		Gfx.Rectangle(X1+3, TempY, X2-1, TempY+17, ListPixelColor)
	End
End;

Procedure ListBox_ShowMouse(Var X,Y:Integer);
Var
	TempY: Integer;
Begin
	With CurCtl^, Place, TListBox(Data^) Do
	Begin
		ListMouseItem:=(Y-4-Place.Y1) Div ListItemHeight;
		If D.InRectCoord(X, Y, X1+4, Y1+4, X2-2,
			((Y2-Y1-4) Div ListItemHeight)*ListItemHeight+Y1+3) And
			(ListMouseItem<ItemsNum) Then
		Begin
			TempY:=Y1+4+ListMouseItem*18;
			ListPixelColor:=Gfx.GetPixel(X1+3, TempY);
			Gfx.Rectangle(X1+3, TempY, X2-1, TempY+17, Kernel.ClrListSel)
		End
		Else ListMouseItem:=-1
	End;
	Kernel.ShowMouse(X, Y)
End;

Procedure ListBox_OnClick(Me:PControl; X,Y:Integer);
Var
	TempY, LastSelItemNum, I: Integer;
	TempMask: Word;
	CurItem: PListItem;
Begin
	CurCtl:=Me;
	With Me^, Place, TListBox(Data^) Do
	Begin
		TempMask:=Mouse.GetMask;
		LastSelItemNum:=SelItemNum;
		ListVisLen:=(Y2-Y1-6) Div ListItemHeight;
		ListMouseItem:=(Y-4-Place.Y1) Div ListItemHeight;
		If D.InRectCoord(X, Y, X1+4, Y1+4, X2-2,
			((Y2-Y1-6) Div ListItemHeight)*ListItemHeight+Y1+3) And
			(ListMouseItem<ItemsNum)
			Then TempY:=Y1+4+ListMouseItem*18
			Else ListMouseItem:=-1;

		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(ListBox_HideMouse, ListBox_ShowMouse,
			Kernel.RefreshNeeded)=Mouse.mbNone;

		If ListMouseItem<>-1 Then
		Begin
			If MultiSelect And D.InRange(Kernel.MsX, X1, X1+18) Then
			Begin
				CurItem:=FirstItem;
				For I:=1 To FirstLine+ListMouseItem-1 Do
					CurItem:=CurItem^.Next;
				CurItem^.Selected:=Not CurItem^.Selected;
				If CurItem^.Selected
					Then Inc(SelItemsTotal)
					Else Dec(SelItemsTotal);
				ListBox_IntSelectItem(Me, FirstLine+ListMouseItem)
			End
			Else Begin
				OnBeforeSelect(Owner, Me);
				ListBox_IntSelectItem(Me, FirstLine+ListMouseItem);
				If TempMask=Mouse.mbLeft
					Then If {LastSelItemNum}ClickedItemNum<>SelItemNum Then
					Begin
						OnSelect(Owner, Me);
						ClickedItemNum:=SelItemNum
					End
					Else Begin
						OnStrongSelect(Owner, Me);
						ClickedItemNum:=-1
					End;
				If TempMask=Mouse.mbRight Then
					OnContextMenu(Owner, Me)
			End
		End
	End
End;


Procedure ListBox_DeleteItem(Me:PControl; N:Integer);
Var
	CurItem, PrevItem, NextItem, IntCurItem, IntNextItem: PListItem;
	I: Integer;
Begin
	With Me^, TListBox(Data^) Do
	Begin
		If Not D.InRange(N, 1, ItemsNum) Then Exit;

		PrevItem:=Nil;
		CurItem:=FirstItem;
		For I:=1 To N-1 Do
		Begin
			PrevItem:=CurItem;
			CurItem:=CurItem^.Next
		End;

		NextItem:=CurItem^.Next;
		IntCurItem:=CurItem;
		Repeat
			IntNextItem:=IntCurItem^.SubItem;
			D.FreePStr(IntCurItem^.Name, 'Ctl - ListBox_DeleteItem');
			Dispose(IntCurItem);
			IntCurItem:=IntNextItem
		Until IntCurItem=Nil;

		If PrevItem<>Nil
			Then PrevItem^.Next:=NextItem
			Else FirstItem:=NextItem;
		If N=ItemsNum Then
			LastItem:=PrevItem;

		Dec(ItemsNum);
		D.NotMore(SelItemNum, ItemsNum)
	End;
	ListBox_TryAutoRedraw(Me)
End;

Procedure ListBox_Clear(Me:PControl);
Var
	Cur, Temp, Cur2, Temp2: PListItem;
	I: Integer;
Begin
	With Me^, TListBox(Data^) Do
	Begin
		{Log.BugMsg('Ctl2', 'ListBox_Clear', 'Debug output follows ...');
		ListBox_DebugListItems(Me);}

		Cur:=FirstItem;
		While Cur<>Nil Do
		Begin
			If Cur^.SubItem<>Nil Then
			Begin
				Cur2:=Cur^.SubItem;
				Repeat
					Temp2:=Cur2^.SubItem;
					D.FreePStr(Cur2^.Name, 'Ctl - ListBox_Clear');
					Dispose(Cur2);
					Cur2:=Temp2
				Until Cur2=Nil
			End;
			Temp:=Cur^.Next;
			D.FreePStr(Cur^.Name, 'Ctl - ListBox_Clear');
			Dispose(Cur);
			Cur:=Temp
		End;
		FirstItem:=Nil;
		LastItem:=Nil;
		RecentItem:=Nil;
		ItemsNum:=0;
		FirstLine:=1;
		SelItemNum:={1}0;
		ShowIcons:=False;
		For I:=1 To 12 Do
			Column[I].RealWidth:=0;
		{Scroll_SetParams(ListScroll,1,1,1);}
	End;
	ListBox_TryAutoRedraw(Me)
End;

Procedure ListBox_OnDestroy(Me:PControl);
Begin
	ListBox_Clear(Me);
	{Kernel.DestroyCtl(Me^.Owner,TListBox(Me^.Data^).ListScroll);}
	FreeMem(Me^.Data, SizeOf(TListBox))
End;

Function ListBox_OnKey(Me:PControl; Key,ExtKey:Char): Boolean;
Var
	Recognized: Boolean;
	LastSelItemNum: Integer;
	CurItem, InitItem: PListItem;
	CurItemNum: Integer;
	Found, FullCycle: Boolean;
	UpCaseKey: Char;

Begin
	Log.BugMsg('Ctl2', 'ListBox_OnKey', 'Strting...');
	Recognized:=False;
	With Me^, TListBox(Data^) Do
	Begin
		LastSelItemNum:=SelItemNum;
		If (Key=#0) And (ExtKey In [#72, #80, #73, #81, #71, #79, #82]) Then
		Begin
			Log.BugMsg('Ctl2', 'ListBox_OnKey', 'Calling OnBeforeSelect...');
			OnBeforeSelect(Owner, Me);
			Case ExtKey Of
					{ Up arrow }
				#72: ListBox_IntSelectItem(Me, D.Max(SelItemNum-1, 1));
					{ Down arrow }
				#80: ListBox_IntSelectItem(Me, SelItemNum+1);
					{ PgUp }
				#73: If SelItemNum=FirstLine
					Then ListBox_IntSelectItem(Me, D.Max(1, FirstLine-TempVisLen+1))
					Else ListBox_IntSelectItem(Me, FirstLine);
					{ PgDn }
				#81: If SelItemNum=FirstLine+TempVisLen-1
					Then ListBox_IntSelectItem(Me, SelItemNum+TempVisLen-1)
					Else ListBox_IntSelectItem(Me, FirstLine+TempVisLen-1);
					{ Home }
				#71: ListBox_IntSelectItem(Me, 1);
					{ End }
				#79: ListBox_IntSelectItem(Me, ItemsNum);
					{ Ins }
				#82: If MultiSelect Then
				Begin
					Log.BugMsg('Ctl2', 'ListBox_OnKey', 'Ins pressed, processing...');
					SelItem^.Selected:=Not SelItem^.Selected;
					Log.BugMsg('Ctl2', 'ListBox_OnKey', 'SelItem^ accessed');
					{If CurItem^.Selected}
					If SelItem^.Selected
						Then Inc(SelItemsTotal)
						Else Dec(SelItemsTotal);
					Log.BugMsg('Ctl2', 'ListBox_OnKey', 'Drawing current item...');
					ListBox_IntSelectItem(Me, SelItemNum);
					Log.BugMsg('Ctl2', 'ListBox_OnKey', 'Focusing on next item...');
					ListBox_IntSelectItem(Me, SelItemNum+1);
				End
			End;
			Recognized:=True
		End;
		If Key In [' '..#255] Then
		Begin
			UpCaseKey:=UpCase(Key);
			If (SelItemNum<>0) And (SelItem<>Nil)
				Then If UpCase(String(SelItem^.Name^)[1])=UpCaseKey
					Then CurItem:=SelItem^.Next
					Else CurItem:=FirstItem
				Else CurItem:=FirstItem;
			If CurItem=FirstItem
				Then CurItemNum:=1
				Else CurItemNum:=SelItemNum+1;
			InitItem:=CurItem;
			Found:=False;
			FullCycle:=False;
			While Not (Found Or FullCycle) Do
				If UpCase(String(CurItem^.Name^)[1])=UpCaseKey
					Then Found:=True
					Else Begin
						CurItem:=CurItem^.Next;
						If CurItem=Nil Then
						Begin
							CurItem:=FirstItem;
							CurItemNum:=1
						End
						Else
							Inc(CurItemNum);
						If CurItem=InitItem Then
							FullCycle:=True
					End;
			If Found Then
			Begin
				OnBeforeSelect(Owner, Me);
				ListBox_IntSelectItem(Me, CurItemNum);
				Recognized:=True { !!! }
			End
		End;

		If Recognized And (LastSelItemNum<>SelItemNum) Then
		Begin
			OnSelect(Owner, Me)
		End
		Else If (Key=#13) And (@OnStrongSelect<>@Kernel.CtlDummyProc) Then
			Begin
				OnStrongSelect(Owner, Me);
				Recognized:=True
			End
	End;
	ListBox_OnKey:=Recognized
End;

Procedure ListBox_OnWheel(Me:PControl; Delta:Integer);
Var
	{TempSelItemNum: Integer;}
	TempVisLen, TempFirstLine: Integer;
Begin
	With Me^, TListBox(Data^) Do
	Begin
		{TempSelItemNum:=SelItemNum+Delta*3;
		D.ToRange(TempSelItemNum, 1, ItemsNum);
		ListBox_IntSelectItem(Me, TempSelItemNum)}
		With Place Do
			TempVisLen:=(Y2-Y1-4) Div ListItemHeight;
		TempFirstLine:=FirstLine+Delta*3;
		D.ToRange(TempFirstLine, 1, ItemsNum-TempVisLen+1);
		If FirstLine<>TempFirstLine Then
		Begin
			FirstLine:=TempFirstLine;
			Kernel.BeginPaint(Place);
			ListBox_IntDraw(Me, True);
			Kernel.EndPaint
		End
	End
End;

Function ListBox_GetItemByIndex(Me:PControl; Index:Integer): PListItem;
Var
	Cur: PListItem;
	N: Integer;
Begin
	With Me^, TListBox(Data^) Do
		If D.InRange(Index, 1, ItemsNum) Then
		Begin
			Cur:=FirstItem;
			N:=1;
			While (Cur<>Nil) And (N<>Index) Do
			Begin
				Inc(N);
				Cur:=Cur^.Next
			End
		End
		Else
			Cur:=Nil;
	ListBox_GetItemByIndex:=Cur
End;

Function ListBox_FindItem(Me:PControl; VName: String): Integer;
Var
	CurItem: PListItem;
	CurIndex: Integer;
	Finished: Boolean;
Begin
	With TListBox(Me^.Data^) Do
	Begin
		CurItem:=FirstItem;
		CurIndex:=1;
		Finished:=False;
		ListBox_FindItem:=0;
		While (CurItem<>Nil) And Not Finished Do
			If String(CurItem^.Name^)=VName Then
			Begin
				ListBox_FindItem:=CurIndex;
				Finished:=True
			End
			Else Begin
				CurItem:=CurItem^.Next;
				Inc(CurIndex)
			End
	End
End;

Function ListBox_GetItemsNum(Me:PControl): Integer;
Begin
	ListBox_GetItemsNum:=TListBox(Me^.Data^).ItemsNum
End;

Function ListBox_GetSelItemIndex(Me:PControl): Integer;
Begin
	ListBox_GetSelItemIndex:=TListBox(Me^.Data^).SelItemNum
End;

Function ListBox_GetSelItem(Me:PControl): PListItem;
Begin
	With TListBox(Me^.Data^) Do
		ListBox_GetSelItem:=ListBox_GetItemByIndex(Me, SelItemNum)
End;

Procedure ListBox_GetSelItemRect(Me:PControl; Var R:TRect);
Begin
	With Me^, TListBox(Data^), Place Do
		If D.InRange(SelItemNum, FirstLine, FirstLine+TempVisLen-1)
			Then D.AssignRect(X1+4, Y1+4+(SelItemNum-FirstLine)*18,
				X2-2, Y1+4+(SelItemNum-FirstLine)*18+17, R)
			Else D.AssignRect(-1, -1, -1, -1, R)
End;


Procedure ListBox_OnHint(Me:PControl);
Var
	Index: Integer;
	UnderMouse: PListItem;
Begin
	With Me^, TListBox(Data^) Do
	Begin
		Index:=FirstLine+(Kernel.MsY-4-Place.Y1) Div ListItemHeight;
		If Not D.InRange(Index, FirstLine,
			D.Min(FirstLine+TempVisLen-1, ItemsNum)) Then
			Index:=0;
		UnderMouse:=ListBox_GetItemByIndex(Me, Index);
		OnHint(Owner, Me, UnderMouse{SelItem})
	End
End;


Procedure ListBox_UpdateLastItem(Me:PControl);
Begin
	With Me^, TListBox(Data^) Do
		LastItem:=ListBox_GetItemByIndex(Me, ItemsNum)
End;



Function ListBox_DefaultSortFunc(Me:PProg; Item1,Item2:PListItem): Boolean;
Begin
	If String(Item1^.Name^)<String(Item2^.Name^)
		Then ListBox_DefaultSortFunc:=True
		Else ListBox_DefaultSortFunc:=False
End;

Procedure ListBox_Sort(Me:PControl);
Var
	I: Integer;
	Cur, Temp, LastCur, LastTemp: PListItem;
	NewFirstItem: PListItem;
Begin
	With Me^, TListBox(Data^) Do
	Begin
		If FirstItem=Nil Then Exit; { 0 . -  }
		If FirstItem^.Next=Nil Then Exit; { 1 . -  }

		{Log.BugMsg('Ctl', 'ListBox_Sort', '');
		Cur:=FirstItem;}

		NewFirstItem:=Nil;
		While FirstItem<>Nil Do
		Begin
			Temp:=FirstItem;
			Cur:=FirstItem;
			LastCur:=FirstItem;
			LastTemp:=Nil;
			While Cur^.Next<>Nil Do
			Begin
				Cur:=Cur^.Next;
				If Not SortFunc(Owner, Cur, Temp) Then
				Begin
					Temp:=Cur;
					LastTemp:=LastCur
				End;
				LastCur:=Cur
			End;
				{ ७  i ਣi쭮 ᯨ᪠... }
			If LastTemp=Nil
				Then FirstItem:=Temp^.Next
				Else LastTemp^.Next:=Temp^.Next;
				{ ...  }
			Temp^.Next:=NewFirstItem;
			NewFirstItem:=Temp
		End;
		FirstItem:=NewFirstItem
	End;
	ListBox_UpdateLastItem(Me);
	ListBox_TryAutoRedraw(Me)
End;

Procedure ListBox_AddItemFirst(Me:PControl; VName:String; VIcon:Pointer;
	VIndent:Byte);
Var
	Cur: PListItem;
	TempWidth: Integer;
Begin
	With Me^, TListBox(Data^) Do
	Begin
		New(Cur);
		Cur^.Next:=FirstItem;
		Cur^.SubItem:=Nil;
		FirstItem:=Cur;
		D.AssignPStr(VName, Cur^.Name);
		Cur^.Icon:=VIcon;
		Cur^.Indent:=VIndent;
		If VIcon<>Nil Then
			ShowIcons:=True;
		Cur^.Selected:=False;
		Inc(ItemsNum);
		If LastItem=Nil Then
			LastItem:=Cur;
		RecentItem:=Cur;
		RecentItemLevel:=1;

		Font.SetFont(Kernel.CurFont);
		If Column[1].Align=lcRightMono
			Then TempWidth:=Font.WidthFW(VName)
			Else TempWidth:=Font.Width(VName);
		If (VIcon<>Nil) Or ShowIcons Then
			Inc(TempWidth, 20);
		If MultiSelect Then
			Inc(TempWidth, 20);
		Inc(TempWidth, VIndent);
		If TempWidth>Column[1].RealWidth Then
			Column[1].RealWidth:=TempWidth
	End;
	ListBox_TryAutoRedraw(Me)
End;

Procedure ListBox_AddItemLast(Me:PControl; VName:String; VIcon:Pointer;
	VIndent:Byte);
Var
	TempWidth: Integer;
Begin
	With Me^, TListBox(Data^) Do
	Begin
		If LastItem<>Nil Then
		Begin
			New(LastItem^.Next);
			LastItem:=LastItem^.Next
		End
		Else Begin
			New(LastItem);
			FirstItem:=LastItem
		End;
		D.AssignPStr(VName, LastItem^.Name);
		LastItem^.Icon:=VIcon;
		LastItem^.Indent:=VIndent;
		If VIcon<>Nil Then
			ShowIcons:=True;
		LastItem^.Selected:=False;
		LastItem^.SubItem:=Nil;
		LastItem^.Next:=Nil;
		Inc(ItemsNum);
		RecentItem:=LastItem;
		RecentItemLevel:=1;

		Font.SetFont(Kernel.CurFont);
		If Column[1].Align=lcRightMono
			Then TempWidth:=Font.WidthFW(VName)
			Else TempWidth:=Font.Width(VName);
		If (VIcon<>Nil) Or ShowIcons Then
			Inc(TempWidth, 20);
		If MultiSelect Then
			Inc(TempWidth, 20);
		Inc(TempWidth, VIndent);
		If TempWidth>Column[1].RealWidth Then
			Column[1].RealWidth:=TempWidth
	End;
	ListBox_TryAutoRedraw(Me)
End;

Procedure ListBox_AddItemSorted(Me:PControl; VName:String; VIcon:Pointer;
	VIndent:Byte);
Var
	Cur, Temp1, Temp2: PListItem;
	TempWidth: Integer;
	Found: Boolean;
Begin
	With Me^, TListBox(Data^) Do
	Begin
		New(Cur);
		{Cur^.Next:=FirstItem;
		FirstItem:=Cur;}
		Cur^.SubItem:=Nil;
		D.AssignPStr(VName, Cur^.Name);
		Cur^.Icon:=VIcon;
		Cur^.Indent:=VIndent;
		If VIcon<>Nil Then
			ShowIcons:=True;
		Cur^.Selected:=False;
		Inc(ItemsNum);
		If LastItem=Nil Then
			LastItem:=Cur;
		RecentItem:=Cur;
		RecentItemLevel:=1;

		Font.SetFont(Kernel.CurFont);
		If Column[1].Align=lcRightMono
			Then TempWidth:=Font.WidthFW(VName)
			Else TempWidth:=Font.Width(VName);
		If (VIcon<>Nil) Or ShowIcons Then
			Inc(TempWidth, 20);
		If MultiSelect Then
			Inc(TempWidth, 20);
		Inc(TempWidth, VIndent);
		If TempWidth>Column[1].RealWidth Then
			Column[1].RealWidth:=TempWidth;
		

			{  i  ᯨ    }
		If FirstItem<>Nil Then
		Begin
			If SortFunc(Owner, Cur, FirstItem) Then
			Begin
				Temp1:=FirstItem;
				FirstItem:=Cur;
				FirstItem^.Next:=Temp1
			End
			Else Begin
				Temp1:=FirstItem;
				Found:=False;
				While (Temp1^.Next<>Nil) And Not Found Do
					If SortFunc(Owner, Temp1^.Next, Cur)
						Then Temp1:=Temp1^.Next
						Else Found:=True;

				If Found Then
				Begin
					Temp2:=Temp1^.Next;
					Temp1^.Next:=Cur;
					Cur^.Next:=Temp2
				End
				Else Begin
					Temp1^.Next:=Cur;
					Cur^.Next:=Nil
				End
			End
		End
		Else Begin
			FirstItem:=Cur;
			FirstItem^.Next:=Nil
		End
	End;
	ListBox_UpdateLastItem(Me);
	ListBox_TryAutoRedraw(Me)
End;

Procedure ListBox_AddItemSecond(Me:PControl; VName:String; VIcon:Pointer;
	VIndent:Byte);
Var
	Cur, TempNext: PListItem;
	TempWidth: Integer;
Begin
	With Me^, TListBox(Data^) Do
	Begin
   	If FirstItem=Nil Then
		Begin
			ListBox_AddItemFirst(Me, VName, VIcon, VIndent);
         Exit
      End;
		If FirstItem^.Next=Nil Then
      Begin
      	ListBox_AddItemLast(Me, VName, VIcon, VIndent);
			Exit
      End;

		TempNext:=FirstItem^.Next;
		New(Cur);
      FirstItem^.Next:=Cur;
		Cur^.Next:=TempNext;
		Cur^.SubItem:=Nil;
		D.AssignPStr(VName, Cur^.Name);
		Cur^.Icon:=VIcon;
		Cur^.Indent:=VIndent;
		If VIcon<>Nil Then
			ShowIcons:=True;
		Cur^.Selected:=False;
		Inc(ItemsNum);
		If LastItem=Nil Then
			LastItem:=Cur;
		RecentItem:=Cur;
		RecentItemLevel:=1;

		Font.SetFont(Kernel.CurFont);
		If Column[1].Align=lcRightMono
			Then TempWidth:=Font.WidthFW(VName)
			Else TempWidth:=Font.Width(VName);
		If (VIcon<>Nil) Or ShowIcons Then
			Inc(TempWidth, 20);
		If MultiSelect Then
			Inc(TempWidth, 20);
		Inc(TempWidth, VIndent);
		If TempWidth>Column[1].RealWidth Then
			Column[1].RealWidth:=TempWidth
	End;
	ListBox_TryAutoRedraw(Me)
End;



Procedure ListBox_AddSubItem(Me:PControl; VName:String; VIcon:Pointer);
Var
	TempWidth: Integer;
Begin
	With Me^, TListBox(Data^) Do
	Begin
		Inc(RecentItemLevel);
		If RecentItemLevel>ColumnNum Then
		Begin
			ColumnNum:=RecentItemLevel;
			Column[ColumnNum].RealWidth:=0;
			{Column[ColumnNum].Align:=alLeft}
		End;
		New(RecentItem^.SubItem);
		RecentItem:=RecentItem^.SubItem;
		With RecentItem^ Do
		Begin
			D.AssignPStr(VName, Name);
			Icon:=VIcon;
			Indent:=0;
			SubItem:=Nil;
			Next:=Nil;

			Font.SetFont(Kernel.CurFont);
			If Column[RecentItemLevel].Align=lcRightMono
				Then TempWidth:=Font.WidthFW(VName)
				Else TempWidth:=Font.Width(VName);
			If (Icon<>Nil) And ShowIcons Then
				Inc(TempWidth, 20);
			If TempWidth>Column[RecentItemLevel].RealWidth Then
				Column[RecentItemLevel].RealWidth:=TempWidth
		End
	End;
	ListBox_TryAutoRedraw(Me)
End;

Procedure ListBox_OnScrollUpdate(Me:PProg; Control:PControl);
Begin
	With TListBox(Control^.Data^) Do
		FirstLine:=Scroll_GetPos(ListScroll);
	ListBox_IntDraw(Control, False)
End;

Procedure ListBox_SetSortFunc(Me:PControl; VSortFunc:TListBoxSortFunc);
Begin
	With Me^, TListBox(Data^) Do
		SortFunc:=VSortFunc
End;

Procedure ListBox_SetOnBeforeSelect(Me:PControl; VOnBeforeSelect:TCtlHandler);
Begin
	With Me^, TListBox(Data^) Do
		OnBeforeSelect:=VOnBeforeSelect;
End;

Procedure ListBox_SetOnSelect(Me:PControl; VOnSelect:TCtlHandler);
Begin
	With Me^, TListBox(Data^) Do
		OnSelect:=VOnSelect;
End;

Procedure ListBox_SetOnStrongSelect(Me:PControl; VOnStrongSelect:TCtlHandler);
Begin
	With Me^, TListBox(Data^) Do
		OnStrongSelect:=VOnStrongSelect;
End;

Procedure ListBox_SetOnContextMenu(Me:PControl; VOnContextMenu:TCtlHandler);
Begin
	With Me^, TListBox(Data^) Do
		OnContextMenu:=VOnContextMenu;
End;

Procedure ListBox_SetOnHint(Me:PControl; VOnHint:TListBoxHintHandler);
Begin
	With Me^, TListBox(Data^) Do
		OnHint:=VOnHint;
End;

Procedure ListBox_ScrollToViewSelItem(Me:PControl);
Var
	TempVisLen: Integer;
Begin
	With Me^, TListBox(Data^), Place Do
	Begin
		If SelItemNum=0 Then Exit;
		TempVisLen:=(Y2-Y1-4) Div ListItemHeight;
		If D.InRange(SelItemNum, FirstLine, FirstLine+TempVisLen-1) Then Exit;
		If SelItemNum<FirstLine
			Then FirstLine:=SelItemNum
			Else FirstLine:=SelItemNum-TempVisLen+1;
		ListBox_IntDraw(Me, True)
	End
End;

Procedure ListBox_SetColumnProps(Me:PControl; VColumnNum:Integer;
	VAlign:TListColumnAlign; VVisible:Boolean);
Begin
	With Me^, TListBox(Data^) Do
	Begin
		Column[VColumnNum].Align:=VAlign;
		Column[VColumnNum].Visible:=VVisible
	End
End;

Function ListBox_GetSelItemsTotal(Me:PControl): Integer;
Begin
	With Me^, TListBox(Data^) Do
		ListBox_GetSelItemsTotal:=SelItemsTotal
End;

Procedure ListBox_DebugListItems(Me:PControl);
Var
	Cur, SubCur: PListItem;
	TempStr: String;
Begin
	Log.BugMsg('Ctl2', 'ListBox_DebugListItems', 'Starting...');
	With Me^, TListBox(Data^) Do
	Begin
		Cur:=FirstItem;
		While Cur<>Nil Do
		Begin
			TempStr:=String(Cur^.Name^);
			SubCur:=Cur^.SubItem;
			While SubCur<>Nil Do
			Begin
				TempStr:=TempStr+'   |   '+String(SubCur^.Name^);
				SubCur:=SubCur^.SubItem
			End;
			Log.ActMsg(TempStr);
			Cur:=Cur^.Next
		End
	End;
	Log.BugMsg('Ctl2', 'ListBox_DebugListItems', '...complete!');
End;

Function ListBox_Create(Prog:PProg; VMultiSelect:Boolean): PControl;
Var
	Me: PControl;
	I: Integer;
Begin
	Me:=Kernel.AddCtl(Prog);
	With Me^ Do
	Begin
		OnClick:=ListBox_OnClick;
		OnKey:=ListBox_OnKey;
		OnRefocus:=ListBox_OnRefocus;
		OnHint:=ListBox_OnHint;
		OnDestroy:=ListBox_OnDestroy;

		GetMem(Data, SizeOf(TListBox));
		With TListBox(Data^) Do
		Begin
			ShowIcons:=False;
			OnBeforeSelect:=Kernel.CtlDummyProc;
			OnSelect:=Kernel.CtlDummyProc;
			OnStrongSelect:=Kernel.CtlDummyProc;
			OnContextMenu:=Kernel.CtlDummyProc;
			OnHint:=ListBoxHintDummy;
			OnWheel:=ListBox_OnWheel;
			MultiSelect:=VMultiSelect;
			FirstItem:=Nil;
			LastItem:=Nil;
			ItemsNum:=0;
			ClickedItemNum:=-1;
			FirstLine:=1;
			SelItemNum:={1}0;
			SelItemsTotal:=0;
			ColumnNum:=1;
			SortFunc:=ListBox_DefaultSortFunc;
			For I:=1 To 12 Do
				With Column[I] Do
				Begin
					RealWidth:=0;
					Align:=lcLeft;
					Visible:=True
				End;

			ListScroll:=Scroll_Create(Owner, 0, 0, 0, orVertical,
				ListBox_OnScrollUpdate);
			ListScroll^.FocusCtl:=Me;
			ListScroll^.OwnerCtl:=Me;
			ListScroll^.AutoRedraw:=False
		End
	End;
	ListBox_Create:=Me
End;
