Unit
	Log; { Polit Halcyon Eva log unit }

Interface

Uses
	DOS;

Const
	Enabled: Boolean=True;

Var
	LogFile: Text;
	LogName: String;
	FlushNeeded: Boolean;
	Open: Boolean;

	Procedure Init(ProgName:String; ToFlush:Boolean);
	Procedure Msg(UnitName,ProcName,Message:String);
	Procedure SysMsg(UnitName,ProcName,Message:String);
	Procedure ActMsg(Message:String);
	Procedure ErrMsg(UnitName,ProcName,Message:String);
	Procedure FatMsg(UnitName,ProcName,Message:String);
	Procedure BugMsg(UnitName,ProcName,Message:String);
	Procedure Done;

Implementation

Uses
	D;

Procedure Msg(UnitName,ProcName,Message:String);
Begin
	If Not Enabled Then Exit;
	WriteLn(LogFile, UnitName, ': ', ProcName, ' - ', Message);
	If FlushNeeded Then
		Flush(LogFile)
End;

Procedure ActMsg(Message:String);
Begin
	If Not Enabled Then Exit;
	WriteLn(LogFile, '       ', Message);
	If FlushNeeded Then
		Flush(LogFile)
End;

Procedure Init(ProgName:String; ToFlush:Boolean);
Var
	Temp: String;
	Year, Month, Day, WeekD: Word;
	Hour, Minute, Second, Sec100: Word;
Begin
	If Not Enabled Then Exit;

	LogName:=ProgName;
	Assign(LogFile, LogName);
	ReWrite(LogFile);
	FlushNeeded:=ToFlush;
	GetDate(Year, Month, Day, WeekD);
	Temp:='Date: '+D.St(Day)+'/'+D.St(Month)+'/'+D.St(Year);
	GetTime(Hour, Minute, Second, Sec100);
	Temp:=Temp+'. Time: '+St(Hour)+':'+St(Minute)+'.'+St(Second)+'.';
	SysMsg('Log', 'Init', 'Log open: '+ProgName);
	ActMsg(Temp);
	ActMsg('MaxAvail = '+D.StL(MaxAvail)+', MemAvail = '+D.StL(MemAvail));
	Open:=True
End;

Procedure SysMsg(UnitName,ProcName,Message:String);
Begin
	Msg('SYSTEM '+UnitName, ProcName, Message)
End;

Procedure ErrMsg(UnitName,ProcName,Message:String);
Begin
	Msg('ERROR  '+UnitName, ProcName, Message)
End;

Procedure FatMsg(UnitName,ProcName,Message:String);
Begin
	Msg('FATAL  '+UnitName, ProcName, Message)
End;

Procedure BugMsg(UnitName,ProcName,Message:String);
Begin
	Msg('DEBUG  '+UnitName, ProcName, Message)
End;

Procedure Done;
Var
	Temp: String;
	Year, Month, Day, WeekD: Word;
	Hour, Minute, Second, Sec100: Word;
Begin
	If Not Enabled Then Exit;

	GetDate(Year, Month, Day, WeekD);
	Temp:='Date: '+D.St(Day)+'/'+D.St(Month)+'/'+D.St(Year);
	GetTime(Hour, Minute, Second, Sec100);
	Temp:=Temp+'. Time: '+St(Hour)+':'+St(Minute)+'.'+St(Second)+'.';
	SysMsg('Log', 'Done', 'Log normally closed: '+LogName);
	ActMsg(Temp);
	ActMsg('MaxAvail = '+D.StL(MaxAvail)+', MemAvail = '+D.StL(MemAvail));
	Close(LogFile);
	Open:=False
End;

Begin
	Open:=False
End.