Unit
	LptGfx; { Polit Halcyon Eva advanced printing unit }

Interface

Uses
	Font, LPT, D, Types, Gfx, Kernel;

Var
	Fnt:^TRFont;

	Procedure PrintStr(S:String);
	Procedure DumpTextFile(SourceFName,TargetFName:String);

Implementation

Procedure TryLoadFont;
Begin
	If Fnt=Nil Then
		Fnt:=Kernel.LoadRes('fonts\printer8.raf')
End;

	{ modified from Font.Print }
	{ ॢ 冷  .   ᨫ  ਭ }
Procedure LineToGfxDump(S:String; Var P:Pointer; Var Size:Word);
Var
	ChIndex: Byte;
	CurX, CurXX, CurY: Integer;
	BytesNum: Byte;
	ChX,ChY: Byte;
	CurByte: Byte;
	CurOffs: Word;
	TempWidth: Word;
	CurMask: Byte;
	{
		ChIndex - char index in proposed string (cur char - S[ChIndex])
		CurX - current X coord for current char
		CurXX - initial X coord for current byte of current char
			(coords for this byte pixels - CurXX, CurXX+1, ... CurXX+7)
		CurY - current Y coodrd for current byte
		BytesNum - width bytes for cur char
			(FontWidth or less if char is thinner)
		ChX,ChY - byte position for current char image
		CurOffs - current byte offset, CurByte=Data[CurOffs]
		CurByte - current byte of cur char image
	}
Begin
	If Fnt=Nil Then Exit;
	{$IFDEF DEBUG}
		If TFont(Font^).Sig<>'RAF' Then
		Begin
			Log.ErrMsg('Font', 'Print', 'Current font has no RAF signature, failed');
			Exit
		End;
	{$ENDIF}

	TempWidth:=Font.Width(S);
	Size:=TempWidth+6;
	GetMem(P, Size);
	FillChar(P^, Size, 0);
	TMatrix(P^)[0]:=27;
	TMatrix(P^)[1]:=Byte('L'); { double density graphics }
	TMatrix(P^)[2]:=Lo(TempWidth);
	TMatrix(P^)[3]:=Hi(TempWidth);
	TMatrix(P^)[Size-2]:=13;
	TMatrix(P^)[Size-1]:=10;

	CurX:=4;
	With Fnt^ Do
		For ChIndex:=1 To Length(S) Do
		Begin
			CurOffs:=(Byte(S[ChIndex])-1)*BytesPerChar;
			BytesNum:=D.Min(FontWidth, (Width[Byte(S[ChIndex])]+7) Div 8);
			If BytesNum>0 Then
				For ChX:=0 To BytesNum-1 Do
					For ChY:=0 To FontHeight-1 Do
					Begin
						CurByte:=Data[CurOffs];
						If CurByte<>0 Then
						Begin
							CurXX:=CurX+ChX*8;
							CurY:=ChY;
							CurMask:=1 Shl (7-CurY);
							If (CurByte And $80)<>0 Then
								TMatrix(P^)[CurXX]:=TMatrix(P^)[CurXX] Or CurMask;
							If (CurByte And $40)<>0 Then
								TMatrix(P^)[CurXX+1]:=TMatrix(P^)[CurXX+1] Or CurMask;
							If (CurByte And $20)<>0 Then
								TMatrix(P^)[CurXX+2]:=TMatrix(P^)[CurXX+2] Or CurMask;
							If (CurByte And $10)<>0 Then
								TMatrix(P^)[CurXX+3]:=TMatrix(P^)[CurXX+3] Or CurMask;
							If (CurByte And $08)<>0 Then
								TMatrix(P^)[CurXX+4]:=TMatrix(P^)[CurXX+4] Or CurMask;
							If (CurByte And $04)<>0 Then
								TMatrix(P^)[CurXX+5]:=TMatrix(P^)[CurXX+5] Or CurMask;
							If (CurByte And $02)<>0 Then
								TMatrix(P^)[CurXX+6]:=TMatrix(P^)[CurXX+6] Or CurMask;
							If (CurByte And $01)<>0 Then
								TMatrix(P^)[CurXX+7]:=TMatrix(P^)[CurXX+7] Or CurMask;
						End;
						Inc(CurOffs)
					End;
			{If FixedWidth=0
				Then} Inc(CurX, Width[Byte(S[ChIndex])]+1)
				{Else Inc(CurX, FixedWidth)}
		End
End;

	{  LineToGfxDump, i i ࠦ  ଠ }
Procedure LineToGfxDumpJst(S:String; NewWidth:Integer; Var P:Pointer;
	Var Size:Word);
Var
	TempP: Pointer;
	TempSize: Word;
	CurWidth, CurPos: Integer;
Begin
	CurWidth:=Font.Width(S);
	If NewWidth<CurWidth Then
	Begin
		Log.BugMsg('LptGfx', 'LineToGfxDumpJst', 'Line is wider that preferred width');
		Log.ActMsg('NewWidth='+D.St(NewWidth)+', CurWidth='+D.St(CurWidth));
		Log.ActMsg('S="'+S+'"');
		Exit
	End;

	LineToGfxDump(S, TempP, TempSize);
	Size:=NewWidth+6;
	GetMem(P, Size);
	Move(TempP^, P^, TempSize);
	FreeMem(TempP, TempSize);

	CurPos:=4;
	Repeat
		If (TMatrix(P^)[CurPos]=0) And (TMatrix(P^)[CurPos+1]<>0) Then
		Begin { insert blank }
			Move(TMatrix(P^)[CurPos], TMatrix(P^)[CurPos+1],
				CurWidth-CurPos+6);
			TMatrix(P^)[CurPos]:=0;
			Inc(CurPos);
			Inc(CurWidth)
		End;
		Inc(CurPos);
		If CurPos=CurWidth+3 Then CurPos:=4
	Until CurWidth=NewWidth;
	TMatrix(P^)[2]:=Lo(NewWidth);
	TMatrix(P^)[3]:=Hi(NewWidth)
End;

Procedure PrintStr(S:String);
Var
	P: Pointer;
	I: Word;
	LastFnt: Pointer;
	TempSize: Word;
Begin
	LastFnt:=Font.GetFont;
	TryLoadFont;
	Font.SetFont(Fnt);
	LineToGfxDump(S, P, TempSize);
	For I:=0 To TempSize-1 Do
	Begin
		Repeat
		Until LPT.Ready;
		LPT.SendChar(Chr(TMatrix(P^)[I]))
	End;
	FreeMem(P, TempSize);
	Font.SetFont(LastFnt)
End;

Procedure DumpTextFile(SourceFName,TargetFName:String);
	{ on Citizen #27'm'#4 means 'print #128-#159 as letters' }
	{ on Fujitsu #27'm' means 'justification mode' }
Const
	PrnInitCommon: String=#27'9'{detect paper end};
	PrnInitText: String=#27'm'#4{print #128-#159}+
		#27'x'#0{reset justification/nlq off}+
		#27'U'#1{unidirectional}+
		#13#10{cr/lf};
	PrnInitTextDraft: String='';
   PrnInitTextFastDraft: String=#27'U'#0{bidirectional};
	PrnInitTextEmphasized: String=#27'E'{emphasized};
	PrnInitTextProportional: String=#27'p'#1{proportional};
	PrnInitTextNLQ: String=#27'x'#1{nlq};
	PrnTextLineEnd: String=#13#10{carriage return, line feed};
	PrnDone: String=#12{form feed};
	(*PrnDone: String=#13#10#10#10{empty lines};*)
Var
	F1: File Of Char;
	F2: File;
	LastFnt: Pointer;
	P: Pointer;
	TempStr: String;
	TempSize: Word;
	PrnFont: Char;
	CurStr, PrintStr: String;
	CurLen, V, N: Integer;
	C, LastC: Char;
	TextLineWidth, GfxLineWidth: Integer;
	DoJustify: Boolean;
	AddToNextStr: String[1];

	Procedure BlockWriteString(S:String);
	Begin
		BlockWrite(F2, S[1], Length(S))
	End;

	Procedure DropLastCRLF(Var S:String);
	Var
		I: Integer;
	Begin
		For I:=1 To 2 Do
			If S[Length(S)] In [#13, #10] Then
				Dec(Byte(S[0]))
	End;
Begin
	If Not D.FileExist(SourceFName) Then
	Begin
		Log.ErrMsg('LptGfx', 'DumpTextFile', 'File not found: '+SourceFName);
		Exit
	End;

	Assign(F1, SourceFName);
	Reset(F1);
	Assign(F2, TargetFName);
	Rewrite(F2, 1);
	BlockWriteString(PrnInitCommon);

	Ini.Select('polit.ini', 'Print');
	DoJustify:=Ini.GetBool('JustifyText', True);
	If Ini.GetStr('TextMode', 'Polit')='POLIT' Then
	Begin
		TempStr:=Ini.GetStr('Paper', 'A4Portrait');
		GfxLineWidth:=800; {816}
		If (TempStr='A4LANDSCAPE') Or (TempStr='A3PORTRAIT') Then
			GfxLineWidth:=1132; {1156}
		If TempStr='A3LANDSCAPE' Then GfxLineWidth:=1600; {1632}

		LastFnt:=Font.GetFont;
		TryLoadFont;
		Font.SetFont(Fnt);
		CurStr:='';
		CurLen:=0;
		C:=#0;
		While Not EOF(F1) Do
		Begin
			LastC:=C;
			Read(F1, C);
			CurStr:=CurStr+C;
			Inc(CurLen, Font.Width(C));
			If (LastC=#13) And (C=#10) Or EOF(F1) Then
			Begin
				DropLastCRLF(CurStr);
				If CurStr<>'' Then
				Begin
					LineToGfxDump(CurStr, P, TempSize);
					BlockWrite(F2, P^, TempSize);
					FreeMem(P, TempSize)
				End
				Else BlockWriteString(#13#10);
				CurStr:='';
				CurLen:=0
			End;
			If CurLen>GfxLineWidth Then
			Begin
				V:=Length(CurStr);
				If CurStr[V]=' '
					Then AddToNextStr:=' '
					Else AddToNextStr:='';
				While (CurStr[V]=' ') And (V>0) Do
					Dec(V);
				CurStr:=Copy(CurStr, 1, V);
				While (CurStr[V]<>' ') And (V>0) Do
					Dec(V);
				If V=0 Then V:=Length(CurStr); { no spaces, wrap at right margin }
				PrintStr:=Copy(CurStr, 1, V);
				If DoJustify
					Then LineToGfxDumpJst(PrintStr, GfxLineWidth, P, TempSize)
					Else LineToGfxDump(PrintStr, P, TempSize);
				BlockWrite(F2, P^, TempSize);
				FreeMem(P, TempSize);
				CurStr:=Copy(CurStr, V+1, CurLen)+AddToNextStr;
				CurLen:=Font.Width(CurStr)
			End
		End;
		Font.SetFont(LastFnt)
	End
	Else Begin { TextMode=Printer }
		
		TempStr:=Ini.GetStr('Paper', 'A4Portrait');
		TextLineWidth:=68;
		If (TempStr='A4LANDSCAPE') Or (TempStr='A3PORTRAIT') Then
			TextLineWidth:=96;
		If TempStr='A3LANDSCAPE' Then TextLineWidth:=136;

		BlockWrite(F2, PrnInitText[1], Length(PrnInitText));
		PrnFont:='N'; { NLQ by default }
		TempStr:=Ini.GetStr('PrinterFont', 'NLQ');
		If TempStr='FASTDRAFT' Then PrnFont:='F';
		If TempStr='DRAFT' Then PrnFont:='D';
		If TempStr='EMPHASIZED' Then PrnFont:='E';
		If TempStr='PROPORTIONAL' Then PrnFont:='P';
		Case PrnFont Of
			'F': BlockWriteString(PrnInitTextFastDraft);
			'D': BlockWriteString(PrnInitTextDraft);
			'E': BlockWriteString(PrnInitTextEmphasized);
			'P': BlockWriteString(PrnInitTextProportional);
			'N': BlockWriteString(PrnInitTextNLQ);
		End;

		CurStr:='';
		CurLen:=0;
		C:=#0;
		While Not EOF(F1) Do
		Begin
			LastC:=C;
			Read(F1, C);
			CurStr:=CurStr+C;
			Inc(CurLen);
			If (LastC=#13) And (C=#10) Then
			Begin
				BlockWriteString(CurStr);
				CurStr:='';
				CurLen:=0
			End;
			If CurLen>TextLineWidth Then
			Begin
				V:=CurLen;
				While (CurStr[V]<>' ') And (V>0) Do
					Dec(V);
				If V=0 Then V:=TextLineWidth; { no spaces, wrap at right margin }
				PrintStr:=Copy(CurStr, 1, V);
				If DoJustify Then
					D.JustifyLine(PrintStr, TextLineWidth);
				BlockWriteString(PrintStr+#13#10);
				CurLen:=Length(CurStr)-V;
				CurStr:=Copy(CurStr, V+1, CurLen)
			End
		End;
		If CurStr<>'' Then
			BlockWriteString(CurStr+#13#10)
	End;
	Close(F1);
	BlockWriteString(PrnDone);
	Close(F2)
End;







Begin
	Fnt:=Nil;
End.