{ ************ MainMenu ************ }
Type
	TMainMenu=Record
		Menu: PMenuItem
	End;

Procedure MainMenu_Paint(Me:PControl; VX1, VY1, VX2:Integer);
Var
	CurItem: PMenuItem;
	CurWidth, CurX: Integer;
Begin
	With Me^, Place, TMainMenu(Data^) Do
	Begin
		CurItem:=Menu;
		CurX:=VX1;
		While CurItem<>Nil Do
		Begin
			CurWidth:=Ctl.Button_PrefWidth(CurItem^.Cargo);
			Ctl.Button_Paint(CurItem^.Cargo, CurX, VY1,
				CurX+CurWidth-1);
			Inc(CurX, CurWidth+4);
			CurItem:=CurItem^.Next
		End
	End
End;

Procedure MainMenu_OnDestroy(Me:PControl);
Begin
	With TMainMenu(Me^.Data^) Do
		Popup.FreeMenu(Menu);
	FreeMem(Me^.Data, SizeOf(TMainMenu))
End;

Procedure MainMenu_OnPress(Me:PProg; Control:PControl);
Var
	CurItem: PMenuItem;
	Found: Boolean;
Begin
	With TMainMenu(Control^.Data^) Do
	Begin
		CurItem:=Menu;
		Found:=False;
		While (CurItem<>Nil) And Not Found Do
			If CurItem^.Cargo=CurCtl
				Then Found:=True
				Else CurItem:=CurItem^.Next;
		If Found Then
			If CurItem^.SubMenu<>Nil
				Then With TControl(CurItem^.Cargo^).Place Do
					Popup.OpenMenu(Me, CurItem^.SubMenu, X1, Y2+2)
				Else CurItem^.OnClick(Me, CurItem)
	End
End;

Function MainMenu_Create(Prog:PProg; VMenu:PMenuItem;
	VPicturePos:TPicturePos): PControl;
Var
	Me: PControl;
	CurItem: PMenuItem;
	TempCtl: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
	With Me^ Do
	Begin
		OnDestroy:=MainMenu_OnDestroy;
		Enabled:=False;
		D.AssignRect(-1, -1, -1, -1, Place);

		GetMem(Data, SizeOf(TMainMenu));
		With TMainMenu(Data^) Do
		Begin
			Menu:=VMenu;
			CurItem:=VMenu;
			While CurItem<>Nil Do
			Begin
				CurItem^.Cargo:=Button_Create(Prog, String(CurItem^.Name^),
					CurItem^.Icon, VPicturePos, MainMenu_OnPress);
				D.AssignPStr(String(CurItem^.Hint^),
					TControl(CurItem^.Cargo^).Hint);
				TControl(CurItem^.Cargo^).OwnerCtl:=Me;
				CurItem:=CurItem^.Next
			End
		End
	End;
	MainMenu_Create:=Me
End;
