{ ******* MonthCal ******* }
Const
	MonthDays: Array[1..12] Of Word=
		(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

Type
	TMonthCal=Record
		Year, Month, Day: Word;
		Cols, FirstRow, LastRow: Integer;
	End;

Var
	MonthX, MonthY: Integer;
	MonthColor: TColor;

Procedure MonthCal_IntDraw(Me:PControl);
Const
	WeekDay: Array[1..7] Of String[2]=
		('', '', '', '', '', '', '');
	
Var
	Row, Col, DayN: Integer;
	Finished: Boolean;
	TempColor, ClrWeekend: TColor;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, TMonthCal(Data^), Place Do
	Begin
		Font.SetFont(Kernel.CurFont);
		For Row:=1 To 5 Do
			Font.Print(X1, Y1+4+(Row-1)*16, Kernel.ClrTextCom, WeekDay[Row]);
		ClrWeekend:=Gfx.Blend(Kernel.ClrTextCom, 176{red}, 50);
		For Row:=6 To 7 Do
			Font.Print(X1, Y1+4+(Row-1)*16, ClrWeekend, WeekDay[Row]);

		Gfx.AngleRect(X1+20, Y1, X2, Y2, Kernel.ClrListDarker);
		Gfx.AngleRect(X1+21, Y1+1, X2, Y2, Kernel.ClrListDark);
		Gfx.Bar(X1+22, Y1+2, X2, Y2, Kernel.ClrList);

		If (Year Mod 4)=0
			Then MonthDays[2]:=29
			Else MonthDays[2]:=28;
		DayN:=1;
		Row:=D.GetWeekDay(Year, Month, 1);
		If Row=0 Then Row:=7;
		FirstRow:=Row; { for OnClick }
		Col:=1;
		Finished:=False;
		ClrWeekend:=Gfx.Blend(Kernel.ClrListFont, 176{red}, 50);
		Repeat
			If D.InRange(Row, 1, 5)
				Then TempColor:=Kernel.ClrListFont
				Else TempColor:=ClrWeekend;
			If DayN=Day Then
			Begin
				Gfx.Bar(X1+24+(Col-1)*21, Y1+3+(Row-1)*16,
					X1+44+(Col-1)*21, Y1+18+(Row-1)*16, Kernel.ClrListSel);
				TempColor:=Kernel.ClrListSelFont
			End;
			Font.Print(X1+30+(Col-1)*21, Y1+4+(Row-1)*16, TempColor, D.St(DayN));
			If DayN<MonthDays[Month] Then
			Begin
				If Row=7 Then
				Begin
					Row:=1;
					Inc(Col)
				End
				Else Inc(Row);
				Inc(DayN)
			End
			Else Finished:=True
		Until Finished;
			{ for OnClick }
		Cols:=Col;
		LastRow:=Row
	End
End;

Procedure MonthCal_Paint(Me:PControl; VX1,VY1:Integer);
Begin
	With Me^, TMonthCal(Data^), Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX1+150, Y1+VY1+115, Me^.Place);
	MonthCal_IntDraw(Me)
End;

Procedure MonthCal_OnRefocus(Me:PControl; Focused:Boolean);
Begin
	Inc(Me^.Place.X1, 20);
	Kernel.CtlRefocusDummy(Me, Focused);
	Dec(Me^.Place.X1, 20)
End;


Function MonthCal_OnKey(Me:PControl; Key,ExtKey:Char): Boolean;
Var
	Recognized: Boolean;
Begin
	Recognized:=False;
	With Me^, TMonthCal(Data^) Do
	Begin
		If (Key=#0) And (ExtKey=#72) Then
		Begin { up arrow }
			D.DecNoLess(Integer(Day), 1);
			Recognized:=True
		End;
		If (Key=#0) And (ExtKey=#80) Then
		Begin { down arrow }
			D.IncNoMore(Integer(Day), MonthDays[Month]);
			Recognized:=True
		End;
		If (Key=#0) And (ExtKey=#75) Then
		Begin { left arrow }
			If Day>7 Then Dec(Day, 7);
			Recognized:=True
		End;
		If (Key=#0) And (ExtKey=#77) Then
		Begin { right arrow }
			If Day<=MonthDays[Month]-7 Then Inc(Day, 7);
			Recognized:=True
		End;
		If (Key=#0) And (ExtKey=#71) Then
		Begin { home }
			Day:=1;
			Recognized:=True
		End;
		If (Key=#0) And (ExtKey=#79) Then
		Begin { end }
			Day:=MonthDays[Month];
			Recognized:=True
		End;
	End;
	If Recognized Then
		MonthCal_IntDraw(Me);
	MonthCal_OnKey:=Recognized
End;


Procedure MonthCal_HideMouse(Var X,Y:Integer);
Begin
	With CurCtl^, Place, TMonthCal(Data^) Do
	Begin
		Kernel.HideMouse(X, Y);
		If D.InRectCoord(MonthX, MonthY, 0, 0, Cols-1, 6) Then
			If Not ((MonthX=0) And (MonthY<FirstRow-1)) And
					Not ((MonthX=Cols-1) And (MonthY>LastRow-1)) Then
				Gfx.Rectangle(X1+24+MonthX*21, Y1+3+MonthY*16,
					X1+44+MonthX*21, Y1+18+MonthY*16, MonthColor);
	End
End;

Procedure MonthCal_ShowMouse(Var X,Y:Integer);
Begin
	With CurCtl^, Place, TMonthCal(Data^) Do
	Begin
		If D.InRectCoord(X, Y, X1+24, Y1+3, X2, Y2) Then
		Begin
			MonthX:=(X-X1-24) Div 21;
			MonthY:=(Y-Y1-3) Div 16;
			If D.InRectCoord(MonthX, MonthY, 0, 0, Cols-1, 6) Then
				If Not ((MonthX=0) And (MonthY<FirstRow-1)) And
					Not ((MonthX=Cols-1) And (MonthY>LastRow-1)) Then
			Begin
				MonthColor:=Gfx.GetPixel(X1+24+MonthX*21, Y1+3+MonthY*16);
				Gfx.Rectangle(X1+24+MonthX*21, Y1+3+MonthY*16,
					X1+44+MonthX*21, Y1+18+MonthY*16, Kernel.ClrListSel)
			End
		End
	End;
	Kernel.ShowMouse(X, Y)
End;


Procedure MonthCal_OnClick(Me:PControl; X,Y:Integer);
Begin
	CurCtl:=Me;
	With Me^, Place, TMonthCal(Data^) Do
	Begin
		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(MonthCal_HideMouse, MonthCal_ShowMouse,
			Kernel.RefreshNeeded)=Mouse.mbNone;

		If D.InRectCoord(Kernel.MsX, Kernel.MsY, X1+24, Y1+3, X2, Y2) Then
			If D.InRange(MonthX, 0, Cols-1) And
				Not ((MonthX=0) And (MonthY<FirstRow-1)) And
				Not ((MonthX=Cols-1) And (MonthY>LastRow-1)) Then
			Begin
				Day:=MonthX*7+MonthY+1-FirstRow+1;
				MonthCal_IntDraw(Me)
			End
	End
End;

Procedure MonthCal_SetDate(Me:PControl; VYear,VMonth,VDay:Word);
Begin
	With Me^, TMonthCal(Data^) Do
	Begin
		Year:=VYear;
		Month:=VMonth;
		Day:=VDay;
		D.ToRange(Integer(Day), 1, MonthDays[Month])
	End;
	If Me^.AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
		If (Me^.CanDraw Or Kernel.DontBother) And Me^.Visible Then
		Begin
			Kernel.BeginPaint(Me^.Place);
			MonthCal_IntDraw(Me);
			Kernel.EndPaint
		End
End;

Procedure MonthCal_GetDate(Me:PControl; Var VYear,VMonth,VDay:Word);
Begin
	With Me^, TMonthCal(Data^) Do
	Begin
		VYear:=Year;
		VMonth:=Month;
		VDay:=Day
	End
End;


Procedure MonthCal_OnDestroy(Me:PControl);
Begin
	FreeMem(Me^.Data, SizeOf(TMonthCal))
End;

Function MonthCal_Create(Prog:PProg; VYear,VMonth,VDay:Word): PControl;
Var
	Me: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
	With Me^ Do
	Begin
		OnRefocus:=MonthCal_OnRefocus;
		OnClick:=MonthCal_OnClick;
		OnKey:=MonthCal_OnKey;
		OnDestroy:=MonthCal_OnDestroy;

		GetMem(Data, SizeOf(TMonthCal));
		With TMonthCal(Data^) Do
		Begin
			Year:=VYear;
			Month:=VMonth;
			Day:=VDay
		End
	End;
	MonthCal_Create:=Me
End;
