Unit
	Mouse; { Polit Halcyon Eva mouse unit }

Interface

Uses
	DOS, Types, Ini;

Type
	TMouseProc=Procedure(X,Y:Integer);

Var
	R: Registers;
	Area: TRect;
	mbLeft, mbRight, mbMiddle, mbNone: Word;
	HaveWheel: Boolean;


	Procedure Init;
	Function Buttons:Integer;
	Function CheckWheel: Boolean;
	Function GetDX: Integer;
	Function GetDY: Integer;
	Procedure GetDXDY(Var VDX,VDY:Integer);
	Function GetMask: Word;
	Function GetWheel: Integer;
	Procedure GetMaskAndWheel(Var Mask:Word; Var Wheel:Integer);
	Procedure InitHand;

Implementation

Uses
	Gfx;

Procedure MouseFunc(N:Word);
Begin
	R.AX:=N;
	Intr($33, R)
End;

Function Buttons: Integer;
Begin
	MouseFunc(0);
	If R.AX=0
		Then Buttons:=0
		Else Buttons:=R.BX
End;

Function CheckWheel: Boolean;
Begin
	MouseFunc($11);
	HaveWheel:=(R.CX And 1)=1
End;

Function GetDX: Integer;
Begin
	MouseFunc(11);
	GetDX:=R.CX
End;

Function GetDY: Integer;
Begin
	MouseFunc(11);
	GetDY:=R.DX
End;

Procedure GetDXDY(Var VDX,VDY:Integer);
Begin
	MouseFunc(11);
	VDX:=Integer(R.CX);
	VDY:=Integer(R.DX)
End;

Function GetMask: Word;
Begin
	MouseFunc(3);
	GetMask:=R.BX
End;

Procedure GetMaskAndWheel(Var Mask:Word; Var Wheel:Integer);
Begin
	MouseFunc(3);
	Mask:=R.BL;
	If HaveWheel
		Then Wheel:=ShortInt(R.BH)
		Else Wheel:=0
End;

Function GetWheel: Integer;
Begin
	If HaveWheel Then
	Begin
		R.BX:=Word(-1);
		MouseFunc(5);
		GetWheel:=Integer(R.BX)
	End
	Else
		GetWheel:=0
End;


Procedure InitHand;
Begin
	Ini.Select('polit.ini', 'Mouse');
	If Ini.GetStr('Hand', 'RIGHT')='RIGHT' Then
	Begin
		mbLeft:=1;
		mbRight:=2
	End
	Else Begin
		mbLeft:=2;
		mbRight:=1
	End;
	mbMiddle:=4;
	mbNone:=0;
End;

Procedure Init;
Var
	V: Integer;
	SpeedX, SpeedY: Integer;
	ScrX, ScrY: Integer;
	TempStr: String;
Begin
	Log.SysMsg('Mouse', 'Init', 'Mouse init sequence started');
	V:=Buttons;
	HaveWheel:=CheckWheel{False};
	If V=0 Then
	Begin
		Log.FatMsg('Mouse', 'Init', 'Mouse or mouse driver not found!');
		Gfx.Done;
		Log.Done;
		WriteLn('UKR:   i ࠩ 誨.');
		WriteLn('     ஡  i  DOSPOLIT.');
		WriteLn('ENG: Mouse driver is required.');
		WriteLn('     Try to start Polit ising DOSPOLIT command.');
		Halt(10)
	End
	Else Begin
		TempStr:='Mouse found, reported as '+D.St(V)+'-buttons';
		If HaveWheel Then
			TempStr:=TempStr+' with wheel';
		Log.SysMsg('Mouse', 'Init', TempStr)
	End;

	InitHand;
	{SpeedX:=Ini.GetInt('SpeedX', 4);
	SpeedY:=Ini.GetInt('SpeedY', 4);
	SetSpeed(SpeedX, SpeedY)}
End;

Begin End.