{$F+}
Unit
	MouSetup; { Polit Halcyon MouSetup application }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx;

Type
	TMouSetupData=Record
		LabSpeed, TrkSpeed: PControl;
		LabButtons, RadLeftHand, RadRightHand: PControl;
		ChkPlaceMouse, ChkOnShots: PControl;
		BtnClose: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TMouSetupData(Data^) Do
	Begin
		Kernel.DarkBar(X1, Y2-34, X2, Y2);
		Gfx.TranspBar(X1, Y2-35, X2, Y2-35, clBlack, 50);

		Ctl.Label_Paint(LabSpeed, 10, 10, 140);
		Ctl.Track_Paint(TrkSpeed, 150, 10, X2-X1-10);

		Ctl.Label_Paint(LabButtons, 10, 50, 140);
		Ctl.Radio_Paint(RadRightHand, 150, 50);
		Ctl.Radio_Paint(RadLeftHand, 150, 70);

		Ctl.Check_Paint(ChkPlaceMouse, 10, 110);
		Ctl.Check_Paint(ChkOnShots, 10, 135);

		Ctl.Button_Paint(BtnClose, X2-X1-105, Y2-Y1-26, X2-X1-5);
	End;
End;


Procedure OnSpeedTrack(Me:PProg; Control:PControl);
Begin
	With Me^, TMouSetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Mouse');
		Ini.SetInt('Speed', Ctl.Track_GetPos(TrkSpeed));
		Kernel.MsSpeed:=Ctl.Track_GetPos(TrkSpeed)
	End
End;

Procedure OnHandRadio(Me:PProg; Control:PControl);
Begin
	With Me^, TMouSetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Mouse');
		If Ctl.Radio_Selected(RadRightHand) Then
			Ini.SetStr('Hand', 'Right');
		If Ctl.Radio_Selected(RadLeftHand) Then
			Ini.SetStr('Hand', 'Left');
		Mouse.InitHand
	End
End;

Procedure OnPlaceCheck(Me:PProg; Control:PControl);
Begin
	With Me^, TMouSetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Mouse');
		If Check_GetState(ChkPlaceMouse)
			Then Ini.SetStr('PlaceMouse', 'Animate')
			Else Ini.SetStr('PlaceMouse', 'No')
	End
End;

Procedure OnOnShotsCheck(Me:PProg; Control:PControl);
Begin
	With Me^, TMouSetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Mouse');
		Ini.SetBool('OnScreenshots', Ctl.Check_GetState(ChkOnShots))
	End
End;

Procedure OnCloseBtn(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;


Procedure OnClose(Me:PProg);
Var
	TempPtr: Pointer;
Begin
	With Me^ Do
		If Parent<>Nil Then
			TempPtr:=Kernel.SendMessage(Me, Parent, 'Settings:CloseSheet', Nil);
	FreeMem(Me^.Data, SizeOf(TMouSetupData))
End;

Procedure OnInit(Me:PProg);
Var
	TempSpeed: Integer;
	TempHand, TempPlace: String;
	TempOnShots: Boolean;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('誠: ன', WinTitle);
		MinX:=300;
		MinY:=200;
		GetMem(Data, SizeOf(TMouSetupData));
		If Parent=Nil
			Then Kernel.InitWindow(Me, 'BlueDlg', [wbMin, wbClose])
			Else Kernel.InitSheetWindow(Me, 'BlueDlg', [wbSlide], brLeft);
		Kernel.DrawWindowAni(Me);

		With TMouSetupData(Data^) Do
		Begin
			Ini.Select('polit.ini', 'Mouse');
			TempSpeed:=Ini.GetInt('Speed', 8);
			D.ToRange(TempSpeed, 1, 15);
			TempHand:=Ini.GetStr('Hand', 'Right');
			TempPlace:=Ini.GetStr('PlaceMouse', 'Animate');
			If TempPlace='WARP' Then TempPlace:='ANIMATE';
			TempOnShots:=Ini.GetBool('OnScreenshots', True);

			LabSpeed:=Ctl.Label_Create(Me, 'i :', Nil, lsNormal, alRight);
			TrkSpeed:=Ctl.Track_Create(Me, 1, 15, TempSpeed, tkGrowRight,
				False, OnSpeedTrack);
			LabSpeed^.FocusCtl:=TrkSpeed;

			LabButtons:=Ctl.Label_Create(Me, '㢠 :', Nil, lsNormal, alRight);
			RadRightHand:=Ctl.Radio_Create(Me, ' ࠢ 㪨',
				(TempHand='RIGHT'), 1);
			Ctl.Radio_SetOnChange(RadRightHand, OnHandRadio);
			RadLeftHand:=Ctl.Radio_Create(Me, ' i 㪨',
				(TempHand='LEFT'), 1);
			Ctl.Radio_SetOnChange(RadLeftHand, OnHandRadio);

			ChkPlaceMouse:=Ctl.Check_Create(Me, '⠢     㬮砭',
				(TempPlace<>'NO'));
			Ctl.Check_SetOnChange(ChkPlaceMouse, OnPlaceCheck);

			ChkOnShots:=Ctl.Check_Create(Me, '   i ࠭',
				TempOnShots);
			Ctl.Check_SetOnChange(ChkOnShots, OnOnShotsCheck);

			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseBtn);

			ActiveCtl:=TrkSpeed;
			ButtonEsc:=BtnClose;
		End
	End
End;



Begin
	Kernel.RegBuiltIn('MouSetup', '', 'pic\i_mouset.bmp', OnInit)
End.
