{$F+}
Unit
	MT_Filer; { Polit Halcyon * Filer * application }
				 { originally by Masterdron (m.t.)     }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, DOS, Popup{, LFN};

Const
	ChunkSize: LongInt=2048;

Type
	TJumpDir=(jdForward, jdBack, jdNone);
	TFType=(TF_file, TF_dir);
	TRenameResult=(rrNone, rrOK, rrCancel);
	TFileOp=(foDelete, foRename, foCopy, foMove, foStatQuick, foStatFull);
	TObjectKind=(okFile, okFolder);

	TFiler=Record
		LstFiles1, LstFiles2: PControl;
		PicFolder, PicFile, PicUp, PicFloppy, PicFixed, PicCD: Pointer;
		LabPath1: PControl;
		LabPath2: PControl;
		SplTest: PControl;
		PbtDrive1, PbtDrive2: PControl;
		MnuDisks1, MnuDisks2: PMenuItem;
		cur_dir1, cur_dir2: String;
		BtnView, BtnRename, BtnCopy, BtnMove, BtnMkDir, BtnDelete: PControl;
		TimWork, InpRename, ActivePanel: PControl;
		RenameRect: TRect;
		RenameResult: TRenameResult;
		ProStatus: PControl;
		MnuContext: PMenuItem;
		PicRename, PicCopy, PicMove, PicMkDir, PicDelete: Pointer;

			{ ******* for file ops engine ******* }
		Steps, CurSteps: LongInt;
			{ for NextStep }
		Objects: Array[1..70] Of Record
			Name: PStr;
			Kind: TObjectKind
		End;
		ObjectsNum, CurObject: Integer;
			{ for OnIdle }
		Par: Array[1..70] Of Record
			Path: String;
			SR: SearchRec;
			Res: Integer;
			State: (stPrepare, stStartSearch, stContSearch, stCopyFile);
		End;
		LastPar: Integer;
		OrigSourcePath, OrigTargetPath, SourcePath, TargetPath: String;
		PBuf: Pointer;
		RealSize: Integer;
		F1, F2: File;
		FileOp: Array[1..2] Of TFileOp;
		OpObject: TObjectKind;
		Pass: 1..2;
		LastFName1, LastFName2: String;
		LastWidth, LastSplitterPos: Integer;
	End;

Var
	TF : PProg;
	del_file : TFType;
	op_error : byte;

Implementation

Procedure Filer_OnPaint(Me:PProg);
Var
	TempX, I: Integer;
	CurX, TempWidth: Real;
	BtnOp: Array[1..6] Of PControl;
Begin
	With Me^, ClientRect, TFiler(Data^) Do
	Begin
		Ctl.Splitter_Paint(SplTest, 150, 5, X2-X1-150, Y2-Y1-60);
		TempX:=Ctl.Splitter_GetCoord(SplTest);
		With WinRect Do
			If ((X2-X1+1)<>LastWidth) And (TempX=LastSplitterPos) Then
			Begin
				TempX:=Round(LastSplitterPos/LastWidth*(X2-X1+1));
				Ctl.Splitter_SetCoord(SplTest, TempX)
			End;

			{ iv: manual WinBG drawing (for speed) }
		Kernel.WinBGBar(Me, X1, Y1, X2, Y1+31);
		Kernel.WinBGBar(Me, X1, Y1+32, X1+4, Y2-60);
		Kernel.WinBGBar(Me, X1+TempX-7-16, Y1+32, X1+TempX+7, Y2-60);
		Kernel.WinBGBar(Me, X2-4-16, Y1+32, X2, Y2-60);
		Kernel.WinBGBar(Me, X1, Y2-59, X2, Y2);

		Ctl.Splitter_Paint(SplTest, 150, 5, X2-X1-150, Y2-Y1-60);
		{TempX:=Ctl.Splitter_GetCoord(SplTest);}

		Ctl.Label_Paint(LabPath1, 5, 5, TempX-8-60);
		Ctl.Label_Paint(LabPath2, TempX+7, 5, X2-X1-5-60);

		Ctl2.ListBox_Paint(LstFiles1, 5, 32, TempX-8, Y2-Y1-60);
		Ctl2.ListBox_Paint(LstFiles2, TempX+7, 32, X2-X1-5, Y2-Y1-60);

		Ctl.PopupBtn_Paint(PbtDrive1, TempX-8-55, 5, TempX-8);
		Ctl.PopupBtn_Paint(PbtDrive2, X2-X1-5-55, 5, X2-X1-5);

		{ View F2-Rename F5-Copy F6-Move F7-MkDir F8-Delete }
		BtnOp[1]:=BtnView;
		BtnOp[2]:=BtnRename;
		BtnOp[3]:=BtnCopy;
		BtnOp[4]:=BtnMove;
		BtnOp[5]:=BtnMkDir;
		BtnOp[6]:=BtnDelete;
		TempWidth:=(X2-X1-10-4*(6-1))/6;
		CurX:=5;
		For I:=1 To 6 Do
		Begin
			Ctl.Button_Paint(BtnOp[I], Round(CurX), Y2-Y1-52, Round(CurX+TempWidth));
			CurX:=CurX+TempWidth+4
		End;

		Ctl.Progress_Paint(ProStatus, 5, Y2-Y1-26, X2-X1-5);

		If InpRename<>Nil Then
			With RenameRect Do
				Ctl.InpLine_Paint(InpRename, X1, Y1, X2);

		With WinRect Do
			LastWidth:=X2-X1+1;
		LastSplitterPos:=TempX;
	End
End;

{==============================================================================}
Procedure fill_listbox(ME:PProg; Var Lst,Lab:Pcontrol;
	cur_dir,LastDir:String; JumpDir:TJumpDir); Forward;

Procedure OnWorkTimer(Me:PProg; Control:PControl; Times:Integer);
Var
	TempItem: PListItem;
	TempDir, LastDir: String;
	TempF: File;
Begin
	With Me^, TFiler(Data^) Do
	Begin
		if ActiveCtl<>InpRename Then
		Begin
			ActivePanel:=ActiveCtl;
			RenameResult:=rrCancel
		End;

		If RenameResult=rrNone Then Exit;

		TempItem:=Ctl2.ListBox_GetSelItem(ActivePanel);
		If RenameResult=rrOK Then
		Begin
			GetDir(0, LastDir);
			If ActivePanel=LstFiles1
				Then TempDir:=Cur_Dir1
				Else TempDir:=Cur_Dir2;
			If Length(TempDir)=2 Then TempDir:=TempDir+'\';
			ChDir(TempDir);
			{LFN.LFNRename(String(TempItem^.Name^), Ctl.InpLine_GetText(InpRename));}
			Assign(TempF, String(TempItem^.Name^));
			Rename(TempF, Ctl.InpLine_GetText(InpRename));
			ChDir(LastDir);
			If ActivePanel=LstFiles1
				Then Fill_ListBox(Me, LstFiles1, LabPath1, Cur_Dir1,
					D.NormLine(Ctl.InpLine_GetText(InpRename)), jdNone)
				Else Fill_ListBox(Me, LstFiles2, LabPath2, Cur_Dir2,
					D.NormLine(Ctl.InpLine_GetText(InpRename)), jdNone);
			kernel.SelectFocusCtl(Me, ActivePanel)
		End;

		Kernel.DestroyCtl(Me, InpRename);
		Ctl.TimerCtl_SetActive(TimWork, False);
		ActiveCtl:=ActivePanel;
		InpRename:=Nil;
		{Kernel.PaintWindow(Me);}
		Ctl2.ListBox_Draw(ActiveCtl)
	End
End;



Procedure OnViewClick(Me:PProg;Control:PControl);
var
	TempName: String;
	RName, FName : string;
	FTypePic : pointer;
Begin
	With Me^, TFiler(Data^), ClientRect Do
	Begin
		If InpRename<>Nil Then
		Begin { ਡ    i㢠 }
			RenameResult:=rrCancel;
			OnWorkTimer(Me, TimWork, 1)
		End;

		RName:=String((Ctl2.ListBox_GetSelItem(ActiveCtl))^.Name^);
		FTypePic:=Ctl2.ListBox_GetSelItem(ActiveCtl)^.Icon;
		If ActiveCtl=LstFiles1
			Then TempName:=Ctl.Label_GetCaption(LabPath1)
			Else TempName:=Ctl.Label_GetCaption(LabPath2);

		If (FTypePic<>PicFolder) Then
		Begin
			TempName:=Copy(TempName, 1, Length(TempName)-3)+RName;
			Log.BugMsg('Filer', 'OnViewClick', 'Name = '+TempName);
			Kernel.RunFile(TempName)
		End
	End
End;
{==============================================================================}



Procedure TryRefreshPanels(Me:PProg);
Var
	TempPath1, TempPath2: String;
	CurFile1, CurFile2: String;
Begin
	Log.BugMsg('Filer', 'TryRefreshPanels', 'Starting...');
	With TFiler(Me^.Data^) Do
	Begin
		CurFile1:=String(Ctl2.ListBox_GetSelItem(LstFiles1)^.Name^);
		CurFile2:=String(Ctl2.ListBox_GetSelItem(LstFiles2)^.Name^);

		{LFN.LFNGetShortPath(False, Cur_Dir1, TempPath1);
		LFN.LFNGetShortPath(False, Cur_Dir2, TempPath2);}
		TempPath1:=Cur_Dir1;
		TempPath2:=Cur_Dir2;
		If (TempPath1=OrigSourcePath) Or (TempPath1=OrigTargetPath) Then
			Fill_ListBox(ME, LstFiles1, LabPath1, cur_dir1, CurFile1, jdNone);
		If (TempPath2=OrigSourcePath) Or (TempPath2=OrigTargetPath) Then
			Fill_ListBox(ME, LstFiles2, LabPath2, cur_dir2, CurFile2, jdNone)
	End;
	Log.BugMsg('Filer', 'TryRefreshPanels', 'All OK!');
End;


	{ to enter supply:
	  Objects array, ObjectsNum, CurObject
	  OrigSourcePath }
Procedure NextStep(Me:PProg);
Var
	I: Integer;
Begin
	Log.BugMsg('Filer', 'NextStep', 'Starting...');
	With TFiler(Me^.Data^) Do
	Begin
		If CurObject=ObjectsNum Then
		Begin { Pass complete }
			If Pass=1 Then
			Begin { second pass }
				ProStatus^.AutoRedraw:=False;
				Ctl.Progress_SetKind(ProStatus, pkDeterm);
				ProStatus^.AutoRedraw:=True;
				Ctl.Progress_SetParams(ProStatus, 0, Steps, 0);
				Log.BugMsg('Filer', 'NextStep', 'Steps = '+D.StL(Steps));
				CurSteps:=0;
				Pass:=2;
				CurObject:=0
			End
			Else Begin { all done! }
				Log.BugMsg('Filer', 'NextStep', 'CurSteps = '+D.StL(CurSteps));
				Me^.OnIdle:=Kernel.DummyProc;
				For I:=1 To ObjectsNum Do
					D.FreePStr(Objects[I].Name, 'Filer - FileOp done');
				FreeMem(PBuf, ChunkSize);
				Ctl.Progress_SetParams(ProStatus, 0, 10, 0);
				TryRefreshPanels(Me);
				Exit
			End
		End;

		Inc(CurObject);
		LastPar:=1;
		Par[1].State:=stPrepare;
		opObject:=Objects[CurObject].Kind;
		SourcePath:=OrigSourcePath+'\'+String(Objects[CurObject].Name^);
		{LFN.LFNGetShortPath(False, SourcePath, SourcePath);}
		TargetPath:=OrigTargetPath
	End;
	Log.BugMsg('Filer', 'NextStep', 'All OK!');
End;




	{ to enter supply:
	  LastPar=1;
	  Par[1].State=stPrepare;
	  opObject, FileOp[1, 2], Pass;
	  SourcePath, TargetPath; }
Procedure OnIdle(Me:PProg);
Var
	TempName, DebugName: String;
	TempRes: Integer;
	TempF: File;

	Procedure StepProgress;
	Var
		TempPath1, TempPath2: String;
		TempSource, TempTarget: String;
	Begin
		With TFiler(Me^.Data^) Do
		Begin
			Inc(CurSteps);
			Ctl.Progress_Step(ProStatus);
			If ((CurSteps Mod 1200)=0) Then
				TryRefreshPanels(Me)
		End
	End;

Begin
	Log.BugMsg('Filer', 'OnIdle', 'Starting...');
	With TFiler(Me^.Data^) Do
	Begin
		If LastPar=0 Then
		Begin { Current step complete }
			NextStep(Me);
			Exit
		End;

		With Par[LastPar] Do
			Case State Of
				stPrepare: Begin
					Path:='';
					Case OpObject Of
						okFolder: Begin
							If FileOp[Pass] In [foRename, foCopy, foMove] Then
							Begin
								TargetPath:=OrigTargetPath+'\'+ClipFName(SourcePath+'.tmp');
								{MkDir(TargetPath)}
								{LFN.LFNGetLongPath(False, SourcePath, TempName);
								TempName:=D.LastPathItem(TempName);
								LFN.LFNMkDir(OrigTargetPath+'\'+TempName)}
								TempName:=SourcePath;
								TempName:=D.LastPathItem(TempName);
								MkDir(OrigTargetPath+'\'+TempName)
							End;
							State:=stStartSearch
						End;
						okFile: Begin
							Case FileOp[Pass] Of
								foDelete: Begin
									Assign(F1, SourcePath);
									SetFAttr(F1, 0);
									Erase(F1);
									{Inc(CurSteps);
									Ctl.Progress_Step(ProStatus);}
									StepProgress;
									LastPar:=0
								End;
								foRename: Begin
									Assign(F1, SourcePath);
									Rename(F1, TargetPath+'\'+ClipFNameExt(SourcePath));
									{LFN.LFNGetLongPath(False, SourcePath, TempName);
									TempName:=D.LastPathItem(TempName);
									LFN.LFNRename(SourcePath, TargetPath+'\'+TempName);}
									{Inc(CurSteps);
									Ctl.Progress_Step(ProStatus);}
									StepProgress;
									LastPar:=0
								End;
								foCopy, foMove: Begin
									FileMode:=0;
									Assign(F1, SourcePath);
									Reset(F1, 1);
									{Assign(F2, TargetPath+'\'+ClipFNameExt(SourcePath));}
									LastFName1:=D.UniqueFName(TargetPath);
									Assign(F2, TargetPath+'\'+LastFName1);
									Rewrite(F2, 1);
									{LastFName2:=GetLastDir(SourcePath);}
									LastFName2:='';
									State:=stCopyFile;
									FileMode:=2
								End;
								foStatQuick: Begin
									Inc(Steps);
									LastPar:=0
								End;
								foStatFull: Begin
									FileMode:=0;
									Assign(F1, SourcePath);
									Reset(F1, 1);
									Inc(Steps, (FileSize(F1)+ChunkSize-1) Div ChunkSize);
									Close(F1);
									LastPar:=0;
									FileMode:=2
								End
							End
						End
					End;
				End;
				stStartSearch: Begin { start search }
					FindFirst(SourcePath+Path+'\*.*', AnyFile, SR);
					Res:=DOSError;
					State:=stContSearch
				End;
				stContSearch: Begin { next file/folder found }
					If Res=0 Then { something found }
					Begin
						If (SR.Attr and Directory)=0 Then
						Begin { it's a file }
							DebugName:=SR.Name;
							Case FileOp[Pass] Of
								foDelete: Begin
									Assign(F1, SourcePath+Path+'\'+SR.Name);
									SetFAttr(F1, 0);
									Erase(F1);
									{Inc(CurSteps);
									Ctl.Progress_Step(ProStatus)}
									StepProgress
								End;
								foRename: Begin
									{LFN.LFNGetLongPath(False, SourcePath+Path+'\'+SR.Name, TempName);
									TempName:=D.LastPathItem(TempName);
									LFN.LFNRename(SourcePath+Path+'\'+SR.Name,
										TargetPath+Path+'\'+TempName);}
									TempName:=SourcePath+Path+'\'+SR.Name;
									TempName:=D.LastPathItem(TempName);
									{Inc(CurSteps);
									Ctl.Progress_Step(ProStatus)}
									StepProgress
								End;
								foCopy, foMove: Begin
									Log.BugMsg('Filer', 'OnIdle', 'Enetring ContSearch:COPY section...');
									FileMode:=0;
									Assign(F1, SourcePath+Path+'\'+SR.Name);
									Reset(F1, 1);
									{Assign(F2, TargetPath+Path+'\'+SR.Name);}
									LastFName1:=D.UniqueFName(TargetPath+Path);
									Assign(F2, TargetPath+Path+'\'+LastFName1);
									Rewrite(F2, 1);
									LastFName2:=SR.Name;
									State:=stCopyFile;
									FileMode:=2;
									Log.BugMsg('Filer', 'OnIdle', 'ContSearch:COPY section OK!');
								End;
								foStatQuick: Inc(Steps);
								foStatFull: Begin
									Assign(F1, SourcePath+Path+'\'+SR.Name);
									FileMode:=0;
									Reset(F1, 1);
									Inc(Steps, (FileSize(F1)+ChunkSize-1) Div ChunkSize);
									If IOResult<>0 Then
									Begin
										Log.BugMsg('Filer', 'OnIdle', 'Bad IOResult (gaining file stats)');
										Log.ActMsg('File: '+SourcePath+Path+'\'+SR.Name)
									End;
									Close(F1);
									FileMode:=2
								End
							End
						End
						Else If SR.Name[1]<>'.' Then
							Begin { it's a folder }
								Case FileOp[Pass] Of
									foRename, foCopy, foMove: Begin
										{MkDir(TargetPath+Path+'\'+SR.Name);}
										{LFN.LFNGetLongPath(False, SourcePath+Path+'\'+SR.Name, TempName);
										TempName:=D.LastPathItem(TempName);
										LFN.LFNMkDir(TargetPath+Path+'\'+TempName);}
										TempName:=SourcePath+Path+'\'+SR.Name;
										TempName:=D.LastPathItem(TempName);
										MkDir(TempName);
										{Inc(CurSteps);
										Ctl.Progress_Step(ProStatus)}
										StepProgress
									End;
									foStatQuick, foStatFull: Inc(Steps)
								End;
								Par[LastPar+1].Path:=Path+'\'+SR.Name;
								Par[LastPar+1].State:=stStartSearch;
								Inc(LastPar)
							End;
						FindNext(SR);
						Res:=DOSError
					End
					Else Begin { current search complete }
						Case FileOp[Pass] Of
							foRename, foMove: Begin
								RmDir(SourcePath+Path);
								If IOResult<>0 Then
								Begin
									Log.ErrMsg('Filer', 'OnIdle', 'Cannot delete folder after move:');
									Log.ActMsg(SourcePath+Path)
								End
							End;
							foDelete: Begin
								RmDir(SourcePath+Path);
								{Inc(CurSteps);
								Ctl.Progress_Step(ProStatus)}
								StepProgress
							End
						End;
						Dec(LastPar)
					End
				End;
				stCopyFile: Begin
					Log.BugMsg('Filer', 'OnIdle', 'Entering stCopyFile...');
					BlockRead(F1, PBuf^, ChunkSize, RealSize);
					If RealSize>0 Then
					Begin
						BlockWrite(F2, PBuf^, RealSize);
						{Inc(CurSteps);
						Ctl.Progress_Step(ProStatus)}
						StepProgress
					End;
					If RealSize<ChunkSize Then
					Begin
						Close(F1);
						Close(F2);

						{If LastFName2=''
							Then LFN.LFNGetLongPath(False, SourcePath, TempName)
							Else LFN.LFNGetLongPath(False, SourcePath+Path+'\'+LastFName2,
								TempName);}
						If LastFName2=''
							Then TempName:=SourcePath
							Else TempName:=SourcePath+Path+'\'+LastFName2;
						TempName:=D.LastPathItem(TempName);

						Log.BugMsg('Filer', 'OnIdle', 'Renaming file: '+
							TargetPath+Path+'\'+LastFName1);
						Log.ActMsg('to file: '+TargetPath+Path+'\'+TempName);

						{TempRes:=LFN.LFNRename(TargetPath+Path+'\'+LastFName1,
							TargetPath+Path+'\'+TempName);}
						{Assign(TempF, TargetPath+Path+'\'+LastFName1);
						Rename(TempF, TargetPath+Path+'\'+TempName);}

						Rename(F2, TargetPath+Path+'\'+TempName);

						{If TempRes<>0 Then
						Begin
							Log.BugMsg('Filer', 'OnIdle', 'Error renaming file: '+
								D.St(TempRes));
							Log.ActMsg('File: '+TargetPath+Path+'\'+TempName)
						End;}
						{LFN.LFNRename(TargetPath+Path+'\tempmzfk.md',
							TargetPath+Path+'\'+TempName);}
						If FileOp[Pass]=foMove Then
						Begin
							SetFAttr(F1, 0);
							Erase(F1);
							If IOResult<>0 Then
								Log.BugMsg('Filer', 'OnIdle', 'Error deleting file during move')
						End;
						Case OpObject Of
							okFolder: State:=stContSearch;
							okFile: Dec(LastPar)
						End
					End;
					Log.BugMsg('Filer', 'OnIdle', 'stCopyFile OK!');
				End
			End
	End;
	Log.BugMsg('Filer', 'OnIdle', 'All OK!');
End;



{===================================================================}

Procedure PrepareFileOp(Me:PProg);
Var
	TempStr: String;
	TempItem: PListItem;

	Function GetLabelPath(Lab:PControl): String;
	Var
		TempStr: String;
	Begin
		TempStr:=Ctl.Label_GetCaption(Lab);
		If Length(TempStr)=6
			Then TempStr:=Copy(TempStr, 1, 3)
			Else TempStr:=Copy(TempStr, 1, Length(TempStr)-4);
		{LFN.LFNGetShortPath(False, TempStr, TempStr);}
		If Length(TempStr)=3 Then
			Delete(TempStr, 3, 1);
		GetLabelPath:=TempStr
	End;
Begin
	Log.BugMsg('Filer', 'PrepareFileOp', 'Starting...');
	With TFiler(Me^.Data^) Do
	Begin
		GetMem(PBuf, ChunkSize);
		Ctl.Progress_SetKind(ProStatus, pkIndeterm);
		If Me^.ActiveCtl=LstFiles1 Then
		Begin
			OrigSourcePath:=GetLabelPath(LabPath1);
			OrigTargetPath:=GetLabelPath(LabPath2)
		End
		Else Begin
			OrigSourcePath:=GetLabelPath(LabPath2);
			OrigTargetPath:=GetLabelPath(LabPath1)
		End;
			{ 㢠 ᯨ᮪ 䠩i   }
		If Ctl2.ListBox_GetSelItemsTotal(Me^.ActiveCtl)=0 Then
		Begin
			ObjectsNum:=1;
			TempItem:=Ctl2.ListBox_GetSelItem(Me^.ActiveCtl);
			D.AssignPStr(String(TempItem^.Name^), Objects[1].Name);
			If TempItem^.Icon=PicFolder
				Then Objects[1].Kind:=okFolder
				Else Objects[1].Kind:=okFile
		End
		Else Begin
			ObjectsNum:=0;
			TempItem:=Ctl2.ListBox_GetItemByIndex(Me^.ActiveCtl, 1);
			While TempItem<>Nil Do
			Begin
				If TempItem^.Selected Then
				Begin
					Inc(ObjectsNum);
					D.AssignPStr(String(TempItem^.Name^), Objects[ObjectsNum].Name);
					If TempItem^.Icon=PicFolder
						Then Objects[ObjectsNum].Kind:=okFolder
						Else Objects[ObjectsNum].Kind:=okFile
				End;
				TempItem:=TempItem^.Next
			End
		End;
		CurObject:=0;
		CurSteps:=0;
		If FileOp[2]=foDelete
			Then Steps:=1
			Else Steps:=0;
		Pass:=1;
		LastPar:=1;
		Me^.OnIdle:=OnIdle;
		NextStep(Me)
	End;
	Log.BugMsg('Filer', 'PrepareFileOp', 'All OK!');
End;

Procedure FileOpCheckRenameField(Me:PProg);
Begin
	With TFiler(Me^.Data^) Do
	Begin
		If InpRename<>Nil Then
		Begin { ਡ    i㢠 }
			RenameResult:=rrCancel;
			OnWorkTimer(Me, TimWork, 1)
		End
	End
End;

Procedure OnCopyClick(Me:PProg; Control:PControl);
Begin
	Log.BugMsg('Filer', 'OnCopyClick', 'Starting...');
	With TFiler(Me^.Data^) Do
	Begin
		FileOpCheckRenameField(Me);
		FileOp[1]:=foStatFull;
		FileOp[2]:=foCopy;
		PrepareFileOp(Me)
	End;
	Log.BugMsg('Filer', 'OnCopyClick', 'All OK!');
End;

Procedure OnDeleteClick(Me:PProg; Control:PControl);
Begin
	With TFiler(Me^.Data^) Do
	Begin
		FileOpCheckRenameField(Me);
		FileOp[1]:=foStatQuick;
		FileOp[2]:=foDelete;
		PrepareFileOp(Me)
	End
End;

Procedure OnMoveClick(Me:PProg; Control:PControl);
Var
	TempStr1, TempStr2: String;
Begin
	With TFiler(Me^.Data^) Do
	Begin
		FileOpCheckRenameField(Me);
		TempStr1:=Ctl.Label_GetCaption(LabPath1);
		TempStr2:=Ctl.Label_GetCaption(LabPath2);
		If TempStr1[1]=TempStr2[1] Then
		Begin
			FileOp[1]:=foStatQuick;
			FileOp[2]:=foRename
		End
		Else Begin
			FileOp[1]:=foStatFull;
			FileOp[2]:=foMove
		End;
		PrepareFileOp(Me)
	End
End;

Procedure OnPropsClick(Me:PProg; Control:PControl);
Var
	TempItem: PListItem;
	TempName: String;
Begin
	With Me^, TFiler(Data^) Do
	Begin
		FileOpCheckRenameField(Me);
		TempItem:=Ctl2.ListBox_GetSelItem(ActiveCtl);
		If TempItem<>Nil Then
		Begin
			If ActiveCtl=LstFiles1
				Then TempName:=Cur_Dir1
				Else TempName:=Cur_Dir2;
			TempName:=TempName+'\'+String(TempItem^.Name^);
			Kernel.RunChild2(Me, 'FPropDlg', TempName)
		End
	End
End;





Function OnInpRenameChange(Me:PProg; Control:PControl; Ch:String): String;
Begin
	With Me^, TFiler(Data^) Do
		Case Ch[1] Of
			#13: RenameResult:=rrOK;
			#27: RenameResult:=rrCancel;
			Else OnInpRenameChange:=Ch
		End
End;

Procedure OnRenameClick(Me:PProg; Control:PControl);
Var
	TempItem: PListItem;
Begin
	With Me^, TFiler(Data^) Do
	Begin
		If InpRename<>Nil Then Exit;
		If Ctl2.ListBox_GetSelItemIndex(ActiveCtl)=0 Then Exit;

		ActivePanel:=ActiveCtl;
		Ctl2.ListBox_ScrollToViewSelItem(ActiveCtl);
		Ctl2.ListBox_GetSelItemRect(ActiveCtl, RenameRect);
		Dec(RenameRect.Y1, ClientRect.Y1+2);
		Dec(RenameRect.X1, ClientRect.X1-17);
		Dec(RenameRect.X2, ClientRect.X1+1);
		TempItem:=Ctl2.ListBox_GetSelItem(ActiveCtl);
		InpRename:=Ctl.InpLine_Create(Me, String(TempItem^.Name^),
			TempItem^.Icon);
		Ctl.InpLine_SetOnChangeFunc(InpRename, OnInpRenameChange);
		RenameResult:=rrNone;
		Ctl.TimerCtl_SetActive(TimWork, True);

		Kernel.PaintWindow(Me)
	End
End;

Procedure OnMkDirClick(Me:PProg; Control:PControl);
Var
	CurPath: String;
	CurLabel: PControl;
Begin
	With Me^, TFiler(Data^) Do
	Begin
		If ActiveCtl=LstFiles1 Then
		Begin
			CurPath:=Cur_Dir1;
			CurLabel:=LabPath1
		End
		Else Begin
			CurPath:=Cur_Dir2;
			CurLabel:=LabPath2
		End;
		{LFN.LFNMkDir(CurPath+'\ ');}
		MkDir(CurPath+'\Folder');
		Fill_ListBox(Me, ActiveCtl, CurLabel, CurPath, 'Folder', jdNone);
		OnRenameClick(Me, BtnRename)
	End
End;

{==============================================================================}
Procedure fill_listbox(ME:PProg; Var Lst,Lab:Pcontrol;
	cur_dir,LastDir:String; JumpDir:TJumpDir);
var
	SR: SearchRec;
	TempRect: TRect;
	ShortName : String;
	Res: Integer;
	TempIcon: Pointer;
Begin
	With Me^, TFiler(Data^), ClientRect do
	Begin
			{ eye candy :) }
		If Not Kernel.IgnoreAutoRedraw Then
		Begin
			Ctl2.ListBox_GetSelItemRect(Lst, TempRect);
			If D.InRect(Kernel.MsX, Kernel.MsY, TempRect) Then
				D.AssignRect(Kernel.MsX-2, Kernel.MsY-2,
					Kernel.MsX+2, Kernel.MsY+2, TempRect);
			Case JumpDir Of
				jdForward: Gfx.ZoomRect(TempRect, Lst^.Place);
				jdBack: Gfx.ZoomRect(Lst^.Place, TempRect);
			End
		End;

		Ctl2.ListBox_Clear(Lst);
		FindFirst(cur_dir+'\*.*', AnyFile xor VolumeId, SR);
		While DOSError=0 Do
		Begin
			If SR.Name[1]<>'.' Then
			Begin
				ShortName:=D.NormLine(SR.Name);
				{ShortName:=SR.AltName;
				if ShortName='' then ShortName:=LongName;}

				If (SR.Attr And Directory)=0 Then
				Begin { 䠩 }
					Ctl2.ListBox_AddItemLast(Lst, ShortName,
						Kernel.GetFileIcon(ShortName), 0);
					Ctl2.ListBox_AddSubItem(Lst, D.NormNum(D.StL(SR.Size)), Nil)
				End
				Else {  }
					Ctl2.ListBox_AddItemFirst(Lst, ShortName, PicFolder, 0)
			End;
			FindNext(SR)
		End;

		Ctl2.ListBox_Sort(Lst);
		If Length(Cur_Dir)>2 Then
			Ctl2.ListBox_AddItemFirst(Lst, '..', PicUp, 0);
		If LastDir=''
			Then Ctl2.ListBox_SelectItem(Lst, 1)
			Else Ctl2.ListBox_SelectItem(Lst,
				Ctl2.ListBox_FindItem(Lst, LastDir));

		If Not Kernel.IgnoreAutoRedraw Then
			{Kernel.PaintWindow(Me)}
			Ctl2.ListBox_Draw(Lst)
	End
End;
{==============================================================================}
Procedure open_PbtDrive1 (Me:PProg; Item:PMenuItem);
Begin
	With Me^, TFiler(Data^) Do
	begin
		Button_SetCapAndPic(PopupBtn_AsButton(PbtDrive1),
			Copy(String(Item^.Name^), 1, 2), Item^.Icon);
		{Button_SetPicture(PopupBtn_AsButton(PbtDrive1), Item^.Icon);}
		cur_dir1:=Copy(String(Item^.Name^), 1, 2);
		Ctl.Label_SetCaption(LabPath1, Cur_Dir1+'\*.*');
		fill_listbox(Me, LstFiles1, LabPath1, cur_dir1, '', jdNone);
	End
End;

Procedure open_PbtDrive2 (Me:PProg; Item:PMenuItem);
Begin
	With Me^, TFiler(Data^) do
	Begin
		Button_SetCapAndPic(PopupBtn_AsButton(PbtDrive2),
			Copy(String(Item^.Name^), 1, 2), Item^.Icon);
		{Button_SetPicture(PopupBtn_AsButton(PbtDrive2), Item^.Icon);}
		cur_dir2:=Copy(String(Item^.Name^), 1, 2);
		Ctl.Label_SetCaption(LabPath2, Cur_Dir2+'\*.*');
		fill_listbox(Me, LstFiles2, LabPath2, cur_dir2, '', jdNone);
	End
End;

{==============================================================================}
{==============================================================================}
Procedure ReadDir(Me:PProg; Var Lst,Lab:PControl; Var cur_dir:String);
Var
	FName: String;
	FTypePic: Pointer;
	I: Integer;
	RName: String;
	TempJumpDir: TJumpDir;
	TempName: String;
	LastDir: String;
Begin
	With Me^, TFiler(Data^),ClientRect do
	Begin
		RName:=String((Ctl2.ListBox_GetSelItem(Lst))^.Name^);
		FTypePic:=Ctl2.ListBox_GetSelItem(Lst)^.Icon;

		If (FTypePic<>PicFolder) And (FTypePic<>PicUp) then
		Begin { file clicked, execute it }
			TempName:=Ctl.Label_GetCaption(Lab);
			TempName:=Copy(TempName, 1, Length(TempName)-3);
			TempName:=TempName+RName;
			Kernel.RunFile(TempName);
			Exit
		End;

		If (FTypePic=PicFolder) And (RName<>'..') Then
		Begin { folder clicked }
			LastDir:='';
			cur_dir:=cur_dir+'\'+rname;
			TempJumpDir:=jdForward
		End
		Else Begin { ".." clicked }
			(* cur_dir:=D.ClipFPath(cur_dir+'.tmp'); { 㬭 :) | 祭 - Iv :) } *)
			LastDir:=D.LastPathItem(Cur_Dir);
			Cur_Dir:=D.DropLastPathItem(Cur_Dir);
			if cur_dir[length(cur_dir)]='\' then delete(cur_dir, length(cur_dir), 1);
			log.msg ('filer','cd ..',cur_dir+'\*.*');
			TempJumpDir:=jdBack
		End;

		Ctl.Label_SetCaption(Lab, cur_dir+'\*.*');
		fill_listbox(Me, Lst, Lab, cur_dir, LastDir, TempJumpDir)
	End
end;
{==============================================================================}
{==============================================================================}
Procedure OnFileSelect(Me:PProg; Control:PControl);
Begin
	With Me^, TFiler(Data^) Do
	Begin
		If ActiveCtl=LstFiles1 Then
			ReadDir (Me, LstFiles1, LabPath1, cur_dir1);
		If ActiveCtl=LstFiles2 Then
			ReadDir (Me, LstFiles2, LabPath2, cur_dir2);
	End
End;
{==============================================================================}
Procedure Filer_OnClose(Me:PProg);
Begin
	With Me^, TFiler(Data^) Do
	Begin
			{ ॣ ⠭  Ini-䠩i }
		If IOresult=IOResult Then ; { ᭮, ? }
		Ini.Load('prog\filer\filer.ini');
		Ini.Select('prog\filer\filer.ini', 'Filer');
		Ini.SetStr('LeftPath', Cur_Dir1);
		Ini.SetStr('RightPath', Cur_Dir2);
		With ClientRect Do
			Ini.SetInt('SplitterPos', Ctl.Splitter_GetCoord(SplTest));
		If ActiveCtl=LstFiles1
			Then Ini.SetStr('ActivePanel', 'Left')
			Else Ini.SetStr('ActivePanel', 'Right');
		Ini.SaveCurFile;
		Ini.FreeFile('prog\filer\filer.ini');
		Ini.SelectFile('polit.ini')
	End;

	Kernel.FreeRes('folder.bmp');
	Kernel.FreeRes('file.bmp');
	Kernel.FreeRes('up.bmp');
	Kernel.FreeRes('d_floppy.bmp');
	Kernel.FreeRes('d_fixed.bmp');
	Kernel.FreeRes('d_cdrom.bmp');
	Kernel.FreeRes('b_rename.bmp');
	Kernel.FreeRes('b_copy.bmp');
	Kernel.FreeRes('b_move.bmp');
	Kernel.FreeRes('b_new_f.bmp');
	Kernel.FreeRes('b_erase.bmp');
	FreeMem(Me^.Data, SizeOf(TFiler))
End;
{==============================================================================}
Procedure Filer_OnListBoxHint(Me:PProg; Control:PControl; Item:PListItem);
Begin
	With Me^, TFiler(Data^) Do
		If Item<>Nil Then
		Begin
			If Item^.Icon=PicFolder
				Then D.ReassignPStr(String(Item^.Name^)+#13+'', Control^.Hint)
				Else If Item^.Icon=PicUp
					Then D.ReassignPStr('  । ', Control^.Hint)
					Else D.ReassignPStr(String(Item^.Name^)+#13+
						Kernel.GetFileDescr(String(Item^.Name^))+#13+
						String(Item^.SubItem^.Name^)+' ', Control^.Hint)
		End
		Else D.ReassignPStr('', Control^.Hint)
End;

{==============================================================================}
Function MySortFunc(Me:PProg; Item1,Item2:PListItem): Boolean;
Begin
	With Me^, TFiler(Data^) Do
		If (Item1^.Icon=PicFolder) And (Item2^.Icon<>PicFolder)
			Then MySortFunc:=True
			Else If (Item1^.Icon<>PicFolder) And (Item2^.Icon=PicFolder)
				Then MySortFunc:=False
				Else If D.UpCaseLine(String(Item1^.Name^))<
					D.UpCaseLine(String(Item2^.Name^))
					Then MySortFunc:=True
					Else MySortFunc:=False
End;
{==============================================================================}
Procedure make_drives_menus (me : Pprog);
Var
	Letter: Char;
	FirstCD: Char;
	CurCD: Byte;
	TempLabel: String;
Begin
	With Me^, TFiler(Data^) Do
	Begin
		MnuDisks1:=Popup.CreateMenu;
		MnuDisks2:=Popup.CreateMenu;
		For Letter:='A' To 'Z' Do
			Case D.GetDriveType(Letter) Of
				dtFloppy: Begin
					Popup.AddCommand(MnuDisks1, Letter+':', '', '',
						PicFloppy, True, Open_PbtDrive1);
					Popup.AddCommand(MnuDisks2, Letter+':', '', '',
						PicFloppy, True, Open_PbtDrive2);
				End;
				dtFixed: Begin
					TempLabel:=D.GetVolumeLabel(Letter);
					Popup.AddCommand(MnuDisks1, Letter+': '+TempLabel, '', '',
						PicFixed, True, Open_PbtDrive1);
					Popup.AddCommand(MnuDisks2, Letter+': '+TempLabel, '', '',
						PicFixed, True, Open_PbtDrive2)
				End
			End;

			{ ६  ᪮ CD-ROM }
		FirstCD:=D.GetFirstCDDrive;
		For CurCD:=1 To D.GetCDDrivesNum Do
		Begin
			Letter:=Char(Byte(FirstCD)+CurCD-1);
			Popup.AddCommand(MnuDisks1, Letter+':', '', '',
				PicCD, True, Open_PbtDrive1);
			Popup.AddCommand(MnuDisks2, Letter+':', '', '',
				PicCD, True, Open_PbtDrive2)
		End
	End
End;



Procedure OnFileListMenu(Me:PProg;Control:PControl);
Var
	SelItem:PListItem;
	ProgName:String;
Begin
	With Me^, TFiler(Data^) Do
		Popup.OpenMenu(Me, MnuContext, Kernel.MsX, Kernel.MsY)
End;


Procedure OnContextMenuClick(Me:PProg; Item:PMenuItem);
Var
	SelItem:PListItem;
Begin
	With Me^, TFiler(Data^) Do
	Begin
		If String(Item^.Name^)='i' Then OnFileSelect(Me, ActiveCtl);
		If String(Item^.Name^)='⨢i...' Then OnPropsClick(Me, Nil);
		If String(Item^.Name^)='i㢠' Then OnRenameClick(Me, BtnRename);
		If String(Item^.Name^)='i' Then OnCopyClick(Me, BtnCopy);
		If String(Item^.Name^)='७' Then OnMoveClick(Me, BtnMove);
		If String(Item^.Name^)='⢮ ' Then OnMkDirClick(Me, BtnMkDir);
		If String(Item^.Name^)='' Then OnDeleteClick(Me, BtnDelete);
	End
End;



Procedure MakeContextMenu(Me:PProg);
Begin
	With Me^, TFiler(Data^) Do
	Begin
		MnuContext:=Popup.CreateMenu;
		Popup.AddCommand(MnuContext, 'i', 'Enter', '', Nil,
			True, OnContextMenuClick);
		Popup.AddCommand(MnuContext, '⨢i...', '', '', Nil,
			True, OnContextMenuClick);
		Popup.AddSpace(MnuContext);
		Popup.AddCommand(MnuContext, 'i㢠', 'F2', '', PicRename,
			True, OnContextMenuClick);
		Popup.AddCommand(MnuContext, 'i', 'F5', '', PicCopy,
			True, OnContextMenuClick);
		Popup.AddCommand(MnuContext, '७', 'F6', '', PicMove,
			True, OnContextMenuClick);
		Popup.AddCommand(MnuContext, '⢮ ', 'F7', '', PicMkDir,
			True, OnContextMenuClick);
		Popup.AddCommand(MnuContext, '', 'F8', '', PicDelete,
			True, OnContextMenuClick)
	End
End;

{==============================================================================}
{==============================================================================}
Procedure reread_panels(Me:PProg);
begin
	With Me^,TFiler(Data^) Do
	Begin
		fill_listbox(ME,LstFiles1, LabPath1, cur_dir1, '', jdNone);
		fill_listbox(ME,LstFiles2, LabPath2, cur_dir2, '', jdNone)
	End
End;
{==============================================================================}
{==============================================================================}
{==============================================================================}




Function Filer_OnKey(Me:PProg; C1,C2:Char): Boolean;
Begin
	Filer_OnKey:=False;
	With TFiler(Me^.Data^) Do
		If C1=#0 Then
			Case C2 Of
				#60: Begin
					Kernel.ClickCtl(Me, BtnRename);
					Filer_OnKey:=True
				End;
				#63: Begin
					Kernel.ClickCtl(Me, BtnCopy);
					Filer_OnKey:=True
				End;
				#64: Begin
					Kernel.ClickCtl(Me, BtnMove);
					Filer_OnKey:=True
				End;
				#65: Begin
					Kernel.ClickCtl(Me, BtnMkDir);
					Filer_OnKey:=True
				End;
				#66: Begin
					Kernel.ClickCtl(Me, BtnDelete);
					Filer_OnKey:=True
				End;

				#104: Begin { Alt+F1 }
					Kernel.ClickCtl(Me, Ctl.PopupBtn_AsButton(PbtDrive1));
					Filer_OnKey:=True
				End;
				#105: Begin { Alt+F2 }
					Kernel.ClickCtl(Me, Ctl.PopupBtn_AsButton(PbtDrive2));
					Filer_OnKey:=True
				End;
			End
End;

Function Filer_OnMessage(Me, Sender:PProg; VMsg:String; VData:Pointer): Pointer;
Var
	TempName: String;
Begin
	With Me^, TFiler(Data^) Do
	Begin
		If VMsg='FilePropsChanged' Then
		Begin
			{TempName:=String(Ctl2.ListBox_GetSelItem(ActiveCtl)^.Name^);}
			TempName:=D.LastPathItem(String(VData^));
			If ActiveCtl=LstFiles1
				Then Fill_ListBox(Me, LstFiles1, LabPath1, Cur_Dir1, TempName, jdNone)
				Else Fill_ListBox(Me, LstFiles2, LabPath2, Cur_Dir2, TempName, jdNone)
		End;
	End
End;



{==============================================================================}
{==============================================================================}
{==============================================================================}
{==============================================================================}

{==============================================================================}




Procedure Filer_OnInit(Me:PProg);
Var
	SR: SearchRec;
	SplitterPos: Integer;
	ActPanel: String;
Begin
	op_error:=0;
	With Me^ Do
	Begin
		D.AssignPStr('Filer - Polit file manager v0.3 '+String(Param^),WinTitle);
		MinX:=400;
		MinY:=190;
		OnPaint:=Filer_OnPaint;
		OnMessage:=Filer_OnMessage;
		OnClose:=Filer_OnClose;
		OnKey:=Filer_OnKey;
		GetMem(Data,SizeOf(TFiler));
		Kernel.InitWindow(Me,'BlueWin', [wbMin, wbMax, wbClose]);
		WinBG:=bgManual;
		Kernel.DrawWindowAni(Me);
		

		With TFiler(Data^) Do
		Begin
			With WinRect Do
				LastWidth:=X2-X1+1;
			PicFolder:=Kernel.LoadBMPRes('pic\folder.bmp');
			PicFile:=Kernel.LoadBMPRes('pic\file.bmp');
			PicUp:=Kernel.LoadBMPRes('pic\up.bmp');
			PicFloppy:=Kernel.LoadBMPRes('pic\d_floppy.bmp');
			PicFixed:=Kernel.LoadBMPRes('pic\d_fixed.bmp');
			PicCD:=Kernel.LoadBMPRes('pic\d_cdrom.bmp');
			PicRename:=Kernel.LoadBMPRes('pic\b_rename.bmp');
			PicCopy:=Kernel.LoadBMPRes('pic\b_copy.bmp');
			PicMove:=Kernel.LoadBMPRes('pic\b_move.bmp');
			PicMkDir:=Kernel.LoadBMPRes('pic\b_new_f.bmp');
			PicDelete:=Kernel.LoadBMPRes('pic\b_erase.bmp');

				{ ⠦ ⠭  Ini-䠩 }
			Ini.Load('prog\filer\filer.ini');
			Ini.Select('prog\filer\filer.ini', 'Filer');
			Ini.UpCaseNeeded:=False;
			Cur_Dir1:=Ini.GetStr('LeftPath', 'C:');
			Cur_Dir2:=Ini.GetStr('RightPath', 'C:');
			Ini.UpCaseNeeded:=True;
			With ClientRect Do
				SplitterPos:=Ini.GetInt('SplitterPos', (X2-X1) Div 2);
			LastSplitterPos:=SplitterPos;
			ActPanel:=Ini.GetStr('ActivePanel', 'Right');
			Ini.FreeFile('prog\filer\filer.ini');
			Ini.SelectFile('polit.ini');

			make_drives_menus(Me);
			MakeContextMenu(Me);

				{============= panel1===================}
			LstFiles1:=Ctl2.ListBox_Create(Me, True);
			Ctl2.ListBox_SetOnStrongSelect(LstFiles1, OnFileSelect);
			Ctl2.ListBox_SetOnContextMenu(LstFiles1, OnFileListMenu);
			Ctl2.ListBox_SetOnHint(LstFiles1, Filer_OnListBoxHint);
			LstFiles1^.AutoRedraw:=False;
			Ctl2.ListBox_SetSortFunc(LstFiles1, MySortFunc);
			Ctl2.ListBox_SetColumnProps(LstFiles1, 2, lcRightMono, True);

			LabPath1:=Ctl.Label_Create(Me, Cur_Dir1+'\*.*', PicFolder,
				lsBeveled, alCenter);

			{cur_dir1:='C:';}
			fill_listbox(me, LstFiles1, LabPath1, cur_dir1, '', jdNone);
			Ctl2.ListBox_SelectItem(LstFiles1, 1);

			PbtDrive1:=Ctl.PopupBtn_Create(Me, Cur_Dir1[1]+':', MnuDisks1, PicFixed,
				ppLeft);
			D.ReassignPStr('Drive select', PbtDrive1^.Hint);
			PopupBtn_AsButton(PbtDrive1)^.FocusCtl:=Nil;


				{============= panel2===================}
			LstFiles2:=Ctl2.ListBox_Create(Me, True);
			Ctl2.ListBox_SetOnStrongSelect(LstFiles2, OnFileSelect);
			Ctl2.ListBox_SetOnContextMenu(LstFiles2, OnFileListMenu);
			Ctl2.ListBox_SetOnHint(LstFiles2, Filer_OnListBoxHint);
			LstFiles2^.AutoRedraw:=False;
			Ctl2.ListBox_SetSortFunc(LstFiles2, MySortFunc);
			Ctl2.ListBox_SetColumnProps(LstFiles2, 2, lcRightMono, True);

			{cur_dir2:='C:';}
			LabPath2:=Ctl.Label_Create(Me, Cur_Dir2+'\*.*', PicFolder, lsBeveled, alCenter);

			fill_listbox(me,LstFiles2,LabPath2,cur_dir2,'',jdNone);
			Ctl2.ListBox_SelectItem(LstFiles2, 1);

			PbtDrive2:=Ctl.PopupBtn_Create(Me, Cur_Dir2[1]+':', MnuDisks2, PicFixed,
				ppLeft);
			D.ReassignPStr('Drive select', PbtDrive2^.Hint);
			PopupBtn_AsButton(PbtDrive2)^.FocusCtl:=Nil;



								{======================== op buttons ====================}
			{ View F2-Rename F5-Copy F6-Move F7-MkDir F8-Delete }

			BtnView:=Ctl.Button_Create(Me, 'Open', nil, ppLeft,
				{OnViewClick}OnFileSelect);
			D.ReassignPStr('View/Edit selected file', BtnView^.Hint);
			BtnView^.FocusCtl:=Nil;

			BtnRename:=Ctl.Button_Create(Me, 'Rename', PicRename, ppLeft,
				OnRenameClick);
			D.ReassignPStr('Rename selected item', BtnRename^.Hint);
			BtnRename^.FocusCtl:=Nil;

			BtnCopy:=Ctl.Button_Create(Me, 'Copy', PicCopy, ppLeft,
				OnCopyClick);
			D.ReassignPStr('Copy selected items(s) to new destination', BtnCopy^.Hint);
			BtnCopy^.FocusCtl:=Nil;

			BtnMove:=Ctl.Button_Create(Me, 'Move', PicMove, ppLeft,
				OnMoveClick);
			D.ReassignPStr('Move selected item(s)', BtnMove^.Hint);
			BtnMove^.FocusCtl:=Nil;

			BtnMkDir:=Ctl.Button_Create(Me, 'MkDir', PicMkDir, ppLeft,
				OnMkDirClick);
			D.ReassignPStr('Create new folder', BtnMkDir^.Hint);
			BtnMkDir^.FocusCtl:=Nil;

			BtnDelete:=Ctl.Button_Create(Me, 'Delete', PicDelete, ppLeft,
				OnDeleteClick);
			D.ReassignPStr('Delete selected item(s)', BtnDelete^.Hint);
			BtnDelete^.FocusCtl:=Nil;


			TimWork:=Ctl.TimerCtl_Create(Me, 1, False, OnWorkTimer);
			ProStatus:=Ctl.Progress_Create(Me, 0, 10, 0, pkDeterm);

			InpRename:=Nil;

			With ClientRect Do
				SplTest:=Ctl.Splitter_Create(Me, SplitterPos, orVertical, saNone);
			SplTest^.FocusCtl:=Nil;

			If ActPanel='RIGHT'
				Then ActiveCtl:=LstFiles2
				Else ActiveCtl:=LstFiles1;
			ButtonEnter:=BtnView
		End
	End
End;


Begin
	Kernel.RegBuiltIn('Filer', '-', 'pic\i_filer.bmp', Filer_OnInit)
End.
