{$F+}
Unit
	Navi; { Polit Halcyon Navi application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Gfx, DOS, Ini, Popup;

Const
	MaxBackItemsNum=10;
	MaxFavNum=10;

Type
	TInfo=Record
		Path:String;
		Part:Real;
		SR:SearchRec;
		DirsLeft:Integer;
		NextPart:Real;
		{X,Y:Integer;}
		Result:Integer;
		HaveSubs:Boolean;
		ToDo:(BeginScan, ContinueScan);
	End;

	TNaviData=Record
		TabPages, BtnClose, LstFiles, LstSearch, LstHistory: PControl;
		NavCtl: Array[1..30] Of PControl;
		NavCtlNum: Integer;
		Path: String;
		PicComp, PicUp, PicFolder, PicFile: Pointer;
		PicFloppy, PicHDD, PicCD: Pointer;
		PicSearch: Pointer;
		PicBack, PicFavorites: Pointer;
		PicGo, PicStop: Pointer;
		BtnBack, BtnFavorites: PControl;
		Back: Array[1..MaxBackItemsNum] Of Record
			Name, FullPath: PStr;
			Icon: Pointer
		End;
		BackItemsNum: Integer;
		MnuBack, MnuFavorites: PMenuItem;
		Drives: Array['A'..'Z'] Of TDriveType;
		InpSearch, BtnSearch, BtnStopSearch, ProSearch: PControl;

		Dir: String;
		FileName: String;
		Percent: Real;
		Level: Integer;
		Info: Array[1..24] Of TInfo;
		FoundNum: LongInt;

		Fav: Array[1..MaxFavNum] Of Record
			Name, FullPath: String;
			Times: Integer;
		End;
		FavNum, MinTimes: Integer;
	End;


Implementation

Procedure SetVisibility(Me:PProg);
Var
	Flag: Boolean;
	I: Integer;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
			{ page 1 - files }
		Flag:=(Ctl.TabSet_GetActiveTab(TabPages)=1);
		BtnBack^.Visible:=Flag;
		BtnFavorites^.Visible:=Flag;
		For I:=1 To NavCtlNum Do
			NavCtl[I]^.Visible:=Flag;
		LstFiles^.Visible:=Flag;
			{ page 2 - search }
		Flag:=(Ctl.TabSet_GetActiveTab(TabPages)=2);
		InpSearch^.Visible:=Flag;
		BtnSearch^.Visible:=Flag;
		BtnStopSearch^.Visible:=Flag;
		ProSearch^.Visible:=Flag;
		LstSearch^.Visible:=Flag;
			{ page 3 - history }
		Flag:=(Ctl.TabSet_GetActiveTab(TabPages)=3);
		LstHistory^.Visible:=Flag;
	End;
	If Not Kernel.IgnoreAutoRedraw Then
		Kernel.PaintWindow(Me)
End;

Procedure OnPaint(Me:PProg);
Var
	I: Integer;
Begin
	With Me^, ClientRect, TNaviData(Data^) Do
	Begin
		If X1>=X2 Then Exit; {   }

		Ctl.TabSet_Paint(TabPages, 0, 2, X2-X1-3, Y2-Y1-29);
			{ page 1 - computer }
		Ctl.Button_Paint(BtnBack, 1, 28, 35);
		Ctl.Button_Paint(BtnFavorites, 40, 28, 74);
		For I:=1 To NavCtlNum-1 Do
		Begin
			{NavCtl[I].Visible:=True;} {!}
			Ctl.Button_Paint(NavCtl[I], 1+(I-1)*4, 55+(I-1)*22,
				X2-X1-4-(NavCtlNum-I)*4)
		End;
		Ctl.Label_Paint(NavCtl[NavCtlNum], 1+(NavCtlNum-1)*4, 55+(NavCtlNum-1)*22, X2-X1-4);
		Ctl2.ListBox_Paint(LstFiles, 1, 58+NavCtlNum*22, X2-X1-4, Y2-Y1-30);
			{ page 2 - search }
		Ctl.InpLine_Paint(InpSearch, 1, 28, X2-X1-5);
		Ctl.Button_Paint(BtnSearch, 1, 55, X2-X1-35);
		Ctl.Button_Paint(BtnStopSearch, X2-X1-30, 55, X2-X1-5);
		Ctl.Progress_Paint(ProSearch, 1, 80, X2-X1-5);
		Ctl2.ListBox_Paint(LstSearch, 1, 110, X2-X1-5, Y2-Y1-30);
			{ page 3 - history }
		Ctl2.ListBox_Paint(LstHistory, 1, 55, X2-X1-5, Y2-Y1-30);

			{ out of notebook }
		Ctl.Button_Paint(BtnClose, 1, Y2-Y1-24, 100)
	End;
End;

Procedure OnBackItemClick(Me:PProg; Item:PMenuItem); Forward;

Procedure BuildFavsMenu(Me:PProg);
Var
	I: Integer;
	TempIcon: Pointer;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		If MnuFavorites<>Nil Then
			Popup.FreeMenu(MnuFavorites);
		MnuFavorites:=Popup.CreateMenu;
		For I:=1 To FavNum Do
			With Fav[I] Do
			Begin
				If Name=''''
				Then TempIcon:=PicComp
				Else Begin
					TempIcon:=PicFolder;
					If Length(Name)=2 Then
						If Name[2]=':'
							Then Case Drives[Name[1]] Of
								dtFloppy: TempIcon:=PicFloppy;
								dtFixed: TempIcon:=PicHDD;
								dtCDROM: TempIcon:=PicCD
							End
				End;
				Popup.AddCommand(MnuFavorites, Name, '', FullPath,
					TempIcon, True, OnBackItemClick)
			End;
		If FavNum>0 Then
		Begin
			BtnFavorites^.Enabled:=True;
			If Not Kernel.IgnoreAutoRedraw Then
				Ctl.Button_Draw(BtnFavorites)
		End
	End
End;

Procedure AddFolderToHistory(Me:PProg; VName,VFullPath:String);
Var
	TempIcon: Pointer;
	Hour, Min, Sec, Sec100: Word;
	TempItem: PListItem;
	I, TempN, TempTimes: Integer;
	Finished, FavsAltered: Boolean;
	TempFullPath: String;

	Function FindFav(VName,VFullPath:String): Integer;
	Var
		I: Integer;
	Begin
		FindFav:=0;
		With TNaviData(Me^.Data^) Do
			For I:=1 To FavNum Do
				With Fav[I] Do
					If (Name=VName) And (FullPath=VFullPath) Then
						FindFav:=I
	End;

	Procedure DelUnpopular;
	Var
		I: Integer;
	Begin
		With TNaviData(Me^.Data^) Do
		Begin
			I:=1;
			Repeat
				If Fav[I].Times<MinTimes Then
				Begin {  }
					Fav[I]:=Fav[FavNum];
					Dec(FavNum)
				End
				Else Inc(I)
			Until I>FavNum
		End
	End;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
			{    㦥  ᯨ᪠ -   }
		TempItem:=Ctl2.ListBox_GetItemByIndex(LstHistory, 1);
		If Not ((String(TempItem^.SubItem^.SubItem^.Name^)=VFullPath) And
			(String(TempItem^.Name^)=VName)) Then
		Begin { i -  }
			If VName=''''
				Then TempIcon:=PicComp
				Else Begin
					TempIcon:=PicFolder;
					If Length(VName)=2 Then
						If VName[2]=':'
							Then Case Drives[VName[1]] Of
								dtFloppy: TempIcon:=PicFloppy;
								dtFixed: TempIcon:=PicHDD;
								dtCDROM: TempIcon:=PicCD
							End
				End;
			{LstHistory^.AutoRedraw:=False;} {     祭 }
			Ctl2.ListBox_AddItemFirst(LstHistory, VName, TempIcon, 0);
			DOS.GetTime(Hour, Min, Sec, Sec100);
			Ctl2.ListBox_AddSubItem(LstHistory, D.St2(Hour)+':'+D.St2(Min), Nil);
			{LstHistory^.AutoRedraw:=True;} {  i ॡ ஡ ᠬ ⠪ }
			Ctl2.ListBox_AddSubItem(LstHistory, VFullPath, Nil)
		End;

			{      ? }
		If VName=''''
			Then TempFullPath:=''
			Else Begin
				TempFullPath:=VFullPath+'\'+VName;
				If Length(VName)=2
					Then If VName[2]=':'
						Then TempFullPath:=VName
			End;

		TempN:=FindFav(VName, TempFullPath);
		If TempN=0 Then
		Begin {  - 㢠 室  Ii }
			TempItem:=Ctl2.ListBox_GetItemByIndex(LstHistory, 1);
			TempTimes:=0;
			While TempItem<>Nil Do
			Begin
				If (String(TempItem^.Name^)=VName) And
					(String(TempItem^.SubItem^.SubItem^.Name^)=VFullPath) Then
					Inc(TempTimes);
				TempItem:=TempItem^.Next
			End;
				{ i , 鮡 ࠯  i? }
			Finished:=False;
			FavsAltered:=False;
			While (TempTimes>=MinTimes) And Not Finished Do
			Begin
				If FavNum=MaxFavNum Then
				Begin { ᯨ᮪  }
					If TempTimes>MinTimes Then
					Begin { i ᮪,    嫠 }
						Inc(MinTimes);
						DelUnpopular;
						FavsAltered:=True
					End
					Else { i , i }
						Finished:=True
				End
				Else Begin {  i,  }
					Inc(FavNum);
					Fav[FavNum].Name:=VName;
					Fav[FavNum].FullPath:=TempFullPath;
					Fav[FavNum].Times:=TempTimes;
					Finished:=True;
					FavsAltered:=True
				End
			End;
			If FavsAltered Then
				BuildFavsMenu(Me)
		End
		Else {  - i  i }
			Inc(Fav[TempN].Times)
	End;
End;

Procedure AddFileToHistory(Me:PProg; VName,VFullPath:String);
Var
	Hour, Min, Sec, Sec100: Word;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		{LstHistory^.AutoRedraw:=False;} {     祭 }
		Ctl2.ListBox_AddItemSecond(LstHistory, VName,
			Kernel.GetFileIcon(VName), 8);
		DOS.GetTime(Hour, Min, Sec, Sec100);
		Ctl2.ListBox_AddSubItem(LstHistory, D.St2(Hour)+':'+D.St2(Min), Nil);
		{LstHistory^.AutoRedraw:=True;} {  i ॡ ஡ ᠬ ⠪ }
		Ctl2.ListBox_AddSubItem(LstHistory, VFullPath, Nil)
	End
End;




Procedure AddToBackMenu(Me:PProg; VIcon:Pointer; VName,VFullPath:String);
Var
	Found: Boolean;
	I: Integer;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
			{   "ii" }
		Found:=False;
		For I:=1 To BackItemsNum Do
			If String(Back[I].FullPath^)=VFullPath Then
				Found:=True;
		If Not Found Then
		Begin {    ୮ }
			If BackItemsNum>0 Then
				Popup.FreeMenu(MnuBack);
			MnuBack:=Popup.CreateMenu;
			BtnBack^.Enabled:=True;
			If BackItemsNum=MaxBackItemsNum Then
			Begin
				D.FreePStr(Back[1].Name, 'Navi - Scrolling back menu (Name)');
				D.FreePStr(Back[1].FullPath, 'Navi - Scrolling back menu (FullPath)');
				For I:=1 To MaxBackItemsNum-1 Do
					Back[I]:=Back[I+1]
			End
			Else
				Inc(BackItemsNum);
			D.AssignPStr(VName, Back[BackItemsNum].Name);
			D.AssignPStr(VFullPath, Back[BackItemsNum].FullPath);
			Back[BackItemsNum].Icon:=VIcon;
			For I:=BackItemsNum DownTo 1 Do
				With Back[I] Do
					Popup.AddCommand(MnuBack, String(Name^), '',
						String(FullPath^), Icon, True, OnBackItemClick)
		End
	End
End;


Function MySortFunc(Me:PProg; Item1,Item2:PListItem): Boolean;
Begin
	With Me^, TNaviData(Data^) Do
		If (Item1^.Icon=PicFolder) And (Item2^.Icon<>PicFolder)
			Then MySortFunc:=True
			Else If (Item1^.Icon<>PicFolder) And (Item2^.Icon=PicFolder)
				Then MySortFunc:=False
				Else If String(Item1^.Name^)<String(Item2^.Name^)
					Then MySortFunc:=True
					Else MySortFunc:=False
End;

Procedure RefreshFilesList(Me:PProg);
Var
	SR: SearchRec;
	DT: DateTime;
	Letter: Char;
	FirstCD: Char;
	CurCD: Byte;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		Ctl2.ListBox_Clear(LstFiles);
		If Path='' Then
		Begin { "`" - ᯨ᮪ i }
			For Letter:='A' To 'Z' Do
				Case Drives[Letter] Of
					dtFloppy: Ctl2.ListBox_AddItemLast(LstFiles, Letter+':', PicFloppy, 0);
					dtFixed: Begin
						Ctl2.ListBox_AddItemLast(LstFiles, Letter+':', PicHDD, 0);
						{Ctl2.ListBox_AddSubItem(LstFiles,
							D.NormLine(D.GetVolumeLabel(Letter)), Nil)}
					End;
					dtCDROM: Ctl2.ListBox_AddItemLast(LstFiles, Letter+':', PicCD, 0);
				End;
			If Not Kernel.IgnoreAutoRedraw Then
				Ctl2.ListBox_Draw(LstFiles)
		End
		Else Begin { 砩  }
			DOS.FindFirst(Path+'\*.*', AnyFile, SR);
			While DOSError=0 Do
			Begin
				If SR.Name[1]<>'.' Then
				Begin
					If (SR.Attr And Directory)<>0 Then
					Begin { folder }
						Ctl2.ListBox_AddItemFirst(LstFiles, D.NormLine(SR.Name),
							PicFolder, 0);
						Ctl2.ListBox_AddSubItem(LstFiles, '', Nil);
						UnpackTime(SR.Time, DT);
						Ctl2.ListBox_AddSubItem(LstFiles, D.St2(DT.Day)+'/'+
							D.St2(DT.Month)+'/'+D.St(DT.Year), Nil)
					End
					Else Begin { file }
						Ctl2.ListBox_AddItemFirst(LstFiles, D.NormLine(SR.Name),
							Kernel.GetFileIcon(SR.Name), 0);
						Ctl2.ListBox_AddSubItem(LstFiles,
							D.NormNum(D.StL(SR.Size)), Nil);
						UnpackTime(SR.Time, DT);
						Ctl2.ListBox_AddSubItem(LstFiles, D.St2(DT.Day)+'/'+
							D.St2(DT.Month)+'/'+D.St(DT.Year), Nil)
					End
				End;
				DOS.FindNext(SR)
			End;
				{ 㢠  䠢i⮬  i ( ।) }
			Ctl2.ListBox_SetSortFunc(LstFiles, MySortFunc);
			Ctl2.ListBox_Sort(LstFiles)
		End;
		Ctl2.ListBox_SelectItem(LstFiles, 1);
		{Log.BugMsg('Navi', 'RefreshFilesList', '');}
		{Ctl2.ListBox_DebugListItems(LstFiles)}
	End
End;


Procedure OnNavBtnClick(Me:PProg; Control:PControl);
Var
	TempName: String;
	TempIcon: Pointer;
	Finished: Boolean;
	LastDir: String;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
			{  i   ᯨ NavCtl }
		Repeat
			Kernel.DestroyCtl(Me, NavCtl[NavCtlNum]);
			Dec(NavCtlNum);
			Finished:=False;
			LastDir:=D.LastPathItem(Path);
			Path:=D.DropLastPathItem(Path)
		Until NavCtl[NavCtlNum]=Control;
			{   , i ⢮  }
		TempName:=Ctl.Button_GetCaption(Control);
		AddFolderToHistory(Me, TempName, D.DropLastPathItem(Path));
		TempIcon:=Ctl.Button_GetPicture(Control);
		Kernel.DestroyCtl(Me, NavCtl[NavCtlNum]);
		NavCtl[NavCtlNum]:=Ctl.Label_Create(Me, TempName, TempIcon,
			lsBeveled, alLeft);
		NavCtl[NavCtlNum]^.CanDraw:=True;
		AddToBackMenu(Me, TempIcon, TempName, Path);
		RefreshFilesList(Me);
		Ctl2.ListBox_SelectItem(LstFiles, Ctl2.ListBox_FindItem(LstFiles, LastDir));
		ActiveCtl:=LstFiles;
		Kernel.PaintWindow(Me)
	End
End;

Procedure ChangeDirTo(Me:PProg; NewPath:String);
Var
	I: Integer;
	NextSlashPos: Byte;
	CurDirName, ParentDir: String;
	TempIcon: Pointer;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		For I:=1 To NavCtlNum Do
			Kernel.DestroyCtl(Me, NavCtl[I]);

		Path:=NewPath;
		NavCtlNum:=1;
		If NewPath<>'' Then
		Begin
			NavCtl[1]:=Ctl.Button_Create(Me, '''', PicComp,
				ppLeft, OnNavBtnClick);
			NavCtl[1]^.FocusCtl:=Nil;
			NavCtl[1]^.CanDraw:=True;
			Repeat
				NextSlashPos:=Pos('\', NewPath);
				If NextSlashPos=0 Then
				Begin
					CurDirName:=NewPath;
					NewPath:=''
				End
				Else Begin
					CurDirName:=Copy(NewPath, 1, NextSlashPos-1);
					Delete(NewPath, 1, NextSlashPos)
				End;
				TempIcon:=PicFolder;
				If Length(CurDirName)=2 Then
					If CurDirName[2]=':'
						Then Case Drives[CurDirName[1]] Of
							dtFloppy: TempIcon:=PicFloppy;
							dtFixed: TempIcon:=PicHDD;
							dtCDROM: TempIcon:=PicCD
						End;
				Inc(NavCtlNum);
				If NextSlashPos=0
					Then NavCtl[NavCtlNum]:=Ctl.Label_Create(Me, CurDirName, TempIcon,
						lsBeveled, alLeft)
					Else NavCtl[NavCtlNum]:=Ctl.Button_Create(Me, CurDirName, TempIcon,
						ppLeft, OnNavBtnClick);
				NavCtl[NavCtlNum]^.FocusCtl:=Nil;
				NavCtl[NavCtlNum]^.CanDraw:=True;
			Until NextSlashPos=0;
			ParentDir:='';
			If Length(NewPath)<>2
				Then If NewPath[2]<>':'
					Then ParentDir:=Copy(Path, 1, Length(Path)-Length(CurDirName)-1)
		End
		Else Begin
			NavCtl[1]:=Ctl.Label_Create(Me, '''', PicComp,
				lsBeveled, alLeft);
			NavCtl[1]^.CanDraw:=True;
			CurDirName:='''';
			ParentDir:=''
		End;
		AddFolderToHistory(Me, CurDirName, ParentDir);
		RefreshFilesList(Me);
		ActiveCtl:=LstFiles;
		Kernel.PaintWindow(Me)
	End
End;

Procedure OnBackItemClick(Me:PProg; Item:PMenuItem);
Begin
	ChangeDirTo(Me, String(Item^.Hint^))
End;


Procedure OnFileSelect(Me:PProg; Control:PControl);
Var
	CurItem: PListItem;
	TempName: String;
	TempIcon: Pointer;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		CurItem:=Ctl2.ListBox_GetSelItem(LstFiles);
		If (CurItem^.Icon=PicComp) Or (CurItem^.Icon=PicFolder) Or
			(CurItem^.Icon=PicFloppy) Or (CurItem^.Icon=PicHDD) Or
			(CurItem^.Icon=PicCD) Then
		Begin {    }
				{  ⠭i  .. }
			TempName:=Ctl.Label_GetCaption(NavCtl[NavCtlNum]);
			TempIcon:=Ctl.Label_GetPicture(NavCtl[NavCtlNum]);
			Kernel.DestroyCtl(Me, NavCtl[NavCtlNum]);
				{ i 쮣 ⢮  .. }
			NavCtl[NavCtlNum]:=Ctl.Button_Create(Me, TempName, TempIcon,
				ppLeft, OnNavBtnClick);
			NavCtl[NavCtlNum]^.FocusCtl:=Nil;
			NavCtl[NavCtlNum]^.CanDraw:=True;
				{ i    鮩 i  }
			Inc(NavCtlNum);
			NavCtl[NavCtlNum]:=Ctl.Label_Create(Me, String(CurItem^.Name^),
				CurItem^.Icon, lsBeveled, alLeft);
			NavCtl[NavCtlNum]^.CanDraw:=True;
			AddFolderToHistory(Me, String(CurItem^.Name^), Path);

			If Path=''
				Then Path:=String(CurItem^.Name^)
				Else Path:=Path+'\'+String(CurItem^.Name^);

				{   "ii" }
			AddToBackMenu(Me, CurItem^.Icon, String(CurItem^.Name^), Path);
				{  ᯨ᮪ }
			RefreshFilesList(Me);
			ActiveCtl:=LstFiles;
			Kernel.PaintWindow(Me);
		End
		Else Begin { 䠩 - i }
			AddFileToHistory(Me, String(CurItem^.Name^), Path);
			Kernel.RunFile(Path+'\'+String(CurItem^.Name^))
		End
	End
End;

Procedure OnFileListHint(Me:PProg; Control:PControl; Item:PListItem);
Var
	TempHint: String;
Begin
	With Me^, TNaviData(Data^) Do
		If Item<>Nil Then
		Begin
			{PicComp, PicUp, PicFolder, PicFile: Pointer;
			PicFloppy, PicHDD, PicCD: Pointer;}
			If Item^.Icon=PicFolder
				Then TempHint:=''+#13+String(Item^.SubItem^.SubItem^.Name^)
				Else If Item^.Icon=PicFloppy
					Then TempHint:='᪮'
					Else If Item^.Icon=PicHDD
						Then TempHint:='⪨ '+#13+
							D.GetVolumeLabel(String(Item^.Name^)[1])
						Else If Item^.Icon=PicCD
							Then TempHint:='᪮ CD-ROM'
							Else TempHint:=Kernel.GetFileDescr(String(Item^.Name^))+#13+
								String(Item^.SubItem^.Name^)+' ';

			D.ReassignPStr(String(Item^.Name^)+#13+TempHint, Control^.Hint)
		End
		Else D.ReassignPStr('', Control^.Hint)
End;


Procedure OnHistItemSelect(Me:PProg; Control:PControl);
Var
	CurItem: PListItem;
	TempName, FullPath: String;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		CurItem:=Ctl2.ListBox_GetSelItem(LstHistory);
		TempName:=String(CurItem^.SubItem^.SubItem^.Name^)+'\'+
			String(CurItem^.Name^);
		If D.FileOrFolder(TempName)=ffFile Then
		Begin { 䠩 - i Notepad' }
			{Kernel.RunBuiltIn('Notepad',
				String(CurItem^.SubItem^.SubItem^.Name^)+'\'+
				String(CurItem^.Name^))}
			Kernel.RunFile(TempName)
		End
		Else Begin
			Ctl.TabSet_SetActiveTab(TabPages, 1);
			SetVisibility(Me);
			TempName:=String(CurItem^.Name^);
			If TempName='''' Then
			Begin
				TempName:='';
				FullPath:=''
			End
			Else If Length(TempName)=2
				Then If TempName[2]=':'
					Then FullPath:=''
					Else FullPath:=String(CurItem^.SubItem^.SubItem^.Name^)+'\'
				Else FullPath:=String(CurItem^.SubItem^.SubItem^.Name^)+'\';
			ChangeDirTo(Me, FullPath+TempName)
		End
	End
End;


Procedure OnTabChange(Me:PProg; Control:PControl);
Begin
	SetVisibility(Me)
End;

Procedure OnBackClick(Me:PProg; Control:PControl);
Begin
	With Me^, TNaviData(Data^) Do
		If BackItemsNum>0 Then
			With Control^.Place Do
				Popup.OpenMenu(Me, MnuBack, X1, Y2+1)
End;

Procedure OnFavClick(Me:PProg; Control:PControl);
Begin
	With Me^, TNaviData(Data^) Do
		If FavNum>0 Then
			With Control^.Place Do
				Popup.OpenMenu(Me, MnuFavorites, X1, Y2+1)
End;




Procedure OnIdle(Me:PProg);
Var
	AlreadyFound: Boolean;
	TempIcon: Pointer;
	I, LastSlashPos: Integer;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		With Info[Level] Do
		Begin
			Case ToDo Of
				BeginScan: Begin
					AlreadyFound:=False;
					FindFirst(Path+FileName, AnyFile Xor VolumeID, SR);
					While DOSError=0 Do
					Begin
						If SR.Name[1]<>'.' Then
						Begin
							If Not AlreadyFound Then
							Begin
								TempIcon:=PicFolder;
								If Length(Path)=3 Then
									If Path[2]=':' Then
										Case Drives[Path[1]] Of
											dtFloppy: TempIcon:=PicFloppy;
											dtFixed: TempIcon:=PicHDD;
											dtCDROM: TempIcon:=PicCD;
										End;
									{ ஧  ६ i`      }
								LastSlashPos:=0;
								For I:=1 To Length(Path)-1 Do
									If Path[I]='\' Then
										LastSlashPos:=I;
								If LastSlashPos>0 Then
								Begin
									Ctl2.ListBox_AddItemFirst(LstSearch,
										Copy(Path, LastSlashPos+1,
										Length(Path)-LastSlashPos-1), TempIcon, 0);
									Ctl2.ListBox_AddSubItem(LstSearch,
										Copy(Path, 1, LastSlashPos-1), Nil)
								End
								Else Begin
									Ctl2.ListBox_AddItemFirst(LstSearch, Path,
										TempIcon, 0);
									Ctl2.ListBox_AddSubItem(LstSearch, '', Nil)
								End;
								AlreadyFound:=True
							End;
							Ctl2.ListBox_AddItemSecond(LstSearch, D.NormLine(SR.Name),
								Kernel.GetFileIcon(SR.Name), 8);
							Ctl2.ListBox_AddSubItem(LstSearch,
								Copy(Path, 1, Length(Path)-1), Nil);
							Inc(FoundNum)
						End;
						FindNext(SR)
					End;

					DirsLeft:=0;
					FindFirst(Path+'*.*', Directory, SR);
					While DOSError=0 Do
					Begin
						If SR.Name[1]<>'.' Then
							If (SR.Attr And Directory)<>0 Then
								Inc(DirsLeft);
						FindNext(SR)
					End;
					If DirsLeft>0 Then
					Begin
						NextPart:=Part/DirsLeft;
						FindFirst(Path+'*.*',AnyFile,SR);
						Result:=DOSError;
						ToDo:=ContinueScan;
						HaveSubs:=True
					End
					Else Begin
						Percent:=Percent+Part;
						Ctl.Progress_SetValue(ProSearch, Round(Percent*10));
						Dec(Level);
						FindNext(Info[Level].SR);
						Info[Level].Result:=DOSError
					End
				End;
				ContinueScan: Begin
					If Result=0 Then
					Begin
						If SR.Name[1]<>'.' Then
							If (SR.Attr And Directory)<>0 Then
							Begin
								If Length(Path)+Length(SR.Name)<79 Then
								Begin
									Inc(Level);
									{Log.BugMsg('Navi', 'OnIdle', 'Level='+D.St(Level));
									Log.ActMsg('Path='+Path);
									Log.ActMsg('SR.Name='+SR.Name);}
									Info[Level].Path:=Path+D.NormLine(SR.Name)+'\';
									Info[Level].Part:=Info[Level-1].NextPart;
									Info[Level].ToDo:=BeginScan;
									Exit
									{ TNaviData(Me^.Data^).Info[TNaviData(Me^.Data^).Level].Path }
								End
							End;
						FindNext(SR);
						Result:=DOSError
					End
					Else If Level>1 Then Begin
						Dec(Level);
						FindNext(Info[Level].SR);
						Info[Level].Result:=DOSError
					End
					Else Begin
						Ctl.Progress_SetValue(ProSearch, 1000);
						Me^.OnIdle:=Kernel.DummyProc
					End
				End
			End
		End;
		{If Level=0 Then
		Begin
			Ctl.Progress_SetValue(ProSearch, 1000);
			Me^.OnIdle:=Kernel.DummyProc
		End}
	End
End;


Procedure OnSearchClick(Me:PProg; Control:PControl);
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		If Path='' Then Exit;
		Percent:=0;
		FileName:=Ctl.InpLine_GetText(InpSearch);
		Dir:=Path;
		If Length(Dir)<>3 Then
			Dir:=Dir+'\';
		Level:=1;
		Info[1].Path:=Dir;
		Info[1].Part:=100;
		Info[1].ToDo:=BeginScan;
		Ctl2.ListBox_Clear(LstSearch);
		Ctl.Progress_SetValue(ProSearch, 0);
	End;
	Me^.OnIdle:=OnIdle;
End;

Procedure OnStopSearchClick(Me:PProg; Control:PControl);
Begin
	With Me^, TNaviData(Data^) Do
		Ctl.Progress_SetValue(ProSearch, 0);
	Me^.OnIdle:=Kernel.DummyProc
End;


Procedure OnSearchItemSelect(Me:PProg; Control:PControl);
Var
	CurItem, CurItem2: PListItem;
	TempName, FullPath: String;
	TempIcon: Pointer;
	Hour, Min, Sec, Sec100: Word;
	I, LastSlashPos: Integer;
	TopHistPath: String;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		CurItem:=Ctl2.ListBox_GetSelItem(LstSearch);
		If CurItem^.Icon=PicFile Then
		Begin { 䠩 - i Notepad' }
			CurItem2:=Ctl2.ListBox_GetItemByIndex(LstHistory, 1);
			TopHistPath:=String(CurItem2^.SubItem^.SubItem^.Name^);
			DOS.GetTime(Hour, Min, Sec, Sec100);
			If TopHistPath=''
				Then TopHistPath:=String(CurItem2^.Name^)
				Else TopHistPath:=TopHistPath+'\'+String(CurItem2^.Name^);
			If TopHistPath<>String(CurItem^.SubItem^.Name^) Then
			Begin {   }
				FullPath:=String(CurItem^.SubItem^.Name^);
				TempIcon:=PicFolder;
				If Length(TempName)=2 Then
					If TempName[2]=':'
						Then Case Drives[TempName[1]] Of
							dtFloppy: TempIcon:=PicFloppy;
							dtFixed: TempIcon:=PicHDD;
							dtCDROM: TempIcon:=PicCD
						End;
					{ ஧  ६ i`      }
				LastSlashPos:=0;
				For I:=1 To Length(FullPath)-1 Do
					If FullPath[I]='\' Then
						LastSlashPos:=I;
				If LastSlashPos>0 Then
				Begin
					Ctl2.ListBox_AddItemFirst(LstHistory,
						Copy(FullPath, LastSlashPos+1,
						Length(FullPath)-LastSlashPos), TempIcon, 0);
					Ctl2.ListBox_AddSubItem(LstHistory, D.St2(Hour)+':'+D.St2(Min), Nil);
					Ctl2.ListBox_AddSubItem(LstHistory,
						Copy(FullPath, 1, LastSlashPos-1), Nil)
				End
				Else Begin
					Ctl2.ListBox_AddItemFirst(LstHistory, FullPath,
						TempIcon, 0);
					Ctl2.ListBox_AddSubItem(LstHistory, D.St2(Hour)+':'+D.St2(Min), Nil);
					Ctl2.ListBox_AddSubItem(LstHistory, '', Nil)
				End
			End;
				{  䠩  ii }
			Ctl2.ListBox_AddItemSecond(LstHistory, String(CurItem^.Name^),
				CurItem^.Icon, 8);
			Ctl2.ListBox_AddSubItem(LstHistory, D.St2(Hour)+':'+D.St2(Min), Nil);
			Ctl2.ListBox_AddSubItem(LstHistory,
				String(CurItem^.SubItem^.Name^), Nil);

			{Kernel.RunBuiltIn('Notepad',
				String(CurItem^.SubItem^.Name^)+'\'+
				String(CurItem^.Name^))}
			Kernel.RunFile(String(CurItem^.SubItem^.Name^)+'\'+
				String(CurItem^.Name^))
		End
		Else Begin {  - i  ii  }
			Ctl.TabSet_SetActiveTab(TabPages, 1);
			SetVisibility(Me);
			TempName:=String(CurItem^.Name^);
			If TempName='''' Then
			Begin
				TempName:='';
				FullPath:=''
			End
			Else If Length(TempName)=2
				Then If TempName[2]=':'
					Then FullPath:=''
					Else FullPath:=String(CurItem^.Name^)+'\'
				Else FullPath:=String(CurItem^.SubItem^.Name^)+'\';
			AddToBackMenu(Me, CurItem^.Icon, TempName, FullPath+TempName);
			ChangeDirTo(Me, FullPath+TempName)
		End
	End
End;




Function OnMessage(Me, Sender:PProg; VMsg:String; VData:Pointer): Pointer;
Begin
	With TNaviData(Me^.Data^) Do
	Begin
		OnMessage:=Nil;
		If VMsg='GetDir' Then
			If Path<>'' Then
				OnMessage:=Addr(Path[0]);
		if VMsg='GetFavoritesMenu' Then
			OnMessage:=MnuFavorites
	End
End;

Function OnKey(Me:PProg; C1,C2:Char): Boolean;
Var
	LastDir: String;
Begin
	OnKey:=False;
	With TNaviData(Me^.Data^) Do
	Begin
		If Ctl.TabSet_GetActiveTab(TabPages)<>1 Then Exit;

		If (C1=#8) Or ((C1=#0) And (C2=#115)) Then
		Begin { Backspace or Ctrl+Left }
			If NavCtlNum>=2 Then
				Kernel.ClickCtl(Me, NavCtl[NavCtlNum-1]);
			OnKey:=True
		End;
		If (C1=#0) And (C2=#48) Then
		Begin
			If BtnBack^.Enabled Then
				Kernel.ClickCtl(Me, BtnBack);
			OnKey:=True
		End;
		If (C1=#0) And (C2=#33) Then
		Begin
			If BtnFavorites^.Enabled Then
				Kernel.ClickCtl(Me, BtnFavorites);
			OnKey:=True
		End;
	End
End;




Procedure OnCloseBtn(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;


Procedure SaveFavorites(Me:PProg); Forward;

Procedure OnClose(Me:PProg);
Begin
	SaveFavorites(Me);
	Kernel.FreeRes('comp.bmp');
	Kernel.FreeRes('up.bmp');
	Kernel.FreeRes('folder.bmp');
	Kernel.FreeRes('file.bmp');
	Kernel.FreeRes('d_floppy.bmp');
	Kernel.FreeRes('d_fixed.bmp');
	Kernel.FreeRes('d_cdrom.bmp');
	Kernel.FreeRes('b_search.bmp');
	Kernel.FreeRes('b_back.bmp');
	Kernel.FreeRes('b_favor.bmp');
	Kernel.FreeRes('b_go.bmp');
	Kernel.FreeRes('b_stop.bmp');
	With Me^, TNaviData(Data^) Do
	Begin
		Popup.FreeMenu(MnuFavorites);
		If BackItemsNum>0 Then
			Popup.FreeMenu(MnuBack);

		Ini.Select('prog\navi\navi.ini', 'Navi');
		With WinRect Do
			Ini.SetInt('Width', X2-X1);
		Ini.SetStr('Path', Path);
		Ini.SaveCurFile;
		Ini.FreeFile('prog\navi\navi.ini');
	End;
	FreeMem(Me^.Data, SizeOf(TNaviData))
End;



Procedure SaveFavorites(Me:PProg);
Var
	F: Text;
	CurItem: PListItem;
	TempName, TempPath: String;
	I: Integer;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		Assign(F, 'prog\navi\favorite.dat');
		Rewrite(F);
		For I:=1 To FavNum Do
			With Fav[I] Do
			Begin
				WriteLn(F, Name);
				WriteLn(F, FullPath);
				WriteLn(F, Times);
				WriteLn(F)
			End;
		Close(F)
	End
End;

Procedure LoadFavorites(Me:PProg);
Var
	F: Text;
Begin
	With Me^, TNaviData(Data^) Do
	Begin
		FavNum:=0;
		If D.FileExist('prog\navi\favorite.dat') Then
		Begin
			Assign(F, 'prog\navi\favorite.dat');
			Reset(F);
			While Not EOF(F) Do
			Begin
				Inc(FavNum);
				With Fav[FavNum] Do
				Begin
					ReadLn(F, Name);
					ReadLn(F, FullPath);
					ReadLn(F, Times);
					ReadLn(F)
				End
			End;
			Close(F)
		End;
		If FavNum>0 Then
		Begin
			BuildFavsMenu(Me);
			BtnFavorites^.Enabled:=True
		End
		Else BtnFavorites^.Enabled:=False
	End
End;


Procedure OnInit(Me:PProg);
Var
	Letter, FirstCD: Char;
	CurCD: Byte;
	Width: Integer;
	TempPath: String;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnKey:=OnKey;
	Me^.OnMessage:=OnMessage;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		Ini.Load('prog\navi\navi.ini');
		Ini.Select('prog\navi\navi.ini', 'Navi');
		Width:=Ini.GetInt('Width', 140);
		TempPath:=Ini.GetStr('Path', '');

		D.AssignPStr('i', WinTitle);
		MinX:=140;
		MinY:=330;
		GetMem(Data, SizeOf(TNaviData));
		Kernel.InitPanelWindow(Me, 'BlueWin', brLeft, [wbSlide], Width);
		{Kernel.InitWindow(Me, 'BlueWin', [wbClose]);}
		CanBeActive:=True;
		Kernel.DrawWindowAni(Me);

		With TNaviData(Data^) Do
		Begin
			PicComp:=Kernel.LoadBMPRes('pic\comp.bmp');
			PicUp:=Kernel.LoadBMPRes('pic\up.bmp');
			PicFolder:=Kernel.LoadBMPRes('pic\folder.bmp');
			PicFile:=Kernel.LoadBMPRes('pic\file.bmp');
			PicFloppy:=Kernel.LoadBMPRes('pic\d_floppy.bmp');
			PicHDD:=Kernel.LoadBMPRes('pic\d_fixed.bmp');
			PicCD:=Kernel.LoadBMPRes('pic\d_cdrom.bmp');
			PicSearch:=Kernel.LoadBMPRes('pic\b_search.bmp');
			PicBack:=Kernel.LoadBMPRes('pic\b_back.bmp');
			PicFavorites:=Kernel.LoadBMPRes('pic\b_favor.bmp');
			PicGo:=Kernel.LoadBMPRes('pic\b_go.bmp');
			PicStop:=Kernel.LoadBMPRes('pic\b_stop.bmp');

			TabPages:=Ctl.TabSet_Create(Me, False, OnTabChange);
			Ctl.TabSet_AddTab(TabPages, '', '', Nil);
			Ctl.TabSet_AddTab(TabPages, '', '', Nil);
			Ctl.TabSet_AddTab(TabPages, 'Ii', '', Nil);

			BtnBack:=Ctl.Button_Create(Me, '', PicBack, ppLeft, OnBackClick);
			Ctl.Button_SetMarkStyle(BtnBack, bmMenuDown);
			BtnBack^.Enabled:=False;
			BtnBack^.FocusCtl:=Nil;
			BtnFavorites:=Ctl.Button_Create(Me, '', PicFavorites, ppLeft,
				OnFavClick);
			Ctl.Button_SetMarkStyle(BtnFavorites, bmMenuDown);
			{BtnFavorites^.Enabled:=False;}
			BtnFavorites^.FocusCtl:=Nil;

				{ i㢠 ᯨ᮪ ⨯i ᪮  }
			For Letter:='A' To 'Z' Do
				Drives[Letter]:=D.GetDriveType(Letter);
			FirstCD:=D.GetFirstCDDrive;
			For CurCD:=1 To D.GetCDDrivesNum Do
				Drives[Char(Byte(FirstCD)+CurCD-1)]:=dtCDROM;

			LstFiles:=Ctl2.ListBox_Create(Me, False);
			LstFiles^.AutoRedraw:=False;
			Ctl2.ListBox_SetOnStrongSelect(LstFiles, OnFileSelect);
			Ctl2.ListBox_SetColumnProps(LstFiles, 2, lcRightMono, True);
			Ctl2.ListBox_SetColumnProps(LstFiles, 3, lcRightMono, True);
			Ctl2.ListBox_SetOnHint(LstFiles, OnFileListHint);
			Path:='';
			RefreshFilesList(Me);
			NavCtl[1]:=Ctl.Label_Create(Me, '''', PicComp, lsBeveled, alLeft);
			NavCtlNum:=1;
			BackItemsNum:=0;
			MnuBack:=Nil;

			LstSearch:=Ctl2.ListBox_Create(Me, False);
			Ctl2.ListBox_SetOnStrongSelect(LstSearch, OnSearchItemSelect);
			InpSearch:=Ctl.InpLine_Create(Me, '*.*', Nil);
			BtnSearch:=Ctl.Button_Create(Me, ' ', PicGo, ppLeft,
				OnSearchClick);
			BtnStopSearch:=Ctl.Button_Create(Me, '', PicStop, ppLeft,
				OnStopSearchClick);
			D.ReassignPStr('㯨 ', BtnStopSearch^.Hint);
			ProSearch:=Ctl.Progress_Create(Me, 1, 1000, 1, pkDeterm);

			LstHistory:=Ctl2.ListBox_Create(Me, False);
			Ctl2.ListBox_SetColumnProps(LstHistory, 2, lcRightMono, True);
			Ctl2.ListBox_SetOnStrongSelect(LstHistory, OnHistItemSelect);
			Ctl2.ListBox_AddItemFirst(LstHistory, '''', PicComp, 0);
			Ctl2.ListBox_AddSubItem(LstHistory, '', Nil);
			Ctl2.ListBox_AddSubItem(LstHistory, '', Nil);

			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseBtn);

			MnuFavorites:=Nil;
			FavNum:=0;
			MinTimes:=1;
			LoadFavorites(Me);

			SetVisibility(Me);
			ActiveCtl:=LstFiles;

			ChangeDirTo(Me, TempPath)
		End
	End
End;



Begin
	Kernel.RegBuiltIn('Navi', 'ii ', 'pic\i_navi.bmp', OnInit)
End.
