{ ************ Notebook ************ }
Type
	TNotebook=Record
		Tabs: PControl;
		Page: Array[1..30] Of Record
			Num: Integer;
			Data: Pointer
		End;
		TabsNum: Integer;
		NBRect: TRect;
		LastCtl: PControl;
		OnChangePage: TCtlHandler
	End;



{Procedure Notebook_SetVisibility(Me:PControl);
Var
	I, K: Integer;
	VisFlag: Boolean;
Begin
	With Me^, TNotebook(Data^) Do
	Begin
		For I:=1 To TabsNum Do
		Begin
			VisFlag:=(I=TabSet_GetActiveTab(Tabs));
			For K:=1 To Page[I].Num Do
				PControl(TPtrMatrix(Page[I].Data^)[K-1])^.Visible:=VisFlag
		End
	End
End;}

Procedure Notebook_Draw(Me:PControl);
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, TNotebook(Data^), Place Do
	Begin
		Gfx.TranspBar(X1+1, Y2, X2, Y2, clBlack, 50);
		Gfx.TranspBar(X1, Y2, X1, Y2, clBlack, 25);
		Gfx.TranspBar(X2, Y1+23, X2, Y2-1, clBlack, 50);
		Gfx.TranspBar(X2, Y1+22, X2, Y1+22, clBlack, 25);

		{ to-do: set visible flags }

		If (Tabs^.CanDraw Or Kernel.DontBother) And Visible Then
		Begin
			Kernel.BeginPaint(Tabs^.Place);
			TabSet_PaintDirect(Tabs, X1, Y1, X2, Y2);
			Kernel.EndPaint
		End
	End
End;

Procedure Notebook_Paint(Me:PControl; VX1,VY1,VX2,VY2:Integer);
Var
	I, K: Integer;
Begin
	With Me^.Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY2, Me^.Place);
	Notebook_Draw(Me);
	{Notebook_SetVisibility(Me)}
	With Me^, TNotebook(Data^) Do
	Begin
		For I:=1 To TabsNum Do
			For K:=1 To Page[I].Num Do
				PControl(TPtrMatrix(Page[I].Data^)[K-1])^.Visible:=
					(I=TabSet_GetActiveTab(Tabs))
	End
End;

Procedure Notebook_OnChangeTab(Me:PProg; Control:PControl);
Begin
	Kernel.PaintWindow(Me);
	TNotebook(Control^.Data^).OnChangePage(Me, Control)
End;

Procedure Notebook_OnRefocus(Me:PControl; Focused:Boolean);
Begin
End;

Procedure Notebook_OnDestroy(Me:PControl);
Begin
	FreeMem(Me^.Data, SizeOf(TNotebook));
End;

Procedure Notebook_AddPage(Me:PControl; VName,VHint:String; VIcon:Pointer);
Var
	A: Array[0..70] Of PControl;
	ANum: Integer;
	Cur: PControl;
	TempLastCtl: PControl;
Begin
	With Me^, TNotebook(Data^) Do
	Begin
		ANum:=0;
		Cur:=Owner^.FirstCtl;
		TempLastCtl:=LastCtl;

		While (Cur<>LastCtl) And (Cur<>Nil) Do
		Begin
			Inc(ANum);
			A[ANum-1]:=Cur;
			TempLastCtl:=Cur;
			Cur:=Cur^.Next
		End;
		Inc(TabsNum);
		Page[TabsNum].Num:=ANum;
		{LastCtl:=TempLastCtl;}
		LastCtl:=Owner^.FirstCtl;
		If ANum>0 Then
		Begin
			GetMem(Page[TabsNum].Data, ANum*SizeOf(Pointer));
			Move(A[0],Page[TabsNum].Data^, ANum*SizeOf(Pointer))
		End;
		TabSet_AddTab(Tabs, VName, VHint, VIcon);
	End
End;

Procedure Notebook_SetActivePage(Me:PControl; VActivePage:Integer);
Begin
	With TNotebook(Me^.Data^) Do
		TabSet_SetActiveTab(Tabs, VActivePage)
End;

Function Notebook_GetActivePage(Me:PControl): Integer;
Begin
	With TNotebook(Me^.Data^) Do
		Notebook_GetActivePage:=TabSet_GetActiveTab(Tabs)
End;

Procedure Notebook_SetOnChange(Me:PControl; VOnChange:TCtlHandler);
Begin
	With Me^, TNotebook(Data^) Do
		OnChangePage:=VOnChange
End;


Function Notebook_Create(Prog:PProg;VGrayBack:Boolean): PControl;
Var
	Me: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Kernel.CtlClickDummy, Kernel.CtlKeyDummy,
		Notebook_OnRefocus, Kernel.CtlDummy, Notebook_OnDestroy,
		False, False, '');}
	With Me^ Do
	Begin
		OnRefocus:=Notebook_OnRefocus;
		OnDestroy:=Notebook_OnDestroy;
		Enabled:=False;

		GetMem(Data, SizeOf(TNotebook));
		With TNotebook(Data^) Do
		Begin
			OnChangePage:=Kernel.CtlDummyProc;
			TabsNum:=0;
			Tabs:=TabSet_Create(Owner, VGrayBack, Notebook_OnChangeTab);
			LastCtl:=Tabs;
			Tabs^.OwnerCtl:=Me
		End
	End;
	Notebook_Create:=Me
End;
