{$F+}
Unit
	NotePad; { Polit Halcyon NotePad application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, DOS, Popup, {LFN,} LptGfx;

Type
	TMemoTestData=Record
		MemTest: PControl;
		BtnNew, BtnOpen, BtnSave, PbtFont, SwtMode, BtnPrint: PControl;
		PicNew, PicOpen, PicSave, PicFont, PicFontFile, PicPrint: Pointer;
		PicView, PicEdit: Pointer;
		MemoFont: Pointer;
		MemoFontName: String;
		MnuFonts, MnuMode: PMenuItem;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TMemoTestData(Data^) Do
	Begin
		Kernel.WinBGBar(Me, X1, Y1, X2, Y1+49);
		Kernel.WinBGBar(Me, X1, Y1+50, X1+5, Y2-5);
		Kernel.WinBGBar(Me, X2-5-16, Y1+50, X2, Y2-5);
		Kernel.WinBGBar(Me, X1, Y2-5, X2, Y2);

		Ctl.Button_Paint(BtnNew, 5, 5, 65);
		Ctl.Button_Paint(BtnOpen, 70, 5, 130);
		Ctl.Button_Paint(BtnSave, 135, 5, 195);
		Ctl.PopupBtn_Paint(PbtFont, 205, 5, 265);
		Ctl.Switcher_Paint(SwtMode, 270, 5, 330);
		Ctl.Button_Paint(BtnPrint, 335, 5, 395);

		Ctl2.Memo_Paint(MemTest, 5, 50, X2-X1-5, Y2-Y1-5);
	End;
End;



Procedure OnNewBtn(Me:PProg;Control:PControl);
Begin
	With Me^, TMemoTestData(Data^) Do
	Begin
		Ctl2.Memo_Clear(MemTest);
		D.ReassignPStr('', Param);
		Kernel.SetWindowCaption(Me, '');
		Ctl.Button_SetMarkStyle(BtnSave, bmDialog)
	End
End;


Function OnMessage(Me, Sender:PProg; VMsg:String; VData:Pointer): Pointer;
Var
	TempName, TempPath: String;
Begin
	With Me^, TMemoTestData(Data^) Do
	Begin
		If VMsg='OpenFile' Then
		Begin
			{LFN.LFNGetShortPath(False, String(VData^), TempName);}
			TempName:=String(VData^);
			If D.FileExist(TempName) Then
			Begin
				Ctl2.Memo_Clear(MemTest);
				Ctl2.Memo_LoadFile(MemTest, TempName, True);
				Kernel.SetWindowCaption(Me, D.LastPathItem(String(VData^)));
				D.ReassignPStr(String(VData^), Param);
				Ctl.Button_SetMarkStyle(BtnSave, bmNone)
			End
			Else
				Kernel.ShowHint('  :'+#13+String(VData^))
		End;
		If VMsg='SaveFile' Then
		Begin
			TempName:=String(VData^);
			{LFN.LFNGetShortPath(False, D.DropLastPathItem(TempName), TempPath);}
			TempPath:=D.DropLastPathItem(TempName);
			Ctl2.Memo_SaveToFile(MemTest, TempPath+'\'+D.LastPathItem(TempName), True, True, True);
			Kernel.SetWindowCaption(Me, D.LastPathItem(TempName));
			D.ReassignPStr(TempName, Param);
			Ctl.Button_SetMarkStyle(BtnSave, bmNone)
		End
	End
End;


Procedure OnOpenBtn(Me:PProg; Control:PControl);
Begin
	With Me^, TMemoTestData(Data^) Do
		Kernel.RunChild2(Me, 'FileDlg', 'o *.txt')
End;

Procedure OnSaveBtn(Me:PProg; Control:PControl);
Var
	TempName: String;
Begin
	With Me^, TMemoTestData(Data^) Do
		If String(Param^)<>'' Then
		Begin
			{LFN.LFNGetShortPath(False, String(Param^), TempName);}
			Ctl2.Memo_SaveToFile(MemTest, String(Param^), {True}False, True, True)
		End
		Else Kernel.RunChild2(Me, 'FileDlg', 's *.txt');
End;

Procedure OnPrintBtn(Me:PProg; Control:PControl);
Var
	TempName: String;
	TempPtr: Pointer;
	TempList: TPtrList;
	TempF: File;
Begin
	With Me^, TMemoTestData(Data^) Do
	Begin
		TempName:=Kernel.TempDir+D.UniqueFName(Kernel.TempDir);
		TempList.Data:=Addr(TempName);
		New(TempList.Next);
		TempList.Next^.Data:=Param;
		TempList.Next^.Next:=Nil;

		Ctl2.Memo_SaveToFile(MemTest, Kernel.TempDir+'prn_text.tmp',
			False, False, False);
		LptGfx.DumpTextFile(Kernel.TempDir+'prn_text.tmp',
			TempName);
		Assign(TempF, Kernel.TempDir+'prn_text.tmp');
		Erase(TempF);
		If Kernel.FindProg('PrnSpool')=Nil Then
			Kernel.RunBuiltIn('PrnSpool', '');
		TempPtr:=Kernel.SendMessage(Me, Kernel.FindProg('PrnSpool'),
			'PrintFile', Addr(TempList));
		Dispose(TempList.Next);
	End
End;


Procedure SetMemoFont(Me:PProg; FName:String);
Begin
	With Me^, TMemoTestData(Data^) Do
	Begin
		If MemoFontName<>'' Then
			Kernel.FreeRes(MemoFontName);
		MemoFont:=Kernel.LoadRes('Fonts\'+FName);
		MemoFontName:=FName;
		Memo_SetFont(MemTest, MemoFont)
	End
End;

Procedure OnFontsMenuClick(Me:PProg; Item:PMenuItem);
Var
	TempExt: String[3];
Begin
	With Me^, TMemoTestData(Data^) Do
	Begin
		If Item^.Icon=Kernel.GetFileIcon('*.raf')
			Then TempExt:='raf'
			Else TempExt:='chr';
		SetMemoFont(Me, String(Item^.Name^)+'.'+TempExt)
	End
End;


Procedure OnViewModeClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TMemoTestData(Data^) Do
		Ctl2.Memo_SetKind(MemTest, mkReadOnly)
End;

Procedure OnEditModeClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TMemoTestData(Data^) Do
		Ctl2.Memo_SetKind(MemTest, mkEditable)
End;


Function OnKey(Me:PProg; C1,C2:Char): Boolean;
Begin
	OnKey:=False;
	With TMemoTestData(Me^.Data^) Do
		Case C1 Of
			^N: Begin
				Kernel.ClickCtl(Me, BtnNew);
				OnKey:=True
			End;
			^O: Begin
				Kernel.ClickCtl(Me, BtnOpen);
				OnKey:=True
			End;
			^S: Begin
				Kernel.ClickCtl(Me, BtnSave);
				OnKey:=True
			End;
			^P: Begin
				Kernel.ClickCtl(Me, BtnPrint);
				OnKey:=True
			End;
			#27: Begin
				Kernel.CloseProg(Me);
				OnKey:=True
			End
		End
End;

Procedure OnClose(Me:PProg);
Begin
	Kernel.FreeRes('b_new.bmp');
	Kernel.FreeRes('b_open.bmp');
	Kernel.FreeRes('b_save.bmp');
	Kernel.FreeRes('b_font.bmp');
	Kernel.FreeRes('f_font.bmp');
	Kernel.FreeRes('b_view.bmp');
	Kernel.FreeRes('b_edit.bmp');
	Kernel.FreeRes('i_print.bmp');
	With Me^, TMemoTestData(Data^) Do
		If MemoFontName<>'' Then
			Kernel.FreeRes(MemoFontName+'.raf');
	FreeMem(Me^.Data, SizeOf(TMemoTestData))
End;

Procedure MakeMenus(Me:PProg);
Var
	SR: SearchRec;
	TempIcon: Pointer;
Begin
	With Me^, TMemoTestData(Data^) Do
	Begin
		MnuFonts:=Popup.CreateMenu;

		TempIcon:=Kernel.GetFileIcon('*.raf');
		FindFirst('fonts\*.raf', AnyFile, SR);
		While DOSError=0 Do
		Begin
			Popup.AddCommand(MnuFonts, D.NormLine(Copy(SR.Name, 1,
				Length(SR.Name)-4)), '', '', TempIcon, True,
				OnFontsMenuClick);
			FindNext(SR)
		End;

		TempIcon:=Kernel.GetFileIcon('*.chr');
		FindFirst('fonts\*.chr', AnyFile, SR);
		While DOSError=0 Do
		Begin
			Popup.AddCommand(MnuFonts, D.NormLine(Copy(SR.Name, 1,
				Length(SR.Name)-4)), '', '', TempIcon, True,
				OnFontsMenuClick);
			FindNext(SR)
		End;

		MnuMode:=Popup.CreateMenu;
		Popup.AddCommand(MnuMode, '', '', '', PicEdit, True,
			OnEditModeClick);
		Popup.AddCommand(MnuMode, 'ॣ', '', '', PicView, True,
			OnViewModeClick);
	End
End;

Procedure OnInit(Me:PProg);
Var
	TempParam: String;
	TempKind: TMemoKind;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	Me^.OnMessage:=OnMessage;
	Me^.OnKey:=OnKey;
	With Me^ Do
	Begin
		If String(Param^)<>''
			Then D.AssignPStr(D.LastPathItem(String(Param^)), WinTitle)
			Else D.AssignPStr('', WinTitle);
		MinX:=401;
		MinY:=128;
		GetMem(Data, SizeOf(TMemoTestData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		WinBG:=bgManual;
		Kernel.DrawWindowAni(Me);

		With TMemoTestData(Data^) Do
		Begin
			PicNew:=Kernel.LoadBMPRes('pic\b_new.bmp');
			PicOpen:=Kernel.LoadBMPRes('pic\b_open.bmp');
			PicSave:=Kernel.LoadBMPRes('pic\b_save.bmp');
			PicFont:=Kernel.LoadBMPRes('pic\b_font.bmp');
			PicFontFile:=Kernel.LoadBMPRes('pic\f_font.bmp');
			PicView:=Kernel.LoadBMPRes('pic\b_view.bmp');
			PicEdit:=Kernel.LoadBMPRes('pic\b_edit.bmp');
			PicPrint:=Kernel.LoadBMPRes('pic\i_print.bmp');
			MemoFontName:='';
			MakeMenus(Me);

			BtnNew:=Ctl.Button_Create(Me, '',  PicNew, ppTop, OnNewBtn);
			BtnNew^.FocusCtl:=Nil;
			D.ReassignPStr('  ⥪'+#13+'Ctrl+N', BtnNew^.Hint);

			BtnOpen:=Ctl.Button_Create(Me, 'i', PicOpen, ppTop,
				OnOpenBtn);
			BtnOpen^.FocusCtl:=Nil;
			D.ReassignPStr('⠦ 䠩  ।'+#13+'Ctrl+O',
				BtnOpen^.Hint);
			Button_SetMarkStyle(BtnOpen, bmDialog);

			BtnSave:=Ctl.Button_Create(Me, 'ॣ', PicSave, ppTop,
				OnSaveBtn);
			BtnSave^.FocusCtl:=Nil;
			D.ReassignPStr('   ⥪ i ।'+#13+'Ctrl+S',
				BtnSave^.Hint);

			PbtFont:=Ctl.PopupBtn_Create(Me, '', MnuFonts, PicFont,
				ppTop);
			PopupBtn_AsButton(PbtFont)^.FocusCtl:=Nil;
			D.ReassignPStr('   ⥪', PbtFont^.Hint);

			SwtMode:=Ctl.Switcher_Create(Me, MnuMode, ppTop);
			Switcher_AsButton(SwtMode)^.FocusCtl:=Nil;

			BtnPrint:=Ctl.Button_Create(Me, '', PicPrint, ppTop,
				OnPrintBtn);
			BtnPrint^.FocusCtl:=Nil;
			D.ReassignPStr('㢠 ⥪ i ।'+#13+'Ctrl+P',
				BtnPrint^.Hint);

			{TempKind:=mkEditable;
			If String(Param^)<>'' Then
				If D.UpCaseLine(D.ClipFExt(String(Param^)))<>'.TXT' Then
					TempKind:=mkReadOnly;}
			MemTest:=Ctl2.Memo_Create(Me, mkEditable, True, '');
			{LFN.LFNGetShortPath(False, String(Param^), TempParam);}
			TempParam:=String(Param^);
			If D.FileExist(TempParam)
				Then Ctl2.Memo_LoadFile(MemTest, TempParam, True)
				Else Ctl.Button_SetMarkStyle(BtnSave, bmDialog);

			ActiveCtl:=MemTest;
		End
	End
End;



Begin
	Kernel.RegBuiltIn('Notepad', '᭨', 'pic\i_memo.bmp', OnInit)
End.
