{$F+}
Unit
	Pic; { Polit Halcyon Eva picture files support unit }

Interface

Uses
	Gfx, SGraph, Types, Log, D;

	Procedure IntLoadBMP(FName,PalFName:String; UsePalette:Boolean; Var P:Pointer);
	Procedure LoadBMP(FName:String; Var P:Pointer);
	Procedure LoadCUR(FName:String; Var P:Pointer; Var HotX,HotY:Word);
	Procedure LoadGIF(FName:String; Var P:Pointer);
	Procedure LoadJPG(FName:String; Var VP:Pointer);
	{Procedure LoadPCX(FName:String; Var P:Pointer);}

Var
	LastColorDepth: Integer;
	OnProgress: TProcedure;

	

Implementation

Type
	TString=Record
		Len: Word;
		Data: Pointer
	End;
	TGifTable=Array[0..4095] Of TString;
	THuff_Table=record
		L:array [1..16] of byte;           { Huffman Tables }
		V:array [1..16,1..255] of byte;
		C:array [0..1,0..3,0..$FF] of record
			L:byte;
			V:word
		end
	end;

Var
	DitherBMP24: Boolean;

		{ for LoadGIF }
	Table: ^TGifTable;

		{ for LoadJPG }
	Current_bit, Current_byte: byte;
	TR, TG, TB, C: Integer; { for PutPixelRGB }



Procedure Dummy;
Begin
End;

Procedure IntLoadBMP(FName,PalFName:String; UsePalette:Boolean; Var P:Pointer);
Type
	TBMPHeader=Record
		BMSig: Array[1..2] Of Char; {   'BM' }
		FSize: LongInt;
		Res1: LongInt;
		DataOffs: LongInt;
		ColorTabOffs: LongInt; {   $0e,  i饭  䠩i }
		Width: LongInt;
		Height: LongInt;
		Planes: Word;
		BPP: Word;
		Compression: LongInt; { 0-, 1-RLE 8bit, 2-RLE 4bit }
		PicSize: LongInt; { Width*Height*BPP Div 8 }
		HorizRes: LongInt;
		VertRes: LongInt; { 宦, i    ⮢ }
		ColorsUsed: LongInt; { ii i  ii (0-i) }
		ColorsImp: LongInt { 0-. i  }
	End;

	{TBMPPalEntry=Record
		B, G, R, F: Integer
	End;}
Var
	F, FP: File;
	Hdr: TBMPHeader;
	Y, I, LastI, X: Integer;
	TempOffs: Word;
	WidthDiv2: Word;
	TempWidth, RowTail: Integer;
	TempByte: Byte;
	Tmp: Pointer;
	Pal: Array[0..255] Of Record
		B, G, R, O: Byte
	End;
	TempPal: TPalette;
	MaxStripHeight, TailHeight: Integer;
	PS: Array[1..35] Of Pointer;
	Stripes, CurStripe: Integer;

	Procedure ReadRows8Pal(Var VP:Pointer; VHeight:Integer);
	Var
		X, Y: Integer;
	Begin
		For Y:=0 To VHeight-1 Do
		Begin
			BlockRead(F, TMatrix(VP^)[TempOffs], Hdr.Width);
			For X:=0 To Hdr.Width-1 Do
				TMatrix(VP^)[TempOffs+X]:=Pal[TMatrix(VP^)[TempOffs+X]].O;
			BlockRead(F, Tmp^, RowTail);
			Dec(TempOffs, Hdr.Width);
			OnProgress
		End
	End;

	Procedure ReadRows8(Var VP:Pointer; VHeight:Integer);
	Var
		Y: Integer;
	Begin
		For Y:=0 To VHeight-1 Do
		Begin
			BlockRead(F, TMatrix(VP^)[TempOffs], Hdr.Width);
			BlockRead(F, Tmp^, RowTail);
			Dec(TempOffs, Hdr.Width);
			OnProgress
		End
	End;

	Procedure ReadRows4(Var VP:Pointer; VHeight:Integer);
	Var
		Y, I: Integer;
	Begin
		For Y:=0 To VHeight-1 Do
		Begin
			BlockRead(F, Tmp^, WidthDiv2);
			For I:=0 To ((Hdr.Width+1) Div 2)-2 Do
			Begin
				TMatrix(VP^)[TempOffs+I+I]:=TMatrix(Tmp^)[I] Shr 4;
				TMatrix(VP^)[TempOffs+I+I+1]:=TMatrix(Tmp^)[I] And $f
			End;
			I:=((Hdr.Width+1) Div 2)-1;
			TMatrix(VP^)[TempOffs+I+I]:=TMatrix(Tmp^)[I] Shr 4;
			If I<>LastI Then
				TMatrix(VP^)[TempOffs+I+I+1]:=TMatrix(Tmp^)[I] And $f;

			BlockRead(F, Tmp^, RowTail);
			Dec(TempOffs, Hdr.Width);
			OnProgress
		End
	End;

	Procedure ReadRows24(Var VP:Pointer; VHeight:Integer);
	Var
		X, Y: Integer;
	Begin
		{Log.BugMsg('Pic', 'IntLoadBMP', 'ReadRows24 starting, height='+
			D.St(VHeight));}
		For Y:=0 To VHeight-1 Do
		Begin
			{Log.BugMsg('Pic', 'IntLoadBMP', 'Loading row N'+D.St(Y)+
				', TempOffs='+D.StL(TempOffs));}
			BlockRead(F, Tmp^, Hdr.Width*3);
			For X:=0 To Hdr.Width-1 Do
				TMatrix(VP^)[TempOffs+X]:=
					RGB2Pal[TMatrix(Tmp^)[X*3+2] Shr 4,
						TMatrix(Tmp^)[X*3+1] Shr 4, TMatrix(Tmp^)[X*3] Shr 4];
			BlockRead(F, Tmp^, RowTail);
			Dec(TempOffs, Hdr.Width);
			OnProgress
		End;
	End;

	Procedure ReadRows24Dither(Var VP:Pointer; VHeight:Integer);
	Var
		X, Y: Integer;
		ErrR, ErrG, ErrB: Integer;
		R, G, B, C, J: Integer;
	Begin
		{Log.BugMsg('Pic', 'IntLoadBMP', 'ReadRows24 starting, height='+
			D.St(VHeight));}
		ErrR:=0;
		ErrG:=0;
		ErrB:=0;
		For Y:=0 To VHeight-1 Do
		Begin
			{Log.BugMsg('Pic', 'IntLoadBMP', 'Loading row N'+D.St(Y)+
				', TempOffs='+D.StL(TempOffs));}
			BlockRead(F, Tmp^, Hdr.Width*3);
			For X:=0 To Hdr.Width-1 Do
			Begin
				R:=TMatrix(Tmp^)[X*3+2]+ErrR;
				G:=TMatrix(Tmp^)[X*3+1]+ErrG;
				B:=TMatrix(Tmp^)[X*3]+ErrB;
				D.ToRange(R, 0, 255);
				D.ToRange(G, 0, 255);
				D.ToRange(B, 0, 255);
				C:=Gfx.RGB2Pal[R Shr 4, G Shr 4, B Shr 4];
				ErrR:=R-Gfx.Palette[C].R Shl 2;
				ErrG:=G-Gfx.Palette[C].G Shl 2;
				ErrB:=B-Gfx.Palette[C].B Shl 2;
				TMatrix(VP^)[TempOffs+X]:=C
			End;
			BlockRead(F, Tmp^, RowTail);
			Dec(TempOffs, Hdr.Width);
			OnProgress
		End;
	End;

Begin
	{Log.BugMsg('Pic', 'IntLoadBMP', 'Loading BMP: '+FName);}
	If Not D.FileExist(FName) Then
	Begin
		Log.ErrMsg('Pic', 'IntLoadBMP', 'File not found: '+FName);
		Log.ActMsg('Replacing with black pixel');
		Gfx.MakeEmptyImage(P);
		Exit
	End;
	Assign(F, FName);
	ReSet(F, 1);
	BlockRead(F, Hdr, SizeOf(Hdr));
	If Gfx.BigImageSize(0, 0, Hdr.Width, Hdr.Height)>MaxAvail Then
	Begin
		Log.ErrMsg('Pic', 'IntLoadBMP', 'Not enough memory to load '+FName);
		Log.ActMsg('Replacing with black pixel');
		Gfx.MakeEmptyImage(P);
		Close(F);
		Exit
	End;
	LastColorDepth:=Hdr.BPP;
	OnProgress;
	Case Hdr.BPP Of
			{ 8 bit (256 colors) }
		8: Begin
			If UsePalette Then
			Begin
				BlockRead(F, Pal, 1024);
				For I:=0 To 255 Do
				Begin
					TempPal[I].R:=Pal[I].R Shr 2;
					TempPal[I].G:=Pal[I].G Shr 2;
					TempPal[I].B:=Pal[I].B Shr 2
				End
			End
			Else Seek(F, Hdr.DataOffs);
			If PalFName<>'' Then
				If D.FileExist(PalFName)
					Then Gfx.LoadPal(PalFName, TempPal)
					Else Log.ErrMsg('Pic', 'IntLoadBMP', 'External palette not found: '+PalFName);
			If UsePalette Then
			Begin
				Pal[0].O:=0;
				For I:=1 To 255 Do
					With TempPal[I] Do
						{Pal[I].O:=RGB2Pal[R Shr 2, G Shr 2, B Shr 2];}
						Pal[I].O:=Gfx.RGB(R, G, B)
			End;
				{ i ᫥ }
			TempWidth:=((Hdr.Width+3) Div 4)*4;
			RowTail:=TempWidth-Hdr.Width;
			MaxStripHeight:=64000 Div Hdr.Width;
			Stripes:=(Hdr.Height+MaxStripHeight-1) Div MaxStripHeight;
			TailHeight:=Hdr.Height-((Stripes-1)*MaxStripHeight);
			GetMem(Tmp, D.Max(Hdr.Width, 7));
				{ ⠦ ⠭  - ଠ ⨭ }
			GetMem(PS[Stripes], Hdr.Width*TailHeight+4);
			TempOffs:=Hdr.Width*(TailHeight-1)+4;
			If UsePalette
				Then ReadRows8Pal(PS[Stripes], TailHeight)
				Else ReadRows8(PS[Stripes], TailHeight);
			TMatrix2(PS[Stripes]^)[0]:=Hdr.Width;
			TMatrix2(PS[Stripes]^)[1]:=TailHeight;
				{ ( ॡ) ⠦ ᪨  BigImages }
			For I:=Stripes-1 DownTo 1 Do
			Begin
				GetMem(PS[I], Hdr.Width*MaxStripHeight+12);
				TBigImage(PS[I]^).SmallWidth:=0;
				TBigImage(PS[I]^).SmallHeight:=0;
				TBigImage(PS[I]^).BigWidth:=Hdr.Width;
				TBigImage(PS[I]^).BigHeight:=MaxStripHeight;
				TempOffs:=Hdr.Width*(MaxStripHeight-1)+12;
				If UsePalette
					Then ReadRows8Pal(PS[I], MaxStripHeight)
					Else ReadRows8(PS[I], MaxStripHeight);
				TBigImage(PS[I]^).Next:=PS[I+1];
			End;

			P:=PS[1];
			FreeMem(Tmp, D.Max(Hdr.Width, 7));
		End;

			{ 4 bit (16 colors) }
		4: Begin
			If UsePalette Then
			Begin
				BlockRead(F, Pal, 64);
				For I:=0 To 15 Do
				Begin
					TempPal[I].R:=Pal[I].R Shr 2;
					TempPal[I].G:=Pal[I].G Shr 2;
					TempPal[I].B:=Pal[I].B Shr 2
				End
			End
			Else Seek(F, Hdr.DataOffs);
			If PalFName<>'' Then
				If D.FileExist(PalFName)
					Then Gfx.LoadPal(PalFName, TempPal)
					Else Log.ErrMsg('Pic', 'IntLoadBMP', 'External palette not found: '+PalFName);
			If UsePalette Then
			Begin
				Pal[0].O:=0;
				For I:=1 To 15 Do
					With TempPal[I] Do
						{Pal[I].O:=RGB2Pal[R Shr 2, G Shr 2, B Shr 2];}
						Pal[I].O:=Gfx.RGB(R, G, B)
			End;
			Seek(F, Hdr.DataOffs);
			TempWidth:=((Hdr.Width+7) Div 8)*8;
			RowTail:=4-(((Hdr.Width+1) Div 2) Mod 4);
			{RowTail:=(TempWidth-Hdr.Width}
			If RowTail=4 Then RowTail:=0;
			WidthDiv2:=(Hdr.Width+1) Div 2;
			MaxStripHeight:=64000 Div Hdr.Width;
			Stripes:=(Hdr.Height+MaxStripHeight-1) Div MaxStripHeight;
			TailHeight:=Hdr.Height-((Stripes-1)*MaxStripHeight);
			If Odd(Hdr.Width)
				Then LastI:=((Hdr.Width+1) Div 2)-1
				Else LastI:=-1;
			GetMem(Tmp, D.Max(WidthDiv2, 7));
				{ ⠦ ⠭  - ଠ ⨭ }
			GetMem(PS[Stripes], Hdr.Width*TailHeight+4);
			TempOffs:=Hdr.Width*(TailHeight-1)+4;
			ReadRows4(PS[Stripes], TailHeight);
			TMatrix2(PS[Stripes]^)[0]:=Hdr.Width;
			TMatrix2(PS[Stripes]^)[1]:=TailHeight;
				{ ( ॡ) ⠦ ᪨  BigImages }
			For I:=Stripes-1 DownTo 1 Do
			Begin
				GetMem(PS[I], Hdr.Width*MaxStripHeight+12);
				TBigImage(PS[I]^).SmallWidth:=0;
				TBigImage(PS[I]^).SmallHeight:=0;
				TBigImage(PS[I]^).BigWidth:=Hdr.Width;
				TBigImage(PS[I]^).BigHeight:=MaxStripHeight;
				TempOffs:=Hdr.Width*(MaxStripHeight-1)+12;
				ReadRows4(PS[I], MaxStripHeight);
				TBigImage(PS[I]^).Next:=PS[I+1];
			End;

			P:=PS[1];
			FreeMem(Tmp, D.Max(WidthDiv2, 7));
		End;

			{ 24 bit (16777216 colors) }
		24: Begin
			{Log.BugMsg('Pic', 'IntLoadBMP', 'Loading 24-bit BMP...');}
			Ini.Select('polit.ini', 'Pic');
			DitherBMP24:=Ini.GetBool('DitherBMP24', True);
			Seek(F, Hdr.DataOffs);
			{TempWidth:=((Hdr.Width+3) Div 4)*4;}
			{TempWidth:=((Hdr.Width+7) Div 8)*8;}
			TempWidth:=(((Hdr.Width*3)+3) Div 4)*4;
			RowTail:=TempWidth-Hdr.Width*3;
			MaxStripHeight:=64000 Div (Hdr.Width);
			Stripes:=(Hdr.Height+MaxStripHeight-1) Div MaxStripHeight;
			TailHeight:=Hdr.Height-((Stripes-1)*MaxStripHeight);
			GetMem(Tmp, D.Max(Hdr.Width*3, 7));
				{ ⠦ ⠭  - ଠ ⨭ }
			{Log.BugMsg('Pic', 'IntLoadBMP', 'Loading tail strip...');}
			GetMem(PS[Stripes], Hdr.Width*TailHeight+4);
			TempOffs:=Hdr.Width*(TailHeight-1)+4;
			If DitherBMP24
				Then ReadRows24Dither(PS[Stripes], TailHeight)
				Else ReadRows24(PS[Stripes], TailHeight);
			TMatrix2(PS[Stripes]^)[0]:=Hdr.Width;
			TMatrix2(PS[Stripes]^)[1]:=TailHeight;
				{ ( ॡ) ⠦ ᪨  BigImages }
			For I:=Stripes-1 DownTo 1 Do
			Begin
				{Log.BugMsg('Pic', 'IntLoadBMP', 'Loading strip N'+D.St(I));}
				GetMem(PS[I], Hdr.Width*MaxStripHeight+12);
				TBigImage(PS[I]^).SmallWidth:=0;
				TBigImage(PS[I]^).SmallHeight:=0;
				TBigImage(PS[I]^).BigWidth:=Hdr.Width;
				TBigImage(PS[I]^).BigHeight:=MaxStripHeight;
				TempOffs:=Hdr.Width*(MaxStripHeight-1)+12;
				If DitherBMP24
					Then ReadRows24Dither(PS[I], MaxStripHeight)
					Else ReadRows24(PS[I], MaxStripHeight);
				TBigImage(PS[I]^).Next:=PS[I+1];
			End;

			P:=PS[1];
			FreeMem(Tmp, D.Max(Hdr.Width*3, 7));
			{Log.BugMsg('Pic', 'IntLoadBMP', 'All OK!');}
		End;
		Else Begin
			Log.ErrMsg('Pic', 'IntLoadBMP', 'Invalid BPP ('+D.St(Hdr.BPP)+'), file '+FName);
			Log.ActMsg('Replacing with black pixel.');
			Gfx.MakeEmptyImage(P)
		End
	End;
	Close(F);
	
End;

Procedure LoadBMP(FName:String; Var P:Pointer);
Begin
	IntLoadBMP(FName, '', False, P)
End;


{************************************************************************}


Procedure LoadCUR(FName:String; Var P:Pointer; Var HotX,HotY:Word);
Const
	Trans:Array[0..15] Of Byte=
		(0, 4, 2, 6, 1, 5, 3, 7, 8, 12, 10, 14, 9, 13, 11, 15);
Type
	TCurHeader=Record
		Res1: Word; { must be 0 }
		Signature: Word; { =0002h }
		CursorsNum: Word;

		Width, Height: Byte;
		Res2: Word;
		HotX, HotY: Word;
		DataSize: LongInt;
		DataOffset: LongInt;

		PaletteOffset: LongInt;
		ImageWidth, ImageHeight2: LongInt;
		PlanesNum: Word;
		BitsPerPixel: Word;
		Res3: LongInt;
		TotalSize: LongInt;
		Res4: Array[1..16] Of Byte
	End;
Var
	Header: TCurHeader;
	Palette: Pointer;
	Image, Mask: Pointer;
	ImagePic: Pointer;
	F: File;
	X, Y: Integer;
	SrcByte, TargByte: Word;
	MaskByte, MaskBit: Word;
	B, CurByte: Byte;
	RealHeight, RealWidth: Word;

	Procedure ReturnBlackPixel;
	Begin
		Gfx.MakeEmptyImage(ImagePic);
		P:=ImagePic;
		HotX:=0;
		HotY:=0;
	End;
Begin
	If Not D.FileExist(FName) Then
	Begin
		Log.ErrMsg('Pic', 'LoadCUR', 'File not found: '+FName);
		Log.ActMsg('Replacing with black pixel');
		ReturnBlackPixel;
		Exit
	End;

	Assign(F, FName);
	Reset(F, 1);
	BlockRead(F, Header, SizeOf(Header));
	If Gfx.ImageSize(Header.Width, Header.Height)>MaxAvail Then
	Begin
		Log.ErrMsg('Pic', 'LoadCUR', 'Not enough memory to load '+FName);
		Log.ActMsg('Replacing with black pixel');
		Gfx.MakeEmptyImage(P);
		Close(F);
		Exit
	End;
	Seek(F, FilePos(F)+(1 Shl Header.BitsPerPixel)*4);

	GetMem(Image, Header.Width*Header.Height*Header.BitsPerPixel Div 8);
	BlockRead(F, Image^, Header.Width*Header.Height*Header.BitsPerPixel Div 8);
	GetMem(Mask, Header.Width*Header.Height Div 8);
	BlockRead(F, Mask^, Header.Width*Header.Height Div 8);
	Close(F);
	LastColorDepth:=Header.BitsPerPixel;
	Case Header.BitsPerPixel Of
		4: Begin
				{  ࠢi ஧i  }
			RealWidth:=0;
			RealHeight:=31;
			For Y:=Header.Height-1 DownTo 0 Do
				For X:=0 To Header.Width-1 Do
				Begin
					B:=TMatrix(Mask^)[Y*4+(X Div 8)];
					If (B And (1 Shl (7-(X Mod 8))))=0 Then
					Begin
						If X>RealWidth Then
							RealWidth:=X;
						If Y<RealHeight Then
							RealHeight:=Y
					End
				End;
			Inc(RealWidth);
			If Odd(RealWidth) Then
				Inc(RealWidth);
			RealHeight:=31-RealHeight;
			Inc(RealHeight);
			GetMem(ImagePic, RealWidth*RealHeight+4);

			For Y:=0 To RealHeight-1 Do
				For X:=0 To (RealWidth Div 2)-1 Do
				Begin
					SrcByte:=(31-Y)*16+X;
					TargByte:=Y*RealWidth+X*2+4;
					MaskByte:=(31-Y)*4+X Div 4;
					MaskBit:=(4-(X Mod 4))*2-1;
					B:=TMatrix(Image^)[SrcByte];

					If (TMatrix(Mask^)[MaskByte] And (1 Shl MaskBit))=0 Then
					Begin
						CurByte:=Trans[B Shr 4];
						If CurByte=0 Then CurByte:=clOpaqueBlack
					End
					Else
						CurByte:=0;
					TMatrix(ImagePic^)[TargByte]:=CurByte;

					Inc(TargByte);
					Dec(MaskBit);

					If (TMatrix(Mask^)[MaskByte] And (1 Shl MaskBit))=0 Then
					Begin
						CurByte:=Trans[B And $0f];
						If CurByte=0 Then CurByte:=clOpaqueBlack
					End
					Else
						CurByte:=0;
					TMatrix(ImagePic^)[TargByte]:=CurByte
				End
		End
		Else Begin
			Log.ErrMsg('Pic', 'LoadCUR', 'Invalid BPP ('+D.St(Header.BitsPerPixel)+
				'), file '+FName);
			Log.ActMsg('Replacing with black pixel.');
			ReturnBlackPixel;
			Exit
		End
	End;

	TMatrix(ImagePic^)[0]:=RealWidth;
	TMatrix(ImagePic^)[1]:=0;
	TMatrix(ImagePic^)[2]:=RealHeight;
	TMatrix(ImagePic^)[3]:=0;
	FreeMem(Image, Header.Width*Header.Height*Header.BitsPerPixel Div 8);
	FreeMem(Mask, Header.Width*Header.Height Div 8);
	P:=ImagePic;
	HotX:=Header.HotX;
	HotY:=Header.HotY
End;


{************************************************************************}


Procedure LoadGIF(FName:String; Var P:Pointer);
Const
	LaceStep: Array[0..3] Of Integer=(8, 8, 4, 2);
	LaceFirst: Array[1..4] Of Integer=(4, 2, 1, 1);
Type
	TGIFHeader=Record
		GIFSig: Array[1..3] Of Char; { "GIF" }
		VerSig: Array[1..3] Of Char; { "87a" / "89a" }
	End;
	TScreenDescr=Record
		Width, Height: Word;
		Flags: Byte;
		BGColor: Byte;
		AspectRatio: Byte;
	End;
	TControlExt=Record
		Flags: Byte;
		DelayTime: Word;
		TranspColor: Byte
	End;
	TImageDescr=Record
		Left, Top: Word;
		Width, Height: Word;
		Flags: Byte
	End;

Var
	F: File;
	Pal: Array[0..255] Of TRGB;
	GIFHdr: TGIFHeader;
	Scr: TScreenDescr;
	Ext: TControlExt;
	Img: TImageDescr;
	Data2: Pointer;
	DataPos, DataSize: Word;
	DataBit: ShortInt;
	DispMethod: Byte;
	UseTransp: Boolean;

	GlobalPal, LocalPal, Interlace: Boolean;
	BPP, GlobalPalBPP, LocalBPP: Byte;
	B, B1: Byte;
	I: Integer;
	CodeSize, OrigCodeSize: Byte;
	ClearCode, EndCode: Word;

	GX2, GY2: Integer;
	GX, GY: Integer;
	CurCode, OldCode: Word;

	{Table: Array[0..4095] Of TString;}
	FirstFree, FirstFreeGlobal: Integer;

	BlockLen: Byte;
	LacePass: Byte;
	XLatPal: Array[0..255] Of Byte;

	MaxStripHeight, Stripes: Word;
	PS: Array[1..35] Of Pointer;
	CurStripe, CurOffset, CurStripeSize: Word;


		{ ******* Table Stuff ******* }
	Procedure InitTable;
	Var
		I: Integer;
	Begin
		For I:=0 To (1 Shl (OrigCodeSize-1))-1 Do
		Begin
			Table^[I].Len:=1;
			GetMem(Table^[I].Data, 1);
			TMatrix(Table^[I].Data^)[0]:=I
		End;
		For I:=(1 Shl (OrigCodeSize-1)) To 4095 Do
			Table^[I].Len:=0;
		FirstFreeGlobal:=1 Shl (CodeSize-1)+2;
		FirstFree:=FirstFreeGlobal;
		{Log.BugMsg('Pic', 'LoadGIF:InitTable', 'Done')}
	End;

	Procedure AddToTable(Index:Integer);
	Begin
		{Log.BugMsg('Pic', 'LoadGIF:AddToTable', 'Adding #'+
			D.St(FirstFree)+' based on #'+D.St(Index));}
		If (Index=ClearCode) Or (Index=EndCode) Then Exit;
		If Table^[FirstFree].Len>0 Then
		Begin
			{Log.ActMsg('Item was used, freeing it');}
			FreeMem(Table^[FirstFree].Data, Table^[FirstFree].Len)
		End;
		Table^[FirstFree].Len:=Table^[OldCode].Len+1;
		GetMem(Table^[FirstFree].Data, Table^[FirstFree].Len);
		Move(Table^[OldCode].Data^, Table^[FirstFree].Data^, Table^[OldCode].Len);
		TMatrix(Table^[FirstFree].Data^)[Table^[OldCode].Len]:=
			TMatrix(Table^[Index].Data^)[0];
		Inc(FirstFree);
		If FirstFree=(1 Shl CodeSize) Then
			If CodeSize<12 Then
				Inc(CodeSize)
	End;

	Procedure FreeTable;
	Var
		I: Integer;
	Begin
		For I:=0 To 4095 Do
			If Table^[I].Len>0 Then
			Begin
				{Log.BugMsg('Pic', 'LoadGIF:FreeTable', 'Freeing item $'+
					D.St(I)+', its len='+D.St(Table[I].Len));}
				FreeMem(Table^[I].Data, Table^[I].Len)
			End
	End;

		{ ******* Inputting stuff ******* }
		{ super-optimal, Cyberhead gotta love it :) }
	Function GetNextCode: Word;
	Var
		TempCode, ResCode: Word;
		GotBits, RemainedInByte: Integer;
	Begin
		ResCode:=0;
		GotBits:=0;
		RemainedInByte:=8-DataBit;
		Repeat
			If CodeSize-GotBits<=RemainedInByte Then
			Begin {  筮 i  ii }
				TempCode:=TMatrix(Data2^)[DataPos] Shr DataBit;
				TempCode:=TempCode And ((1 Shl (CodeSize-GotBits))-1);
				ResCode:=ResCode Or (TempCode Shl GotBits);
				Inc(DataBit, CodeSize-GotBits);
				If DataBit=8 Then
				Begin
					Inc(DataPos);
					DataBit:=0;
					If DataPos=BlockLen Then
					Begin
						BlockRead(F, BlockLen, 1);
						BlockRead(F, Data2^, BlockLen);
						DataPos:=0
					End
				End;
				GotBits:=CodeSize
			End
			Else Begin { 㤥   i i쪮 i }
				TempCode:=TMatrix(Data2^)[DataPos] Shr DataBit;
				ResCode:=ResCode Or (TempCode Shl GotBits);
				Inc(GotBits, RemainedInByte);
				Inc(DataPos);
				DataBit:=0;
				RemainedInByte:=8;
				If DataPos=BlockLen Then
				Begin
					BlockRead(F, BlockLen, 1);
					BlockRead(F, Data2^, BlockLen);
					DataPos:=0
				End
			End
		Until GotBits=CodeSize;
		GetNextCode:=ResCode
	End;

		{ ******* Outputting Stuff ******* }
	Procedure OutPixel(B:Byte);
	Var
		DI: Integer;
	Begin
		TMatrix(PS[CurStripe]^)[CurOffset]:=XLatPal[B];
		If GX=GX2 Then OnProgress;
		If Interlace Then
		Begin
			If GX=GX2 Then
			Begin
				GX:=0;
				Inc(GY, LaceStep[LacePass]);
				If GY>GY2 Then
				Begin
					Inc(LacePass);
					GY:=LaceFirst[LacePass];
				End;
				CurStripe:=GY Div MaxStripHeight;
				If CurStripe+1=Stripes
					Then CurOffset:=4+(GY-CurStripe*MaxStripHeight)*Img.Width
					Else CurOffset:=12+(GY-CurStripe*MaxStripHeight)*Img.Width;
				Inc(CurStripe)
			End
			Else Begin
				Inc(GX);
				Inc(CurOffset)
			End
		End
		Else Begin
			If GX=GX2 Then GX:=0;
			Inc(GX);
			Inc(CurOffset);
			If CurOffset=CurStripeSize Then
			Begin
				Inc(CurStripe);
				If CurStripe=Stripes Then
				Begin
					CurOffset:=4;
					Dec(CurStripeSize, 8)
				End
				Else CurOffset:=12
			End
		End;
	End;

	Procedure OutString(Index:Integer);
	Var
		I, I2: Integer;
	Begin
		I2:=Table^[Index].Len-1;
		For I:=0 To I2 Do
			OutPixel(TMatrix(Table^[Index].Data^)[I]);
	End;

Begin
	{Log.BugMsg('Pic', 'LoadGIF', 'Starting...');}
	If SizeOf(TGifTable)>MaxAvail Then
	Begin
		Log.ErrMsg('Pic', 'LoadGIF', 'Not enough memory to load '+FName);
		Log.ActMsg('Cannot even prepare to load it :)');
		Log.ActMsg('Returning black pixel');
		Gfx.MakeEmptyImage(P);
		Close(F);
		Exit
	End;
	New(Table);
	Assign(F, FName);
	Reset(F, 1);

		{ GIF Header }
	BlockRead(F, GIFHdr, SizeOf(GIFHdr));
	If GIFHdr.VerSig[2]='9' Then
		Log.ErrMsg('Pic', 'LoadGIF', 'Loading GIF89a (it can crash the program)');

		{ Logical Screen Descriptor (LSD ;) }
	OnProgress;
	BlockRead(F, Scr, SizeOf(Scr));
	GlobalPal:=(Scr.Flags And $80)=$80;
	BPP:=((Scr.Flags And $70) Shr 4)+1;
	LastColorDepth:=BPP;
	GlobalPalBPP:=(Scr.Flags And $07)+1;
	If GlobalPal Then
	Begin
		{Log.BugMsg('Pic', 'LoadGIF', 'Loading palette...');}
		BlockRead(F, Pal, (1 Shl {BPP}GlobalPalBPP)*3);
		For I:=0 To 255 Do
			With Pal[I] Do
			Begin
				R:=R Shr 2;
				G:=G Shr 2;
				B:=B Shr 2;
				{XLatPal[I]:=RGB2Pal[R Shr 2, G Shr 2, B Shr 2]}
				XLatPal[I]:=Gfx.RGB(R, G, B)
			End
	End;

		{ Search for Image Descriptor }
	DispMethod:=0;
	UseTransp:=False;
	Repeat
		BlockRead(F, B, 1);
		If B=Byte('!') Then
		Begin
			{Log.BugMsg('Pic', 'LoadGIF', 'Processing GIF extension block...');}
			BlockRead(F, B, 1); { extension label }
			BlockRead(F, B1, 1); { size }
			If B=$f9 Then
			Begin { it's a graphics control extension block }
				{Log.BugMsg('Pic', 'LoadGIF', 'It''s a graphics control extension block');}
				BlockRead(F, Ext, SizeOf(Ext));
				DispMethod:=(Ext.Flags And $1c) Shr 2;
				UseTransp:=((Ext.Flags And 1)=1);
				If UseTransp Then
					XLatPal[Ext.TranspColor]:={20}248;
				BlockRead(F, B, 1);
				{Log.BugMsg('Pic', 'LoadGIF', 'done.');}
			End
			Else Repeat { skip all data blocks }
				{Log.BugMsg('Pic', 'LoadGIF', 'Unknown block: tag '+
					D.IntToHex(B, 2)+' (dec. '+D.St(B)+', size '+
					D.St(B1)+')');}
				Seek(F, FilePos(F)+B1);
				If Not EOF(F)
					Then BlockRead(F, B1, 1)
					Else B1:=0
			Until B1=0
		End
	Until (B=Byte(',')) Or EOF(F);

	If EOF(F) Then
	Begin
		Log.ErrMsg('Pic', 'LoadGIF', 'Unexpected end of file: '+FName);
		Gfx.MakeEmptyImage(P);
		Dispose(Table);
		Exit
	End;

	{Log.BugMsg('Pic', 'LoadGIF', 'Image start found!');}
	BlockRead(F, Img, SizeOf(Img));
	If Gfx.BigImageSize(0, 0, Img.Width, Img.Height)>MaxAvail Then
	Begin
		Log.ErrMsg('Pic', 'LoadGIF', 'Not enough memory to load '+FName);
		Log.ActMsg('Replacing with black pixel');
		Gfx.MakeEmptyImage(P);
		Close(F);
		Exit
	End;
	LocalPal:=(Img.Flags And $80)=$80;
	Interlace:=(Img.Flags And $40)=$40;
	LocalBPP:=(Img.Flags And $07)+1;
	If LocalPal Then
	Begin
		{Log.BugMsg('Pic', 'LoadGIF', 'Loading local palette...');}
		BlockRead(F, Pal, (1 Shl LocalBPP)*3);
		For I:=0 To (1 Shl LocalBPP)-1 Do
			With Pal[I] Do
			Begin
				R:=R Shr 2;
				G:=G Shr 2;
				B:=B Shr 2;
				{XLatPal[I]:=RGB2Pal[R Shr 2, G Shr 2, B Shr 2]}
				XLatPal[I]:=Gfx.RGB(R, G, B)
			End;
		If UseTransp Then
			XLatPal[Ext.TranspColor]:={20}248;
		{Log.BugMsg('Pic', 'LoadGIF', 'done.');}
	End;

		{ Raster Data Block }
	BlockRead(F, OrigCodeSize, 1);
	If OrigCodeSize=1
		Then OrigCodeSize:=3
		Else Inc(OrigCodeSize);
	CodeSize:=OrigCodeSize;

		{ Prepare to load stripes }
	{Log.BugMsg('Pic', 'LoadGIF', 'Preparing to load stripes...');}
	MaxStripHeight:=64000 Div Img.Width;
	Stripes:=(Img.Height+MaxStripHeight-1) Div MaxStripHeight;
	{Log.BugMsg('Pic', 'LoadGIF', 'Stripes='+D.St(Stripes));}
	For I:=1 To Stripes-1 Do
	Begin
		{Log.BugMsg('Pic', 'LoadGIF', 'Preparing stripe N'+D.St(I)+
			', MaxAvail='+D.StL(MaxAvail));}
		GetMem(PS[I], Img.Width*MaxStripHeight+12);
		TBigImage(PS[I]^).SmallWidth:=0;
		TBigImage(PS[I]^).SmallHeight:=0;
		TBigImage(PS[I]^).BigWidth:=Img.Width;
		TBigImage(PS[I]^).BigHeight:=MaxStripHeight;
		If I>1 Then
			TBigImage(PS[I-1]^).Next:=PS[I]
	End;
	{Log.BugMsg('Pic', 'LoadGIF', 'Preparing last stripe, MaxAvail='+
		D.StL(MaxAvail));
	Log.ActMsg('Width='+D.St(Img.Width)+', height='+D.St(Img.Height));}
	GetMem(PS[Stripes], Img.Width*(Img.Height-((Stripes-1)*MaxStripHeight))+4);
	FillChar(PS[Stripes]^,
		Img.Width*(Img.Height-((Stripes-1)*MaxStripHeight))+4, 0); {?}
	TBigImage(PS[Stripes]^).SmallWidth:=Img.Width;
	TBigImage(PS[Stripes]^).SmallHeight:=
		Img.Height-((Stripes-1)*MaxStripHeight);
	If Stripes>1 Then
		TBigImage(PS[Stripes-1]^).Next:=PS[Stripes];
	CurStripe:=1;
	If Stripes=1 Then
	Begin
		CurOffset:=4;
		CurStripeSize:=4+Img.Width*Img.Height
	End
	Else Begin
		CurOffset:=12;
		CurStripeSize:=12+Img.Width*MaxStripHeight
	End;

		{ Load Data }
	GetMem(Data2, 255);
	BlockRead(F, BlockLen, 1);
	BlockRead(F, Data2^, BlockLen);
	DataPos:=0;
	DataBit:={-1}0;

	GX2:=Img.Width-1;
	GY2:=Img.Height-1;
	GX:=0;
	GY:=0;
	LacePass:=0;

	InitTable;
	ClearCode:=1 Shl (CodeSize-1);
	EndCode:=ClearCode+1;
	CurCode:=ClearCode;

	OnProgress;
	{Log.BugMsg('Pic', 'LoadGIF', 'Entering the main loop...');}
	Repeat
		OldCode:=CurCode;
		CurCode:=GetNextCode;
		If CurCode=ClearCode Then
		Begin
			FirstFree:=FirstFreeGlobal;
			CodeSize:=OrigCodeSize;
			CurCode:=GetNextCode;
			If CurCode=EndCode Then Break;
			OutPixel(CurCode And $FF{13})
		End
		Else If CurCode=EndCode
			Then Begin
				Log.BugMsg('Pic', 'LoadGIF', 'EndCode encountered, terminating');
				Break
			End
			Else Begin
				If CurCode<FirstFree Then
				Begin { present in strings table }
					OutString(CurCode);
					If OldCode<>ClearCode Then
						AddToTable(CurCode)
				End
				Else Begin { absent in strings table }
					AddToTable(OldCode);
					OutString(FirstFree-1)
				End
			End
	Until (GY>GY2) Or EOF(F);
	Close(F);
	If IOResult=IOResult Then ;
	FreeMem(Data2, 255);
	FreeTable;
	Dispose(Table);
	{Close(Log)}
	P:=PS[1]
End;


{************************************************************************}


Procedure LoadJPG(FName:String; Var VP:Pointer);
Const
	MaxBufSize=4096;

Var
	PictureFile:file;                              { Work file variable }
	FilePtr:word;                                 { Counter block bytes }
	Width,Height:word;                                     { Image Size }
	planes:longint;                               { Color Planes Number }
	method:byte;                                   { Compression method }
	Marker:array [$C0..$FE] of boolean;                { Marker present }

	ComponentID:array [1..4] of record C,H,V,T:byte end; { Component ID }
									  { (No, Sampling factors, Quantization Table) }
	Huff_tab: ^THuff_Table;
	ZigZag: array [0..3,0..63] of word;            { Quantization Tables }
	Scan: record
		Component,TD,TA: array [1..4] of byte;      { Scan Header}
		Ss,Se,Ah,Al:byte
	end;  { (Tables, etc.) }
	ACT:array [0..1,0..3] of byte;        { Arithmetic Table (not used) }
	RestartInterval:word;                            { Restart Interval }
	sum,idct:{single}real;                             { IDCT variables }
	Vector:array [0..63] of integer;             { Vector (64 elements) }
	DC:array [1.. 3] of integer;                  { DC coefficients }
	v,w:word;
	r,g,b,m,vv,hh:byte;
	X,Y,Z:longint;
	xx,yy:integer;

	ErrR, ErrG, ErrB: Integer;
	P: Array[1..35] Of Pointer;
	TempData: Array[0..31, 0..15, 1..3] Of Byte;
	CosTrans: Array[0..7, 0..7] Of Real;
	ByteXlat: Array[0..255] Of Byte;
	Buf: Pointer;
	BufPos, BufSize: Integer;
	MaxStripHeight, Stripes, TailHeight: Word;
	CurStripe, CurStripeHeader: Integer;

Const
	ZigZag2Table:array [0..7,0..7] of byte=(( 0, 1, 5, 6,14,15,27,28),
														 ( 2, 4, 7,13,16,26,29,42),
														 ( 3, 8,12,17,25,30,41,43),
														 ( 9,11,18,24,31,40,44,53),
														 (10,19,23,32,39,45,52,54),
														 (20,22,33,38,46,51,55,60),
														 (21,34,37,47,50,56,59,61),
														 (35,36,48,49,57,58,62,63));

Function ReadByte: Byte;
begin
	BlockRead(PictureFile, Current_byte, 1);
	ReadByte:=Current_byte;
	Inc(FilePtr);
	Current_bit:=0
end;

Function ReadByteBuffered: Byte;
Begin
	Current_byte:=TMatrix(Buf^)[BufPos];
	ReadByteBuffered:=Current_Byte;
	Inc(BufPos);
	If BufPos>=BufSize Then
	Begin
		BlockRead(PictureFile, Buf^, MaxBufSize, BufSize);
		BufPos:=0
	End;
	Current_bit:=0
End;


function ReadWord:word;
var
	Current_word: word;
begin
  BlockRead(PictureFile,Current_word,2);
			ReadWord:=Swap(Current_word);
  inc(FilePtr,2)
end;


function Read1bit:byte; { Take one bit from Current Byte }
begin
	if Current_bit=0 then
	begin
		ReadByteBuffered;
		if Current_byte=$FF then
		begin
			Repeat
				ReadByteBuffered
			Until Current_byte<$FF;
			Case Current_byte Of
				$d0..$d7: Begin
					FillChar(DC, SizeOf(DC),0);
					ReadByteBuffered
				End;
				0: Current_byte:=$FF;
				else ReadByteBuffered
			End
		end;
		Current_byte:=ByteXlat[Current_byte] { flip bits }
	end;

	Read1bit:=Current_Byte And 1;
	Asm
		shr	Current_byte, 1
		inc	Current_bit
		cmp	Current_bit, 8
		jnz	@L10
		mov	Current_bit, 0
	@L10:
	End;
end;

Procedure NextBit(var V:longint);
Begin
	V:=(V shl 1)+Read1bit
End;

Function ReadBits(bits:byte):word; { Take few bits }
Var
	i: byte;
	L: longint;
begin
	L:=0;
	For i:=1 to bits do
		L:=(L Shl 1)+Read1bit;
	ReadBits:=L
end;

function Hi4(b8:byte):byte; assembler;
asm
	mov	al, b8
	shr	al, 4
end;

function Lo4(b8:byte):byte; assembler;
asm
	mov	al, b8
	and	al, 0fh
end;

function Bits2Integer(bits:byte; value:word): integer;
begin
	if (value and (1 shl (bits-1))>0)
		then Bits2Integer:=value
		else Bits2Integer:=-(Integer(value) xor (1 shl bits-1))
end;

function HuffmanCode(T,C:byte): word; { Find Huffman Code from bitstream }
var
	i,L:byte;
	V:longint;
begin
	L:=0;
	V:=0;
	Repeat
		inc(L);
		NextBit(V);
		For i:=0 to $FF do
			if (Huff_Tab^.C[T,C,i].L=L) and (Huff_Tab^.C[T,C,i].V=V) then
			begin
				HuffmanCode:=i;
				Exit
			end;
	Until L=16;
	HuffmanCode:=V
end;

procedure YCbCr2RGB(Y,Cb,Cr:integer; var R,G,B:byte); { YCbCr -> RGB }
var
	RR,GG,BB:integer;                             { color conversion }
begin
	RR:=Round(Y                 +1.40200*(Cr-128));
	GG:=Round(Y-0.34414*(Cb-128)-0.71414*(Cr-128));
	BB:=Round(Y+1.77200*(Cb-128));
	if RR<0 then R:=0 else if RR>255 then R:=255 else R:=RR;
	if GG<0 then G:=0 else if GG>255 then G:=255 else G:=GG;
	if BB<0 then B:=0 else if BB>255 then B:=255 else B:=BB
end;



Procedure PutPixelRGB(VX,VY:word; VR,VG,VB:byte); { Set color (True Color only) }
begin
	TR:=VR+ErrR;
	TG:=VG+ErrG;
	TB:=VB+ErrB;

	Asm
		cmp	TR, 0
		jge	@L1
		mov	TR, 0
		jmp	@L2
	@L1:
		cmp	TR, 255
		jle	@L2
		mov	TR, 255
	@L2:
		cmp	TG, 0
		jge	@L3
		mov	TG, 0
		jmp	@L4
	@L3:
		cmp	TG, 255
		jle	@L4
		mov	TG, 255
	@L4:
		cmp	TB, 0
		jge	@L5
		mov	TB, 0
		jmp	@L6
	@L5:
		cmp	TB, 255
		jle	@L6
		mov	TB, 255
	@L6:
	End;

	{Log.BugMsg('Pic', 'PutPixelRGB', 'TR='+D.St(TR)+' TG='+D.St(TG)+'TB='+D.St(TB));}
	C:=Gfx.RGB2Pal[TR Shr 4, TG Shr 4, TB Shr 4];
	ErrR:=TR-Gfx.Palette[C].R Shl 2;
	ErrG:=TG-Gfx.Palette[C].G Shl 2;
	ErrB:=TB-Gfx.Palette[C].B Shl 2;

	TMatrix(P[CurStripe]^)[CurStripeHeader+(VY Mod MaxStripHeight)*Width+VX]:=C;
end;

Procedure PutPixelMono(VX,VY:word; VL:byte); { Set mono color }
var
	TempOffset: Word;
begin
	TMatrix(P[CurStripe]^)[CurStripeHeader+(VY Mod MaxStripHeight)*Width+VX]:=
		224+(VL Shr 3)
end;



Procedure PreparePrecalcTables;
Var
	XX, W: Integer;
	OrigB, OrigB2, ProcB, V, B: Byte;
Begin
		{ Prepare CosTrans }
	For XX:=0 To 7 Do
		For W:=0 To 7 Do
			CosTrans[XX, W]:=Cos((2*XX+1)*W*Pi/16);

		{ Prepare ByteXlat }
	For OrigB:=0 To 255 Do
	Begin
		OrigB2:=OrigB;
		ProcB:=0;
		For V:=0 To 7 Do
		Begin
			ProcB:=ProcB Shl 1+(OrigB2 And 1);
			OrigB2:=OrigB2 Shr 1
		End;
		ByteXlat[OrigB]:=ProcB
	End;

	ProcB:=OrigB
End;

Begin (**************************************** MAIN PROCEDURE ********)

	If Pos('.', FName)=0 Then FName:=FName+'.JPG';
	If Not D.FileExist(FName) Then
	Begin
		Log.ErrMsg('Pic', 'LoadJPG', 'File not found: '+FName);
		Log.ActMsg('Returning black pixel');
		Gfx.MakeEmptyImage(VP);
		Exit
	End;

	Assign(PictureFile, FName);
	Reset(PictureFile,1);
	OnProgress;
	If SizeOf(Huff_Tab)>MaxAvail Then
	Begin
		Log.ErrMsg('Pic', 'LoadJPG', 'Not enough memory to load '+FName);
		Log.ActMsg('Cannot even prepare to load it :)');
		Log.ActMsg('Returning black pixel');
		Close(PictureFile);
		Gfx.MakeEmptyImage(VP);
		Exit
	End;
	New(Huff_tab);
	Fillchar(Huff_Tab^, SizeOf(THuff_Table), 0);
	For m:=$C0 to $FE do
		Marker[m]:=False;
	method:=0;
	RestartInterval:=0;

	{Log.BugMsg('Pic', 'LoadJPG', 'Reading headers...');}
	Repeat
		BlockRead(PictureFile,v,2);
		if Lo(v)<>$FF then
		begin
			Log.ErrMsg('Pic', 'LoadJPG', 'Invalid file format (unknown tag)');
			Log.ActMsg('Returning black pixel');
			Close(PictureFile);
			Gfx.MakeEmptyImage(VP);
			Dispose(Huff_tab);
			Exit
		end;
		b:=Hi(v); Marker[b]:=True;
		Z:=FilePos(PictureFile);
		if (b<>$D8) and (b<>$D9) then
		begin
			BlockRead(PictureFile,v,2);
			v:=Swap(v);
			Case b of
				$C0,$C1,$C2,$C3,$C5,$C6,$C7,$C9,$CA,$CB,$CD,$CE,$CF: begin
					{Log.BugMsg('Pic', 'LoadJPG', 'Reading main image parameters...');}
					vv  :=ReadByte;                   { Main Image Parameters }
					Height:=ReadWord;
					Width :=ReadWord;
					planes:=ReadByte;
					if (vv<>8) or ((planes<>1) and (planes<>3)) then
					begin
						Log.ErrMsg('Pic', 'LoadJPG', 'Invalid file format');
						If VV<>8 Then Log.ActMsg('Bit depth is'+D.St(VV)+' (only 8-bit images supported)');
						If ((planes<>1) and (planes<>3)) Then
							Log.ActMsg('There are '+D.St(Planes)+'bit planes. Only RGB (3 planes) and greyscale (1 plane) images supported');
						Log.ActMsg('Returning black pixel');
						Close(PictureFile);
						Dispose(Huff_tab);
						Gfx.MakeEmptyImage(VP);
						Exit
					end;
					LastColorDepth:=Planes*VV;
					For hh:=1 to planes do
					begin
						ComponentID[hh].C:=ReadByte; vv:=ReadByte;
						ComponentID[hh].H:= Hi4(vv);
						ComponentID[hh].V:= Lo4(vv);
						ComponentID[hh].T:=ReadByte
					end;
					method:=b
				end;

				$C4: begin
					{Log.BugMsg('Pic', 'LoadJPG', 'Reading Huffman tables...');}
					FilePtr:=0;
					Repeat                    { Read & compile Huffman Tables }
						hh:=ReadByte;
						For vv:=1 to 16 do
							Huff_Tab^.L[vv]:=ReadByte;
						For vv:=1 to 16 do
							For m:=1 to Huff_Tab^.L[vv] do
								Huff_Tab^.V[vv, m]:=ReadByte;
						w:=0;
						For vv:=1 to 16 do
						begin
							For m :=1 to Huff_Tab^.L[vv] do
							begin
								Huff_Tab^.C[Hi4(hh), Lo4(hh), Huff_Tab^.V[vv,m]].L:=vv;
								Huff_Tab^.C[Hi4(hh), Lo4(hh), Huff_Tab^.V[vv,m]].V:=w;
								inc(w)
							end;
							w:=w shl 1
						end
					Until FilePtr>=v-2
				end;

				$CC: begin FilePtr:=0;
					{Log.BugMsg('Pic', 'LoadJPG', 'Reading arithmetic tables...');}
					Repeat              { Arithmetic Coding Tables (not used) }
						hh:=ReadByte;
						ACT[Hi4(hh),Lo4(hh)]:=ReadByte
					Until FilePtr>=v-2
				end;

				$DA: begin
					{Log.BugMsg('Pic', 'LoadJPG', 'Reading start of scan...');}
					m:=ReadByte;                              { START OF SCAN }
					For hh:=1 to m do
					begin
						Scan.Component[hh]:=ReadByte;
						vv:=ReadByte;
						Scan.TD[hh]:=Hi4(vv);
						Scan.TA[hh]:=Lo4(vv)
					end;
					Scan.Ss:=ReadByte;
					Scan.Se:=ReadByte;
					vv:=ReadByte;
					Scan.Ah:=Hi4(vv);
					Scan.Al:=Lo4(vv)
				end;

				$DB: begin
					{Log.BugMsg('Pic', 'LoadJPG', 'Reading quantization tables...');}
					FilePtr:=0;
					Repeat                       { Define Quantization Tables }
						hh:=ReadByte;
						For vv:=0 to $3F do
							if Hi4(hh)=0
								then ZigZag[Lo(hh),vv]:=ReadByte
								else ZigZag[Lo(hh),vv]:=ReadWord
					Until FilePtr>=v-2
				end;

				$DD: begin
					RestartInterval:=ReadWord
				end
			End;

			Seek(PictureFile,Z+v);
			if IOResult<>0 then
			begin
				Log.ErrMsg('Pic', 'LoadJPG', 'Disk error (cannot seek to the next tag)');
				Log.ActMsg('Returning black pixel');
				Close(PictureFile);
				Dispose(Huff_tab);
				Gfx.MakeEmptyImage(VP);
				Exit
			end
		end
	Until (b=$D9) or (b=$DA);
	{Log.BugMsg('Pic', 'LoadJPG', 'Complete reading header!');}

	if (method<>$C0) or (b=$D9) then
	begin
		Log.ErrMsg('Pic', 'LoadJPG', 'Unknown compression method (only Baseline method supported)');
		Log.ActMsg('Returning black pixel');
		Close(PictureFile);
		Dispose(Huff_tab);
		Gfx.MakeEmptyImage(VP);
		Exit
	end;

	If Gfx.BigImageSize(0, 0, Width, Height)>MaxAvail Then
	Begin
		Log.ErrMsg('Pic', 'LoadJPG', 'Not enough memory to load '+FName);
		Log.ActMsg('Returning black pixel');
		Close(PictureFile);
		Dispose(Huff_tab);
		Gfx.MakeEmptyImage(VP);
		Exit
	End;

	MaxStripHeight:=64000 Div Width;
	MaxStripHeight:=(MaxStripHeight Div 16)*16;
	Stripes:=(Height+MaxStripHeight-1) Div MaxStripHeight;
	TailHeight:=Height-((Stripes-1)*MaxStripHeight);

	{Log.BugMsg('Pic', 'LoadJPG', 'Stripes='+D.St(Stripes));}
	For CurStripe:=1 To Stripes-1 Do
	Begin
		{Log.BugMsg('Pic', 'LoadJPG', 'Preparing stripe N'+D.St(CurStripe)+
			', MaxAvail='+D.StL(MaxAvail));}
		GetMem(P[CurStripe], Width*MaxStripHeight+12);
		TBigImage(P[CurStripe]^).SmallWidth:=0;
		TBigImage(P[CurStripe]^).SmallHeight:=0;
		TBigImage(P[CurStripe]^).BigWidth:=Width;
		TBigImage(P[CurStripe]^).BigHeight:=MaxStripHeight;
		If CurStripe>1 Then
			TBigImage(P[CurStripe-1]^).Next:=P[CurStripe]
	End;
	{Log.BugMsg('Pic', 'LoadJPG', 'Preparing last stripe, MaxAvail='+
		D.StL(MaxAvail));
	Log.ActMsg('Width='+D.St(Width)+', height='+D.St(Height));}
	GetMem(P[Stripes], Width*(Height-((Stripes-1)*MaxStripHeight))+4);
	TBigImage(P[Stripes]^).SmallWidth:=Width;
	TBigImage(P[Stripes]^).SmallHeight:=Height-((Stripes-1)*MaxStripHeight);
	If Stripes>1 Then
		TBigImage(P[Stripes-1]^).Next:=P[Stripes];
	CurStripe:=1;
	If Stripes=1
		Then CurStripeHeader:=4
		Else CurStripeHeader:=12;

	{Log.BugMsg('Pic', 'LoadJPG', 'Stripes OK, preparing to start...');}
	ErrR:=0;
	ErrG:=0;
	ErrB:=0;
	PreparePrecalcTables;

	GetMem(Buf, MaxBufSize);
	BlockRead(PictureFile, Buf^, MaxBufSize, BufSize);
	BufPos:=0;
	OnProgress;

	{Log.BugMsg('Pic', 'LoadJPG', 'Entering main loop...');}
	Case method of
		$C0: begin                                       { Baseline method }
			if not (Marker[$C4] and Marker[$DB]) then
			begin
				Log.ErrMsg('Pic', 'LoadJPG', 'File is corrupted (table markers not found)');
				Log.ActMsg('Returning black pixel');
				Close(PictureFile);
				Dispose(Huff_tab);
				FreeMem(Buf, MaxBufSize);
				Gfx.MakeEmptyImage(VP);
				Exit
			end;

			FillChar(DC,SizeOf(DC),0);
			Y:=0;
			Repeat
				X:=0;
				Repeat
					For b:=1 to planes do
						For vv:=1 to ComponentID[b].V do
							For hh:=1 to ComponentID[b].H do
							Begin
								Z:=HuffmanCode(0,Scan.TD[b]);
								Vector[0]:=DC[b]+Bits2Integer(Lo4(Byte(Z)),ReadBits(Lo4(Byte(Z))));
								DC[b]:=Vector[0];
								xx:=1;
								Repeat
									Z:=HuffmanCode(1,Scan.TA[b]);
									if Z=0
										then Repeat
											Vector[xx]:=0;
											Inc(xx)
										Until xx>=64
										else begin
											yy:=xx+Hi4(Z);
											While xx<yy do
											begin
												Vector[xx]:=0;
												inc(xx)
											end;
											Vector[xx]:=Bits2Integer(Lo4(Z),
												ReadBits(Lo4(Z)));
											inc(xx)
										end
								Until xx>=64;

								For yy:=0 to 7 do
									For xx:=0 to 7 do
									Begin
										sum:=0;
										For v:=0 to 7 do
											For w:=0 to 7 do
											begin
												m:=ZigZag2Table[v,w];
												idct:=Vector[m]*
													ZigZag[ComponentID[b].T,m]*
													CosTrans[XX, W]*CosTrans[YY, V];
												if w=0 then idct:=idct/sqrt(2);
												if v=0 then idct:=idct/sqrt(2);
												sum:=sum+idct
											end;
										w:=(hh-1)*8+xx;
										v:=(vv-1)*8+yy;
										if (X+w<Width) and (Y+v<Height) then
										begin
											Z:=Round(sum/4)+128;
											if Z<0 then Z:=0;
											if Z>255 then Z:=255;
											Case B Of
												1: TempData[W, V, 1]:=Z;
												2: TempData[W, V, 2]:=Z;
												3: TempData[W, V, 3]:=Z
											End
										end
									end
							End; { for b:=1 to planes }

					Case Planes Of
						1: Begin
							For yy:=ComponentID[1].V*8-1 downto 0 do
								For xx:=ComponentID[1].H*8-1 downto 0 do
									PutPixelMono(X+xx, Y+yy, TempData[XX, YY, 1])
						End;
						3: Begin
							For yy:=ComponentID[1].V*8-1 downto 0 do
								For xx:=ComponentID[1].H*8-1 downto 0 do
									If (X+xx<Width) and (Y+yy<Height) Then
									Begin
										Z:=TempData[XX, YY, 1];
										V:=TempData[xx*ComponentID[2].H div ComponentID[1].H,
											yy*ComponentID[2].V div ComponentID[1].V, 2];
										W:=TempData[xx*ComponentID[3].H div ComponentID[1].H,
											yy*ComponentID[3].V div ComponentID[1].V, 3];

										YCbCr2RGB(Z,v,w,r,g,b);
										PutPixelRGB(X+xx,Y+yy,r,g,b)
									End
						End
					End;

					{Log.BugMsg('Pic', 'LoadJPG', 'One block OK');}
					Inc(X, ComponentID[1].H*8);
					OnProgress
				Until X>=Width;
				{Log.BugMsg('Pic', 'LoadJPG', 'One row OK');}
				if RestartInterval>0 then Current_bit:=0;
				Inc(Y, ComponentID[1].V*8);
				Gfx.PutPixel(0, Y, 255);
				CurStripe:=(Y Div MaxStripHeight)+1;
				If CurStripe=Stripes
					Then CurStripeHeader:=4
					Else CurStripeHeader:=12;
			Until Y>=Height
		end;
										  { Other compression methods }
	End; { case method }
	Close(PictureFile);
	Dispose(Huff_tab);
	FreeMem(Buf, MaxBufSize);
	VP:=P[1]
End;

{Procedure LoadPCX(FName:String; Var P:Pointer);
Begin
	SGraph.LoadPCXToPtr(FName, P)
End;}









Begin
	LastColorDepth:=0;
	OnProgress:=Dummy
End.