{ ************ Picture control ************ }
Type
	TPicCtl=Record
		Picture: Pointer;
		Beveled, Big, Transp: Boolean;
	End;

{Procedure PicCtl_DrawBevel(Me:PControl);
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then Exit;
	With Me^.Place Do
	Begin
		Kernel.BeginPaintCoord(X1, Y1, X2, Y2);
		Gfx.Rectangle(X1, Y1, X2, Y2, clWhite);
		Gfx.Rectangle(X1+1, Y1+1, X2-1, Y2-1, clMidGray);
		Kernel.EndPaint
	End
End;}


Procedure PicCtl_IntDraw(Me:PControl);
Var
	Delta: Integer;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;
	With Me^, TPicCtl(Data^), Place Do
	Begin
		{If Picture=Nil
			Then Log.ActMsg('Picture=Nil')
			Else Log.ActMsg('Picture<>Nil');}
		If Beveled Then
		Begin
			Gfx.Rectangle(X1, Y1, X2, Y2, Kernel.ClrStatic);
			Gfx.Rectangle(X1+1, Y1+1, X2-1, Y2-1, Kernel.ClrWinBG);
			Gfx.Bar(X1+2, Y1+2, X2-2, Y2-2, Kernel.ClrDisabled);
			Delta:=3
		End
		Else Delta:=0;

		If Picture<>Nil Then
			If Big
				Then If Transp
					Then Gfx.PutSpriteX8(X1+Delta, Y1+Delta, Picture)
					Else Gfx.PutImageX8(X1+Delta, Y1+Delta, Picture)
				Else If Transp
					Then Gfx.PutBigSprite(X1+Delta, Y1+Delta, Picture)
					Else Gfx.PutBigImage(X1+Delta, Y1+Delta, Picture)


		(*If Beveled Then
		Begin
			Gfx.Rectangle(X1, Y1, X2, Y2, Kernel.ClrStatic);
			Gfx.Rectangle(X1+1, Y1+1, X2-1, Y2-1, Kernel.ClrWinBG);
			Gfx.Bar(X1+2, Y1+2, X2-2, Y2-2, Kernel.ClrDisabled);
			If Picture<>Nil Then
				If Big
					Then Gfx.PutSpriteX8(X1+3, Y1+3, Picture)
					Else Gfx.PutBigSprite(X1+3, Y1+3, Picture)
					{Else Gfx.PutBigImage(X1+3, Y1+3, Picture)}
		End
		Else If Picture<>Nil Then
			If Big
				Then Gfx.PutSpriteX8(X1, Y1, Picture)
				Else Gfx.PutBigSprite(X1, Y1, Picture)
				{Else Gfx.PutBigImage(X1, Y1, Picture)}*)
	End
End;

Procedure PicCtl_Paint(Me:PControl; VX,VY:Integer);
Var
	SizeX, SizeY: Integer;
Begin
	With Me^, TPicCtl(Data^), Owner^.ClientRect Do
	Begin
		if Picture<>Nil Then
		Begin
			If Big Then
			Begin
				SizeX:=Gfx.ImageX(Picture)*8;
				SizeY:=Gfx.ImageY(Picture)*8
			End
			Else Begin
				SizeX:=Gfx.ImageX2(Picture);
				SizeY:=Gfx.ImageY2(Picture)
			End
		End
		Else Begin
			SizeX:=0;
			SizeY:=0
		End;
		If Beveled Then
		Begin
			Inc(SizeX, 5);
			Inc(SizeY, 5)
		End;
		D.AssignRect(X1+VX, Y1+VY, X1+VX+SizeX, Y1+VY+SizeY, Me^.Place)
	End;
	PicCtl_IntDraw(Me)
End;

Procedure PicCtl_SetPicture(Me:PControl; VPicture:Pointer);
Begin
	With Me^, TPicCtl(Data^) Do
	Begin
		Picture:=VPicture;

		If Me^.AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
			If (Me^.CanDraw Or Kernel.DontBother) And Me^.Visible Then
			Begin
				Kernel.BeginPaint(Me^.Place);
				PicCtl_IntDraw(Me);
				Kernel.EndPaint
			End
	End
End;

Procedure PicCtl_Draw(Me:PControl);
Begin
	With Me^ Do
		If CanDraw Or Kernel.DontBother Then
		Begin
			Kernel.BeginPaint(Me^.Place);
			If Visible
				Then PicCtl_IntDraw(Me)
				Else Kernel.HideCtl(Me);
			Kernel.EndPaint
		End
End;


Procedure PicCtl_OnDestroy(Me:PControl);
Begin
	FreeMem(Me^.Data, SizeOf(TPicCtl))
End;

Function PicCtl_Create(Prog:PProg; VPicture:Pointer;
	VBeveled,VBig,VTransp:Boolean):PControl;
Var
	Me:PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Kernel.CtlClickDummy,
		Kernel.CtlKeyDummy, Kernel.CtlRefocusDummy, Kernel.CtlDummy,
		Kernel.CtlDummy, False, True, Hint);}
	
	With Me^ Do
	Begin
		OnDestroy:=PicCtl_OnDestroy;
		Enabled:=False;

		GetMem(Data, SizeOf(TPicCtl));
		With TPicCtl(Data^) Do
		Begin
			Picture:=VPicture;
			Beveled:=VBeveled;
			Transp:=VTransp;
			Big:=VBig
		End;
	End;
	PicCtl_Create:=Me
End;
