{$F+}
unit
  Polar; { Polit Halcyon Polar Screensaver }

interface

uses
  Kernel, Gfx;

implementation

const
  FuncNum = 16;

type
  FuncArray = array [1..FuncNum] of Word;

const
  ColorNum = 15;
  MaxFactor1 = 10;
  MaxFactor2 = 10;
  MaxGraph = 7;

  N: Real = 0.01;
  GraphNum: Word = 1;

  Factor1Correction: FuncArray =
(3, 1, 1, 2, 1, 1, 5, 7, 4, 11, 3, 3, 3, 5, 1, 2);
  ScaleCorrection: FuncArray =
(0, 50, 45, 20, 15, 20, 15, 70, 60, 100, 18, 200, 25, 1, 70, 40);
  MaxDotsCorrection: FuncArray =
(14, 5, 15, 20, 12, 30, 17, 13, 11, 3, 15, 10, 8, 30, 8, 30);

var
  X1, Y1: Integer;
  CurrColor: Word;
  CurrFunc: Word;
  Factor1, Factor2: Integer;
  XStart, YStart: Word;
  HalfMaxX, HalfMaxY: Word;
  MaxX, MaxY: Word;
  X, Y: Integer;
  Phi: Real;
  MaxDots, Scale, Dots: Word;

  CallCount:Integer;

  procedure GetReady;
  begin
	 if GraphNum = 0 then
	 {Begin
		Kernel.TakeScreenShot;}
		Gfx.Bar(0, 0, MaxX, MaxY, clBlack);
	 {End;}

    MaxDots := 200;
    Scale := 1;
    Dots := 0;

    CurrColor := Random(ColorNum - 1) + 1;
    Factor1 := Random(MaxFactor1 - 2) + 2;
    Factor2 := Random(MaxFactor2 - 2) + 2;
    CurrFunc := Random(FuncNum);
    XStart := Random(MaxX);
    YStart := Random(MaxY);
    {if (CurrFunc <> 1) and (CurrFunc <> 4) and (CurrFunc <> 9)
and (CurrFunc <> 10) and (CurrFunc <> 14) and (CurrFunc <> 15) then
	 begin
		if (GraphNum mod 2 = 0) and (N > 0) then
        N := -N;
    end;}
    Phi := N;

    if Factor1 > Factor2 then
      Scale := Scale * Factor1
    else
      Scale := Scale * Factor2;

	 Inc(GraphNum);
	 if GraphNum > MaxGraph then
		GraphNum := 0;
	 Factor1 := Factor1 * Factor1Correction[CurrFunc]; { 201 range check error }
    Scale := Scale + ScaleCorrection[CurrFunc];
    {MaxDots := MaxDots * Factor1 * Factor1 + MaxDotsCorrection[CurrFunc];}
    MaxDots := MaxDots * MaxDotsCorrection[CurrFunc];
  end;

  procedure Polar_OnIdle;
  begin
	 Inc(CallCount);
	 If CallCount<(D.MachineSpeed Div 15) Then
		Exit;
	 CallCount:=0;
	 case CurrFunc of
      1: { Exp(Phi / Factor1) }
      begin
        X := XStart + Round((Exp(Phi / Factor1)) * Scale * Cos(Phi));
        Y := YStart + Round((Exp(Phi / Factor1)) * Scale * Sin(Phi));
      end;
      2: { Cos(Factor1 * Phi) }
      begin
        X := XStart + Round((Cos(Factor1 * Phi)) * Scale * Cos(Phi));
        Y := YStart + Round((Cos(Factor1 * Phi)) * Scale * Sin(Phi));
      end;
		3: { Sin(Phi / Factor1) }
      begin
        X := XStart + Round((Sin(Phi / Factor1)) * Scale * Cos(Phi));
        Y := YStart + Round((Sin(Phi / Factor1)) * Scale * Sin(Phi));
      end;
      4: { Ln(Phi / Factor1) }
      begin
        X := XStart + Round((Ln(Phi / Factor1)) * Scale * Cos(Phi));
        Y := YStart + Round((Ln(Phi / Factor1)) * Scale * Sin(Phi));
      end;
      5: { Exp(Sin(Phi * Factor1)) }
      begin
        X := XStart + Round((Exp(Sin(Phi * Factor1))) * Scale * Cos(Phi));
        Y := YStart + Round((Exp(Sin(Phi * Factor1))) * Scale * Sin(Phi));
      end;
      6: { Exp(Cos(Phi / Factor1)) }
      begin
        X := XStart + Round(Exp(Cos(Phi / Factor1)) * Scale * Cos(Phi));
        Y := YStart + Round(Exp(Sin(Phi / Factor1)) * Scale * Sin(Phi));
		end;
      7: { Exp(Cos(Factor1 / Phi)) }
      begin
        X := XStart + Round((Exp(Cos(Factor1 / Phi))) * Scale * Cos(Phi));
        Y := YStart + Round((Exp(Cos(Factor1 / Phi))) * Scale * Sin(Phi));
      end;
      8: { Exp(Sin(Factor1 / Phi)) }
      begin
        X := XStart + Round((Cos(Exp(Sin(Factor1 / Phi)))) * Scale * Cos(Phi));
        Y := YStart + Round((Cos(Exp(Sin(Factor1 / Phi)))) * Scale * Sin(Phi));
      end;
      9: { Sin(Factor1 * Ln(Phi)) }
      begin
        X := XStart + Round((Sin(Factor1 * Ln(Phi))) * Scale * Cos(Phi));
        Y := YStart + Round((Sin(Factor1 * Ln(Phi))) * Scale * Sin(Phi));
      end;
      10: { Cos(Exp(Phi) / Sin(Phi * Factor2) / Factor1 }
      begin
        X := XStart + Round((Cos(Exp(Phi) / Sin(Phi * Factor2) / Factor1)) * Scale * Cos(Phi));
		  Y := YStart + Round((Cos(Exp(Phi) / Sin(Phi * Factor2) / Factor1)) * Scale * Sin(Phi));
      end;
      11: { Exp(Cos(Factor1 * Ln(Factor2 / Sqr(Phi)))) }
      begin
        X := XStart + Round((Exp(Cos(Factor1 * Ln(Factor2 / Sqr(Phi))))) * Scale * Cos(Phi));
        Y := YStart + Round((Exp(Cos(Factor1 * Ln(Factor2 / Sqr(Phi))))) * Scale * Sin(Phi));
      end;
      12: { Cos(Factor1 * Phi) * Sin(Phi / Factor2) }
      begin
		  if Factor1 mod 2 = 0 then
          Inc(Factor1);
        X := XStart + Round((Cos(Factor1 * Phi) * Sin(Phi / Factor2)) * Scale * Cos(Phi));
        Y := YStart + Round((Cos(Factor1 * Phi) * Sin(Phi / Factor2)) * Scale * Sin(Phi));
      end;
      13: { Cos(Factor1 * Phi) / Sin(Phi / Factor2) }
      begin
		  if Factor1 mod 2 = 0 then
          Inc(Factor1);
        if Factor2 mod 2 = 0 then
			 Dec(Factor2);
        X := XStart + Round((Cos(Factor1 * Phi) / Sin(Phi / Factor2)) * Scale * Cos(Phi));
        Y := YStart + Round((Cos(Factor1 * Phi) / Sin(Phi / Factor2)) * Scale * Sin(Phi));
      end;
      14: { Sin(Phi / Factor1) * Ln(Factor1 * Phi) / Cos(Phi / Factor2) }
      begin
		  X := XStart + Round((Sin(Phi / Factor1) * Ln(Factor1 * Phi) / Cos(Phi / Factor2)) * Scale * Cos(Phi));
		  Y := YStart + Round((Sin(Phi / Factor1) * Ln(Factor1 * Phi) / Cos(Phi / Factor2)) * Scale * Sin(Phi));
      end;
		15: { Ln(Phi) * Sin(Factor1 * Phi) * Cos(Phi / Factor2) }
      begin
        if Factor1 mod 2 = 0 then
          Inc(Factor1);
        if Factor2 mod 2 = 0 then
          Inc(Factor2);
		  X := XStart + Round((Ln(Phi) * Sin(Factor1 * Phi) * Cos(Phi / Factor2)) * Scale * Cos(Phi));
		  Y := YStart + Round((Ln(Phi) * Sin(Factor1 * Phi) * Cos(Phi / Factor2)) * Scale * Sin(Phi)); { 201 }
		end;
		16: { Cos(Phi / Factor1) }
		begin
		  X := XStart + Round((Cos(Phi / Factor1)) * Scale * Cos(Phi));
		  Y := YStart + Round((Cos(Phi / Factor1)) * Scale * Sin(Phi));
		end;
	 end;

    Phi := Phi + N;
    Inc(Dots);
    if Dots = 1 then
	 begin
      X1 := X;
      Y1 := Y;
	 end;
	 If D.InRectCoord(X, Y, 0, 0, Gfx.ScrX, Gfx.ScrY)
		Then PutPixel(X, Y, CurrColor)
		Else CallCount:=30;
    if (Dots > MaxDots) or ((X = X1) and (Y = Y1) and (Dots > 300)) then
	 begin
		GetReady;
      {Gfx.Bar(0, 0, Gfx.ScrX, Gfx.ScrY, clBlack);
      Dots := 0;
      Phi := N;}
    end;
    {Polar_OnInit};
  end;

  procedure Polar_OnInit;
  begin
    MaxX := Gfx.ScrX;
	 MaxY := Gfx.ScrY;
	 GraphNum:=0;
	 GetReady;
	 CallCount:=0;
  end;

begin
  Kernel.RegScrSaver('Polar', Polar_OnInit, Polar_OnIdle);
end.
