{$F+}
Unit
	Popup; { Polit Halcyon popup menu unit }

Interface

Uses
	Types, Kernel, Log, D, Gfx, Font, BCRT;

Type
	TMenuItemKind=(ikRoot, ikCommand, ikSpace, ikLegend,
		ikSubmenu, ikCheck, ikRadio);
	PMenuItem=^TMenuItem;
	TMenuProc=Procedure(Me:PProg; Item:PMenuItem);
	TMenuItem=Record
		Name, HotKey, Hint: PStr;
		Icon: Pointer;
		Kind: TMenuItemKind;
		Enabled: Boolean;
		OnClick: TMenuProc;
		RelY, ScrY: Integer;

		Checked: Boolean;
		Group: Byte;
		Cargo: Pointer;

		SubMenu, Prev, Next: PMenuItem
	End;

	PScrMenu=^TScrMenu;
	TScrMenu=Record
		Place: TRect;
		FirstItem, LastItem, SelItem: PMenuItem;
		MaxNameWidth, MaxHotKeyWidth: Integer;
		Save, SelItemSave: Pointer;
		Next: PScrMenu;
		SaveFName: PStr;
	End;

	TPopupStadia=(psNothing, psClick, psRelease, psKey);
	TUpOrDown=(udUp, udDown);


	Procedure Init;
	Procedure Done;

	Procedure DummyProc(Me:PProg; Item:PMenuItem);

	Function CreateMenu: PMenuItem;
	Function AddSpace(Var Parent:PMenuItem): PMenuItem;
	Function AddLegend(Var Parent:PMenuItem; VName,VHint:String;
		VIcon:Pointer): PMenuItem;
	Function AddCommand(Var Parent:PMenuItem; VName,VHotKey,VHint:String;
		VIcon:Pointer; VEnabled:Boolean; VOnClick:TMenuProc): PMenuItem;
	Function AddSubmenu(Var Parent:PMenuItem; VName,VHint:String;
		VIcon:Pointer; VEnabled:Boolean): PMenuItem;
	Function AddRadio(Var Parent:PMenuItem; VName,VHotKey,VHint:String;
		VIcon:Pointer; VChecked:Boolean; VGroup:Byte; VEnabled:Boolean;
		VOnClick:TMenuProc): PMenuItem;
	Function AddCheck(Var Parent:PMenuItem; VName,VHotKey,VHint:String;
		VIcon:Pointer; VChecked:Boolean; VEnabled:Boolean;
		VOnClick:TMenuProc): PMenuItem;

	Procedure OpenMenu(Me:PProg; VMenu:PMenuItem; PX1,PY1:Integer);
	Procedure FreeMenu(Var VMenu:PMenuItem);

Implementation

Var
	FirstScrMenu: PScrMenu;
	PicCheck, PicRadio, PicSubmenu: TSkinPic;
		{ disabled/enabled, off/on }
	MouseScrMenu: PScrMenu;
	MouseItem: PMenuItem;
	MouseItemRect: TRect;
	ShDep: Integer;
	PopupStadia: TPopupStadia;
	TempItem: PMenuItem;
	PicU, PicD, PicL, PicR: Pointer;
	PopupStyle: (psNormal, psTransparent, psStriped, psBlurred,
		psGradient, psSteel, psPapirus, psXP);
	FadeBy: Integer;
	IconWidth: Integer;


Procedure DummyProc(Me:PProg; Item:PMenuItem);
Begin End;


Function CreateMenu: PMenuItem;
Var
	TempMenu: PMenuItem;
Begin
	New(TempMenu);
	With TempMenu^ Do
	Begin
		Name:=Nil;
		HotKey:=Nil;
		Hint:=Nil;
		Icon:=Nil;
		Kind:=ikRoot;
		Enabled:=True;
		OnClick:=DummyProc;
		RelY:=0;
		Cargo:=Nil;
		SubMenu:=Nil;
		Prev:=Nil;
		Next:=Nil
	End;
	CreateMenu:=TempMenu
End;

Function IntAddItem(Var Parent:PMenuItem; VName,VHotKey,VHint:String;
	VIcon:Pointer; VKind:TMenuItemKind; VEnabled:Boolean; VOnClick:TMenuProc): PMenuItem;
Var
	CurItem: PMenuItem;
	PrevY: Integer;
Begin
	If Parent^.SubMenu=Nil Then
	Begin { 訩 㭪  }
		New(Parent^.SubMenu);
		PrevY:=0;
		CurItem:=Parent^.SubMenu
	End
	Else Begin {  訩 㭪  :) }
		CurItem:=Parent^.SubMenu;
		While CurItem^.Next<>Nil Do
			CurItem:=CurItem^.Next;
		PrevY:=CurItem^.RelY;
		New(CurItem^.Next);
		CurItem^.Next^.Prev:=CurItem;
		CurItem:=CurItem^.Next
	End;

	With CurItem^ Do
	Begin
		D.AssignPStr(VName, Name);
		D.AssignPStr(VHotKey, HotKey);
		D.AssignPStr(VHint, Hint);
		Icon:=VIcon;
		Kind:=VKind;
		OnClick:=VOnClick;
		Enabled:=VEnabled;
		If Kind=ikSpace
			Then RelY:=PrevY+12
			Else RelY:=PrevY+18;
		SubMenu:=Nil;
		Next:=Nil
	End;
	IntAddItem:=CurItem
End;

Function AddSpace(Var Parent:PMenuItem): PMenuItem;
Begin
	AddSpace:=IntAddItem(Parent, '', '', '', Nil, ikSpace, False, DummyProc)
End;

Function AddLegend(Var Parent:PMenuItem; VName,VHint:String;
	VIcon:Pointer): PMenuItem;
Begin
	AddLegend:=IntAddItem(Parent, VName, '', VHint, VIcon, ikLegend, False, DummyProc)
End;

Function AddCommand(Var Parent:PMenuItem; VName,VHotKey,VHint:String;
	VIcon:Pointer; VEnabled:Boolean; VOnClick:TMenuProc): PMenuItem;
Begin
	AddCommand:=IntAddItem(Parent, VName, VHotKey, VHint, VIcon, ikCommand, VEnabled, VOnClick)
End;

Function AddSubmenu(Var Parent:PMenuItem; VName,VHint:String;
	VIcon:Pointer; VEnabled:Boolean): PMenuItem;
Begin
	AddSubmenu:=IntAddItem(Parent, VName, '', VHint, VIcon, ikSubmenu, VEnabled, DummyProc)
End;

Function AddRadio(Var Parent:PMenuItem; VName,VHotKey,VHint:String;
	VIcon:Pointer; VChecked:Boolean; VGroup:Byte; VEnabled:Boolean;
	VOnClick:TMenuProc): PMenuItem;
Var
	TempItem: PMenuItem;
Begin
	TempItem:=IntAddItem(Parent, VName, VHotKey, VHint, VIcon, ikRadio, VEnabled, VOnClick);
	TempItem^.Checked:=VChecked;
	TempItem^.Group:=VGroup;
	AddRadio:=TempItem
End;

Function AddCheck(Var Parent:PMenuItem; VName,VHotKey,VHint:String;
	VIcon:Pointer; VChecked:Boolean; VEnabled:Boolean;
	VOnClick:TMenuProc): PMenuItem;
Var
	TempItem: PMenuItem;
Begin
	TempItem:=IntAddItem(Parent, VName, VHotKey, VHint, VIcon, ikCheck, VEnabled, VOnClick);
	TempItem^.Checked:=VChecked;
	AddCheck:=TempItem
End;

Procedure FreeMenu(Var VMenu:PMenuItem);
Var
	CurItem, NextItem:PMenuItem;
Begin
	CurItem:=VMenu^.Submenu;
	While CurItem<>Nil Do
	Begin
		NextItem:=CurItem^.Next;
		D.FreePStr(CurItem^.Name, 'Popup - FreeMenu');
		D.FreePStr(CurItem^.HotKey, 'Popup - FreeMenu');
		D.FreePStr(CurItem^.Hint, 'Popup - FreeMenu');
		If CurItem^.SubMenu<>Nil Then
			FreeMenu(CurItem^.SubMenu);
		Dispose(CurItem);
		CurItem:=NextItem
	End;
	Dispose(VMenu);
	VMenu:=Nil
End;












Procedure SetCanDrawFlags;
Var
	CurProg: PProg;
	CurCtl: PControl;
	CurScrMenu: PScrMenu;
	CurCanDraw:Boolean;
Begin
	Kernel.RefreshAllCanDrawFlags;
		{ ஭  ஫ i  }
	CurProg:=FirstProg;
	While CurProg<>Nil Do
	Begin
		CurCtl:=CurProg^.FirstCtl;
		While CurCtl<>Nil Do
		Begin
			CurCanDraw:=CurCtl^.CanDraw;
			CurScrMenu:=FirstScrMenu;
			While CurScrMenu<>Nil Do
			Begin
				If D.Intersect(CurCtl^.Place, CurScrMenu^.Place) Then
					CurCanDraw:=False;
				CurScrMenu:=CurScrMenu^.Next
			End;
			CurCtl^.CanDraw:=CurCanDraw;
			CurCtl:=CurCtl^.Next
		End;
		CurProg:=CurProg^.Next
	End
End;


Procedure DrawItem(ScrMenu:PScrMenu; Item:PMenuItem; FillBG:Boolean);
Var
	CurColor: TColor;
	I: Integer;
Begin
	With ScrMenu^, Place, Item^ Do
	Begin
		If FillBG Then
		Begin
			If Item=SelItem Then
			Begin
				Gfx.Bar(X1+5, ScrY+2, X2-ShDep-5, ScrY+15, clBlue);
				Case PopupStyle Of
					psNormal, psTransparent, psXP: Gfx.Rectangle(X1+4, ScrY+1,
						X2-ShDep-4, ScrY+16, clBlueGray);
					psStriped, psSteel, psPapirus: Gfx.TranspButtonRect(X1+4,
						ScrY+1, X2-ShDep-4, ScrY+16, clBlue, clBlue, 50);
					psBlurred: Gfx.TranspButtonRect(X1+4, ScrY+1,
						X2-ShDep-4, ScrY+16, clBlack, clWhite, 60);
					{psGradient: For I:=1 To 16 Do
						Gfx.Line(X1+4, ScrY+I, X2-ShDep-4, ScrY+I, 239+I);}
					psGradient: Begin
						Gfx.Rectangle(X1+4, ScrY+1, X2-ShDep-4, ScrY+16, 235);
						Gfx.Line(X1+5, ScrY+2, X1+5, ScrY+15, 248);
						Gfx.Line(X2-ShDep-5, ScrY+2, X2-ShDep-5, ScrY+15, 254);
						For I:=0 To 6 Do
							Gfx.Rectangle(X1+6, ScrY+2+I+I, X2-ShDep-6, ScrY+3+I+I,
								248+I)
					End;
				End
			End
			Else
				Gfx.Bar(X1+4, ScrY+1, X2-ShDep-4, ScrY+16, Kernel.Clr3DFace)
		End;

		If Enabled
			Then If PopupStyle=psBlurred
				Then If FadeBy>0
					Then CurColor:=clBlack
					Else CurColor:=clWhite
				Else CurColor:=Kernel.ClrText
			Else CurColor:=Kernel.ClrTextDis;
		Case Kind Of
			ikCommand: If Icon<>Nil Then
			Begin
				If Enabled
					Then Gfx.PutSprite(X1+4, ScrY+1, Icon)
					Else Gfx.PutSpriteGrayed16(X1+4, ScrY+1, Icon)
			End;
			ikLegend: If PopupStyle=psBlurred
				Then If FadeBy>0
					Then CurColor:=clWhite
					Else CurColor:=clBlack
				Else CurColor:=Kernel.ClrTextCom;
			ikSubmenu: Gfx.PutSprite(X1+4+IconWidth+4+MaxNameWidth+9+
				MaxHotKeyWidth+4, ScrY+4, PicSubmenu[Enabled, (Item=SelItem)]);
			ikCheck: Gfx.PutSprite(X1+4, ScrY+1,
				PicCheck[Enabled, Checked]);
			ikRadio: Gfx.PutSprite(X1+4, ScrY+1,
				PicRadio[Enabled, Checked]);
		End;
		
		If Kind<>ikSpace Then
		Begin
			Font.Print(X1+4+IconWidth+4, ScrY+2, CurColor, String(Name^));
			Font.Print(X1+4+IconWidth+4+MaxNameWidth+9, ScrY+2,
				CurColor, String(HotKey^))
		End
	End
End;

Procedure DrawMenu(VMenu:PMenuItem; ParentRect:TRect);
Var
	TempScrMenu: PScrMenu;
	CurItem: PMenuItem;
	Finished: Boolean;
	CurColor: TColor;
	FirstItemHeight: Integer;
	PX1, PY1, TempWidth, I: Integer;
	ToRight: Boolean;
	TempRect: TRect;
Begin
	TempScrMenu:=FirstScrMenu;
	New(FirstScrMenu);
	FirstScrMenu^.Next:=TempScrMenu;
	With FirstScrMenu^ Do
	Begin
		FirstItem:=VMenu;
		SelItem:=Nil;
		SelItemSave:=Nil;
			{  . ਭ Name  HotKey   }
		Font.SetFont(Kernel.CurFont);
		MaxNameWidth:=0;
		MaxHotKeyWidth:=0;
		CurItem:=VMenu;
		Finished:=False;
		While Not Finished Do
		Begin
			MaxNameWidth:=D.Max(Font.Width(String(CurItem^.Name^)),
				MaxNameWidth);
			MaxHotKeyWidth:=D.Max(Font.Width(String(CurItem^.HotKey^)),
				MaxHotKeyWidth);
			If CurItem^.Next=Nil
				Then Finished:=True
				Else CurItem:=CurItem^.Next
		End;
		LastItem:=CurItem;

		TempWidth:=4+IconWidth+4+MaxNameWidth+9+MaxHotKeyWidth+4+
			Gfx.ImageX(PicSubmenu[True, False])+4+ShDep;
		If (Gfx.ScrX-ParentRect.X2-2)>=TempWidth Then
		Begin
			PX1:=ParentRect.X2+4;
			ToRight:=True
		End
		Else Begin
			PX1:=ParentRect.X1-TempWidth;
			ToRight:=False
		End;
		PY1:=ParentRect.Y1-4;

		Place.X1:=PX1;
		Place.X2:=PX1+4+IconWidth+4+MaxNameWidth+9+MaxHotKeyWidth+4+
			Gfx.ImageX(PicSubmenu[True, False])+4+ShDep;
		Place.Y1:=PY1;
		Place.Y2:=PY1+4+CurItem^.RelY+4+ShDep;
		D.ToRangePair(Place.X1, Place.X2, 0, Gfx.ScrX);
		D.ToRangePair(Place.Y1, Place.Y2, 1, Gfx.ScrY-18);

		With Place Do
			If ParentRect.X1<>ParentRect.X2 Then
			Begin { i }
				If ToRight
					Then D.AssignRect(X1, Y1, X1+2, Y2, TempRect)
					Else D.AssignRect(X2-2, Y1, X2, Y2, TempRect);
			End
			Else {  }
				D.AssignRect(X1, Y1, X1+2, Y1+2, TempRect);

		If PopupStyle<>psXP Then
			Gfx.ZoomRect(TempRect, Place);

		With Place Do
		Begin
			If Gfx.BigImageSize(X1, Y1, X2, Y2)>MaxAvail Then
			Begin {  `i - ॣ ⨭  䠩 }
				Log.BugMsg('Popup', 'DrawMenu', 'Memory low');
				D.AssignPStr(D.UniqueFName('Temp'), SaveFName);
				Gfx.SavePCX(X1, Y1, X2, Y2, String(SaveFName^))
			End
			Else Begin { `i  }
				Log.BugMsg('Popup', 'DrawMenu', 'Memory OK');
				SaveFName:=Nil;
				Gfx.GetBigImagePlus(X1, Y1, X2, Y2, Save)
			End;
				{   }
			Case PopupStyle Of
				psNormal: Begin
					{Gfx.ButtonRect(X1, Y1, X2-ShDep, Y2-ShDep,
						Kernel.Clr3DFace, clBlack);
					Gfx.ButtonRect(X1+1, Y1+1, X2-ShDep-1, Y2-ShDep-1,
						Kernel.Clr3DLight, Kernel.Clr3DDark);
					Gfx.Bar(X1+2, Y1+2, X2-ShDep-2, Y2-ShDep-2, Kernel.Clr3DFace)}
					{Gfx.HorGradBar(X1+2, Y1+2, X2-ShDep-2, Y2-ShDep-2,
						Kernel.Clr3DDark, Kernel.Clr3DFace)}
					Gfx.ButtonRect(X1, Y1, X2-ShDep, Y2-ShDep,
						Kernel.ClrWinLight, Kernel.ClrWinDark);
					Gfx.Bar(X1+1, Y1+1, X2-ShDep-1, Y2-ShDep-1, Kernel.ClrWinBG)
				End;
				psTransparent: Begin
					{Gfx.TranspButtonRect(X1, Y1, X2-ShDep, Y2-ShDep,
						Kernel.ClrWinBG, clBlack, 80);
					Gfx.TranspButtonRect(X1+1, Y1+1, X2-ShDep-1, Y2-ShDep-1,
						Kernel.Clr3DLight, Kernel.Clr3DDark, 80);
					Gfx.TranspBar(X1+2, Y1+2, X2-ShDep-2, Y2-ShDep-2,
						Kernel.ClrWinBG, 80)}
					Gfx.TranspButtonRect(X1, Y1, X2-ShDep, Y2-ShDep,
						Kernel.ClrWinLight, Kernel.ClrWinDark, 80);
					Gfx.TranspBar(X1+1, Y1+1, X2-ShDep-1, Y2-ShDep-1,
						Kernel.ClrWinBG, 80)
				End;
				psStriped: Begin
					Gfx.TranspButtonRect(X1, Y1, X2-ShDep, Y2-ShDep,
						255, 245, 80);
					Gfx.StripBar(X1+1, Y1+1, X2-ShDep-1, Y2-ShDep-1)
				End;
				psBlurred: Begin
					If FadeBy>0
						Then Gfx.TranspButtonRect(X1, Y1, X2-ShDep, Y2-ShDep,
							clWhite, Kernel.Clr3DDark, 80)
						Else Gfx.TranspButtonRect(X1, Y1, X2-ShDep, Y2-ShDep,
							Kernel.ClrWinBG, clBlack, 80);
					Gfx.BlurBar(X1+1, Y1+1, X2-ShDep-1, Y2-ShDep-1, FadeBy)
				End;
				psGradient: Begin
					Gfx.FillButtonRect(X1, Y1, X2-ShDep, Y2-ShDep, 255, 238, 252);
					Gfx.Line(X1+1, Y1+1, X1+1, Y2-ShDep-1, 247);
					Gfx.Line(X2-ShDep-1, Y1+1, X2-ShDep-1, Y2-ShDep-1, 245);
					For I:=0 To 12 Do
						Gfx.Rectangle(X1+2+I+I, Y1+1, X1+2+I+I+1, Y2-ShDep-1, 239+I)
				End;
				psSteel: Begin
					Gfx.SteelBar(X1, Y1, X2-ShDep, Y2-ShDep, 80);
					Gfx.TranspButtonRect(X1, Y1, X2-ShDep, Y2-ShDep,
						255, 238, 80);
					Gfx.TranspButtonRect(X1+1, Y1+1, X2-ShDep-1, Y2-ShDep-1,
						255, 242, 50)
				End;
				psPapirus: Gfx.AgedBar(X1, Y1, X2-ShDep, Y2-ShDep, 83, 107);
				psXP: Begin
					Gfx.TranspBar(X1, Y1, X2-ShDep, Y2-ShDep, Kernel.Clr3DFace, 25);
					Gfx.TranspBar(X1, Y1, X2-ShDep, Y2-ShDep, Kernel.Clr3DFace, 33);
					Gfx.TranspBar(X1, Y1, X2-ShDep, Y2-ShDep, Kernel.Clr3DFace, 50);

					Gfx.Rectangle(X1, Y1, X2-ShDep, Y2-ShDep, 215);
					Gfx.Bar(X1+1, Y1+1, X1+2, Y2-ShDep-1, 192);
					Gfx.Bar(X1+3, Y1+1, X2-ShDep-1, Y2-ShDep-1, 255)
				End;
			End;

			If ShDep>0 Then
			Begin
				Ini.Select('polit.ini', 'Graphics');
				If Ini.GetStr('Shadows', 'SMOOTH')='FAST'
					Then Gfx.BoxShadow(X1, Y1, X2-ShDep, Y2-ShDep, ShDep)
					Else Gfx.BoxShadowSoft(X1, Y1, X2-ShDep, Y2-ShDep, ShDep)
			End
		End;

			{  㭪 }
		CurItem:=FirstItem;
		FirstItemHeight:=FirstItem^.RelY;
		While CurItem<>Nil Do
		Begin
			CurItem^.ScrY:=Place.Y1+4+CurItem^.RelY-FirstItemHeight;
			DrawItem(FirstScrMenu, CurItem, False);
			CurItem:=CurItem^.Next
		End
	End;
	SetCanDrawFlags
End;


Procedure FreeLastScrMenu;
Var
	TempScrMenu: PScrMenu;
	TempF: File;
Begin
	TempScrMenu:=FirstScrMenu^.Next;
	With FirstScrMenu^, Place Do
	Begin
		If SaveFName<>Nil Then
		Begin
			Gfx.ShowPCX(X1, Y1, String(SaveFName^));
			Assign(TempF, String(SaveFName^));
			Erase(TempF);
			D.FreePStr(SaveFName, 'Popup - FreeLastScrMenu - FName')
		End
		Else Begin
			Gfx.PutBigImage(X1, Y1, Save);
			Gfx.FreeBigImage(Save)
		End;
		If SelItemSave<>Nil Then
		Begin
			{Log.BugMsg('Popup', 'FreeLastScrMenu', 'Freeing SelItemImage');}
			Gfx.FreeImage(SelItemSave)
		End
	End;
	Dispose(FirstScrMenu);
	FirstScrMenu:=TempScrMenu;
	SetCanDrawFlags
End;

Procedure FreeScrMenusBefore(BeforeMenu:PScrMenu);
Begin
	While FirstScrMenu<>BeforeMenu Do
		FreeLastScrMenu
End;

Procedure FreeAllScrMenus;
Begin
	FreeScrMenusBefore(Nil)
	{While FirstScrMenu<>Nil Do
		FreeLastScrMenu}
End;





Function GetScrMenuXY(X,Y:Integer): PScrMenu;
Var
	CurScrMenu: PScrMenu;
	Found: Boolean;
Begin
		{  ,  直 ࠧ  }
	CurScrMenu:=FirstScrMenu;
	Found:=False;
	While (CurScrMenu<>Nil) And Not Found Do
	Begin
		If D.InRect(X, Y, CurScrMenu^.Place)
			Then Found:=True
			Else CurScrMenu:=CurScrMenu^.Next
	End;
	If Found
		Then GetScrMenuXY:=CurScrMenu
		Else GetScrMenuXY:=Nil
End;

Procedure GetItemUnderCursor(X,Y:Integer; Var RScrMenu:PScrMenu; Var RItem:PMenuItem);
Var
	CurScrMenu: PScrMenu;
	CurItem: PMenuItem;
	Found: Boolean;
Begin
	CurScrMenu:=GetScrMenuXY(X, Y);

	If CurScrMenu<>Nil Then
	Begin
		RScrMenu:=CurScrMenu;

		CurItem:=CurScrMenu^.FirstItem;
		Found:=False;
		While (CurItem<>Nil) And Not Found Do
		Begin
			If (CurItem^.Kind In [ikCommand, ikSubmenu, ikCheck, ikRadio]) And
				CurItem^.Enabled Then
			Begin
				If D.InRectCoord(X, Y, CurScrMenu^.Place.X1+2, CurItem^.ScrY,
					CurScrMenu^.Place.X2-2-ShDep, CurItem^.ScrY+17)
					Then Found:=True
					Else CurItem:=CurItem^.Next
			End
			Else
				CurItem:=CurItem^.Next
		End;
		If Found
			Then RItem:=CurItem
			Else RItem:=Nil
	End
	Else Begin { i箣  諨 :( }
		RScrMenu:=Nil;
		RItem:=Nil
	End
End;


Procedure Popup_HideMouse(Var X,Y:Integer);
Begin
	Kernel.HideMouse(X, Y);
	If MouseItem<>Nil Then
		With MouseItemRect Do
			Gfx.PutRectImage(X1, Y1, X2, Y2, PicU, PicD, PicL, PicR)
			{Gfx.Rectangle(X1, Y1, X2, Y2, clSilver)}
End;

Procedure Popup_ShowMouse(Var X,Y:Integer);
Begin
	GetItemUnderCursor(X, Y, MouseScrMenu, MouseItem);
	If MouseItem<>Nil Then
	Begin
		D.AssignRect(MouseScrMenu^.Place.X1+3, MouseItem^.ScrY,
			MouseScrMenu^.Place.X2-3-ShDep, MouseItem^.ScrY+17, MouseItemRect);
		With MouseItemRect Do
		Begin
			Gfx.GetRectImage(X1, Y1, X2, Y2, PicU, PicD, PicL, PicR);
			Gfx.ButtonRect(X1, Y1, X2, Y2, Kernel.ClrAccent, Kernel.ClrAccent)
		End
	End;
	Kernel.ShowMouse(X, Y)
End;

Procedure Popup_SimpleShowMouse(Var X,Y:Integer);
Begin
	With MouseItemRect Do
	Begin
		Gfx.GetRectImage(X1, Y1, X2, Y2, PicU, PicD, PicL, PicR);
		Gfx.ButtonRect(X1, Y1, X2, Y2, Kernel.ClrAccent, Kernel.ClrAccent)
	End;
	Kernel.ShowMouse(X, Y)
End;

Function ItemInMenu(Item:PMenuItem; Menu:PMenuItem): Boolean;
Var
	CurItem: PMenuItem;
	Found: Boolean;
Begin
	CurItem:=Menu;
	Found:=False;
	While (CurItem<>Nil) And Not Found Do
		If CurItem=Item
			Then Found:=True
			Else CurItem:=CurItem^.Next;
	ItemInMenu:=Found
End;

Procedure Popup_KeyUpOrDown(Key:TUpOrDown);
Begin
	Popup_HideMouse(Kernel.MsX, Kernel.MsY);

	If Key=udUp Then
	Begin
		If (MouseItem<>Nil) And ItemInMenu(MouseItem, FirstScrMenu^.FirstItem) Then
		Begin
			If MouseItem^.Prev=Nil
				Then MouseItem:=FirstScrMenu^.LastItem
				Else MouseItem:=MouseItem^.Prev
		End
		Else
			MouseItem:=FirstScrMenu^.LastItem;

		While Not MouseItem^.Enabled Do
			If MouseItem^.Prev=Nil
				Then MouseItem:=FirstScrMenu^.LastItem
				Else MouseItem:=MouseItem^.Prev
	End
	Else Begin { Down }
		If (MouseItem<>Nil) And ItemInMenu(MouseItem, FirstScrMenu^.FirstItem) Then
		Begin
			If MouseItem^.Next=Nil
				Then MouseItem:=FirstScrMenu^.FirstItem
				Else MouseItem:=MouseItem^.Next
		End
		Else
			MouseItem:=FirstScrMenu^.FirstItem;

		While Not MouseItem^.Enabled Do
			If MouseItem^.Next=Nil
				Then MouseItem:=FirstScrMenu^.FirstItem
				Else MouseItem:=MouseItem^.Next
	End;

	D.AssignRect(FirstScrMenu^.Place.X1+3, MouseItem^.ScrY,
		FirstScrMenu^.Place.X2-3-ShDep, MouseItem^.ScrY+17, MouseItemRect);
	Popup_SimpleShowMouse(Kernel.MsX, Kernel.MsY)
End;

Procedure OpenMenu(Me:PProg; VMenu:PMenuItem; PX1,PY1:Integer);
Var
	Finished: Boolean;
	CurScrMenu: PScrMenu;

	LastMsMask, MsMask: Word;
	CurIdle: PProg;
	DX, DY: Integer;
	LastSelItem: PMenuItem;
	TempRect: TRect;
	C1, C2: Char;
	TempStr: String;
	MsX8, MsY8: Integer;
	MsRect8: TRect;

	Procedure ClickOnCommand;
	Begin
		Popup_HideMouse(Kernel.MsX, Kernel.MsY);
		FreeAllScrMenus;
		Kernel.ShowMouse(Kernel.MsX, Kernel.MsY);
		Kernel.HideMouse(Kernel.MsX, Kernel.MsY);
		Kernel.RefreshAllCanDrawFlags;
		Kernel.ShowMouseProc:=Kernel.ShowMouseSave;
		Kernel.HideMouseProc:=Kernel.HideMouseSave;
		Kernel.InsideHeart:=False;
		{Log.BugMsg('Popup', 'OpenMenu', 'Executing OnClick...');}
		MouseItem^.OnClick(Me, MouseItem);
		Finished:=True
	End;

	Procedure TryUnselLastSelItem;
	Begin
		If LastSelItem<>Nil Then
		Begin
			{DrawItem(MouseScrMenu, LastSelItem, True);}
			{Log.BugMsg('Popup', 'OpenMenu.TryUnselLastSelItem', 'Drawing & freeing it');}
			Gfx.PutImage(MouseScrMenu^.Place.X1+4, LastSelItem^.ScrY,
				MouseScrMenu^.SelItemSave);
			Gfx.FreeImage(MouseScrMenu^.SelItemSave);
			MouseScrMenu^.SelItemSave:=Nil
		End
	End;

	Procedure ClickOnCheck;
	Begin
		Popup_HideMouse(Kernel.MsX, Kernel.MsY);
		With MouseItemRect Do
			MouseScrMenu:=GetScrMenuXY(X1+21, Y1+9);
		MouseItem^.Checked:=Not MouseItem^.Checked;
		With MouseItemRect Do
			Gfx.PutSprite(X1+1, Y1+1, PicCheck[True, MouseItem^.Checked]);
		If (D.KeyStatus And ksCtrl)=0 Then
		Begin
			FreeAllScrMenus;
			Finished:=True;
			Kernel.RefreshAllCanDrawFlags;
			Kernel.ShowMouseProc:=Kernel.ShowMouseSave;
			Kernel.HideMouseProc:=Kernel.HideMouseSave;
			Kernel.InsideHeart:=False;
			MouseItem^.OnClick(Me, MouseItem);
		End
		Else Begin
			FreeScrMenusBefore(MouseScrMenu);
			LastSelItem:=MouseScrMenu^.SelItem;
			MouseScrMenu^.SelItem:=Nil;
			TryUnselLastSelItem;
			Popup_SimpleShowMouse(Kernel.MsX, Kernel.MsY);
			MouseItem^.OnClick(Me, MouseItem)
		End
	End;

	Procedure ClickOnRadio;
	Var
		CurItem: PMenuItem;
	Begin
		Popup_HideMouse(Kernel.MsX, Kernel.MsY);
		With MouseItemRect Do
			MouseScrMenu:=GetScrMenuXY(X1+21, Y1+9);
		CurItem:=MouseScrMenu^.FirstItem;
		While CurItem<>Nil Do
		Begin
			If (CurItem^.Kind=ikRadio) And (CurItem^.Group=MouseItem^.Group) Then
			Begin
				If CurItem=MouseItem
					Then CurItem^.Checked:=True
					Else CurItem^.Checked:=False;
				Gfx.PutSprite(MouseScrMenu^.Place.X1+4, CurItem^.ScrY+1,
					PicRadio[CurItem^.Enabled, CurItem^.Checked]);
			End;
			CurItem:=CurItem^.Next
		End;
		If (D.KeyStatus And ksCtrl)=0 Then { ctrl }
		Begin
			FreeAllScrMenus;
			Finished:=True;
			Kernel.RefreshAllCanDrawFlags;
			Kernel.ShowMouseProc:=Kernel.ShowMouseSave;
			Kernel.HideMouseProc:=Kernel.HideMouseSave;
			Kernel.InsideHeart:=False;
			MouseItem^.OnClick(Me, MouseItem);
		End
		Else Begin
			FreeScrMenusBefore(MouseScrMenu);
			LastSelItem:=MouseScrMenu^.SelItem;
			MouseScrMenu^.SelItem:=Nil;
			TryUnselLastSelItem;
			Popup_SimpleShowMouse(Kernel.MsX, Kernel.MsY);
			MouseItem^.OnClick(Me, MouseItem)
		End
	End;

	Procedure ClickOnSubmenu;
	Begin
		Popup_HideMouse(Kernel.MsX, Kernel.MsY);
		With MouseItemRect Do
			MouseScrMenu:=GetScrMenuXY(X1+21, Y1+9);
		FreeScrMenusBefore(MouseScrMenu);
		If MouseItem<>MouseScrMenu^.SelItem Then
		Begin
			LastSelItem:=MouseScrMenu^.SelItem;
			MouseScrMenu^.SelItem:=MouseItem;
			TryUnselLastSelItem;

			{Gfx.PutSprite(MouseScrMenu^.Place.X1+4, CurItem^.ScrY+1,
					PicRadio[CurItem^.Enabled, CurItem^.Checked]);}

			{Log.BugMsg('Popup', 'OpenMenu.ClickOnSubmenu', 'GetImagePlus');}
			Gfx.GetImagePlus(MouseScrMenu^.Place.X1+4, MouseItem^.ScrY,
				MouseScrMenu^.Place.X2-ShDep-4, MouseItem^.ScrY+17,
				MouseScrMenu^.SelItemSave);
			DrawItem(MouseScrMenu, MouseItem, True);
			DrawMenu(MouseItem^.Submenu, MouseItemRect);

			If PopupStadia=psKey Then
			Begin
				MouseItem:=FirstScrMenu^.LastItem;
				Popup_SimpleShowMouse(Kernel.MsX, Kernel.MsY);
				Popup_KeyUpOrDown(udDown)
			End
			Else
				Popup_ShowMouse(Kernel.MsX, Kernel.MsY)
		End
		Else Begin
			LastSelItem:=MouseScrMenu^.SelItem;
			MouseScrMenu^.SelItem:=Nil;
			TryUnselLastSelItem;
			Popup_SimpleShowMouse(Kernel.MsX, Kernel.MsY)
		End
	End;

	Procedure ClickOnMouseItem;
	Begin
		If MouseItem<>Nil Then
			Case MouseItem^.Kind Of
				ikCommand: ClickOnCommand;
				ikCheck: ClickOnCheck;
				ikRadio: ClickOnRadio;
				ikSubmenu: ClickOnSubmenu
			End
	End;

	Procedure PressEsc;
	Begin
		If FirstScrMenu^.Next=Nil Then
		Begin {  popup i }
			Popup_HideMouse(Kernel.MsX, Kernel.MsY);
			FreeAllScrMenus;
			Finished:=True;
			PopupStadia:=psKey
		End
		Else Begin {  ⠭ i i }
			Popup_HideMouse(Kernel.MsX, Kernel.MsY);
			FreeLastScrMenu;
			LastSelItem:=FirstScrMenu^.SelItem;
			FirstScrMenu^.SelItem:=Nil;
			MouseScrMenu:=FirstScrMenu;
			TryUnselLastSelItem;
			MouseItem:=LastSelItem;
			D.AssignRect(FirstScrMenu^.Place.X1+3, MouseItem^.ScrY,
				FirstScrMenu^.Place.X2-3-ShDep, MouseItem^.ScrY+17, MouseItemRect);
			Popup_SimpleShowMouse(Kernel.MsX, Kernel.MsY)
		End
	End;

Begin
	Ini.Select('polit.ini', 'Menu');
	TempStr:=Ini.GetStr('Style', 'NORMAL');
	PopupStyle:=psNormal;
	If TempStr='TRANSPARENT' Then PopupStyle:=psTransparent;
	If TempStr='STRIPED' Then PopupStyle:=psStriped;
	If TempStr='BLURRED' Then PopupStyle:=psBlurred;
	If TempStr='GRADIENT' Then PopupStyle:=psGradient;
	If TempStr='METAL' Then PopupStyle:=psSteel;
	If TempStr='PAPIRUS' Then PopupStyle:=psPapirus;
	If TempStr='XP' Then PopupStyle:=psXP;
	If Not (PopupStyle In [psBlurred, psPapirus]) Then
	Begin
		ShDep:=Ini.GetInt('ShadowDepth', 3);
		D.ToRange(ShDep, 0, 100)
	End
	Else Begin
		FadeBy:=Ini.GetInt('BlurredFadeBy', -21);
		ShDep:=0
	End;

	D.AssignRect(PX1-4, PY1+4, PX1-4, PY1+4, TempRect);
	DrawMenu(VMenu^.Submenu, TempRect);
	Finished:=False;
	LastSelItem:=Nil;
	GetItemUnderCursor(Kernel.MsX, Kernel.MsY, MouseScrMenu, MouseItem);
	If MouseItem<>Nil Then
		D.AssignRect(MouseScrMenu^.Place.X1+2, MouseItem^.ScrY,
			MouseScrMenu^.Place.X2-2-ShDep, MouseItem^.ScrY+17, MouseItemRect);

		{ ਣ㢠  室  横 }
	Gfx.PrepareRectImage(PicU, PicD, PicL, PicR);
	LastMsMask:=Mouse.GetMask;
	Kernel.HideMouseSave:=Kernel.HideMouseProc;
	Kernel.HideMouseProc:=Popup_HideMouse;
	Kernel.ShowMouseSave:=Kernel.ShowMouseProc;
	Kernel.ShowMouseProc:=Popup_ShowMouse;
	Kernel.InsideHeart:=True;
	Popup_ShowMouse(MsX, MsY);
	CurIdle:=Kernel.FirstProg;
	PopupStadia:=psNothing;
	MsX8:=MsX*8;
	MsY8:=MsY*8;
	MsRect8.X1:=Kernel.MsRect.X1*8;
	MsRect8.Y1:=Kernel.MsRect.Y1*8;
	MsRect8.X2:=Kernel.MsRect.X2*8;
	MsRect8.Y2:=Kernel.MsRect.Y2*8;

	Repeat
		PopupStadia:=psNothing; {  誨 ᯮ i饭 }
		Repeat
			Kernel.ExecTimers;   {  ⠩ ணࠬ }
			If CurIdle<>Nil Then { ... Idle' }
			Begin
				CurIdle^.OnIdle(CurIdle);
				CurIdle:=CurIdle^.Next;
				If CurIdle=Nil Then
					CurIdle:=FirstProg
			End;

			Mouse.GetDXDY(DX, DY);
			If (DX<>0) Or (DY<>0) Then {  訢  ? }
			Begin { ⠪ -     ࠭i }
				Kernel.LastMouseMove:=D.SysTimer;
				Kernel.HintPresent:=False;
				Popup_HideMouse(Kernel.MsX, Kernel.MsY);
				Inc(MsX8, DX*Kernel.MsSpeed);
				D.ToRange(MsX8, MsRect8.X1, MsRect8.X2);
				Kernel.MsX:=MsX8 Div 8;
				Inc(MsY8, DY*Kernel.MsSpeed);
				D.ToRange(MsY8, MsRect8.Y1, MsRect8.Y2);
				Kernel.MsY:=MsY8 Div 8;
				Popup_ShowMouse(Kernel.MsX, Kernel.MsY)
			End
			Else { i - ஡㢠  i }
				If (D.SysTimer-Kernel.LastMouseMove>Kernel.HintShowTime) And
					(MsMask=0) And (Not Kernel.HintPresent) Then
				Begin
					Kernel.ShowMouseProc:=Kernel.ShowMouseSave;
					Kernel.HideMouseProc:=Kernel.HideMouseSave;
					If MouseScrMenu<>Nil Then {    类 i  }
					Begin
						If MouseItem<>Nil Then { ...i  类 㭪i - }
							If D.InRect(Kernel.MsX, Kernel.MsY, MouseItemRect) Then
								ShowHint(String(MouseItem^.Hint^)) {   i }
					End
					Else
						Kernel.ShowHintPlus; { i  i ஫ }
					Kernel.HideMouseProc:=Popup_HideMouse;
					Kernel.ShowMouseProc:=Popup_ShowMouse
				End;

			If BCRT.KeyPressed Then
			Begin
				C1:=BCRT.ReadKey;
				If BCRT.KeyPressed
					Then C2:=BCRT.ReadKey
					Else C2:=#0;

				If (C1=#0) And (C2=#67) Then
					TakeScreenShot;
				If (C1=#0) And (C2=#72) Then
					Popup_KeyUpOrDown(udUp);
				If (C1=#0) And (C2=#80) Then
					Popup_KeyUpOrDown(udDown);
				If C1 In [' ', #13, #10] Then
				Begin
					PopupStadia:=psKey;
					ClickOnMouseItem;
					While KeyPressed Do
						C1:=ReadKey
				End;
				If C1=#27 Then PressEsc;
				
			End;

			MsMask:=Mouse.GetMask;
			Case PopupStadia Of
				psNothing: If MsMask=Mouse.mbLeft Then {    誨 }
				Begin
					If MouseScrMenu=Nil Then
					Begin {    -  Kernel.Click i  }
						Popup_HideMouse(Kernel.MsX, Kernel.MsY);
						FreeAllScrMenus;
						Finished:=True;
						Kernel.ShowMouseProc:=Kernel.ShowMouseSave;
						Kernel.HideMouseProc:=Kernel.HideMouseSave;
						InsideHeart:=False;
						Kernel.RefreshAllCanDrawFlags;
						Gfx.FreeRectImage(PicU, PicD, PicL, PicR);
						Kernel.Click;
						Gfx.PrepareRectImage(PicU, PicD, PicL, PicR);
						PopupStadia:=psRelease;
						MouseItem:=Nil
					End
					Else {   }
						PopupStadia:=psClick;
				End;
				psClick: If MsMask=Mouse.mbNone Then PopupStadia:=psRelease
			End
		Until PopupStadia In [psRelease, psKey];
		{Log.BugMsg('Popup', 'OpenMenu', 'Calling handler');}
		If PopupStadia=psRelease Then
			ClickOnMouseItem
	Until Finished;
	{Log.BugMsg('Popup', 'OpenMenu', 'Handler called');}

	Kernel.ShowMouseProc:=Kernel.ShowMouseSave;
	Kernel.HideMouseProc:=Kernel.HideMouseSave;
	Kernel.InsideHeart:=False;

	Kernel.RefreshAllCanDrawFlags;
	Gfx.FreeRectImage(PicU, PicD, PicL, PicR);
	{Log.BugMsg('Popup', 'OpenMenu', 'Finishing');}
End;


Procedure Init;
Var
	TempStr: String;
	P: Pointer;
Begin
	Pic.LoadBMP(Kernel.SkinDir+'btn_rght.bmp', P);
	Gfx.SplitSkin3(P, PicSubmenu);
	Pic.LoadBMP(Kernel.SkinDir+'check.bmp', P);
	Gfx.SplitSkin4(P, PicCheck);
	Pic.LoadBMP(Kernel.SkinDir+'radio.bmp', P);
	Gfx.SplitSkin4(P, PicRadio);
End;

Procedure Done;
Begin
	{Kernel.FreeRes('pop0rght.bmp');
	Kernel.FreeRes('pop_rght.bmp');
	Kernel.FreeRes('check_d0.bmp');
	Kernel.FreeRes('check_d1.bmp');
	Kernel.FreeRes('check_e0.bmp');
	Kernel.FreeRes('check_e1.bmp');
	Kernel.FreeRes('radio_d0.bmp');
	Kernel.FreeRes('radio_d1.bmp');
	Kernel.FreeRes('radio_e0.bmp');
	Kernel.FreeRes('radio_e1.bmp');}
	Gfx.FreeSkin3(PicSubmenu);
	Gfx.FreeSkin4(PicCheck);
	Gfx.FreeSkin4(PicRadio);
	
End;

Begin
	IconWidth:=16
End.