{ ************ PopupBtn ************ }
Type
	TPopupBtn=Record
		MyButton: PControl;
		Menu: PMenuItem
	End;

Procedure PopupBtn_Paint(Me:PControl; VX1, VY1, VX2:Integer);
Begin
	Button_Paint(TPopupBtn(Me^.Data^).MyButton, VX1, VY1, VX2)
End;


Procedure PopupBtn_OnRefocus(Me:PControl; Focused:Boolean);
Begin
	With TPopupBtn(Me^.Data^) Do
		Kernel.CtlRefocusDummy(MyButton, Focused)
End;

Procedure PopupBtn_OnPress(Me:PProg; Control:PControl);
Begin
	With TPopupBtn(Control^.Data^), MyButton^.Place Do
		Popup.OpenMenu(Me, Menu, X1, Y2+2)
End;

Function PopupBtn_AsButton(Me:PControl): PControl;
Begin
	With TPopupBtn(Me^.Data^) Do
		PopupBtn_AsButton:=MyButton
End;

Procedure PopupBtn_OnDestroy(Me:PControl);
Begin
	With TPopupBtn(Me^.Data^) Do
		Popup.FreeMenu(Menu);
	FreeMem(Me^.Data, SizeOf(TPopupBtn))
End;


Function PopupBtn_Create(Prog:PProg; VCaption:String; VMenu:PMenuItem;
	VPicture:Pointer; VPicturePos:TPicturePos): PControl;
Var
	Me: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Kernel.CtlClickDummy, Kernel.CtlKeyDummy,
		PopupBtn_OnRefocus, Kernel.CtlDummy, PopupBtn_OnDestroy,
		False, False, '');}
	With Me^ Do
	Begin
		OnRefocus:=PopupBtn_OnRefocus;
		OnDestroy:=PopupBtn_OnDestroy;
		Enabled:=False;
		D.AssignRect(-1, -1, -1, -1, Place);

		GetMem(Data, SizeOf(TPopupBtn));
		With TPopupBtn(Data^) Do
		Begin
			Menu:=VMenu;

			MyButton:=Button_Create(Prog, VCaption, VPicture,
				VPicturePos, PopupBtn_OnPress);
			Button_SetMarkStyle(MyButton, bmMenuDown);
			MyButton^.OwnerCtl:=Me;
			{Button^.AutoRedraw:=True;}
		End
	End;
	PopupBtn_Create:=Me
End;
