{$F+}
Unit
	PrnSetup; { Polit Halcyon PrnSetup application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Popup, DOS, Gfx;

Type
	TPrnSetupData=Record
		LabModel, BtnModel,
		LabPort, PbtPort,
		LabPaper, PbtPaper: PControl;
		NbkModes: PControl;
		MnuPort, MnuPaper: PMenuItem;
		PicJack, PicA4P, PicA4L, PicA3P, PicA3L: Pointer;
		BtnTestPage: PControl;
		RadViaPolit, RadViaPrinter: PControl;
		PbtPolFont, PbtPrnFont: PControl;
		MnuPolFont, MnuPrnFont: PMenuItem;
		CanSample: PControl;
		PicDraft, PicEmphasized, PicProportional, PicNLQ: Pointer;
		CurPolFont: Pointer;
		CurPolFontName: String;
		ChkJustify: PControl;
		BtnAccept, BtnClose: PControl;
		{RadDither, RadMono: PControl;}

	End;

Implementation

Procedure DrawPreview(Me:PProg);
Const
	SampleText='Abcdefg 123';
Var
	TempStr: String;
	LastFont: Pointer;
	X, Y: Integer;
Begin
	With Me^, TPrnSetupData(Data^), CanSample^.Place Do
	Begin
		Case Ctl.Notebook_GetActivePage(NbkModes) Of
			2: Begin {  ⥪i }
				Gfx.Bar(X1+2, Y1+2, X2-2, Y2-2, clSilver);
				If Ctl.Radio_Selected(RadViaPolit) Then
				Begin {   }
					LastFont:=Font.GetFont;
					Font.SetFont(CurPolFont);
					Font.Print(X1+4, Y1+4, clBlack, SampleText);
					For Y:=Font.Height(CurPolFont)-1 Downto 0 Do
						For X:=0 To Font.Width(SampleText) Do
							Gfx.Line(X1+4+X, Y1+4+Y+Y, X1+4+X, Y1+4+Y+Y+1,
								Gfx.GetPixel(X1+4+X, Y1+4+Y));
					Font.SetFont(LastFont)
				End
				Else Begin {  ਭ }
					TempStr:=Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtPrnFont));
					If Copy(TempStr, 1, 8)='୮' Then
						Gfx.PutImage(X1+2, Y1+2, PicDraft);
					If TempStr='i' Then
						Gfx.PutImage(X1+2, Y1+2, PicEmphasized);
					If TempStr='யi' Then
						Gfx.PutImage(X1+2, Y1+2, PicProportional);
					If TempStr='i᭨' Then
						Gfx.PutImage(X1+2, Y1+2, PicNLQ);
				End
			End;
		End
	End
End;


Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TPrnSetupData(Data^) Do
	Begin
		Kernel.WinBGBar(Me, X1, Y1, X2, Y1+4);
		Kernel.WinBGBar(Me, X1, Y1+5, X1+4, Y2-35);
		Kernel.WinBGBar(Me, X2-4, Y1+5, X2, Y2-35);
		Kernel.WinBGBar(Me, X1, Y2-34, X2, Y2);
		Kernel.WindowBar(X1+5, Y1+5+22, X2-5, Y2-35, False, False);

		Ctl.Notebook_Paint(NbkModes, 5, 5, X2-X1-5, Y2-Y1-35);

			{ page 1 - common }
		Ctl.Label_Paint(LabModel, 10, 40, 120);
		Ctl.Button_Paint(BtnModel, 130, 40, X2-X1-15);
		Ctl.Label_Paint(LabPort, 10, 70, 120);
		Ctl.PopupBtn_Paint(PbtPort, 130, 70, X2-X1-15);
		Ctl.Label_Paint(LabPaper, 10, 100, 120);
		Ctl.PopupBtn_Paint(PbtPaper, 130, 100, X2-X1-15);

			{ page 2 - text }
		Ctl.Radio_Paint(RadViaPolit, 15, 40);
		Ctl.PopupBtn_Paint(PbtPolFont, 130, 40, X2-X1-15);
		Ctl.Radio_Paint(RadViaPrinter, 15, 70);
		Ctl.PopupBtn_Paint(PbtPrnFont, 130, 70, X2-X1-15);
		Ctl.Canvas_Paint(CanSample, (X2-X1) Div 2-82, 100,
			(X2-X1) Div 2+83, 141);
		DrawPreview(Me);
		Ctl.Check_Paint(ChkJustify, 15, 160);
			{ page 3 - pictures }
		{Ctl.Radio_Paint(RadDither, 15, 145);
		Ctl.Radio_Paint(RadMono, 15, 180);}

			{ out of notebook }
		Ctl.Button_Paint(BtnTestPage, 5, Y2-Y1-26, X2-X1-205);
		Ctl.Button_Paint(BtnAccept, X2-X1-195, Y2-Y1-26, X2-X1-105);
		Ctl.Button_Paint(BtnClose, X2-X1-95, Y2-Y1-26, X2-X1-5);
	End;
End;

Procedure OnPortMenuClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TPrnSetupData(Data^) Do
		Button_SetCaption(PopupBtn_AsButton(PbtPort), String(Item^.Name^))
End;

Procedure OnPaperMenuClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TPrnSetupData(Data^) Do
		Button_SetCapAndPic(PopupBtn_AsButton(PbtPaper), String(Item^.Name^),
			Item^.Icon)
End;

Procedure OnPolFontMenuClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TPrnSetupData(Data^) Do
		Button_SetCaption(PopupBtn_AsButton(PbtPolFont), String(Item^.Name^))
End;

Procedure OnPrnFontMenuClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TPrnSetupData(Data^) Do
	Begin
		Button_SetCaption(PopupBtn_AsButton(PbtPrnFont), String(Item^.Name^));
		Kernel.WaitTicks(3);
		Ctl.Canvas_BeginPaint(CanSample);
		DrawPreview(Me);
		Kernel.EndPaint
	End
End;

Procedure OnFontRadio(Me:PProg; Control:PControl);
Begin
	With Me^, TPrnSetupData(Data^) Do
	Begin
		Ctl.Canvas_BeginPaint(CanSample);
		DrawPreview(Me);
		Kernel.EndPaint
	End
End;


Procedure ApplyChanges(Me:PProg);
Var
	TempStr: String;
	TempPtr: Pointer;
Begin
	With Me^, TPrnSetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Print');

		TempStr:=Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtPort));
		Ini.SetStr('Port', TempStr);

		TempPtr:=Ctl.Button_GetPicture(Ctl.PopupBtn_AsButton(PbtPaper));
		If TempPtr=PicA4P Then Ini.SetStr('Paper', 'A4Portrait');
		If TempPtr=PicA4L Then Ini.SetStr('Paper', 'A4Landscape');
		If TempPtr=PicA3P Then Ini.SetStr('Paper', 'A3Portrait');
		If TempPtr=PicA3L Then Ini.SetStr('Paper', 'A3Landscape');

		If Ctl.Radio_Selected(RadViaPolit)
			Then Ini.SetStr('TextMode', 'Polit')
			Else Ini.SetStr('TextMode', 'Printer');

		TempStr:=Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtPolFont));
		Ini.SetStr('PolitFont', 'Fonts\'+TempStr+'.raf');

		TempStr:=Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtPrnFont));
      If TempStr='୮ (袨)' Then Ini.SetStr('PrinterFont', 'FastDraft');
		If TempStr='୮' Then Ini.SetStr('PrinterFont', 'Draft');
		If TempStr='i' Then Ini.SetStr('PrinterFont', 'Emphasized');
		If TempStr='யi' Then Ini.SetStr('PrinterFont', 'Proportional');
		If TempStr='i᭨' Then Ini.SetStr('PrinterFont', 'NLQ');

		Ini.SetBool('JustifyText', Ctl.Check_GetState(ChkJustify));

		Ini.SaveCurFile
	End
End;

Procedure OnAcceptClick(Me:PProg; Control:PControl);
Begin
	ApplyChanges(Me);
	Kernel.CloseProg(Me)
End;

Procedure OnTestPageClick(Me:PProg; Control:PControl);
Var
	TempName: String;
	TempPtr: Pointer;
	TempList: TPtrList;
Begin
	With Me^, TPrnSetupData(Data^) Do
	Begin
		ApplyChanges(Me); {    }

		TempName:=D.UniqueFName('');
		TempList.Data:=Addr(TempName);
		New(TempList.Next);
		D.AssignPStr('⮢ i', TempList.Next^.Data);
		TempList.Next^.Next:=Nil;

		LptGfx.DumpTextFile('prn_test.txt', TempName);
		If Kernel.FindProg('PrnSpool')=Nil Then
			Kernel.RunBuiltIn('PrnSpool', '');
		TempPtr:=Kernel.SendMessage(Me, Kernel.FindProg('PrnSpool'),
			'PrintFile', Addr(TempList));
		D.FreePStr(TempList.Next^.Data, 'PrnSetup - testpage name');
		Dispose(TempList.Next);
	End
End;


Procedure OnCloseClick(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;



Function OnMessage(Me, Sender:PProg; Msg:String; Data:Pointer): Pointer;
Begin
	With Me^, TPrnSetupData(Data^) Do
	Begin

		OnMessage:=Nil
	End
End;



Procedure OnClose(Me:PProg);
Var
	TempPtr: Pointer;
Begin
	With Me^ Do
		If Parent<>Nil Then
			TempPtr:=Kernel.SendMessage(Me, Parent, 'Settings:CloseSheet', Nil);
	Kernel.FreeRes('b_jack1.bmp');
	Kernel.FreeRes('b_a4p.bmp');
	Kernel.FreeRes('b_a4l.bmp');
	Kernel.FreeRes('b_a3p.bmp');
	Kernel.FreeRes('b_a3l.bmp');
	Kernel.FreeRes('draft.bmp');
	Kernel.FreeRes('emphasiz.bmp');
	Kernel.FreeRes('proport.bmp');
	Kernel.FreeRes('nlq.bmp');
	With Me^, TPrnSetupData(Data^) Do
		Kernel.FreeRes(D.UpCaseLine(CurPolFontName)+'.RAF');
	FreeMem(Me^.Data, SizeOf(TPrnSetupData))
End;

Procedure MakeMenus(Me:PProg);
Var
	I: Integer;
	SR: SearchRec;
Begin
	With Me^, TPrnSetupData(Data^) Do
	Begin
		MnuPort:=Popup.CreateMenu;
		Popup.AddCommand(MnuPort, 'LPT1', '', '', PicJack, True,
			OnPortMenuClick);
		Popup.AddCommand(MnuPort, 'LPT2', '', '', PicJack, True,
			OnPortMenuClick);
		Popup.AddCommand(MnuPort, 'LPT3', '', '', PicJack, True,
			OnPortMenuClick);

		MnuPaper:=Popup.CreateMenu;
		Popup.AddCommand(MnuPaper, 'A4, 210x297 ', '', '',
			PicA4P, True, OnPaperMenuClick);
		Popup.AddCommand(MnuPaper, 'A4, 297x210 ', '', '',
			PicA4L, True, OnPaperMenuClick);
		Popup.AddCommand(MnuPaper, 'A3, 297x420 ', '', '',
			PicA3P, True, OnPaperMenuClick);
		Popup.AddCommand(MnuPaper, 'A3, 420x297 ', '', '',
			PicA3L, True, OnPaperMenuClick);

		MnuPolFont:=Popup.CreateMenu;
		FindFirst('fonts\*.raf', AnyFile, SR);
		While DOSError=0 Do
		Begin
			If (SR.Attr And Directory)=0 Then
				If Font.FileHeightRaster('fonts\'+SR.Name)=8 Then
					Popup.AddCommand(MnuPolFont, D.NormLine(D.ClipFName(SR.Name)), '', '',
						Nil, True, OnPolFontMenuClick);
			FindNext(SR)
		End;

		MnuPrnFont:=Popup.CreateMenu;
		Popup.AddCommand(MnuPrnFont, '୮ (袨)', '', '',
			Nil, True, OnPrnFontMenuClick);
		Popup.AddCommand(MnuPrnFont, '୮', '', '',
			Nil, True, OnPrnFontMenuClick);
		Popup.AddCommand(MnuPrnFont, 'i', '', '',
			Nil, True, OnPrnFontMenuClick);
		Popup.AddCommand(MnuPrnFont, 'யi', '', '',
			Nil, True, OnPrnFontMenuClick);
		Popup.AddCommand(MnuPrnFont, 'i᭨', '', '',
			Nil, True, OnPrnFontMenuClick);
	End
End;


Procedure OnInit(Me:PProg);
Var
	TempStr, TempStr2: String;
	TempPtr: Pointer;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnMessage:=OnMessage;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('ਭ: ன', WinTitle);
		MinX:=300;
		MinY:=225;
		GetMem(Data, SizeOf(TPrnSetupData));
		If Parent=Nil
			Then Kernel.InitWindow(Me, 'BlueDlg', [wbMin, wbClose])
			Else Kernel.InitSheetWindow(Me, 'BlueDlg', [wbSlide], brLeft);
		WinBG:=bgManualDark;
		Kernel.DrawWindowAni(Me);

		With TPrnSetupData(Data^) Do
		Begin
			PicJack:=Kernel.LoadBMPRes('pic\b_jack1.bmp');
			PicA4P:=Kernel.LoadBMPRes('pic\b_a4p.bmp');
			PicA4L:=Kernel.LoadBMPRes('pic\b_a4l.bmp');
			PicA3P:=Kernel.LoadBMPRes('pic\b_a3p.bmp');
			PicA3L:=Kernel.LoadBMPRes('pic\b_a3l.bmp');
			PicDraft:=Kernel.LoadBMPRes('prog\prnsetup\draft.bmp');
			PicEmphasized:=Kernel.LoadBMPRes('prog\prnsetup\emphasiz.bmp');
			PicProportional:=Kernel.LoadBMPRes('prog\prnsetup\proport.bmp');
			PicNLQ:=Kernel.LoadBMPRes('prog\prnsetup\nlq.bmp');
			MakeMenus(Me);

			NbkModes:=Ctl.Notebook_Create(Me, True);

			LabModel:=Ctl.Label_Create(Me, ':', Nil, lsDisabled, alRight);
			BtnModel:=Ctl.Button_Create(Me, 'Epson-i᭨', Nil, ppLeft,
				Kernel.CtlDummyProc);
			BtnModel^.Enabled:=False;
			Ctl.Button_SetMarkStyle(BtnModel, bmMenuDown);

			LabPort:=Ctl.Label_Create(Me, 'i祭 :', Nil, lsNormal, alRight);
			Ini.Select('polit.ini', 'Print');
			TempStr:=Ini.GetStr('Port', 'LPT1');
			If (TempStr<>'LPT1') And (TempStr<>'LPT2') And
				(TempStr<>'LPT3') Then TempStr:='LPT1';
			PbtPort:=Ctl.PopupBtn_Create(Me, TempStr, MnuPort, PicJack, ppLeft);

			LabPaper:=Ctl.Label_Create(Me, 'ଠ :', Nil, lsNormal, alRight);
			Ini.Select('polit.ini', 'Print');
			TempStr:=Ini.GetStr('Paper', 'A4Portrait');
			TempStr2:='A4, 210x297 ';
			TempPtr:=PicA4P;
			If TempStr='A4LANDSCAPE' Then
			Begin
				TempStr2:='A4, 297x210 ';
				TempPtr:=PicA4L
			End;
			If TempStr='A3PORTRAIT' Then
			Begin
				TempStr2:='A3, 297x420 ';
				TempPtr:=PicA3P
			End;
			If TempStr='A3LANDSCAPE' Then
			Begin
				TempStr2:='A3, 420x297 ';
				TempPtr:=PicA3L
			End;
			PbtPaper:=Ctl.PopupBtn_Create(Me, TempStr2, MnuPaper,
				TempPtr, ppLeft);
			

			Ctl.Notebook_AddPage(NbkModes, '쭥', '', Nil);

			Ini.Select('polit.ini', 'Print');
			TempStr:=Ini.GetStr('TextMode', 'Polit');
			If (TempStr<>'POLIT') And (TempStr<>'PRINTER') Then
				TempStr:='POLIT';
			RadViaPolit:=Ctl.Radio_Create(Me, ' ',
				(TempStr='POLIT'), 1);
			Ctl.Radio_SetOnChange(RadViaPolit, OnFontRadio);

			Ini.Select('polit.ini', 'Print');
			TempStr2:=Ini.GetStr('PolitFont', 'Fonts\Printer8.raf');
			If D.FileExist(TempStr2)
				Then CurPolFont:=Kernel.LoadRes(D.UpCaseLine(TempStr2))
				Else CurPolFont:=Nil;
			CurPolFontName:=D.NormLine(D.ClipFName(TempStr2));
			PbtPolFont:=Ctl.PopupBtn_Create(Me, CurPolFontName,
				MnuPolFont, Nil, ppLeft);

			RadViaPrinter:=Ctl.Radio_Create(Me, ' ਭ',
				(TempStr='PRINTER'), 1);
			Ctl.Radio_SetOnChange(RadViaPrinter, OnFontRadio);

			Ini.Select('polit.ini', 'Print');
			TempStr:=Ini.GetStr('PrinterFont', 'NLQ');
			TempStr2:='i᭨';
         If TempStr='FASTDRAFT' Then TempStr2:='୮ (袨)';
         If TempStr='DRAFT' Then TempStr2:='୮';
			If TempStr='EMPHASIZED' Then TempStr2:='i';
			If TempStr='PROPORTIONAL' Then TempStr2:='யi';
			If TempStr='NLQ' Then TempStr2:='i᭨';
			PbtPrnFont:=Ctl.PopupBtn_Create(Me, TempStr2,
				MnuPrnFont, Nil, ppLeft);

			CanSample:=Ctl.Canvas_Create(Me, True);
			ChkJustify:=Ctl.Check_Create(Me,
				'i ⥪  ਭi i',
				Ini.GetBool('JustifyText', True));

			Ctl.Notebook_AddPage(NbkModes, ' ⥪i', '', Nil);
			{RadDither:=Ctl.Radio_Create(Me, '। ii 客', True, 2);
			RadMono:=Ctl.Radio_Create(Me, '஬ ࠦ', False, 2);
			Ctl.Notebook_AddPage(NbkModes, ' ⨭', '', Nil);}

			BtnTestPage:=Ctl.Button_Create(Me, '',
				Kernel.GetFileIcon('dummy.txt'), ppLeft, OnTestPageClick);
			BtnAccept:=Ctl.Button_Create(Me, '਩', Kernel.PicOK,
				ppLeft, OnAcceptClick);
			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseClick);

			ActiveCtl:=Ctl.PopupBtn_AsButton(PbtPort);
			ButtonEnter:=BtnAccept;
			ButtonEsc:=BtnClose
		End
	End
End;



Begin
	Kernel.RegBuiltIn('PrnSetup', '', 'pic\i_prnset.bmp', OnInit)
End.
