{$F+}
Unit
	PrnSpool; { Polit Halcyon PrnSpool application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, LPT;

Const
	MaxCount=9{450};
	InitTime=56;      { 3 ᥪ㭤 }
	PageFeedTime=270; { 15 ᥪ㭤 }

Type
	TSpoolerState=(ssNone, ssPreparing, ssPrinting, ssError, ssPause);
	TPrnSpoolData=Record
		LabNow, LabFName, LabSize, ProGress, LabStatus: PControl;
		LabQueue, LstQueue: PControl;
		PicPause, PicStop, PicHelp, PicUp, PicDown, PicRemove: Pointer;
		BtnPause, BtnStop, BtnHelp, BtnUp, BtnDown, BtnRemove: PControl;
		FName: String;
		F: File Of Char;
		BytesTotal, BytesSent: LongInt;
		State: TSpoolerState;
		Count: Integer;
		PrnTimeOut: LongInt;
	End;
   TSpoolTipData=Record
      Lab1, LabNoPaper, LabOffline, LabOff, Lab2: PControl;
	End;

Implementation

{ ********************* SpoolTip ********************* }

Procedure SpoolTip_OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TSpoolTipData(Data^) Do
	Begin
		Ctl.Label_Paint(Lab1, 10, 5, X2-X1-10);
		Ctl.Label_Paint(LabNoPaper, 10, 40, X2-X1-10);
		Ctl.Label_Paint(LabOffline, 10, 65, X2-X1-10);
		Ctl.Label_Paint(LabOff, 10, 90, X2-X1-10);
		Ctl.Label_Paint(Lab2, 10, 115, X2-X1-10);
	End;
End;

Procedure SpoolTip_OnClose(Me:PProg);
Begin
	FreeMem(Me^.Data, SizeOf(TSpoolTipData))
End;

Procedure SpoolTip_OnInit(Me:PProg);
Begin
	Me^.OnPaint:=SpoolTip_OnPaint;
	Me^.OnClose:=SpoolTip_OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('i', WinTitle);
		MinX:=200;
		MinY:=155;
		GetMem(Data, SizeOf(TSpoolTipData));
		Kernel.InitSheetWindow(Me, 'BlueDlg', [wbSlide], brLeft);
		Kernel.DrawWindowAni(Me);

		With TSpoolTipData(Data^) Do
		Begin
      	Lab1:=Ctl.Label_Create(Me, 'ਭ  ⮢ 㢠.'+#13+
				'i 稭 ⠪i:', Nil, lsComment, alLeft);
			LabNoPaper:=Ctl.Label_Create(Me, '- i稢 i;',
				Nil, lsComment, alLeft);
			LabOffline:=Ctl.Label_Create(Me, '-  ᭥  "Online";',
				Nil, lsComment, alLeft);
			LabOff:=Ctl.Label_Create(Me, '- ਭ  i.',
				Nil, lsComment, alLeft);
         Lab2:=Ctl.Label_Create(Me, 'i ਭ, i '+#13+
				'㬥 㤥 த.', Nil, lsComment, alLeft);
		End
	End
End;



{ ********************* PrnSpool ********************* }

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TPrnSpoolData(Data^) Do
	Begin
		Ctl.Label_Paint(LabNow, 10, 10, 80);
		Ctl.Label_Paint(LabFName, 90, 10, X2-X1-100);
		Ctl.Label_Paint(LabSize, X2-X1-95, 10, X2-X1-43);
		Ctl.Progress_Paint(ProGress, 90, 35, X2-X1-43);
		Ctl.Label_Paint(LabStatus, 90, 60, X2-X1-43);
		Ctl.Button_Paint(BtnPause, X2-X1-33, 10, X2-X1-10);
		Ctl.Button_Paint(BtnStop, X2-X1-33, 35, X2-X1-10);
      Ctl.Button_Paint(BtnHelp, X2-X1-33, 60, X2-X1-10);

		Ctl.Label_Paint(LabQueue, 10, 100, 80);
		Ctl2.ListBox_Paint(LstQueue, 90, 100, X2-X1-43, Y2-Y1-10);
		Ctl.Button_Paint(BtnUp, X2-X1-33, 100, X2-X1-10);
		Ctl.Button_Paint(BtnDown, X2-X1-33, 125, X2-X1-10);
		Ctl.Button_Paint(BtnRemove, X2-X1-33, 150, X2-X1-10);
	End;
End;

Function GetChar(Me:PProg): Char;
Var
	C: Char;
Begin
	With Me^, TPrnSpoolData(Data^) Do
	Begin
		Inc(BytesSent);
		Read(F, C);
		GetChar:=C
	End
End;


Procedure FilePrintComplete(Me:PProg);
Var
	TempItem: PListItem;
Begin
	With Me^, TPrnSpoolData(Data^) Do
	Begin
		Close(F);
		If D.UpCaseLine(D.ClipFExt(FName))='.TMP' Then
		Begin {  ⨬ᮢ 䠩  }
			Assign(F, FName);
			Erase(F)
		End;

		TempItem:=Ctl2.ListBox_GetItemByIndex(LstQueue, 1);
		If TempItem=Nil Then
		Begin {  i i  䠩i }
			Kernel.CloseProg(Me);
			Log.BugMsg('PrnSpool', 'OnIdle', 'Closed myself')
		End
		Else Begin { ६ 㯭 䠩 i ࣨ }
			FName:=String(TempItem^.SubItem^.SubItem^.Name^);
			Assign(F, FName);
			Reset(F);
			Ctl.Label_SetCaption(LabFName, String(TempItem^.Name^));
			BytesTotal:=FileSize(F);
			BytesSent:=0;
			State:=ssPreparing;
			PrnTimeOut:=D.SysTimer+PageFeedTime;
			Count:=0;
			Ctl.Label_SetCaption(LabSize,
				D.NormNum(D.StL(Round(BytesTotal/1024)))+' ');
			Ctl.Label_SetCaption(LabStatus, 'i⮢  ...');
			Ctl2.ListBox_DeleteItem(LstQueue, 1);
			Ctl.Progress_SetValue(ProGress, 0);
			Ctl.Progress_Draw(ProGress)
		End
	End
End;

Procedure OnIdle(Me:PProg);

	Procedure EnterErrorMode;
	Begin
		With Me^, TPrnSpoolData(Data^) Do
		Begin
			Ctl.Label_SetCaption(LabStatus, 'ਭ  ⮢');
			BtnHelp^.Enabled:=True;
			Ctl.Button_Draw(BtnHelp);
			State:=ssError
		End
	End;

	Procedure EnterPrintingMode;
	Begin
		With Me^, TPrnSpoolData(Data^) Do
		Begin
			Ctl.Label_SetCaption(LabStatus, ' 㬥...');
			BtnHelp^.Enabled:=False;
			Ctl.Button_Draw(BtnHelp);
			State:=ssPrinting
		End
	End;

Begin
	With Me^, TPrnSpoolData(Data^) Do
	Begin
		Inc(Count);
		If Count<MaxCount Then Exit;
		Count:=0;
		Case State Of
			ssPrinting: Begin
				If LPT.Ready Then
				Begin
					If Not EOF(F) Then
					Begin
						LPT.SendChar(GetChar(Me));
						Ctl.Progress_SetValue(ProGress, Round(BytesSent/BytesTotal*100))
					End
					Else
						FilePrintComplete(Me)
				End
				Else { Not LPT.Ready }
					If Not LPT.ReadyExceptBusy Then EnterErrorMode
			End;
			ssPreparing: Begin
				If D.SysTimer>PrnTimeOut Then EnterErrorMode;
				If LPT.Ready Then EnterPrintingMode
			End;
			ssError: If LPT.Ready Then EnterPrintingMode
		End { Case State }
	End
End;

Function OnMessage(Me,Sender:PProg; Msg:String; VData:Pointer): Pointer;
Var
	TempPort: String;
	TempFileName, TempShowName, TempSizeStr: String;
	TempSize: LongInt;
	TempF: File Of Char;
Begin
	OnMessage:=Nil;
	With Me^, TPrnSpoolData(Data^) Do
	Begin
		If Msg='PrintFile' Then
		Begin
			TempFileName:=String(TPtrList(VData^).Data^);
			If Not D.FileExist(TempFileName) Then
			Begin
				Log.ErrMsg('PrnSpool', 'OnMessage', 'File not found: '+
					TempFileName);
				Exit
			End;

			TempShowName:=String(TPtrList(VData^).Next^.Data^);
			Assign(TempF, TempFileName);
			Reset(TempF);
			TempSize:=FileSize(TempF);
			Close(TempF);
			TempSizeStr:=D.NormNum(D.StL(Round(TempSize/1024)))+' ';
			If State=ssNone Then
			Begin {   }
				FName:=TempFileName;
				Assign(F, FName);
				Reset(F);
				TempShowName:=D.LastPathItem(TempShowName);
				Ctl.Label_SetCaption(LabFName, TempShowName);
				Reset(F);
				BytesTotal:=TempSize;
				BytesSent:=0;
				State:=ssPreparing;
				PrnTimeOut:=D.SysTimer+InitTime;
				Count:=0;
				Ctl.Label_SetCaption(LabSize, TempSizeStr);
				Ctl.Label_SetCaption(LabStatus, 'i⮢  ...');

					{   ਭ }
				Ini.Select('polit.ini', 'Print');
				LPT.Port:=0; { LPT1 by default }
				TempPort:=Ini.GetStr('Port', 'LPT1');
				If TempPort='LPT2' Then LPT.Port:=1;
				If TempPort='LPT3' Then LPT.Port:=2;
				LPT.Init
			End
			Else Begin {    }
				TempShowName:=D.LastPathItem(TempShowName);
				Ctl2.ListBox_AddItemLast(LstQueue, TempShowName,
					Kernel.GetFileIcon(TempShowName), 0);
				Ctl2.ListBox_AddSubItem(LstQueue, TempSizeStr, Nil);
				Ctl2.ListBox_AddSubItem(LstQueue, TempFileName, Nil)
			End { If State=ssNone }
		End { If Msg='PrintFile' }
	End
End;

Procedure OnPauseClick(Me:PProg; Control:PControl);
Begin
	With Me^, TPrnSpoolData(Data^) Do
	Begin
		If State=ssPrinting
			Then State:=ssPause
			Else State:=ssPrinting;
		Ctl.Button_SetDown(BtnPause, (State=ssPause))
	End
End;

Procedure OnStopClick(Me:PProg; Control:PControl);
Var
	StartTime: LongInt;
Begin
	With Me^, TPrnSpoolData(Data^) Do
	Begin
		LPT.Init;
		StartTime:=D.SysTimer;
		Repeat
		Until (LPT.Ready) Or (D.SysTimer>StartTime+InitTime);
		If LPT.Ready Then
			LPT.SendChar(#12);
		FilePrintComplete(Me)
	End
End;

Procedure OnHelpClick(Me:PProg; Control:PControl);
Var
	TempProg: PProg;
Begin
	With Me^, TPrnSpoolData(Data^) Do
	Begin
		TempProg:=Kernel.FindProg('PrnSpool dialog');
		If TempProg=Nil
			Then Kernel.RunChild(Me, SpoolTip_OnInit, '')
			Else Kernel.CloseProg(TempProg);
		Ctl.Button_SetDown(BtnHelp, Not Ctl.Button_GetDown(BtnHelp))
	End
End;

Procedure OnRemoveClick(Me:PProg; Control:PControl);
Begin
	With Me^, TPrnSpoolData(Data^) Do
		Ctl2.ListBox_DeleteItem(LstQueue,
			Ctl2.ListBox_GetSelItemIndex(LstQueue))
End;





Procedure OnClose(Me:PProg);
Begin
	Kernel.FreeRes('b_pause2.bmp');
	Kernel.FreeRes('b_stop.bmp');
   Kernel.FreeRes('b_help.bmp');
	Kernel.FreeRes('b_up.bmp');
	Kernel.FreeRes('b_down.bmp');
	Kernel.FreeRes('b_erase.bmp');
	FreeMem(Me^.Data, SizeOf(TPrnSpoolData))
End;

Procedure OnInit(Me:PProg);
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnIdle:=OnIdle;
	Me^.OnMessage:=OnMessage;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('ਭ', WinTitle);
		MinX:=350;
		MinY:=210;
		GetMem(Data, SizeOf(TPrnSpoolData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TPrnSpoolData(Data^) Do
		Begin
			PicPause:=Kernel.LoadBmpRes('pic\b_pause2.bmp');
			PicStop:=Kernel.LoadBmpRes('pic\b_stop.bmp');
         PicHelp:=Kernel.LoadBmpRes('pic\b_help.bmp');
			PicUp:=Kernel.LoadBmpRes('pic\b_up.bmp');
			PicDown:=Kernel.LoadBmpRes('pic\b_down.bmp');
			PicRemove:=Kernel.LoadBmpRes('pic\b_erase.bmp');

				{ i箣   }
			FName:='';
			State:=ssNone;

			LabNow:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
			LabFName:=Ctl.Label_Create(Me, '', Kernel.GetFileIcon(FName),
				lsBeveled, alLeft);
			LabSize:=Ctl.Label_Create(Me, '', Nil, lsBeveled, alRight);
			ProGress:=Ctl.Progress_Create(Me, 0, 100, 0, pkDeterm);
			LabStatus:=Ctl.Label_Create(Me, '( )', Nil, lsNormal, alCenter);
			BtnPause:=Ctl.Button_Create(Me, '', PicPause, ppLeft, OnPauseClick);
			D.ReassignPStr('ਧ㯨 ', BtnPause^.Hint);
			BtnStop:=Ctl.Button_Create(Me, '', PicStop, ppLeft, OnStopClick);
			D.ReassignPStr('ii ', BtnStop^.Hint);
			BtnHelp:=Ctl.Button_Create(Me, '', PicHelp, ppLeft, OnHelpClick);
			BtnHelp^.Enabled:=False;
			D.ReassignPStr(' ᭥', BtnHelp^.Hint);

			LabQueue:=Ctl.Label_Create(Me, ' i:', Nil, lsNormal, alRight);
			LstQueue:=Ctl2.ListBox_Create(Me, False);
			Ctl2.ListBox_SetColumnProps(LstQueue, 2, lcRight, True);
			Ctl2.ListBox_SetColumnProps(LstQueue, 3, lcLeft, False);

			BtnUp:=Ctl.Button_Create(Me, '', PicUp, ppLeft, Kernel.CtlDummyProc);
			D.ReassignPStr('⠢ 㬥'+#13+'   ࣨ', BtnUp^.Hint);
			BtnDown:=Ctl.Button_Create(Me, '', PicDown, ppLeft, Kernel.CtlDummyProc);
			D.ReassignPStr('⠢ 㬥'+#13+'i i  ࣨ', BtnDown^.Hint);
			BtnRemove:=Ctl.Button_Create(Me, '', PicRemove, ppLeft, OnRemoveClick);
			D.ReassignPStr(' 㬥 i ࣨ  ', BtnRemove^.Hint);

			ActiveCtl:=LstQueue;


		End
	End
End;



Begin
	Kernel.RegBuiltIn('PrnSpool', '', 'pic\i_print.bmp', OnInit)
End.
