{ ************ Radio button ************ }
Type
	TRadio=Record
		Caption: PStr;
		OnChange: TCtlHandler;
		Group: Integer;
		Selected, SelNow: Boolean
	End;

Var
	RadioInside: Boolean;
	PicRadio: TSkinPic;


Procedure Radio_OnDestroy(Me:PControl);
Begin
	With Me^, TRadio(Data^) Do
	Begin
		D.FreePStr(Caption, 'Ctl - Radio_OnDestroy');
		FreeMem(Data, SizeOf(TRadio))
	End
End;

Procedure Radio_IntDraw(Me:PControl);
Var
	TempStr:String;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, Place, TRadio(Data^) Do
	Begin
		gfx.PutSprite(X1, Y1, PicRadio[Enabled, SelNow]);
		{If Enabled Then
			If SelNow
				Then Gfx.PutSprite(X1, Y1, PicRadioE1)
				Else Gfx.PutSprite(X1, Y1, PicRadioE0)
		Else
			If SelNow
				Then Gfx.PutSprite(X1, Y1, PicRadioD1)
				Else Gfx.PutSprite(X1, Y1, PicRadioD0);}

		Font.SetFont(Kernel.CurFont);
		TempStr:=Kernel.ShortenStr(String(Caption^), X2-X1-21);
		If Enabled
			Then Font.Print(X1+21, Y1+2, Kernel.ClrText, TempStr)
			Else Font.Print(X1+21, Y1+2, Kernel.ClrTextDis, TempStr)
	End;
End;

Procedure Radio_Paint(Me:PControl; VX1, VY1:Integer);
Begin
	Font.SetFont(Kernel.CurFont);
	With Me^, TRadio(Data^), Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1+2, X1+VX1+Font.Width(String(Caption^))+21,
			Y1+VY1+14+2, Me^.Place);
	Radio_IntDraw(Me)
End;

Procedure Radio_OnClick(Me:PControl; X, Y:Integer); Forward;

Procedure Radio_UnselectGroup(Prog:PProg; VGroup:Integer);
Var
	Cur:PControl;
Begin
	Cur:=Prog^.FirstCtl;
	While Cur<>Nil Do
	Begin
		If (Addr(Cur^.OnClick)=Addr(Radio_OnClick)) And
			(TRadio(Cur^.Data^).Group=VGroup) Then { to fix in future }
		Begin
			TRadio(Cur^.Data^).Selected:=False;
			TRadio(Cur^.Data^).SelNow:=False;
			If (Cur^.CanDraw Or Kernel.DontBother) And Cur^.Visible Then
			Begin
				Kernel.BeginPaint(Cur^.Place);
				Radio_IntDraw(Cur);
				Kernel.EndPaint
			End
		End;
		Cur:=Cur^.Next
	End
End;

Function Radio_OnKey(Me:PControl; Key, ExtKey:Char): Boolean;
Begin
	With Me^, TRadio(Data^) Do
		If Key=' ' Then
		Begin
			Radio_UnselectGroup(Owner, Group);
			Selected:=Not Selected;
			SelNow:=Selected;
			Radio_IntDraw(Me);
			TRadio(Me^.Data^).OnChange(Me^.Owner, Me);
			Radio_OnKey:=True
		End
		Else
			Radio_OnKey:=False
End;


Procedure Radio_HideMouse(Var X, Y:Integer);
Begin
	RadioInside:=D.InRect(X, Y, CurCtl^.Place);
	Kernel.HideMouse(X, Y)
End;

Procedure Radio_ShowMouse(Var X, Y:Integer);
Var
	InsideNow:Boolean;
Begin
	InsideNow:=D.InRect(X, Y, CurCtl^.Place);
	With TRadio(CurCtl^.Data^) Do
		If RadioInside Xor InsideNow Then
		Begin
			SelNow:=InsideNow Or Selected;
			Radio_IntDraw(CurCtl)
		End;
	Kernel.ShowMouse(X, Y)
End;

Procedure Radio_OnClick(Me:PControl; X, Y:Integer);
Begin
	With TRadio(Me^.Data^) Do
	Begin
		RadioInside:=True;
		CurCtl:=Me;
		SelNow:=True;
		Radio_IntDraw(Me);
		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(Radio_HideMouse, Radio_ShowMouse,
			Kernel.RefreshNeeded)=0;
		If SelNow Then
		Begin
			With Me^ Do
			Begin
				Radio_UnselectGroup(Owner, Group);
				Selected:=True;
				SelNow:=True;
				TRadio(Data^).OnChange(Owner, Me)
			End
		End;
		Radio_IntDraw(Me);
	End
End;

Procedure Radio_TryAutoRedraw(Me:PControl);
Begin
	If Me^.AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
		If (Me^.CanDraw Or Kernel.DontBother) And Me^.Visible Then
		Begin
			Kernel.BeginPaint(Me^.Place);
			Radio_IntDraw(Me);
			Kernel.EndPaint
		End
End;

Procedure Radio_Draw(Me:PControl);
Begin
	With Me^ Do
		If CanDraw Or Kernel.DontBother Then
		Begin
			Kernel.BeginPaint(Place);
			If Visible
				Then Radio_IntDraw(Me)
				Else Kernel.HideCtl(Me);
			Kernel.EndPaint
		End
End;

Procedure Radio_SetCaption(Me:PControl; VCaption:String);
Begin
	With Me^, TRadio(Data^) Do
		D.ReAssignPStr(VCaption, Caption);
	Kernel.BeginPaint(Me^.Place);
	Kernel.HideCtl(Me);
	Kernel.EndPaint;
	Radio_TryAutoRedraw(Me)
End;

Procedure Radio_Select(Me:PControl);
Begin
	With Me^, TRadio(Data^) Do
	Begin
		Radio_UnselectGroup(Owner, Group);
		Selected:=True;
	End;
	Radio_TryAutoRedraw(Me)
End;

Function Radio_Selected(Me:PControl): Boolean;
Begin
	Radio_Selected:=TRadio(Me^.Data^).Selected
End;

Procedure Radio_SetOnChange(Me:PControl; VOnChange:TCtlHandler);
Begin
	With Me^, TRadio(Data^) Do
		OnChange:=VOnChange
End;

Function Radio_Create(Prog:PProg; VCaption:String; VSelected:Boolean;
	VGroup:Integer):PControl;
Var
	Me:PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Radio_OnClick, Radio_OnKey, Kernel.CtlRefocusDummy,
		Kernel.CtlDummy, Radio_OnDestroy, VEnabled, True, Hint);}
	With Me^ Do
	Begin
		OnClick:=Radio_OnClick;
		OnKey:=Radio_OnKey;
		OnDestroy:=Radio_OnDestroy;

		GetMem(Data, SizeOf(TRadio));
		With TRadio(Data^) Do
		Begin
			D.AssignPStr(VCaption, Caption);
			OnChange:=Kernel.CtlDummyProc;
			Group:=VGroup;
			Selected:=VSelected;
			SelNow:=VSelected;
		End
	End;
	Radio_Create:=Me
End;
