{ ************ Scroll ************ }
Type
	TScroll=Record
		Orient: TOrientation;
		OnUpdate: TCtlHandler;
		TotalLen, VisLen, FirstItem: LongInt{Integer};
		FirstItem10: LongInt;
		ToAdd: Integer;
		DecRect, IncRect, SliderRect: TRect;
		Scrolling: Boolean;
		InRange: Boolean;
	End;
	TScrollUnderMouse=(umNone, umSlider, umDec, umInc);

Const
	ButtonSize=15;
	ScrollSpeed=3;

Var
	UnderMouse: TScrollUnderMouse;
	PicLine, PicDrag: Array[TOrientation] Of TSkinPic;
	PicArDec, PicArInc: Array[TOrientation] Of TSkinPic;
	PicSlider1, PicSlider2: Array[TOrientation] Of TSkinPic;
	ScrollSliderSkinned, ScrollDragSkinned: Boolean;
	MinSliderSize: Integer;

Function Scroll_Coord(Me:PControl; Item:Integer): Integer;
Begin
	With Me^, TScroll(Data^), Place Do
		If Orient=orVertical
			Then Scroll_Coord:=ButtonSize+1+Round(LongInt(Item)*
				LongInt(Y2-Y1-ButtonSize*2-2)/(TotalLen+ToAdd))
			Else Scroll_Coord:=ButtonSize+1+Round(LongInt(Item)*
				LongInt(X2-X1-ButtonSize*2-2)/(TotalLen+ToAdd))
End;


Procedure Scroll_DrawUpperShaft(Me:PControl; Item1,Item2:Integer);
Var
	I, Base: Integer;
Begin
	With Me^, TScroll(Data^), Place Do
		If Orient=orVertical Then
		Begin
			Base:=Y1+ButtonSize;
			For I:=Scroll_Coord(Me, Item1) To Scroll_Coord(Me, Item2)-1 Do
				Gfx.PutImage(X1, Y1+I, PicLine[orVertical, Enabled, Not Odd(Base+Y1+I)])
		End
		Else Begin
			Base:=X1+ButtonSize;
			For I:=Scroll_Coord(Me, Item1) To Scroll_Coord(Me, Item2)-1 Do
				Gfx.PutImage(X1+I, Y1, PicLine[orHorizontal, Enabled, Not Odd(Base+X1+I)])
		End
End;

Procedure Scroll_DrawLowerShaft(Me:PControl; Item1,Item2:Integer);
Var
	I, Base: Integer;
Begin
	With Me^, TScroll(Data^), Place Do
		If Orient=orVertical Then
		Begin
			Base:=Y2-ButtonSize;
			For I:=Scroll_Coord(Me, Item1)+1 To Scroll_Coord(Me, Item2) Do
				Gfx.PutImage(X1, Y1+I, PicLine[orVertical, Enabled, Not Odd(Base+Y1+I)])
		End
		Else Begin
			Base:=X2-ButtonSize;
			For I:=Scroll_Coord(Me, Item1)+1 To Scroll_Coord(Me, Item2) Do
				Gfx.PutImage(X1+I, Y1, PicLine[orHorizontal, Enabled, Not Odd(Base+X1+I)])
		End
End;

Procedure Scroll_DrawSlider(Me:PControl);
Var
	Shift: Integer;
	IsPressed: Boolean;
	TempX, TempY: Integer;
Begin
	With Me^, TScroll(Data^), SliderRect Do
	Begin
		IsPressed:=Scrolling And (UnderMouse=umSlider);
		If IsPressed
			Then Shift:=1
			Else Shift:=0;
		If ScrollSliderSkinned Then
		Begin
			If Orient=orVertical
				Then Gfx.SkinBarVer(X1, Y1, Y2,
					PicSlider1[Orient, Enabled, IsPressed],
					PicSlider2[Orient, Enabled, IsPressed])
				Else Gfx.SkinBar(X1, Y1, X2,
					PicSlider1[Orient, Enabled, IsPressed],
					PicSlider2[Orient, Enabled, IsPressed])
		End
		Else Begin
			If Enabled
				Then If IsPressed
					Then Gfx.FillButtonRect(X1, Y1, X2, Y2, Kernel.Clr3DActDark,
						Kernel.Clr3DActLight, Kernel.Clr3DAct)
					Else Gfx.FillButtonRect(X1, Y1, X2, Y2, Kernel.Clr3DLight,
						Kernel.Clr3DDark, Kernel.Clr3DFace)
				Else Gfx.FillButtonRect(X1, Y1, X2, Y2, Kernel.ClrTextDis,
						Kernel.ClrTextDis, Kernel.ClrWinBG)
		End;
		If ScrollDragSkinned Then
		Begin
			TempX:=X1+(X2-X1-Gfx.ImageX(PicDrag[Orient, True, True])) Div 2+Shift;
			TempY:=Y1+(Y2-Y1-Gfx.ImageY(PicDrag[Orient, True, True])) Div 2+Shift;
			Gfx.PutSprite(TempX, TempY, PicDrag[Orient, Enabled, IsPressed])
		End
	End
End;

Procedure Scroll_UpdateSlider(Me:PControl);
Var
	Upper, Lower: LongInt;
Begin
	With Me^, TScroll(Data^), Place Do
		If InRange Then
		Begin
			Upper:=Scroll_Coord(Me, FirstItem-1);
			Lower:=Scroll_Coord(Me, FirstItem+VisLen+ToAdd-1);
			If ToAdd=0 Then
				While Lower-Upper<MinSliderSize Do
				Begin
					Inc(ToAdd);
					Upper:=Scroll_Coord(Me, FirstItem-1);
					Lower:=Scroll_Coord(Me, FirstItem+VisLen+ToAdd-1)
				End;
			If Orient=orVertical
				Then D.AssignRect(X1, Y1+Upper, X2, Y1+Lower, SliderRect)
				Else D.AssignRect(X1+Upper, Y1, X1+Lower, Y2, SliderRect);
		End
End;

Procedure Scroll_IntDraw(Me:PControl);
Var
	I, Temp, Temp2{, TX, TY}: Integer;
	Shift: Integer;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, TScroll(Data^), Place Do
	Begin
		If (VisLen<TotalLen) And (FirstItem>=1) And (FirstItem+VisLen-1<=TotalLen)
			Then InRange:=True
			Else InRange:=False;

		ToAdd:=0;
		Scroll_UpdateSlider(Me);

		With DecRect Do
			Gfx.PutSprite(X1, Y1, PicArDec[Orient,
				(Enabled And (FirstItem>1)),
				(Scrolling And (UnderMouse=umDec))]);

		With IncRect Do
			Gfx.PutSprite(X1, Y1, PicArInc[Orient,
				(Enabled And (FirstItem<TotalLen-VisLen+1)),
				(Scrolling And (UnderMouse=umInc))]);

		If InRange Then
		Begin
			Scroll_DrawSlider(Me);
			Scroll_DrawUpperShaft(Me, 0, FirstItem-1);
			Scroll_DrawLowerShaft(Me, FirstItem+VisLen+ToAdd-1, TotalLen+ToAdd);
			If Orient=orVertical Then
			Begin
				Gfx.PutImage(X1, Y1+15, PicLine[orVertical, Enabled, True]);
				Gfx.PutImage(X1, Y2-15, PicLine[orVertical, Enabled, True])
			End
			Else Begin
				Gfx.PutImage(X1+15, Y1, PicLine[orHorizontal, Enabled, True]);
				Gfx.PutImage(X2-15, Y1, PicLine[orHorizontal, Enabled, True])
			End
		End
		Else If Orient=orVertical
			Then Kernel.WindowBar(X1, Y1+15, X2, Y2-15, False, True)
			Else Kernel.WindowBar(X1+15, Y1, X2-15, Y2, False, True)
	End;
End;

Procedure Scroll_Paint(Me:PControl; VX1,VY1,VX2,VY2:Integer);
Begin
	With Me^.Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY2, Me^.Place);
	With Me^, Place, TScroll(Data^) Do
		If Orient=orVertical Then
		Begin
			D.AssignRect(X1, Y1, X2, Y1+ButtonSize-1, DecRect);
			D.AssignRect(X1, Y2-ButtonSize+1, X2, Y2, IncRect)
		End
		Else Begin
			D.AssignRect(X1, Y1, X1+ButtonSize-1, Y2, DecRect);
			D.AssignRect(X2-ButtonSize+1, Y1, X2, Y2, IncRect)
		End;
	Scroll_IntDraw(Me)
End;

Procedure Scroll_PaintDirect(Me:PControl; VX1,VY1,VX2,VY2:Integer);
Begin
	D.AssignRect(VX1, VY1, VX2, VY2, Me^.Place);
	With Me^, Place, TScroll(Data^) Do
		If Orient=orVertical Then
		Begin
			D.AssignRect(X1, Y1, X2, Y1+ButtonSize-1, DecRect);
			D.AssignRect(X1, Y2-ButtonSize+1, X2, Y2, IncRect)
		End
		Else Begin
			D.AssignRect(X1, Y1, X1+ButtonSize-1, Y2, DecRect);
			D.AssignRect(X2-ButtonSize+1, Y1, X2, Y2, IncRect)
		End;
	Scroll_IntDraw(Me)
End;

Procedure Scroll_Draw(Me:PControl);
Begin
	With Me^ Do
		If CanDraw Or Kernel.DontBother Then
		Begin
			Kernel.BeginPaint(Place);
			If Visible
				Then Scroll_IntDraw(Me)
				Else Kernel.HideCtl(Me);
			Kernel.EndPaint
		End
End;



Procedure Scroll_MoveSlider(Me:PControl; Delta:Integer);
Var
	LastFI, I: Integer;
Begin
	With Me^, Place, TScroll(Data^) Do
	Begin
		{Log.BugMsg('Ctl', 'Scroll_MoveSlider', 'Starting...');}
		LastFI:=FirstItem;
		Inc(FirstItem10, Delta);
		If FirstItem10<10 Then
			FirstItem10:=10;
		If FirstItem10>LongInt(TotalLen-VisLen+1)*10 Then
			FirstItem10:=LongInt(TotalLen-VisLen+1)*10;
		FirstItem:=Round(FirstItem10/10);
		{Log.BugMsg('Ctl', 'Scroll_MoveSlider', 'New FirstItem='+
			D.St(FirstItem));}
		If FirstItem=LastFI Then Exit;
		Kernel.BeginPaint(Place);
		If (FirstItem=1) Or (FirstItem=TotalLen-VisLen+1) Or
			(((LastFI=1) Or (LastFI=TotalLen-VisLen+1)) And (FirstItem<>LastFI)) Then
		Begin
			{Log.BugMsg('Ctl', 'Scroll_MoveSlider', 'Going to draw...');}
			Scroll_IntDraw(Me);
			Kernel.EndPaint;
			If OwnerCtl=Nil
				Then OnUpdate(Me^.Owner, Me)
				Else OnUpdate(Me^.Owner, OwnerCtl);
			Exit
		End;
		With SliderRect Do
			Gfx.Bar(X1, Y1, X2, Y2, Kernel.ClrWinBG);
		Scroll_UpdateSlider(Me);
		Scroll_DrawSlider(Me);
		If Delta>0
			Then Scroll_DrawUpperShaft(Me, LastFI-1, FirstItem-1)
			Else Scroll_DrawLowerShaft(Me, FirstItem+VisLen+ToAdd-1,
				LastFI+VisLen+ToAdd-1);
		Kernel.EndPaint;
		If OwnerCtl=Nil
			Then OnUpdate(Me^.Owner, Me)
			Else OnUpdate(Me^.Owner, OwnerCtl)
	End
End;

Procedure Scroll_Timer(Me:PControl; Times:Integer);
Var
	NextFI: Integer;
	NextFI10: LongInt;
	TempDelta: Integer;
Begin
	With Me^,Place,TScroll(Data^) Do
	Begin
		{Log.BugMsg('Ctl', 'Scroll_Timer', 'Starting...');}
		If (UnderMouse=umDec) And (FirstItem>1) Then
			Scroll_MoveSlider(Me, -2*Times);
		If (UnderMouse=umInc) And (FirstItem+VisLen-1<TotalLen) Then
			Scroll_MoveSlider(Me, 2*Times);
		If (UnderMouse=umSlider) And (Delta<>0) Then
		Begin
			NextFI10:=FirstItem10+(Delta Div 5)*Times;
			If NextFI10<=10 Then
			Begin
				NextFI10:=10;
				Delta:=0;
				{If Orient=orVertical
					Then Kernel.SelectCursor(MouseScrVer)
					Else Kernel.SelectCursor(MouseScrHor)}
			End;
			If NextFI10>=LongInt(TotalLen-VisLen+1)*10 Then
			Begin
				NextFI10:=LongInt(TotalLen-VisLen+1)*10;
				Delta:=0;
				{If Orient=orVertical
					Then Kernel.SelectCursor(MouseScrVer)
					Else Kernel.SelectCursor(MouseScrHor)}
			End;
			NextFI:=Round(NextFI10/10);
			{If (FirstItem<>NextFI) And ((NextFI=1) Or (NextFI=TotalLen-VisLen+1)) Then
				Delta:=0;}
			If FirstItem<>NextFI Then
			Begin
				Kernel.HideMouse(Kernel.MsX, Kernel.MsY);
				TempDelta:=Scroll_Coord(Me, NextFI)-Scroll_Coord(Me, FirstItem);
				If Orient=orVertical
					Then Inc(Kernel.MsY, TempDelta)
					Else Inc(Kernel.MsX, TempDelta);
				Kernel.ShowMouse(Kernel.MsX, Kernel.MsY)
			End;
			If FirstItem10<>NextFI10 Then
			Begin
				Scroll_MoveSlider(Me, NextFI10-FirstItem10);
				{Log.SysMsg('Ctl','Scroll_Timer','Delta='+D.St(Delta)+
					', mouse shift='+D.St(TempDelta)+
					', slider shift='+D.St(NextFI-FirstItem))}
			End
		End
	End
End;

Procedure Scroll_HideMouse(Var X,Y:Integer);
Begin
	LastMsX:=X;
	LastMsY:=Y;
	Kernel.HideMouse(X, Y)
End;

Procedure Scroll_ShowMouse(Var X,Y:Integer);
Var
	LastDelta: Integer;
	DeltaSign: Integer;
Begin
	LastDelta:=Delta;
	If TScroll(CurCtl^.Data^).Orient=orVertical
		Then Inc(Delta, Y-LastMsY)
		Else Inc(Delta, X-LastMsX);
	If UnderMouse=umSlider Then
	Begin
		DeltaSign:=D.Sgn(Delta Div 5);
		If D.Sgn(LastDelta Div 5)<>DeltaSign Then
			If TScroll(CurCtl^.Data^).Orient=orVertical
				Then Case DeltaSign Of
					-1: Kernel.SelectCursor(MouseScrUp);
					 0: Kernel.SelectCursor(MouseScrVer);
					 1: Kernel.SelectCursor(MouseScrDown)
				End
				Else Case DeltaSign Of
					-1:Kernel.SelectCursor(MouseScrLeft);
					 0:Kernel.SelectCursor(MouseScrHor);
					 1:Kernel.SelectCursor(MouseScrRight)
				End
	End;
	X:=LastMsX;
	Y:=LastMsY;
	Kernel.MsX8:=X*8;
	Kernel.MsY8:=Y*8;
	Kernel.ShowMouse(X, Y)
End;

Procedure Scroll_OnClick(Me:PControl; X,Y:Integer);
Var
	Temp: Integer;
	ClickCoord, SliderLenPx: LongInt{Integer};
	CellLenPx, SliderCenter: Real;
Begin
	If Not (Me^.Enabled) Or Not TScroll(Me^.Data^).InRange Then
	Begin
		Kernel.SelectCursor(Kernel.MouseNo);
		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(Kernel.HideMouse,
			Kernel.ShowMouse, Kernel.RefreshNeeded)=0;
		Kernel.SelectCursor(Kernel.MouseDefault);
		Exit
	End;

	CurCtl:=Me;
	With Me^, Place, TScroll(Data^) Do
	Begin
		If D.InRect(X, Y, DecRect)
			Then UnderMouse:=umDec
			Else If D.InRect(X, Y, IncRect)
				Then UnderMouse:=umInc
				Else Begin
					UnderMouse:=umSlider;
					If Not D.InRect(X, Y, SliderRect) Then
					Begin
						SliderLenPx:=Scroll_Coord(Me, VisLen+ToAdd)-
							Scroll_Coord(Me, 0);
						CellLenPx:=SliderLenPx/(VisLen+ToAdd);
						If Orient=orVertical Then
						Begin
							ClickCoord:=Y-Place.Y1-15-1-(SliderLenPx Div 2);
							D.ToRangeL(ClickCoord, 0, Y2-Y1-30-2-SliderLenPx)
						End
						Else Begin
							ClickCoord:=X-Place.X1-15-1-(SliderLenPx Div 2);
							D.ToRangeL(ClickCoord, 0, X2-X1-30-2-SliderLenPx)
						End;
						SliderCenter:=ClickCoord/CellLenPx;
						FirstItem:=Round(SliderCenter)+1;
						D.ToRangeL(FirstItem, 1, TotalLen-VisLen+1);

						If OwnerCtl=Nil
							Then OnUpdate(Me^.Owner, Me)
							Else OnUpdate(Me^.Owner, OwnerCtl)
					End
				End;
		FirstItem10:=LongInt(FirstItem*10);
		Case UnderMouse Of
			umDec:Begin
				If Orient=orVertical
					Then Kernel.SelectCursor(MouseScrUp)
					Else Kernel.SelectCursor(MouseScrLeft);
				Scroll_MoveSlider(Me, -10)
			End;
			umInc:Begin
				If Orient=orVertical
					Then Kernel.SelectCursor(MouseScrDown)
					Else Kernel.SelectCursor(MouseScrRight);
				Scroll_MoveSlider(Me, 10)
			End;
			umSlider:If Orient=orVertical
				Then Kernel.SelectCursor(MouseScrVer)
				Else Kernel.SelectCursor(MouseScrHor)
		End;
		Scrolling:=True;
		Kernel.AddTimer(Me, Scroll_Timer, 1);
		
		Scroll_IntDraw(Me);
		LastMsX:=Kernel.MsX;
		LastMsY:=Kernel.MsY;
		Delta:=0;

		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(Scroll_HideMouse, Scroll_ShowMouse,
			Kernel.RefreshNeeded)=0;

		Kernel.RemoveTimer(Me, Scroll_Timer);
		Kernel.SelectCursor(Kernel.MouseDefault);
		Scrolling:=False;
		Scroll_IntDraw(Me)
	End
End;

Function Scroll_OnKey(Me:PControl; Key,ExtKey:Char): Boolean;
Begin
	Scroll_OnKey:=True;
	With Me^, TScroll(Data^) Do
	Begin
		FirstItem10:=LongInt(FirstItem*10);
		If Key=#0 Then
			Case ExtKey Of
				#72,#75: If FirstItem>1 Then
					Scroll_MoveSlider(Me, -10);
				#80,#77: If FirstItem+VisLen-1<TotalLen Then
					Scroll_MoveSlider(Me, 10);
				#73: If FirstItem>VisLen-1
					Then Scroll_MoveSlider(Me, -(VisLen-1)*10)
					Else Scroll_MoveSlider(Me, -(FirstItem+1)*10);
				#81: If FirstItem+VisLen<TotalLen-VisLen+1
					Then Scroll_MoveSlider(Me, (VisLen-1)*10)
					Else Scroll_MoveSlider(Me, (TotalLen-VisLen+1-FirstItem)*10);
				#71: Scroll_MoveSlider(Me, -(FirstItem+1)*10);
				#79: Scroll_MoveSlider(Me, (TotalLen-VisLen+1-FirstItem)*10);
				Else Scroll_OnKey:=False
			End
		Else
			Scroll_OnKey:=False
	End
End;

Procedure Scroll_OnDestroy(Me:PControl);
Begin
	With Me^ Do
		FreeMem(Data, SizeOf(TScroll));
End;

Procedure Scroll_SetParams(Me:PControl; VTotalLen,VVisLen,VFirstItem:Integer);
Begin
	With Me^, TScroll(Data^) Do
	Begin
		TotalLen:=VTotalLen;
		{If TotalLen=0 Then
			TotalLen:=1;}
		VisLen:=VVisLen;
		FirstItem:=VFirstItem;
		FirstItem10:=LongInt(FirstItem)*10;
		

		If AutoRedraw And Not Kernel.IgnoreAutoRedraw And
			(Me^.CanDraw Or Kernel.DontBother) And Visible Then
		Begin
			Kernel.BeginPaint(Place);
			Scroll_IntDraw(Me);
			Kernel.EndPaint
		End
		Else
			ToAdd:=0 {  箬 Scroll_Draw 㢠 ToAdd }
	End
End;

Function Scroll_GetPos(Me:PControl): Integer;
Begin
	With Me^, TScroll(Data^) Do
		Scroll_GetPos:=FirstItem
End;

Function Scroll_Create(Prog:PProg; VTotalLen,VVisLen,VFirstItem:Integer;
	VOrient:TOrientation; VOnUpdate:TCtlHandler): PControl;
Var
	Me: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Scroll_OnClick,Scroll_OnKey,
		Kernel.CtlRefocusDummy,Kernel.CtlDummy,Scroll_Destroy,VEnabled,
		False,Hint);}
	With Me^ Do
	Begin
		OnClick:=Scroll_OnClick;
		OnKey:=Scroll_OnKey;
		OnDestroy:=Scroll_OnDestroy;

		GetMem(Data, SizeOf(TScroll));
		With TScroll(Data^) Do
		Begin
			Orient:=VOrient;
			OnUpdate:=VOnUpdate;
			TotalLen:=VTotalLen;
			VisLen:=VVisLen;
			FirstItem:=VFirstItem;
			{If (VisLen<TotalLen) And (FirstItem>=1) And (FirstItem+VisLen-1<=TotalLen)
				Then InRange:=True
				Else InRange:=False;}
			FirstItem10:=10;
			ToAdd:=0;
			Scrolling:=False;
		End
	End;
	Scroll_Create:=Me
End;
