{$F+}
Unit
	ScrSetup; { Polit Halcyon ScrSetup application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Gfx, Ini, DOS, Popup, Pic;

Type
	TScrSetupData=Record
		RealPal: TPalette;
		PicSkin, PicColorSet, PicCursorSet: Pointer;
		PicMonCtls: Pointer;

		NbkPages: PControl;
		BtnClose: PControl;

		Trk4size, Lab4Size, Lab4S: PControl;
		BtnTry: PControl;

		Lab2, PbtSkin: PControl;
		Lab3, PbtColorSet: PControl;
		Lab4, PbtCursorSet: PControl;

		ChkFade, LabFade, TrkFade: PControl;
		ChkZoom, LabZoom, TrkZoom: PControl;
		MnuPopupStyle, MnuWinBG: PMenuItem;
		PicMon, PicPopSt0, PicPopSt1, PicPopSt2, PicPopSt3,
			PicPopSt4, PicPopSt5, PicPopSt6, PicPopSt7: Pointer;
		PicWinBG0, PicWinBG1, PicWinBG2: Pointer;
		PicRes: Array[1..5] Of Pointer;
		LabPopup, PbtPopup: PControl;
		LabWinBG, PbtWinBG: PControl;
		CanMon: PControl;
		PctMonCtls, LabBright, TrkBright, LabCont, TrkCont: PControl;
		CanTheme1, CanTheme2, LstTheme: PControl;
		ChkStopAnims: PControl;

		MnuSkin, MnuColors, MnuCursors: PMenuItem;

		Themes: Array[1..45] Of PStr;
		ThemesNum: Integer;
		PopupStyle, WinBGMode: Char;
		FontName: String;
	End;

Implementation

Procedure DrawThemePreview(Me:PProg; CanTheme:PControl); Forward;

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TScrSetupData(Data^) Do
	Begin
		Kernel.WinBGBar(Me, X1, Y1, X2, Y1+4);
		Kernel.WinBGBar(Me, X1, Y1+5, X1+4, Y2-35);
		Kernel.WinBGBar(Me, X2-4, Y1+5, X2, Y2-35);
		Kernel.WinBGBar(Me, X1, Y2-34, X2, Y2);
		Kernel.WindowBar(X1+5, Y1+5+22, X2-5, Y2-35, False, False);

		Ctl.Notebook_Paint(NbkPages, 5, 5, X2-X1-5, Y2-Y1-35);
			{ page 1 - themes }
		Ctl.Canvas_Paint(CanTheme1, 100, 40, 100+Gfx.ImageX(PicMon),
			40+Gfx.ImageY(PicMon));
		If Ctl.Notebook_GetActivePage(NbkPages)=1 Then
		Begin
			With CanTheme1^.Place Do
				Gfx.PutSprite(X1, Y1, PicMon);
			DrawThemePreview(Me, CanTheme1)
		End;
		Ctl2.ListBox_Paint(LstTheme, 60, 140, X2-X1-60, Y2-Y1-45);

			{ page 2 - appearance }
		Ctl.Canvas_Paint(CanTheme2, 100, 40, 100+Gfx.ImageX(PicMon),
			40+Gfx.ImageY(PicMon));
		If Ctl.Notebook_GetActivePage(NbkPages)=2 Then
		Begin
			With CanTheme2^.Place Do
				Gfx.PutSprite(X1, Y1, PicMon);
			DrawThemePreview(Me, CanTheme2)
		End;
		Ctl.Label_Paint(Lab2, 10, 140, 120);
		Ctl.PopupBtn_Paint(PbtSkin, 130, 140, 270);
		Ctl.Label_Paint(Lab3, 10, 170, 120);
		Ctl.PopupBtn_Paint(PbtColorSet, 130, 170, 270);
		Ctl.Label_Paint(Lab4, 10, 210, 120);
		Ctl.PopupBtn_Paint(PbtCursorSet, 130, 210, 270);

			{ page 3 - video mode }
		Ctl.Canvas_Paint(CanMon, 100, 40, 100+Gfx.ImageX(PicMon),
			40+Gfx.ImageY(PicMon));
		If Ctl.Notebook_GetActivePage(NbkPages)=3 Then
			With CanMon^.Place Do
			Begin
				Gfx.PutSprite(X1, Y1, PicMon);
				Gfx.PutImage(X1+10, Y1+8, PicRes[Ctl.Track_GetPos(Trk4size)])
			End;

		Ctl.Label_Paint(Lab4S, 20, 140, 80);
		Ctl.Track_Paint(Trk4size, 90, 140, X2-X1-100);
		Ctl.Label_Paint(Lab4size, X2-X1-90, 140, X2-X1-15);

		Ctl.PicCtl_Paint(PctMonCtls, X2-X1-90, 173);
		Ctl.Label_Paint(LabBright, 20, 170, 80);
		Ctl.Track_Paint(TrkBright, 90, 170, X2-X1-100);
		Ctl.Label_Paint(LabCont, 20, 200, 80);
		Ctl.Track_Paint(TrkCont, 90, 200, X2-X1-100);

			{ page 4 - effects }
		Ctl.Check_Paint(ChkFade, 20, 40);
		Ctl.Label_Paint(LabFade, 20, 60, 120);
		Ctl.Track_Paint(TrkFade, 130, 60, X2-X1-20);
		Ctl.Check_Paint(ChkZoom, 20, 100);
		Ctl.Label_Paint(LabZoom, 20, 120, 120);
		Ctl.Track_Paint(TrkZoom, 130, 120, X2-X1-20);
		Ctl.Check_Paint(ChkStopAnims, 20, 160);

		Ctl.Label_Paint(LabPopup, 20, 200, 120);
		Ctl.PopupBtn_Paint(PbtPopup, 130, 200, X2-X1-50);
		Ctl.Label_Paint(LabWinBG, 20, 230, 120);
		Ctl.PopupBtn_Paint(PbtWinBG, 130, 230, X2-X1-50);
			{ out of notebook }
		Ctl.Button_Paint(BtnTry, X2-X1-215, Y2-Y1-26, X2-X1-115);
		Ctl.Button_Paint(BtnClose, X2-X1-105, Y2-Y1-26, X2-X1-5);
	End;
End;


Procedure OnSizeTrack(Me:PProg; Control:PControl);
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		Case Ctl.Track_GetPos(Control) Of
			1: Ctl.Label_SetCaption(Lab4size, '640 x 400');
			2: Ctl.Label_SetCaption(Lab4size, '640 x 480');
			3: Ctl.Label_SetCaption(Lab4size, '800 x 600');
			4: Ctl.Label_SetCaption(Lab4size, '1024 x 768');
			5: Ctl.Label_SetCaption(Lab4size, '1280 x 1024');
		End;
		Ctl.Canvas_BeginPaint(CanMon);
		With CanMon^.Place Do
			Gfx.PutImage(X1+10, Y1+8, PicRes[Ctl.Track_GetPos(Control)]);
		Kernel.EndPaint
	End
End;



Procedure OnSkinMenuClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		Button_SetCaption(PopupBtn_AsButton(PbtSkin), String(Item^.Name^));
		DrawThemePreview(Me, CanTheme2);
		Ctl2.ListBox_SelectItem(LstTheme, 1)
	End
End;

Procedure OnColorsMenuClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		Button_SetCaption(PopupBtn_AsButton(PbtColorSet), String(Item^.Name^));
		DrawThemePreview(Me, CanTheme2);
		Ctl2.ListBox_SelectItem(LstTheme, 1)
	End
End;

Procedure OnCursorsMenuClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TScrSetupData(Data^) Do
		Button_SetCaption(PopupBtn_AsButton(PbtCursorSet), String(Item^.Name^))
End;





Procedure OnFadeCheck(Me:PProg;Control:PControl);
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		If Ctl.Check_GetState(ChkFade)
			Then Ctl.Label_SetStyle(LabFade, lsNormal)
			Else Ctl.Label_SetStyle(LabFade, lsDisabled);
		TrkFade^.Enabled:=Ctl.Check_GetState(ChkFade);
		Ctl.Track_SetPos(TrkFade, Ctl.Track_GetPos(TrkFade));
		Ini.Select('polit.ini', 'Graphics');
		If Ctl.Check_GetState(ChkFade)
			Then Ini.SetInt('FadeSpeed', Ctl.Track_GetPos(TrkFade))
			Else Ini.SetInt('FadeSpeed', -1)
	End
End;

Procedure OnFadeTrack(Me:PProg; Control:PControl);
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Graphics');
		Ini.SetInt('FadeSpeed', Ctl.Track_GetPos(TrkFade))
	End
End;

Procedure OnZoomCheck(Me:PProg;Control:PControl);
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		If Ctl.Check_GetState(ChkZoom)
			Then Ctl.Label_SetStyle(LabZoom, lsNormal)
			Else Ctl.Label_SetStyle(LabZoom, lsDisabled);
		TrkZoom^.Enabled:=Ctl.Check_GetState(ChkZoom);
		Ctl.Track_SetPos(TrkZoom, Ctl.Track_GetPos(TrkZoom));
		Ini.Select('polit.ini', 'Graphics');
		If Ctl.Check_GetState(ChkZoom)
			Then Ini.SetInt('ZoomSpeed', Ctl.Track_GetPos(TrkZoom))
			Else Ini.SetInt('ZoomSpeed', -1)
	End
End;

Procedure OnZoomTrack(Me:PProg; Control:PControl);
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Graphics');
		Ini.SetInt('ZoomSpeed', Ctl.Track_GetPos(TrkZoom))
	End
End;

Procedure OnStopAnimsCheck(Me:PProg;Control:PControl);
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		Ini.Select('polit.ini', 'Graphics');
		Ini.SetBool('StopAnimsOnMouse', Ctl.Check_GetState(ChkStopAnims))
	End
End;




Procedure OnPopupStyleMenuClick(Me:PProg; Item:PMenuItem);
Var
	TempStr: String;
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		TempStr:=String(Item^.Name^);
		{PopupBtn_SetCaption(PbtPopup, TempStr);
		PopupBtn_SetPicture(PbtPopup, Item^.Icon);}
		Button_SetCaption(PopupBtn_AsButton(PbtPopup), TempStr);
		Button_SetPicture(PopupBtn_AsButton(PbtPopup), Item^.Icon);
		Ctl2.ListBox_SelectItem(LstTheme, 1);

		{TempStr:=PopupBtn_GetCaption(PbtPopup);}
		Ini.Select('polit.ini', 'Menu');
		If TempStr='砩' Then
			Ini.SetStr('Style', 'Normal');
		If TempStr='஧' Then
			Ini.SetStr('Style', 'Transparent');
		If TempStr='㣠' Then
			Ini.SetStr('Style', 'Striped');
		If TempStr='' Then
			Ini.SetStr('Style', 'Blurred');
		If TempStr='ࠤi⭥' Then
			Ini.SetStr('Style', 'Gradient');
		If TempStr='⠫' Then
			Ini.SetStr('Style', 'Metal');
		If TempStr='i' Then
			Ini.SetStr('Style', 'Papirus');
		If TempStr='Windows XP' Then
			Ini.SetStr('Style', 'XP')
	End
End;

Procedure OnWinBGMenuClick(Me:PProg; Item:PMenuItem);
Var
	TempStr: String;
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		TempStr:=String(Item^.Name^);
		Button_SetCapAndPic(PopupBtn_AsButton(PbtWinBG), TempStr, Item^.Icon);
		Ctl2.ListBox_SelectItem(LstTheme, 1)
	End
End;





Procedure OnBrightContTrack(Me:PProg; Control:PControl);
Var
	Brightness, Contrast: Integer;
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		Gfx.Palette:=RealPal;
		Brightness:=Ctl.Track_GetPos(TrkBright);
		Contrast:=Ctl.Track_GetPos(TrkCont);
		Gfx.ApplyBrightCont(Brightness, Contrast)
	End
End;

Procedure DrawThemePreview(Me:PProg; CanTheme:PControl);
Var
	ClrDesk, ClrWin, ClrActFr, ClrInactFr: TColor;
	ClrActFrL, ClrActFrD, ClrInactFrL, ClrInactFrD, ClrPopupFont: TColor;
	PicCheck: TSkinPic;
	TempPtr: Pointer;
	TempStr, ThemeFName, ColorSetName, PalFName: String;
	I: Integer;
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		TempStr:='colors\'+
			Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtColorSet))+'.ini';
		Ini.Load(TempStr);
		Ini.Select(TempStr, 'Colors');
		ClrDesk:=Ini.GetInt('Desktop', clNavy);
		ClrWin:=Ini.GetInt('WindowBG', clSilver);
		ClrActFr:=Ini.GetInt('ActWinBG', clBlue);
		ClrInactFr:=Ini.GetInt('InactWinBG', clGray);
		ClrActFrL:=Ini.GetInt('ActWinLight', clCyan);
		ClrActFrD:=Ini.GetInt('ActWinDark', clNavy);
		ClrInactFrL:=Ini.GetInt('InactWinLight', clSilver);
		ClrInactFrD:=Ini.GetInt('InactWinDark', clNightGray);
		Ini.FreeFile(TempStr);

		TempStr:=Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtPopup));
		PopupStyle:='N';
		If TempStr='஧' Then PopupStyle:='T';
		If TempStr='㣠' Then PopupStyle:='S';
		If TempStr='' Then PopupStyle:='B';
		If TempStr='ࠤi⭥' Then PopupStyle:='G';
		If TempStr='⠫' Then PopupStyle:='M';
		If TempStr='i' Then PopupStyle:='P';
		If TempStr='Windows XP' Then PopupStyle:='X';

		TempStr:=Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtWinBG));
		WinBGMode:='C';
		If TempStr='㣨' Then WinBGMode:='S';
		If TempStr='⠫' Then WinBGMode:='M';

		I:=Ctl2.ListBox_GetSelItemIndex(LstTheme);
		If I>1 Then
		Begin
			ThemeFName:='themes\'+String(Themes[I-1]^);
			Ini.Load(ThemeFName);
			Ini.Select(ThemeFName, 'Theme');
			ColorSetName:=Ini.GetStr('ColorScheme', 'colors\default.ini');
			Ini.FreeFile(ThemeFName);
			Ini.Load(ColorSetName);
			Ini.Select(ColorSetName, 'Palette');
			PalFName:='Colors\'+Ini.GetStr('Palette', 'polit.pal');
			Ini.FreeFile(ColorSetName)
		End
		Else
			PalFName:='';
		TempStr:='skin\'+
			Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtSkin))+'\check.bmp';
		Pic.IntLoadBMP(TempStr, PalFName, (PalFName<>''), TempPtr);
		Gfx.SplitSkin4(TempPtr, PicCheck);

		Ctl.Canvas_BeginPaint(CanTheme);
		With CanTheme^.Place Do
		Begin
				{ taskbar }
			Gfx.Bar(X1+10, Y1+8, X1+10+76-1, Y1+8+3-1, ClrWin);
			Gfx.Line(X1+10, Y1+8+3, X1+10+76-1, Y1+8+3, clBlack);
				{ Desktop }
			Gfx.Bar(X1+10, Y1+8+4, X1+10+76-1, Y1+8+52-1, ClrDesk);
				{ inactive window }
			Gfx.ButtonRect(X1+10+30, Y1+8+10, X1+10+70-1, Y1+8+35-1,
				ClrInactFrL, ClrInactFrD);
			Gfx.Bar(X1+10+31, Y1+8+11, X1+10+69-1, Y1+8+15-1, ClrInactFr);
			Case WinBGMode Of
				'C': Gfx.Bar(X1+10+31, Y1+8+15, X1+10+69-1, Y1+8+34-1, ClrWin);
				'S': Gfx.StripedBar(X1+10+31, Y1+8+15, X1+10+69-1, Y1+8+34-1, 85);
				'M': Gfx.SteelBar(X1+10+31, Y1+8+15, X1+10+69-1, Y1+8+34-1, 70);
			End;
				{ active window }
			Gfx.ButtonRect(X1+10+10, Y1+8+20, X1+10+60-1, Y1+8+49-1,
				ClrActFrL, ClrActFrD);
			Gfx.Rectangle(X1+10+11, Y1+8+21, X1+10+59-1, Y1+8+48-1, ClrActFr);
			Gfx.Bar(X1+10+12, Y1+8+22, X1+10+58-1, Y1+8+24, ClrActFr);
			Case WinBGMode Of
				'C': Gfx.Bar(X1+10+12, Y1+8+25, X1+10+58-1, Y1+8+47-1, ClrWin);
				'S': Gfx.StripedBar(X1+10+12, Y1+8+25, X1+10+58-1, Y1+8+47-1, 85);
				'M': Gfx.SteelBar(X1+10+12, Y1+8+25, X1+10+58-1, Y1+8+47-1, 70);
			End;
				{ menu }
			Case PopupStyle Of
				'N': Gfx.FillButtonRect(X1+10, Y1+8+4, X1+10+21, Y1+8+40,
					clWhite, clGray, ClrWin);
				'T': Gfx.TranspBar(X1+10, Y1+8+4, X1+10+21, Y1+8+40, ClrWin, 80);
				'S': Gfx.StripBar(X1+10, Y1+8+4, X1+10+21, Y1+8+40);
				'B': Gfx.BlurBar(X1+10, Y1+8+4, X1+10+21, Y1+8+40, -21);
				'G': Begin
					Gfx.FillButtonRect(X1+10, Y1+8+4, X1+10+21, Y1+8+40, 255, 238, 252);
					For I:=1 To 6 Do
						Gfx.Line(X1+10+I, Y1+8+4+1, X1+10+I, Y1+8+40-1, 238+I+I)
				End;
				'M': Begin
					Gfx.ButtonRect(X1+10, Y1+8+4, X1+10+21, Y1+8+40, 255, 242);
					Gfx.SteelBar(X1+11, Y1+8+5, X1+10+20, Y1+8+39, 80)
				End;
				'P': Gfx.AgedBar(X1+10, Y1+8+4, X1+10+21, Y1+8+40, 83, 107);
				'X': Begin
					Gfx.Rectangle(X1+10, Y1+8+4, X1+10+21, Y1+8+40, 215);
					Gfx.Bar(X1+11, Y1+8+5, X1+12, Y1+8+39, 192);
					Gfx.Bar(X1+13, Y1+8+5, X1+10+20, Y1+8+39, 255)
				End
			End;
			If PopupStyle='B'
				Then ClrPopupFont:=clWhite
				Else ClrPopupFont:=clBlack;
			Gfx.Line(X1+10+3, Y1+8+8, X1+10+16, Y1+8+8, ClrPopupFont);
			Gfx.PutPixel(X1+10+3, Y1+8+7, ClrPopupFont);
			Gfx.Line(X1+10+3, Y1+8+12, X1+10+9, Y1+8+12, ClrPopupFont);
			Gfx.PutPixel(X1+10+3, Y1+8+11, ClrPopupFont);
			Gfx.Line(X1+10+3, Y1+8+16, X1+10+12, Y1+8+16, ClrPopupFont);
			Gfx.PutPixel(X1+10+3, Y1+8+15, ClrPopupFont);

			Gfx.PutSprite(X1+50, Y1+37, PicCheck[True, True]);
		End;

		Kernel.EndPaint;
		Gfx.FreeSkin4(PicCheck)
	End
End;

Procedure OnThemeSelect(Me:PProg; Control:PControl);
Var
	ThemeFName, TempStr: String;
	Cur, Found: Integer;
	TempIndex: Integer;
Begin
	Log.BugMsg('ScrSetup', 'OnThemeSelect', 'Entering...');
	With Me^, TScrSetupData(Data^) Do
	Begin
		If Ctl2.ListBox_GetSelItemIndex(LstTheme)=1 Then Exit;

		Log.BugMsg('ScrSetup', 'OnThemeSelect', 'Item<>1');
		TempIndex:=Ctl2.ListBox_GetSelItemIndex(LstTheme);
		Log.BugMsg('ScrSetup', 'OnThemeSelect', 'SelItem='+D.St(TempIndex)+
			', ThemesNum='+D.St(ThemesNum));
		ThemeFName:='themes\'+String(Themes[TempIndex-1]^);
		Log.BugMsg('ScrSetup', 'OnThemeSelect', 'ThemeFName='+ThemeFName);
		Ini.Load(ThemeFName);
		Ini.Select(ThemeFName, 'Theme');
			{ font }
		Log.BugMsg('ScrSetup', 'OnThemeSelect', 'Getting params...');
		FontName:=Ini.GetStr('Font', 'fonts\default.raf');
			{ skin }
		TempStr:=Ini.GetStr('SkinDir', 'skin\default\');
		TempStr:=D.NormLine(Copy(TempStr, 6, Length(TempStr)-6));
		Button_SetCaption(PopupBtn_AsButton(PbtSkin), TempStr);
			{ color scheme }
		TempStr:=Ini.GetStr('ColorScheme', 'Colors\default.ini');
		TempStr:=D.NormLine(Copy(TempStr, 8, Length(TempStr)-11));
		Button_SetCaption(PopupBtn_AsButton(PbtColorSet), TempStr);
			{ cursor set }
		TempStr:=Ini.GetStr('CursorsDir', 'Mouse\Neutral\');
		TempStr:=D.NormLine(Copy(TempStr, 7, Length(TempStr)-7));
		Button_SetCaption(PopupBtn_AsButton(PbtCursorSet), TempStr);
			{ popup style }
		TempStr:=Ini.GetStr('PopupStyle', 'NORMAL');
		If TempStr='NORMAL' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtPopup), '砩', PicPopSt0);
		If TempStr='TRANSPARENT' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtPopup), '஧', PicPopSt1);
		If TempStr='STRIPED' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtPopup), '㣠', PicPopSt2);
		If TempStr='BLURRED' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtPopup), '', PicPopSt3);
		If TempStr='GRADIENT' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtPopup), 'ࠤi⭥', PicPopSt4);
		If TempStr='METAL' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtPopup), '⠫', PicPopSt5);
		If TempStr='PAPIRUS' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtPopup), 'i', PicPopSt6);
		If TempStr='XP' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtPopup), 'Windows XP', PicPopSt7);
		{Ini.Select('polit.ini', 'Menu');
		Ini.SetStr('Style', TempStr);}

			{ win bg mode }
		TempStr:=Ini.GetStr('WinBGMode', 'SOLIDCOLOR');
		If TempStr='SOLIDCOLOR' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtWinBG),
				'i쭨', PicWinBG0);
		If TempStr='STRIPED' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtWinBG),
				'㣨', PicWinBG1);
		If TempStr='METAL' Then
			Button_SetCapAndPic(PopupBtn_AsButton(PbtWinBG),
				'⠫', PicWinBG2);

		Ini.FreeFile(ThemeFName);
		Ini.SelectFile('polit.ini');
		DrawThemePreview(Me, CanTheme1)
	End;
	Log.BugMsg('ScrSetup', 'OnThemeSelect', 'Done!');
End;






Procedure OnApplyClick(Me:PProg; Control:PControl);
Var
	X, Y, BPP: Integer;
	TempStr, ColorSetName: String;
	TempPtr: Pointer;
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		Case Ctl.Track_GetPos(Trk4Size) Of
			1:begin X:= 640; Y:= 400; end;
			2:begin X:= 640; Y:= 480; end;
			3:begin X:= 800; Y:= 600; end;
			4:begin X:=1024; Y:= 768; end;
			5:begin X:=1280; Y:=1024; end;
		End;
		Ini.Select('polit.ini', 'Graphics');
		Ini.SetInt('X', X);
		Ini.SetInt('Y', Y);

		Ini.SelectSec('Boot');
		Ini.SetStr('Font', FontName);
		Ini.SetStr('SkinDir', 'Skin\'+
			Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtSkin))+'\');
		Ini.SelectSec('Graphics');
		ColorSetName:='Colors\'+Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtColorSet))+'.Ini';
		Ini.SetStr('ColorScheme', ColorSetName);

		Ini.Load(ColorSetName);
		Ini.Select(ColorSetName, 'Palette');
		TempStr:=Ini.GetStr('Palette', 'polit.pal');
		Ini.FreeFile(ColorSetName);
		Ini.Select('polit.ini', 'Graphics');
		Ini.SetStr('Palette', 'Colors\'+TempStr);

		Ini.SelectSec('Mouse');
		Ini.SetStr('CursorsDir', 'Mouse\'+
			Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtCursorSet))+'\');
		Ini.SelectSec('Menu');
		TempStr:=Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtPopup));
		If TempStr='砩' Then
			Ini.SetStr('Style', 'Normal');
		If TempStr='஧' Then
			Ini.SetStr('Style', 'Transparent');
		If TempStr='㣠' Then
			Ini.SetStr('Style', 'Striped');
		If TempStr='' Then
			Ini.SetStr('Style', 'Blurred');
		If TempStr='ࠤi⭥' Then
			Ini.SetStr('Style', 'Gradient');
		If TempStr='⠫' Then
			Ini.SetStr('Style', 'Metal');
		If TempStr='i' Then
			Ini.SetStr('Style', 'Papirus');
		If TempStr='Windows XP' Then
			Ini.SetStr('Style', 'XP');

		Ini.Select('polit.ini', 'Boot');
		TempStr:=Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtWinBG));
		If TempStr='i쭨' Then
			Ini.SetStr('WinBGMode', 'SolidColor');
		If TempStr='㣨' Then
			Ini.SetStr('WinBGMode', 'Striped');
		If TempStr='⠫' Then
			Ini.SetStr('WinBGMode', 'Metal');
		Ini.SaveCurFile;

		Ini.SaveCurFile
	End;
	If Me^.Parent<>Nil Then
		TempPtr:=Kernel.SendMessage(Me, Me^.Parent, 'Settings:OpenSheet', Nil);
	Kernel.RestartPolit;
End;


Procedure OnCloseClick(Me:PProg;Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;


Procedure OnClose(Me:PProg);
Var
	TempPtr: Pointer;
	I: Integer;
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		If Parent<>Nil Then
			TempPtr:=Kernel.SendMessage(Me, Parent, 'Settings:CloseSheet', Nil);
		Kernel.FreeRes('f_pal.bmp');
		Kernel.FreeRes('f_skin.bmp');
		Kernel.FreeRes('f_curset.bmp');
		Kernel.FreeRes('monitor.bmp');
		Kernel.FreeRes('resx400.bmp');
		Kernel.FreeRes('resx480.bmp');
		Kernel.FreeRes('resx600.bmp');
		Kernel.FreeRes('resx768.bmp');
		Kernel.FreeRes('resx1024.bmp');
		Kernel.FreeRes('b_popst0.bmp');
		Kernel.FreeRes('b_popst1.bmp');
		Kernel.FreeRes('b_popst2.bmp');
		Kernel.FreeRes('b_popst3.bmp');
		Kernel.FreeRes('b_popst4.bmp');
		Kernel.FreeRes('b_popst5.bmp');
		Kernel.FreeRes('b_popst6.bmp');
		Kernel.FreeRes('b_popst7.bmp');
		Kernel.FreeRes('b_wbgst0.bmp');
		Kernel.FreeRes('b_wbgst1.bmp');
		Kernel.FreeRes('b_wbgst2.bmp');
		Kernel.FreeRes('mon_ctls.bmp');

		For I:=1 To ThemesNum Do
			D.FreePStr(Themes[I], 'ScrSetup - Theme name'); { <- CRASH }
	End;
	FreeMem(Me^.Data, SizeOf(TScrSetupData));
End;

Procedure MakeMenus(Me:PProg);
Var
	SR:SearchRec;
Begin
	With Me^, TScrSetupData(Data^) Do
	Begin
		MnuSkin:=Popup.CreateMenu;
		FindFirst('skin\*.', Directory, SR);
		While DOSError=0 Do
		Begin
			If SR.Name[1]<>'.' Then
				Popup.AddCommand(MnuSkin, D.NormLine(SR.Name),
					'', '', PicSkin, True,
					OnSkinMenuClick);
			FindNext(SR)
		End;

		MnuColors:=Popup.CreateMenu;
		FindFirst('colors\*.ini', AnyFile, SR);
		While DOSError=0 Do
		Begin
			Popup.AddCommand(MnuColors, D.NormLine(Copy(SR.Name, 1,
				Length(SR.Name)-4)), '', '', PicColorSet, True,
				OnColorsMenuClick);
			FindNext(SR)
		End;

		MnuCursors:=Popup.CreateMenu;
		FindFirst('mouse\*.', Directory, SR);
		While DOSError=0 Do
		Begin
			If SR.Name[1]<>'.' Then
				Popup.AddCommand(MnuCursors, D.NormLine(SR.Name),
					'', '', PicCursorSet, True,
					OnCursorsMenuClick);
			FindNext(SR)
		End;

		MnuPopupStyle:=Popup.CreateMenu;
		Popup.AddCommand(MnuPopupStyle, '砩', '', '',
			PicPopSt0, True, OnPopupStyleMenuClick);
		Popup.AddCommand(MnuPopupStyle, '஧', '', '',
			PicPopSt1, True, OnPopupStyleMenuClick);
		Popup.AddCommand(MnuPopupStyle, '㣠', '', '',
			PicPopSt2, True, OnPopupStyleMenuClick);
		Popup.AddCommand(MnuPopupStyle, '', '', '',
			PicPopSt3, True, OnPopupStyleMenuClick);
		Popup.AddCommand(MnuPopupStyle, 'ࠤi⭥', '', '',
			PicPopSt4, True, OnPopupStyleMenuClick);
		Popup.AddCommand(MnuPopupStyle, '⠫', '', '',
			PicPopSt5, True, OnPopupStyleMenuClick);
		Popup.AddCommand(MnuPopupStyle, 'i', '', '',
			PicPopSt6, True, OnPopupStyleMenuClick);
		Popup.AddCommand(MnuPopupStyle, 'Windows XP', '', '',
			PicPopSt7, True, OnPopupStyleMenuClick);

		MnuWinBG:=Popup.CreateMenu;
		Popup.AddCommand(MnuWinBG, 'i쭨', '', '',
			PicWinBG0, True, OnWinBGMenuClick);
		Popup.AddCommand(MnuWinBG, '㣨', '', '',
			PicWinBG1, True, OnWinBGMenuClick);
		Popup.AddCommand(MnuWinBG, '⠫', '', '',
			PicWinBG2, True, OnWinBGMenuClick);


	End
End;

Procedure OnInit(Me:PProg);
Var
	Temp: String;
	TrkPos: Integer;
	lb: String;
	TempInt: Integer;
	SR: SearchRec;
	Skin, ColorSet, CursorSet: String;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('࠭: ன', WinTitle);
		MinX:=300;
		MinY:=300;
		GetMem(Data, SizeOf(TScrSetupData));
		If Parent=Nil
			Then Kernel.InitWindow(Me, 'BlueDlg', [wbMin, wbClose])
			Else Kernel.InitSheetWindow(Me, 'BlueDlg', [wbSlide], brLeft);
		WinBG:=bgManualDark;
		Kernel.DrawWindowAni(Me);

		With TScrSetupData(Data^) Do
		Begin
			PicSkin:=Kernel.LoadBMPRes('pic\f_skin.bmp');
			PicColorSet:=Kernel.LoadBMPRes('pic\f_pal.bmp');
			PicCursorSet:=Kernel.LoadBMPRes('pic\f_curset.bmp');
			PicMon:=Kernel.LoadBMPRes('pic\monitor.bmp');
			PicRes[1]:=Kernel.LoadBMPRes('pic\resx400.bmp');
			PicRes[2]:=Kernel.LoadBMPRes('pic\resx480.bmp');
			PicRes[3]:=Kernel.LoadBMPRes('pic\resx600.bmp');
			PicRes[4]:=Kernel.LoadBMPRes('pic\resx768.bmp');
			PicRes[5]:=Kernel.LoadBMPRes('pic\resx1024.bmp');
			PicPopSt0:=Kernel.LoadBMPRes('pic\b_popst0.bmp');
			PicPopSt1:=Kernel.LoadBMPRes('pic\b_popst1.bmp');
			PicPopSt2:=Kernel.LoadBMPRes('pic\b_popst2.bmp');
			PicPopSt3:=Kernel.LoadBMPRes('pic\b_popst3.bmp');
			PicPopSt4:=Kernel.LoadBMPRes('pic\b_popst4.bmp');
			PicPopSt5:=Kernel.LoadBMPRes('pic\b_popst5.bmp');
			PicPopSt6:=Kernel.LoadBMPRes('pic\b_popst6.bmp');
			PicPopSt7:=Kernel.LoadBMPRes('pic\b_popst7.bmp');
			PicWinBG0:=Kernel.LoadBMPRes('pic\b_wbgst0.bmp');
			PicWinBG1:=Kernel.LoadBMPRes('pic\b_wbgst1.bmp');
			PicWinBG2:=Kernel.LoadBMPRes('pic\b_wbgst2.bmp');
			PicMonCtls:=Kernel.LoadBMPRes('pic\mon_ctls.bmp');

			MakeMenus(Me);

			NbkPages:=Ctl.Notebook_Create(Me, True);

			CanTheme1:=Ctl.Canvas_Create(Me, False);
			LstTheme:=Ctl2.ListBox_Create(Me, False);
			Ctl2.ListBox_SetOnSelect(LstTheme, OnThemeSelect);
			{Ctl.ListBox_SetOnStrongSelect(LstTheme, OnThemeSelect);}
			Ctl2.ListBox_AddItemLast(LstTheme, '( )', Nil, 0);
			ThemesNum:=0;
			DOS.FindFirst('themes\*.ini', AnyFile, SR);
			Ini.UpCaseNeeded:=False;
			Log.BugMsg('ScrSetup', 'OnInit', 'ThemesNum='+D.St(ThemesNum));
			While DOSError=0 Do
			Begin
				Ini.Load('themes\'+SR.Name);
				Ini.Select('themes\'+SR.Name, 'Theme');
				Temp:=Ini.GetStr('Name', '');
				Ini.FreeFile('themes\'+SR.Name);
				Ctl2.ListBox_AddItemLast(LstTheme, Temp, Nil, 0);
				Inc(ThemesNum);
				D.AssignPStr(SR.Name, Themes[ThemesNum]);
				DOS.FindNext(SR)
			End;
			Ini.UpCaseNeeded:=True;
			Ctl2.ListBox_SelectItem(LstTheme, 1);
			Log.BugMsg('ScrSetup', 'OnInit', 'ThemesNum='+D.St(ThemesNum));

			Ctl.Notebook_AddPage(NbkPages, '', '', Nil);

			CanTheme2:=Ctl.Canvas_Create(Me, False);
			Ini.Select('polit.ini', 'Graphics');
			Temp:=Ini.GetStr('Palette', 'polit.pal');
			RealPal:=Gfx.Palette;
			Temp:=D.NormLine(Copy(Temp, 1, Length(Temp)-4));

			Ini.Select('polit.ini', 'Boot');
			FontName:=Ini.GetStr('Font', 'fonts\default.raf');
			Skin:=Ini.GetStr('SkinDir', 'skin\default\');
			Temp:=D.NormLine(Copy(Skin, 6, Length(Skin)-6));
			Lab2:=Ctl.Label_Create(Me, 'i:', Nil, lsNormal, alRight);
			PbtSkin:=Ctl.PopupBtn_Create(Me, Temp, MnuSkin, PicSkin, ppLeft);
			Lab2^.FocusCtl:=PopupBtn_AsButton(PbtSkin);
			{PbtSkin^.AutoRedraw:=True;}

			Ini.Select('polit.ini', 'Graphics');
			ColorSet:=Ini.GetStr('ColorScheme', 'colors\default.ini');
			Temp:=D.NormLine(Copy(ColorSet, 8, Length(ColorSet)-11));
			Lab3:=Ctl.Label_Create(Me, '஢ 奬:', Nil, lsNormal, alRight);
			PbtColorSet:=Ctl.PopupBtn_Create(Me, Temp, MnuColors, PicColorSet,
				ppLeft);
			Lab3^.FocusCtl:=PopupBtn_AsButton(PbtColorSet);
			{PbtColorSet^.AutoRedraw:=True;}

			Ini.Select('polit.ini', 'Mouse');
			CursorSet:=Ini.GetStr('CursorsDir', 'mouse\neutral\');
			Temp:=D.NormLine(Copy(CursorSet, 7, Length(CursorSet)-7));
			Lab4:=Ctl.Label_Create(Me, 'i i:', Nil, lsNormal, alRight);
			PbtCursorSet:=Ctl.PopupBtn_Create(Me, Temp, MnuCursors,
				PicCursorSet, ppLeft);
			Lab4^.FocusCtl:=PopupBtn_AsButton(PbtCursorSet);
			{PbtCursorSet^.AutoRedraw:=True;}

			Ctl.Notebook_AddPage(NbkPages, 'ଫ', '', Nil);

			CanMon:=Ctl.Canvas_Create(Me, False);
			Lab4S:=Ctl.Label_Create(Me, 'Poi:', Nil, lsNormal, alRight);
			Ini.Select('polit.ini', 'Graphics');
			Case Ini.GetInt('Y', 600) of
				400:TrkPos:=1;
				480:TrkPos:=2;
				600:TrkPos:=3;
				768:TrkPos:=4;
				1024:TrkPos:=5;
			End;
			Trk4Size:=Ctl.Track_Create(Me, 1, 5, TrkPos, tkGrowRight, True,
				OnSizeTrack);
			Lab4size:=Ctl.Label_Create(Me, Ini.GetStr('X','640')+' x '+
				Ini.GetStr('Y','480'), Nil, lsBeveled, alCenter);
			Lab4S^.FocusCtl:=Trk4size;

			PctMonCtls:=Ctl.PicCtl_Create(Me, PicMonCtls, False, False, True);
			LabBright:=Ctl.Label_Create(Me, 'ࠢi:', Nil, lsNormal, alRIght);
			TrkBright:=Ctl.Track_Create(Me, -4, 4, 0, tkGrowRight, True,
				OnBrightContTrack);
			LabBright^.FocusCtl:=TrkBright;
			LabCont:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRIght);
			TrkCont:=Ctl.Track_Create(Me, 1, 9, 5, tkGrowRight, True,
				OnBrightContTrack);
			LabCont^.FocusCtl:=TrkCont;

			Ctl.Notebook_AddPage(NbkPages, 'i०', '', Nil);

			{ insert here }
			Ini.Select('polit.ini', 'Graphics');
			TempInt:=Ini.GetInt('FadeSpeed', 5);
			ChkFade:=Ctl.Check_Create(Me, '   ᠭ ⨭',
				(TempInt<>-1));
			Ctl.Check_SetOnChange(ChkFade, OnFadeCheck);
			D.ReassignPStr('⮢   i 室i  ,'+#13+
				' ⠪    i祭i i-ᥩ', ChkFade^.Hint);
			LabFade:=Ctl.Label_Create(Me, 'i:', Nil, lsNormal, alRight);
			If TempInt=-1 Then
				Ctl.Label_SetStyle(LabFade, lsDisabled);
			TrkFade:=Ctl.Track_Create(Me,  0, 10, D.Max(TempInt, 0),
				tkGrowRight, True, OnFadeTrack);
			If TempInt=-1 Then
				TrkFade^.Enabled:=False;
			LabFade^.FocusCtl:=TrkFade;

			TempInt:=Ini.GetInt('ZoomSpeed', 5);
			ChkZoom:=Ctl.Check_Create(Me, 'ii  ࠬ',
				(TempInt<>-1));
			Ctl.Check_SetOnChange(ChkZoom, OnZoomCheck);
			D.ReassignPStr('⮢  ⠭i, ஧⠭i,'+#13+
				'६i饭i i, i   ii', ChkZoom^.Hint);
			LabZoom:=Ctl.Label_Create(Me, 'i:', Nil, lsNormal, alRight);
			If TempInt=-1 Then
				Ctl.Label_SetStyle(LabZoom, lsDisabled);
			TrkZoom:=Ctl.Track_Create(Me,  0, 10, D.Max(TempInt, 0),
				tkGrowRight, True, OnZoomTrack);
			If TempInt=-1 Then
				TrkZoom^.Enabled:=False;
			LabZoom^.FocusCtl:=TrkZoom;

			Ini.Select('polit.ini', 'Graphics');
			ChkStopAnims:=Ctl.Check_Create(Me, 'ਢ i ii   誨',
				Ini.GetBool('StopAnimsOnMouse', True));
			Ctl.Check_SetOnChange(ChkStopAnims, OnStopAnimsCheck);

			Ini.Select('polit.ini', 'Menu');
			Temp:=Ini.GetStr('Style', 'Normal');
			LabPopup:=Ctl.Label_Create(Me, '⨫ :', Nil, lsNormal, alRight);

				{ ⠪ ᪫ -  ii ( . Style i୥) }
			If Temp='TRANSPARENT'
				Then PbtPopup:=Ctl.PopupBtn_Create(Me, '஧',
					MnuPopupStyle, PicPopSt1, ppLeft)
				Else If Temp='STRIPED'
					Then PbtPopup:=Ctl.PopupBtn_Create(Me, '㣠',
						MnuPopupStyle, PicPopSt2, ppLeft)
					Else If Temp='BLURRED'
						Then PbtPopup:=Ctl.PopupBtn_Create(Me, '',
							MnuPopupStyle, PicPopSt3, ppLeft)
						Else If Temp='GRADIENT'
							Then PbtPopup:=Ctl.PopupBtn_Create(Me, 'ࠤi⭥',
								MnuPopupStyle, PicPopSt4, ppLeft)
							Else If Temp='METAL'
								Then PbtPopup:=Ctl.PopupBtn_Create(Me, '⠫',
									MnuPopupStyle, PicPopSt5, ppLeft)
								Else If Temp='PAPIRUS'
									Then PbtPopup:=Ctl.PopupBtn_Create(Me,
										'i', MnuPopupStyle, PicPopSt6, ppLeft)
									Else If Temp='XP'
										Then PbtPopup:=Ctl.PopupBtn_Create(Me,
											'Windows XP', MnuPopupStyle, PicPopSt7, ppLeft)
										Else PbtPopup:=Ctl.PopupBtn_Create(Me,
											'砩', MnuPopupStyle, PicPopSt0, ppLeft);
			LabPopup^.FocusCtl:=PopupBtn_AsButton(PbtPopup);

			Ini.Select('polit.ini', 'Boot');
			Temp:=Ini.GetStr('WinBGMode', 'SolidColor');
			LabWinBG:=Ctl.Label_Create(Me, ' i:', Nil, lsNormal, alRight);

			If Temp='STRIPED'
				Then PbtWinBG:=Ctl.PopupBtn_Create(Me, '㣨',
					MnuWinBG, PicWinBG1, ppLeft)
				Else If Temp='METAL'
					Then PbtWinBG:=Ctl.PopupBtn_Create(Me, '⠫',
						MnuWinBG, PicWinBG2, ppLeft)
					Else PbtWinBG:=Ctl.PopupBtn_Create(Me, 'i쭨',
						MnuWinBG, PicWinBG0, ppLeft);
			LabPopup^.FocusCtl:=PopupBtn_AsButton(PbtPopup);

			Ctl.Notebook_AddPage(NbkPages, '䥪', '', Nil);

			BtnTry:=Ctl.Button_Create(Me, '஡㢠', Kernel.PicApply,
				ppLeft, OnApplyClick);
			D.ReassignPStr('ॣ ன i'#13'१⠦ i',
				BtnTry^.Hint);
			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseClick);

			ActiveCtl:=LstTheme;
			ButtonEnter:=BtnTry;
			ButtonEsc:=BtnClose
		End
	End
End;



Begin
	Kernel.RegBuiltIn('ScrSetup', '', 'pic\i_scrset.bmp', OnInit)
End.
