{$F+}
Unit
	Settings; { Polit Halcyon Settings application }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx;

Type
	TSettingsData=Record
		{ i i ணࠬ  ,  쮬 i }
		BtnScreen, BtnTaskbar, BtnKeyboard, BtnMouse, BtnDate, BtnPrinter: PControl;
		PicScreen, PicTaskbar, PicKeyboard, PicMouse, PicDate, PicPrinter: Pointer;
		LabScreen, LabTaskbar, LabKeyboard, LabMouse, LabDate, LabPrinter: PControl;

		BtnCtl: PControl;
		PicCtl, PicWatermark: PControl;
		BtnClose, PctWatermark: PControl;
		OpenSheet: String[8];
	End;

Implementation

Procedure OnPaint(Me:PProg);
Var
	TempStr: String;
Begin
	With Me^, ClientRect, TSettingsData(Data^) Do
	Begin
		{ i   i i                         }
		{ 砩 ⮡i ॡ   i  㢠 }
		Kernel.DarkBar(X1, Y2-34, X2, Y2);
		Gfx.TranspBar(X1, Y2-35, X2, Y2-35, clBlack, 50);

		{Ctl.PicCtl_Paint(PctWatermark, 102, 160);}

		Ctl.Button_Paint(BtnScreen, 10, 10, 90);
		Ctl.Button_Paint(BtnTaskbar, 10, 50, 90);
		Ctl.Button_Paint(BtnCtl, 10, 90, 90);
		Ctl.Button_Paint(BtnDate, 10, 130, 90);
		Ctl.Button_Paint(BtnKeyboard, 10, 170, 90);
		Ctl.Button_Paint(BtnMouse, 10, 210, 90);
		Ctl.Button_Paint(BtnPrinter, 10, 250, 90);

		Ctl.Label_Paint(LabScreen, 100, 10, X2-X1-10);
		Ctl.Label_Paint(LabTaskbar, 100, 50, X2-X1-10);
		Ctl.Label_Paint(LabDate, 100, 130, X2-X1-10);
		Ctl.Label_Paint(LabKeyboard, 100, 170, X2-X1-10);
		Ctl.Label_Paint(LabMouse, 100, 210, X2-X1-10);
		Ctl.Label_Paint(LabPrinter, 100, 250, X2-X1-10);

		Ctl.Button_Paint(BtnClose, X2-X1-105, Y2-Y1-26, X2-X1-5);

		If OpenSheet<>'' Then
		Begin
			TempStr:=OpenSheet;
			OpenSheet:='';
			Kernel.RunChild2(Me, TempStr, '');
		End
	End;
End;

Procedure OnPanelClick(Me:PProg; Control:PControl);
Var
	ToOpenSheet: Boolean;
Begin
	With Me^, TSettingsData(Data^) Do
	Begin
		ToOpenSheet:=Not Ctl.Button_GetDown(Control);
		If Ctl.Button_GetDown(BtnScreen) Then
		Begin
			Ctl.Button_SetDown(BtnScreen, False);
			Kernel.CloseProg(Kernel.FindProg('ScrSetup'))
		End;
		If Ctl.Button_GetDown(BtnTaskbar) Then
		Begin
			Ctl.Button_SetDown(BtnTaskbar, False);
			Kernel.CloseProg(Kernel.FindProg('BarSetup'))
		End;
		If Ctl.Button_GetDown(BtnDate) Then
		Begin
			Ctl.Button_SetDown(BtnDate, False);
			Kernel.CloseProg(Kernel.FindProg('TimSetup'))
		End;
		If Ctl.Button_GetDown(BtnKeyboard) Then
		Begin
			Ctl.Button_SetDown(BtnKeyboard, False);
			Kernel.CloseProg(Kernel.FindProg('KeySetup'))
		End;
		If Ctl.Button_GetDown(BtnMouse) Then
		Begin
			Ctl.Button_SetDown(BtnMouse, False);
			Kernel.CloseProg(Kernel.FindProg('MouSetup'))
		End;
		If Ctl.Button_GetDown(BtnPrinter) Then
		Begin
			Ctl.Button_SetDown(BtnPrinter, False);
			Kernel.CloseProg(Kernel.FindProg('PrnSetup'))
		End;

		Ctl.Button_SetDown(Control, ToOpenSheet);
		If ToOpenSheet Then
		Begin
			If Control=BtnScreen Then Kernel.RunChild2(Me, 'ScrSetup', '');
			If Control=BtnTaskbar Then Kernel.RunChild2(Me, 'BarSetup', '');
			If Control=BtnDate Then Kernel.RunChild2(Me, 'TimSetup', '');
			If Control=BtnKeyboard Then Kernel.RunChild2(Me, 'KeySetup', '');
			If Control=BtnMouse Then Kernel.RunChild2(Me, 'MouSetup', '');
			If Control=BtnPrinter Then Kernel.RunChild2(Me, 'PrnSetup', '');
		End
	End
End;

Function OnMessage(Me,Sender:PProg; Msg:String; Data:Pointer): Pointer;
Begin
	With Me^, TSettingsData(Data^) Do
	Begin
		If Msg='Settings:CloseSheet' Then
		Begin
			If String(Sender^.Name^)='ScrSetup' Then
				Ctl.Button_SetDown(BtnScreen, False);
			If String(Sender^.Name^)='BarSetup' Then
				Ctl.Button_SetDown(BtnTaskbar, False);
			If String(Sender^.Name^)='TimSetup' Then
				Ctl.Button_SetDown(BtnDate, False);
			If String(Sender^.Name^)='KeySetup' Then
				Ctl.Button_SetDown(BtnKeyboard, False);
			If String(Sender^.Name^)='MouSetup' Then
				Ctl.Button_SetDown(BtnMouse, False);
			If String(Sender^.Name^)='PrnSetup' Then
				Ctl.Button_SetDown(BtnPrinter, False);
		End;
		If Msg='Settings:OpenSheet' Then
		Begin
			Ini.Load('settings.ini');
			Ini.Select('settings.ini', 'Common');
			Ini.SetStr('OpenSheet', String(Sender^.Name^));
			Ini.SaveCurFile;
			Ini.FreeFile('settings.ini');
			Ini.SelectFile('polit.ini');
		End
	End;
	OnMessage:=Nil
End;

Procedure OnCloseClick(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;


Procedure OnClose(Me:PProg);
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	With Me^, TSettingsData(Data^) Do
	Begin
		Kernel.FreeRes('i_scrset.bmp');
		Kernel.FreeRes('i_barset.bmp');
		Kernel.FreeRes('i_keyset.bmp');
		Kernel.FreeRes('i_mouset.bmp');
		Kernel.FreeRes('i_ctlset.bmp');
		Kernel.FreeRes('i_timset.bmp');
		Kernel.FreeRes('i_prnset.bmp');
		Kernel.FreeRes('w_set.bmp');
	End;
	FreeMem(Me^.Data, SizeOf(TSettingsData))
End;

Procedure OnInit(Me:PProg);
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	Me^.OnMessage:=OnMessage;
	With Me^ Do
	Begin
		D.AssignPStr('ன', WinTitle);
		MinX:=240;
		MinY:=334;
		GetMem(Data, SizeOf(TSettingsData));
		Kernel.InitWindow(Me, 'BlueDlg', [wbClose]);
		Kernel.DrawWindowAni(Me);

		With TSettingsData(Data^) Do
		Begin
			PicScreen:=Kernel.LoadBMPRes('pic\i_scrset.bmp');
			PicTaskbar:=Kernel.LoadBMPRes('pic\i_barset.bmp');
			PicKeyboard:=Kernel.LoadBMPRes('pic\i_keyset.bmp');
			PicMouse:=Kernel.LoadBMPRes('pic\i_mouset.bmp');
			PicCtl:=Kernel.LoadBMPRes('pic\i_ctlset.bmp');
			PicDate:=Kernel.LoadBMPRes('pic\i_timset.bmp');
			PicPrinter:=Kernel.LoadBMPRes('pic\i_prnset.bmp');
			PicWatermark:=Kernel.LoadBMPRes('pic\w_set.bmp');

			Ini.Load('settings.ini');
			Ini.Select('settings.ini', 'Common');
			Ini.UpCaseNeeded:=False;
			OpenSheet:=Ini.GetStr('OpenSheet', '');
			Ini.SetStr('OpenSheet', '');
			Ini.SaveCurFile;
			Ini.UpCaseNeeded:=True;
			Ini.FreeFile('settings.ini');
			Ini.SelectFile('polit.ini');
			{  -  i  ⢮७ i i 㢠 }
			PctWatermark:=Ctl.PicCtl_Create(Me, PicWatermark, False, True, True);
			BtnScreen:=Ctl.Button_Create(Me, '࠭', PicScreen,
				ppTop, OnPanelClick);
			Ctl.Button_SetDown(BtnScreen, (OpenSheet='ScrSetup'));
			BtnTaskbar:=Ctl.Button_Create(Me, ' ', PicTaskbar,
				ppTop, OnPanelClick);
			Ctl.Button_SetDown(BtnTaskbar, (OpenSheet='BarSetup'));
			BtnCtl:=Ctl.Button_Create(Me, '쭥', PicCtl,
				ppTop, OnPanelClick);
			BtnCtl^.Enabled:=False;
			BtnDate:=Ctl.Button_Create(Me, ' i ', PicDate,
				ppTop, OnPanelClick);
			Ctl.Button_SetDown(BtnDate, (OpenSheet='TimSetup'));
			BtnKeyboard:=Ctl.Button_Create(Me, 'i', PicKeyboard,
				ppTop, OnPanelClick);
			Ctl.Button_SetDown(BtnKeyboard, (OpenSheet='KeySetup'));
			BtnMouse:=Ctl.Button_Create(Me, '誠', PicMouse,
				ppTop, OnPanelClick);
			Ctl.Button_SetDown(BtnMouse, (OpenSheet='MouSetup'));
			BtnPrinter:=Ctl.Button_Create(Me, 'ਭ', PicPrinter,
				ppTop, OnPanelClick);
			Ctl.Button_SetDown(BtnPrinter, (OpenSheet='PrnSetup'));

			LabScreen:=Ctl.Label_Create(Me, ', , i,'+#13+
				'i०, 䥪', Nil, lsComment, alLeft);
			LabTaskbar:=Ctl.Label_Create(Me, ', ०'+#13+
				'஡, ', Nil, lsComment, alLeft);
			LabDate:=Ctl.Label_Create(Me, ','+#13+'', Nil,
				lsComment, alLeft);
			LabKeyboard:=Ctl.Label_Create(Me, 'i i,'+#13+
				'i ii, ', Nil, lsComment, alLeft);
			LabMouse:=Ctl.Label_Create(Me, 'i ,'+#13+
				', i', Nil, lsComment, alLeft);
			LabPrinter:=Ctl.Label_Create(Me, ', ,'+#13+
				'ଠ ', Nil, lsComment, alLeft);
			
			

			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseClick);

			ButtonEsc:=BtnClose;
			ActiveCtl:=BtnScreen
		End
	End
End;



Begin
	Kernel.RegBuiltIn('Settings', 'ன', 'pic\i_setup.bmp', OnInit)
End.
