{ ******* SpinEdit ******* }
Type
	TSpinMouseButton=(smNone, smDec, smInc, smSlide);
	TSpinEdit=Record
		MyEdit: PControl;
		Min, Max, Step, Value: Integer;
		MouseBtn: TSpinMouseButton;
		OnChange: TCtlHandler;
	End;
Var
	Value10: LongInt;
	{PicSpinUp, PicSpinDown, PicSpinCircle: Pointer;
	PicSpinUpA, PicSpinDownA, PicSpinCircleA: Pointer;}
	PicSpinUp, PicSpinDown, PicSpinDrag: TSkinPic;
	SpinArrowWidth, SpinDragWidth: Integer;


Procedure SpinEdit_DrawButtons(Me:PControl);
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;
	With Me^, TSpinEdit(Data^), Place Do
	Begin
		Gfx.PutSprite(X2-SpinDragWidth+1, Y1,
			PicSpinDrag[Enabled, (MouseBtn=smSlide)]);
		Gfx.PutSprite(X2-SpinDragWidth-SpinArrowWidth, Y1,
			PicSpinUp[Enabled, (MouseBtn=smInc)]);
		Gfx.PutSprite(X2-SpinDragWidth-SpinArrowWidth, Y1+11,
			PicSpinDown[Enabled, (MouseBtn=smDec)])
	End
End;

Procedure SpinEdit_IntDraw(Me:PControl);
Begin
	With Me^, TSpinEdit(Data^), Place Do
	Begin
		MyEdit^.Enabled:=Enabled;
		InpLine_PaintDirect(MyEdit, X1, Y1, X2-SpinDragWidth-SpinArrowWidth-2);
		If ((Not CanDraw) And (Not Kernel.DontBother)) Or Not Visible Then
			Exit;

		SpinEdit_DrawButtons(Me)
	End
End;

Procedure SpinEdit_Paint(Me:PControl; VX1,VY1,VX2:Integer);
Begin
	With Me^.Owner^.ClientRect Do
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY1+20, Me^.Place);
	SpinEdit_IntDraw(Me)
End;

Procedure SpinEdit_Draw(Me:PControl);
Begin
	If (Me^.CanDraw Or Kernel.DontBother) Then
	Begin
		Kernel.BeginPaint(Me^.Place);
		If Me^.Visible
			Then SpinEdit_IntDraw(Me)
			Else Kernel.HideCtl(Me);
		Kernel.EndPaint
	End
End;


Procedure SpinEdit_OnRefocus(Me:PControl; Focused:Boolean);
Begin
	With Me^, TSpinEdit(Data^) Do
	Begin
		InpLine_IntDraw(MyEdit);
		Kernel.CtlRefocusDummy(Me, Focused)
	End
End;

Function SpinEdit_OnKey(Me:PControl; Key,ExtKey:Char): Boolean;
Var
	Recognized: Boolean;
	LastValue, TempInt: Integer;
	TempStr: String;
Begin
	Recognized:=False;
	With Me^, TSpinEdit(Data^) Do
	Begin
		LastValue:=Value;

		If (Key=#0) And (ExtKey=#72) Then
		Begin { Up arrow }
			Inc(Value, Step);
			D.NotMore(Value, Max);
			Recognized:=True
		End;
		If (Key=#0) And (ExtKey=#80) Then
		Begin { Down arrow }
			Dec(Value, Step);
			D.NotLess(Value, Min);
			Recognized:=True;
		End;

		If Recognized Then
		Begin
			If Value<>LastValue Then
				InpLine_SetText(MyEdit, D.St(Value));
			SpinEdit_onKey:=True
		End
		Else Begin
			SpinEdit_OnKey:=InpLine_OnKey(MyEdit, Key, ExtKey);
			Value:=D.Str2Int(InpLine_GetText(MyEdit));
		End;
		OnChange(Owner, Me)

		{Else Begin
			TempStr:=InpLine_GetText(MyEdit);
			SpinEdit_OnKey:=InpLine_OnKey(MyEdit, Key, ExtKey);
			TempInt:=D.Str2Int(InpLine_GetText(MyEdit));
			If D.InRange(TempInt, Min, Max)
				Then Value:=TempInt
				Else InpLine_SetText(MyEdit, TempStr)
		End}
	End
End;

Procedure SpinEdit_OnWheel(Me:PControl; Delta:Integer);
Begin
	With Me^, TSpinEdit(Data^) Do
	Begin
		Dec(Value, Step*Delta);
		D.ToRange(Value, Min, Max);
		InpLine_SetText(MyEdit, D.St(Value));
	End
End;


Procedure SpinEdit_HideMouse(Var X,Y:Integer);
Begin
	LastMsX:=X;
	LastMsY:=Y;
	Kernel.HideMouse(X, Y)
End;

Procedure SpinEdit_ShowMouse(Var X,Y:Integer);
Begin
	If TSpinEdit(CurCtl^.Data^).MouseBtn=smSlide Then
		Inc(Delta, LastMsY-Y);
	X:=LastMsX;
	Y:=LastMsY;
	Kernel.ShowMouse(X, Y)
End;

Procedure SpinEdit_Timer(Me:PControl; Times:Integer);
Var
	TempStr: String;
Begin
	With Me^, TSpinEdit(Data^) Do
	Begin
		Case MouseBtn Of
			smDec: Begin
				Dec(Value, Step);
				D.NotLess(Value, Min)
			End;
			smInc: Begin
				Inc(Value, Step);
				D.NotMore(Value, Max)
			End;
			smSlide: Begin
				Inc(Value10, Delta Div 5);
				Value:=Round(Value10/10);
				D.ToRange(Value, Min, Max);
				If Value10<Min*10 Then Value10:=Min*10;
				If Value10>Max*10 Then Value10:=Max*10;
				If (Value=Min) And (Delta<0) Then Delta:=0;
				If (Value=Max) And (Delta>0) Then Delta:=0;
				Case D.Sgn(Delta Div 5) Of
					-1: Kernel.SelectCursor(MouseScrDown);
					 0: Kernel.SelectCursor(MouseScrVer);
					 1: Kernel.SelectCursor(MouseScrUp)
				End
			End
		End;

		TempStr:=D.St(Value);
		If InpLine_GetText(MyEdit)<>TempStr Then
			InpLine_SetText(MyEdit, TempStr);
		OnChange(Owner, Me)
	End
End;

Procedure SpinEdit_OnClick(Me:PControl; X,Y:Integer);
Begin
	If Not Me^.Enabled Then
	Begin
		Kernel.SelectCursor(Kernel.MouseNo);
		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(Kernel.HideMouse,
			Kernel.ShowMouse,Kernel.RefreshNeeded)=0;
		Kernel.SelectCursor(Kernel.MouseDefault);
		Exit
	End;
	CurCtl:=Me;
	With Me^, Place, TSpinEdit(Data^) Do
	Begin
		D.ToRange(Value, Min, Max);
		If D.InRectCoord(X, Y,
			X2-SpinDragWidth-SpinArrowWidth, Y1+11, X2-SpinDragWidth-1, Y2) Then
		Begin
			Dec(Value, Step);
			D.NotLess(Value, Min);
			InpLine_SetText(MyEdit, D.St(Value));
			OnChange(Owner, Me);
			Kernel.AddTimer(Me, SpinEdit_Timer, 4);
			Kernel.SelectCursor(MouseScrDown);
			MouseBtn:=smDec
		End;
		If D.InRectCoord(X, Y,
			X2-SpinDragWidth-SpinArrowWidth, Y1, X2-SpinDragWidth-1, Y1+9) Then
		Begin
			Inc(Value, Step);
			D.NotMore(Value, Max);
			InpLine_SetText(MyEdit, D.St(Value));
			OnChange(Owner, Me);
			Kernel.AddTimer(Me, SpinEdit_Timer, 4);
			Kernel.SelectCursor(MouseScrUp);
			MouseBtn:=smInc
		End;
		If D.InRectCoord(X, Y,
			X2-SpinDragWidth+1, Y1, X2, Y2) Then
		Begin
			Delta:=0;
			Value10:=Value*10;
			Kernel.AddTimer(Me, SpinEdit_Timer, 1);
			Kernel.SelectCursor(MouseScrVer);
			MouseBtn:=smSlide
		End;
		If D.InRectCoord(X, Y,
			X1, Y1, X2-SpinDragWidth-SpinArrowWidth-2, Y2) Then
		Begin
			InpLine_OnClick(MyEdit, X, Y);
			Exit
		End;

		If MouseBtn=smNone Then
		Begin { i  i i  }
			Repeat
				Kernel.CheckSysKeys
			Until Kernel.HeartOfPolit(Kernel.HideMouse,
				Kernel.ShowMouse,Kernel.RefreshNeeded)=0;
			Exit
		End;

		SpinEdit_DrawButtons(Me);
		LastMsX:=X;
		LastMsY:=Y;

		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(SpinEdit_HideMouse,
			SpinEdit_ShowMouse,Kernel.RefreshNeeded)=0;

		Kernel.RemoveTimer(Me, SpinEdit_Timer);
		Kernel.SelectCursor(Kernel.MouseDefault);
		MouseBtn:=smNone;
		SpinEdit_DrawButtons(Me);

	End
End;

Function SpinEdit_GetValue(Me:PControl): Integer;
Var
	TempInt: Integer;
	Res: Word;
Begin
	With Me^, Place, TSpinEdit(Data^) Do
	Begin
		Val(InpLine_GetText(MyEdit), TempInt, Res);
		SpinEdit_GetValue:=TempInt
	End
End;

Function SpinEdit_OnInpLineChange(Me:PProg; Control:PControl; Ch:String): String;
Begin
	With Control^, TSpinEdit(Data^) Do
		If (Ch[1] In ['0'..'9']) And
			(Length(InpLine_GetText(MyEdit))<=3)
			Then SpinEdit_OnInpLineChange:=Ch
			Else SpinEdit_OnInpLineChange:=''
End;

Procedure SpinEdit_OnDestroy(Me:PControl);
Begin
	FreeMem(Me^.Data, SizeOf(TSpinEdit))
End;

Procedure SpinEdit_SetOnChange(Me:PControl; VOnChange:TCtlHandler);
Begin
	With Me^, TSpinEdit(Data^) Do
		OnChange:=VOnChange
End;

Function SpinEdit_Create(Prog:PProg; VMin,VMax,VStep,VValue:Integer): PControl;
Var
	Me: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
	With Me^ Do
	Begin
		OnRefocus:=SpinEdit_OnRefocus;
		OnKey:=SpinEdit_OnKey;
		OnClick:=SpinEdit_OnClick;
		OnWheel:=SpinEdit_OnWheel;
		OnDestroy:=SpinEdit_OnDestroy;

		GetMem(Data, SizeOf(TSpinEdit));
		With TSpinEdit(Data^) Do
		Begin
			Min:=VMin;
			Max:=VMax;
			Step:=VStep;
			Value:=VValue;
			MouseBtn:=smNone;
			OnChange:=Kernel.CtlDummyProc;

			MyEdit:=InpLine_Create(Prog, D.St(Value), Nil);
			MyEdit^.FocusCtl:=Me;
			{Me^.FocusCtl:=MyEdit;}
			MyEdit^.OwnerCtl:=Me;
			InpLine_SetOnChangeFunc(MyEdit, SpinEdit_OnInpLineChange);

		End
	End;
	SpinEdit_Create:=Me
End;
