{ ************ Splitter ************ }
Type
	TDirection=(drUp, drDown, drLeft, drRight);
	TSplitter=Record
		Orient:TOrientation;
		Arrows: TSplitterArrows;
		Area: TRect; { ࠭i न }
		CurX, CurY: Integer; { ।i i }
		LastCurPos: Integer;
	End;

Var
	SplitterCoord, SplitterMsX, SplitterMsY: Integer;
	{SplitterMouseLR, SplitterMouseUD: Pointer;}
	PicSplit: Array[TDirection] Of TSkinPic;


Procedure Splitter_Draw(Me:PControl);
Var
	I: Integer;
	Delta: Integer;
	TempDir: TDirection;
Begin
	With Me^, Place, TSplitter(Data^) Do
	Begin
		Case Orient Of
			orVertical: Begin
				Delta:=0;
				If Arrows<>saNone Then
				Begin
					Delta:=Gfx.ImageY(PicSplit[drLeft, Enabled, False])+2;
					If CurX+Owner^.ClientRect.X1=Area.X2
						Then TempDir:=drLeft
						Else If CurX+Owner^.ClientRect.X1=Area.X1
							Then TempDir:=drRight
							Else If Arrows=saLeftUp
								Then TempDir:=drLeft
								Else TempDir:=drRight;
					Gfx.PutSprite(X1, Y1, PicSplit[TempDir, Enabled, False]);
					Gfx.PutSprite(X1, Y2-Delta+2, PicSplit[TempDir, Enabled, False])
				End
				Else
					Delta:=0;

				For I:=Y1+Delta To Y2-Delta Do
					If Odd(I) Then
						If Enabled Then
						Begin
							Gfx.Line(X1+1, I, X2-1, I, Kernel.ClrLines);
							Gfx.PutPixel(X1, I, Kernel.ClrLines2);
							Gfx.PutPixel(X2, I, Kernel.ClrLines2)
						End
						Else Begin
							Gfx.Line(X1+1, I, X2-1, I, Kernel.ClrDisabled);
							Gfx.PutPixel(X1, I, Kernel.ClrDisabled2);
							Gfx.PutPixel(X2, I, Kernel.ClrDisabled2)
						End
			End;
			orHorizontal: Begin
				Delta:=0;
				If Arrows<>saNone Then
				Begin
					Delta:=Gfx.ImageX(PicSplit[drUp, Enabled, False])+2;
					If CurY+Owner^.ClientRect.Y1=Area.Y2
						Then TempDir:=drUp
						Else If CurY+Owner^.ClientRect.Y1=Area.Y1
							Then TempDir:=drDown
							Else If Arrows=saLeftUp
								Then TempDir:=drUp
								Else TempDir:=drDown;
					Gfx.PutSprite(X1, Y1, PicSplit[TempDir, Enabled, False]);
					Gfx.PutSprite(X2-Delta+2, Y1, PicSplit[TempDir, Enabled, False])
				End
				Else
					Delta:=0;

				For I:=X1+Delta To X2-Delta Do
					If Odd(I) Then
						If Enabled Then
						Begin
							Gfx.Line(I, Y1+1, I, Y2-1, Kernel.ClrLines);
							Gfx.PutPixel(I, Y1, Kernel.ClrLines2);
							Gfx.PutPixel(I, Y2, Kernel.ClrLines2)
						End
						Else Begin
							Gfx.Line(I, Y1+1, I, Y2-1, Kernel.ClrDisabled);
							Gfx.PutPixel(I, Y1, Kernel.ClrDisabled2);
							Gfx.PutPixel(I, Y2, Kernel.ClrDisabled2)
						End
			End
		End
	End
End;

Procedure Splitter_Paint(Me:PControl; VX1,VY1,VX2,VY2:Integer);
Begin
	With Me^, Owner^.ClientRect, TSplitter(Data^) Do
	Begin
		D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY2, Area);
		Case Orient Of
			orVertical: Begin
				D.ToRange(CurX, VX1, VX2);
				D.AssignRect(X1+CurX-2, Y1+VY1, X1+CurX+2, Y1+VY2, Place)
			End;
			orHorizontal: Begin
				D.ToRange(CurY, VY1, VY2);
				D.AssignRect(X1+VX1, Y1+CurY-2, X1+VX2, Y1+CurY+2, Place)
			End
		End
	End;
	Splitter_Draw(Me)
End;



Function Splitter_GetCoord(Me:PControl): Integer;
Begin
	With TSplitter(Me^.Data^) Do
		Case Orient Of
			orVertical: Splitter_GetCoord:=CurX;
			orHorizontal: Splitter_GetCoord:=CurY
		End
End;

Procedure Splitter_SetCoord(Me:PControl; VCoord:Integer);
Begin
	With Me^, TSplitter(Data^) Do
		Case Orient Of
			orVertical: CurX:=VCoord;
			orHorizontal: CurY:=VCoord;
		End
End;



Procedure Splitter_HideMouse(Var X,Y:Integer);
Begin
	Kernel.HideMouse(X, Y);
	With CurCtl^, TSplitter(Data^) Do
	Begin
		SplitterMsX:=X;
		SplitterMsY:=Y;
		Case Orient Of
			orVertical: Gfx.InvertFrame(SplitterCoord-2, Place.Y1,
				SplitterCoord+2, Place.Y2);
			orHorizontal: Gfx.InvertFrame(Place.X1, SplitterCoord-2,
				Place.X2, SplitterCoord+2)
		End
	End
End;

Procedure Splitter_ShowMouse(Var X,Y:Integer);
Begin
	With CurCtl^, TSplitter(Data^) Do
		Case Orient Of
			orVertical: Begin
				Inc(SplitterCoord, X-SplitterMsX);
				If Not D.InRange(SplitterCoord,
					Area.X1, Area.X2) Then
				Begin { bug: jerky movement }
					Dec(SplitterCoord, X-SplitterMsX);
					X:=SplitterMsX
				End;
				Y:=SplitterMsY;
				Gfx.InvertFrame(SplitterCoord-2, Place.Y1,
					SplitterCoord+2, Place.Y2)
			End;
			orHorizontal: Begin
				Inc(SplitterCoord, Y-SplitterMsY);
				If Not D.InRange(SplitterCoord,
					Area.Y1, Area.Y2) Then
				Begin { bug: jerky movement }
					Dec(SplitterCoord, Y-SplitterMsY);
					Y:=SplitterMsY
				End;
				X:=SplitterMsX;
				Gfx.InvertFrame(Place.X1, SplitterCoord-2,
					Place.X2, SplitterCoord+2)
			End
		End;
	Kernel.ShowMouse(X, Y)
End;

Function Splitter_RefreshNeeded(Rect:TRect): Boolean;
Begin
	With CurCtl^, TSplitter(Data^) Do
		Case Orient Of
			orVertical: Splitter_RefreshNeeded:=
					D.IntersectCoord(Rect, SplitterCoord-2, Place.Y1,
					SplitterCoord+2, Place.Y2) Or Kernel.RefreshNeeded(Rect);
			orHorizontal: Splitter_RefreshNeeded:=
					D.IntersectCoord(Rect, Place.X1, SplitterCoord-2,
					Place.X2, SplitterCoord+2) Or Kernel.RefreshNeeded(Rect)
		End
End;

Procedure Splitter_OnClick(Me:PControl; X,Y:Integer);
Var
	LastSplitterCoord: Integer;
	Rect1, Rect2: TRect;
Begin
	With Me^, TSplitter(Data^) Do
	Begin
		Rect1:=Place;
		CurCtl:=Me;
		Case Orient Of
			orVertical: SplitterCoord:=Owner^.ClientRect.X1+CurX;
			orHorizontal: SplitterCoord:=Owner^.ClientRect.Y1+CurY
		End;
		LastSplitterCoord:=SplitterCoord;
		SplitterMsX:=Kernel.MsX;
		SplitterMsY:=Kernel.MsY;
		Case Orient Of
			orVertical: Kernel.SelectCursor(MouseScrHor);
			orHorizontal: Kernel.SelectCursor(MouseScrVer);
		End;

		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(Splitter_HideMouse, Splitter_ShowMouse,
			Splitter_RefreshNeeded)=0;

		Case Orient Of
			orVertical: Begin
				CurX:=SplitterCoord-Owner^.ClientRect.X1;
				If (SplitterCoord=LastSplitterCoord) And (Arrows<>saNone) Then
					If D.InRange(SplitterCoord, Area.X1+1, Area.X2-1) Then
					Begin
						LastCurPos:=CurX;
						Case Arrows Of
							saLeftUp: CurX:=Area.X1-Owner^.ClientRect.X1;
							saRightDown: CurX:=Area.X2-Owner^.ClientRect.X1
						End
					End
					Else
						CurX:=LastCurPos;

				D.AssignRect(Owner^.ClientRect.X1+CurX, Place.Y1,
					Owner^.ClientRect.X1+CurX+4, Place.Y2, Rect2);
				Gfx.ZoomRect(Rect1, Rect2)
			End;
			orHorizontal: Begin
				CurY:=SplitterCoord-Owner^.ClientRect.Y1;
				If (SplitterCoord=LastSplitterCoord) And (Arrows<>saNone) Then
					If D.InRange(SplitterCoord, Area.Y1+1, Area.Y2-1) Then
					Begin
						LastCurPos:=CurY;
						Case Arrows Of
							saLeftUp: CurY:=Area.Y1-Owner^.ClientRect.Y1;
							saRightDown: CurY:=Area.Y2-Owner^.ClientRect.Y1
						End
					End
					Else
						CurY:=LastCurPos;

				D.AssignRect(Place.X1, Owner^.ClientRect.Y1+CurY,
					Place.X2, Owner^.ClientRect.Y1+CurY+4, Rect2);
				Gfx.ZoomRect(Rect1, Rect2)
			End;
		End;
		Kernel.SelectCursor(Kernel.MouseDefault);
		Kernel.PaintWindow(Owner)
	End
End;


Function Splitter_OnKey(Me:PControl; Key,ExtKey:Char):Boolean;
Var
	TempPos: Integer;
Begin
	Splitter_OnKey:=False;
	With Me^, TSplitter(Data^) Do
	Begin
		If (Key=#0) And (ExtKey In [#72, #75]) Then
		Begin
			{ Left, up arrow }
			Case Orient Of
				orVertical: Begin
					TempPos:=D.Max(CurX-5, Area.X1-Owner^.ClientRect.X1);
					If TempPos<>CurX Then
					Begin
						CurX:=TempPos;
						Kernel.PaintWindow(Owner)
					End
				End;
				orHorizontal: Begin
					TempPos:=D.Max(CurY-5, Area.Y1-Owner^.ClientRect.Y1);
					If TempPos<>CurY Then
					Begin
						CurY:=TempPos;
						Kernel.PaintWindow(Owner)
					End
				End;
			End;
			Splitter_OnKey:=True
		End;
		If (Key=#0) And (ExtKey In [#77, #80]) Then
		Begin
			{ Right, down arrow }
			Case Orient Of
				orVertical: Begin
					TempPos:=D.Min(CurX+5, Area.X2-Owner^.ClientRect.X1);
					If TempPos<>CurX Then
					Begin
						CurX:=TempPos;
						Kernel.PaintWindow(Owner)
					End
				End;
				orHorizontal: Begin
					TempPos:=D.Min(CurY+5, Area.Y2-Owner^.ClientRect.Y1);
					If TempPos<>CurY Then
					Begin
						CurY:=TempPos;
						Kernel.PaintWindow(Owner)
					End
				End
			End;
			Splitter_OnKey:=True
		End;
		If (Key=#0) And (ExtKey=#71) Then
		Begin { Home }
			Case Orient Of
				orVertical: If CurX<>Area.X1-Owner^.ClientRect.X1 Then
					Begin
						CurX:=Area.X1-Owner^.ClientRect.X1;
						Kernel.PaintWindow(Owner)
					End;
				orHorizontal: If CurY<>Area.Y1-Owner^.ClientRect.Y1 Then
					Begin
						CurY:=Area.Y1-Owner^.ClientRect.Y1;
						Kernel.PaintWindow(Owner)
					End;
			End;
			Splitter_OnKey:=True
		End;
		If (Key=#0) And (ExtKey=#79) Then
		Begin { End }
			Case Orient Of
				orVertical: If CurX<>Area.X2-Owner^.ClientRect.X1 Then
					Begin
						CurX:=Area.X2-Owner^.ClientRect.X1;
						Kernel.PaintWindow(Owner)
					End;
				orHorizontal: If CurY<>Area.Y2-Owner^.ClientRect.Y1 Then
					Begin
						CurY:=Area.Y2-Owner^.ClientRect.Y1;
						Kernel.PaintWindow(Owner)
					End;
			End;
			Splitter_OnKey:=True
		End;

	End
End;


Procedure Splitter_OnDestroy(Me:PControl);
Begin
	FreeMem(Me^.Data, SizeOf(TSplitter))
End;


Function Splitter_Create(Prog:PProg; VPos:Integer;
	VOrient:TOrientation; VArrows:TSplitterArrows): PControl;
Var
	Me: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Splitter_OnClick, Splitter_OnKey,
		Kernel.CtlRefocusDummy, Kernel.CtlDummy, Splitter_OnDestroy,
		True, True, '');}
	With Me^ Do
	Begin
		OnClick:=Splitter_OnClick;
		OnKey:=Splitter_OnKey;
		OnDestroy:=Splitter_OnDestroy;

		GetMem(Data, SizeOf(TSplitter));
		With TSplitter(Data^) Do
		Begin
			Orient:=VOrient;
			Arrows:=VArrows;
			Case Orient Of
				orVertical: CurX:=VPos;
				orHorizontal: CurY:=VPos
			End;
			LastCurPos:=VPos
		End
	End;
	Splitter_Create:=Me
End;