{$F+}
Unit
	Stars; { Polit Halcyon Stars screensaver }

Interface

Uses
	Kernel, Gfx, Types;

Const
	StarsNum=300;

Var
	Star: Array[1..StarsNum] Of Record
		X, Y, DX, DY: Integer;
		Color: TColor;
		ColorStep, ColorCount: Integer;
	End;
	RunCount, I, Coef: Integer;

Implementation

Procedure CreateStar(N:Integer);
Var
	Speed: Integer;
	Alpha: Real;
Begin
	With Star[N] Do
	Begin
		Speed:=Random(18)+18;
		Alpha:=Random(628)/100;
		DX:=Round(Cos(Alpha)*Speed);
		DY:=Round(Sin(Alpha)*Speed);
		Coef:=Random(Gfx.ScrX Div 9);
		X:=(Gfx.ScrX Div 2)*32+DX*Coef;
		Y:=(Gfx.ScrY Div 2)*32+DY*Coef;
		If Random(21)=3 Then
		Begin { ஢ iઠ }
			Color:=Random(192)+32;
			ColorStep:=Speed
		End
		Else Begin { 砩 }
			Color:=228;
			ColorStep:=42-Speed
		End;
		ColorCount:=0
	End
End;

Procedure Stars_OnInit;
Begin
	Gfx.Bar(0, 0, Gfx.ScrX, Gfx.ScrY, clBlack);
	For I:=1 To StarsNum Do
		CreateStar(I);
	RunCount:=0
End;

Procedure Stars_OnIdle;
Begin
	Inc(RunCount);
	If RunCount<D.MachineSpeed Then Exit;
	RunCount:=0;

	For I:=1 To StarsNum Do
		With Star[I] Do
		Begin
			PutPixel(X Div 32, Y Div 32, clBlack);
			Inc(X, DX);
			Inc(Y, DY);
			If Not D.InRectCoord(X Div 32, Y Div 32, 0, 0, Gfx.ScrX, Gfx.ScrY) Then
				CreateStar(I);
			PutPixel(X Div 32, Y Div 32, Color);
			Inc(ColorCount);
			If (ColorCount>=ColorStep) And (Color<>255) Then
			Begin
				Inc(Color);
				ColorCount:=0
			End
		End
End;

Begin
	Kernel.RegScrSaver('Stars', Stars_OnInit, Stars_OnIdle)
End.