{$F+}
Unit
	Surfac3D; { Polit Halcyon Surface 3D screensaver }

Interface

Uses
	Kernel, Gfx, SGraph;

Const
	Scale=15;
	ScaleDiv=2;
	ScaleFunc=2;
	Range=9;

Var
	RunCount: Integer;
	Increment: Real;
	CenterX, CenterY: Integer;
	LastPos: Array[-Range..Range, -Range..Range] Of Record
		LX, LY: Integer
	End;

Implementation

Procedure Surface3D_OnInit;
Var
	X, Y: Integer;
Begin
	Increment:=0;
	RunCount:=0;
	CenterX:=Gfx.ScrX Div 2;
	CenterY:=Gfx.ScrY*2 Div 3;
	For Y:=-Range To Range Do
		For X:=-Range To Range Do
		Begin
			LastPos[X, Y].LX:=0;
			LastPos[X, Y].LX:=0
		End;
	Gfx.Bar(0, 0, Gfx.ScrX, Gfx.ScrY, clBlack)
End;

Procedure Point3DTo2D(X,Y,Z:Real; Var NX, NY: Integer);
Begin
	NX:=Round((X+Y)*Scale);
	NY:=Round((X-Y-Z)*Scale/2)
End;

Function Func(X,Y:Real): Real;
Begin
	Func:=Cos(Sqrt(X*X+Y*Y)-Increment)
End;

Procedure Surface3D_OnIdle;
Var
	X, Y: Integer;
	NX, NY: Integer;
	Z: Real;
Begin
	Inc(RunCount);
	If RunCount<D.MachineSpeed Then Exit;
	RunCount:=0;

	For Y:=-Range To Range Do
		For X:=-Range To Range Do
			With LastPos[X, Y] Do
			Begin
				Gfx.PutPixel(CenterX+LX, CenterY+LY, 0);
				Z:=Func(X/ScaleDiv, Y/ScaleDiv)*ScaleFunc;
				Point3DTo2D(X, Y, Z, LX, LY);
				PutPixel(CenterX+LX, CenterY+LY, 212+Round(Z*5.5))
			End;
	Increment:=Increment+0.2
End;



Begin
	Kernel.RegScrSaver('Surface3D', Surface3D_OnInit, Surface3D_OnIdle)
End.