{ ************ Switcher ************ }
Type
	TSwitcher=Record
		MyButton: PControl;
		Menu, CurItem: PMenuItem
	End;

Procedure Switcher_Paint(Me:PControl; VX1, VY1, VX2:Integer);
Begin
	Button_Paint(TSwitcher(Me^.Data^).MyButton, VX1, VY1, VX2)
End;

Procedure Switcher_OnRefocus(Me:PControl; Focused:Boolean);
Begin
	With TSwitcher(Me^.Data^) Do
		Kernel.CtlRefocusDummy(MyButton, Focused)
End;

Function Switcher_AsButton(Me:PControl): PControl;
Begin
	With TSwitcher(Me^.Data^) Do
		Switcher_AsButton:=MyButton
End;

Procedure Switcher_OnPress(Me:PProg; Control:PControl);
Begin
	With TSwitcher(Control^.Data^), MyButton^.Place Do
	Begin
		If CurItem^.Next=Nil
			Then CurItem:=Menu
			Else CurItem:=CurItem^.Next;
		Button_SetCaption(MyButton, String(CurItem^.Name^));
		Button_SetPicture(MyButton, CurItem^.Icon);

		CurItem^.OnClick(Me, CurItem)
	End
End;

Procedure Switcher_OnDestroy(Me:PControl);
Begin
	With TSwitcher(Me^.Data^) Do
		Popup.FreeMenu(Menu);
	FreeMem(Me^.Data, SizeOf(TSwitcher))
End;

Function Switcher_Create(Prog:PProg; VMenu:PMenuItem;
	VPicturePos:TPicturePos): PControl;
Var
	Me: PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Kernel.CtlClickDummy, Kernel.CtlKeyDummy,
		Switcher_OnRefocus, Kernel.CtlDummy, Switcher_OnDestroy,
		False, False, '');}
	With Me^ Do
	Begin
		OnRefocus:=Switcher_OnRefocus;
		OnDestroy:=Switcher_OnDestroy;
		Enabled:=False;
		D.AssignRect(-1, -1, -1, -1, Place);

		GetMem(Data, SizeOf(TSwitcher));
		With TSwitcher(Data^) Do
		Begin
			Menu:=VMenu^.SubMenu;
			CurItem:=VMenu^.Submenu;

			MyButton:=Button_Create(Prog, String(CurItem^.Name^),
				CurItem^.Icon, VPicturePos, Switcher_OnPress);
			Button_SetMarkStyle(MyButton, bmSwitch);
			{Button^.AutoRedraw:=True;}
			MyButton^.OwnerCtl:=Me
		End
	End;
	Switcher_Create:=Me
End;
