{ ************ Tab set ************ }
Type
	TTab=Record
		Name,Hint:PStr;
		Icon:Pointer;
		X2:Integer;
	End;
	TTabSet=Record
		Tab:Array[1..15] Of TTab;
		TabsNum,ActiveTab:Integer;
		FocusY2:Integer;
		DarkBack:Boolean;
		OnChange:TCtlHandler;
	End;

Var
	TabUnderMouse:Integer;
	PicTabLineL, PicTabLineR, PicTabL, PicTabR: TSkinPic;
	TabSetSkinned: Boolean;
	TabLineHeight: Integer;


Procedure TabSet_OnDestroy(Me:PControl);
Var
	I:Integer;
Begin
	With Me^,TTabSet(Data^) Do
	Begin
		For I:=1 To TabsNum Do
		Begin
			D.FreePStr(Tab[I].Name,'Ctl - TabSet_OnDestroy (name)');
			D.FreePStr(Tab[I].Hint,'Ctl - TabSet_OnDestroy (hint)')
		End;
		FreeMem(Data,SizeOf(TTabSet))
	End
End;

Procedure TabSet_OnRefocus(Me:PControl;Focused:Boolean);
Var
	RealY2:Integer;
Begin
	With Me^,TTabSet(Data^),Place Do
	Begin
		RealY2:=Y2;
		Y2:=FocusY2;
		Kernel.CtlRefocusDummy(Me,Focused);
		Y2:=RealY2
	End
End;

Procedure TabSet_Draw(Me:PControl; WithBG:Boolean);
{Type
	TTabColorName=(clLight, clActDark, clInactDark, clActFill,
		clInactFill, clFont);
Const
	Colors:Array[Boolean,TTabColorName] Of Byte=(
		(clGray,clGray,clGray,clSilver,clSilver,clGray),
		(clWhite,clNavy,clGray,clBlueGray,clSilver,clBlack));}
Var
	I,CurX, IconWidth:Integer;
	Temp:String;
	TempEnabled, TempPressed: Boolean;
	ClrActLight, ClrInactLight, ClrActDark, ClrInactDark,
	ClrActFill, ClrInactFill, ClrFont, ClrFontAct: Array[Boolean] Of TColor;
Begin
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^,TTabSet(Data^),Place Do
	Begin
		ClrActLight[True]:=Kernel.Clr3DActLight;
		ClrInactLight[True]:=Kernel.Clr3DLight;
		ClrActDark[True]:=Kernel.Clr3DActDark;
		ClrInactDark[True]:=Kernel.Clr3DDark;
		ClrActFill[True]:=Kernel.Clr3DAct;
		ClrInactFill[True]:=Kernel.Clr3DFace;
		ClrFont[True]:=Kernel.ClrText;
		ClrFontAct[True]:=Kernel.ClrTextAct;

		ClrActLight[False]:=Kernel.Clr3DDark;
		ClrInactLight[False]:=Kernel.Clr3DDark;
		ClrActDark[False]:=Kernel.Clr3DDark;
		ClrInactDark[False]:=Kernel.Clr3DDark;
		ClrActFill[False]:=Kernel.ClrWinBG;
		ClrInactFill[False]:=Kernel.ClrWinBG;
		ClrFont[False]:=Kernel.ClrTextDis;
		ClrFontAct[False]:=Kernel.ClrTextDis;

		If TabSetSkinned
			Then Gfx.SkinBar(X1, Y2-TabLineHeight+1, X2,
				PicTabLineL[Enabled, False], PicTabLineR[Enabled, False])
			Else Gfx.FillButtonRect(X1,Y2-3,X2,Y2,ClrActLight[Enabled],
				ClrActDark[Enabled],ClrActFill[Enabled]);
		CurX:=X1+2;
		If WithBG Then
			Kernel.WindowBar(X1, Y1, X2, Y2-TabLineHeight, DarkBack, False);
		Font.SetFont(Kernel.CurFont);
		For I:=1 To TabsNum Do
		Begin
			Temp:=String(Tab[I].Name^);
			If Tab[I].Icon<>Nil
				Then IconWidth:=Gfx.ImageX(Tab[I].Icon)+3
				Else IconWidth:=0;
			If TabSetSkinned
				Then Begin
					TempEnabled:=Enabled;
					TempPressed:=(I=ActiveTab) Or (I=TabUnderMouse);
					If Enabled Then
					Begin
						If I=ActiveTab Then TempEnabled:=False
					End
					Else TempPressed:=False;
					Gfx.SkinBar(CurX, Y1, CurX+Font.Width(Temp)+7+IconWidth,
						PicTabL[TempEnabled, TempPressed],
						PicTabR[TempEnabled, TempPressed])
				End
				Else If (I=ActiveTab) Or (I=TabUnderMouse) Then
					Begin
						Gfx.TabBar(CurX,Y1,CurX+Font.Width(Temp)+7+IconWidth,Y2-4,
							ClrActLight[Enabled],ClrActDark[Enabled], ClrActFill[Enabled]);
						If I=ActiveTab Then
							Gfx.Line(CurX+1,Y2-3,CurX+Font.Width(Temp)+6+IconWidth,Y2-3,
								ClrActFill[Enabled])
					End
					Else
						Gfx.TabBar(CurX,Y1,CurX+Font.Width(Temp)+7+IconWidth,Y2-4,
							ClrInactLight[Enabled],ClrInactDark[Enabled],
							ClrInactFill[Enabled]);
			If Tab[I].Icon<>Nil Then
			Begin
				If Enabled
					Then Gfx.PutSprite(CurX+4, Y1+2, Tab[I].Icon)
					Else Gfx.PutSpriteGrayed16(CurX+4, Y1+2, Tab[I].Icon)
			End;
			If (I=ActiveTab) Or (I=TabUnderMouse)
				Then Font.Print(CurX+4+IconWidth,Y1+4,ClrFontAct[Enabled],Temp)
				Else Font.Print(CurX+4+IconWidth,Y1+4,ClrFont[Enabled],Temp);
			Inc(CurX,Font.Width(Temp)+9+IconWidth);
			Tab[I].X2:=CurX-2;
			{If GrayBack Then
				Gfx.Line(CurX-1,Y1,CurX-1,Y2-4,clMidGray)}
		End;
		{If GrayBack Then
			Gfx.Bar(CurX-1,Y1,X2,Y2-4,clMidGray)}
	End;
End;

Procedure TabSet_Paint(Me:PControl;VX1,VY1,VX2,VY2:Integer);
Begin
	With Me^,Owner^.ClientRect,TTabSet(Data^) Do
	Begin
		D.AssignRect(X1+VX1,Y1+VY1,X1+VX2,Y1+VY1+22,Me^.Place);
		FocusY2:=Y1+VY2
	End;
	TabSet_Draw(Me, True)
End;

Procedure TabSet_PaintDirect(Me:PControl;VX1,VY1,VX2,VY2:Integer);
Begin
	With Me^,Owner^.ClientRect,TTabSet(Data^) Do
	Begin
		D.AssignRect(VX1,VY1,VX2,VY1+22,Me^.Place);
		FocusY2:=VY2
	End;
	TabSet_Draw(Me, True)
End;


Function TabSet_OnKey(Me:PControl;Key,ExtKey:Char):Boolean;
Var
	Recognized:Boolean;
	LastActiveTab:Integer;
Begin
	Recognized:=False;
	With Me^,TTabSet(Data^) Do
	Begin
		LastActiveTab:=ActiveTab;

		If (Key=#0) And (ExtKey In [#75,#73]) Then
		Begin { Left arrow, PgUp }
			Recognized:=True;
			If ActiveTab>1 Then
				Dec(ActiveTab)
		End;
		If (Key=#0) And (ExtKey In [#77,#81]) Then
		Begin { Right arrow, PgDn }
			Recognized:=True;
			If ActiveTab<TabsNum Then
				Inc(ActiveTab)
		End;
		If (Key=#0) And (ExtKey=#71) Then
		Begin { Home }
			Recognized:=True;
			ActiveTab:=1
		End;
		If (Key=#0) And (ExtKey=#79) Then
		Begin { End }
			Recognized:=True;
			ActiveTab:=TabsNum
		End;
		If ActiveTab<>LastActiveTab Then
		Begin
			TabSet_Draw(Me, False);
			If OwnerCtl=Nil
				Then TTabSet(Data^).OnChange(Owner,Me)
				Else TTabSet(Data^).OnChange(Owner,OwnerCtl)
		End
	End;
	TabSet_OnKey:=Recognized
End;


Function TabSet_WhichTab(Me:PControl;X,Y:Integer):Integer;
Var
	I:Integer;
Begin
	With Me^,TTabSet(Data^),Place Do
	Begin
		TabSet_WhichTab:=0;
		If D.InRange(Y,Y1,Y2-4) And D.InRange(X,X1+2,Tab[TabsNum].X2) Then
			For I:=TabsNum DownTo 1 Do
				If Tab[I].X2+1>X Then
					TabSet_WhichTab:=I
	End
End;

Procedure TabSet_HideMouse(Var X,Y:Integer);
Var
	I:Integer;
Begin
	TabUnderMouse:=TabSet_WhichTab(CurCtl,X,Y);
	Kernel.HideMouse(X,Y)
End;

Procedure TabSet_ShowMouse(Var X,Y:Integer);
Var
	UnderMouseNow:Integer;
Begin
	UnderMouseNow:=TabSet_WhichTab(CurCtl,X,Y);
	If UnderMouseNow<>TabUnderMouse Then
	Begin
		TabUnderMouse:=UnderMouseNow;
		TabSet_Draw(CurCtl, False)
	End;
	Kernel.ShowMouse(X,Y)
End;

Procedure TabSet_OnClick(Me:PControl;X,Y:Integer);
Var
	I,LastActiveTab:Integer;
Begin
	With TTabSet(Me^.Data^) Do
	Begin
		LastActiveTab:=ActiveTab;
		CurCtl:=Me;
		TabUnderMouse:=TabSet_WhichTab(Me,X,Y);
		TabSet_Draw(Me, False);
		Repeat
			Kernel.CheckSysKeys
		Until Kernel.HeartOfPolit(TabSet_HideMouse,TabSet_ShowMouse,
			Kernel.RefreshNeeded)=0;
		If TabUnderMouse<>0 Then
			ActiveTab:=TabUnderMouse;
		TabUnderMouse:=0;
		TabSet_Draw(Me, False);
		If LastActiveTab<>ActiveTab Then
			With Me^ Do
				If OwnerCtl=Nil
					Then TTabSet(Data^).OnChange(Owner,Me)
					Else TTabSet(Data^).OnChange(Owner,OwnerCtl)
	End
End;

Procedure TabSet_OnHint(Me:PControl);
Var
	CurPage:Integer;
Begin
	With Me^,TTabSet(Data^) Do
	Begin
		CurPage:=TabSet_WhichTab(Me, Kernel.MsX, Kernel.MsY);
		If CurPage<>0 Then
			Kernel.ShowHint(String(Tab[CurPage].Hint^))
	End
End;

Procedure TabSet_TryAutoRedraw(Me:PControl);
Begin
	If Me^.AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
		If (Me^.CanDraw Or Kernel.DontBother) And Me^.Visible Then
		Begin
			Kernel.BeginPaint(Me^.Place);
			TabSet_Draw(Me, False);
			Kernel.EndPaint
		End
End;

Procedure TabSet_SetActiveTab(Me:PControl;VactiveTab:Integer);
Var
	LastActiveTab:Integer;
Begin
	With Me^,TTabSet(Data^) Do
	Begin
		LastActiveTab:=ActiveTab;
		If D.InRange(VActiveTab,1,TabsNum) Then
			ActiveTab:=VActiveTab;
		If ActiveTab=LastActiveTab Then Exit;
		TabSet_TryAutoRedraw(Me);
		If OwnerCtl=Nil
			Then OnChange(Owner,Me)
			Else OnChange(Owner,OwnerCtl)
	End
End;

Function TabSet_GetActiveTab(Me:PControl): Integer;
Begin
	With Me^,TTabSet(Data^) Do
		TabSet_GetActiveTab:=ActiveTab
End;

Procedure TabSet_AddTab(Me:PControl;VName,VHint:String; VIcon:Pointer);
Begin
	With Me^,TTabSet(Data^) Do
	Begin
		Inc(TabsNum);
		D.AssignPStr(VName,Tab[TabsNum].Name);
		D.AssignPStr(VHint,Tab[TabsNum].Hint);
		Tab[TabsNum].Icon:=VIcon;
		If ActiveTab=0 Then
			ActiveTab:=TabsNum;
	End;
	TabSet_TryAutoRedraw(Me)
End;



Function TabSet_Create(Prog:PProg; VDarkBack:Boolean;
	VOnChange:TCtlHandler):PControl;
Var
	Me:PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{TabSet_OnClick, TabSet_OnKey, TabSet_OnRefocus,
		TabSet_OnHint, TabSet_OnDestroy, VEnabled, False, '');}
	With Me^ Do
	Begin
		OnClick:=TabSet_OnClick;
		OnKey:=TabSet_OnKey;
		OnRefocus:=TabSet_OnRefocus;
		OnHint:=TabSet_OnHint;
		OnDestroy:=TabSet_OnDestroy;

		GetMem(Data,SizeOf(TTabSet));
		With TTabSet(Data^) Do
		Begin
			OnChange:=VOnChange;
			DarkBack:=VDarkBack;
			TabsNum:=0;
			ActiveTab:=0;
		End
	End;
	TabSet_Create:=Me
End;
