{$F+}
Unit
	Tanks; { Polit Halcyon Tanks application }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx, BCRT;

Const
	MaxTanks=9;
	TankColor: Array[1..MaxTanks] Of TColor=
		(clBlue, clRed, clGreen,
		clYellow, clMagenta, clCyan,
		clBrown, clPurple, clTeal);

Type
	TTank=Record
		X, Y, LastY: LongInt;
		BlowX, BlowY, BlowR: Integer;
		Angle, Speed: Integer;
		FallDamage: LongInt;
		People: Integer;
		Name: String[12];
		Color: TColor;
		Score: LongInt;
		Bonuses: Integer;
	End;
	TGameState=(gsToShowDialog, gsNoGame, gsNone, gsFire);
	TFireBombData=Record
		P:Array[1..900] Of Record
			X,Y:Real
		End;
		N1,N2:Integer;
		DX,DY,W:Real;
		GP:Integer;
		AllowedRect: TRect;
	End;

	TExplosion=Record
		X, Y, Radius: Integer
	End;

	TTanksData=Record
		CanField, TimMain: PControl;

		Tank:Array[1..MaxTanks] Of TTank;
		TanksNum, CurTank, Alive, Winner: Integer;
		State: TGameState;
		FireData: ^TFireBombData;
		H: Array[1..1023] Of Integer;
		Explosion: Array[1..300] Of TExplosion;
		ExplNum: Integer;
	End;

	TTanksDlgData=Record
		LabNum, SedNum, LabNames: PControl;
		InpName: Array[1..9] Of PControl;
		PicTank: Array[1..9] Of Pointer;
		BtnStart: PControl;
	End;

Var
	Myself: PProg;

Implementation


Procedure Dlg_OnPaint(Me:PProg);
Var
	I: Integer;
Begin
	With Me^, ClientRect, TTanksDlgData(Data^) Do
	Begin
		Ctl.Label_Paint(LabNum, 5, 10, 130);
		Ctl.SpinEdit_Paint(SedNum, 140, 10, X2-X1-10);
		Ctl.Label_Paint(LabNames, 5, 50, 130);

		For I:=1 To 9 Do
			Ctl.InpLine_Paint(InpName[I], 140, 25+I*25, X2-X1-10);

		Ctl.Button_Paint(BtnStart, 140, 290, X2-X1-10);
	End;
End;

Procedure StartNewGame; Forward;

Procedure Dlg_OnStartClick(Me:PProg; Control:PControl);
Var
	Res: Word;
	RealMyself: PProg;
	I: Integer;
Begin
	RealMyself:=Me^.Parent;
	With TTanksDlgData(Me^.Data^), TTanksData(RealMyself^.Data^) Do
	Begin
		TanksNum:=Ctl.SpinEdit_GetValue(SedNum);
		D.ToRange(TanksNum, 2, 9);
		For I:=1 To 9 Do
			Tank[I].Name:=Ctl.InpLine_GetText(InpName[I]);

		Ini.Load('tanks.ini');
		Ini.SelectSec('Players');
		Ini.SetInt('Number', TanksNum);
		For I:=1 To 9 Do
			Ini.SetStr('Name'+D.St(I), Tank[I].Name);
		Ini.SaveCurFile;
		Ini.FreeFile('tanks.ini');
		Ini.SelectFile('polit.ini');

		Kernel.CloseProg(Me);
			{ i i Myself  १ .  饭 i i i, }
			{  CloseProg -> HideWindow -> PaintWindowDirect  ᢮ }
			{  i i i. }
		Myself:=RealMyself;
		{Kernel.ToFrontWindow(Myself);}
		StartNewGame
	End;
End;

Procedure Dlg_OnClose(Me:PProg);
Var
	I: Integer;
Begin
	With Me^, TTanksDlgData(Data^) Do
		For I:=1 To 9 Do
			Kernel.FreeRes('tank'+D.St(I)+'.bmp');
	FreeMem(Me^.Data, SizeOf(TTanksDlgData))
End;

Procedure Dlg_OnInit(Me:PProg);
Var
	TempInt, I: Integer;
	TempStr: String;
	TempName: Array[1..9] Of String[12];
Begin
	Me^.OnPaint:=Dlg_OnPaint;
	Me^.OnClose:=Dlg_OnClose;
	With Me^ Do
	Begin
		D.AssignPStr(String(Param^), WinTitle);
		MinX:=270;
		MinY:=320;
		GetMem(Data, SizeOf(TTanksDlgData));
		Kernel.InitWindow(Me, 'BlueDlg', []);
		Kernel.DrawWindowAni(Me);

		With TTanksDlgData(Data^) Do
		Begin
			For I:=1 To 9 Do
				PicTank[I]:=Kernel.LoadBMPRes('prog\tanks\tank'+D.St(I)+'.bmp');

			Ini.Load('tanks.ini');
			Ini.Select('tanks.ini', 'Players');
			TempInt:=Ini.GetInt('Number', 3);
			D.ToRange(TempInt, 2, 9);

			LabNum:=Ctl.Label_Create(Me, 'ii ࠢi:', Nil, lsNormal, alRight);
			SedNum:=Ctl.SpinEdit_Create(Me, 2, 9, 1, TempInt);
			{SedNum^.Enabled:=False;}

			LabNames:=Ctl.Label_Create(Me, 'I ࠢi:', Nil, lsNormal, alRight);
			Ini.UpCaseNeeded:=False;
			Ini.Select('tanks.ini', 'Players');
			For I:=1 To 9 Do
				TempName[I]:=Ini.GetStr('Name'+D.St(I), '');

			For I:=1 To 9 Do
				InpName[I]:=Ctl.InpLine_Create(Me, TempName[I], PicTank[I]);

			Ini.FreeFile('tanks.ini');
			Ini.UpCaseNeeded:=True;
			Ini.SelectFile('polit.ini');

			BtnStart:=Ctl.Button_Create(Me, '!', Parent^.Icon, ppLeft,
				Dlg_OnStartClick);
			ButtonEnter:=BtnStart
		End
	End
End;













Procedure GenerateField;
Var
	I, CurX:Integer;
	Coef:Real;

	Procedure Split(N1,N2:Integer);
	Var
		V,Dim:Integer;
	Begin
		With Myself^, ClientRect, TTanksData(Data^) Do
			If N2-N1>1 Then
			Begin
				V:=(N1+N2) Div 2;
				Dim:=(N2-N1) Div 2;
				H[V]:=(H[N1]+H[N2]) Div 2+Random(Dim+Dim)-Dim;
				If H[V]<70 Then H[V]:=70+Random(Dim Div 3+7);
				If H[V]>Y2-Y1-60 Then H[V]:=Y2-Y1-60-Random(Dim Div 3+7);
				Split(N1,V);
				Split(V,N2)
			End
	End;
Begin
	With Myself^, ClientRect, TTanksData(Data^) Do
	Begin
		Randomize;
		H[1]:=(Y2-Y1) Div 2;
		H[1023]:=(Y2-Y1) Div 2;
		Split(1, 1023)
	End
End;


Procedure DrawField;
Var
	I, CurX: Integer;
	Coef: Real;
Begin
	With Myself^, TTanksData(Data^) Do
	Begin
		With ClientRect Do
			Coef:=(X2-X1-72)/1023;
		Ctl.Canvas_BeginPaint(CanField);
		With CanField^.Place Do
			For I:=1 To 1023 Do
			Begin
				CurX:=36+Round(I*Coef);
				Gfx.Line(X1+CurX, Y1, X1+CurX, Y1+H[I]-1, clBlack);
				Gfx.Line(X1+CurX, Y1+H[I], X1+CurX, Y2-61, clGray)
			End;
		Kernel.EndPaint
	End
End;

Procedure DrawTank(ToShow:Boolean);
Var
	TempColor: TColor;
	R: Real;
Begin
	With Myself^, ClientRect, TTanksData(Data^), CanField^.Place Do
		With Tank[CurTank] Do
		Begin
			If ToShow
				Then TempColor:=Color
				Else TempColor:=clBlack;
			Ctl.Canvas_BeginPaint(CanField);
			Gfx.Bar(X1+X-5, Y1+Y+1, X1+X+5, Y1+Y+7, TempColor);
			R:=Angle*Pi/180;
			If ToShow Then TempColor:=clWhite;
			Gfx.Line(X1+X, Y1+Y, X1+X+Round(Cos(R)*Speed),
				Y1+Y-Round(Sin(R)*Speed), TempColor);
			Kernel.EndPaint
		End
End;

Procedure SelectTank;
Begin
	With Myself^, ClientRect, TTanksData(Data^), CanField^.Place Do
		With Tank[CurTank] Do
		Begin
			Kernel.BeginPaintCoord(X1+X-5, Y1+Y+1, X1+X+5, Y1+Y+7);
			Gfx.Rectangle(X1+X-5, Y1+Y+1, X1+X+5, Y1+Y+7, clWhite);
			Kernel.EndPaint
		End
End;

Procedure HealthBar;
Var
	CurX, CurY, CurWidth: Integer;
	CurName: String;
Begin
	With Myself^, ClientRect, TTanksData(Data^), CanField^.Place Do
		With Tank[CurTank] Do
		Begin
			CurX:=36+((X2-X1-70-52) Div (TanksNum-1))*(CurTank-1);
			{CurX:=45+(CurTank-1)*((X2-X1-70) Div TanksNum);}
			Kernel.BeginPaintCoord(X1+CurX, Y2-25, X1+CurX+51, Y2-18);
			Gfx.Bar(X1+CurX, Y2-25, X1+CurX+51, Y2-18, clBlack);
			Gfx.Rectangle(X1+CurX, Y2-25, X1+CurX+51, Y2-18, clWhite);
			If People>0 Then
				Gfx.Bar(X1+CurX+1, Y2-24, X1+CurX+People, Y2-19, Color);
			Kernel.EndPaint;

			Font.SetFont(Kernel.CurFont);
			CurName:=Kernel.ShortenStr(Name, 50+60);
			CurWidth:=Font.Width(CurName);
			CurX:=CurX+26-(CurWidth Div 2);
			Kernel.BeginPaintCoord(X1+CurX, Y2-18, X1+CurX+CurWidth,
				Y2-18+Font.Height(Kernel.CurFont));
			Font.Print(X1+CurX, Y2-18, clBlack, CurName);
			If People<=0 Then
			Begin
				CurY:=Y2-18+(Font.Height(Kernel.CurFont) Div 2);
				Dec(CurX);
				Gfx.Line(X1+CurX, CurY, X1+CurX+CurWidth, CurY, clMaroon)
			End;
			Kernel.EndPaint
		End
End;


Procedure PlaceTank;
Begin
	With Myself^, ClientRect, TTanksData(Data^), CanField^.Place Do
		With Tank[CurTank] Do
		Begin
			X:=35+(CurTank-1)*((X2-X1-70) Div TanksNum)+
				Random((X2-X1-70) Div TanksNum-7);
			Angle:=90;
			Speed:=15;
			People:=50;
			Color:=TankColor[CurTank];
			Y:=21;
			Kernel.BeginPaintCoord(X1+X, Y1, X1+X, Y2);
			Repeat
				Inc(Y)
			Until (Gfx.GetPixel(X1+X, Y1+Y+8)=clGray) Or (Y>Y2-Y1-50);
			Kernel.EndPaint;
			DrawTank(True);
			{OutShadowed(64+(Cur-1)*(512 Div Tanks),GetMaxY-25,Color,Name);
			ShowScore;}
			HealthBar;
			Bonuses:=3;
			{ShowBonuses;}
			BlowX:=X;
			BlowY:=Y;
			BlowR:=12;

		End
End;





Procedure StartNewGame;
Begin
	With Myself^, ClientRect, TTanksData(Data^) Do
	Begin
		GenerateField;
		DrawField;
		Alive:=TanksNum;
		Winner:=0;
		CurTank:=1;
		ExplNum:=0;
		Repeat
			PlaceTank;
			HealthBar;
			Inc(CurTank)
		Until CurTank>TanksNum;
		CurTank:=Random(TanksNum)+1;
		SelectTank;
		State:=gsNone;

	End
End;






Procedure DrawExplosion(X,Y,Radius:Integer; Color: TColor);
Begin
	With Myself^, ClientRect, TTanksData(Data^), CanField^.Place Do
	Begin
		Kernel.BeginPaintCoord(X1+X-Radius, Y1+Y-Radius,
			X1+X+Radius, Y1+Y+Radius);
		Gfx.FillCircle(X1+X, Y1+Y, Radius, Color);
		Kernel.EndPaint
	End
End;

Procedure RestoreBorders;
Begin
	With Myself^, ClientRect, TTanksData(Data^), CanField^.Place Do
	Begin
		Ctl.Canvas_BeginPaint(CanField);
		Gfx.Bar(X1, Y1, X1+35, Y2-26, clSilver);
		Gfx.Bar(X2-35, Y1, X2, Y2-26, clSilver);
		Gfx.Bar(X1+35, Y2-60, X2-35, Y2-26, clSilver);
		Kernel.EndPaint
	End
End;



Procedure OnPaint(Me:PProg);
Var
	CurSave, I: Integer;
Begin
	Myself:=Me;
	With Me^, TTanksData(Data^), CanField^.Place Do
	Begin
		With ClientRect Do
			Ctl.Canvas_Paint(CanField, 0, 0, X2-X1, Y2-Y1);
		If State In [gsToShowDialog, gsNoGame] Then Exit;

		DrawField;
		For I:=1 To ExplNum Do
			With Explosion[I] Do
				If D.InRectCoord(X, Y, 30, 30, X2-X1-30, Y2-Y1) Then
					DrawExplosion(X, Y, Radius, clBlack);
		RestoreBorders;
		Gfx.Bar(X1, Y2-26, X2, Y2, clSilver);

		CurSave:=CurTank;
		CurTank:=1;
		Repeat
			DrawTank(True);
			HealthBar;
			Inc(CurTank)
		Until CurTank>TanksNum;
		CurTank:=CurSave;
		SelectTank
	End;
End;

Procedure OnIdle(Me:PProg);
Begin
	Myself:=Me;
	With Me^, TTanksData(Data^) Do
	Begin
		If (State=gsToShowDialog) And (Me=Kernel.ActiveWin) Then
		Begin
			If Winner=0
				Then Kernel.RunChild(Me, Dlg_OnInit, ' ')
				Else Kernel.RunChild(Me, Dlg_OnInit, Tank[Winner].Name+' ६i!');
			State:=gsNoGame
		End
	End
End;


Procedure TurnCannon(Delta:Integer);
Var
	R: Real;
	TempX, TempY: Integer;
Begin
	With Myself^, ClientRect, TTanksData(Data^), CanField^.Place Do
		With Tank[CurTank] Do
		Begin
			DrawTank(False);
			Inc(Angle, Delta);
			R:=Angle*Pi/180;
			TempX:=X1+X+Round(Cos(R)*Speed);
			TempY:=Y1+Y-Round(Sin(R)*Speed);
			Kernel.BeginPaintCoord(TempX, TempY, TempX, TempY);
			If Not D.InRange(Angle, 0, 180) Or
				(Gfx.GetPixel(TempX, TempY)<>clBlack) Then
				Dec(Angle, Delta);
			Kernel.EndPaint;
			DrawTank(True);
			SelectTank
		End
End;

Procedure SlideCannon(Delta:Integer);
Var
	R: Real;
	TempX, TempY: Integer;
Begin
	With Myself^, ClientRect, TTanksData(Data^), CanField^.Place Do
		With Tank[CurTank] Do
		Begin
			DrawTank(False);
			Inc(Speed, Delta);
			R:=Angle*Pi/180;
			TempX:=X1+X+Round(Cos(R)*Speed);
			TempY:=Y1+Y-Round(Sin(R)*Speed);
			Kernel.BeginPaintCoord(TempX, TempY, TempX, TempY);
			If Not D.InRange(Speed, 1, 33) Or
				(Gfx.GetPixel(TempX, TempY)<>clBlack) Then
				Dec(Speed, Delta);
			Kernel.EndPaint;
			DrawTank(True);
			SelectTank
		End
End;

Procedure Explode(X,Y,Radius:Integer); Forward;

Procedure OnTimMain(Me:PProg; Control:PControl; Times:Integer);
Var
	Counter, I: Integer;
	RX, RY: LongInt;
Begin
	Myself:=Me;
	With Me^, ClientRect, TTanksData(Data^), CanField^.Place Do
		Case State Of
			gsFire: With FireData^ Do
			Begin
				Counter:=1;
				Ctl.Canvas_BeginPaint(CanField);
				Repeat
					If D.InRect(Round(P[N1].X), Round(P[N1].Y), AllowedRect) Then
						Gfx.PutPixel(X1+Round(P[N1].X), Y1+Round(P[N1].Y), 176);
					P[N1+1].X:=P[N1].X+DX{+WindStrength};
					P[N1+1].Y:=P[N1].Y+DY;
					DY:=DY+0.07;
					Inc(N1);
					If N1-N2>30 Then
					Begin
						If D.InRect(Round(P[N2+24].X), Round(P[N2+24].Y), AllowedRect) Then
							Gfx.PutPixel(X1+Round(P[N2+24].X),
								Y1+Round(P[N2+24].Y), 152);
						If D.InRect(Round(P[N2+9].X), Round(P[N2+9].Y), AllowedRect) Then
							Gfx.PutPixel(X1+Round(P[N2+9].X),
								Y1+Round(P[N2+9].Y), 128);
						If D.InRect(Round(P[N2].X), Round(P[N2].Y), AllowedRect) Then
							Gfx.PutPixel(X1+Round(P[N2].X),
								Y1+Round(P[N2].Y), clBlack);
						Inc(N2)
					End;
					RX:=Round(P[N1].X);
					RY:=Round(P[N1].Y);
					If RY<35
						Then GP:=clBlack
						Else If (RX<35) Or (RX>X2-X1-35) Or (RY>Y2-Y1-35)
							Then GP:=8
							Else GP:=Gfx.GetPixel(X1+RX, Y1+RY);
					Inc(Counter)
				Until Not (GP In [clBlack, 128, 152, 176, clWhite]) Or
					(Counter>9*Times);
				Kernel.EndPaint;

				If Not (GP In [clBlack, 128, 152, 176, clWhite]) Then
				Begin { ᭠ ਫi }
					Ctl.Canvas_BeginPaint(CanField);
					For I:=N2 To N1-1 Do
						If D.InRect(Round(P[I].X), Round(P[I].Y), AllowedRect) Then
							Gfx.PutPixel(X1+Round(P[I].X),
								Y1+Round(P[I].Y), clBlack);
					Kernel.EndPaint;

					W:=Sqrt(Sqr(DX)+Sqr(DY))*2.4;
					Explode(Round(P[N1].X), Round(P[N1].Y), 7+Round(W));
					{ShowScore;}

					Dispose(FireData);
					If State=gsFire Then {   ⠫ gsToShowDialog }
						State:={gsBlow}gsNone;
					If Tank[CurTank].People>0 Then
						DrawTank(True);
					If Alive>1 Then
						Repeat
							Inc(CurTank);
							If CurTank>TanksNum Then
								CurTank:=1
						Until Tank[CurTank].People>0;
					SelectTank
				End
			End;
		End
End;



Procedure Damage(T,Size:Integer);
Var
	CurSave: Integer;
	Msg: String;
Begin
	With Myself^, ClientRect, TTanksData(Data^) Do
	Begin
		CurSave:=CurTank;
		CurTank:=T;
		With Tank[CurTank] Do
		Begin
			Dec(People, Size);
			Inc(Tank[CurSave].Score, Size);
			If People<=0 Then
			Begin
				DrawTank(False);
				Dec(Alive)
			End;
			HealthBar
		End;
		CurTank:=CurSave
	End
End;

Procedure Explode(X,Y,Radius:Integer);
Var
	I, CurSave:Integer;
	Dist: LongInt;
Begin
	With Myself^, ClientRect, TTanksData(Data^), CanField^.Place Do
	Begin
		{SetViewPort(0,0,639,GetMaxY-27,ClipOn);}
		If Not D.InRectCoord(X, Y, 30, 30, X2-X1-30, Y2-Y1) Then
		Begin
			RestoreBorders;
			Exit
		End;

		DrawExplosion(X, Y, Radius, clYellow);
		BCRT.Delay(300);
		DrawExplosion(X, Y, Radius, clBlack);
		RestoreBorders;
		Inc(ExplNum);
		Explosion[ExplNum].X:=X;
		Explosion[ExplNum].Y:=Y;
		Explosion[ExplNum].Radius:=Radius;

		CurSave:=CurTank;
		CurTank:=1;
		Repeat
			If Tank[CurTank].People>0 Then
			Begin
				Tank[CurTank].LastY:=Tank[CurTank].Y;
				DrawTank(False);
				Ctl.Canvas_BeginPaint(CanField);
				With Tank[CurTank] Do
				Begin
					FallDamage:=0;
					If Gfx.GetPixel(X1+X, Y1+Y+8)=clBlack Then
						Repeat
							{DrawTank(False);}
							Inc(Y);
							Inc(FallDamage);
							{DrawTank(True);
							BCRT.Delay(12)}
						Until Gfx.GetPixel(X1+X, Y1+Y+8) In
							[clGray, clSilver];
				End;
				Kernel.EndPaint;
				DrawTank(True)
			End;
			Inc(CurTank)
		Until CurTank>TanksNum;
		CurTank:=CurSave;
		{SetViewPort(0,0,639,GetMaxY,ClipOn);}

		For I:=1 To TanksNum Do
			If Tank[I].People>0 Then
			Begin
				Dist:=Round(Sqrt(Sqr(Tank[I].X-X)+Sqr(Tank[I].LastY-Y)));
				If (Dist<Radius) Or (Tank[I].FallDamage>0) Then
					Damage(I, (Radius-Dist) Div 2+Tank[I].FallDamage Div 5)
			End;

		If Alive<=1 Then
		Begin
			For I:=1 To TanksNum Do
				If Tank[I].People>0 Then
					Winner:=I;
			If Winner=0 Then
				Winner:=CurTank;
			State:=gsToShowDialog
		End
	End
End;


Procedure FireBomb;
Const
	WindStrength=0;
Var
	P:Array[1..900] Of Record
		X,Y:Real
	End;
	N1,N2:Integer;
	DX,DY,W:Real;
	I:Integer;
	GP:Integer;
	RX,RY:LongInt;
	AllowedRect: TRect;
Begin
	With Myself^, ClientRect, TTanksData(Data^) Do
		With Tank[CurTank] Do
		Begin
			New(FireData);
			With FireData^ Do
			Begin
				DX:=Cos(Angle*Pi/180)*(Speed+1)/4;
				DY:=-Sin(Angle*Pi/180)*(Speed+1)/4;
				P[1].X:=X+DX*4;
				P[1].Y:=Y+DY*4;
				N1:=1;
				N2:=1;
				D.AssignRect(35, 0, X2-X1-35, Y2-Y1-30, AllowedRect);
			End;
			State:=gsFire
		End
End;




Function OnKey(Me:PProg; Key,ExtKey:Char): Boolean;
Begin
	Myself:=Me;
	With TTanksData(Me^.Data^) Do
	Begin
		If Key=#0 Then
		Begin
			OnKey:=True;
			Case ExtKey Of
				'H': If State=gsNone Then SlideCannon(1);
				'P': If State=gsNone Then SlideCannon(-1);
				'K': If State=gsNone Then TurnCannon(5);
				'M': If State=gsNone Then TurnCannon(-5);
				Else OnKey:=False
			End
		End
		Else Begin
			OnKey:=True;
			Case Key Of
				' ': FireBomb;
				Else OnKey:=False
			End
		End
	End
End;

Procedure OnClose(Me:PProg);
Begin
	FreeMem(Me^.Data, SizeOf(TTanksData))
End;

Procedure OnInit(Me:PProg);
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnIdle:=OnIdle;
	Me^.OnKey:=OnKey;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('', WinTitle);
		MinX:=550;
		MinY:=350;
		GetMem(Data, SizeOf(TTanksData));
		Myself:=Me;
		Kernel.InitWindow(Me, 'BlueDlg', [wbMin, wbClose]);
		Kernel.DrawWindow(Me);

		With TTanksData(Data^) Do
		Begin
			CanField:=Ctl.Canvas_Create(Me, False);
			TimMain:=Ctl.TimerCtl_Create(Me, 1, True, OnTimMain);

			State:=gsToShowDialog;
			TanksNum:=0;
			Winner:=0;
		End
	End
End;



Begin
	Kernel.RegBuiltIn('Tanks', ' ', 'pic\i_tanks.bmp', OnInit)
End.
