{$F+}
Unit
	TaskBar; { Polit Halcyon task bar }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Ini, Gfx, Log, DOS;

Const
	DayName: Array[0..6] Of String[15]=
		('i', 'i', 'iப', '।',
		'⢥', '''⭨', '㡮');
	DayNameShort: Array[0..6] Of String[2]=
		('', '', '', '', '', '', '');
	MaskFilter=ksRightShift+ksLeftShift+ksLeftCtrl+ksLeftAlt+
		ksRightCtrl+ksRightAlt;


Type
	TTaskBtn=Record
		Prog:PProg;
		Button:PControl;
		Down:Boolean
	End;
	TButtonWidthMode=(bwFixed, bwVariable);
	TLanguageSign=(lsNone, lsName, lsFlag);

	TTaskBarData=Record
		Btn:Array[1..21] Of TTaskBtn;
		BtnNum:Integer;
		ButtonWidthMode:TButtonWidthMode;
		ButtonWidth:Integer;
		BtnStart, LabClock, TimClock, ClkTime: PControl;
		PicPolit: Pointer;
		ClockDigital, ClockShowSeconds, ClockAnalog, BarTransparent: Boolean;
		CenterButtons: Boolean;
		PicturePos: TPicturePos;
		DblHeight: Boolean;
		DateStr: String[40];
		LangSign: TLanguageSign;
		CanLang: PControl;
		PicLang: Array[0..5] Of Pointer;
		LangMask: Word;
		SwitchComboPressed: Boolean;
		Decrement: Integer;
	End;

Implementation


Procedure DrawLangSign(Me:PProg);
Begin
	With TTaskBarData(Me^.Data^) Do
	Begin
		Ctl.Canvas_BeginPaint(CanLang);
		With CanLang^.Place Do
		Begin
			Kernel.WindowBar(X1, Y1, X2, Y2, False, False);
			If (LangSign=lsName) Or (PicLang[Kernel.CurLayout]=Nil) Then
			Begin
				Font.SetFont(Kernel.CurFont);
				Font.Print(X1+9, Y1+(Y2-Y1-Font.Height(Kernel.CurFont)) Div 2+1,
					Kernel.ClrText, Kernel.KeybLayoutName[Kernel.CurLayout])
			End
			Else Gfx.PutSprite(X1+7, Y1+(Y2-Y1-16) Div 2, PicLang[Kernel.CurLayout])
		End;
		Kernel.EndPaint
	End
End;


Procedure TaskBar_OnPaint(Me:PProg);
Var
	I: Integer;
	BtnWidth, StartWidth, ClockWidth, StartX: Integer;
Begin
	With Me^, ClientRect, TTaskBarData(Data^) Do
	Begin
		{Log.BugMsg('TaskBar','TaskBar_OnPaint','Painting, buttons = '+D.St(BtnNum));}
		If ClockDigital Then
		Begin
			Font.SetFont(Kernel.CurFont);
			If DblHeight
				Then ClockWidth:=Font.Width(' AA 00.00 ')+8
				Else If ClockShowSeconds
					Then ClockWidth:=Font.Width(' 00:00:00 ')+8
					Else ClockWidth:=Font.Width(' 00:00 ')+8;
				Ctl.Label_Paint(LabClock, X2-X1-ClockWidth+1,
				0{(Y2-Y1-20) Div 2}, X2-X1)
		End
		Else
			ClockWidth:=0;

		If ClockAnalog Then
		Begin
			{If BarTransparent
				Then Gfx.Bar(X2-X1-ClockWidth-(Y2-Y1)-10, Y1,
					X2-X1-ClockWidth, Y2, Gfx.DesktopColor)
				Else Kernel.DarkBar(X2-X1-ClockWidth-(Y2-Y1)-10, Y1,
					X2-X1-ClockWidth, Y2);}
			Ctl2.AnClock_Paint(ClkTime, X2-X1-ClockWidth-(Y2-Y1-Decrement),
				0, X2-X1-ClockWidth);
			Inc(ClockWidth, Y2-Y1+1-Decrement)
		End;

		If LangSign<>lsNone Then
		Begin
			Inc(ClockWidth, 30);
			Ctl.Canvas_Paint(CanLang, X2-X1-ClockWidth+1, 0,
				X2-X1-ClockWidth+30, Y2-Y1-Decrement);
			DrawLangSign(Me)
		End;

		If BarTransparent
			Then Gfx.Bar(X1, Y1, X2-ClockWidth, Y2, Gfx.DesktopColor)
			Else Kernel.DarkBar(X1, Y1, X2-ClockWidth, Y2);
		StartWidth:=Ctl.Button_PrefWidth(BtnStart);
		Ctl.Button_Paint(BtnStart, 0, 0, StartWidth-1);
		If BtnNum>0 Then
		Begin
			Case ButtonWidthMode Of
				bwFixed: BtnWidth:=D.Min(ButtonWidth,
					(X2-X1-StartWidth-ClockWidth-10+1) Div BtnNum);
				bwVariable: BtnWidth:=(X2-X1-StartWidth-ClockWidth-10+1) Div BtnNum;
			End;
			If CenterButtons
				Then StartX:=StartWidth+10+
					(X2-X1-StartWidth-ClockWidth-10+1-BtnWidth*BtnNum) Div 2
				Else StartX:=StartWidth+10;
			For I:=1 To BtnNum Do
				Ctl.Button_Paint(Btn[I].Button, StartX+(I-1)*BtnWidth, 0,
					StartX+I*BtnWidth-2)
		End
	End
End;


Procedure OnClockTimer(Me:PProg; Control:PControl; Times:Integer);
Var
	Hour, Min, Sec, Sec100: Word;
	TempStr: String;
Begin
	With Me^, TTaskBarData(Data^) Do
	Begin
		DOS.GetTime(Hour, Min, Sec, Sec100);
		{Log.BugMsg('TaskBar', 'OnClockTimer', D.St2(Hour)+':'+
			D.St2(Min)+':'+D.St2(Sec)+'.'+D.St2(Sec100));}
		If ClockDigital Then
		Begin
			If ClockShowSeconds
				Then TempStr:=D.St2(Hour)+':'+D.St2(Min)+':'+D.St2(Sec)
				Else TempStr:=D.St2(Hour)+':'+D.St2(Min);
			If DblHeight Then TempStr:=TempStr+#13+DateStr;
			If TempStr<>Ctl.Label_GetCaption(LabClock) Then
				Ctl.Label_SetCaption(LabClock, TempStr)
		End;
		If ClockAnalog Then
			Ctl2.AnClock_SetTime(ClkTime, Hour, Min, Sec)
	End
End;


Procedure DeactivateActive(Me:PProg);
Var
	Cur,Found:Integer;
Begin
	With Me^,TTaskBarData(Data^) Do
	Begin
		Found:=0;
		For Cur:=1 To BtnNum Do
			If Btn[Cur].Down Then
				Found:=Cur;
		If Found<>0 Then
		Begin
			Btn[Found].Button^.AutoRedraw:=True;
			Ctl.Button_SetDown(Btn[Found].Button, False);
			Btn[Found].Down:=False
		End;
	End
End;

Procedure ActivateBtn(Me:PProg;Index:Integer;Redraw:Boolean);
Begin
	With Me^,TTaskBarData(Data^) Do
	Begin
		Btn[Index].Down:=True;
		Btn[Index].Button^.AutoRedraw:=Redraw;
		Ctl.Button_SetDown(Btn[Index].Button, True)
	End
End;

Procedure TaskBar_TaskBtnClick(Me:PProg; Control:PControl);
Var
	Cur, Found: Integer;
begin
	With Me^, ClientRect, TTaskBarData(Data^) Do
	Begin
		Found:=0;
		For Cur:=1 To BtnNum Do
			If Btn[Cur].Button=Control Then
				Found:=Cur;
		If Found=0 Then Exit; { empty space on taskbar was clicked }
		If Not Btn[Found].Down Then
		Begin { activate another window }
			DeactivateActive(Me);
			If Not Btn[Found].Prog^.Visible Then
			Begin
				Gfx.ZoomRect(Btn[Found].Button^.Place, Btn[Found].Prog^.WinRect);
				Kernel.ToFrontWindow(Btn[Found].Prog, True)
			End
			Else
				Kernel.ToFrontWindow(Btn[Found].Prog, False);
			If Btn[Found].Prog^.Child<>Nil Then
				Kernel.ToFrontWindowChilds(Btn[Found].Prog);
			ActivateBtn(Me, Found, True)
		End
		Else Begin { minimize current window }
				{ if only it has no childs }
			If Btn[Found].Prog^.Child=Nil Then
				Kernel.MinimizeWindow(Btn[Found].Prog)
		End;
	End;
	{Kernel.PaintWindow(Me)}
End;



Function TaskBar_OpenWinEvent(Me:PProg;Params:Pointer):Boolean;
Var
	Cur,Found:Integer;
Begin
	(* If TProg(Params^).Parent<>Nil Then
		Exit; {  㢠  i  ii i } *)
	If Kernel.IgnoreAutoRedraw Then Exit;
	With TTaskBarData(Me^.Data^) Do
	Begin
		DeactivateActive(Me);
		If (TProg(Params^).WinKind=wkNormal) And TProg(Params^).CanBeActive Then
		Begin
			Inc(BtnNum);
			Btn[BtnNum].Prog:=Params;
			Btn[BtnNum].Button:=Ctl.Button_Create(Me,
				String(TProg(Params^).WinTitle^), TProg(Params^).Icon,
				PicturePos, TaskBar_TaskBtnClick);
			D.ReassignPStr(String(TProg(Params^).WinTitle^),
				Btn[BtnNum].Button^.Hint);
			{Kernel.RefreshCanDrawFlags(Me);}
				{ taskbar -  ⨢ i,  - ,  ! }
			Btn[BtnNum].Button^.CanDraw:=True;
			ActivateBtn(Me,BtnNum,False);
			Me^.ActiveCtl:=Nil
		End;
		Kernel.PaintWindow(Me)
	End;
	TaskBar_OpenWinEvent:=False;
End;

Function TaskBar_CloseWinEvent(Me:PProg;Params:Pointer):Boolean;
Var
	V,Found:Integer;
Begin
	If Kernel.IgnoreAutoRedraw Then Exit;
	If TProg(Params^).Parent<>Nil Then
		Exit; { ii,  ਡ ii i }
	With TTaskBarData(Me^.Data^) Do
	Begin
		Found:=0;
		For V:=1 To BtnNum Do
			If Btn[V].Prog=Params Then
				Found:=V;
		If Found<>0 Then
		Begin
			Kernel.DestroyCtl(Me,Btn[Found].Button);
			For V:=Found+1 To BtnNum Do
				Btn[V-1]:=Btn[V];
			Dec(BtnNum)
		End;

		Found:=0;
		For V:=1 To BtnNum Do
			If Btn[V].Prog=Kernel.ActiveWin Then
				Found:=V;
		If Found<>0 Then
		Begin
			Btn[Found].Button^.AutoRedraw:=False;
			Ctl.Button_SetDown(Btn[Found].Button, True);
			Btn[Found].Down:=True
		End
	End;
	Kernel.PaintWindow(Me);
	TaskBar_CloseWinEvent:=False
End;

Function TaskBar_ActivateWinEvent(Me:PProg; Params:Pointer):Boolean;
Var
	V,Found:Integer;
	TempProg: PProg;
Begin
	If Kernel.IgnoreAutoRedraw Then Exit;
	With TTaskBarData(Me^.Data^) Do
	Begin
		DeactivateActive(Me);
		If Params=Nil Then Exit;
		Found:=0;
			{  i  i, ⨢.   i }
		TempProg:=PProg(Params);
		While TempProg^.Parent<>Nil Do
			TempProg:=TempProg^.Parent;
		{If TProg(Params^).Parent<>Nil
			Then TempProg:=TProg(Params^).Parent
			Else TempProg:=PProg(Params);}

		For V:=1 To BtnNum Do
			If Btn[V].Prog=TempProg Then
				Found:=V;
		If Found<>0 Then
			ActivateBtn(Me,Found,True)
	End;
	{Kernel.PaintWindow(Me)}
	TaskBar_ActivateWinEvent:=False
End;

Function TaskBar_MinimizeWinEvent(Me:PProg;Params:Pointer):Boolean;
Var
	V, Found: Integer;
Begin
	If Kernel.IgnoreAutoRedraw Then Exit;
	With TTaskBarData(Me^.Data^) Do
	Begin
		Found:=0;
		For V:=1 To BtnNum Do
			If Btn[V].Prog=Params Then
				Found:=V;
		If Found<>0 Then
			Gfx.ZoomRect(TProg(Params^).WinRect,Btn[Found].Button^.Place)
	End;
	{Kernel.PaintWindow(Me)}
	TaskBar_MinimizeWinEvent:=False
End;


Function TaskBar_KeyPressEvent(Me:PProg; Params:Pointer): Boolean;
Var
	Found: Integer;
	Recognized: Boolean;
	TempC1, TempC2: Char;
	TempKStatus: Word;

	Procedure FindPressedButton;
	Var
		V: Byte;
	Begin
		With TTaskBarData(Me^.Data^) Do
		Begin
			Found:=0;
			For V:=1 To BtnNum Do
				If Btn[V].Down Then
					Found:=V
		End
	End;
Begin
	Recognized:=False;
	With TTaskBarData(Me^.Data^) Do
	Begin
		TempC1:=TKey(Params^).C1;
		TempC2:=TKey(Params^).C2;
		TempKStatus:=TKey(Params^).KStatus;

			{ i i쪨 ⠭ ii (Shift, Ctrl, Alt)? }
		If (TempC1=#0) And (TempC2=#0) Then
		Begin
				{   ii ४祭? }
			If (TKey(Params^).KStatus And LangMask)=LangMask Then
				SwitchComboPressed:=True;

				{     ""? }
			If (TKey(Params^).KStatus And MaskFilter)>LangMask Then
				SwitchComboPressed:=False;

				{ i i i饭i;  㫠 ii ४祭? }
			If ((TKey(Params^).KStatus And MaskFilter)=0) And
				SwitchComboPressed Then
			Begin
				SwitchComboPressed:=False;
				D.Cycle(Kernel.CurLayout, 0, Kernel.LayoutNum+1);
				If LangSign<>lsNone Then
					DrawLangSign(Me)
			End;

			TaskBar_KeyPressEvent:=True;
			Exit
		End;

		SwitchComboPressed:=False;

		If (TempC1=#0) And (TempC2=#110) Then
		Begin { Alt+F7 - prev task }
			FindPressedButton;
			If Found<>0 Then
			Begin
				Dec(Found);
				If Found=0 Then Found:=BtnNum;
				If Not Btn[Found].Prog^.Visible Then
				Begin
					Gfx.ZoomRect(Btn[Found].Button^.Place,Btn[Found].Prog^.WinRect);
					Kernel.ToFrontWindow(Btn[Found].Prog, True)
				End
				Else
					Kernel.ToFrontWindow(Btn[Found].Prog, False);
				If Btn[Found].Prog^.Child<>Nil Then
					Kernel.ToFrontWindowChilds(Btn[Found].Prog);
			End;
			Recognized:=True
		End;
		If (TempC1=#0) And (TempC2=#111) Then
		Begin { Alt+F8 - next task }
			FindPressedButton;
			If Found<>0 Then
			Begin
				Inc(Found);
				If Found>BtnNum Then Found:=1;
				If Not Btn[Found].Prog^.Visible Then
				Begin
					Gfx.ZoomRect(Btn[Found].Button^.Place,Btn[Found].Prog^.WinRect);
					Kernel.ToFrontWindow(Btn[Found].Prog, True)
				End
				Else
					Kernel.ToFrontWindow(Btn[Found].Prog, False);
				If Btn[Found].Prog^.Child<>Nil Then
					Kernel.ToFrontWindowChilds(Btn[Found].Prog);
			End;
			Recognized:=True
		End;

		If (TempC1=#0) And (TempC2=#130) Then
		Begin { Alt+'-' - minimize }
			FindPressedButton;
			If Found<>0 Then
				If wbMin In Btn[Found].Prog^.WinButtons Then
					Kernel.MinimizeWindow(Btn[Found].Prog);
			Recognized:=True
		End;
		If (TempC1=#0) And (TempC2=#131) Then
		Begin { Alt+'+' - maximize }
			FindPressedButton;
			If Found<>0 Then
				If wbMax In Btn[Found].Prog^.WinButtons Then
					Kernel.MaximizeWindow(Btn[Found].Prog);
			Recognized:=True
		End;
		If (TempC1=#0) And (TempC2=#112) Then
		Begin { Alt+F9 - open menu }
			With BtnStart^.Place Do
				Kernel.DesktopPopupPlus(X1, Y2+1);
			Recognized:=True
		End;
		If (TempC1=#0) And (TempC2=#108) Then
		Begin { Alt+F5 - close }
			FindPressedButton;
			If Found<>0 Then
				If wbClose In Btn[Found].Prog^.WinButtons Then
					Kernel.CloseProg(Btn[Found].Prog);
			Recognized:=True
		End;

	End;
	TaskBar_KeyPressEvent:=Recognized
End;

Function TaskBar_RenameWinEvent(Me:PProg; Params:Pointer): Boolean;
Var
	V: Integer;
Begin
	If Kernel.IgnoreAutoRedraw Then Exit;
	With TTaskBarData(Me^.Data^) Do
	Begin
		For V:=1 To BtnNum Do
			If Btn[V].Prog=Params Then
			Begin
				Btn[V].Button^.AutoRedraw:=True;
				Ctl.Button_SetCapAndPic(Btn[V].Button, String(Btn[V].Prog^.WinTitle^),
					Btn[V].Prog^.Icon);
				D.ReassignPStr(String(Btn[V].Prog^.WinTitle^), Btn[V].Button^.Hint)
			End;
	End;
	{Kernel.PaintWindow(Me)}
	TaskBar_RenameWinEvent:=False
End;



Procedure TaskBar_OnClose(Me:PProg);
Var
	I: Integer;
Begin
	Kernel.RemoveEventFunc(TaskBar_OpenWinEvent, Me);
	Kernel.RemoveEventFunc(TaskBar_CloseWinEvent, Me);
	Kernel.RemoveEventFunc(TaskBar_ActivateWinEvent, Me);
	Kernel.RemoveEventFunc(TaskBar_MinimizeWinEvent, Me);
	Kernel.RemoveEventFunc(TaskBar_KeyPressEvent, Me);
	Kernel.RemoveEventFunc(TaskBar_RenameWinEvent, Me);
	Kernel.FreeRes('i_polit.bmp');
	With TTaskBarData(Me^.Data^) Do
		If LangSign=lsFlag Then
			For I:=0 To Kernel.LayoutNum Do
				Kernel.FreeRes(Kernel.KeybLayoutName[I]+'.bmp');
	FreeMem(Me^.Data, SizeOf(TTaskBarData))
End;

Procedure TaskBar_StartClick(Me:PProg;Control:PControl);
Begin
	With Control^.Place Do
		Kernel.DesktopPopupPlus(X1, Y2+2)
End;

Procedure TaskBar_OnInit(Me:PProg);
Type
	TTaskBarPos=(tbTop, tbBottom);
Var
	Cur: PProg;
	I: Integer;
	Temp: TTaskBtn;
	TempStr, HintStr: String;
	Hour, Min, Sec, Sec100: Word;
	Year, Month, Day, WeekDay: Word;
	BarPos: String;
	PanelHeight: Integer;
Begin
	With Me^ Do
	Begin
		D.AssignPStr('TaskBar',WinTitle);
		MinX:=40;
		MinY:=26;
		OnPaint:=TaskBar_OnPaint;
		OnIdle:=Kernel.DummyProc;
		OnClose:=TaskBar_OnClose;
		GetMem(Data, SizeOf(TTaskBarData));

		Kernel.AddEventFunc('OpenWin', TaskBar_OpenWinEvent, Me);
		Kernel.AddEventFunc('CloseWin', TaskBar_CloseWinEvent, Me);
		Kernel.AddEventFunc('ActivateWin', TaskBar_ActivateWinEvent, Me);
		Kernel.AddEventFunc('MinimizeWin', TaskBar_MinimizeWinEvent, Me);
		Kernel.AddEventFunc('KeyPress', TaskBar_KeyPressEvent, Me);
		Kernel.AddEventFunc('RenameWin', TaskBar_RenameWinEvent, Me);

		With TTaskBarData(Data^) Do
		Begin
			Ini.Select('polit.ini', 'Taskbar');
			ButtonWidth:=Ini.GetInt('ButtonWidth', 120);
			ClockDigital:=Ini.GetBool('ClockDigital', True);
			ClockAnalog:=Ini.GetBool('ClockAnalog', True);
			ClockShowSeconds:=Ini.GetBool('ClockShowSeconds', True);

			LangSign:=lsName;
			TempStr:=Ini.GetStr('ShowLanguage', 'Name');
			If TempStr='NO' Then LangSign:=lsNone;
			If TempStr='FLAG' Then LangSign:=lsFlag;

			LangMask:=0;
			TempStr:=Ini.GetStr('SwitchLanguage', 'LEFTALT');
			If Pos('LEFTSHIFT', TempStr)>0 Then Inc(LangMask, ksLeftShift);
			If Pos('LEFTCTRL', TempStr)>0 Then Inc(LangMask, ksLeftCtrl);
			If Pos('LEFTALT', TempStr)>0 Then Inc(LangMask, ksLeftAlt);
			If Pos('RIGHTSHIFT', TempStr)>0 Then Inc(LangMask, ksRightShift);
			If Pos('RIGHTCTRL', TempStr)>0 Then Inc(LangMask, ksRightCtrl);
			If Pos('RIGHTALT', TempStr)>0 Then Inc(LangMask, ksRightAlt);
			SwitchComboPressed:=False;

			If Ini.GetStr('ButtonWidthMode', 'Fixed')='FIXED'
				Then ButtonWidthMode:=bwFixed
				Else ButtonWidthMode:=bwVariable;
			CenterButtons:=Ini.GetBool('Centered', False);
			BarPos:=Ini.GetStr('Position', 'TOP');
			If Ini.GetStr('Height', 'NORMAL')='NORMAL' Then
			Begin
				PicturePos:=ppLeft;
				PanelHeight:=21;
				DblHeight:=False
			End
			Else Begin
				PicturePos:=ppTop;
				PanelHeight:=36;
				DblHeight:=True
			End;
			BarTransparent:=Ini.GetBool('Transparent', False);
			If BarTransparent
				Then Decrement:=1
				Else Decrement:=0;
			Case BarTransparent Of
				False: If BarPos='BOTTOM'
					Then Kernel.InitPanelWindow(Me, 'LowerPan', brBottom, [], PanelHeight)
					Else Kernel.InitPanelWindow(Me, 'UpperPan', brTop, [], PanelHeight);
				True: If BarPos='BOTTOM'
					Then Kernel.InitPanelWindow(Me, 'EmptyWin', brBottom, [], PanelHeight)
					Else Kernel.InitPanelWindow(Me, 'EmptyWin', brTop, [], PanelHeight)
			End;
			WinBG:=bgManualDark;
			Kernel.DrawWindow(Me);

				{ Here Polit crashes: }
			PicPolit:=Kernel.LoadBMPRes('pic\i_polit.bmp');

			BtnStart:=Ctl.Button_Create(Me, '',
				PicPolit, PicturePos, TaskBar_StartClick);
			D.ReassignPStr('i  ', BtnStart^.Hint);
			If BarPos='BOTTOM'
				Then Ctl.Button_SetMarkStyle(BtnStart, bmMenuUp)
				Else Ctl.Button_SetMarkStyle(BtnStart, bmMenuDown);

			If ClockDigital Or ClockAnalog Then
			Begin
				DOS.GetDate(Year, Month, Day, WeekDay);
				DateStr:=DayNameShort[WeekDay]+' '+D.St2(Day)+'.'+D.St2(Month);
				HintStr:=DayName[WeekDay]+', '+D.St2(Day)+'.'+D.St2(Month)+'.'+
					D.St(Year);
				DOS.GetTime(Hour, Min, Sec, Sec100);
				If ClockDigital Then
				Begin
					If ClockShowSeconds
						Then TempStr:=D.St2(Hour)+':'+D.St2(Min)+':'+D.St2(Sec)
						Else TempStr:=D.St2(Hour)+':'+D.St2(Min);
					If DblHeight Then TempStr:=TempStr+#13+DateStr;
					LabClock:=Ctl.Label_Create(Me, TempStr, Nil, lsBeveled, alCenter);
					D.ReassignPStr(HintStr, LabClock^.Hint)
				End;
				If ClockAnalog Then
				Begin
					ClkTime:=Ctl2.AnClock_Create(Me, Hour, Min, Sec,
						ClockShowSeconds);
					D.ReassignPStr(HintStr, ClkTime^.Hint)
				End;
				If LangSign<>lsNone Then
					CanLang:=Ctl.Canvas_Create(Me, False);
				TimClock:=Ctl.TimerCtl_Create(Me, 18, True, OnClockTimer)
			End;

				{ ⠦ i  }
			If LangSign=lsFlag Then
			Begin
				For I:=0 To Kernel.LayoutNum Do
				Begin
					TempStr:='prog\taskbar\'+Kernel.KeybLayoutName[I]+'.bmp';
					If D.FileExist(TempStr)
						Then PicLang[I]:=Kernel.LoadBMPRes(TempStr)
						Else PicLang[I]:=Nil
				End
			End;

				{     ࠧ ணࠬ }
			BtnNum:=0;
			Cur:=Kernel.FirstProg;
			While Cur<>Nil Do
			Begin
				If (Cur^.WinKind=wkNormal) And Cur^.CanBeActive Then
				Begin
					Inc(BtnNum);
					Btn[BtnNum].Prog:=Cur;
					Btn[BtnNum].Button:=Ctl.Button_Create(Me,
						String(TProg(Cur^).WinTitle^), TProg(Cur^).Icon,
						PicturePos, TaskBar_TaskBtnClick);
					Btn[BtnNum].Button^.AutoRedraw:=False;
					D.ReassignPStr(String(TProg(Cur^).WinTitle^),
						Btn[BtnNum].Button^.Hint);
					Btn[BtnNum].Down:=False
				End;
				Cur:=Cur^.Next
			End;
			For I:=1 To BtnNum Div 2 Do
			Begin
				Temp:=Btn[I];
				Btn[I]:=Btn[BtnNum-I+1];
				Btn[BtnNum-I+1]:=Temp
			End
		End;
		ActiveCtl:=Nil
	End;
End;


Begin
	Kernel.RegBuiltIn('TaskBar', '', '', TaskBar_OnInit)
End.