{$F+}
Unit
	TaskMan2; { Polit Halcyon windows z-index viewer }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Log, Popup;

Type
	TTaskManData=Record
		LstIndexes: PControl;
		Pic2nd, PicToFront:Pointer;
		PicApp, PicDialog, PicPanL, PicPanU, PicPanD: Pointer;
		BtnClose, Btn2nd, BtnToFront: PControl;
		TimTicker, Lab1, LabMem: PControl;
		MnuActions: PMenuItem;
	End;

Implementation

Procedure TaskMan_OnPaint(Me:PProg);
Var
	I,Temp:Integer;
Begin
	With Me^,ClientRect,TTaskManData(Data^) Do
	Begin
		Ctl.Button_Paint(BtnClose, 5, 5, 55);
		Ctl.Button_Paint(Btn2nd, 60, 5, 110);
		Ctl.Button_Paint(BtnToFront, 115, 5, 165);
		Ctl2.ListBox_Paint(LstIndexes, 5, 48, X2-X1-5, Y2-Y1-30);
		Ctl.Label_Paint(Lab1, 5, Y2-Y1-25, 90);
		Ctl.Label_Paint(LabMem, 100, Y2-Y1-25, X2-X1-5);

	End
End;


{Procedure TaskMan_OnListBoxHint(Me:PProg;Control:PControl;Item:PListItem);
Begin
	If Item<>Nil
		Then D.ReassignPStr(String(Item^.Name^), Control^.Hint)
		Else D.ReassignPStr('', Control^.Hint)
End;}

Procedure TaskMan_OnContextMenuClick(Me:PProg; Item:PMenuItem);
Var
	SelItem:PListItem;
	ProgName:String;
Begin
	With Me^,TTaskManData(Data^) Do
	Begin
		SelItem:=Ctl2.ListBox_GetSelItem(LstIndexes);
		If SelItem<>Nil Then
		Begin
			ProgName:=String(SelItem^.Name^);
			If String(Item^.Name^)='' Then
				Kernel.CloseProg(Kernel.FindProg(ProgName));
			If String(Item^.Name^)='  i' Then
				Kernel.RunBuiltIn(ProgName,'');
			If String(Item^.Name^)=' ।i ' Then
				Kernel.ToFrontWindow(Kernel.FindProg(ProgName), True)
		End
	End
End;

Procedure TaskMan_OnListBoxMenu(Me:PProg;Control:PControl);
Var
	SelItem:PListItem;
	ProgName:String;
Begin
	With Me^,TTaskManData(Data^) Do
		Popup.OpenMenu(Me, MnuActions, Kernel.MsX, Kernel.MsY)
End;

Procedure TaskMan_OnListBoxSelect(Me:PProg; Control:PControl);
Begin
	With Me^, TTaskManData(Data^) Do
		If Not BtnClose^.Enabled Then
		Begin
			BtnClose^.Enabled:=True;
			Btn2nd^.Enabled:=True;
			BtnToFront^.Enabled:=True;

			{Kernel.PaintWindow(Me)}
			Ctl.Button_Draw(BtnClose);
			Ctl.Button_Draw(Btn2nd);
			Ctl.Button_Draw(BtnToFront);
		End
End;

Procedure TaskMan_OnButtonClick(Me:PProg; Control:PControl);
Var
	SelItem: PListItem;
	SelProgName: String;
	SelProg: PProg;
Begin
	With Me^,TTaskManData(Data^) Do
	Begin
		SelItem:=Ctl2.ListBox_GetSelItem(LstIndexes);
		If SelItem=Nil Then Exit;
		SelProgName:=String(SelItem^.Name^);
		SelProg:=Kernel.FindProg(SelProgName);
		If Control=BtnClose
			Then Kernel.CloseProg(SelProg)
			Else Begin {   ਫ 鮩 ᠬ TaskMan ? }
				If Control=Btn2nd Then Kernel.RunBuiltIn(SelProgName, '');
				If Control=BtnToFront Then Kernel.ToFrontWindow(SelProg, True);

				Kernel.SelectFocusCtl(Me, LstIndexes)
			End
	End
End;



Function TaskMan_Event(Me:PProg; Params:Pointer): Boolean;
Var
	Cur:PProg;
	TempIcon: Pointer;
	CurItem: PListItem;
	CurItemName: String;
Begin
	With Me^, TTaskManData(Data^) Do
	Begin
		CurItem:=Ctl2.ListBox_GetSelItem(LstIndexes);
		If CurItem=Nil
			Then CurItemName:=''
			Else CurItemName:=String(CurItem^.Name^);

		Ctl2.ListBox_Clear(LstIndexes);
		Cur:=Kernel.FirstProg;
		While Cur<>Nil Do
		Begin
			Ctl2.ListBox_AddItemLast(LstIndexes, String(Cur^.Name^), Cur^.Icon, 0);
			Ctl2.ListBox_AddSubItem(LstIndexes, 'Z='+D.St(Cur^.ZIndex), Nil);
			Case Cur^.WinKind Of
				wkNormal: TempIcon:=PicApp;
				wkPanel: Case Cur^.WinBorder Of
					brTop: TempIcon:=PicPanU;
					brBottom: TempIcon:=PicPanD;
					brLeft: TempIcon:=PicPanL;
				End
			End;
			If Cur^.Parent<>Nil Then
				TempIcon:=PicDialog;
			Ctl2.ListBox_AddSubItem(LstIndexes, '', TempIcon);
			Ctl2.ListBox_AddSubItem(LstIndexes, D.NormNum(D.StL(Cur^.Memory)), Nil);
			Ctl2.ListBox_AddSubItem(LstIndexes,
				D.CloneChar('|', D.Max(Round(Cur^.Memory/4096), 1)), Nil);

			Cur:=Cur^.Next
		End;
		{BtnClose^.Enabled:=False;
		Btn2nd^.Enabled:=False;
		BtnToFront^.Enabled:=False;
		Kernel.PaintWindow(Me);}

		If CurItemName=''
			Then Ctl2.ListBox_SelectItem(LstIndexes, 0)
			Else Ctl2.ListBox_SelectItem(LstIndexes,
				Ctl2.ListBox_FindItem(LstIndexes, CurItemName));
		Ctl2.ListBox_Draw(LstIndexes);

		If (CurItemName='') And BtnClose^.Enabled Then
		Begin
			BtnClose^.Enabled:=False;
			Btn2nd^.Enabled:=False;
			BtnToFront^.Enabled:=False;
			Ctl.Button_Draw(BtnClose);
			Ctl.Button_Draw(Btn2nd);
			Ctl.Button_Draw(BtnToFront)
		End
	End;
	TaskMan_Event:=False
End;

Procedure OnTimerTick(Me:PProg; Control:PControl; Times:Integer);
Begin
	With Me^, TTaskManData(Data^) Do
		Ctl.Label_SetCaption(LabMem, D.NormNum(D.StL(MemAvail{ Div 1024})){+' K'})
End;




Procedure TaskMan_OnClose(Me:PProg);
Begin
	Kernel.RemoveEventFunc(TaskMan_Event, Me);
	Kernel.RemoveEventFunc(TaskMan_Event, Me);
	Kernel.RemoveEventFunc(TaskMan_Event, Me);
	Kernel.RemoveEventFunc(TaskMan_Event, Me);
	Kernel.RemoveEventFunc(TaskMan_Event, Me);
	Kernel.FreeRes('b_2ndwin.bmp');
	Kernel.FreeRes('b_upw.bmp');
	Kernel.FreeRes('i_app.bmp');
	Kernel.FreeRes('p_dialog.bmp');
	Kernel.FreeRes('p_pan_u.bmp');
	Kernel.FreeRes('p_pan_d.bmp');
	Kernel.FreeRes('p_pan_l.bmp');
	FreeMem(Me^.Data,SizeOf(TTaskManData))
End;



Procedure TaskMan_OnInit(Me:PProg);
Begin
	With Me^ Do
	Begin
		D.AssignPStr(' '+String(Param^),WinTitle);
		MinX:=171;
		MinY:=140;
		OnPaint:=TaskMan_OnPaint;
		OnClose:=TaskMan_OnClose;
		GetMem(Data,SizeOf(TTaskManData));
		Kernel.InitWindow(Me,'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		Kernel.AddEventFunc('OpenWin', TaskMan_Event, Me);
		Kernel.AddEventFunc('OpenChildWin', TaskMan_Event, Me);
		Kernel.AddEventFunc('CloseWin', TaskMan_Event, Me);
		Kernel.AddEventFunc('ActivateWin', TaskMan_Event, Me);
		Kernel.AddEventFunc('MinimizeWin', TaskMan_Event, Me);

		With TTaskManData(Data^) Do
		Begin
			Pic2nd:=Kernel.LoadBMPRes('pic\b_2ndwin.bmp');
			PicToFront:=Kernel.LoadBMPRes('pic\b_upw.bmp');
			PicApp:=Kernel.LoadBMPRes('pic\i_app.bmp');
			PicDialog:=Kernel.LoadBMPRes('pic\p_dialog.bmp');
			PicPanU:=Kernel.LoadBMPRes('pic\p_pan_u.bmp');
			PicPanD:=Kernel.LoadBMPRes('pic\p_pan_d.bmp');
			PicPanL:=Kernel.LoadBMPRes('pic\p_pan_l.bmp');
			Log.BugMsg('TaskMan', 'OnInit', 'Pictures loaded');

			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppTop, TaskMan_OnButtonClick);
			BtnClose^.Enabled:=False;
			BtnClose^.FocusCtl:=Nil;
			Btn2nd:=Ctl.Button_Create(Me, 'i', Pic2nd,
				ppTop, TaskMan_OnButtonClick);
			Btn2nd^.Enabled:=False;
			Btn2nd^.FocusCtl:=Nil;
			BtnToFront:=Ctl.Button_Create(Me, '।', PicToFront,
				ppTop, TaskMan_OnButtonClick);
			BtnToFront^.Enabled:=False;
			BtnToFront^.FocusCtl:=Nil;
			Log.BugMsg('TaskMan', 'OnInit', 'Buttons created');

			LstIndexes:=Ctl2.ListBox_Create(Me, False);
			Ctl2.ListBox_SetOnSelect(LstIndexes, TaskMan_OnListBoxSelect);
			Ctl2.ListBox_SetOnContextMenu(LstIndexes, TaskMan_OnListBoxMenu);
			{Ctl.ListBox_AddItemFirst(LstIndexes,'starting...', Nil);}
			Ctl2.ListBox_SetColumnProps(LstIndexes, 4, lcRightMono, True);
			LstIndexes^.AutoRedraw:=False;
			Log.BugMsg('TaskMan', 'OnInit', 'List created');

			TimTicker:=Ctl.TimerCtl_Create(Me, 2, True, OnTimerTick);
			Lab1:=Ctl.Label_Create(Me, 'i쭠 '':', Nil, lsNormal, alRight);
			LabMem:=Ctl.Label_Create(Me, '', Nil, lsBeveled, alRight);
			Log.BugMsg('TaskMan', 'OnInit', 'Timer&label created');

			ActiveCtl:=LstIndexes;
			ButtonEnter:=BtnClose;

			MnuActions:=Popup.CreateMenu;
			Popup.AddCommand(MnuActions, '', '', '',
				PicClose, True, TaskMan_OnContextMenuClick);
			Popup.AddCommand(MnuActions, '  i', '', '',
				Pic2nd, True, TaskMan_OnContextMenuClick);
			Popup.AddCommand(MnuActions, ' ।i ', '', '',
				PicToFront, True, TaskMan_OnContextMenuClick);
			Log.BugMsg('TaskMan', 'OnInit', 'Popup created, that''s all');
		End
	End
End;


Begin
	Kernel.RegBuiltIn('TaskMan', ' ', 'pic\i_tskman.bmp', TaskMan_OnInit)
End.