{$F+}
Unit
	TestKeys; { Polit Halcyon TestKeys application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2;

Type
	TTestKeysData=Record
		LabStatus: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTestKeysData(Data^) Do
	Begin
		Ctl.Label_Paint(LabStatus, 10, 10, X2-X1-10);
	End;
End;


Function KeyPressEvent(Me:PProg; Params:Pointer): Boolean;
Var
	TempStr: String;
Begin
	With TTestKeysData(Me^.Data^) Do
	Begin
		If (TKey(Params^).C1=#0) And (TKey(Params^).C2=#0) Then
		Begin { modifier key pressed! }
			TempStr:='';
			If (TKey(Params^).KStatus And ksRightShift)<>0 Then
				TempStr:=TempStr+'RightShift ';
			If (TKey(Params^).KStatus And ksLeftShift)<>0 Then
				TempStr:=TempStr+'LeftShift ';
			If (TKey(Params^).KStatus And ksCtrl)<>0 Then
				TempStr:=TempStr+'Ctrl ';
			If (TKey(Params^).KStatus And ksAlt)<>0 Then
				TempStr:=TempStr+'Alt ';

		End;
		Ctl.Label_SetCaption(LabStatus, ' '+TempStr)
	End
End;


Procedure OnClose(Me:PProg);
Begin
	Kernel.RemoveEventFunc(KeyPressEvent, Me);
	FreeMem(Me^.Data, SizeOf(TTestKeysData))
End;

Procedure OnInit(Me:PProg);
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr(' KeyPress', WinTitle);
		MinX:=210;
		MinY:=120;
		GetMem(Data, SizeOf(TTestKeysData));
		Kernel.InitWindow(Me, 'BlueDlg', [wbHelp, wbClose]);
		Kernel.DrawWindowAni(Me);

		Kernel.AddEventFunc('KeyPress', KeyPressEvent, Me);
		With TTestKeysData(Data^) Do
		Begin
			LabStatus:=Ctl.Label_Create(Me, '', Nil, lsBeveled, alCenter)

		End
	End
End;



Begin
	Kernel.RegBuiltIn('TestKeys', 'TestKeys', 'pic\i_app.bmp', OnInit)
End.
