{$F+}
Unit
	TimSetup; { Polit Halcyon TimSetup application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Gfx, Popup;

Const
	MonthName: Array[1..12] Of String[21]=
		('i祭 (1)', '⨩ (2)', '१ (3)', 'i⥭ (4)',
		'ࠢ (5)', 'ࢥ (6)', ' (7)', '௥ (8)',
		'ᥭ (9)', '⥭ (10)', '⮯ (11)', '㤥 (12)');

Type
	TTimSetupData=Record
		NbkPages: PControl;
		LabYear, SedYear, LabMonth, PbtMonth, MclDate: PControl;
		LabHour, SedHour, LabMin, SedMin, ClkTime: PControl;
		BtnAccept, BtnClose: PControl;
		PicDate, PicTime: Pointer;
		MnuMonth: PMenuItem;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTimSetupData(Data^) Do
	Begin
		Kernel.WinBGBar(Me, X1, Y1, X2, Y1+4);
		Kernel.WinBGBar(Me, X1, Y1+5, X1+4, Y2-35);
		Kernel.WinBGBar(Me, X2-4, Y1+5, X2, Y2-35);
		Kernel.WinBGBar(Me, X1, Y2-34, X2, Y2);
		Kernel.WindowBar(X1+5, Y1+5+22, X2-5, Y2-35, False, False);

		Ctl.Notebook_Paint(NbkPages, 5, 5, X2-X1-5, Y2-Y1-35);
			{ i 1 -  }
		Ctl.Label_Paint(LabYear, 20, 40, 60);
		Ctl.SpinEdit_Paint(SedYear, 70, 40, X2-X1-70);
		Ctl.Label_Paint(LabMonth, 20, 70, 60);
		Ctl.PopupBtn_Paint(PbtMonth, 70, 70, X2-X1-20);
		Ctl2.MonthCal_Paint(MclDate, 50, 105);
			{ i 2 -  }
		Ctl.Label_Paint(LabHour, 20, 40, 90);
		Ctl.SpinEdit_Paint(SedHour, 100, 40, X2-X1-50);
		Ctl.Label_Paint(LabMin, 20, 70, 90);
		Ctl.SpinEdit_Paint(SedMin, 100, 70, X2-X1-50);
		Ctl2.AnClock_Paint(ClkTime, 50, 105, X2-X1-56);
		{Ctl2.AnClock_Paint(ClkTime, 10, 10, 31);}

		Ctl.Button_Paint(BtnAccept, X2-X1-215, Y2-Y1-26, X2-X1-115);
		Ctl.Button_Paint(BtnClose, X2-X1-105, Y2-Y1-26, X2-X1-5);
	End;
End;


Procedure OnYearMonthChange(Me:PProg; Control:PControl);
Var
	Year, Month, Day, I: Word;
	TempStr: String;
Begin
	With Me^, TTimSetupData(Data^) Do
	Begin
		Ctl2.MonthCal_GetDate(MclDate, Year, Month, Day);
		TempStr:=Ctl.Button_GetCaption(Ctl.PopupBtn_AsButton(PbtMonth));
		For I:=1 To 12 Do
			If MonthName[I]=TempStr Then
				Month:=I;
		Ctl2.MonthCal_SetDate(MclDate, Ctl.SpinEdit_GetValue(SedYear),
			Month, Day)
	End
End;

Procedure OnHourMinChange(Me:PProg; Control:PControl);
Var
	Hour, Min, Sec: Integer;
	TempStr: String;
Begin
	With Me^, TTimSetupData(Data^) Do
	Begin
		Ctl2.AnClock_GetTime(ClkTime, Hour, Min, Sec);
		Ctl2.AnClock_SetTime(ClkTime, Ctl.SpinEdit_GetValue(SedHour),
			Ctl.SpinEdit_GetValue(SedMin), Sec)
	End
End;


Procedure OnMonthMenuClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TTimSetupData(Data^) Do
	Begin
		Button_SetCaption(PopupBtn_AsButton(PbtMonth),
			String(Item^.Name^));
		OnYearMonthChange(Me, PbtMonth)
	End
End;



Procedure OnAcceptClick(Me:PProg; Control:PControl);
Var
	Year, Month, Day: Word;
	Hour, Min, Sec, Sec100: Integer;
   HourW, MinW, SecW, Sec100W: Word;
Begin
	With Me^, TTimSetupData(Data^) Do
	Begin
		Log.BugMsg('TimSetup', 'OnAcceptClick', 'before='+D.StL(D.SysTimer));
		Ctl2.MonthCal_GetDate(MclDate, Year, Month, Day);
		DOS.SetDate(Year, Month, Day);
		Ctl2.AnClock_GetTime(ClkTime, Hour, Min, Sec);
		DOS.SetTime(Hour, Min, 1, 0);
		Log.BugMsg('TimSetup', 'OnAcceptClick', ' after='+D.StL(D.SysTimer));
      DOS.GetTime(HourW, MinW, SecW, Sec100W);
      Log.BugMsg('TimSetup', 'OnAcceptClick', 'GetTime: '+D.St(HourW)+':'+
			D.St(MinW)+':'+D.St(SecW));
		Kernel.ResetTimers;
		Gfx.AllowZoomRect:=False;
		Kernel.CloseProg(Kernel.FindProg('TaskBar'));
		Kernel.RunBuiltIn('TaskBar', '');
		Gfx.AllowZoomRect:=True;

		Kernel.CloseProg(Me)
	End
End;

Procedure OnCloseClick(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;





Procedure OnClose(Me:PProg);
Var
	TempPtr: Pointer;
Begin
	With Me^, TTimSetupData(Data^) Do
	Begin
   	If Parent<>Nil Then
			TempPtr:=Kernel.SendMessage(Me, Parent, 'Settings:CloseSheet', Nil);
		Kernel.FreeRes('b_calend.bmp');
		Kernel.FreeRes('b_clock.bmp');
	End;
	FreeMem(Me^.Data, SizeOf(TTimSetupData))
End;


Procedure MakeMenus(Me:PProg);
Var
	I: Integer;
Begin
	With Me^, TTimSetupData(Data^) Do
	Begin
		MnuMonth:=Popup.CreateMenu;
		Popup.AddCommand(MnuMonth, MonthName[1], '', '',
			Nil, True, OnMonthMenuClick);
		For I:=2 To 12 Do
			Popup.AddCommand(MnuMonth, MonthName[I], '', '', Nil, True, OnMonthMenuClick)
	End
End;


Procedure OnInit(Me:PProg);
Var
	Year, Month, Day, WeekDay: Word;
	Hour, Min, Sec, Sec100: Word;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr(' i : ன', WinTitle);
		MinX:=221;
		MinY:=280;
		GetMem(Data, SizeOf(TTimSetupData));
		If Parent=Nil
			Then Kernel.InitWindow(Me, 'BlueDlg', [wbMin, wbClose])
			Else Kernel.InitSheetWindow(Me, 'BlueDlg', [wbSlide], brLeft);
		WinBG:=bgManualDark;
		Kernel.DrawWindowAni(Me);

		With TTimSetupData(Data^) Do
		Begin
			PicDate:=Kernel.LoadBMPRes('pic\b_calend.bmp');
			PicTime:=Kernel.LoadBMPRes('pic\b_clock.bmp');
			MakeMenus(Me);
			DOS.GetDate(Year, Month, Day, WeekDay);
			DOS.GetTime(Hour, Min, Sec, Sec100);

			Sec:=42;
			NbkPages:=Ctl.Notebook_Create(Me, True);

			LabYear:=Ctl.Label_Create(Me, 'i:', Nil, lsNormal, alRight);
			SedYear:=Ctl.SpinEdit_Create(Me, 1900, 2027, 1, Year);
			Ctl.SpinEdit_SetOnChange(SedYear, OnYearMonthChange);
			LabYear^.FocusCtl:=SedYear;
			LabMonth:=Ctl.Label_Create(Me, 'i:', Nil, lsNormal, alRight);
			PbtMonth:=Ctl.PopupBtn_Create(Me, MonthName[Month], MnuMonth,
				Nil, ppLeft);
			LabMonth^.FocusCtl:=Ctl.PopupBtn_AsButton(PbtMonth);
			MclDate:=Ctl2.MonthCal_Create(Me, Year, Month, Day);
			Ctl.Notebook_AddPage(NbkPages, '', '', PicDate);

			LabHour:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
			SedHour:=Ctl.SpinEdit_Create(Me, 0, 23, 1, Hour);
			Ctl.SpinEdit_SetOnChange(SedHour, OnHourMinChange);
			LabHour^.FocusCtl:=SedHour;
			LabMin:=Ctl.Label_Create(Me, ':', Nil, lsNormal, alRight);
			SedMin:=Ctl.SpinEdit_Create(Me, 0, 59, 1, Min);
			Ctl.SpinEdit_SetOnChange(SedMin, OnHourMinChange);
			LabMin^.FocusCtl:=SedMin;
			ClkTime:=Ctl2.AnClock_Create(Me, Hour, Min, Sec, False);
			Ctl.Notebook_AddPage(NbkPages, '', '', PicTime);

			BtnAccept:=Ctl.Button_Create(Me, '਩', Kernel.PicOK,
				ppLeft, OnAcceptClick);
			D.ReassignPStr('⠭   i ', BtnAccept^.Hint);
			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseClick);

			ActiveCtl:=MclDate;
			ButtonEnter:=BtnAccept;
			ButtonEsc:=BtnClose
		End
	End
End;



Begin
	Kernel.RegBuiltIn('TimSetup', '', 'pic\i_timset.bmp', OnInit)
End.
