Unit
	Types; { Polit Halcyon Eva types unit }

Interface

Type
	TRect=Record
		X1, Y1, X2, Y2: Integer
	End;
	TMatrix=Array[0..65000] Of Byte;
	TMatrix2=Array[0..32000] Of Word;
	TPtrMatrix=Array[0..16000] Of Pointer;
	PStr=Pointer; { Pointer to string }
	PResData=Pointer; { Pointer to resource data }
	TBorder=(brLeft, brRight, brTop, brBottom);
	TAlign=(alLeft, alRight, alCenter);
	TColor=Byte;
	TFileOrFolder=(ffFile, ffFolder);

	PPtrList=^TPtrList;
	TPtrList=Record
		Data: Pointer;
		Next: PPtrList
	End;

	TBigImage=Record
		SmallWidth, SmallHeight: Word;
		Next: Pointer;
		BigWidth, BigHeight: Word;
		Data: Byte; { many bytes in fact :) }
	End;

	TMouseProc=Procedure(X,Y:Integer);
	TMouseProc2=Procedure(Var X,Y:Integer);
	TRectProc=Procedure(Var Rect:TRect);
	TOrientation=(orHorizontal, orVertical);
	TDriveType=(dtFixed, dtFloppy, dtCDROM, dtNone);
	TOperatingSystem=(osDOS, osWindows);
	TSkinPic=Array[Boolean, Boolean] Of Pointer;

	TRefreshNeededFunc=Function(Rect:TRect): Boolean;

	PControl=^TControl;
	TCtlClickProc=Procedure(Me:PControl; X,Y:Integer);
	TCtlRefocusProc=Procedure(Me:PControl; Focused:Boolean);
	TCtlProc=Procedure(Me:PControl);
	TCtlKeyFunc=Function(Me:PControl; Key,ExtKey:Char):Boolean;
	TCtlWheelProc=Procedure(Me:PControl; Delta:Integer);
		{ True - key received, False - continue analyse it }
	PProg=^TProg;
	TCtlHandler=Procedure(Me:PProg; Control:PControl);

	TControl=Record
		Place: TRect;
		Enabled, Visible, CanDraw: Boolean;
		AutoRedraw: Boolean;
		Hint: PStr;
		{HintPic: Pointer;   for future }
		FocusCtl: PControl;
		Owner: PProg;
		OwnerCtl: PControl;
		Data: Pointer; { all control data including user handler(s) }
							{ real format depends on control's kind }
		OnClick: TCtlClickProc;
		OnKey: TCtlKeyFunc;
		OnRefocus: TCtlRefocusProc;
		OnHint: TCtlProc;
		OnWheel: TCtlWheelProc;
		OnDestroy: TCtlProc;

		Next: PControl
	End;

	PWinLook=^TWinLook;
	TWinLookProc=Procedure(Prog:PProg);
	TWinLookClickProc=Procedure(Prog:PProg; X,Y:Integer);
	TWinButton=(wbMin, wbMax, wbClose, wbHelp, wbSlide, wbDetach);
	TWinButtonSet=Set Of TWinButton;
	TWinLook=Record
		Name: PStr;
		ClientDeltaRect: TRect;
		OnPrepare: TWinLookProc; { Init WinLook data in Prog record }
		OnDrawFrame: TWinLookProc;
		OnClick: TWinLookClickProc;
		OnRefreshButtons: TWinLookProc;
		OnDestroy: TWinLookProc; { Free WinLook data }
		Next: PWinLook
	End;


	TProcedure=Procedure;
	TProc=Procedure(Me:PProg);
	TMessageFunc=Function(Me,Sender:PProg; Msg:String;
		Data:Pointer): Pointer;
	TKeyFunc=Function(Me:PProg; C1,C2:Char): Boolean;
	TWindowKind=(wkNone, wkNormal, wkPanel, wkSheet); { will be more }
	TWindowBG=(bgDefault, bgDark, bgManual, bgManualDark);

	TProg=Record
		Name, WinTitle, Param: PStr;
		Icon: Pointer;
		WinRect, LastWinRect, ClientRect: TRect;
		WinLook: PWinLook;
		WinLookData: Pointer;
		WinButtons: TWinButtonSet;
		WinBG: TWindowBG;
		WinKind: TWindowKind;
		WinBorder: TBorder;
		MinX, MinY: Integer;
		ZIndex: Integer; { 1=bottom, max=top }
		Visible, CanBeActive: Boolean;
		Memory: LongInt; { for debug -  i i i :) }

		Data: Pointer; { user's program }
		FirstCtl, ActiveCtl: PControl;
		ButtonEnter, ButtonEsc, ButtonF1: PControl;
		Child, Parent: PProg;

		OnPaint: TProc;
		OnIdle: TProc;
		OnMessage: TMessageFunc;
		OnKey: TKeyFunc;
		OnClose: TProc;

		Next: PProg;
	End;

	PEvent=^TEvent;
	TEventFunc=Function(Me:PProg; Params:Pointer): Boolean; { true = finish scan }
	TEvent=Record
		Name: PStr;
		Func: TEventFunc;
		Owner: PProg;

		Next: PEvent
	End;

	PResource=^TResource;
	TResource=Record
		Name: String[12];
		Size: Word;
		Data: Pointer;
		UseCount: Integer;

		Next: PResource
	End;

	PBuiltIn=^TBuiltIn;
	TBuiltIn=Record
		Name, FriendlyName: PStr;
		OnInit: TProc;
		Icon: Pointer;

		Next: PBuiltIn
	End;

	PTimer=^TTimer;
	TTimerProc=Procedure(Me:PControl; Times:Integer);
	TTimer=Record
		Control: PControl;
		Proc: TTimerProc;
		Freq, Times: Integer;
		NextTime: LongInt;
		Next: PTimer
	End;

	{TProcsTable=Record
		AssignPStr: Procedure(S:String; Var P:Pointer);
		RunBuiltIn: Procedure(Name,Params:String);
		InitWindow: Procedure(Prog:PProg; WinLookName:String);
		DrawWindow: Procedure(Prog:PProg);
	End;}

	TScreenSaverProc=Procedure;
	PScreenSaver=^TScreenSaver;
	TScreenSaver=Record
		Name: PStr;
		OnInit, OnIdle: TScreenSaverProc;
		Next: PScreenSaver
	End;

	TRGB=Record
		R, G, B: Byte
	End;
	TPalette=Array[0..255] Of TRGB;

	PCursor=^TCursor;
	TCursor=Record
		Image: Pointer;
		SizeX, SizeY: Word;
		HotX, HotY: Word;
		Next: PCursor
	End;

	PWinPos=^TWinPos;
	TWinPos=Record
		Name: PStr;
		X1, Y1: Integer;
		SizeX, SizeY: Integer;
		Next: PWinPos
	End;
	TWinPosFileRec=Record
		Name: String[32];
		X1, Y1: Integer;
		SizeX, SizeY: Integer
	End;

	TKey=Record
		C1, C2: Char;
		KStatus: Word
	End;

Implementation Begin End.