{$F+}
Unit
	ViewPic; { Polit Halcyon ViewPic application }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx, LFN;

Type
	TViewPicData=Record
		PctImage, LabStat: PControl;
		PicImage: Pointer;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TViewPicData(Data^) Do
	Begin
		Ctl.PicCtl_Paint(PctImage, 0, 0);
		If Gfx.ImageX2(PicImage)<X2-X1 Then
			Kernel.WinBGBar(Me, X1+Gfx.ImageX2(PicImage), Y1, X2, Y2-21);
		{Ctl.Label_Paint(LabStat, 1, Y2-Y1-21, X2-X1-1);}
		Ctl.Label_Paint(LabStat, 0, Y2-Y1-20, X2-X1);
	End;
End;

Function OnKey(Me:PProg; Key,ExtKey:Char): Boolean;
Begin
	OnKey:=False;
	If Key=#27 Then
	Begin
		Kernel.CloseProg(Me);
		OnKey:=True
	End
End;

Procedure OnClose(Me:PProg);
Begin
	With Me^, TViewPicData(Data^) Do
		If PicImage<>Nil Then
			Gfx.FreeBigImage(PicImage);
	FreeMem(Me^.Data, SizeOf(TViewPicData))
End;

Procedure OnInit(Me:PProg);
Var
	AllOK: Boolean;
	StatText: String;
	TempParam, TempExt, TempBPP: String;
	WinX, WinY: Integer;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnKey:=OnKey;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		MinX:=120;
		MinY:=1;
		GetMem(Data, SizeOf(TViewPicData));
		With TViewPicData(Data^) Do
		Begin
			AllOK:=True;
			StatText:='';
			{LFN.LFNGetShortPath(False, String(Param^), TempParam);}
			TempParam:=String(Param^);
			If D.FileExist(TempParam) Then
			Begin
				TempExt:=D.UpCaseLine(D.ClipFExt(TempParam));
				Delete(TempExt, 1, 1);
				If (TempExt='BMP') Or (TempExt='GIF')
					Or (TempExt='JPG') Or (TempExt='JPE')
					{Or (TempExt='PCX')} Then
				Begin
					Pic.OnProgress:=Kernel.MouseWorkingNextFrame;
					Kernel.ShowMouseProc(Kernel.MsX, Kernel.MsY);
					Kernel.MouseWorkingSubframe:=Kernel.MouseWorkingDelay;
					If TempExt='BMP' Then
						Pic.IntLoadBMP(TempParam, '', True, PicImage);
					If TempExt='GIF' Then
						Pic.LoadGIF(TempParam, PicImage);
					If (TempExt='JPG') Or (TempExt='JPE') Then
						Pic.LoadJPG(TempParam, PicImage);
					{If TempExt='PCX' Then
						Pic.LoadPCX(TempParam, PicImage);}

					Pic.OnProgress:=D.Dummy;
					Kernel.HideMouseProc(Kernel.MsX, Kernel.MsY);
					Kernel.SelectCursor(Kernel.MouseDefault)
				End
				Else Begin
					AllOK:=False;
					StatText:='i ଠ'
				End
			End
			Else Begin
				AllOK:=False;
				StatText:='   :(.'
			End;

			If AllOK Then
			Begin
				D.AssignPStr(D.LastPathItem(String(Param^)), WinTitle);
				MinX:=Gfx.ImageX2(PicImage);
				MinY:=Gfx.ImageY2(PicImage){+23}+21;
				Case Pic.LastColorDepth Of
					1: TempBPP:='2 ';
					2: TempBPP:='4 ';
					3: TempBPP:='8 i';
					4: TempBPP:='16 i';
					5: TempBPP:='32 ';
					6: TempBPP:='64 ';
					7: TempBPP:='128 i';
					8: TempBPP:='256 i';
					24: TempBPP:='16  i';
					Else TempBPP:=''
				End;
				StatText:=TempExt+' '+D.St(MinX)+'x'+D.St(MinY)+', '+TempBPP
			End
			Else Begin
				{PicImage:=Nil;}
				Gfx.MakeEmptyImage(PicImage);
				D.AssignPStr('', WinTitle);
				MinX:=210;
				MinY:=23
			End;
			WinX:=MinX;
			WinY:=MinY;
			Kernel.InitWindow(Me, 'BlueDlg', [wbMin, wbClose]);
			WinBG:=bgManual;
			Kernel.AssignWinSize(Me, D.Max(WinX, 120), WinY);
			Kernel.DrawWindowAni(Me);
			PctImage:=Ctl.PicCtl_Create(Me, PicImage, False, False, False);
			LabStat:=Ctl.Label_Create(Me, StatText, Nil, lsBeveled, alLeft);
			ActiveCtl:=Nil
		End
	End
End;



Begin
	Kernel.RegBuiltIn('ViewPic', '', 'pic\i_vpic.bmp', OnInit)
End.
