{Wave Player v0.0 technical alpha}
{Written with SoundLib 2.0 use}
{By Andrew Kosovich}

{$F+}
Unit
	WavePlay; { Polit Halcyon WavePlay application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2,
          sndlib2,drv_sb,drv_sil,snd_fmt,ports,stream32;

Type
	TWavePlayData=Record
            { i i ணࠬ  ,  쮬 i }
  i         : integer;
  tc,bc     : byte;
  st        : string[39];

  sound     : psound;
  wav       : pwave;
  voc       : pvoc;
  wave      : psounddat;
  sb        : psoundblaster;
  silent    : psilent;
  driver    : psounddriver;
  vol       : word;
  pos,pos2  : longint;
  ch,lch    : char;
  {$IFNDEF FPC}
  s         : tfilestream32;
  {$ELSE}
  s         : tdosstream;
  {$ENDIF}
  speed     : {double}real;

  cap       : tcardinfo;
  intpol    : boolean;
  mute      : boolean;


  {WavePlay window controls:  }
  btnPlay, BtnPause, btnStop, btnOpen:PControl;
  prPlay:PControl;
  edFileName:PControl;
  trkVolume:PControl;
  {lblPlay,} lblWav:PControl;
  PctVolume: PControl;


  Playing:boolean;
  PlayPos:Integer;

  PicOpen, PicPlay, PicPause, PicStop, PicSpeaker: Pointer;
	End;

Implementation
Procedure InitDrv(Me:PProg);
begin

	With Me^, ClientRect, TWavePlayData(Data^) Do
	Begin

  { Initialize sound driver }
  new(sb,init(4096));
  if (sb = nil)or(not sb^.startplayback(0,snd_auto+snd_mixmanual)) then
  begin
    { Init silent driver WITH interrupt calls }
    new(silent,init(0,true));
    silent^.startplayback(0,snd_auto);
{    writeln('Soundblaster driver initialization failed, using silent driver');
	 writeln('You won''t hear any sound, you''ll just see the displayment');
    writeln;
    writeln('Press any key to continue...');
    readkey;}
    driver := silent;
  end
  else driver := sb;

  end;
end;

Procedure OpenWav(Me:Pprog);
begin

	With Me^, ClientRect, TWavePlayData(Data^) Do
	Begin
	  if Playing Then
		 Kernel.ClickCtl(Me, BtnStop);


  { Initialize sound object }
  new(sound,init(driver^,1));

  if not D.FileExist(InpLine_GetText(edFileName)) then
  begin
	 Label_SetCaption(lblWAV, '  ');
	 sound^.free;
	 driver^.free;
	 exit
  end;

  if not s.init(InpLine_GetText(edFileName) ,stopenread) then
  begin
	 Label_SetCaption(lblWAV, '  i 䠩');
	 sound^.free;
	 driver^.free;
	 exit
  end;

  new(wav,init(sound^,s));
  if (wav = nil) then
  begin
	 new(voc,init(sound^,s));
	 wave := voc;
  end else wave := wav;

  { If no supported file type found, exit }
  if (wave = nil) then
  begin
	 Label_SetCaption(lblWAV, '  ண 䠩.  ଠ  iਬ.');
	 {halt driver and wave}
	 wave^.free;
	 s.done;
	 sound^.free;
	 driver^.free;
	 exit
  end;

	 { Put out current playback information }
  driver^.getcapabilities(cap);
 { writexy(35,4,'Initialized "'+cap.cardstring+'" @');}
  if (driver^.data.flags and snd_stereo <> 0) then st := '८' else st := '';
  Label_SetCaption(lblWAV, Cap.CardString+' '+D.St(driver^.data.freq)+' , '+st);

  {Progress Init}

  Progress_SetParams(prPlay, 0, wave^.getsize div 1024, 0);

  vol:=Track_GetPos(trkVolume);
  Speed:=1;

  { Start playback }
  Playing:=True;
  Playpos:=0;
  wave^.play;
 end;
end;



Procedure OnBtnOpenPress(Me:PProg; Control:PControl);
Begin
	With Me^, ClientRect, TWavePlayData(Data^) Do
	Begin
		Kernel.RunChild2(Me, 'FileDlg', 'o *.wav')

	End;

end;

Procedure OnBtnPlayPress(Me:PProg; Control:PControl);
Begin
	With Me^, ClientRect, TWavePlayData(Data^) Do
	Begin
			 if not playing then
			 begin
			  initdrv(Me);
			  OpenWav(Me);


			 end;
	End;

end;



Procedure OnBtnPausePress(Me:PProg; Control:PControl);
Begin
	With Me^, ClientRect, TWavePlayData(Data^) Do
	Begin
					if playing then begin
						  wave^.pause;
						  if (wave^.ispaused) then
						  begin
						  end;

					end;
	End;

end;

Procedure OnBtnStopPress(Me:PProg; Control:PControl);
Begin
	With Me^, ClientRect, TWavePlayData(Data^) Do
	Begin
			if playing then
			begin
			  Progress_SetParams(prPlay, 0, wave^.getsize div 1024, 0);
			  playing:=false;
			  wave^.free;
			  s.done;
			  sound^.free;
			  driver^.free;
         end;

	End;

end;

Procedure OnTrkVolumeChange(Me:Pprog; Control:Pcontrol);
Begin
	With Me^, ClientRect, TWavePlayData(Data^) Do
	Begin


	 if Playing then begin
      vol:=Track_GetPos(trkVolume);
      sound^.setvolume(0,vol);
      sound^.setvolume(1,vol);


    end;
        end;
end;


Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TWavePlayData(Data^) Do
	Begin
			 {InpLine_Paint(edFileName, 8, 8, 366);

			 Button_Paint(btnOpen, 370, 8, 420);
			 Button_Paint(btnPlay, 8, 98, 108);
			 Button_Paint(btnPause, 112, 98, 212);
			 Button_Paint(btnStop, 216, 98, 316);

			 Label_Paint(lblPlay, 316, 38, 420);
			 Label_Paint(lblWAV, 8, 38, 316);

			 Progress_Paint(prPlay, 8, 68, 420);

			 Track_Paint(trkVolume, 320, 98, 420);}

			 Ctl.InpLine_Paint(edFileName, 10, 10, X2-X1-55);
			 Ctl.Button_Paint(btnOpen, X2-X1-45, 10, X2-X1-10);

			 Ctl.Label_Paint(lblWAV, 10, 40, X2-X1-10);
			 {Ctl.Label_Paint(lblPlay, 220, 40, X2-X1-10);}

			 Ctl.Progress_Paint(prPlay, 10, 70, X2-X1-10);

			 Ctl.Button_Paint(btnPlay, 10, 100, 55);
			 Ctl.Button_Paint(btnPause, 65, 100, 110);
			 Ctl.Button_Paint(btnStop, 120, 100, 145);
			 Ctl.PicCtl_Paint(PctVolume, 170, 100);
			 Ctl.Track_Paint(trkVolume, 190, 100, 240);
	End;
End;

Procedure OnIdle(Me:PProg);
Begin
	With Me^, TWavePlayData(Data^) Do
	Begin
  if Playing then  begin
    if (driver^.change) then driver^.mixdata;

      {Shob Progress ne peremalyovuvavsya chasto :-}
		if PlayPos<>wave^.getpos div 1024 then
		begin
			PlayPos:=wave^.getpos div 1024;
			Progress_SetValue(prPlay, Playpos);
      end;



  end;
{    if (sound^.change) then }


	End
End;

Function OnMessage(Me, Sender:PProg; Msg:String; MsgData:Pointer): Pointer;
Var
	TempName, TempPath: String;
Begin
	With Me^, TWavePlayData(Data^) Do
	Begin
		If Msg='OpenFile' Then
		Begin
			{LFN.LFNGetShortPath(False, String(MsgData^), TempName);}
			{Log.BugMsg('WavePlay', 'OnMessage', 'Param = '+String(MsgData^));}
			TempName:=String(MsgData^);
			If D.FileExist(TempName) Then
			Begin
				Inpline_SetText(edFileName, TempName);
{				D.ReassignPStr(String(Data^), Param);}

			End
			Else
				Kernel.ShowHint('  :'+#13+String(Data^));


	  end;
	End;
End;

Function OnKey(Me:PProg; Key,ExtKey:Char): Boolean;
Begin
	With Me^, TWavePlayData(Data^) Do
	Begin

	if playing then begin;
		lch := ch;
		ch := key;
		if lch = #0 then
		case ch of
		  'H' : wave^.setpos(wave^.getpos+16*1024);
		  'P' : wave^.setpos(wave^.getpos-16*1024);
		  'M' : wave^.setpos(wave^.getpos+4*1024);
		  'K' : wave^.setpos(wave^.getpos-6*1024);
		end else
		case ch of
		  'm','M' : begin
						  mute := not mute;
						  wave^.mute(mute);
						end;
		  'p','P' : begin
						  wave^.pause;
						  if (wave^.ispaused) then
						  begin

						  end;
						end;
		  'i','I' : begin
                    intpol := not intpol;
                    wave^.setinterpolation(intpol);
                  end;
         '-','+': begin
                    if (ch = '-')and(vol > 3) then dec(vol,4);
                    if (ch = '+')and(vol < 509) then inc(vol,4);
                    sound^.setvolume(0,vol);
                    sound^.setvolume(1,vol);
                  end;
         '[',']': begin
                    if (ch = '[')and(speed > 0.02) then speed := speed-0.005;
                    if (ch = ']')and(speed < 1.95) then speed := speed+0.005;
                    wave^.setspeed(speed);

		end;

	 end;
    end;
		waveplay.OnKey:=false;
	End;
End;

Procedure OnClose(Me:PProg);
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	With Me^, TWavePlayData(Data^) Do
	Begin
			if playing then begin
				wave^.free;
				s.done;
				sound^.free;
				driver^.free;
		  end;

	end;

	Kernel.FreeRes('b_open.bmp');
	Kernel.FreeRes('b_play.bmp');
	Kernel.FreeRes('b_pause.bmp');
	Kernel.FreeRes('b_stop.bmp');
	Kernel.FreeRes('speaker.bmp');
	FreeMem(Me^.Data, SizeOf(TWavePlayData))
End;

Procedure OnInit(Me:PProg);
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnIdle:=OnIdle;
	Me^.OnMessage:=OnMessage;
	Me^.OnKey:=OnKey;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('Wave player', WinTitle);
		MinX:={428}251;
		MinY:=130;
		GetMem(Data, SizeOf(TWavePlayData));
		Kernel.InitWindow(Me, 'BlueDlg', [wbMin, wbClose]);
		{Kernel.AssignWinSize(Me, 428, 132);}
		Kernel.DrawWindowAni(Me);

		With TWavePlayData(Data^) Do
		Begin
			PicOpen:=Kernel.LoadBMPRes('pic\b_open.bmp');
			PicPlay:=Kernel.LoadBMPRes('pic\b_play.bmp');
			PicPause:=Kernel.LoadBMPRes('pic\b_pause.bmp');
			PicStop:=Kernel.LoadBMPRes('pic\b_stop.bmp');
			PicSpeaker:=Kernel.LoadBMPRes('pic\speaker.bmp');

			{  -  i  ⢮७ i i 㢠 }

			edFileName:=InpLine_Create(Me, '', Kernel.GetFileIcon('*.wav'));
			btnOpen:=Button_Create(Me, '', PicOpen, ppLeft, OnBtnOpenPress);
			Ctl.Button_SetMarkStyle(btnOpen, bmDialog);

			lblWAV:=Label_Create(Me, '0   ', nil, lsNormal, alLeft);
			{lblPLay:=Label_Create(Me, '0:00:00 / 0:00:00', nil, lsNormal, alRight);}

			prPlay:=Progress_Create(Me, 0, 1, 0, pkDeterm);

			btnPlay:=Button_Create(Me, 'Play', PicPlay, ppLeft, OnBtnPlayPress);
			btnPause:=Button_Create(Me, 'Pause', PicPause, ppLeft, OnBtnPausePress);
			btnStop:=Button_Create(Me, 'Stop', PicStop, ppLeft, OnBtnStopPress);

			PctVolume:=Ctl.PicCtl_Create(Me, PicSpeaker, False, False, True);
			trkVolume:=Track_Create(Me, 1, {355}512, {255}384, tkGrowRight, false, OnTrkVolumeChange);
			ActiveCtl:=edFileName;

			If D.FileExist(String(Param^)) Then
			Begin
				Ctl.InpLine_SetText(edFileName, String(Param^));
				InitDrv(Me);
				Playing:=False;
				OpenWav(Me);
				playing:=True
			End
			Else Playing:=false;
		End;
	End
End;



Begin
	Kernel.RegBuiltIn('WavePlay', 'WavePlay', 'pic\f_wav.bmp', OnInit)
End.
