{$F+}
Unit
	WinLook; { Polit Halcyon window frames drawing unit }

Interface

Uses
	Kernel, Types, Log, Gfx, Font, D, Pic, BCRT;

Type
	TDragBorderSet=Set Of TBorder;



	Procedure Init;
	Procedure DialogWinOper(Prog:PProg; Borders:TDragBorderSet);
	Procedure Done;


Implementation

Type
	TDrawUnderSkin=(usButtons, usBackground, usNone);
	TBlueWinData=Record
		Movable, Resizable: Boolean;
		MoveRect, MinRect, MaxRect, CloseRect, HelpRect,
		SlideRect, DetachRect, HoleRect: TRect;
		LeftSizeRect, RightSizeRect, BottomSizeRect,
		BottomLeftSizeRect, BottomRightSizeRect: TRect;
		CanResizeLeft, CanResizeRight, CanResizeDown: Boolean;
	End;
	TUpperPanData=Record
		Position: TBorder;
	End;

Var
	Struc:TWinLook;

	CurRect: TRect;
	LastX,LastY:Integer;
	WinBorders:Set Of TBorder;
	PicSize:Word;
	CurProg:PProg;
	PicMin, PicMax, PicClose, PicHelp, PicLSize, PicRSize,
	PicSlide, PicDetach: TSkinPic;
	PicMoveL, PicMoveC, PicMoveR, PicRight: TSkinPic;
	SkinMoveTiled: Boolean;
	InsideBtn:Boolean; { for win frame buttons like Close }
	ButtonPic: TSkinPic;
	ShadowDepth:Integer;
	WinBtnWidth, WinBtnHeight, SizeBtnHeight, SizeBtnWidth, RightPicWidth: Integer;
	HoleWidth, BorderWidth: Integer;
	DrawHole: Boolean;
	DrawUnderSkin: TDrawUnderSkin;
	WinHdrFontName: PStr;
	WinHdrFont: Pointer;
	HeaderSkinned: Boolean;

	Colors: Array[Boolean] Of Record
		ClrBG, ClrFrame, ClrFont, ClrFontShadow, ClrHole,
		ClrLight, ClrLightPlus, ClrDark, ClrDarkPlus: TColor;
	End;

	PicU, PicD, PicL, PicR: Pointer;



Procedure WinLook_HideMouse(Var X,Y:Integer);
Begin
	Kernel.HideMouse(X,Y);
	With CurRect Do
		Gfx.PutRectImage(X1, Y1, X2, Y2, PicU, PicD, PicL, PicR)
	{Gfx.InvertFrame(WinX1,WinY1,WinX2,WinY2)}
End;

Procedure WinLook_ShowMouse(Var X,Y:Integer);
Var
	DX,DY:Integer;
Begin
	DX:=X-LastX;
	DY:=Y-LastY;
	LastX:=X;
	LastY:=Y;

	With CurRect Do
	Begin
		If brLeft In WinBorders Then Inc(X1, DX);
		If brRight In WinBorders Then Inc(X2, DX);
		If brTop In WinBorders Then Inc(Y1, DY);
		If brBottom In WinBorders Then Inc(Y2, DY);

		If X1<Kernel.Screen.X1 Then
		Begin
			X1:=Kernel.Screen.X1;
			If X2-X1+1<CurProg^.MinX Then
				X2:=Kernel.Screen.X1+CurProg^.MinX-1
		End;
		If X2>Kernel.Screen.X2 Then
		Begin
			X2:=Kernel.Screen.X2;
			If X2-X1+1<CurProg^.MinX Then
				X1:=Kernel.Screen.X2-CurProg^.MinX+1
		End;
		If Y1<Kernel.Screen.Y1 Then
		Begin
			Y1:=Kernel.Screen.Y1;
			If Y2-Y1+1<CurProg^.MinY Then
				Y2:=Kernel.Screen.Y1+CurProg^.MinY-1
		End;
		If Y2>Kernel.Screen.Y2 Then
		Begin
			Y2:=Kernel.Screen.Y2;
			If Y2-Y1+1<CurProg^.MinY Then
				Y1:=Kernel.Screen.Y2-CurProg^.MinY+1
		End;

		If X2-X1+1<CurProg^.MinX Then
			If brLeft In WinBorders
				Then X1:=X2-CurProg^.MinX+1
				Else X2:=X1+CurProg^.MinX-1;
		If Y2-Y1+1<CurProg^.MinY Then
			If brTop In WinBorders
				Then Y1:=Y2-CurProg^.MinY+1
				Else Y2:=Y1+CurProg^.MinY-1;

		{Gfx.InvertFrame(WinX1,WinY1,WinX2,WinY2);}
		Gfx.GetRectImage(X1, Y1, X2, Y2, PicU, PicD, PicL, PicR);
		Gfx.ButtonRect(X1, Y1, X2, Y2, clWhite, clBlack)
	End;
	Kernel.ShowMouse(X,Y)
End;

Function WinLook_RefreshNeeded(Rect:TRect): Boolean;
Begin
	With CurRect Do
		WinLook_RefreshNeeded:=
			D.IntersectCoord(Rect, X1, Y1, X2, Y1+1) Or
			D.IntersectCoord(Rect, X1, Y2-1, X2, Y2) Or
			D.IntersectCoord(Rect, X1, Y1+2, X1+1, Y2-2) Or
			D.IntersectCoord(Rect, X2-1, Y1+2, X2, Y2-2) Or
			Kernel.RefreshNeeded(Rect)
End;

Procedure DialogWinOper(Prog:PProg; Borders:TDragBorderSet);
Var
	RealScreen, FullScreen, ReducedScreen: TRect;
Begin
	CurProg:=Prog;
	CurRect:=Prog^.WinRect;
	LastX:=Kernel.MsX;
	LastY:=Kernel.MsY;
	WinBorders:=Borders;
	Gfx.PrepareRectImage(PicU, PicD, PicL, PicR);
	With Prog^ Do
		If WinKind=wkPanel Then
			Case WinBorder Of
				brLeft: Dec(Kernel.Screen.X1, WinRect.X2-WinRect.X1+1);
				brRight: Inc(Kernel.Screen.X2, WinRect.X2-WinRect.X1+1);
			End;

	RealScreen:=Kernel.Screen;
	If Prog^.Child<>Nil Then
		If Prog^.Child^.WinKind=wkSheet Then
			With Prog^.Child^ Do
			Begin { ,  WinBorder -  brLeft,  brRight }
				Case WinBorder Of
					brLeft: Dec(Kernel.Screen.X2, WinRect.X2-WinRect.X1+1);
					brRight: Inc(Kernel.Screen.X1, WinRect.X2-WinRect.X1+1);
				End;
				If Prog^.Child^.WinRect.Y2>Prog^.WinRect.Y2 Then
					Dec(Kernel.Screen.Y2,
						Prog^.Child^.WinRect.Y2-Prog^.WinRect.Y2)
			End;

	Repeat
		Kernel.CheckSysKeys
	Until Kernel.HeartOfPolit(WinLook_HideMouse, WinLook_ShowMouse,
		WinLook_RefreshNeeded)=0;
	Kernel.SelectCursor(Kernel.MouseDefault);

	Gfx.FreeRectImage(PicU, PicD, PicL, PicR);
	Kernel.Screen:=RealScreen;

	Case Prog^.WinKind Of
		wkNormal: With CurRect Do
			Kernel.ResizeOrMoveWindow(CurProg, X1, Y1, X2, Y2);
		wkPanel: Begin
			FullScreen:=Kernel.Screen;
			Case Prog^.WinBorder Of
				brLeft: Inc(Kernel.Screen.X1, CurRect.X2-CurRect.X1+1);
				brRight: Dec(Kernel.Screen.X2, CurRect.X2-CurRect.X1+1);
			End;
			ReducedScreen:=Kernel.Screen;
			Kernel.FitAllWindowsToScreen(True);
			Kernel.Screen:=FullScreen;
			With CurRect Do
				Kernel.ResizeOrMoveWindow(CurProg, X1, Y1, X2, Y2);
			Kernel.Screen:=ReducedScreen
		End
	End
End;






Procedure DrawWinLookBtn(Prog:PProg; Rect:TRect; Active,Pressed,Present:Boolean);
Begin
	With Rect, Colors[Active] Do
		If Present
			Then If Pressed
				Then Gfx.FillButtonRect(X1, Y1, X2, Y2, ClrDark, ClrLight, ClrFrame)
				Else Gfx.FillButtonRect(X1, Y1, X2, Y2, ClrLight, ClrDark, ClrFrame)
			Else Kernel.WinBGBar(Prog, X1, Y1, X2, Y2)
				{Gfx.Bar(X1, Y1, X2, Y2, ClrBG)}
End;

Procedure DrawWinLookPicBtn(Prog:PProg; Rect:TRect; Pic:TSkinPic;
	Active,Pressed,Present:Boolean);
Begin
	If Present Then
	Begin
		Case DrawUnderSkin Of
			usButtons: DrawWinLookBtn(Prog, Rect, Active, Pressed, True);
			usBackground: With Rect Do
				Gfx.Bar(X1, Y1, X2, Y2, Colors[Active].ClrFrame)
		End;
		Gfx.PutSprite(Rect.X1, Rect.Y1, Pic[Active, Pressed])
	End
	Else With Rect, Colors[Active] Do
		Kernel.WinBGBar(Prog, X1, Y1, X2, Y2)
		{Gfx.Bar(X1, Y1, X2, Y2, ClrBG)}
	{BCRT.Delay(1200);}
End;


Procedure WinButton_HideMouse(Var X,Y:Integer);
Begin
	InsideBtn:=D.InRect(X, Y, CurRect);
	Kernel.HideMouse(X,Y)
End;

Procedure WinButton_ShowMouse(Var X,Y:Integer);
Var
	InsideNow:Boolean;
Begin
	InsideNow:=D.InRect(X, Y, CurRect);
	If InsideBtn Xor InsideNow Then
		DrawWinLookPicBtn(Nil, CurRect, ButtonPic, True, InsideNow, True);
	Kernel.ShowMouse(X,Y)
End;


Function WinButton(Rect:TRect; Pic:TSkinPic):Boolean;
Begin
	CurRect:=Rect;
	InsideBtn:=True;
	ButtonPic:=Pic;
	DrawWinLookPicBtn(Nil, Rect, Pic, True, True, True);
	Repeat
		Kernel.CheckSysKeys
	Until Kernel.HeartOfPolit(WinButton_HideMouse, WinButton_ShowMouse,
		Kernel.RefreshNeeded)=0;
	WinButton:=InsideBtn;
	DrawWinLookPicBtn(Nil, Rect, Pic, True, False, True)
End;





Procedure BlueWin_Click(Prog:PProg;X,Y:Integer);
Var
	TempStr: String;
	IconWidth, TempY: Integer;
	TempRect, FullScreen, ReducedScreen: TRect;
Begin
	With Prog^, WinRect, TBlueWinData(WinLookData^), Colors[True] Do
	Begin
		If (X1=X2) Or (Y1=Y2) Then
		Begin {   }
			Repeat
				Kernel.CheckSysKeys
			Until Kernel.HeartOfPolit(Kernel.HideMouse,
				Kernel.ShowMouse, Kernel.RefreshNeeded)=0;
			If Not D.InRect(Kernel.MsX, Kernel.MsY, WinRect) Then Exit;
			FullScreen:=Kernel.Screen;
			Case WinBorder Of
				brLeft: Inc(Kernel.Screen.X1, LastWinRect.X2-LastWinRect.X1);
				brRight: Dec(Kernel.Screen.X2, LastWinRect.X2-LastWinRect.X1);
			End;
			ReducedScreen:=Kernel.Screen;
			Kernel.FitAllWindowsToScreen(True);
			Kernel.Screen:=FullScreen;
			With LastWinRect Do
				Kernel.ResizeOrMoveWindow(Prog, X1, Y1, X2, Y2);
			Kernel.Screen:=ReducedScreen;
			Exit
		End;

		D.AddRectsPlus(WinRect, MoveRect, TempRect);
		If Movable And ((D.InRect(X, Y, TempRect)) Or
			((D.KeyStatus And (ksAlt+ksCtrl))=ksAlt)) Then
		Begin
			If HeaderSkinned
				Then With TempRect Do
					If SkinMoveTiled
						Then Gfx.SkinBarTiled(X1, Y1, X2, PicMoveL[True, True],
							PicMoveC[True, True], PicMoveR[True, True])
						Else Gfx.SkinBar(X1, Y1, X2, PicMoveL[True, True],
							PicMoveR[True, True])
				Else DrawWinLookBtn(Prog, TempRect, True, True, True);
			If Prog^.Icon<>Nil Then
			Begin
				IconWidth:=Gfx.ImageX(Icon)+4;
				Gfx.PutSprite(X1+5, Y1+(WinBtnHeight-Gfx.ImageY(Icon)) Div 2+2,
					Icon)
			End
			Else
				IconWidth:=0;
			Font.SetFont(WinHdrFont);
			With TempRect Do
				TempStr:=Kernel.ShortenStr(String(WinTitle^), X2-X1-3-IconWidth);
			TempY:=Y1+(WinBtnHeight-Font.Height(WinHdrFont)) Div 2;
			Font.Print(X1+IconWidth+5, TempY+2, ClrFontShadow, TempStr);
			Font.Print(X1+IconWidth+4, TempY+1, ClrFont, TempStr);
			Kernel.SelectCursor(Kernel.MouseMove);
			DialogWinOper(Prog, [brLeft, brRight, brTop, brBottom]);
			Exit
		End;

		If wbMin In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, MinRect, TempRect);
			If D.InRect(X, Y, TempRect) Then
				If WinButton(TempRect, PicMin) Then
				Begin
					Kernel.MinimizeWindow(Prog);
					Exit
				End
		End;
		If wbMax In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, MaxRect, TempRect);
			If D.InRect(X, Y, TempRect) Then
				If WinButton(TempRect, PicMax) Then
				Begin
					Kernel.MaximizeWindow(Prog);
					Exit
				End
		End;
		If wbClose In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, CloseRect, TempRect);
			If D.InRect(X, Y, TempRect) Then
				If WinButton(TempRect, PicClose) Then
				Begin
					Kernel.CloseProg(Prog);
					Exit
				End
		End;
		If wbHelp In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, HelpRect, TempRect);
			If D.InRect(X, Y, TempRect) Then
				If WinButton(TempRect, PicHelp) Then
				Begin
					{Kernel.CloseProg(Prog)}
					Exit
				End
		End;
		If wbSlide In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, SlideRect, TempRect);
			If D.InRect(X, Y, TempRect) Then
				If WinButton(TempRect, PicSlide) Then
				Begin
					Case WinKind Of
						wkSheet: Kernel.CloseProg(Prog);
						wkPanel: Kernel.SlidePanel(Prog)
					End;
					Exit
				End
		End;
		If wbDetach In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, DetachRect, TempRect);
			If D.InRect(X, Y, TempRect) Then
				If WinButton(TempRect, PicDetach) Then
				Begin
					Exit
				End
		End;

		If Resizable Then
		Begin
			D.AddRectsPlus(WinRect, LeftSizeRect, TempRect);
			If CanResizeLeft And D.InRect(X, Y, TempRect) Then
			Begin
				DrawWinLookBtn(Prog, TempRect, True, True, True);
				Kernel.SelectCursor(Kernel.MouseResizeHor);
				DialogWinOper(Prog, [brLeft]);
				Exit
			End;
			D.AddRectsPlus(WinRect, RightSizeRect, TempRect);
			If CanResizeRight And D.InRect(X, Y, TempRect) Then
			Begin
				DrawWinLookBtn(Prog, TempRect, True, True, True);
				Kernel.SelectCursor(Kernel.MouseResizeHor);
				DialogWinOper(Prog, [brRight]);
				Exit
			End;
			D.AddRectsPlus(WinRect, BottomLeftSizeRect, TempRect);
			If CanResizeLeft And CanResizeDown And D.InRect(X, Y, TempRect) Then
			Begin
				DrawWinLookPicBtn(Prog, TempRect, PicLSize, True, True, True);
				Kernel.SelectCursor(Kernel.MouseResizeDiag1);
				DialogWinOper(Prog, [brLeft, brBottom]);
				Exit
			End;
			D.AddRectsPlus(WinRect, BottomSizeRect, TempRect);
			If CanResizeDown And D.InRect(X, Y, TempRect) Then
			Begin
				DrawWinLookBtn(Prog, TempRect, True, True, True);
				Kernel.SelectCursor(Kernel.MouseResizeVer);
				DialogWinOper(Prog, [brBottom]);
				Exit
			End;
			D.AddRectsPlus(WinRect, BottomRightSizeRect, TempRect);
			If CanResizeRight And CanResizeDown And D.InRect(X, Y, TempRect) Or
				((D.KeyStatus And (ksAlt+ksCtrl))=ksAlt+ksCtrl) Then
			Begin
				DrawWinLookPicBtn(Prog, TempRect, PicRSize, True, True, True);
				Kernel.SelectCursor(Kernel.MouseResizeDiag2);
				DialogWinOper(Prog, [brRight, brBottom]);
				Exit
			End
		End
	End
End;

Procedure BlueWin_DrawFrame(Prog:PProg);
Var
	IconWidth: Integer;
	TempStr: String;
	TempX1, TempX2, TempX3, TempX4, TempY: Integer;
	IsActive: Boolean;

	TempRect: TRect;
Begin
	IsActive:=(Prog=Kernel.ActiveWin);
	With Prog^, TBlueWinData(WinLookData^), WinRect, Colors[IsActive] Do
	Begin
		If (X1=X2) Or (Y1=Y2) Then
		Begin {   }
			Case WinBorder Of
				{brLeft: Gfx.Line(X1, Y1, X2, Y2, ClrDarkPlus);
				brRight: Gfx.Line(X1, Y1, X2, Y2, ClrLightPlus);
				brTop: Gfx.Line(X1, Y1, X2, Y2, ClrDarkPlus);
				brBottom: Gfx.Line(X1, Y1, X2, Y2, ClrLightPlus)}
				brLeft: Gfx.Line(X1, Y1, X2, Y2, ClrFrame);
				brRight: Gfx.Line(X1, Y1, X2, Y2, ClrFrame);
				brTop: Gfx.Line(X1, Y1, X2, Y2, ClrFrame);
				brBottom: Gfx.Line(X1, Y1, X2, Y2, ClrFrame)
			End;
			Exit
		End;
			{ i ࠬ }
		Gfx.ButtonRect(X1, Y1, X2, Y2, ClrLightPlus, ClrDarkPlus);
		Gfx.PutSprite(X2-RightPicWidth, Y1+1, PicRight[IsActive, False]);
			{  i }
		D.AddRectsPlus(WinRect, MoveRect, TempRect);
		With TempRect Do
			If Movable And HeaderSkinned
				Then If SkinMoveTiled
					Then Gfx.SkinBarTiled(X1, Y1, X2, PicMoveL[IsActive, False],
						PicMoveC[IsActive, False], PicMoveR[IsActive, False])
					Else Gfx.SkinBar(X1, Y1, X2, PicMoveL[IsActive, False],
						PicMoveR[IsActive, False])
				Else DrawWinLookBtn(Prog, TempRect, IsActive, False, Movable);
		If Icon<>Nil Then
		Begin
			IconWidth:=Gfx.ImageX(Icon)+4;
			Gfx.PutSprite(X1+4, Y1+(WinBtnHeight-Gfx.ImageY(Icon)) Div 2+1, Icon)
		End
		Else
			IconWidth:=0;
		Font.SetFont(WinHdrFont);
		With TempRect Do
			TempStr:=Kernel.ShortenStr(String(WinTitle^), X2-X1-3-IconWidth);
		TempY:=Y1+(WinBtnHeight-Font.Height(WinHdrFont)) Div 2;
		If Movable Then
		Begin
			Font.Print(X1+IconWidth+4, TempY+1, ClrFontShadow, TempStr);
			Font.Print(X1+IconWidth+3, TempY, ClrFont, TempStr)
		End
		Else If IsActive
			Then Font.Print(X1+IconWidth+3, TempY, Kernel.ClrText, TempStr)
			Else Font.Print(X1+IconWidth+3, TempY, Kernel.ClrTextDis, TempStr);
			{  㢠 i }
		If wbHelp In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, HelpRect, TempRect);
			DrawWinLookPicBtn(Prog, TempRect, PicHelp, IsActive, False, True)
		End;
		If wbMin In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, MinRect, TempRect);
			DrawWinLookPicBtn(Prog, TempRect, PicMin, IsActive, False, True)
		End;
		If wbMax In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, MaxRect, TempRect);
			DrawWinLookPicBtn(Prog, TempRect, PicMax, IsActive, False, True)
		End;
		If wbClose In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, CloseRect, TempRect);
			DrawWinLookPicBtn(Prog, TempRect, PicClose, IsActive, False, True)
		End;
		If wbSlide In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, SlideRect, TempRect);
			DrawWinLookPicBtn(Prog, TempRect, PicSlide, IsActive, False, True)
		End;
		If wbDetach In WinButtons Then
		Begin
			D.AddRectsPlus(WinRect, DetachRect, TempRect);
			DrawWinLookPicBtn(Prog, TempRect, PicDetach, IsActive, False, True)
		End;
		If ((WinButtons-[wbClose]-[wbSlide])<>[]) And (HoleWidth>0) Then
		Begin
			D.AddRectsPlus(WinRect, HoleRect, TempRect);
			With TempRect Do
				If DrawHole
					Then Kernel.WinBGBar(Prog, X1, Y1, X2, Y2)
					Else Gfx.Bar(X1, Y1, X2, Y2, ClrHole)
		End;
			{  ॡ - ࠬ  i ஧ii }
		If Resizable Then
		Begin
			D.AddRectsPlus(WinRect, LeftSizeRect, TempRect);
			DrawWinLookBtn(Prog, TempRect, IsActive, False, CanResizeLeft);
			D.AddRectsPlus(WinRect, RightSizeRect, TempRect);
			DrawWinLookBtn(Prog, TempRect, IsActive, False, CanResizeRight);
			D.AddRectsPlus(WinRect, BottomLeftSizeRect, TempRect);
			DrawWinLookPicBtn(Prog, TempRect, PicLSize, IsActive, False,
				CanResizeLeft And CanResizeDown);
			D.AddRectsPlus(WinRect, BottomSizeRect, TempRect);
			DrawWinLookBtn(Prog, TempRect, IsActive, False, CanResizeDown);
			D.AddRectsPlus(WinRect, BottomRightSizeRect, TempRect);
			DrawWinLookPicBtn(prog, TempRect, PicRSize, IsActive, False,
				CanResizeRight And CanResizeDown);
		End
	End
End;

Procedure BlueWin_OnRefreshButtons(Prog:PProg);
Var
	TempX: Integer;
	TempWidth: Integer;
Begin
	With Prog^, TBlueWinData(WinLookData^) Do
	Begin
		If HeaderSkinned
			Then TempX:=-RightPicWidth
			Else TempX:=0;
		TempWidth:=WinBtnWidth-1;
		If wbClose In WinButtons Then
		Begin
			Dec(TempX, WinBtnWidth);
			D.AssignRect(TempX, 1, TempX+TempWidth, WinBtnHeight, CloseRect)
		End;
		If wbSlide In WinButtons Then
		Begin
			Dec(TempX, WinBtnWidth);
			D.AssignRect(TempX, 1, TempX+TempWidth, WinBtnHeight, SlideRect)
		End;

		If (WinButtons-[wbClose]-[wbSlide])<>[] Then {     }
		Begin
			Dec(TempX, HoleWidth);
			D.AssignRect(TempX, 1, TempX+HoleWidth-1, WinBtnHeight, HoleRect)
		End;

		If wbDetach In WinButtons Then
		Begin
			Dec(TempX, WinBtnWidth);
			D.AssignRect(TempX, 1, TempX+TempWidth, WinBtnHeight, DetachRect)
		End;
		If wbMax In WinButtons Then
		Begin
			Dec(TempX, WinBtnWidth);
			D.AssignRect(TempX, 1, TempX+TempWidth, WinBtnHeight, MaxRect)
		End;
		If wbMin In WinButtons Then
		Begin
			Dec(TempX, WinBtnWidth);
			D.AssignRect(TempX, 1, TempX+TempWidth, WinBtnHeight, MinRect)
		End;
		If wbHelp In WinButtons Then
		Begin
			Dec(TempX, WinBtnWidth);
			D.AssignRect(TempX, 1, TempX+TempWidth, WinBtnHeight, HelpRect)
		End;
		D.AssignRect(1, 1, TempX-1, WinBtnHeight, MoveRect);

		If Resizable Then
		Begin
			D.AssignRect(1, WinBtnHeight+1, BorderWidth, -SizeBtnHeight-1,
				LeftSizeRect);
			D.AssignRect(-BorderWidth, WinBtnHeight+1, -1, -SizeBtnHeight-1,
				RightSizeRect);
			D.AssignRect(1, -SizeBtnHeight, SizeBtnWidth, -1,
				BottomLeftSizeRect);
			D.AssignRect(SizeBtnWidth+1, -SizeBtnHeight, -SizeBtnWidth-1, -1,
				BottomSizeRect);
			D.AssignRect(-SizeBtnWidth, -SizeBtnHeight, -1, -1,
				BottomRightSizeRect);
		End
	End
End;

Procedure BlueWin_OnPrepare(Prog:PProg);
Begin
	GetMem(Prog^.WinLookData, SizeOf(TBlueWinData));
	With Prog^, TBlueWinData(WinLookData^) Do
	Begin
		Resizable:=True;
		Case WinKind Of
			wkNormal: Begin
				Movable:=True;
				CanResizeLeft:=True;
				CanResizeRight:=True;
				CanResizeDown:=True
			End;
			wkPanel: Begin
				Movable:=False;
				CanResizeLeft:=(WinBorder=brRight);
				CanResizeRight:=(WinBorder=brLeft);
				CanResizeDown:=(WinBorder=brTop)
			End;
		End
	End
End;



Procedure BlueDlg_OnPrepare(Prog:PProg);
Begin
	GetMem(Prog^.WinLookData, SizeOf(TBlueWinData));
	With Prog^, TBlueWinData(WinLookData^) Do
	Begin
		Resizable:=False;
		Movable:=(WinKind=wkNormal)
	End
End;


Procedure BlueWin_OnDestroy(Prog:PProg);
Begin
	FreeMem(Prog^.WinLookData, SizeOf(TBlueWinData))
End;





Procedure GrayBox_DrawFrame(Prog:PProg);
Begin
	With Prog^,WinRect Do
	Begin
		Gfx.ButtonRect(X1, Y1, X2, Y2, clSilver, clBlack);
		Gfx.ButtonRect(X1+1, Y1+1, X2-1, Y2-1, clWhite, clGray);
		Rectangle(X1+2, Y1+2, X2-2, Y2-2, clSilver)
	End;
End;

Procedure GrayBox_Click(Prog:PProg; X,Y:Integer);
Begin
	With Prog^.WinRect Do
	Begin
		{Gfx.ButtonRect(X1+1,Y1+1,X2-1,Y2-1,clGray,clWhite);
		DialogWinOper(Prog,[brLeft,brRight,brTop,brBottom])}
	End
End;





Procedure EmptyWin_DrawFrame(Prog:PProg);
Begin
End;

Procedure EmptyWin_Click(Prog:PProg; X,Y:Integer);
Begin
End;






Procedure UpperPan_DrawFrame(Prog:PProg);
Begin
	With Prog^, TUpperPanData(WinLookData^), WinRect Do
		Case Position Of
			brTop: Gfx.Line(X1, Y2, X2, Y2, clBlack);
			brBottom: Gfx.Line(X1, Y1, X2, Y1, clWhite)
		End
End;

Procedure UpperPan_OnPrepare(Prog:PProg);
Begin
	GetMem(Prog^.WinLookData, SizeOf(TUpperPanData));
	With Prog^, TUpperPanData(WinLookData^) Do
		Position:=brTop
End;

Procedure LowerPan_OnPrepare(Prog:PProg);
Begin
	GetMem(Prog^.WinLookData, SizeOf(TUpperPanData));
	With Prog^, TUpperPanData(WinLookData^) Do
		Position:=brBottom
End;

Procedure UpperPan_OnDestroy(Prog:PProg);
Begin
	FreeMem(Prog^.WinLookData, SizeOf(TUpperPanData))
End;








Procedure Init;
Var
	FName: String;
	P: Pointer;
	TempStr: String;
Begin
	Pic.LoadBMP(Kernel.SkinDir+'win_min.bmp', P);
	Gfx.SplitSkin3(P, PicMin);
	WinBtnWidth:=Gfx.ImageX(PicMin[True, False]);
	WinBtnHeight:=Gfx.ImageY(PicMin[True, False]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'win_max.bmp', P);
	Gfx.SplitSkin3(P, PicMax);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'win_clos.bmp', P);
	Gfx.SplitSkin3(P, PicClose);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'win_help.bmp', P);
	Gfx.SplitSkin3(P, PicHelp);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'win_lsld.bmp', P);
	Gfx.SplitSkin3(P, PicSlide);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'win_tach.bmp', P);
	Gfx.SplitSkin3(P, PicDetach);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'win_lsiz.bmp', P);
	Gfx.SplitSkin3(P, PicLSize);
	SizeBtnWidth:=Gfx.ImageX(PicLSize[True, False]);
	SizeBtnHeight:=Gfx.ImageY(PicLSize[True, False]);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'win_rsiz.bmp', P);
	Gfx.SplitSkin3(P, PicRSize);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'win_movl.bmp', P);
	Gfx.SplitSkin3(P, PicMoveL);
	Kernel.LoadingStep;
	HeaderSkinned:=(Gfx.ImageY(PicMoveL[True, False])>1);
	Pic.LoadBMP(Kernel.SkinDir+'win_movc.bmp', P);
	Gfx.SplitSkin3(P, PicMoveC);
	Kernel.LoadingStep;
	SkinMoveTiled:=(Gfx.ImageY(PicMoveC[True, False])>1);
	Pic.LoadBMP(Kernel.SkinDir+'win_movr.bmp', P);
	Gfx.SplitSkin3(P, PicMoveR);
	Kernel.LoadingStep;
	Pic.LoadBMP(Kernel.SkinDir+'win_rght.bmp', P);
	Gfx.SplitSkin3(P, PicRight);
	Kernel.LoadingStep;
	RightPicWidth:=Gfx.ImageX(PicRight[True, False]);

	Ini.Load(Kernel.SkinDir+'skin.ini');
	Ini.Select(Kernel.SkinDir+'skin.ini', 'Skin');
	HoleWidth:=Ini.GetInt('HoleWidth', 10);
	BorderWidth:=Ini.GetInt('BorderWidth', 4);
	TempStr:=Ini.GetStr('DrawUnderSkin', 'BUTTONS');
	If TempStr='BUTTONS'
		Then DrawUnderSkin:=usButtons
		Else If tempStr='BACKGROUND'
			Then DrawUnderSkin:=usBackground
			Else DrawUnderSkin:=usNone;
	DrawHole:=Ini.GetBool('DrawHole', False);
	D.AssignPStr(Ini.GetStr('WinHeaderFont', 'fonts\default.raf'),
		WinHdrFontName);
	Ini.FreeFile(Kernel.SkinDir+'skin.ini');
	WinHdrFont:=Kernel.LoadRes(String(WinHdrFontName^));
	Kernel.LoadingStep;

	Ini.Select('polit.ini', 'Graphics');
	FName:=Ini.GetStr('ColorScheme', 'colors\default.ini');
	Ini.Select(FName, 'Colors');
	With Colors[True] Do
	Begin
		ClrBG:=Ini.GetInt('WindowBG', clSilver);
		ClrFrame:=Ini.GetInt('ActWinBG', clBlue);
		ClrFont:=Ini.GetInt('ActWinFont', clWhite);
		ClrFontShadow:=Ini.GetInt('ActWinFontShadow', clNavy);
		ClrLight:=Ini.GetInt('ActWinLight', clCyan);
		ClrLightPlus:=Ini.GetInt('ActWinLightPlus', clWhite);
		ClrDark:=Ini.GetInt('ActWinDark', clNavy);
		ClrDarkPlus:=Ini.GetInt('ActWinDarkPlus', clBlack);
		If DrawHole
			Then ClrHole:=Ini.GetInt('ActWinHole', ClrBG)
			Else ClrHole:=ClrFrame
	End;
	With Colors[False] Do
	Begin
		ClrBG:=Colors[True].ClrBG;
		ClrFrame:=Ini.GetInt('InActWinBG', clGray);
		ClrFont:=Ini.GetInt('InActWinFont', clBlack);
		ClrFontShadow:=Ini.GetInt('InActWinFontShadow', clGray);
		ClrLight:=Ini.GetInt('InActWinLight', clSilver);
		ClrLightPlus:=Ini.GetInt('InActWinLightPlus', clWhite);
		ClrDark:=Ini.GetInt('InActWinDark', clNightGray);
		ClrDarkPlus:=Ini.GetInt('InActWinDarkPlus', clBlack);
		If DrawHole
			Then ClrHole:=Ini.GetInt('InActWinHole', Colors[True].ClrBG)
			Else ClrHole:=ClrFrame
	End;
	Ini.FreeFile(FName);
	Ini.SelectFile('polit.ini');
	Kernel.LoadingStep;

	With Struc Do
	Begin
		D.AssignPStr('GrayBox',Name);
		D.AssignRect(3, 3, -3, -3, ClientDeltaRect);
		OnPrepare:=Kernel.WinLookDummy;
		OnRefreshButtons:=Kernel.WinLookDummy;
		OnDestroy:=Kernel.WinLookDummy;
		OnDrawFrame:=GrayBox_DrawFrame;
		OnClick:=GrayBox_Click
	End;
	Kernel.RegWinLook(Struc);

	With Struc Do
	Begin
		D.AssignPStr('UpperPan',Name);
		D.AssignRect(0, 0, 0, -1, ClientDeltaRect);
		OnPrepare:=UpperPan_OnPrepare;
		OnRefreshButtons:=Kernel.WinLookDummy;
		OnDestroy:=UpperPan_OnDestroy;
		OnDrawFrame:=UpperPan_DrawFrame;
		OnClick:=Kernel.WinLookClickDummy
	End;
	Kernel.RegWinLook(Struc);

	With Struc Do
	Begin
		D.AssignPStr('LowerPan',Name);
		D.AssignRect(0, 1, 0, 0, ClientDeltaRect);
		OnPrepare:=LowerPan_OnPrepare;
		OnRefreshButtons:=Kernel.WinLookDummy;
		OnDestroy:=UpperPan_OnDestroy;
		OnDrawFrame:=UpperPan_DrawFrame;
		OnClick:=Kernel.WinLookClickDummy
	End;
	Kernel.RegWinLook(Struc);

	With Struc Do
	Begin
		D.AssignPStr('BlueWin',Name);
		D.AssignRect(BorderWidth+1, WinBtnHeight+1, -BorderWidth-1,
			-SizeBtnHeight-1, ClientDeltaRect);
		OnPrepare:=BlueWin_OnPrepare;
		OnRefreshButtons:=BlueWin_OnRefreshButtons;
		OnDestroy:=BlueWin_OnDestroy;
		OnDrawFrame:=BlueWin_DrawFrame;
		OnClick:=BlueWin_Click
	End;
	Kernel.RegWinLook(Struc);

	With Struc Do
	Begin
		D.AssignPStr('BlueDlg',Name);
		D.AssignRect(1, WinBtnHeight+1, -1, -1, ClientDeltaRect);
		OnPrepare:=BlueDlg_OnPrepare;
		OnRefreshButtons:=BlueWin_OnRefreshButtons;
		OnDestroy:=BlueWin_OnDestroy;
		OnDrawFrame:=BlueWin_DrawFrame;
		OnClick:=BlueWin_Click
	End;
	Kernel.RegWinLook(Struc);

	With Struc Do
	Begin
		D.AssignPStr('EmptyWin', Name);
		D.AssignRect(0, 0, 0, 0, ClientDeltaRect);
		OnPrepare:=Kernel.WinLookDummy;
		OnRefreshButtons:=Kernel.WinLookDummy;
		OnDestroy:=Kernel.WinLookDummy;
		OnDrawFrame:=EmptyWin_DrawFrame;
		OnClick:=EmptyWin_Click
	End;
	Kernel.RegWinLook(Struc);
End;

Procedure Done;
Begin
	Gfx.FreeSkin3(PicMin);
	Gfx.FreeSkin3(PicMax);
	Gfx.FreeSkin3(PicClose);
	Gfx.FreeSkin3(PicHelp);
	Gfx.FreeSkin3(PicSlide);
	Gfx.FreeSkin3(PicDetach);
	Gfx.FreeSkin3(PicLSize);
	Gfx.FreeSkin3(PicRSize);
	Gfx.FreeSkin3(PicMoveL);
	Gfx.FreeSkin3(PicMoveC);
	Gfx.FreeSkin3(PicMoveR);
	Gfx.FreeSkin3(PicRight);
	Kernel.FreeRes(D.ClipFName(String(WinHdrFontName^)));
	D.FreePStr(WinHdrFontName, 'Gfx - Done');
End;



Begin
End.